@Override
	public <AV extends AttributeValue> Bag<AV> getAttributeSelectorResult(final AttributeSelectorExpression<AV> attributeSelector) throws IndeterminateEvaluationException
	{
		final Bag<?> bagResult = attributeSelectorResults.get(attributeSelector.getAttributeSelectorId());
		if (bagResult == null)
		{
			return null;
		}

		final Datatype<Bag<AV>> expectedBagDatatype = attributeSelector.getReturnType();
		final Datatype<?> expectedElementDatatype = expectedBagDatatype.getTypeParameter().get();
		if (!bagResult.getElementDatatype().equals(expectedElementDatatype))
		{
			throw new IndeterminateEvaluationException("Datatype (" + bagResult.getElementDatatype() + ")of AttributeSelector " + attributeSelector.getAttributeSelectorId()
					+ " in context is different from actually expected/requested (" + expectedElementDatatype
					+ "). May be caused by use of same AttributeSelector Category/Path/ContextSelectorId with different Datatypes in different in different policy elements, which is not allowed.",
					XacmlStatusCode.SYNTAX_ERROR.value());
		}

		/*
		 * If datatype classes match, bagResult should has same type as datatypeClass.
		 */
		final Bag<AV> result = expectedBagDatatype.cast(bagResult);
		this.listeners.forEach((lt, l) -> l.attributeSelectorResultConsumed(attributeSelector, result));
		return result;
	}
