@Override
	public <AV extends AttributeValue> AttributeBag<AV> getNamedAttributeValue(final AttributeFqn attributeFqn, final Datatype<AV> datatype) throws IndeterminateEvaluationException
	{
		final AttributeBag<?> bagResult = namedAttributes.get(attributeFqn);
		if (bagResult == null)
		{
			return null;
		}

		if (!bagResult.getElementDatatype().equals(datatype))
		{
			throw new IndeterminateEvaluationException("Datatype (" + bagResult.getElementDatatype() + ") of AttributeDesignator " + attributeFqn + " in context is different from expected/requested ("
					+ datatype
					+ "). May be caused by refering to the same Attribute Category/Id/Issuer with different Datatypes in different policy elements and/or attribute providers, which is not allowed.",
					XacmlStatusCode.SYNTAX_ERROR.value());
		}

		/*
		 * If datatype classes match, bagResult should have same type as datatypeClass.
		 */
		final AttributeBag<AV> result = (AttributeBag<AV>) bagResult;
		this.listeners.forEach((lt, l) -> l.namedAttributeValueConsumed(attributeFqn, result));
		return result;
	}
