@Override
	public <AV extends AttributeValue> boolean putAttributeSelectorResultIfAbsent(final AttributeSelectorExpression<AV> attributeSelector, final Bag<AV> result) throws IndeterminateEvaluationException
	{
		final AttributeSelectorId attSelectorId = attributeSelector.getAttributeSelectorId();
		if (attributeSelectorResults.putIfAbsent(attSelectorId, result) != null)
		{
			LOGGER.error("Attempt to override value of AttributeSelector {} already set in evaluation context. Overriding value: {}", attSelectorId, result);
			return false;
		}

		for (final Listener listener : this.listeners.values())
		{
			final Optional<AttributeFqn> optionalContextSelectorFQN = attributeSelector.getContextSelectorFQN();
			final Optional<AttributeBag<XPathValue>> contextSelectorValue = optionalContextSelectorFQN.isPresent()
					? Optional.of(getNamedAttributeValue(optionalContextSelectorFQN.get(), StandardDatatypes.XPATH))
					: Optional.empty();
			listener.attributeSelectorResultProduced(attributeSelector, contextSelectorValue, result);
		}

		return true;
	}
