@Override
	public boolean putNamedAttributeValueIfAbsent(final AttributeFqn attributeFqn, final AttributeBag<?> result)
	{
		final Bag<?> duplicate = namedAttributes.putIfAbsent(attributeFqn, result);
		if (duplicate != null)
		{
			/*
			 * This should never happen, as getAttributeDesignatorResult() should have been called first (for same id) and returned this oldResult, and no further call to
			 * putAttributeDesignatorResultIfAbsent() in this case. In any case, we do not support setting a different result for same id (but different datatype URI/datatype class) in the same
			 * context
			 */
			LOGGER.warn("Attempt to override value of AttributeDesignator {} already set in evaluation context. Overriding value: {}", attributeFqn, result);
			return false;
		}

		this.listeners.forEach((lt, l) -> l.namedAttributeValueProduced(attributeFqn, result));
		/*
		 * Attribute value cannot change during evaluation context, so if old value already there, put it back
		 */
		return true;
	}
