private boolean init()
	{
		if (!initialized && catalogLocation != null && extSchemaLocation != null && confLocation != null)
		{
			LOGGER.info("Loading PDP configuration from file {} with extension schema location '{}' and XML catalog location '{}'", confLocation, extSchemaLocation, catalogLocation);
			try
			{
				final PdpEngineConfiguration conf = PdpEngineConfiguration.getInstance(confLocation, catalogLocation, extSchemaLocation);
				pdp = new BasePdpEngine(conf);
			}
			catch (IOException | IllegalArgumentException e)
			{
				throw new RuntimeException("Error parsing PDP configuration from location: " + confLocation, e);
			}

			initialized = true;
		}

		return initialized;
	}
