public static PdpEngineConfiguration getInstance(final File confFile, final PdpModelHandler modelHandler) throws IOException, IllegalArgumentException
	{
		if (confFile == null || !confFile.exists())
		{
			// no property replacement of PARENT_DIR
			throw new IllegalArgumentException("Invalid configuration file location: No file exists at: " + confFile);
		}
		// configuration file exists

		if (modelHandler == null)
		{
			throw NULL_PDP_MODEL_HANDLER_ARGUMENT_EXCEPTION;
		}

		/*
		 * Set property PARENT_DIR in environment properties for future replacement in configuration strings by PDP extensions using file paths
		 */
		final File confAbsFile = confFile.getAbsoluteFile();
		LOGGER.debug("Config file's location - absolute path: {}", confAbsFile);
		final File confAbsFileParent = confAbsFile.getParentFile();
		LOGGER.debug("Config file's parent directory: {}", confAbsFileParent);
		final String propVal = confAbsFileParent.toURI().toString();
		LOGGER.debug("Property {} = {}", EnvironmentPropertyName.PARENT_DIR, propVal);
		final EnvironmentProperties envProps = new DefaultEnvironmentProperties(Collections.singletonMap(EnvironmentPropertyName.PARENT_DIR, propVal));
		return getInstance(new StreamSource(confFile), modelHandler, envProps);
	}
