public static <ATTRIBUTE_PROVIDER_CONF extends AbstractAttributeProvider> CloseableNamedAttributeProvider.FactoryBuilder<ATTRIBUTE_PROVIDER_CONF> getAttributeProviderFactoryBuilder(
	        final Class<ATTRIBUTE_PROVIDER_CONF> jaxbConfClass)
	{
		final JaxbBoundPdpExtension<ATTRIBUTE_PROVIDER_CONF> ext = (JaxbBoundPdpExtension<ATTRIBUTE_PROVIDER_CONF>) JAXB_BOUND_EXTENSIONS_BY_JAXB_CLASS.get(jaxbConfClass);
		if (ext == null)
		{
			throw new IllegalArgumentException("No PDP extension found supporting JAXB (configuration) type: " + jaxbConfClass + ". Expected types: " + JAXB_BOUND_EXTENSIONS_BY_JAXB_CLASS.keySet());
		}

		if (!(ext instanceof CloseableNamedAttributeProvider.FactoryBuilder))
		{
			throw new IllegalArgumentException("No PDP extension of type " + CloseableNamedAttributeProvider.FactoryBuilder.class
			        + " (Attribute Provider factory builder) supporting JAXB/XML (configuration) type: " + jaxbConfClass);
		}

		return (CloseableNamedAttributeProvider.FactoryBuilder<ATTRIBUTE_PROVIDER_CONF>) ext;
	}
