public PepAction evaluate(final EvaluationContext context) throws IndeterminateEvaluationException
	{
		// else there are assignmentExpressions
		final List<PepActionAttributeAssignment<?>> assignments = new ArrayList<>();
		for (final AttributeAssignmentExpressionEvaluator attrAssignmentExpr : this.evaluatableAttributeAssignmentExpressions)
		{
			/*
			 * Section 5.39 of XACML 3.0 core spec says there may be multiple AttributeAssignments resulting from one AttributeAssignmentExpression
			 */
			final Collection<PepActionAttributeAssignment<?>> attrAssignsFromExpr;
			try
			{
				attrAssignsFromExpr = attrAssignmentExpr.evaluate(context);
				LOGGER.debug("{}/{} -> {}", this, attrAssignmentExpr, attrAssignsFromExpr);
			}
			catch (final IndeterminateEvaluationException e)
			{
				throw new IndeterminateEvaluationException(this + ": Error evaluating " + attrAssignmentExpr, e.getStatusCode(), e);
			}

			assignments.addAll(attrAssignsFromExpr);
		}

		return new PepAction(actionId, isMandatory, ImmutableList.copyOf(assignments));
	}
