public static BooleanEvaluator getInstance(final Target target, final XPathCompiler xPathCompiler,
			final ExpressionFactory expressionFactory) throws IllegalArgumentException
	{
		if (target == null)
		{
			return MATCH_ALL_TARGET_EVALUATOR;
		}

		final List<AnyOf> anyOfs = target.getAnyOves();
		if (anyOfs == null || anyOfs.isEmpty())
		{
			return MATCH_ALL_TARGET_EVALUATOR;
		}

		return new NonEmptyTargetEvaluator(anyOfs, xPathCompiler, expressionFactory);
	}
