public static <AV extends AttributeValue> AttributeSelectorExpression<AV> newInstance(final AttributeSelectorType attributeSelectorElement, final XPathCompiler xPathCompiler,
			final AttributeProvider attributeProvider, final AttributeValueFactory<AV> attributeFactory) throws IllegalArgumentException
	{
		final String contextSelectorId = attributeSelectorElement.getContextSelectorId();
		if (contextSelectorId == null)
		{
			return new AttributeSelectorExpressionWithoutContextSelector<>(attributeSelectorElement, xPathCompiler, attributeFactory);
		}

		// contextSelectorId != null
		if (attributeProvider == null)
		{
			throw NULL_ATTRIBUTE_PROVIDER_BUT_NON_NULL_CONTEXT_SELECTOR_ID_EXCEPTION;
		}

		return new AttributeSelectorExpressionWithContextSelector<>(attributeSelectorElement, xPathCompiler, attributeFactory, attributeProvider);

	}
