@Override
	public Function<?> getFunction(final String functionId, final Datatype<? extends AttributeValue> subFunctionReturnType)
	{
		final Function<?> nonGenericFunc = nonGenericFunctionRegistry.getExtension(functionId);
		if (nonGenericFunc != null)
		{
			return nonGenericFunc;
		}

		if (genericHigherOrderFunctionFactoryRegistry == null)
		{
			return null;
		}

		final GenericHigherOrderFunctionFactory funcFactory = genericHigherOrderFunctionFactoryRegistry.getExtension(functionId);
		if (funcFactory == null)
		{
			return null;
		}

		return funcFactory.getInstance(subFunctionReturnType);
	}
