@Override
	public <SUB_RETURN extends AttributeValue> HigherOrderBagFunction<?, SUB_RETURN> getInstance(final Datatype<SUB_RETURN> subFunctionReturnType) throws IllegalArgumentException {
		if (subFunctionReturnType == null)
		{
			throw NULL_SUB_FUNCTION_RETURN_TYPE_ARG_EXCEPTION;
		}

		if (!(subFunctionReturnType instanceof AttributeDatatype<?>))
		{
			throw new IllegalArgumentException(
					"Invalid sub-function's return type specified for function '" + functionId + "': " + subFunctionReturnType + ". Expected: any primitive attribute datatype.");
		}

		return new MapFunction<>(functionId, (AttributeDatatype<SUB_RETURN>) subFunctionReturnType);
	}
