@Override
	public FirstOrderFunctionCall<StringValue> newCall(final List<Expression<?>> argExpressions, final Datatype<?>... remainingArgTypes)
	{

		return new EagerSinglePrimitiveTypeEval<StringValue, StringValue>(functionSignature, argExpressions, remainingArgTypes)
		{

			@Override
			protected StringValue evaluate(final Deque<StringValue> args) throws IndeterminateEvaluationException
			{
				// string-concatenate(str1, str2, str3, ...)
				final StringBuilder strBuilder = new StringBuilder();
				while (!args.isEmpty())
				{
					strBuilder.append(args.poll().getUnderlyingValue());
				}

				return new StringValue(strBuilder.toString());
			}

		};
	}
