public static <ADAPTER_INPUT, ADAPTER_OUTPUT> PdpEngineInoutAdapter<ADAPTER_INPUT, ADAPTER_OUTPUT> newInoutAdapter(final Class<ADAPTER_INPUT> adapterInputClass,
			final Class<ADAPTER_OUTPUT> adapterOutputClass, final CloseablePdpEngine adaptee,
			final Map<Class<?>, Entry<DecisionRequestPreprocessor<?, ?>, DecisionResultPostprocessor<?, ?>>> ioProcChainsByInputType,
			final DecisionRequestPreprocessorSupplier defaultReqPreprocSupplier, final Supplier<DecisionResultPostprocessor<?, ?>> defaultResultPostprocSupplier) throws IllegalArgumentException
	{
		final Entry<DecisionRequestPreprocessor<?, ?>, DecisionResultPostprocessor<?, ?>> ioProcChain = ioProcChainsByInputType.get(adapterInputClass);
		final DecisionResultPostprocessor<?, ?> rawResultPostproc;
		final DecisionRequestPreprocessor<?, ?> rawReqPreproc;
		if (ioProcChain == null)
		{
			rawResultPostproc = null;
			rawReqPreproc = null;
		}
		else
		{
			rawResultPostproc = ioProcChain.getValue();
			rawReqPreproc = ioProcChain.getKey();
		}

		final DecisionResultPostprocessor<?, ?> finalResultProc = rawResultPostproc == null ? defaultResultPostprocSupplier.get() : rawResultPostproc;
		final DecisionRequestPreprocessor<?, ?> finalReqProc = rawReqPreproc == null ? defaultReqPreprocSupplier.get(finalResultProc.getFeatures()) : rawReqPreproc;
		return PdpEngineAdapters.newInoutAdapter(adapterInputClass, adapterOutputClass, adaptee, finalReqProc, finalResultProc);
	}
