public static <ADAPTER_INPUT, ADAPTEE_INPUT_DECISION_REQUEST extends DecisionRequest, ADAPTER_OUTPUT> PdpEngineInoutAdapter<ADAPTER_INPUT, ADAPTER_OUTPUT> newInoutAdapter(
			final Class<ADAPTER_INPUT> adapterInputClass, final Class<ADAPTER_OUTPUT> adapterOutputClass, final PdpEngineConfiguration configuration,
			final DecisionRequestPreprocessor<ADAPTER_INPUT, ADAPTEE_INPUT_DECISION_REQUEST> defaultReqPreproc,
			final DecisionResultPostprocessor<ADAPTEE_INPUT_DECISION_REQUEST, ADAPTER_OUTPUT> defaultResultPostproc) throws IllegalArgumentException, IOException
	{
		// use intermediate Java-friendly PdpEngineConfiguration (higher-level than JAXB) that has #getAttributeValueFactory()
		try (final BasePdpEngine adaptedPdpEngine = new BasePdpEngine(configuration))
		{

			final Entry<DecisionRequestPreprocessor<?, ?>, DecisionResultPostprocessor<?, ?>> ioProcChain = configuration.getInOutProcChains().get(adapterInputClass);
			final DecisionResultPostprocessor<?, ?> rawResultPostProc;
			final DecisionRequestPreprocessor<?, ?> rawReqPreproc;
			if (ioProcChain == null)
			{
				rawResultPostProc = null;
				rawReqPreproc = null;
			}
			else
			{
				rawResultPostProc = ioProcChain.getValue();
				rawReqPreproc = ioProcChain.getKey();
			}

			return newInoutAdapter(adapterInputClass, adapterOutputClass, adaptedPdpEngine, rawReqPreproc == null ? defaultReqPreproc : rawReqPreproc,
					rawResultPostProc == null ? defaultResultPostproc : rawResultPostProc);
		}
	}
