private void initMaps()
	{
		if (immutableRootPolicyRefsMetadata.isPresent())
		{
			final Set<PrimaryPolicyMetadata> allRefPolicies = immutableRootPolicyRefsMetadata.get().getRefPolicies();
			final int maxNumOfRefPolicies;
			final int maxNumOfRefPolicySets;
			if (this.rootPolicyMetadata().getType() == TopLevelPolicyElementType.POLICY)
			{
				maxNumOfRefPolicies = 1 + allRefPolicies.size();
				maxNumOfRefPolicySets = allRefPolicies.size();
			}
			else
			{
				maxNumOfRefPolicies = allRefPolicies.size();
				maxNumOfRefPolicySets = 1 + allRefPolicies.size();
			}

			final Map<String, PrimaryPolicyMetadata> mutableMapOfRefPolicies = HashCollections.newUpdatableMap(maxNumOfRefPolicies);
			final Map<String, PrimaryPolicyMetadata> mutableMapOfRefPolicySets = HashCollections.newUpdatableMap(maxNumOfRefPolicySets);

			for (final PrimaryPolicyMetadata refPolicyMetadata : allRefPolicies)
			{
				if (refPolicyMetadata.getType() == TopLevelPolicyElementType.POLICY)
				{
					mutableMapOfRefPolicies.put(refPolicyMetadata.getId(), refPolicyMetadata);
				}
				else
				{
					mutableMapOfRefPolicySets.put(refPolicyMetadata.getId(), refPolicyMetadata);
				}
			}

			this.lazilyFilledMapOfRefPolicies = ImmutableMap.copyOf(mutableMapOfRefPolicies);
			this.lazilyFilledMapOfRefPolicySets = ImmutableMap.copyOf(mutableMapOfRefPolicySets);
		}
		else
		{
			if (this.rootPolicyMetadata().getType() == TopLevelPolicyElementType.POLICY)
			{
				this.lazilyFilledMapOfRefPolicies = ImmutableMap.of(this.immutableRootPolicyMetadata.getId(), immutableRootPolicyMetadata);
				this.lazilyFilledMapOfRefPolicySets = ImmutableMap.of();
			}
			else
			{
				this.lazilyFilledMapOfRefPolicies = ImmutableMap.of();
				this.lazilyFilledMapOfRefPolicySets = ImmutableMap.of(this.immutableRootPolicyMetadata.getId(), immutableRootPolicyMetadata);
			}
		}
	}
