public static TopLevelPolicyElementEvaluator getInstance(final PolicySet policyElement, final XPathCompiler parentDefaultXPathCompiler, final Map<String, String> namespacePrefixesByURI,
	        final ExpressionFactory expressionFactory, final CombiningAlgRegistry combiningAlgorithmRegistry, final PolicyProvider<?> refPolicyProvider, final Deque<String> ancestorPolicySetRefChain)
	        throws IllegalArgumentException
	{
		if (policyElement == null)
		{
			throw NULL_XACML_POLICYSET_ARG_EXCEPTION;
		}

		final PrimaryPolicyMetadata policyMetadata = new BasePrimaryPolicyMetadata(TopLevelPolicyElementType.POLICY_SET, policyElement.getPolicySetId(), new PolicyVersion(policyElement.getVersion()));
		final PolicySetElementEvaluatorFactory<?, ?> factory = refPolicyProvider instanceof StaticPolicyProvider
		        ? new StaticPolicySetElementEvaluatorFactory(policyMetadata, policyElement.getPolicySetDefaults(), (StaticPolicyProvider) refPolicyProvider, parentDefaultXPathCompiler,
		                namespacePrefixesByURI, expressionFactory, combiningAlgorithmRegistry)
		        : new DynamicPolicySetElementEvaluatorFactory(policyMetadata, policyElement.getPolicySetDefaults(), refPolicyProvider, parentDefaultXPathCompiler, namespacePrefixesByURI,
		                expressionFactory, combiningAlgorithmRegistry);
		return getInstanceGeneric(factory, policyElement, ancestorPolicySetRefChain);
	}
