public static PolicyRefEvaluator getInstance(final TopLevelPolicyElementType refPolicyType, final IdReferenceType idRef, final PolicyProvider<?> refPolicyProvider,
	        final Deque<String> policySetRefChainWithIdRefIfPolicySet) throws IllegalArgumentException
	{
		final PolicyRefEvaluatorFactory<? extends PolicyRefEvaluator> factory = refPolicyProvider instanceof StaticPolicyProvider
		        ? new StaticPolicyRefEvaluatorFactory((StaticPolicyProvider) refPolicyProvider)
		        : new DynamicPolicyRefEvaluatorFactory(refPolicyProvider);
		return getInstanceGeneric(factory, refPolicyType, idRef, policySetRefChainWithIdRefIfPolicySet);
	}
