private static PolicyRefsMetadata newPolicyRefExtraMetadata(final TopLevelPolicyElementEvaluator referredPolicy, final EvaluationContext evalCtx) throws IndeterminateEvaluationException
	{
		assert referredPolicy != null;

		final PrimaryPolicyMetadata referredPolicyMetadata = referredPolicy.getPrimaryPolicyMetadata();
		final Optional<PolicyRefsMetadata> referredPolicyRefsMetadata = referredPolicy.getPolicyRefsMetadata(evalCtx);
		final Set<PrimaryPolicyMetadata> newRefPolicies;
		final List<String> newLongestPolicyRefChain;
		if (referredPolicyRefsMetadata.isPresent())
		{
			final Set<PrimaryPolicyMetadata> childRefPolicies = referredPolicyRefsMetadata.get().getRefPolicies();
			// LinkedHashSet to preserve order
			newRefPolicies = new LinkedHashSet<>(childRefPolicies.size() + 1);
			newRefPolicies.addAll(childRefPolicies);
			newRefPolicies.add(referredPolicyMetadata);

			final List<String> referredPolicyLongestRefChain = referredPolicyRefsMetadata.get().getLongestPolicyRefChain();
			newLongestPolicyRefChain = new ArrayList<>(referredPolicyLongestRefChain.size() + 1);
			newLongestPolicyRefChain.add(referredPolicy.getPolicyId());
			newLongestPolicyRefChain.addAll(referredPolicyLongestRefChain);
		}
		else
		{
			newRefPolicies = Sets.newHashSet(referredPolicyMetadata);
			newLongestPolicyRefChain = Arrays.asList(referredPolicy.getPolicyId());
		}

		return new BasePolicyRefsMetadata(newRefPolicies, newLongestPolicyRefChain);
	}
