@Parameters(name = "{index}: {1}; user={2}; sys={3} -> {5}")
	public static Collection<Object[]> data()
	{
		final Object[][] data = new Object[][] {
		        /*
		         * each test input is: input string, user-defined properties Map<EnvironmentPropertyName,String>, system properties as Map<String, String>, and expected output string
		         */
		        /* empty collection */
		        { "${PARENT_DIR}/a", ImmutableMap.of(EnvironmentPropertyName.PARENT_DIR, "/tmp"), null, "/tmp/a" },

		        /*
		         * System property replacement
		         */
		        { "${org.ow2.authzforce.data.dir}/b", null, ImmutableMap.of("org.ow2.authzforce.data.dir", "/tmp/authzforce"), "/tmp/authzforce/b" },

		        /*
		         * Environment variable PATH replacement. Environment variable AUTHZFORCE_DATA_DIR must be set to "/tmp/authzforce" (e.g. with 'environmentVariables' configuration element of Maven
		         * Surefire plugin)
		         */
		        { "${AUTHZFORCE_DATA_DIR}/c", null, null, "/tmp/authzforce/c" },

		        /*
		         * All kinds of placeholder replacements
		         */
		        { "${AUTHZFORCE_DATA_DIR}/b/${PARENT_DIR}/c/${sys.prop}/d", ImmutableMap.of(EnvironmentPropertyName.PARENT_DIR, "path/to"), ImmutableMap.of("sys.prop", "zx"),
		                "/tmp/authzforce/b/path/to/c/zx/d" },

		        /*
		         * Default value
		         */
		        { "${PARENT_DIR!/opt/driver-testbed-sec-authz-service/data}/a", null, null, "/opt/driver-testbed-sec-authz-service/data/a" },

				/*
				 * 
				 */
		};

		return Arrays.asList(data);
	}
