private static <AV extends AttributeValue> Collection<Object[]> newBagSizeFunctionTestParams(final String bagSizeFunctionId, final AttributeDatatype<AV> bagElementType, final AV primitiveValue)
	{
		final Collection<Object[]> params = new ArrayList<>();

		// bag-size({}) -> 0
		params.add(new Object[] { bagSizeFunctionId, Arrays.asList(bagElementType.getEmptyBag()), ZERO_AS_INT });

		// bag-size({primitiveValue}) -> 1
		params.add(new Object[] { bagSizeFunctionId, Arrays.asList(Bags.singleton(bagElementType, primitiveValue)), ONE_AS_INT });

		// bag-size({primitiveValue, primitiveValue}) -> 2
		params.add(new Object[] { bagSizeFunctionId, Arrays.asList(Bags.newBag(bagElementType, Collections.nCopies(2, primitiveValue))), TWO_AS_INT });
		return params;
	}
