private static <AV extends AttributeValue> Collection<Object[]> newIsInFunctionTestParams(final String isInFunctionId, final AttributeDatatype<AV> bagElementType, final AV primitiveValue1,
			final AV primitiveValue2)
	{
		final Collection<Object[]> params = new ArrayList<>();

		// is-in(val, {}) -> false
		params.add(new Object[] { isInFunctionId, Arrays.asList(primitiveValue1, bagElementType.getEmptyBag()), BooleanValue.FALSE });

		// is-in(primitiveValue2, {primitiveValue1, primitiveValue2}) -> true
		final Bag<AV> twoValBag = Bags.newBag(bagElementType, Arrays.asList(primitiveValue1, primitiveValue2));
		params.add(new Object[] { isInFunctionId, Arrays.asList(primitiveValue2, twoValBag), BooleanValue.TRUE });

		// is-in(primitiveValue2, {primitiveValue1, primitiveValue1}) -> false
		final Bag<AV> twoValBag2 = Bags.newBag(bagElementType, Collections.nCopies(2, primitiveValue1));
		params.add(new Object[] { isInFunctionId, Arrays.asList(primitiveValue2, twoValBag2), BooleanValue.FALSE });
		return params;
	}
