private static <AV extends AttributeValue> Collection<Object[]> newOneAndOnlyFunctionTestParams(final String oneAndOnlyFunctionId, final AttributeDatatype<AV> bagElementType,
			final AV primitiveValue)
	{
		final Collection<Object[]> params = new ArrayList<>();

		// case 1: empty bag {}
		// one-and-only({}) -> Indeterminate
		params.add(new Object[] { oneAndOnlyFunctionId, Arrays.asList(bagElementType.getEmptyBag()), null });

		// one-and-only({primitiveValue}) -> primitiveValue
		params.add(new Object[] { oneAndOnlyFunctionId, Arrays.asList(Bags.singleton(bagElementType, primitiveValue)), primitiveValue });

		// one-and-only({primitiveValue, primitiveValue}) -> Indeterminate
		params.add(new Object[] { oneAndOnlyFunctionId, Arrays.asList(Bags.newBag(bagElementType, Collections.nCopies(2, primitiveValue))), null });

		return params;
	}
