@Parameters(name = "{index}: {0}")
	public static Collection<Object[]> params() throws Exception
	{
		final Collection<Object[]> params = new ArrayList<>();

		// *-one-and-only functions
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_STRING_ONE_AND_ONLY, StandardDatatypes.STRING, new StringValue("Test")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_BOOLEAN_ONE_AND_ONLY, StandardDatatypes.BOOLEAN, BooleanValue.FALSE));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_INTEGER_ONE_AND_ONLY, StandardDatatypes.INTEGER, IntegerValue.valueOf(3)));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_DOUBLE_ONE_AND_ONLY, StandardDatatypes.DOUBLE, new DoubleValue("3.14")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_ANYURI_ONE_AND_ONLY, StandardDatatypes.ANYURI, new AnyUriValue("http://www.example.com")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_HEXBINARY_ONE_AND_ONLY, StandardDatatypes.HEXBINARY, new HexBinaryValue("0FB7")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_BASE64BINARY_ONE_AND_ONLY, StandardDatatypes.BASE64BINARY, new Base64BinaryValue("RXhhbXBsZQ==")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_TIME_ONE_AND_ONLY, StandardDatatypes.TIME, new TimeValue("09:30:15")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_DATE_ONE_AND_ONLY, StandardDatatypes.DATE, new DateValue("2002-09-24")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_DATETIME_ONE_AND_ONLY, StandardDatatypes.DATETIME, new DateTimeValue("2002-09-24T09:30:15")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_DAYTIMEDURATION_ONE_AND_ONLY, StandardDatatypes.DAYTIMEDURATION, new DayTimeDurationValue("P1DT2H")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_YEARMONTHDURATION_ONE_AND_ONLY, StandardDatatypes.YEARMONTHDURATION, new YearMonthDurationValue("P1Y2M")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_X500NAME_ONE_AND_ONLY, StandardDatatypes.X500NAME, new X500NameValue("cn=John Smith, o=Medico Corp, c=US")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_RFC822NAME_ONE_AND_ONLY, StandardDatatypes.RFC822NAME, new Rfc822NameValue("Anderson@sun.com")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_IPADDRESS_ONE_AND_ONLY, StandardDatatypes.IPADDRESS, new IpAddressValue("192.168.1.10")));
		params.addAll(newOneAndOnlyFunctionTestParams(NAME_DNSNAME_ONE_AND_ONLY, StandardDatatypes.DNSNAME, new DnsNameWithPortRangeValue("example.com")));

		// *-bag-size functions
		params.addAll(newBagSizeFunctionTestParams(NAME_STRING_BAG_SIZE, StandardDatatypes.STRING, new StringValue("Test")));
		params.addAll(newBagSizeFunctionTestParams(NAME_BOOLEAN_BAG_SIZE, StandardDatatypes.BOOLEAN, BooleanValue.FALSE));
		params.addAll(newBagSizeFunctionTestParams(NAME_INTEGER_BAG_SIZE, StandardDatatypes.INTEGER, IntegerValue.valueOf(1)));
		params.addAll(newBagSizeFunctionTestParams(NAME_DOUBLE_BAG_SIZE, StandardDatatypes.DOUBLE, new DoubleValue("3.14")));
		params.addAll(newBagSizeFunctionTestParams(NAME_ANYURI_BAG_SIZE, StandardDatatypes.ANYURI, new AnyUriValue("http://www.example.com")));
		params.addAll(newBagSizeFunctionTestParams(NAME_HEXBINARY_BAG_SIZE, StandardDatatypes.HEXBINARY, new HexBinaryValue("0FB7")));
		params.addAll(newBagSizeFunctionTestParams(NAME_BASE64BINARY_BAG_SIZE, StandardDatatypes.BASE64BINARY, new Base64BinaryValue("RXhhbXBsZQ==")));
		params.addAll(newBagSizeFunctionTestParams(NAME_TIME_BAG_SIZE, StandardDatatypes.TIME, new TimeValue("09:30:15")));
		params.addAll(newBagSizeFunctionTestParams(NAME_DATE_BAG_SIZE, StandardDatatypes.DATE, new DateValue("2002-09-24")));
		params.addAll(newBagSizeFunctionTestParams(NAME_DATETIME_BAG_SIZE, StandardDatatypes.DATETIME, new DateTimeValue("2002-09-24T09:30:15")));
		params.addAll(newBagSizeFunctionTestParams(NAME_DAYTIMEDURATION_BAG_SIZE, StandardDatatypes.DAYTIMEDURATION, new DayTimeDurationValue("P1DT2H")));
		params.addAll(newBagSizeFunctionTestParams(NAME_YEARMONTHDURATION_BAG_SIZE, StandardDatatypes.YEARMONTHDURATION, new YearMonthDurationValue("P1Y2M")));
		params.addAll(newBagSizeFunctionTestParams(NAME_X500NAME_BAG_SIZE, StandardDatatypes.X500NAME, new X500NameValue("cn=John Smith, o=Medico Corp, c=US")));
		params.addAll(newBagSizeFunctionTestParams(NAME_RFC822NAME_BAG_SIZE, StandardDatatypes.RFC822NAME, new Rfc822NameValue("Anderson@sun.com")));
		params.addAll(newBagSizeFunctionTestParams(NAME_IPADDRESS_BAG_SIZE, StandardDatatypes.IPADDRESS, new IpAddressValue("192.168.1.10")));
		params.addAll(newBagSizeFunctionTestParams(NAME_DNSNAME_BAG_SIZE, StandardDatatypes.DNSNAME, new DnsNameWithPortRangeValue("example.com")));

		// *-is-in functions
		params.addAll(newIsInFunctionTestParams(NAME_STRING_IS_IN, StandardDatatypes.STRING, new StringValue("Test1"), new StringValue("Test2")));
		params.addAll(newIsInFunctionTestParams(NAME_BOOLEAN_IS_IN, StandardDatatypes.BOOLEAN, BooleanValue.FALSE, BooleanValue.TRUE));
		params.addAll(newIsInFunctionTestParams(NAME_INTEGER_IS_IN, StandardDatatypes.INTEGER, IntegerValue.valueOf(1), IntegerValue.valueOf(2)));
		params.addAll(newIsInFunctionTestParams(NAME_DOUBLE_IS_IN, StandardDatatypes.DOUBLE, new DoubleValue("-4.21"), new DoubleValue("3.14")));
		params.addAll(newIsInFunctionTestParams(NAME_ANYURI_IS_IN, StandardDatatypes.ANYURI, new AnyUriValue("http://www.example.com"), new AnyUriValue("http://www.example1.com")));
		params.addAll(newIsInFunctionTestParams(NAME_HEXBINARY_IS_IN, StandardDatatypes.HEXBINARY, new HexBinaryValue("0FB7"), new HexBinaryValue("0FB8")));
		params.addAll(newIsInFunctionTestParams(NAME_BASE64BINARY_IS_IN, StandardDatatypes.BASE64BINARY, new Base64BinaryValue("RXhhbXBsZQ=="), new Base64BinaryValue("T3RoZXI=")));
		params.addAll(newIsInFunctionTestParams(NAME_TIME_IS_IN, StandardDatatypes.TIME, new TimeValue("09:30:15"), new TimeValue("17:18:19")));
		params.addAll(newIsInFunctionTestParams(NAME_DATE_IS_IN, StandardDatatypes.DATE, new DateValue("2002-09-24"), new DateValue("2003-10-25")));
		params.addAll(newIsInFunctionTestParams(NAME_DATETIME_IS_IN, StandardDatatypes.DATETIME, new DateTimeValue("2002-09-24T09:30:15"), new DateTimeValue("2003-10-25T17:18:19")));
		params.addAll(newIsInFunctionTestParams(NAME_DAYTIMEDURATION_IS_IN, StandardDatatypes.DAYTIMEDURATION, new DayTimeDurationValue("P1DT2H"), new DayTimeDurationValue("-P1DT3H")));
		params.addAll(newIsInFunctionTestParams(NAME_YEARMONTHDURATION_IS_IN, StandardDatatypes.YEARMONTHDURATION, new YearMonthDurationValue("P1Y2M"), new YearMonthDurationValue("-P1Y3M")));
		params.addAll(newIsInFunctionTestParams(NAME_X500NAME_IS_IN, StandardDatatypes.X500NAME, new X500NameValue("cn=John Smith, o=Medico Corp, c=US"), new X500NameValue(
				"cn=John Smith, o=Other Corp, c=US")));
		params.addAll(newIsInFunctionTestParams(NAME_RFC822NAME_IS_IN, StandardDatatypes.RFC822NAME, new Rfc822NameValue("Anderson@sun.com"), new Rfc822NameValue("Smith@sun.com")));
		params.addAll(newIsInFunctionTestParams(NAME_IPADDRESS_IS_IN, StandardDatatypes.IPADDRESS, new IpAddressValue("192.168.1.10"), new IpAddressValue("192.168.1.11")));
		params.addAll(newIsInFunctionTestParams(NAME_DNSNAME_IS_IN, StandardDatatypes.DNSNAME, new DnsNameWithPortRangeValue("example.com"), new DnsNameWithPortRangeValue("example1.com")));

		// *-bag functions
		params.addAll(newBagOfFunctionTestParams(NAME_STRING_BAG, StandardDatatypes.STRING, new StringValue("Test1"), new StringValue("Test2")));
		params.addAll(newBagOfFunctionTestParams(NAME_BOOLEAN_BAG, StandardDatatypes.BOOLEAN, BooleanValue.FALSE, BooleanValue.TRUE));
		params.addAll(newBagOfFunctionTestParams(NAME_INTEGER_BAG, StandardDatatypes.INTEGER, IntegerValue.valueOf(1), IntegerValue.valueOf(2)));
		params.addAll(newBagOfFunctionTestParams(NAME_DOUBLE_BAG, StandardDatatypes.DOUBLE, new DoubleValue("-4.21"), new DoubleValue("3.14")));
		params.addAll(newBagOfFunctionTestParams(NAME_ANYURI_BAG, StandardDatatypes.ANYURI, new AnyUriValue("http://www.example.com"), new AnyUriValue("http://www.example1.com")));
		params.addAll(newBagOfFunctionTestParams(NAME_HEXBINARY_BAG, StandardDatatypes.HEXBINARY, new HexBinaryValue("0FB7"), new HexBinaryValue("0FB8")));
		params.addAll(newBagOfFunctionTestParams(NAME_BASE64BINARY_BAG, StandardDatatypes.BASE64BINARY, new Base64BinaryValue("RXhhbXBsZQ=="), new Base64BinaryValue("T3RoZXI=")));
		params.addAll(newBagOfFunctionTestParams(NAME_TIME_BAG, StandardDatatypes.TIME, new TimeValue("09:30:15"), new TimeValue("17:18:19")));
		params.addAll(newBagOfFunctionTestParams(NAME_DATE_BAG, StandardDatatypes.DATE, new DateValue("2002-09-24"), new DateValue("2003-10-25")));
		params.addAll(newBagOfFunctionTestParams(NAME_DATETIME_BAG, StandardDatatypes.DATETIME, new DateTimeValue("2002-09-24T09:30:15"), new DateTimeValue("2003-10-25T17:18:19")));
		params.addAll(newBagOfFunctionTestParams(NAME_DAYTIMEDURATION_BAG, StandardDatatypes.DAYTIMEDURATION, new DayTimeDurationValue("P1DT2H"), new DayTimeDurationValue("-P1DT3H")));
		params.addAll(newBagOfFunctionTestParams(NAME_YEARMONTHDURATION_BAG, StandardDatatypes.YEARMONTHDURATION, new YearMonthDurationValue("P1Y2M"), new YearMonthDurationValue("-P1Y3M")));
		params.addAll(newBagOfFunctionTestParams(NAME_X500NAME_BAG, StandardDatatypes.X500NAME, new X500NameValue("cn=John Smith, o=Medico Corp, c=US"), new X500NameValue(
				"cn=John Smith, o=Other Corp, c=US")));
		params.addAll(newBagOfFunctionTestParams(NAME_RFC822NAME_BAG, StandardDatatypes.RFC822NAME, new Rfc822NameValue("Anderson@sun.com"), new Rfc822NameValue("Smith@sun.com")));
		params.addAll(newBagOfFunctionTestParams(NAME_IPADDRESS_BAG, StandardDatatypes.IPADDRESS, new IpAddressValue("192.168.1.10"), new IpAddressValue("192.168.1.11")));
		params.addAll(newBagOfFunctionTestParams(NAME_DNSNAME_BAG, StandardDatatypes.DNSNAME, new DnsNameWithPortRangeValue("example.com"), new DnsNameWithPortRangeValue("example1.com")));

		return params;
	}
