@Test
	public void testEvaluate() throws IndeterminateEvaluationException
	{
		if (isTestOkBeforeFuncCall)
		{
			/*
			 * Test already OK (syntax error was expected and occured when creating the function call already), no need to carry on the function call
			 */
			return;
		}

		/*
		 * Use null context as all inputs given as values in function tests, therefore already provided as inputs to function call
		 */
		try
		{
			/*
			 * funcCall != null (see constructor)
			 */
			final Value actualResult = funcCall.evaluate(null);
			if (expectedResult instanceof Bag && actualResult instanceof Bag && areBagsComparedAsSets)
			{
				final Set<?> expectedSet = bagToSet((Bag<?>) expectedResult);
				final Set<?> actualSet = bagToSet((Bag<?>) actualResult);
				Assert.assertEquals(toString, expectedSet, actualSet);
			} else if (expectedResult != null)
			{
				Assert.assertEquals(toString, expectedResult, actualResult);
			}
		} catch (final IndeterminateEvaluationException e)
		{
			if (expectedResult != null)
			{
				// unexpected error
				throw e;
			}
		}
	}
