private static JSONObject toJson(final PepActionAttributeAssignment<?> aa)
	{
		final Map<String, Object> aaJsonPropMap = HashCollections.newUpdatableMap(5);
		aaJsonPropMap.put("AttributeId", aa.getAttributeId());
		final AttributeValue aaVal = aa.getValue();
		if (!aaVal.getXmlAttributes().isEmpty())
		{
			throw ILLEGAL_ATTRIBUTE_ASSIGNMENT_RUNTIME_EXCEPTION;
		}

		final List<Serializable> contentParts = aaVal.getContent();
		if (contentParts.isEmpty() || contentParts.size() > 1)
		{
			throw ILLEGAL_ATTRIBUTE_ASSIGNMENT_RUNTIME_EXCEPTION;
		}

		aaJsonPropMap.put("Value", contentParts.get(0).toString());

		final Optional<String> category = aa.getCategory();
		if (category.isPresent())
		{
			aaJsonPropMap.put("Category", category.get());
		}

		aaJsonPropMap.put("DataType", aa.getDatatype().getId());

		final Optional<String> issuer = aa.getIssuer();
		if (issuer.isPresent())
		{
			aaJsonPropMap.put("Issuer", issuer.get());
		}

		return new JSONObject(aaJsonPropMap);
	}
