private static JSONObject toJson(final Status status)
	{
		/*
		 * Weirdness: StatusCode is optional in XACML/JSON Status although mandatory in XACML/XML Status
		 */
		final Map<String, Object> statusJsonObject = HashCollections.newUpdatableMap(3);
		statusJsonObject.put("StatusCode", toJson(status.getStatusCode()));
		final String statusMsg = status.getStatusMessage();
		if (statusMsg != null)
		{
			statusJsonObject.put("StatusMessage", statusMsg);
		}

		final StatusDetail statusDetail = status.getStatusDetail();
		assert statusDetail == null;
		// FIXME: StatusDetail not supported for the moment

		return new JSONObject(statusJsonObject);
	}
