private static JSONObject toJson(final String obligationOrAdviceId, final List<PepActionAttributeAssignment<?>> aaList)
	{
		assert obligationOrAdviceId != null && aaList != null;
		final Map<String, Object> obligationOrAdviceJsonPropMap = HashCollections.newUpdatableMap(2);
		obligationOrAdviceJsonPropMap.put("Id", obligationOrAdviceId);
		if (!aaList.isEmpty())
		{
			final List<JSONObject> jsonAttAssignments = aaList.stream().map(e -> toJson(e)).collect(Collectors.toList());
			obligationOrAdviceJsonPropMap.put("AttributeAssignment", new JSONArray(jsonAttAssignments));
		}

		return new JSONObject(obligationOrAdviceJsonPropMap);
	}
