public static TopLevelPolicyElementRef getPolicyRef(final Path path) throws JAXBException
	{
		/*
		 * Unmarshall without schema validation because some test policy files are intendedly invalid to test XACML syntax validation
		 */
		final Object policyOrPolicySet = Xacml3JaxbHelper.XACML_3_0_JAXB_CONTEXT.createUnmarshaller().unmarshal(path.toFile());
		final boolean isPolicySet;
		final String policyId;
		if (policyOrPolicySet instanceof PolicySet)
		{
			isPolicySet = true;
			policyId = ((PolicySet) policyOrPolicySet).getPolicySetId();
		}
		else
		{
			isPolicySet = false;
			policyId = ((Policy) policyOrPolicySet).getPolicyId();
		}

		return new TopLevelPolicyElementRef(policyId, null, isPolicySet);
	}
