public static PdpEngineConfiguration newPdpEngineConfiguration(final TopLevelPolicyElementRef rootPolicyRef, final Path policiesDirectory, final boolean enableXPath,
	        final Optional<Path> attributeProviderConfFile, final String requestPreprocId, final String resultPostprocId) throws IllegalArgumentException, IOException, JAXBException
	{
		final List<String> policyLocations = new ArrayList<>();

		/*
		 * Root policy expected to be in the policies directory as well
		 */
		try (DirectoryStream<Path> stream = Files.newDirectoryStream(policiesDirectory))
		{
			for (final Path path : stream)
			{
				if (Files.isRegularFile(path))
				{
					policyLocations.add(path.toString());
				}
			}
		}
		catch (final DirectoryIteratorException ex)
		{
			// I/O error encounted during the iteration, the cause is an IOException
			throw ex.getCause();
		}

		return newPdpEngineConfiguration(rootPolicyRef, policyLocations, enableXPath, attributeProviderConfFile, requestPreprocId, resultPostprocId);
	}
