private static List<Attributes> normalizeAttributeCategories(final List<Attributes> attributesList)
	{
		// Attributes categories may be in different order than expected although it is still compliant (order does not matter to the spec)
		// always use the same order (lexicographical here)
		final SortedSet<Attributes> sortedSet = new TreeSet<>(ATTRIBUTES_COMPARATOR);
		for (final Attributes attributes : attributesList)
		{
			sortedSet.add(attributes);
		}

		return new ArrayList<>(sortedSet);
	}
