private static Entry<String, Integer> parseDnsName(final String dnsName) throws IllegalArgumentException
	{
		assert dnsName != null;

		final String host;
		final Integer port;
		final int portSep = dnsName.indexOf(':');
		if (portSep == -1)
		{
			// there is no port portRange, so just use the name
			host = dnsName;
			port = UNDEFINED_PORT;
		} else
		{
			// split the name and the port
			host = dnsName.substring(0, portSep);
			// validate port portRange
			port = Integer.valueOf(dnsName.substring(portSep + 1, dnsName.length()));
		}

		// verify that the hostname is valid before we store it
		if (!isValidHostName(host))
		{
			throw new IllegalArgumentException("Bad hostname: " + host);
		}

		return new SimpleEntry<>(host, port);
	}
