@Test
	public void testGetPolicySetWithValidIdAndValidVersionPattern() throws IllegalArgumentException, IndeterminateEvaluationException
	{
		// Valid ID, valid version pattern (a PolicySet with same version and id also exists, make sure the right policy type is returned)
		final TopLevelPolicyElementEvaluator policyEvaluator = POLICY_PROVIDER_MODULE.get(TopLevelPolicyElementType.POLICY_SET, "root-rbac-policyset",
		        Optional.of(new PolicyVersionPatterns("1.*", null, null)), null, null);
		assertNotNull(policyEvaluator);
		assertEquals(TopLevelPolicyElementType.POLICY_SET, policyEvaluator.getPolicyElementType());
		assertEquals("root-rbac-policyset", policyEvaluator.getPolicyId());
		assertEquals("1.2", policyEvaluator.getPolicyVersion().toString());
	}
