@org.junit.Test
	public void testUnauthorizedRequest() throws Exception
	{

		final SpringBusFactory bf = new SpringBusFactory();
		final URL busFile = EmbeddedPdpBasedAuthzInterceptorTest.class.getResource("cxf-client.xml");

		final Bus bus = bf.createBus(busFile.toString());
		SpringBusFactory.setDefaultBus(bus);
		SpringBusFactory.setThreadDefaultBus(bus);

		final URL wsdl = EmbeddedPdpBasedAuthzInterceptorTest.class.getResource("DoubleItSecure.wsdl");
		final Service service = Service.create(wsdl, SERVICE_QNAME);
		final QName portQName = new QName(NAMESPACE, "DoubleItTransportPort");
		final DoubleItPortType transportPort = service.getPort(portQName, DoubleItPortType.class);
		updateAddressPort(transportPort, PORT);

		final Client client = ClientProxy.getClient(transportPort);
		client.getRequestContext().put("ws-security.username", "bob");

		TokenTestUtils.updateSTSPort((BindingProvider) transportPort, STS_PORT);

		try
		{
			doubleIt(transportPort, 25);
			fail("Failure expected on bob");
		}
		catch (final Exception ex)
		{
			// expected
		}
	}
