private void setHttpResponseStatus(final SoapMessage message, final int status)
	{
		// skip if inbound
		if (!MessageUtils.isOutbound(message))
		{
			return;
		}

		// outbound
		final Exchange exchange = message.getExchange();
		final Message outMessage = Optional.ofNullable(exchange.getOutMessage()).orElse(exchange.getOutFaultMessage());
		final HttpServletResponse httpResponse = (HttpServletResponse) outMessage.get(AbstractHTTPDestination.HTTP_RESPONSE);
		if (httpResponse != null)
		{
			httpResponse.setStatus(status);
		}
		/*
		 * else this is likely SOAP over some non-HTTP transport protocol
		 */

		/*
		 * Prevent any further processing by other interceptors
		 */
		message.getInterceptorChain().abort();

	}
