public synchronized void stop() {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, getName() + ", stops.");
    running = false;
    
    // Be careful, if this method is called by the thread itself the code below
    // cause a deadlock. Simply set running to false then return so the daemon should
    // terminate.
    if (Thread.currentThread() == thread) return;
    
    if (thread != null) {
      while (thread.isAlive()) {
        if (canStop) {

          if (thread.isAlive())
            thread.interrupt();

          shutdown();
        }
        try {
          thread.join(1000L);
        } catch (InterruptedException exc) {
          continue;
        }
      }
      finish();
      thread = null;
    }
  }
