public static final void toByteArray(ByteArrayOutputStream output, String str) {
    if (str == null) return;

    output.write(34);	// '"'

    int max = str.length();
    for (int i = 0; i < max; i ++) {
      // gets the numeric value of the unicode character
      int b = str.charAt(i);
      if ((b >= 32) && (b <= 126)) {
        // ASCII printable character, includes '"' and '\\'
        switch (b) {
        case 34:	// '"'
        case 92:	// '\\'
          output.write(92);	// '\\'
          break;
        }
        output.write(b);
      } else {
        output.write(92);	// '\\'
        switch (b) {
        case 8:		// backspace
          output.write(98);	// 'b'
          break;
        case 9:		// horizontal tab
          output.write(116);	// 't'
          break;
        case 10:	// linefeed
          output.write(110);	// 'n'
          break;
        case 12:	// form feed
          output.write(102);	// 'f'
          break;
        case 13:	// carriage return
          output.write(114);	// 'r'
          break;
        default:
          // UTF escape sequence
          output.write(117);	// 'u'
        int b3 = b >> 4;
      int b4 = b & 0xf;
      if (b4 < 10)
        b4 += 48;		// '0'
      else
        b4 += 87;		// 'a' - 10
      int b2 = b3 >> 4;
      b3 &= 0xf;
      if (b3 < 10)
        b3 += 48;		// '0'
      else
        b3 += 87;		// 'a' - 10
      int b1 = b2 >> 4;
      b2 &= 0xf;
      if (b2 < 10)
        b2 += 48;		// '0'
      else
        b2 += 87;		// 'a' - 10
      if (b1 < 10)
        b1 += 48;		// '0'
      else
        b1 += 87;		// 'a' - 10
      output.write(b1);
      output.write(b2);
      output.write(b3);
      output.write(b4);
      break;
        }
      }
    }

    output.write(34);	// '"'
  }
