public static final void toString(StringBuffer output, Object obj) {
    if (obj == null) {
      output.append("null");
      return;
    }

    if (obj instanceof String) {
      toString(output, (String) obj);
      return;
    }
    if (obj instanceof List) {
      toString(output, (List<?>) obj);
      return;
    }
    if (obj instanceof Collection) {
      toString(output, (Collection<?>) obj);
      return;
    }
    if (obj instanceof Map) {
      toString(output, (Map<?, ?>) obj);
      return;
    }
    if (obj instanceof Map.Entry) {
      toString(output, (Map.Entry<?, ?>) obj);
      return;
    }

    Class<?> type = obj.getClass();
    if (type.isArray()) {
      toString(output, obj, type.getComponentType());
      return;
    }

    try {
      Class<?>[] argstype = new Class[1];
      argstype[0] = Class.forName("java.lang.StringBuffer");
      Method method = type.getMethod("toString", argstype);
      Object[] args = new Object[1];
      args[0] = output;
      method.invoke(obj, args);
      return;
    } catch (Exception exc) {}

    output.append(obj.toString());
  }
