public static final void toString(StringBuffer output,
                                    Object obj, Class<?> type,
                                    int listMax, int listBorder) {
    if (obj == null) {
      output.append("null");
      return;
    }

    if (type.isPrimitive()) {
      if (type == Boolean.TYPE)
        toString(output, (boolean[]) obj);
      else if (type == Character.TYPE)
        toString(output, (char[]) obj);
      else if (type == Byte.TYPE)
        toString(output, (byte[]) obj);
      else if (type == Short.TYPE)
        toString(output, (short[]) obj);
      else if (type == Integer.TYPE)
        toString(output, (int[]) obj);
      else if (type == Long.TYPE)
        toString(output, (long[]) obj);
      else if (type == Float.TYPE)
        toString(output, (float[]) obj);
      else if (type == Double.TYPE)
        toString(output, (double[]) obj);
      return;
    }

    Object[] tab = (Object[]) obj;

    output.append("(");
    int size = tab.length;
    output.append(size);
    if (listMax == -1 || size <= listMax) {
      for (int i = 0; i < size; i ++) {
        output.append(",");
        toString(output, tab[i]);
      }
    } else {
      int border = size / 2;
      if (listBorder < border)
        border = listBorder;
      for (int i = 0; i < border; i ++) {
        output.append(",");
        toString(output, tab[i]);
      }
      output.append(",..");
      for (int i = border; i > 0; i --) {
        output.append(",");
        toString(output, tab[size - i]);
      }
    }
    output.append(")");
  }
