public static StringBuffer dumpAllStackTraces(StringBuffer dump) {
    Map<Thread, StackTraceElement[]> stacktraces = Thread.getAllStackTraces();

    for (Thread thread : stacktraces.keySet()) {
      Thread.State state = thread.getState();
      dump.append(String.format("\"%s\" %s prio=%d tid=%d nid=1 %s\njava.lang.Thread.State: %s",
          thread.getName(),
          (thread.isDaemon() ? "daemon" : ""),
          thread.getPriority(),
          thread.getId(),
          Thread.State.WAITING.equals(state) ? "in Object.wait()" : state.name().toLowerCase(),
              (state.equals(Thread.State.WAITING) ? "WAITING (on object monitor)" : state)));
      final StackTraceElement[] stacktrace = stacktraces.get(thread);
      for (final StackTraceElement stackTraceElement : stacktrace) {
        dump.append("\n\tat ").append(stackTraceElement);
      }
      dump.append("\n---\n");
    }
    return dump;
  }
