public static StringBuffer dumpAttributes(String name, StringBuffer strbuf) {
    Set<String> mBeans = null;
    try {
      mBeans = MXWrapper.queryNames(name);
    } catch (Exception exc) {
      logger.log(BasicLevel.ERROR, "DumpAttributes.dumpAttributes, bad name: " + name, exc);
      return strbuf;
    }

    if (mBeans != null) {
      for (Iterator<String> iterator = mBeans.iterator(); iterator.hasNext();) {
        String mBean = iterator.next();

        // Get all mbean's attributes
        try {
          List<String> attributes = MXWrapper.getAttributeNames(mBean);
          if (attributes != null) {
            for (int i = 0; i < attributes.size(); i++) {
              String attname = (String) attributes.get(i);
              try {
                addRecord(strbuf, mBean, attname, MXWrapper.getAttribute(mBean, attname));
              } catch (Exception exc) {
                if (logger.isLoggable(BasicLevel.DEBUG))
                  logger.log(BasicLevel.DEBUG,
                             "DumpAttributes.dumpAttributes, bad attribute : " + mBean + ":" + attname, exc);
                else
                  logger.log(BasicLevel.WARN,
                             "DumpAttributes.dumpAttributes, bad attribute : " + mBean + ":" + attname);
              }
            }
          }
        } catch (Exception exc) {
          logger.log(BasicLevel.ERROR, "DumpAttributes.dumpAttributes", exc);
        }
      }
    }
    return strbuf;
  }
