public final static ServerSocketFactory getFactory(String ssfcn) {
  	ServerSocketFactory serverSocketFactory = null;
    try {
      Class<?> factoryClass = Class.forName(ssfcn);
      Method method = factoryClass.getMethod("getFactory", (Class[]) null);
      serverSocketFactory = (ServerSocketFactory) method.invoke(null, (Object[]) null);
    } catch (Exception exc) {
      logger.log(BasicLevel.ERROR,
                 "Use default SocketFactory, unable to instantiate : " + ssfcn, exc);
      serverSocketFactory = getDefaultFactory();
    }
    return serverSocketFactory;
  }
