public static SocketFactory getFactory(String sfcn) {
    SocketFactory socketFactory = null;
    try {
      Class<?> factoryClass = Class.forName(sfcn);
      Method method = factoryClass.getMethod("getFactory", (Class[]) null);
      socketFactory = (SocketFactory) method.invoke(null, (Object[]) null);
    } catch (Exception exc) {
      logger.log(BasicLevel.ERROR,
                 "Use default SocketFactory, unable to instantiate : " + sfcn, exc);
      socketFactory = getDefaultFactory();
    }
    return socketFactory;
  }
