public static Object decodeValue(Decoder decoder) throws Exception {
    byte type = decoder.decodeByte();
    switch (type) {
    case NULL:
      return null;
    case BOOLEAN:
      return new Boolean(decoder.decodeBoolean());
    case BYTE:
      return new Byte(decoder.decodeByte());
    case SHORT:
      return new Short(decoder.decodeSignedShort());
    case INT:
      return new Integer(decoder.decodeSignedInt());
    case LONG:
      return new Long(decoder.decodeSignedLong());
    case FLOAT:
      return new Float(decoder.decodeFloat());
    case DOUBLE:
      return new Double(decoder.decodeDouble());
    case STRING:
      return decoder.decodeString();
    case BYTEARRAY:
      return decoder.decodeByteArray();
    default:
      throw new InvalidClassException("Bad primitive type"); 
    }
  }
