public static void encodeValue(Object obj, Encoder encoder) throws Exception {
    if (obj == null) {
      encoder.encodeByte(NULL);
    } else if (obj instanceof Boolean) {
      encoder.encodeByte(BOOLEAN);
      encoder.encodeBoolean(((Boolean) obj).booleanValue());
    } else if (obj instanceof Byte) {
      encoder.encodeByte(BYTE);
      encoder.encodeByte(((Byte) obj).byteValue());
    } else if (obj instanceof Short) {
      encoder.encodeByte(SHORT);
      encoder.encodeSignedShort(((Short) obj).shortValue());
    } else if (obj instanceof Integer) {
      encoder.encodeByte(INT);
      encoder.encodeSignedInt(((Integer) obj).intValue());
    } else if (obj instanceof Long) {
      encoder.encodeByte(LONG);
      encoder.encodeSignedLong(((Long) obj).longValue());
    } else if (obj instanceof Float) {
      encoder.encodeByte(FLOAT);
      encoder.encodeFloat(((Float) obj).floatValue());
    } else if (obj instanceof Double) {
      encoder.encodeByte(DOUBLE);
      encoder.encodeDouble(((Double) obj).doubleValue());
    } else if (obj instanceof String) {
      encoder.encodeByte(STRING);
      encoder.encodeString((String) obj);
    } else if (obj instanceof byte[]) {
      encoder.encodeByte(BYTEARRAY);
      encoder.encodeByteArray((byte[]) obj);
    } else {
      throw new InvalidClassException("Bad primitive type"); 
    }
  }
