public static int getEncodedSize(Object obj) throws IOException {
    int size = 0;
    if (obj == null) {
      size += Encodable.BYTE_ENCODED_SIZE;
    } else if (obj instanceof Boolean) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.BOOLEAN_ENCODED_SIZE;
    } else if (obj instanceof Byte) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.BYTE_ENCODED_SIZE;
    } else if (obj instanceof Short) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.SHORT_ENCODED_SIZE;
    } else if (obj instanceof Integer) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.INT_ENCODED_SIZE;
    } else if (obj instanceof Long) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.LONG_ENCODED_SIZE;
    } else if (obj instanceof Float) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.FLOAT_ENCODED_SIZE;
    } else if (obj instanceof Double) {
      size += Encodable.BYTE_ENCODED_SIZE + Encodable.DOUBLE_ENCODED_SIZE;
    } else if (obj instanceof String) {
      size += Encodable.BYTE_ENCODED_SIZE + EncodableHelper.getStringEncodedSize((String) obj);
    } else if (obj instanceof byte[]) {
      size += Encodable.BYTE_ENCODED_SIZE + EncodableHelper.getByteArrayEncodedSize((byte[]) obj);
    } else {
      throw new InvalidClassException("Bad primitive type"); 
    }
    return size;
  }
