public static Object readObjectFrom(InputStream is) throws IOException {
    byte type = readByteFrom(is);
    switch (type) {
    case NULL:
      return null;
    case BOOLEAN:
      return new Boolean(readBooleanFrom(is));
    case BYTE:
      return new Byte(readByteFrom(is));
    case SHORT:
      return new Short(readShortFrom(is));
    case INT:
      return new Integer(readIntFrom(is));
    case LONG:
      return new Long(readLongFrom(is));
    case FLOAT:
      return new Float(readFloatFrom(is));
    case DOUBLE:
      return new Double(readDoubleFrom(is));
    case STRING:
      return readStringFrom(is);
    case BYTEARRAY:
      return readByteArrayFrom(is);
    default:
      throw new InvalidClassException("Bad primitive type"); 
    }
  }
