public void start(BundleContext context) throws Exception {
    Activator.context = context;

    short sid = getShortProperty(AGENT_SERVER_ID_PROPERTY, (short) 0);
    String path = getProperty(AGENT_SERVER_STORAGE_PROPERTY, "s" + sid);
    try {
      AgentServer.init(sid, path, null);
    } catch (Exception exc) {
      System.out.println(AgentServer.getName() + "initialization failed: " + AgentServer.ERRORSTRING);
      System.out.println(exc.toString());
      System.out.println(AgentServer.ENDSTRING);
      logmon.log(BasicLevel.ERROR, AgentServer.getName() + " initialization failed", exc);
      throw exc;
    }

    try {
      String errStr = AgentServer.start();
      if (errStr == null) {
        System.out.println(AgentServer.getName() + " started: " + AgentServer.OKSTRING);
      } else {
        System.out.println(AgentServer.getName() + " started: " + AgentServer.ERRORSTRING);
        System.out.print(errStr);
        System.out.println(AgentServer.ENDSTRING);
      }
    } catch (Exception exc) {
      System.out.println(AgentServer.getName() + " start failed: " + AgentServer.ERRORSTRING);
      System.out.print(exc.toString());
      System.out.println(AgentServer.ENDSTRING);
      logmon.log(BasicLevel.ERROR, AgentServer.getName() + " failed", exc);
      throw exc;
    }
  }
