private boolean checkEngine(long now) {
    logmon.log(BasicLevel.DEBUG,
               AgentServer.getName() + ".checkEngine():" + engine.getNbReactions() + ", " + reactCount);

    if (engine.getNbReactions() > reactCount) {
      reactCount = engine.getNbReactions();
      lastEngineChangeDate = now;
      return false;
    }

    if (! engine.isRunning()) {
      // The engine does not run, just log a warn if needed
      if (((now - lastEngineChangeDate) > dtwarn) && ((now - lastEngineWarnDate) > dtwarn)) {
        logmon.log(BasicLevel.DEBUG,
                   AgentServer.getName() + ", engine is not started.");
        lastEngineWarnDate = now;
      }
      return false;
    }

    if (idleEngine()) {
      // The engine was idle, just log a warn if needed
      if (((now - lastEngineChangeDate) > dtwarn) && ((now - lastEngineWarnDate) > dtwarn)) {
        logmon.log(BasicLevel.WARN,
                   AgentServer.getName() + ", engine is idle.");
        lastEngineWarnDate = now;
      }
      return false;
    }


    if (((now - lastEngineChangeDate) > dterr) && ((now - lastEngineWarnDate) > dtwarn)) {
      // Log an error and throw an alert
      logmon.log(BasicLevel.ERROR,
                 AgentServer.getName() + ", the engine doesn't progress since " + new Date(lastEngineChangeDate));
      lastEngineWarnDate = now;
      return true;
    } else if (((now - lastEngineChangeDate) > dtwarn) && ((now - lastEngineWarnDate) > dtwarn)) {
      // Log a warning
      logmon.log(BasicLevel.WARN,
                 AgentServer.getName() + ", the engine doesn't progress since " + new Date(lastEngineChangeDate));
      lastEngineWarnDate = now;
      return false;
    }
    
    return false;
  }
