private boolean checkTransaction(long now) {
    logmon.log(BasicLevel.DEBUG,
               AgentServer.getName() + ".checkTransaction()" + transaction.getCommitCount() + ", " + commitCount + "," + transaction.getPhase());

    if (transaction.getCommitCount() > commitCount) {
      commitCount = transaction.getCommitCount();
      lastTransactionChangeDate = now;
      return false;
    }

    if (transaction.getPhase() == Transaction.FREE) {
      lastTransactionChangeDate = now;
      return false;
    }
    
    if (((now - lastTransactionChangeDate) > dterr) && ((now - lastTransactionWarnDate) > dtwarn)) {
      // Log an error and throw an alert
      logmon.log(BasicLevel.ERROR,
                 AgentServer.getName() + ", Transaction doesn't progress since " + new Date(lastTransactionChangeDate));
      lastTransactionWarnDate = now;
    } else if (((now - lastTransactionChangeDate) > dtwarn) && ((now - lastTransactionWarnDate) > dtwarn)) {
      // Log a warning
      logmon.log(BasicLevel.WARN,
                 AgentServer.getName() + ", Transaction doesn't progress since " + new Date(lastTransactionChangeDate));
      lastTransactionWarnDate = now;
    }

    return true;
  }
