protected void agentInitialize(boolean firstTime) throws Exception {
    // Get the logging monitor from current server MonologLoggerFactory
    this.logmon = Debug.getLogger(getLogTopic());
    // Initializes the updated field to true:
    this.updated = true;

    try {
      MXWrapper.registerMBean(this, "AgentServer", getMBeanName());
    } catch (Exception exc) {
      if (logmon.isLoggable(BasicLevel.DEBUG)) {
        logmon.log(BasicLevel.WARN,
                   "Agent" + id + " [" + name + "]: JMX registration failed", exc);
      } else {
        logmon.log(BasicLevel.WARN,
                   "Agent" + id + " [" + name + "]: JMX registration failed");
      }
    }

    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG,
                 "Agent" + id + " [" + name + "], initialized: " + firstTime);
  }
