protected final void readFully(int length) throws IOException {
    if (getLogger().isLoggable(BasicLevel.DEBUG))
      getLogger().log(BasicLevel.DEBUG, "readFully(" + length + ')');
    
    int valid = count - pos;
    if (valid < length) {
      // There is not enough byte in the buffer
      if (length > buf.length) {
        // Allocate a new buffer then copy valid data.
        byte[] newbuf = new byte[length];
        System.arraycopy(buf, pos, newbuf, 0, valid);
        buf = newbuf; pos = 0; count = valid;
      } else if ((pos + length) > buf.length) {
        // Clear already read data in order to allow the read of next.
        System.arraycopy(buf, pos, buf, 0, valid);
        pos = 0;
        count = valid;
      }

      do {
        if (getLogger().isLoggable(BasicLevel.DEBUG))
          getLogger().log(BasicLevel.DEBUG, "read(" + count + ')');
        
        int nb = in.read(buf, count, buf.length - count);
        if (nb < 0) throw new EOFException();
        count += nb;
      } while (count < length);
    }
    
    if (getLogger().isLoggable(BasicLevel.DEBUG))
      getLogger().log(BasicLevel.DEBUG, "readFully returns - count=" + count);
  }
