void directSendTo(AgentId from,
                    AgentId to,
                    Notification not) {
    MessageConsumer consumer = null;
    Message msg = null;

    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG,
                 toString() + ".directSendTo(" + from + ", " + to + ", " + not + ")");

    if ((to == null) || to.isNullId())
      return;

    msg = Message.alloc(from, to, not);
    try {
      consumer = AgentServer.getConsumer(to.to);
    } catch (UnknownServerException exc) {
      channel.logmon.log(BasicLevel.ERROR,
                         toString() + ", can't post message: " + msg,
                         exc);
      // TODO: Post an ErrorNotification ?
      return;
    }

    try {
      if (AgentServer.engine.isNoTxIfTransient() && 
          msg.not != null && msg.not.persistent == false) {
        consumer.postAndValidate(msg);
      } else {
        AgentServer.getTransaction().begin();      
        consumer.post(msg);
      
//      if (AgentServer.sdf != null) {
//        // SDF generation
//        StringBuffer strbuf = new StringBuffer();
//        strbuf.append("<sendto agent=\"").append(msg.to);
//        strbuf.append("\" notification=\"").append(StringId.toStringId('N', '_', msg.getSource(), msg.getDest(), msg.getStamp()));
//        strbuf.append("\" info=\"").append(msg.not.getClass().getSimpleName());
//        strbuf.append("\" flowid=\"0\">\n");
//        strbuf.append("<comment>").append(msg.not).append("</comment>\n" + "</sendto>\n");
//
//        AgentServer.sdf.println(strbuf.toString());
//      }
//      
//      if (AgentServer.logsdf.isLoggable(BasicLevel.INFO))
//        AgentServer.logsdf.log(BasicLevel.INFO,
//                             "  sendto " + msg.to + ' ' + StringId.toStringId('N', '_', msg.getSource(), msg.getDest(), msg.getStamp()));
      
        if (logmon.isLoggable(BasicLevel.DEBUG))
          logmon.log(BasicLevel.DEBUG, toString() + ".directSendTo() -> " + msg.getStamp());

        consumer.save();
        AgentServer.getTransaction().commit(false);
        // then commit and validate the message.
        consumer.validate();
        AgentServer.getTransaction().release();
      }
    } catch (Exception exc) {
      // Should never happened (IOException or ClassNotFoundException).
      logmon.log(BasicLevel.FATAL,
                 toString() + ", Transaction problem.", exc);
      throw new TransactionError(toString() + ", " + exc.getMessage());
    }
  }
