public void start() throws Exception {
    logmon.log(BasicLevel.DEBUG, getName() + ", starting");
    try {
      if (isRunning()) return;

      if (port != 0) {
        dmon = new Daemon[NbDaemon];
        ServerSocket listen = createServerSocket();

        for (int i=0; i<NbDaemon; i++) {
          dmon[i] = new NetServerIn(getName() + '.' + i, listen, logmon);
        }
      } else {
        // AF: May be, we have to verify that there is only one 'listen' network.
        for (int i=0; i<servers.length; i++) {
          server = AgentServer.getServerDesc(servers[i]);
          if ((server.getServerId() != AgentServer.getServerId()) && (server.getPort() > 0)) {
            logmon.log(BasicLevel.DEBUG, getName() + ", server=" + server);
            break;
          }
          server = null;
        }
        dmon = new Daemon[1];
        dmon[0] = new NetServerOut(getName(), logmon);
      }

      for (int i=0; i<dmon.length; i++) {
        dmon[i].start();
      }
    } catch (IOException exc) {
      logmon.log(BasicLevel.ERROR, getName() + ", can't start", exc);
      throw exc;
    }
    logmon.log(BasicLevel.DEBUG, getName() + ", started");
  }
