protected final void readMessageHeader(Message msg) throws IOException {
    if (getLogger().isLoggable(BasicLevel.DEBUG))
      getLogger().log(BasicLevel.DEBUG, "readMessageHeader()");
    
    readFully(Message.LENGTH);
    
    if (getLogger().isLoggable(BasicLevel.DEBUG))
      getLogger().log(BasicLevel.DEBUG, "readMessageHeader-1 : " + BinaryDump.toHex(buf, pos, Message.LENGTH));
    
    // Reads sender's AgentId
    msg.from = new AgentId(readShort(), readShort(), readInt());
    // Reads adressee's AgentId
    msg.to = new AgentId(readShort(), readShort(), readInt());
    // Reads source server id of message
    msg.source = readShort();
    // Reads destination server id of message
    msg.dest = readShort();
    // Reads stamp of message
    msg.stamp = readInt();
    
    if (getLogger().isLoggable(BasicLevel.DEBUG))
      getLogger().log(BasicLevel.DEBUG, "readMessageHeader returns");
  }
