private void removeExpired(Message msg) {

    try {
      AgentServer.getTransaction().begin();

      ExpiredNot expiredNot = null;
      if (msg.not.deadNotificationAgentId != null) {
        if (logmon.isLoggable(BasicLevel.DEBUG)) {
          logmon.log(BasicLevel.DEBUG, "forward expired notification " + msg.from + ", " + msg.not + " to "
              + msg.not.deadNotificationAgentId);
        }
        expiredNot = new ExpiredNot(msg.not, msg.from, msg.to);
      } else {
        if (logmon.isLoggable(BasicLevel.DEBUG)) {
          logmon.log(BasicLevel.DEBUG, "removes expired notification " + msg.from + ", " + msg.not);
        }
      }

      if (expiredNot != null) {
        Channel.post(Message.alloc(AgentId.localId, msg.not.deadNotificationAgentId, expiredNot));
        Channel.validate();
      }

      msg.delete();
      msg.free();

      AgentServer.getTransaction().commit(true);
    } catch (Exception exc) {
      logmon.log(BasicLevel.ERROR, "exception in removeExpired msg#" + msg.getStamp(), exc);
    }
  }
