private Message selectFirst() {
    Message msg = null;
    if (persistent) {
      if (ack != null) {
        msg = ack;
        ack = null;
      } else if (msgToSendlist.size() > 0) {
        MessageSoftRef msgRef = (MessageSoftRef) msgToSendlist.first();

        if (msgRef.isExpired(System.currentTimeMillis())) {
          msgToSendlist.remove(msgRef);
          removeExpired(msgRef);
          return null;
        } else {
          msg = msgRef.loadMessage();
        }
      }
    } else {
      if (ack != null) {
        msg = ack;
        ack = null;
      } else if (msgToSendlist.size() > 0) {
        msg = (Message) msgToSendlist.first();
        if (msg.not.expiration > 0 && msg.not.expiration < System.currentTimeMillis()) {
          msgToSendlist.remove(msg);
          removeExpired(msg);
          return null;
        }
      }
    }
    return msg;
  }
