public Message loadMessage() throws TransactionError {
    Message msg = getMessage();
    if (msg == null) {
      try {
        msg = Message.load(name);
        softRef = new SoftReference<Message>(msg);
        if (logmon.isLoggable(BasicLevel.DEBUG))
          logmon.log(BasicLevel.DEBUG, "SoftReference: reload from disk " + msg);
      } catch (Exception exc) {
        logmon.log(BasicLevel.ERROR, "SoftReference: Can't load message " + name, exc);
        throw new TransactionError(exc);
      }
    }
    return msg;
  }
