private void insertMessageAt(Message item, int index) {
    if (Debug.debug && logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG,
                 logmsg + "insertMessageAt(" + item + ", " + index + ")");

    if (count == data.length) {
      Object newData[] = new Object[data.length *2];
      if ((first + count) < data.length) {
        System.arraycopy(data, first, newData, 0, count);
      } else {
        int j = data.length - first;
        System.arraycopy(data, first, newData, 0, j);
        System.arraycopy(data, 0, newData, j, count - j);
      }
      first = 0;
      data = newData;
    }
    if (index != count) {
      try {
        int srcPos = (first + index)%data.length;
        int destPos = (first + index + 1)%data.length;
        int copyLength = count - index;
        int lastDestPos = (destPos + copyLength - 1)%data.length;
        if (srcPos > lastDestPos) {
          Object lastElement = data[data.length - 1];
          int copyLength1 = data.length - srcPos -1;
          if (copyLength1 > 0) {
            System.arraycopy(data, srcPos, data, destPos, copyLength1);
          }
          int copyLength2 = copyLength - (copyLength1 + 1);
          if (copyLength2 > 0) {
            System.arraycopy(data, 0, data, 1, copyLength2);
          }
          data[0] = lastElement;
        } else {
          System.arraycopy(data, srcPos, data, destPos, copyLength);
        }
        
      } catch (ArrayIndexOutOfBoundsException exc) {
        throw new RuntimeException("insertMessageAt '" + index + "': " + this, exc);
      }
    }
    if (persistent)
      data[(first + index)%data.length] = new MessageSoftRef(item);
    else
      data[(first + index)%data.length] = item;
    count += 1;

    if (Debug.debug && logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG,
                 logmsg + "insertMessageAt() -> " + this);
  }
