public void encode(Encoder encoder) throws Exception {
    // Writes sender's AgentId
    encoder.encode16(from.from);
    encoder.encode16(from.to);
    encoder.encode32(from.stamp);
    // Writes adressee's AgentId
    encoder.encode16(to.from);
    encoder.encode16(to.to);
    encoder.encode32(to.stamp);
    // Writes source server id of message
    encoder.encode16(source);
    // Writes destination server id of message
    encoder.encode16(dest);
    // Writes stamp of message
    encoder.encode32(stamp);

    if (not == null) {
      Debug.getLogger(getClass().getName()).log(BasicLevel.ERROR,
          "Message.writeObject() -> null notification.");
      encoder.encodeByte(NULL);
    } else {
      // Writes notification attributes
      encoder.encodeByte(optToByte());
      if (! not.detachable) {
        // Writes notification object
        if (not.getEncodableClassId() == -1) {
          encoder.encodeBoolean(false);
          if (serializedNot == null) {
            serializedNot = new SerializableWrapper(not);
          }
          serializedNot.encode(encoder);
        } else {
          encoder.encodeBoolean(true);
          encoder.encodeUnsignedInt(not.getEncodableClassId());
          not.encode(encoder);
        }
      } else {
        Debug.getLogger(getClass().getName()).log(BasicLevel.DEBUG,
            "Message.writeObject() -> detachable notification: " + not);
      }
    }
  }
