private void readObject(java.io.ObjectInputStream in)
       throws IOException, ClassNotFoundException {
    // Reads sender's AgentId
    from = new AgentId(in.readShort(), in.readShort(), in.readInt());
    // Reads adressee's AgentId
    to = new AgentId(in.readShort(), in.readShort(), in.readInt());
    // Reads source server id of message
    source = in.readShort();
    // Reads destination server id of message
    dest = in.readShort();
    // Reads stamp of message
    stamp = in.readInt();

    int opt = in.read();
    if (opt == NULL) {
      Debug.getLogger(getClass().getName()).log(BasicLevel.ERROR,
                                                "Message.readObject -> null notification.");

      not = null;
    } else {
      // Reads notification attributes
      boolean persistent = ((opt & PERSISTENT) != 0);
      boolean detachable = ((opt & DETACHABLE) != 0);

      if (! detachable) {
        // Reads notification object
        not = (Notification) in.readObject();
        not.detachable = detachable;
        not.persistent = persistent;
        not.detached = false;
      } else {
        Debug.getLogger(getClass().getName()).log(BasicLevel.DEBUG,
                                                  "Message.readObject -> " + opt);

      }
    }
  }
