private void writeObject(java.io.ObjectOutputStream out) throws IOException {
    // Writes sender's AgentId
    out.writeShort(from.from);
    out.writeShort(from.to);
    out.writeInt(from.stamp);
    // Writes adressee's AgentId
    out.writeShort(to.from);
    out.writeShort(to.to);
    out.writeInt(to.stamp);
    // Writes source server id of message
    out.writeShort(source);
    // Writes destination server id of message
    out.writeShort(dest);
    // Writes stamp of message
    out.writeInt(stamp);

    if (not == null) {
      Debug.getLogger(getClass().getName()).log(BasicLevel.ERROR,
                                                "Message.writeObject() -> null notification.");

      out.write(NULL);
    } else {
      // Writes notification attributes
      out.write(optToByte());
      if (! not.detachable) {
        // Writes notification object
        out.writeObject(not);
      } else {
        Debug.getLogger(getClass().getName()).log(BasicLevel.DEBUG,
                                                  "Message.writeObject() -> detachable notification: " + not);
      }
    }
  }
