@Override
  public void decode(Decoder decoder) throws Exception {
    byte tmp = decoder.decodeByte();
    priority = tmp & 0x0F; // 4 bits
    if ((tmp & ExpirationSet) != 0)
      expiration = decoder.decodeUnsignedLong();
    if ((tmp & ContextSet) != 0) {
      int classId = decoder.decodeUnsignedInt();
      EncodableFactory factory = EncodableFactoryRepository.getFactory(classId);
      Encodable encodable = factory.createEncodable();
      encodable.decode(decoder);
      context = encodable;
    }
    if ((tmp & DeadNotificationAgentIdSet) != 0) {
      deadNotificationAgentId = new AgentId();
      deadNotificationAgentId.decode(decoder);
    }
  }
