@Override
  public void encode(Encoder encoder) throws Exception {
    encoder.encodeByte((byte) ((priority & 0x0F)
        | // 4 bits
        ((expiration > 0) ? ExpirationSet : 0x00)
        | ((context != null) ? ContextSet : 0x00)
        | ((deadNotificationAgentId != null) ? DeadNotificationAgentIdSet
            : 0x00)));
    if (expiration > 0)
      encoder.encodeUnsignedLong(expiration);
    if (context != null) {
      if (context instanceof Encodable) {
        encoder.encodeBoolean(true);
        Encodable encodable = (Encodable) context;
        encoder.encodeUnsignedInt(encodable.getEncodableClassId());
        encodable.encode(encoder);
      } else {
        throw new Exception("Context is not Encodable");
      }
    }
    if (deadNotificationAgentId != null)
      deadNotificationAgentId.encode(encoder);
  }
