@Override
  public int getEncodedSize() throws Exception {
    int encodedSize = 0;
    encodedSize += BYTE_ENCODED_SIZE;
    if (expiration > 0)
      encodedSize += LONG_ENCODED_SIZE;
    if (context != null) {
      if (context instanceof Encodable) {
        Encodable encodable = (Encodable) context;
        encodedSize += INT_ENCODED_SIZE;
        encodedSize += encodable.getEncodedSize();
      } else {
        throw new Exception("Context is not Encodable");
      }
    }
    if (deadNotificationAgentId != null)
      encodedSize += deadNotificationAgentId.getEncodedSize();
    return encodedSize;
  }
