public void addService(int sid,
                         String className, 
                         String args) 
    throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, 
                 "ServerConfigHelper.addService(" + sid + ',' + className + ',' + args + ')');
    A3CMLConfig a3cmlConfig = AgentServer.getConfig();
    A3CMLServer a3cmlServer = a3cmlConfig.getServer((short)sid);
    A3CMLService a3cmlService = new A3CMLService(className, args);
    a3cmlServer.addService(a3cmlService);
    
    if (sid == AgentServer.getServerId()) {
      try {
        ServiceManager.register(className, args);
        ServiceDesc desc = (ServiceDesc) ServiceManager.manager.registry.get(className);
        if (! desc.running) {
          ServiceManager.start(desc);
        }
      } catch (Exception exc) {
        a3cmlServer.removeService(className);
      }
    }

    if (autoCommit) commit();
  }
