public void removeServer(int sid) 
    throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, 
                 "ServerConfigHelper.removeServer(" + 
                 sid + ')');
    if (sid != AgentServer.getServerId()) {
      A3CMLConfig a3cmlConfig = AgentServer.getConfig();
      A3CMLServer a3cmlServer = a3cmlConfig.getServer((short)sid);
      
      if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, 
                 " -> server.networks = " + a3cmlServer.networks);

      // Check that the server doesn't belong to more than one
      // domain.
      if (a3cmlServer.networks.size() > 1)
        throw new Exception(
          "Can't remove server: it belongs to more than one domain.");

      a3cmlConfig.removeServer((short)sid);
      
      A3CMLServer root = a3cmlConfig.getServer(AgentServer.getServerId());
      a3cmlConfig.configure(root);
      
      ServerDesc servDesc = 
        AgentServer.removeServerDesc((short)sid);
      
      if (servDesc.getDomain() instanceof Network) {
        Network net = (Network) servDesc.getDomain();
        net.stop();
        net.delServer(servDesc.sid);
        net.start();
      }
      
      for (Enumeration<ServerDesc> e = AgentServer.elementsServerDesc(); e.hasMoreElements(); ) {
        ServerDesc sd = e.nextElement();
        if (sd.gateway == sid) {
          sd.gateway = -1;
          sd.setDomain(null);
        }
      }

      if (autoCommit) commit();
    }
    //else do nothing (don't remove the local server)
  }
