public synchronized ServerDesc put(ServerDesc desc) {
    // Make sure the value is not null
    if (desc == null) throw new NullPointerException();

    // Makes sure the key is not already in the hashtable.
    ServerDescEntry tab[] = table;
    int index = (desc.sid & 0x7FFF) % tab.length;
    for (ServerDescEntry e = tab[index] ; e != null ; e = e.next) {
      if (e.desc.sid == desc.sid) {
        ServerDesc old = e.desc;
        e.desc = desc;
        return old;
      }
    }

    if (count >= threshold) {
      // Rehash the table if the threshold is exceeded
      rehash();

      tab = table;
      index = (desc.sid & 0x7FFF) % tab.length;
    } 

    // Creates the new entry.
    ServerDescEntry e = new ServerDescEntry(desc, tab[index]);
    tab[index] = e;
    count++;
    return null;
  }
