static void start(boolean exitOnFailure) throws Exception {
    // Launch all services defined in A3CML file
    for (Enumeration<ServiceDesc> e = manager.registry.elements(); e.hasMoreElements() ;) {
      ServiceDesc desc = e.nextElement();
      try {
        start(desc);
      } catch (Exception exc) {
        if (xlogmon.isLoggable(BasicLevel.DEBUG))
          xlogmon.log(BasicLevel.ERROR,
                      getName() + ", cannot start service:" + desc.getClassName(), exc);
        else
          xlogmon.log(BasicLevel.ERROR,
                      getName() + ", cannot start service:" + desc.getClassName());
        if (exitOnFailure)
          throw new Exception("Cannot start service " + desc.getClassName());
      }
    }
  }
