public A3CMLServer duplicate() throws Exception {
    A3CMLServer clone = new A3CMLServer(sid, 
                                        name, 
                                        hostname);
    if (networks != null) {
      for (Enumeration<A3CMLNetwork> n = networks.elements(); n.hasMoreElements(); )
        clone.networks.addElement(n.nextElement().duplicate());
    }
    clone.gateway = gateway;
    clone.domain = domain;
    clone.port = port;

    // super class
    clone.visited = visited;
    if (services != null) {
      for (Enumeration<A3CMLService> e = services.elements(); e.hasMoreElements(); )
        clone.services.addElement(e.nextElement().duplicate());
    }
    if (properties != null) {
      for (Enumeration<String> e = properties.keys(); e.hasMoreElements(); ) {
        
        String pName = e.nextElement();
        A3CMLProperty prop = properties.get(pName);
        if (prop != null) {
          if (clone.properties == null) clone.properties = new Hashtable<String, A3CMLProperty>();
          clone.properties.put(pName, prop.duplicate());
        }
      }
    }
    if (nat != null) {
      for (Enumeration<A3CMLNat> e = nat.elements(); e.hasMoreElements(); )
        clone.addNat(e.nextElement().duplicate());
    }
    clone.jvmArgs = jvmArgs;

    return clone;
  }
