public static A3CMLConfig getConfig(Reader reader) throws Exception {
    if (Log.logger.isLoggable(BasicLevel.DEBUG))
      Log.logger.log(BasicLevel.DEBUG, "Config.getConfig(" + reader + ")");
    
    String cfgName = System.getProperty(AgentServer.CFG_NAME_PROPERTY, 
                                        AgentServer.DEFAULT_CFG_NAME);
    String wrpCName = System.getProperty(AgentServer.A3CMLWRP_PROPERTY, 
                                         AgentServer.DEFAULT_A3CMLWRP);
    Class<?> wrpClass = Class.forName(wrpCName);

    A3CMLWrapper wrapper = (A3CMLWrapper) wrpClass.newInstance();
    A3CMLConfig a3config = null;
    try {
      a3config = wrapper.parse(reader,cfgName);
    } catch (Exception exc) {
        Log.logger.log(BasicLevel.ERROR,
                   "Config.getConfig : " + exc.getMessage(), exc);
    }

    if ((a3config == null) || (a3config.servers == null))
      throw new Exception("Empty configuration \"" + cfgName + "\" in configuration file.");

    return a3config;
  }
