public static final void toXML(A3CMLConfig config,
                                 PrintWriter out) throws Exception {
    // out.write("<?xml version=\"1.0\"?>\n");
//     out.write("<!DOCTYPE config SYSTEM \"a3config.dtd\">\n");
    out.write("\n<" + ELT_CONFIG + ">\n\n");

    // write all property
    for (Enumeration e = config.properties.elements();
         e.hasMoreElements();) {
      A3CMLProperty p = (A3CMLProperty) e.nextElement();
      out.write(TAB +
                "<" + ELT_PROPERTY + " " +
                ATT_NAME + "=\"");
      out.write(p.name);
      out.write("\" " +
                ATT_VALUE + "=\"");
      out.write(p.value);
      out.write("\"/>\n");
    }
    out.write("\n");

    // write all know domain
    for (Enumeration e = config.domains.elements();
         e.hasMoreElements();) {
      A3CMLDomain d = (A3CMLDomain) e.nextElement();
      out.write(TAB + "<" + ELT_DOMAIN + " " + ATT_NAME + "=\"");
      out.write(d.name);
      out.write("\" " + ATT_NETWORK + "=\"");
      out.write(d.network);
      out.write("\"/>\n");
    }
    out.write("\n");

    // write all know servers.
    for (Enumeration e = config.servers.elements();
         e.hasMoreElements();) {
      Object obj = e.nextElement();

      if (obj instanceof A3CMLServer)
        writeToXMLServer(obj,out);
      out.write("\n");
    }

    out.write("</" + ELT_CONFIG + ">\n");
    out.flush();
  }
