private static final void writeToXMLServer(Object obj,
                                             PrintWriter out) {
    if (obj instanceof A3CMLServer) {
      A3CMLServer server = (A3CMLServer) obj;
      out.write(TAB + "<" + ELT_SERVER + " " + ATT_HOSTNAME + "=\"");
      out.write(server.hostname);
      out.write("\" " + ATT_ID + "=\"");
      out.write(Short.toString(server.sid));
      out.write("\" " + ATT_NAME + "=\"");
      out.write(server.name);
      out.write("\">\n");
          
      // jvm args
      if (server.jvmArgs != null && server.jvmArgs.length() > 0) {
        out.write(TAB2 + "<" + ELT_JVM_ARGS + " " + ATT_VALUE + "=\"");
        out.write(server.jvmArgs);
        out.write("\"/>\n");
      }

      // write all property
      if (server.properties != null) {
        for (Enumeration e = server.properties.elements();
             e.hasMoreElements();) {
          A3CMLProperty p = (A3CMLProperty) e.nextElement();
          out.write(TAB2 + "<" + ELT_PROPERTY + " " + ATT_NAME + "=\"");
          out.write(p.name);
          out.write("\" " + ATT_VALUE + "=\"");
          out.write(p.value);
          out.write("\"/>\n");
        }
      }

      // write all Nat
      if (server.nat != null) {
        for (Enumeration e = server.nat.elements();
             e.hasMoreElements();) {
          A3CMLNat n = (A3CMLNat) e.nextElement();
          out.write(TAB2 + "<" + ELT_NAT + " " + ATT_SID + "=\"");
          out.write(Short.toString(n.sid));
          out.write("\" " + ATT_HOSTNAME + "=\"");
          out.write(n.host);
          out.write("\" " + ATT_PORT + "=\"");
          out.write(Integer.toString(n.port));
          out.write("\"/>\n");
        }
      }

      // network
      if (server.networks != null) {
        for (Enumeration e = server.networks.elements();
             e.hasMoreElements();) {
          A3CMLNetwork n = (A3CMLNetwork) e.nextElement();
          out.write(TAB2 + "<" + ELT_NETWORK + " " + ATT_DOMAIN + "=\"");
          out.write(n.domain);
          out.write("\" " + ATT_PORT + "=\"");
          out.write(Integer.toString(n.port));
          out.write("\"/>\n");
        }
      }

      //service
      if (server.services != null) {
        for (Enumeration e = server.services.elements();
             e.hasMoreElements();) {
          A3CMLService service = (A3CMLService) e.nextElement();
          out.write(TAB2 + "<" + ELT_SERVICE + " " + ATT_CLASS + "=\"");
          out.write(service.classname);
          out.write("\" " + ATT_ARGS + "=\"");
          if ((service.args != null) && (service.args.length() > 0)) {
            out.write(service.args);
          }
          out.write("\"/>\n");
        }
      }
      out.write(TAB + "</" + ELT_SERVER + ">\n");
    }
  }
