@Override
  public void loadAll(String prefix, Map map) {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "Transaction, loadAll(" + prefix + ")");
    
    String[] names = getList(prefix);
    for (String name : names) {
      try {
        map.put(name, load(name));
      } catch (ClassNotFoundException | IOException exc) {
        if (logmon.isLoggable(BasicLevel.DEBUG))
          logmon.log(BasicLevel.WARN, "Transaction, loadAll: cannot retrieve content for " + name, exc);
        else
          logmon.log(BasicLevel.WARN, "Transaction, loadAll: cannot retrieve content for " + name + " - " + exc.getMessage());
      }
    }

    return;
  }
