public final void save(Serializable obj,
                         String dirName, String name,
                         boolean first) throws IOException {
    Context ctx = perThreadContext.get();
    byte[] encodedObject;
    if (onlyUseJavaSerialization) {
      encodedObject = serialize(obj, ctx);
    } else {
      Encodable encodable = isEncodable(obj);
      if (encodable == null) {
        encodedObject = serialize(obj, ctx);
      } else {
        try {
          encodedObject = new byte[Encodable.BYTE_ENCODED_SIZE
              + Encodable.INT_ENCODED_SIZE + encodable.getEncodedSize()];
          ByteBuffer buf = ByteBuffer.wrap(encodedObject);
          ByteBufferEncoder encoder = new ByteBufferEncoder(buf);
          encoder.encodeByte(ENCODING_TAG);
          encoder.encode32(encodable.getEncodableClassId());
          encodable.encode(encoder);
        } catch (Exception exc) {
          throw new IOException(exc);
        }
      }
    }
    
    saveInLog(encodedObject, dirName, name, ctx.log, false, first);
  }
