@Override
  public void loadAll(String prefix, Map map) {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "DBTransaction, loadAll(" + prefix + ")");
    
    try {
      // Creating a statement lets us issue commands against the connection.
      Statement s = conn.createStatement();
      ResultSet rs = s.executeQuery("SELECT name, content FROM " + dbtable + " WHERE name LIKE '" + prefix + "%'");

      while (rs.next()) {
        String name = rs.getString(1);
        
        // Try to retrieve content from memory log.
        byte[] content = null;
        try {
          content = getFromLog(name);
        } catch (IOException exc) {
          if (logmon.isLoggable(BasicLevel.DEBUG))
            logmon.log(BasicLevel.WARN, "DBTransaction, loadAll: cannot retrieve content for " + name, exc);
          else
            logmon.log(BasicLevel.WARN, "DBTransaction, loadAll: cannot retrieve content for " + name + " - " + exc.getMessage());
        }
        
        // If content is not present in memory log get it from DB.
        if (content == null)
          content = rs.getBytes(2);
        
        if (content == null) {
          logmon.log(BasicLevel.WARN, "DBTransaction, loadAll: no content for " + name);
          continue;
        }
        
        // Deserializes the object and adds it to the list.
        try {
          map.put(name, loadFromByteArray(content));
        } catch (ClassNotFoundException | IOException exc) {
          if (logmon.isLoggable(BasicLevel.DEBUG))
            logmon.log(BasicLevel.WARN, "DBTransaction, loadAll: cannot retrieve content for " + name, exc);
          else
            logmon.log(BasicLevel.WARN, "DBTransaction, loadAll: cannot retrieve content for " + name + " - " + exc.getMessage());
        }
      }
      rs.close();
      s.close();

      if (logmon.isLoggable(BasicLevel.DEBUG))
        logmon.log(BasicLevel.DEBUG, "DBTransaction, loadAll: " + map.size());

      return;
    } catch (SQLException sqle) {
      logmon.log(BasicLevel.DEBUG, "DBTransaction.getList()", sqle);
    }
    
    return;
  }
