public final void initRepository() throws IOException {
    LogMemoryCapacity = getInteger("NTLogMemoryCapacity", LogMemoryCapacity).intValue();
    MaxLogFileSize = getInteger("NTLogFileSize", MaxLogFileSize / Mb).intValue() * Mb;
    MaxLogMemorySize = getInteger("NTLogMemorySize", MaxLogMemorySize / Kb).intValue() * Kb;

    LogThresholdOperation = getInteger("NTLogThresholdOperation", LogThresholdOperation).intValue();
    Operation.initPool(LogThresholdOperation);

    syncOnWrite = getBoolean("Transaction.SyncOnWrite");
    
    try {
      repositoryImpl = System.getProperty("NTRepositoryImpl", repositoryImpl);
      repository = (Repository) Class.forName(repositoryImpl).newInstance();
      repository.init(this, dir);
    } catch (ClassNotFoundException exc) {
      logmon.log(BasicLevel.FATAL,
                 "NTransaction, cannot initializes the repository ", exc);
      throw new IOException(exc.getMessage());
    } catch (InstantiationException exc) {
      logmon.log(BasicLevel.FATAL,
                 "NTransaction, cannot initializes the repository ", exc);
      throw new IOException(exc.getMessage());
    } catch (IllegalAccessException exc) {
      logmon.log(BasicLevel.FATAL,
                 "NTransaction, cannot initializes the repository ", exc);
      throw new IOException(exc.getMessage());
    }
    
    if (getBoolean("NTNoLockFile"))
      logmon.log(BasicLevel.ERROR,
                 "NTransaction, no longer use NTNoLockFile property, use Transaction.UseLockFile.");
    useLockFile = getBoolean("Transaction.UseLockFile");
    
    logFile = new LogFile(dir, repository, useLockFile, syncOnWrite);
    
    // Be careful, setGarbageDelay and garbageAsync use logFile !!
    setGarbageDelay(getInteger("NTGarbageDelay", getGarbageDelay()).intValue());
    garbageAsync(getBoolean("NTAsyncGarbage"));
  }
