protected void doStart() throws Exception {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "CommonService.doStart()");
  	 try {
       AgentServer.init(sid, path, null);
     } catch (Exception exc) {
       logmon.log(BasicLevel.ERROR, AgentServer.getName() + " initialization failed", exc);
       throw exc;
     }

     try {
       String errStr = AgentServer.start();
       if (errStr == null) {
      	 if (logmon.isLoggable(BasicLevel.INFO))
           logmon.log(BasicLevel.INFO, AgentServer.getName() + " started: " + AgentServer.OKSTRING);
       } else {
      	 if (logmon.isLoggable(BasicLevel.INFO)) {
           logmon.log(BasicLevel.INFO, AgentServer.getName() + " started: " + AgentServer.ERRORSTRING +
          		 "\n" + errStr + "\n" + AgentServer.ENDSTRING);
      	 }
       }
     } catch (Exception exc) {
       logmon.log(BasicLevel.ERROR, AgentServer.getName() + " failed", exc);
       throw exc;
     }
     
     // Register ServerDesc
     ServerDesc serverDesc = AgentServer.getServerDesc(sid);
     Properties props = new Properties();
     props.setProperty("sid", ""+sid);
     props.setProperty("name", serverDesc.getServerName());
     props.setProperty("host", serverDesc.getHostname());
     props.setProperty("port", ""+serverDesc.getPort());
     bundleContext.registerService(
    		 ServerDesc.class.getName(),
    		 serverDesc,
    		 (Dictionary)props);
     if (logmon.isLoggable(BasicLevel.DEBUG))
       logmon.log(BasicLevel.DEBUG, "CommonService ServerDesc register: " + serverDesc); 
  }
