public void updated(Dictionary properties) throws ConfigurationException {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "updated(" + properties + ')');
  	
  	if (properties == null) {
  		doStop();
  		return;
  	}
  	
  	String sidStr = (String) properties.get(SID);
  	if (sidStr != null && sidStr.length() > 0) {
  		sid = new Short(sidStr).shortValue();
  	}
  	
		DefaultSubstitutionEngine engine = new DefaultSubstitutionEngine();
		ChainedResolver resolver = new ChainedResolver();
		resolver.getResolvers().add(new PropertiesResolver(System.getProperties()));
		engine.setResolver(new RecursiveResolver(engine, resolver));
		
		String storage = (String) properties.get(STORAGE);
		if (storage != null && storage.length() > 0) {
			path = engine.substitute(storage);
		}
		
		String pathToConf = (String) properties.get(PATH_TO_CONF);
		if (pathToConf != null && pathToConf.length() > 0) {
			System.setProperty(AgentServer.CFG_DIR_PROPERTY, engine.substitute(pathToConf));
		}
		
		// set System properties if needed
		Enumeration en = properties.keys();
		while (en.hasMoreElements()) {
	    Object key = en.nextElement();
	    if (SID.equals(key) || STORAGE.equals(key) || PATH_TO_CONF.equals(key)) {
	    	// reserved word.
	    	continue;
	    } else {
	    	Object value = properties.get(key);
	    	if (value != null && key instanceof String && value instanceof String)
	    		System.setProperty((String) key, (String) value);
	    }
    }
		
		// start the a3 server
		try {
	    doStart();
    } catch (Exception e) {
    	if (logmon.isLoggable(BasicLevel.ERROR))
        logmon.log(BasicLevel.ERROR, "updated:: doStart EXCEPTION", e);
	    throw new ConfigurationException(null, e.getMessage());
    }
  }
