private ResolveResult findContextFor(String name) throws NamingException {
    String rname = getRelativeName(name);
    Context context = null;

    if (rname.equals("")) {
      // null name refers to this context
      context = new scnURLContext(myEnv);
    } else {
      // other names are component independant
      context = namingFactory.getInitialContext(myEnv);
    }
    
    // Check context is not null to avoid nullPointerException
    if (context == null) {
      throw new NameNotFoundException("No context for this component");
    }
    
    // Build a ResolveResult object to return
    ResolveResult r = new ResolveResult(context, rname);
    return r;
  }
