public void agentInitialize(boolean firstTime) throws Exception {
    if (firstTime) {
      looseCoupling = AgentServer.getBoolean(fr.dyade.aaa.jndi2.impl.ServerImpl.LOOSE_COUPLING);
      if (serverIds.length > 0 && (!looseCoupling)) {
        rootOwnerId = DistributedJndiServer.getDefault(serverIds[0]);
      } else {
        rootOwnerId = getId();
      }
    }

    super.agentInitialize(firstTime);

    writeRequestContextLists = (Hashtable) AgentServer.getTransaction().load(WRITE_REQUEST_TABLE);
    if (writeRequestContextLists == null) {
      writeRequestContextLists = new Hashtable();
    }

    initRequestContextLists = (Hashtable) AgentServer.getTransaction().load(INIT_REQUEST_TABLE);
    if (initRequestContextLists == null) {
      initRequestContextLists = new Hashtable();
    }

    syncRequestContextLists = (Hashtable) AgentServer.getTransaction().load(SYNC_REQUEST_TABLE);
    if (syncRequestContextLists == null) {
      syncRequestContextLists = new Hashtable();
    }

    servers = (Vector)AgentServer.getTransaction().load(SERVER_LIST);
    if (servers == null) {
      servers = new Vector();      
      for (int i = 0; i < serverIds.length; i++) {        
        AgentId aid = DistributedJndiServer.getDefault(serverIds[i]);
        servers.addElement(aid);
        sendTo(aid, new InitJndiServerNot(null, null, true));
      }
      saveServers();
    }

    getServerImpl().setUpdateListener(this);
  }
