protected JndiReply invokeOwner(AgentId owner,
                                  RequestContext reqCtx) {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, "ReplicationManager.invokeOwner(" + owner + ',' + reqCtx + ')');
    JndiRequest request = reqCtx.getRequest();
    if (request instanceof CreateSubcontextRequest) {
      CreateSubcontextRequest csr = (CreateSubcontextRequest) request;
      request = new CreateRemoteSubcontextRequest(csr.getName(), getId());
    }

    sendTo(owner,
           new JndiScriptRequestNot(new JndiRequest[] { request }, true));
    RequestContextList list = (RequestContextList) writeRequestContextLists.get(owner);
    if (list == null) {
      list = new RequestContextList();
      writeRequestContextLists.put(owner, list);
    }
    list.put(reqCtx);
    saveWriteRequestTable();
    return null;
  }
