private void onUpdateEvent(AgentId from, ChangeOwnerEvent evt) 
  throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ReplicationManager.onUpdateEvent(" +
                       from + ',' + evt + ')');

    NamingContextInfo[] contexts = evt.getNamingContexts();
    for (int i = 0; i < contexts.length; i++) {
      NamingContext nc = getServerImpl().getNamingContext(
                                                          contexts[i].getNamingContext().getId());

      if (nc == null) {
        // The InitJndiServerNot sent by 
        // the server that created this context may not
        // have been received.
        getServerImpl().addNamingContext(contexts[i]);
      } else {
        nc.setOwnerId(contexts[i].getNamingContext().getOwnerId());
        getServerImpl().resetNamingContext(
                                           contexts[i].getNamingContext());
      }
    }
  }
