public void bind(CompositeName path, 
                   Object obj) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, "ServerImpl.bind(" + 
                       path + ',' + 
                       obj + ',' + ')');
    // The root context is (in a way) already bound since
    // it is already a context.
    if (path.size() == 0) throw new NameAlreadyBoundException();

    path = (CompositeName) path.clone();
    String lastName = (String) path.remove(path.size() - 1);
    NamingContext nc = contextManager.getNamingContext(path);

    bind(nc, lastName, obj, serverId);
    
    if (updateListener != null) {
      updateListener.onUpdate(
        new BindEvent(path,nc.getId(), lastName, obj));
    }
  }
