public void bind(NamingContext nc, 
                   String lastName, 
                   Object obj,
                   Object ownerId) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ServerImpl.bind(" + nc + ',' + lastName + ',' + obj + ',' + ownerId + ')');
    
    if (! nc.getOwnerId().equals(ownerId) && (!looseCoupling) ) {
      throw new NotOwnerException(
        nc.getOwnerId());
    }

    Record r = nc.getRecord(lastName);
    if (r != null) throw new NameAlreadyBoundException();
    
    nc.addRecord(new ObjectRecord(lastName, obj));
    contextManager.storeNamingContext(nc);
  }
