public void createSubcontext(CompositeName path,
                               Object subcontextOwnerId) 
    throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(
        BasicLevel.DEBUG, 
        "ServerImpl.createSubcontext(" + 
        path + ',' + subcontextOwnerId + ')');

    // The root already exists.
    if (path.size() == 0) throw new NameAlreadyBoundException();

    CompositeName parentPath = (CompositeName)path.clone();    
    String lastName = 
      (String)parentPath.remove(parentPath.size() - 1);
    NamingContext parentNc = 
      contextManager.getNamingContext(parentPath);

    NamingContextId ncid = createSubcontext(
      parentNc, lastName, path, null,
      subcontextOwnerId, serverId);

    if (updateListener != null) {
      updateListener.onUpdate(
        new CreateSubcontextEvent(
          parentNc.getId(), lastName, path, ncid, 
          subcontextOwnerId));
    }
  }
