public NamingContextId createSubcontext(
    NamingContext parentNc, 
    String lastName,
    CompositeName path,
    NamingContextId ncid,
    Object subcontextOwnerId,
    Object ownerId) 
    throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ServerImpl.createSubcontext(" + 
                       parentNc + ',' +
                       lastName + ',' + 
                       path + ',' + 
                       ncid + ',' + 
                       subcontextOwnerId + ',' +
                       ownerId + ')');
    if (! parentNc.getOwnerId().equals(ownerId) && (!looseCoupling) ) {
      throw new NotOwnerException(
        parentNc.getOwnerId());
    }

    if (parentNc.getRecord(lastName) != null) 
      throw new NameAlreadyBoundException();
    NamingContext nc;
    if(!   looseCoupling)
	 nc = 
	    contextManager.newNamingContext(
					    subcontextOwnerId, ncid, path);
    else
	 nc = 
	    contextManager.newNamingContext(
					    subcontextOwnerId, null, path);
    parentNc.addRecord(new ContextRecord(
      lastName, nc.getId()));
    contextManager.storeNamingContext(parentNc);
    return nc.getId();
  }
