public boolean destroySubcontext(NamingContext parentNc,                                    
                                   String lastName,
                                   CompositeName path,
                                   Object ownerId) 
    throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ServerImpl.destroySubcontext(" + 
                       parentNc + ',' +
                       lastName + ',' + 
                       path + ',' +
                       ownerId + ')');
    if (! parentNc.getOwnerId().equals(ownerId) && (!looseCoupling)) {
      throw new NotOwnerException(
        parentNc.getOwnerId());
    }

    Record r = parentNc.getRecord(lastName);
    if (r != null) {
      if (r instanceof ContextRecord) {        
        ContextRecord cr = (ContextRecord)r;
        NamingContextId ctxId = cr.getId();
        contextManager.delete(ctxId, path);
        
        // Remove from the parent context
        parentNc.removeRecord(lastName);
        contextManager.storeNamingContext(parentNc);        
        return true;
      }
      
      throw new NotContextException();
    }
    
    // else do nothing (idempotency)
    return false;
  }
