public void rebind(CompositeName path, 
                     Object obj) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, "ServerImpl.rebind(" + 
                       path + ',' + 
                       obj + ',' + ')');

    // The root context cannot become a name-value pair.
    if (path.size() == 0) throw new NamingException("Cannot rebind the root context");

    path = (CompositeName)path.clone();
    String lastName = (String)path.remove(path.size() - 1);
    NamingContext nc = contextManager.getNamingContext(path);    

    rebind(nc, lastName, obj, serverId);

    if (updateListener != null) {
      updateListener.onUpdate(
        new RebindEvent(path,nc.getId(), lastName, obj));
    }
  }
