public void rebind(NamingContext nc, 
                     String lastName, 
                     Object obj,
                     Object ownerId) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ServerImpl.rebind(" + 
                       nc + ',' +
                       lastName + ',' + 
                       obj + ',' + 
                       ownerId + ')');
    if (! nc.getOwnerId().equals(ownerId) && (!looseCoupling) ) {
      throw new NotOwnerException(
        nc.getOwnerId());
    }

    Record r = nc.getRecord(lastName);
    if (r != null) {
      if (r instanceof ContextRecord) {
        // DF: seems not consistent to delete recursively the whole context
        // (empty or not) as the reverse operation is not possible (create a
        // context with a name already bound), so prefer to raise an error.
        // DF (TODO): Have to check the specification.
        throw new NamingException("Cannot rebind a context");
      }
      
      ObjectRecord or = (ObjectRecord)r;
      or.setObject(obj);
    } else {
      nc.addRecord(new ObjectRecord(lastName, obj));
    }
    contextManager.storeNamingContext(nc);    
  }
