public void unbind(CompositeName path) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, "ServerImpl.unbind(" + 
                       path + ')');

    // The root context cannot be deleted.
    if (path.size() == 0) throw new NamingException("Cannot unbind the root context");

    path = (CompositeName)path.clone();    
    String lastName = (String)path.remove(path.size() - 1);
    NamingContext nc = contextManager.getNamingContext(path);    

    if (unbind(nc, lastName, serverId)) {
      if (updateListener != null) {
        updateListener.onUpdate(
          new UnbindEvent(path,nc.getId(), lastName));
      }
    }
  }
