public boolean unbind(NamingContext nc,
                        String lastName,
                        Object ownerId) throws NamingException {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "ServerImpl.unbind(" + 
                       nc + ',' +
                       lastName + ',' + 
                       ownerId + ')');
    if (! nc.getOwnerId().equals(ownerId) && (!looseCoupling) ) {
      throw new NotOwnerException(
        nc.getOwnerId());
    }
    Record r = nc.getRecord(lastName);
    if (r != null) { 
      if (r instanceof ContextRecord)
        throw new NamingException("Cannot unbind a context");

      nc.removeRecord(lastName);
      contextManager.storeNamingContext(nc);        
      return true;
    }
    
    // else do nothing (idempotency)
    return false;
  }
