private void doReact(AgentId from, JndiScriptRequestNot not) throws Exception {
    if (Trace.logger.isLoggable(BasicLevel.DEBUG))
      Trace.logger.log(BasicLevel.DEBUG, 
                       "AgentEntryPoint[" + manager.getId() + "].doReact(" + from + ",(JndiScriptRequestNot)" + not + ')');
    
    JndiRequest[] requests = not.getRequests();
    JndiReply[] replies = new JndiReply[requests.length];
    for (int i = 0; i < requests.length; i++) {
      AgentRequestContext reqCtx = new AgentRequestContext(requests[i], from, not.reply());
      replies[i] = manager.invoke(reqCtx);
    }
    if (not.reply()) {
      // Reply to all the operations from the input
      // script except those that are asynchronous.
      // This can't happen in a centralized server.
      // But in a distributed JNDI configuration, this
      // server may be waiting for a notification reply 
      // from an other naming server. 
      // These asynchronous operations
      // are acknowledged in separate notifications.
      manager.sendTo(from, new JndiScriptReplyNot(replies));
    }
  }
