public void setActivationSpecConfig(Properties props) {
  	if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "ActivationSpecImpl.setActivationSpecConfig(" + props + ')');
  	
  	if (props == null)
  		return;
  	name = props.getProperty("name");
  	hostName = props.getProperty("HostName", "localhost");
  	serverPort = new Integer(props.getProperty("ServerPort", "16010")).intValue();

  	userName = props.getProperty("UserName", "anonymous");
  	password = props.getProperty("Password", "anonymous");
  	identityClass = props.getProperty("IdentityClass", "org.objectweb.joram.shared.security.SimpleIdentity");
  	collocated = new Boolean(props.getProperty("Collocated", "false")).booleanValue();

  	connectingTimer = new Integer(props.getProperty("ConnectingTimer", "0")).intValue();
  	cnxPendingTimer = new Integer(props.getProperty("CnxPendingTimer", "0")).intValue();
  	txPendingTimer = new Integer(props.getProperty("TxPendingTimer", "0")).intValue();
  	
  	topicPassivationThreshold = new Integer(props.getProperty("TopicPassivationThreshold", ""+Integer.MAX_VALUE)).intValue();
  	topicActivationThreshold = new Integer(props.getProperty("TopicActivationThreshold", "0")).intValue();
  	topicAckBufferMax = new Integer(props.getProperty("TopicAckBufferMax", "0")).intValue();
  	subscriptionName = props.getProperty("SubscriptionName");
  	subscriptionDurability = props.getProperty("SubscriptionDurability");
  	queueMessageReadMax = new Integer(props.getProperty("QueueMessageReadMax", "2")).intValue();
  	messageSelector = props.getProperty("MessageSelector");
  	maxNumberOfWorks = props.getProperty("MaxNumberOfWorks", "0");
  	maxMessages = props.getProperty("MaxMessages", "10");
  	destinationType = props.getProperty("DestinationType");
  	destination = props.getProperty("Destination");
  	deleteDurableSubscription = new Boolean(props.getProperty("DeleteDurableSubscription", "false")).booleanValue();
  	acknowledgeMode = props.getProperty("AcknowledgeMode", AUTO_ACKNOWLEDGE);
  }
