public void setResourceAdapter(ResourceAdapter ra) throws ResourceException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " setResourceAdapter(" + ra + ")");

    if (this.ra != null)
      throw new IllegalStateException("Can not change resource adapter"
                                      + " association.");

    if (! (ra instanceof JoramAdapter))
      throw new ResourceException("Provided resource adapter is not a JORAM "
                                  + "resource adapter: "
                                  + ra.getClass().getName());

    this.ra = (JoramAdapter) ra;
    
    if (hostName == null && serverPort == -2) {
    	// set the ra value for this ActivationSpec
    	// this value can be override by the MDB descriptor
    	hostName = this.ra.getHostName();
    	serverPort = this.ra.getServerPort();
    	// userName = the default value is anonymous
    	// password = the default value is anonymous
    	identityClass = this.ra.getIdentityClass();
    	collocated = this.ra.getCollocated();
    }
  }
