public void onMessage(javax.jms.Message message) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " onMessage(" + message + ")");

    MessageEndpoint endpoint = null;
    try {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "ServerSession passes message to listener.");
      endpoint = endpointFactory.createEndpoint(xaResource);
      ((javax.jms.MessageListener) endpoint).onMessage(message);
      endpoint.release();
    } catch (Exception exc) {
      try {
        // try to clean the context for next invocation
        if (endpoint != null) endpoint.release();
      } catch (Exception e) {
        // ignore the exception
        if (logger.isLoggable(BasicLevel.INFO))
          logger.log(BasicLevel.INFO, "endpoint.release: ", e);
      }
      logger.log(BasicLevel.ERROR, "InboundSession.onMessage: ", exc);
      throw new java.lang.IllegalStateException("Could not get endpoint instance: ", exc);
    }
  }
