void adminConnect() throws AdminException {
    try {
      org.objectweb.joram.client.jms.ConnectionFactory cf;

      if (collocated)
        cf = LocalConnectionFactory.create();
      else
        cf = TcpConnectionFactory.create(hostName, serverPort);

      if (logger.isLoggable(BasicLevel.DEBUG))
  			logger.log(BasicLevel.DEBUG, "adminConnect: cf = " + cf);
      
      if (connectingTimer == 0)
      	cf.getParameters().connectingTimer = 60;
      else
      	cf.getParameters().connectingTimer = connectingTimer;

      cf.setIdentityClassName(identityClass);
      cf.setCnxJMXBeanBaseName(jmxRootName+"#"+getName());
      cnx = cf.createConnection(rootName, rootPasswd);
      cnx.start();
      wrapper = new JoramAdmin(cnx);
      if (logger.isLoggable(BasicLevel.DEBUG))
  			logger.log(BasicLevel.DEBUG, "adminConnect: wrapper = " + wrapper);

      // register wrapper as a service
      try {
      	if (Activator.context != null) {
      		Properties props = new Properties();
      		props.setProperty("name", getName());
      		props.setProperty("host", hostName);
      		props.setProperty("port", ""+serverPort);
      		props.setProperty("user", rootName);

      		registration =  Activator.context.registerService(
      				AdminItf.class.getName(),
      				wrapper,
      				(Dictionary) props);
      		if (logger.isLoggable(BasicLevel.DEBUG))
      			logger.log(BasicLevel.DEBUG, "Bundle context " + Activator.context + " registerService AdminWrapper " + getName());
      	}
      } catch (Exception e) {
      	 if (logger.isLoggable(BasicLevel.WARN))
      		 logger.log(BasicLevel.WARN, "adminConnect: register wrapper in context " + Activator.context, e);
      }
      
      if (!isActive)
      	adminDurationState = System.currentTimeMillis();
      isActive = true;
      
      // Registering MBeans...
      try {
        MXWrapper.registerMBean(this, getMBeanName());
      } catch (Exception e) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN, "  - Could not register JoramAdapterMBean", e);
      }
    } catch (ConnectException exc) {
    	if (isActive)
    		adminDurationState = System.currentTimeMillis();
    	isActive = false;
      throw new AdminException("Admin connection can't be established: " + exc.getMessage());
    } catch (JMSException e) {
    	if (isActive)
    		adminDurationState = System.currentTimeMillis();
    	isActive = false;
      throw new AdminException("Admin connection can't be established: " + e.getMessage());
		}
  }
