public void reconnect() throws Exception {
  	if (logger.isLoggable(BasicLevel.DEBUG))
  		logger.log(BasicLevel.DEBUG, "JoramAdapter: reconnect()");
  	
  	boolean connected = false;
  	if (getStatus() != Status.STARTED || getStatus() == Status.STOPPED || getStatus() == Status.STOPPING)
  		return;
  	
  	try {
  		wrapper.getConfiguration();
  		connected = true;
  	} catch (Exception e1) {
  	  if (getStatus() == Status.STOPPING || getStatus() == Status.STOPPED) return;
  		try {
	    	adminDisconnect();
	    } catch (Exception e) {
	    	if (logger.isLoggable(BasicLevel.DEBUG))
	    		logger.log(BasicLevel.DEBUG, "JoramAdapter: reconnect " + e);
      }
	    try {
	      adminConnect();
      } catch (AdminException e) {
      	if (logger.isLoggable(BasicLevel.DEBUG))
	    		logger.log(BasicLevel.DEBUG, "JoramAdapter: reconnect " + e);
      	throw e;
      }
    }
    
    if (connected)
    	return;
    
    // reconnect producers and consumers.
    super.reconnect();
    
  	if (logger.isLoggable(BasicLevel.DEBUG))
  		logger.log(BasicLevel.DEBUG, "JoramAdapter: is reconnected = " + connected);
  }
