public synchronized void stop() {
  	if (logger.isLoggable(BasicLevel.INFO))
  		logger.log(BasicLevel.INFO, "JORAM adapter stopping...");

  	if (logger.isLoggable(BasicLevel.DEBUG))
  	  logger.log(BasicLevel.DEBUG, "stop: AgentServer.status = " + AgentServer.getStatusInfo() + ", status = " + getStatusInfo());

  	if (getStatus() != Status.STARTED || getStatus() == Status.STOPPED) {
      status.value = Status.STOPPED;
      if (logger.isLoggable(BasicLevel.INFO))
        logger.log(BasicLevel.INFO, "JORAM adapter stopped.");
      return;
    }
  	
  	if (collocated) { 
  	  if (AgentServer.getStatus() != AgentServer.Status.STARTED) {
  	    if (AgentServer.getStatus() != AgentServer.Status.STARTING) {
  	      status.value = Status.STOPPED;
  	      if (logger.isLoggable(BasicLevel.INFO))
  	        logger.log(BasicLevel.INFO, "JORAM adapter successfully stopped.");
  	      return;
  	    }
  	  }
  	}

  	super.stop();

  	// Finishing the admin session.
  	adminDisconnect();

  	try {
  		MXWrapper.unregisterMBean(getMBeanName());
  	} catch (Exception e) {
  		if (logger.isLoggable(BasicLevel.DEBUG))
  			logger.log(BasicLevel.DEBUG, "unregisterMBean: " + getMBeanName(), e);
  	}

  	if (startJoramServer) {
  		// If JORAM server is collocated, stopping it.
  		if (collocated) {
  			try {
  				AgentServer.stop(true, 0, true);
  			} catch (Exception exc) {
  				if (logger.isLoggable(BasicLevel.WARN))
  					logger.log(BasicLevel.WARN, "Error during AgentServer stopping", exc);

  			}
  		}
  	}

  	status.value = Status.STOPPED;

  	if (logger.isLoggable(BasicLevel.INFO))
  		logger.log(BasicLevel.INFO, "JORAM adapter successfully stopped.");
  }
