private ConnectionFactory getConnectionFactory(ActivationSpecImpl specImpl) {
    ConnectionFactory cf = null;
    if (specImpl.getCollocated())
      cf = LocalConnectionFactory.create();
    else
      cf = TcpConnectionFactory.create(specImpl.getHostName(), specImpl.getServerPort());

    cf.getParameters().connectingTimer = specImpl.getConnectingTimer();
    cf.getParameters().cnxPendingTimer = specImpl.getCnxPendingTimer();
    cf.getParameters().txPendingTimer = specImpl.getTxPendingTimer();

    if (specImpl.getQueueMessageReadMax() > 0) {
      cf.getParameters().queueMessageReadMax = specImpl.getQueueMessageReadMax();
    }

    if (specImpl.getTopicAckBufferMax() > 0) {
      cf.getParameters().topicAckBufferMax = specImpl.getTopicAckBufferMax();
    }

    if (specImpl.getTopicPassivationThreshold() > 0) {
      cf.getParameters().topicPassivationThreshold = specImpl.getTopicPassivationThreshold();
    }

    if (specImpl.getTopicActivationThreshold() > 0) {
      cf.getParameters().topicActivationThreshold = specImpl.getTopicActivationThreshold();
    }

    // set identity class for this connectionFactory.
    cf.setIdentityClassName(specImpl.getIdentityClass());
    return cf;
  }
