public synchronized void reconnect() throws Exception {
  	if (logger.isLoggable(BasicLevel.DEBUG))
  		logger.log(BasicLevel.DEBUG, "JoramResourceAdapter: reconnect()");
  	if (getStatus() != Status.STARTED || getStatus() == Status.STOPPED)
  		return;
    
    // consumers
    Hashtable copyConsumers = (Hashtable) consumers.clone();
    
  	Set keys = copyConsumers.entrySet();
  	Iterator it = keys.iterator();
  	while (it.hasNext()) {
  		Map.Entry entry = (Map.Entry) it.next();
	    
	    MessageEndpointFactory endpointFactory = ((InboundConsumer)entry.getValue()).endpointFactory;
      ActivationSpec spec = (ActivationSpec) entry.getKey();
      try {
      	endpointDeactivation(endpointFactory, spec);
	      endpointActivation(endpointFactory, spec);
      } catch (ResourceException e) {
      	if (logger.isLoggable(BasicLevel.INFO))
	    		logger.log(BasicLevel.INFO, "JoramResourceAdapter: reconnect spec = " + spec, e);
      }
    }
  	
  	// producers
  	it = ((Vector) producers.clone()).iterator();
  	while (it.hasNext()) {
  		ManagedConnectionImpl mci = (ManagedConnectionImpl) it.next();
  		mci.reconnect();
  	}
  }
