public synchronized void start() throws ResourceAdapterInternalException {
    if (getStatus() == Status.STARTED)
      throw new ResourceAdapterInternalException("Adapter already started.");
    if (getStatus() == Status.STOPPED)
      throw new ResourceAdapterInternalException("Adapter has been stopped.");

    if (workManager == null) {
      throw new ResourceAdapterInternalException("WorkManager has not been set.");
    }

    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "JORAM Resource adapter starting...");

    status.value = Status.STARTING;
    
    if (jndiName != null && jndiName.length() > 0) {
    	// bind RessourceAdapter
    	bind(jndiName, this);
    }
    
    status.value = Status.STARTED;

    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "JORAM Resource adapter " + ConnectionMetaData.providerVersion + " successfully deployed.");
  }
