public void setResourceAdapter(ResourceAdapter ra) throws ResourceException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " setResourceAdapter(" + ra + ")");

    if (this.ra != null) {
      out.print("ResourceAdapter instance already associated.");
      throw new javax.resource.spi.IllegalStateException("ResourceAdapter "
                                                         + "instance "
                                                         + "already "
                                                         + "associated.");
    }

    if (! (ra instanceof JoramAdapter)) {
      out.print("Provided ResourceAdapter is not a JORAM ResourceAdapter object: "
                + ra.getClass().getName());
      throw new ResourceException("Provided ResourceAdapter is not a JORAM "
                                  + "ResourceAdapter object: "
                                  + ra.getClass().getName());
    }

    this.ra = (JoramAdapter) ra;
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " setResourceAdapter isCollocated = " + ((JoramAdapter) ra).collocated + ", serverPort = " + ((JoramAdapter) ra).getServerPort());
    
    if (((JoramAdapter) ra).collocated) {
      if (getServerPort() < 0) {
        setServerPort(((JoramAdapter) ra).getServerPort());
      }
    }
    
// TODO remove
//    collocated = this.ra.collocated;
//    isHa = this.ra.isHa;
//    hostName = this.ra.hostName;
//    serverPort = this.ra.serverPort;
//    connectingTimer = this.ra.connectingTimer;
//    txPendingTimer = this.ra.txPendingTimer;
//    cnxPendingTimer = this.ra.cnxPendingTimer;
//    asyncSend = this.ra.asyncSend;
//    multiThreadSync = this.ra.multiThreadSync;
//    multiThreadSyncDelay = this.ra.multiThreadSyncDelay;
//
//    if (logger.isLoggable(BasicLevel.DEBUG))
//      logger.log(BasicLevel.DEBUG,
//                                    this + " setResourceAdapter collocated = " + collocated +
//                                    ", isHa = " + isHa +
//                                    ", hostName = " + hostName +
//                                    ", serverPort = " + serverPort +
//                                    ", connectingTimer = " + connectingTimer +
//                                    ", txPendingTimer = " + txPendingTimer +
//                                    ", cnxPendingTimer = " + cnxPendingTimer);
  }
