public synchronized void cleanup() throws ResourceException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " cleanup()");

    OutboundConnection handle;
    Iterator it = handles.iterator();
    while (it.hasNext()) {
      handle = (OutboundConnection) it.next();
      handle.cleanup();
    }
    
    // TODO (AF): JORAM-335: This session is registered in XAResource, do not close it nor nullify.
    try {
      if (session != null)
        session.close();
    } catch (JMSException e) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, e);
    }
    session = null;
    
    try {
      // Clear the handles. 
      handles.clear();
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, e);
    }
  }
