@Override
  protected XAConnectionFactory createFactory(ConnectionRequestInfo cxRequest) throws ResourceException {
  	XAConnectionFactory factory = null;

  	String hostName = getHostName();
  	int serverPort = getServerPort();
//  	if (isCollocated()) {
//  		hostName = "localhost";
//  		serverPort = -1;
//  	}

  	if (isCollocated()) {
  	  if (cxRequest instanceof QueueConnectionRequest) {
  	    factory = XAQueueLocalConnectionFactory.create();
  	  } else {
  	    factory = XALocalConnectionFactory.create();
  	  }
  	} else {
  	  if (cxRequest instanceof QueueConnectionRequest) {
  	    factory = XAQueueTcpConnectionFactory.create(hostName, serverPort);
  	  } else {
  	    factory = XATcpConnectionFactory.create(hostName, serverPort);
  	  }
  	}
  	
  	if (ra == null) {
      setResourceAdapter(new JoramAdapter());
    }
  	((AbstractConnectionFactory) factory).setCnxJMXBeanBaseName(ra.jmxRootName+"#"+ra.getName());

  	if (logger.isLoggable(BasicLevel.DEBUG))
  		logger.log(BasicLevel.DEBUG, this + " createFactory factory = " + factory);
  	
  	return factory;
  }
