public Object getObjectInstance(Object obj,
			Name name,
			Context ctx,
			java.util.Hashtable env) throws Exception {

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " getObjectInstance(" + obj + 
                                    ", " + name +
                                    ", " + ctx +
                                    ", " + env + ")");

    Reference ref = (Reference) obj;

    String hostName = (String) ref.get("hostName").getContent();
    Integer serverPort = new Integer((String) ref.get("serverPort").getContent());
    String userName = (String) ref.get("userName").getContent();
    String password = (String) ref.get("password").getContent();
    String identityClass = (String) ref.get("identityClass").getContent();

    
    
    ManagedConnectionFactoryImpl mcf = null;

    if (ref.getClassName().equals(cf))
      mcf = new ManagedConnectionFactoryImpl();
    else if (ref.getClassName().equals(qcf))
      mcf = new ManagedQueueConnectionFactoryImpl();
    else if (ref.getClassName().equals(tcf))
      mcf = new ManagedTopicConnectionFactoryImpl();
    else
      return null;
    
    // set ManagedConnectionFactoryConfig
    mcf.setCollocated(new Boolean(false));
    mcf.setHostName(hostName);
    mcf.setServerPort(serverPort);
    mcf.setUserName(userName);
    mcf.setPassword(password);
    mcf.setIdentityClass(identityClass);
    //TODO: ? set connectingTimer, cnxPending, ...

    try {
      return mcf.createConnectionFactory();
    } catch (Exception exc) {
      return null;
    }
  }
