public javax.jms.Connection
      createConnection(String userName, String password) throws JMSException {

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " createConnection(" + userName + ", ****)");

    try {
      ConnectionRequest cxRequest = null;
      if (mcf instanceof ManagedQueueConnectionFactoryImpl)
        cxRequest = new QueueConnectionRequest(userName, password, mcf.getIdentityClass());
      else if (mcf instanceof ManagedTopicConnectionFactoryImpl)
        cxRequest = new TopicConnectionRequest(userName, password, mcf.getIdentityClass());
      else
        cxRequest = new ConnectionRequest(userName, password, mcf.getIdentityClass());

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, this + " createConnection cxManager = " + cxManager);

      Object o = cxManager.allocateConnection(mcf, cxRequest);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, this + " createConnection connection = " + o);

      return (javax.jms.Connection) o;
    } catch (javax.resource.spi.SecurityException exc) {
      throw new JMSSecurityException("Invalid user identification: " + exc);
    } catch (javax.resource.spi.CommException exc) {
      throw new IllegalStateException("Could not connect to the JORAM server: "
                                      + exc);
    } catch (javax.resource.ResourceException exc) {
      throw new JMSException("Could not create connection: " + exc);
    }
  }
