public QueueSession createQueueSession(boolean transacted, int acknowledgeMode) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this + " createQueueSession(" + transacted + ", " + acknowledgeMode +  ")");

    if (! valid)
      throw new javax.jms.IllegalStateException("Invalid connection handle.");

    Session sess = managedCx.getSession();
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, 
                 this + " createQueueSession sess = " +  sess);
    
    // TODO (AF): Use code from OutboundConnection.
    if (sess == null)
      sess = xac.createSession(false, acknowledgeMode);

    return new OutboundQueueSession(sess, this, transacted);
  }
