private void addClientIDToProxy(String clientID) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "addClientIDToProxy(" + clientID + ')');
    try {
      requestor.request(new AddClientIDRequest(clientID));
    } catch (JMSException e) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, e);
      throw new InvalidClientIDException("The JMS client specifies a duplicate client ID \""+ clientID + "\". " + e.getMessage());
    }
  }
