public void setClientID(String clientID) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "setClientID(" + clientID + ')');
    
    if ((clientID != null && clientID.length() == 0))
      throw new InvalidClientIDException("The JMS client specifies an invalid client ID \""+ clientID + "\".");
    if (lockClientID)
      throw new IllegalStateException("ClientID is already set by the provider.");

    checkClosed();
    // add clientID to the proxy
    addClientIDToProxy(clientID);
    // set the clientID
    this.clientID = clientID;
    lockClientId();
  }
