public void start() throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, stringImage + ".start()"); 
    checkClosed();
    
    synchronized (this) {
    // Ignoring the call if the connection is started:
    if (status == Status.START)
      return;
    }

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "--- " + this + ": starting..."); 

    // Starting the sessions: free the connection lock to avoid deadlock with external
    // client threads.
    for (int i = 0; i < sessions.size(); i++) {
      Session session = (Session) sessions.elementAt(i);
      session.start();
    }

    synchronized (this) {
      // Sending a start request to the server:
      mtpx.sendRequest(new CnxStartRequest());

      setStatus(Status.START);
    }
    lockClientId();
  }
