public void setParameters(Properties properties) {
    if ((properties == null) || (properties.isEmpty()))
      return;

    for (Enumeration keys = properties.keys(); keys.hasMoreElements();) {
      String name = (String) keys.nextElement();
      String value = (String) properties.getProperty(name);

      try {
        if ("cnxPendingTimer".equals(name)) {
          cnxPendingTimer = new Integer(value).intValue();
        } else if ("connectingTimer".equals(name)) {
          connectingTimer = new Integer(value).intValue();
        } else if ("asyncSend".equals(name)) {
          asyncSend = new Boolean(value).booleanValue();
        } else if ("txPendingTimer".equals(name)) {
          txPendingTimer = new Integer(value).intValue();
        } else if ("implicitAck".equals(name)) {
          implicitAck = new Boolean(value).booleanValue();
        } else if ("multiThreadSync".equals(name)) {
          multiThreadSync = new Boolean(value).booleanValue();
        } else if ("multiThreadSyncDelay".equals(name)) {
          multiThreadSyncDelay = new Integer(value).intValue();
        } else if ("multiThreadSyncThreshold".equals(name)) {
          multiThreadSyncThreshold = new Integer(value).intValue();
        } else if ("queueMessageReadMax".equals(name)) {
          queueMessageReadMax = new Integer(value).intValue();
        } else if ("topicAckBufferMax".equals(name)) {
          topicAckBufferMax = new Integer(value).intValue();
        } else if ("topicActivationThreshold".equals(name)) {
          topicActivationThreshold = new Integer(value).intValue();
        } else if ("topicPassivationThreshold".equals(name)) {
          topicPassivationThreshold = new Integer(value).intValue();
        } else if ("SoTimeout".equals(name)) {
          SoTimeout = new Integer(value).intValue();
        } else if ("TcpNoDelay".equals(name)) {
          TcpNoDelay = new Boolean(value).booleanValue();
        } else if ("SoLinger".equals(name)) {
          SoLinger = new Integer(value).intValue();
        } else if ("compressedMinSize".equals(name)) {
          compressedMinSize = new Integer(value).intValue();
        } else if ("compressionLevel".equals(name)) {
          compressionLevel = new Integer(value).intValue();
        } else if ("noAckedQueue".equals(name)) {
          noAckedQueue = new Boolean(value).booleanValue();
        } else if ("outLocalPort".equals(name)) {
          outLocalPort = new Integer(value).intValue();
        } else if ("outLocalAddress".equals(name)) {
          outLocalAddress = value;
        } else if ("clientID".equals(name)) {
          clientID = value;
        } else if ("messageIdPrefix".equals(name)) {
          messageIdPrefix = value;
        } else {
          logger.log(BasicLevel.ERROR,
                     "Could not set FactoryParameters <" + name + ", " + value + ">",
                     new Exception("Unknow parameter: " + name));
        }
      } catch (NumberFormatException exc) {
        logger.log(BasicLevel.ERROR,
                   "Could not set FactoryParameters <" + name + ", " + value + ">", exc);
      }
    }
  }
