public <T> T receiveBody(Class<T> c, long timeout) {
    try {
      Message message = receive(timeout);
      if (message != null) {
        T body = message.getBody(c);
        if (body == null) throw new MessageFormatRuntimeException("Message has no body.");
        return body;
      }
      return null;
    } catch (MessageFormatException e) {
      throw new MessageFormatRuntimeException(e.getMessage());
    } catch (JMSException e) {
      throw new MessageFormatRuntimeException("Unable to get message body", e.getMessage(), e);
    }
  }
