public javax.jms.JMSConsumer createConsumer(javax.jms.Destination destination, String selector, boolean noLocal) {
    connection.lockClientID();
    try {
      MessageConsumer consumer = (MessageConsumer) session.createConsumer(destination, selector, noLocal);
      return new JMSConsumer(consumer);
    } catch (InvalidDestinationException e) {
      throw new InvalidDestinationRuntimeException(e.getMessage());
    } catch (InvalidSelectorException e) {
      throw new InvalidSelectorRuntimeException(e.getMessage());
    } catch (JMSException e) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Unable to instantiate a JMSConsumer" + e.getMessage());
      throw new JMSRuntimeException("Unable to instantiate a JMSConsumer");
    } finally {
      if (connection.getAutoStart())
        connection.start();
    }
  }
