public javax.jms.JMSConsumer createSharedDurableConsumer(Topic topic,
      String name, String messageSelector) {
    connection.lockClientID();
    try {
      return new JMSConsumer(session.createSharedDurableConsumer(topic, name, messageSelector));
    } catch (InvalidDestinationException e) {
      throw new InvalidDestinationRuntimeException(e.getMessage(), e.getErrorCode(), e);
    } catch (InvalidSelectorException e) {
      throw new InvalidSelectorRuntimeException(e.getMessage(), e.getErrorCode(), e);
    } catch (IllegalStateException e) {
      throw new IllegalStateRuntimeException(e.getMessage(), e.getErrorCode(), e);
    } catch (JMSException e) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Unable to crate shared durable consumer " + e.getMessage());
      throw new JMSRuntimeException("Unable to create shared durable consumer " + e.getMessage(), e.getErrorCode(), e);
    } finally {
      if (connection.getAutoStart())
        connection.start();
    }
  }
