public void setClientID(String clientID) {
    try {
      if (lockClientID)
        throw new IllegalStateException("ClientID is already set by the provider.");
      if (connection == null) throw new JMSException("Underlying connection is closed");

      connection.setClientID(clientID);
      lockClientID = true;
    } catch (InvalidClientIDException e) {
      throw new InvalidClientIDRuntimeException(e.getMessage(), e.getErrorCode(), e);
    } catch (IllegalStateException e) {
      throw new IllegalStateRuntimeException(e.getMessage(), e.getErrorCode(), e);
    } catch (JMSException e) {
      throw new JMSRuntimeException(e.getMessage(), e.getErrorCode(), e);
    }
  }
