private void doSend(Destination destination, Message message) {
    try {
      message = writeCurrentProperties(message);
      if (getAsync() == null) {
        messageProducer.send(destination, message);
      } else {
        messageProducer.send(destination, message, completionListener);
      }
    } catch (MessageNotWriteableException e) {
      throw new MessageNotWriteableRuntimeException(e.getMessage());
    } catch (UnsupportedOperationException e) {
      throw new InvalidDestinationRuntimeException(e.getMessage());
    } catch (MessageFormatException e) {
      throw new MessageFormatRuntimeException(e.getMessage());
    } catch (InvalidDestinationException e) {
      throw new InvalidDestinationRuntimeException(e.getMessage());
    } catch (IllegalStateException e) {
      throw new IllegalStateRuntimeException(e.getMessage());
    } catch (JMSException e) {
      throw new JMSRuntimeException(e.getMessage());
    }
  }
