public javax.jms.JMSProducer send(Destination destination, Map<String, Object> body) {
    javax.jms.MapMessage message = null;
    try {
      message = session.createMapMessage();
      for (String key : body.keySet()) {
        message.setObject(key, body.get(key));
      }
    } catch (MessageFormatException e) {
      throw new MessageFormatRuntimeException(e.getMessage());
    } catch (MessageNotWriteableException e) {
      throw new MessageNotWriteableRuntimeException(e.getMessage());
    } catch (JMSException e) {
      throw new JMSRuntimeException(e.getMessage());
    }
    doSend(destination, message);
    return this;
  }
