public javax.jms.JMSProducer send(Destination destination, String body) {
    try {
      TextMessage message = (TextMessage) session.createTextMessage(body);
      doSend(destination, message);
    } catch (JMSException e) {
      String errorMessage = "Unable to send message: " + body + " to "
          + destination+ "using session: "+ session;
      if (e instanceof MessageFormatException) {
        throw new MessageFormatRuntimeException(errorMessage);
      } else if (e instanceof InvalidDestinationException) {
        throw new InvalidDestinationRuntimeException(errorMessage);
      } else {
        throw new JMSRuntimeException(errorMessage);
      }
    }
    return this;
  }
