protected void activateListener(Message msg,
                                  MessageListener listener,
                                  int ackMode) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MessageConsumerListener.onMessage(" +  msg + ')');
    
    // if queueMessageReadMax == 0 (disable the mechanism of pre-requesting of the messages), 
    // consume the next message after onMessage.
    if (queueMessageReadMax > 0) {
    // Consume one message
    decreaseMessageCount(ackMode);
    }

    try {
      listener.onMessage(msg);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                   " -> consumer.onMessage(" + msg + ") returned");
    } catch (RuntimeException re) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "", re);
      JMSException exc = new JMSException(re.toString());
      exc.setLinkedException(re);
      throw exc;
    } 
    
    if (queueMessageReadMax == 0) {
      // Consume one message
      decreaseMessageCount(ackMode);
    }
  }
