public void onMessage(Message msg, int ackMode) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MessageConsumerListener.onMessage(" + msg + ')');
    
    MessageListener listener = getNextlistener();
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MessageConsumerListener.onMessage listener = " + listener);
    
    if (listener != null) {
      synchronized (this) {
        if (status == Status.RUN) {
          setStatus(Status.ON_MSG);
        } else {
          // Notify threads trying to close the listener.
          notifyAll();
          throw new javax.jms.IllegalStateException("Message listener closed");
        }
      }

      try {
        activateListener(msg, listener, ackMode);
      } finally {
        synchronized (this) {
          if (status == Status.ON_MSG)
            setStatus(Status.RUN);

          // Notify threads trying to close the listener.
          notifyAll();
        }
      }
    } else {
      throw new JMSException("Null listener");
    }
  }
