public synchronized boolean replyReceived(AbstractJmsReply reply) 
    throws AbortedRequestException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MessageConsumerListener.replyReceived(" + reply + ')');
    
    if (status == Status.CLOSE)
      throw new AbortedRequestException();

    if (queueMode) {
      // 1- Change the status before pushing the  messages into the session queue.
      setReceiveStatus(ReceiveStatus.CONSUMING_REPLY);
    }
    
    try {
      ConsumerMessages cm = (ConsumerMessages)reply;
      // 2- increment messageCount (synchronized)
      messageCount += cm.getMessageCount();
      
      // verify the server activity
      if (!cm.isActive()) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "MessageConsumerListener.replyReceived: the server passivate.");
        topicMsgInputPassivated = true;
      }
          
      pushMessages(cm);
    } catch (StoppedQueueException exc) {
      throw new AbortedRequestException();
    } catch (JMSException exc) {
      throw new AbortedRequestException();
    }
    
    if (queueMode) {
      return true;
    }
    return false;
  }
