public synchronized void setMessageListener(javax.jms.MessageListener messageListener) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MessageConsumer.setMessageListener(" + messageListener + ')');
    checkClosed();
    MessageConsumerListener mcl = sess.getMessageConsumerListener(targetName);
    if (mcl != null) {
      if (messageListener == null) {
        if (shared) {
          mcl.removeMessageListener(this.messageListener);
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "MessageConsumer.setMessageListener mcl.getMessageListenersSize() = " + mcl.getMessageListenersSize());
          if (mcl.getMessageListenersSize() < 1) {
            sess.removeMessageListener(mcl, false);
            sess.removeMessageConsumerListener(targetName);
          }
        } else {
          sess.removeMessageListener(mcl, false);
          sess.removeMessageConsumerListener(targetName);
        }
      } else {
        if (shared && mcl.getMessageListenersSize() > 0) {
          mcl.addMessageListener(messageListener);
        } else {
          sess.removeMessageListener(mcl, false);
          mcl = sess.addMessageListener(new SingleSessionConsumer(queueMode,
              durableSubscriber,
              selector,
              dest.getAdminName(),
              targetName,
              sess,
              messageListener), false);
          sess.putMessageConsumerListener(targetName, mcl);
        }
      }
    } else {
      if (messageListener != null) {
        mcl = sess.addMessageListener(new SingleSessionConsumer(queueMode,
                                                                durableSubscriber,
                                                                selector,
                                                                dest.getAdminName(),
                                                                targetName,
                                                                sess,
                                                                messageListener), true);
        sess.putMessageConsumerListener(targetName, mcl);
      }
      // else idempotent
    }
    this.messageListener = messageListener;
  }
