public void send(javax.jms.Destination destination, 
      javax.jms.Message message,
      javax.jms.CompletionListener completionListener) throws JMSException {
    if (destination == null)
      throw new InvalidDestinationException("Can't send message to an unidentified destination.");
    if (identified)
      throw new UnsupportedOperationException("An identified message producer can't use this method.");
    if (completionListener == null)
      throw new IllegalArgumentException("Completion listener is null");
    doSend((Destination) destination, message, deliveryMode, priority, timeToLive, completionListener);
  }
