private final void checkIdentifier(String identifier) throws IllegalArgumentException {
    if (! strictVerificationWarn()) return;
    
    char[] chars = identifier.toCharArray();
    if (!Character.isJavaIdentifierStart(chars[0])) {
      if (strictVerificationError()) {
        throw new IllegalArgumentException("Invalid property name: " + identifier);
      } else {
        if (strictVerificationWarn())
          logger.log(BasicLevel.WARN,
                     "Invalid property name \"" + identifier + "\" in JMS message.");
        return;
      }
    }

    for (int i=1; i<chars.length; i++) {
      if (!Character.isJavaIdentifierPart(chars[i])) {
        if (strictVerificationError()) {
          throw new IllegalArgumentException("Invalid property name: " + identifier);
        } else {
          if (strictVerificationWarn())
            logger.log(BasicLevel.WARN,
                       "Invalid property name \"" + identifier + "\" in JMS message.");
          return;
        }
      }
    }
  }
