public boolean isBodyAssignableTo(Class c) throws JMSException {
    if (momMsg.body == null) return true;
    
    if (this instanceof StreamMessage) {
      return false;
    } else if (this instanceof TextMessage) {
      return c.isAssignableFrom(String.class);
    } else if (this instanceof BytesMessage) {
      return byte[].class.equals(c)|| java.lang.Object.class.equals(c);
    } else if (this instanceof MapMessage) {
      return java.util.Map.class.equals(c) || java.lang.Object.class.equals(c);
    } else if (this instanceof ObjectMessage) {
        return c.isAssignableFrom(((ObjectMessage) this).getObject().getClass());
// TODO (AF): This case doesn't seem to be part of the specification/
//    } else if (Message.class.equals(c)) {
//      return true;
    } else {
      throw new JMSException ("Unable to to return a value");
    }

  }
