synchronized void acknowledge(Destination dest, String msgId) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Session.acknowledge(" + dest + ", " + msgId + ')');
    checkClosed();
    if (acknowledgeMode == INDIVIDUAL_ACKNOWLEDGE) {
      Enumeration targets = deliveries.keys();
      while (targets.hasMoreElements()) {
        String target = (String) targets.nextElement();
        if (target.equals(dest.getAdminName()) || target.equals(dest.getName())) {
          MessageAcks acks = (MessageAcks) deliveries.get(target);
          acks.remove(msgId);
          Vector ackToSend = new Vector();
          ackToSend.add(msgId);
          mtpx.sendRequest(new SessAckRequest(dest.getName(), ackToSend, dest.isQueue()));
          return;
        }
      }
    }
  }
