private void checkShared(Topic topic, String sharedSubscriptionName, String selector) throws JMSException {
    if (sharedSubscriptionName == null)
      throw new JMSException("the sharedSubscriptionName must be set.");
    
    MessageConsumer mc = getMessageConsumer(sharedSubscriptionName);
    if (mc != null && mc.isOpen()) {
      if (!mc.getDest().getName().equals(topic.getName())) {
        if (logger.isLoggable(BasicLevel.ERROR))
          logger.log(BasicLevel.ERROR, "The shared \"" + sharedSubscriptionName + "\" durable/non-durable subscription already exists and active with a different topic name (" + mc.getDest() + ").");
        throw new JMSException("The shared \"" + sharedSubscriptionName + "\" durable/non-durable subscription already exists and active with a different topic name (" + mc.getDest() + ").");
      }
      if ((mc.getMessageSelector() != null && selector == null) || (selector != null && !selector.equals(mc.getMessageSelector()))) {
        if (logger.isLoggable(BasicLevel.ERROR))
          logger.log(BasicLevel.ERROR, "The shared \"" + sharedSubscriptionName + "\" durable/non-durable subscription already exists and active with a different selector (" + mc.getMessageSelector() + ").");
        throw new JMSException("The shared \"" + sharedSubscriptionName + "\" durable/non-durable subscription already exists and active with a different selector (" + mc.getMessageSelector() + ").");

      }
    }
  }
