public javax.jms.MessageConsumer createDurableConsumer(javax.jms.Topic topic,
                                                         String name) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Session.createDurableConsumer(" + topic + ',' + name + ')');
    
    checkClosed();
    checkThreadOfControl();
    if (topic == null)
      throw new InvalidDestinationException("Invalid null topic.");
    checkClientID();
    
    MessageConsumer mc = new MessageConsumer(this, (Topic) topic, null, name, false, false, true);
    addConsumer(mc);
    return mc;
  }
