public javax.jms.MessageConsumer createDurableConsumer(javax.jms.Topic topic,
                                                         String name,
                                                         String selector,
                                                         boolean noLocal) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "Session.createDurableConsumer(" + topic + ',' + name  + ',' + selector  + ',' + noLocal + ')');
    
    checkClosed();
    checkThreadOfControl();
    if (topic == null)
      throw new InvalidDestinationException("Invalid null topic.");
    checkClientID();
    
    MessageConsumer mc = new MessageConsumer(this, (Topic) topic, selector, name, noLocal, false, true);
    addConsumer(mc);
    return mc;
  }
