public javax.jms.MessageConsumer createSharedConsumer(javax.jms.Topic topic,
                                                        String sharedSubscriptionName,
                                                        String selector) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "Session.createSharedConsumer(" + topic + ',' + sharedSubscriptionName + ',' + selector + ')');

    checkClosed();
    checkThreadOfControl();
    
    if (topic == null)
      throw new InvalidDestinationException("Invalid null destination.");
    ((Topic) topic).check();
    
    checkShared((Topic) topic, sharedSubscriptionName, selector);
    
    //TODO : If there is an active (i.e. not closed) consumer on the shared non-durable subscription, 
    // and an attempt is made to create an additional consumer, specifying the same name and client identifier
    // (if set) but a different topic or message selector, then a JMSException or JMSRuntimeException 
    // (depending on the method signature) will be thrown.
    MessageConsumer mc = new MessageConsumer(this, (Topic) topic, selector, sharedSubscriptionName, false, true, false);
    addConsumer(mc);
    return mc;
  }
