public javax.jms.MessageConsumer createSharedDurableConsumer(javax.jms.Topic topic,
                                                               String name,
                                                               String selector) throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "Session.createSharedDurableConsumer(" + topic + ',' + name + ',' + selector + ')');

    checkClosed();
    checkThreadOfControl();
    
    if (topic == null)
      throw new InvalidDestinationException("Invalid null destination.");
    ((Topic) topic).check();

    checkShared((Topic) topic, name, selector);

    //TODO : If there is an active (i.e. not closed) consumer on the shared non-durable subscription, 
    // and an attempt is made to create an additional consumer, specifying the same name and client identifier
    // (if set) but a different topic or message selector, then a JMSException or JMSRuntimeException 
    // (depending on the method signature) will be thrown.
    MessageConsumer mc = new MessageConsumer(this, (Topic) topic, selector, name, false, true, true);
    addConsumer(mc);
    return mc;
  }
