public synchronized javax.jms.Topic createTopic(String name) throws JMSException {
    checkClosed();
    checkThreadOfControl();

    // Checks if the topic to retrieve is the administration topic:
    if (name.equals("#AdminTopic")) {
      try {
        GetAdminTopicReply reply = (GetAdminTopicReply) requestor.request(new GetAdminTopicRequest());
        if (reply.getId() != null)
          return new Topic(reply.getId());
        
        throw new JMSException("AdminTopic could not be retrieved.");
      } catch (JMSException exc) {
        throw exc;
      } catch (Exception exc) {
        throw new JMSException("AdminTopic could not be retrieved: " + exc);
      }
    }

    try {
      Destination.checkId(name);
    } catch (InvalidDestinationException exc) {
      String id = createDestination(DestinationConstants.getTopicType(), name);
      Topic topic = new Topic(id);
      topic.adminName = name;
      return topic;
    }
    return new Topic(name);
  }
