synchronized void commit(Xid xid) throws XAException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                                 "--- " + this + ": commit(" + xid + ")"); 

    try {
      if (getStatus(xid) != PREPARED)
        throw new XAException("Can't commit non prepared transaction.");

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                                   "--- " + this + ": commits transaction " + xid.toString()); 

      cnx.syncRequest(new XACnxCommit(xid.getBranchQualifier(),
                                      xid.getFormatId(),
                                      xid.getGlobalTransactionId())); 

      transactions.remove(xid);
      Session session = (Session) sessionTable.get(xid);
      if (session != null)
        session.setTransacted(false);

    } catch (JMSException exc) {
      setStatus(xid, ROLLBACK_ONLY);
      throw new XAException("Commit request failed: " + exc);
    } catch (XAException exc) {
      setStatus(xid, ROLLBACK_ONLY);
      throw exc;
    }
  }
