synchronized void start(Xid xid, int flag,
                          Session sess) throws XAException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                                 " XAResourceMngr start(" + xid + ", " + flag + ", " + sess +")");

    sess.setTransacted(true); // for XAResource.TMRESUME
    sessionTable.put(xid,sess);

    // New transaction.
    if (flag == XAResource.TMNOFLAGS) {
      if (transactions.containsKey(xid))
        throw new XAException("Can't start transaction already known by RM.");

      transactions.put(xid, new XAContext());

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                                   "--- " + this + ": involved in transaction " + xid.toString()); 
    } else if (flag == XAResource.TMRESUME) {
      // Resumed transaction.
      if (! transactions.containsKey(xid))
        throw new XAException("Can't resume unknown transaction.");

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                                   "--- " + this + ": resumes transaction " + xid.toString()); 
    } else if (flag == XAResource.TMJOIN) {
      // Already known transaction.
      if (! transactions.containsKey(xid))
        throw new XAException("Can't join unknown transaction.");

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                                   "--- " + this + ": joins transaction " + xid.toString()); 
    } else
      throw new XAException("Invalid flag: " + flag);

    setStatus(xid, STARTED);
  }
