protected ConnectionFactory getConnectionFactory() {
    if ((cluster != null) && ! cluster.isEmpty()) {
      ConnectionFactory cf = null;
      String location = System.getProperty("location");
      if (location == null || location.equals("")) {
        int idx = new Random().nextInt(cluster.size());

        Object key[] = cluster.keySet().toArray();
        location = (String) key[idx];
        System.setProperty("location", location);
      }

      cf = (ConnectionFactory) cluster.get(location);
      if (cf == null) {
        Enumeration e = cluster.elements();
        cf = (ConnectionFactory) e.nextElement();
      }
      return cf;
    }

    return null;
  }
