public Queue create(int serverId,
      String name,
      String dest,
      Properties props) throws ConnectException, AdminException {
    if (dest == null)
      throw new AdminException("Remote destination cannot be null");
    
    if (props == null)
      props = new Properties();
    
    props.setProperty(DestinationConstants.ACQUISITION_CLASS_NAME, RESTAcquisition);
    if (!props.containsKey(DestinationConstants.REST_HOST_PROP))
      props.setProperty(DestinationConstants.REST_HOST_PROP, host);
    if (!props.containsKey(DestinationConstants.REST_PORT_PROP))
      props.setProperty(DestinationConstants.REST_PORT_PROP, "" + port);
    if (!props.containsKey(DestinationConstants.REST_USERNAME_PROP))
      props.setProperty(DestinationConstants.REST_USERNAME_PROP, username);
    if (!props.containsKey(DestinationConstants.REST_PASSWORD_PROP))
      props.setProperty(DestinationConstants.REST_PASSWORD_PROP, password);
    if (!props.containsKey(DestinationConstants.MEDIA_TYPE_JSON_PROP))
      props.setProperty(DestinationConstants.MEDIA_TYPE_JSON_PROP, "" + mediaTypeJson);
    if (!props.containsKey(DestinationConstants.TIMEOUT_PROP))
      props.setProperty(DestinationConstants.TIMEOUT_PROP, "" + timeout);
    if (!props.containsKey(DestinationConstants.IDLETIMEOUT_PROP))
      props.setProperty(DestinationConstants.IDLETIMEOUT_PROP, "" + idleTimeout);
    if (!props.containsKey(DestinationConstants.ACQUISITION_PERIOD))
      props.setProperty(DestinationConstants.ACQUISITION_PERIOD, "" + acquisitionPeriod);
    
    props.setProperty(DestinationConstants.DESTINATION_NAME_PROP, dest);
    
    return Queue.create(serverId, name, Destination.ACQUISITION_QUEUE, props);
  }
