public Queue create(int serverId,
      String name,
      String dest,
      Properties props) throws ConnectException, AdminException {
    if (dest == null)
      throw new AdminException("Remote destination cannot be null");

    if (props == null)
      props = new Properties();
    
    props.setProperty("distribution.className", RESTDistribution);
    if (!props.containsKey(DestinationConstants.REST_HOST_PROP))
      props.setProperty(DestinationConstants.REST_HOST_PROP, host);
    if (!props.containsKey(DestinationConstants.REST_PORT_PROP))
      props.setProperty(DestinationConstants.REST_PORT_PROP, ""+port);
    if (!props.containsKey(DestinationConstants.REST_USERNAME_PROP))
      props.setProperty(DestinationConstants.REST_USERNAME_PROP, userName);
    if (!props.containsKey(DestinationConstants.REST_PASSWORD_PROP))
      props.setProperty(DestinationConstants.REST_PASSWORD_PROP, password);
    if (!props.containsKey(DestinationConstants.ASYNC_DISTRIBUTION_OPTION))
      props.setProperty(DestinationConstants.ASYNC_DISTRIBUTION_OPTION, ""+async);
    if (!props.containsKey(DestinationConstants.BATCH_DISTRIBUTION_OPTION))
      props.setProperty(DestinationConstants.BATCH_DISTRIBUTION_OPTION, ""+batch);
    if (!props.containsKey(DestinationConstants.IDLETIMEOUT_PROP))
      props.setProperty(DestinationConstants.IDLETIMEOUT_PROP, ""+idleTimeout);
    if (!props.containsKey("period"))
      props.setProperty("period", ""+period);

    props.setProperty(DestinationConstants.DESTINATION_NAME_PROP, dest);

    return Queue.create(serverId, name, Destination.DISTRIBUTION_QUEUE, props);
  }
