public static User create(String name, String password,
                            int serverId,
                            String identityClassName,
                            Properties prop) throws ConnectException, AdminException {
    if ((name == null) || name.equals(""))
      throw new AdminException("User name can not be null or empty");
    
    Identity identity = createIdentity(name, password, identityClassName);

    User user = new User(name);
    AdminReply reply = user.getWrapper().doRequest(new CreateUserRequest(identity, serverId, prop));
    user.proxyId = ((CreateUserReply) reply).getProxId();
    
    // Be careful, MBean registration is now done explicitly

    return user;
  }
