public static void destroy() throws Exception {
    init();
    if (baseDir.exists()) {
      int serverId;

      try {
        serverId = loadServerId();
      } catch (IOException exc) {
        // Nothing to do
        serverId = -1;
      }
      if (serverId > 0) {
        adminConnect();

        // Check that this server is the one registered
        // with the identifier 'serverId'.
        Server[] servers = AdminModule.getServers();
        for (int i = 0; i < servers.length; i++) {
          if (servers[i].getId() == serverId &&
              servers[i].getName() == serverName &&
              servers[i].getHostName() == hostName) {
            try {
              AdminModule.removeServer(serverId);
            } catch (UnknownServerException exc) {
              // Nothing to do
            }
          }
        }
      }
      new File(baseDir, SERVER_ID).delete();
      File serverDataDir = new File(baseDir, JORAM_SERVER_DATA);
      if (serverDataDir.exists()) {
        File[] files = serverDataDir.listFiles();
        for (int i = 0; i < files.length; i++) {
          files[i].delete();
        }
        serverDataDir.delete();
      }
      new File(baseDir, A3_SERVERS_XML).delete();
    }
  }
