public synchronized void send(AbstractJmsRequest request) throws Exception {
    SyncRound localRound = currentRound;
    syncRequests.addElement(request);
    if (syncRequests.size() < multiThreadSyncThreshold) {
      try {
        wait(multiThreadSyncDelay);
      } catch (InterruptedException ie) {
      }
    }
    if (!localRound.done) {
      // syncRequests.size() must be > 0
      AbstractJmsRequest[] requests = 
        new AbstractJmsRequest[syncRequests.size()];
      syncRequests.copyInto(requests);
      syncRequests.clear();
      localRound.done = true;
      currentRound = new SyncRound();
      channel.send(new JmsRequestGroup(requests));
      notifyAll();
    }
    // else do nothing
  }
