public void replyAllError(MomExceptionReply exc) {
    // Create first a copy of the current keys
    // registered into the requests table.
    Integer[] requestIds;
    synchronized (requestsTable) {
      Set keySet = requestsTable.keySet();
      requestIds = new Integer[keySet.size()];
      keySet.toArray(requestIds);
    }
    for (int i = 0; i < requestIds.length; i++) {
      ReplyListener rl = (ReplyListener) requestsTable.get(requestIds[i]);
      // The listener may be null because the table
      // may have been modified meanwhile.
      if (rl != null) {
      	rl.errorReceived(requestIds[i].intValue(), exc);
      }
    }
    
    // completionListeners
    synchronized (completionListeners) {
      Set keySet = completionListeners.keySet();
      requestIds = new Integer[keySet.size()];
      keySet.toArray(requestIds);
    }
    for (int i = 0; i < requestIds.length; i++) {
      CompletionListener cl = completionListeners.get(requestIds[i]);
      if (cl != null)
        cl.onException(new Exception(exc.getMessage()));
    }
    completionListeners.clear();
    requestsTable.clear();
  }
