public void init(FactoryParameters params, 
                   Identity identity,
                   boolean reconnect) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "ReliableTcpClient.init(" + params + ',' + identity + ',' + reconnect + ')');

    this.params = params;
    this.reconnect = reconnect;
    if (params.cnxPendingTimer > 0)
      this.reconnectTimeout =  Math.max(3*params.cnxPendingTimer,
                                        (params.connectingTimer*1000)+(2*params.cnxPendingTimer));
    addresses = new Vector<ServerAddress>();
    key = -1;
    this.identity = identity;

    setStatus(INIT);
  }
