private void ackPendingMessages(long ackId) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "ReliableTcpConnection.ackPendingMessages(" + ackId + ')');
    
    if (!noAckedQueue) {
      synchronized (pendingMessages) {
        while (pendingMessages.size() > 0) {
          TcpMessage pendingMsg = (TcpMessage)pendingMessages.elementAt(0);
          if (ackId < pendingMsg.id) {
            // It's an old acknowledge
            break;
          }

          pendingMessages.removeElementAt(0);
        }
      }
    }
  }
