public void start(BundleContext context) throws Exception {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "Activator.start(" + context + ')');
    
  	joramAdminConnect = new JoramAdminConnect();
  	joramAdminConnect.registerMBean();

  	// register *MSF 
  	destMSF = new DestinationMSF(context);
  	userMSF = new UserMSF(context);
  	cfMSF = new ConnectionFactoryMSF(context);
  	
  	// register Service
  	scf = new ServiceConnectionFactory(context);
  	sq = new ServiceQueue(context);
  	st = new ServiceTopic(context);
  	su = new ServiceUser(context);
  	saq = new ServiceAcquisitionQueue(context);
  	sat = new ServiceAcquisitionTopic(context);
  	sdq = new ServiceDistributionQueue(context);
  	sdt = new ServiceDistributionTopic(context);
  	ssq = new ServiceSchedulerQueue(context);
  	sfq = new ServiceFtpQueue(context);
  	salq = new ServiceAliasQueue(context);
  	sadmin = new ServiceAdmin(context);
  	
  	ClassLoader myClassLoader = getClass().getClassLoader();
  	ClassLoader originalContextClassLoader = Thread.currentThread().getContextClassLoader();
  	try {
  	  Thread.currentThread().setContextClassLoader(myClassLoader);
  	  String adminXmlFile = context.getProperty(ADMIN_XML_PATH);
  	  if (adminXmlFile != null) {
  	    ServiceReference<ObjectFactory> ref = context.getServiceReference(javax.naming.spi.ObjectFactory.class);
  	    if (ref == null) {
  	      if (logmon.isLoggable(BasicLevel.ERROR))
  	        logmon.log(BasicLevel.ERROR, "No ServiceReference for javax.naming.spi.ObjectFactory, start jndi client bundle to use jndi.");
  	    }
  	    AdminModule.executeXMLAdmin(adminXmlFile);
  	  }
  	} finally {
  	  Thread.currentThread().setContextClassLoader(originalContextClassLoader);
  	}
  }
