public static AdminItf getWrapper(BundleContext bundleContext, AdminStruct adminStruct) throws AdminException {
  	if (adminStruct == null) 
  		throw new AdminException("The admin struct is null.");
  	
  	if (logmon.isLoggable(BasicLevel.DEBUG))
  		logmon.log(BasicLevel.DEBUG, "getWrapper(" + adminStruct.wrapperName + ", " + adminStruct.adminHost + ", " + adminStruct.adminPort + ", " + adminStruct.adminUser + ')');
  	AdminWrapperTracker wrapperTracker = wrapperTrackers.get(adminStruct);
  	if (wrapperTracker == null) {
  		try {
	      wrapperTracker = new AdminWrapperTracker(bundleContext, adminStruct.wrapperName, adminStruct.adminHost, adminStruct.adminPort, adminStruct.adminUser);
      } catch (InvalidSyntaxException e) {
      	if (logmon.isLoggable(BasicLevel.WARN))
  	  		logmon.log(BasicLevel.WARN, "getWrapper ", e);
      	throw new AdminException("EXCEPTION:: getWrapper: " + e.getMessage());
      }
      
			wrapperTrackers.put(adminStruct, wrapperTracker);
			if (logmon.isLoggable(BasicLevel.DEBUG))
	  		logmon.log(BasicLevel.DEBUG, "getWrapper wrapperTrackers = " + wrapperTrackers);
		}
  	
  	// return the wrapper
  	try  {
  		return wrapperTracker.getAdminWrapper();
  	} catch (Exception e) {
  		wrapperTrackers.remove(adminStruct);
  		if (logmon.isLoggable(BasicLevel.WARN))
	  		logmon.log(BasicLevel.WARN, "getWrapper ", e);
  		throw new AdminException("The admin wrapper tracker not available.");
		}
  }
