private Context getInitialContext() throws IOException, NamingException {
    if (logmon.isLoggable(BasicLevel.DEBUG)) {
    	logmon.log(BasicLevel.DEBUG, "getInitialContext() - Load jndi.properties file");
    }
    
    Context jndiCtx;
    Properties props = new Properties();
    InputStream in = Class.class.getResourceAsStream("/jndi.properties");
    
    if (in == null) {
      if (logmon.isLoggable(BasicLevel.DEBUG)) {
        logmon.log(BasicLevel.DEBUG, "jndi.properties not found on class loader.");
      }
      in = new FileInputStream("jndi.properties");
    }
    
    props.load(in);
    in.close();
    
    Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
    jndiCtx = new InitialContext(props);
    return jndiCtx;
  }
