public void rebind(String jndiName, Object obj) throws NamingException {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
  		logmon.log(BasicLevel.DEBUG, "bind(" + jndiName + ", " + obj + ')');
  	if (isSet(jndiName)) {
  		Context ctx = null;
  		ClassLoader oldClassLoader = Thread.currentThread().getContextClassLoader();
  		try {
  			try {
  				ctx = getInitialContext();
  				ctx.rebind(jndiName, obj);
  			} catch (Exception e) {
  				if (logmon.isLoggable(BasicLevel.WARN))
  					logmon.log(BasicLevel.WARN, "EXCEPTION:: rebind: " + jndiName, e);
  				throw new NamingException(e.getMessage());
  			}
  		} finally {
  			Thread.currentThread().setContextClassLoader(oldClassLoader);
  			// Closing the JNDI context.
  			try {
  				if (ctx != null)
  					ctx.close();
  			}	catch (Exception exc) {}
  		}
  	}
  }
