public void unbind(String jndiName) {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
  		logmon.log(BasicLevel.DEBUG, "unbind(" + jndiName + ')');
  	if (isSet(jndiName)) {
  		Context ctx = null;
  		ClassLoader oldClassLoader = Thread.currentThread().getContextClassLoader();
  		try {
  			try {
  				ctx = getInitialContext();
  				ctx.unbind(jndiName);
  			} catch (Exception e) {
  				if (logmon.isLoggable(BasicLevel.WARN))
  					logmon.log(BasicLevel.WARN, "EXCEPTION:: unbind: " + jndiName, e);
  			}
  		} finally {
  			Thread.currentThread().setContextClassLoader(oldClassLoader);
  			// Closing the JNDI context.
  			try {
  				if (ctx != null)
  					ctx.close();
  			}	catch (Exception exc) {}
  		}
  	}
  }
