public void updated(final String pid, final Dictionary props)
  throws ConfigurationException {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
  		logmon.log(BasicLevel.DEBUG, "ServiceDistributionQueue.updated(" + pid + ", " + props + ')');

  	try {
  		if (props == null) {
  			deleted(pid);
  			return;
  		}
  		
  		properties = props;
  		
  		String dc = (String) properties.get("distribution.className");
  		 if (dc == null)
  		   properties.put("distribution.className", JMSDistributionQueue.JMSDistribution);
  		 
  		new Thread(new Runnable() {
				public void run() {
					doUpdated(pid, props, className, true);
				}
			}).start();
  		
  	} catch (Exception e) {
  		if (logmon.isLoggable(BasicLevel.ERROR))
	  		logmon.log(BasicLevel.ERROR, "ServiceDistributionQueue.updated ", e);
  		throw new ConfigurationException(null, e.getMessage());
  	}
  }
