public void updated(final String pid, final Dictionary properties)
      throws ConfigurationException {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "ServiceTopic.updated(" + pid + ", " + properties + ')');

    try {
      if (properties == null) {
        deleted(pid);
        return;
      }

      String cn = (String) properties.get("className");
      if (cn != null)
        className = cn;

      new Thread(new Runnable() {
        public void run() {
          doUpdated(pid, properties, className, false);
        }
      }).start();

    } catch (Exception e) {
      if (logmon.isLoggable(BasicLevel.ERROR))
        logmon.log(BasicLevel.ERROR, "ServiceTopic.updated ", e);
      throw new ConfigurationException(null, e.getMessage());
    }
  }
