public void doUpdated(String pid, Dictionary properties) {
  	if (logmon.isLoggable(BasicLevel.DEBUG))
  		logmon.log(BasicLevel.DEBUG, "doUpdated(" + pid + ", " + properties + ')');

  	try {
  		User user = users.get(pid);

  		String wrapperName = (String) properties.get(ADMIN_WRAPPER);
  		String adminHost = (String) properties.get(ADMIN_HOST);
  		String adminPort = (String) properties.get(ADMIN_PORT);
  		String adminUser = (String) properties.get(ADMIN_USERNAME);
  		AdminItf wrapper = AdminWrapperHelper.getWrapper(bundleContext, new AdminStruct(wrapperName, adminHost, adminPort, adminUser));

  		if (user == null) {
  			String name = (String) properties.get(NAME);
  			if (!isSet(name)) 
  				name = "anonymous";

  			String password = (String) properties.get(PASSWORD);
  			if (!isSet(password)) 
  				password = "anonymous";

  			int sid = 0;
  			String serverId = (String) properties.get(SERVERID);
  			if (isSet(serverId)) {
  				sid = new Integer(serverId).intValue();
  			} else {
  				if (logmon.isLoggable(BasicLevel.DEBUG))
  					logmon.log(BasicLevel.DEBUG, "doUpdated serverId not set used 0");
  			}

  			String identityClassName = (String) properties.get(IDENTITYCLASS);
  			if (!isSet(identityClassName)) {
  				identityClassName = SimpleIdentity.class.getName();
  			}

  			Properties props = new Properties();
  			Enumeration keys = properties.keys();
  			while (keys.hasMoreElements()) {
  				String key = (String) keys.nextElement();
  				// TODO: remove unused properties
  				Object value = properties.get(key);
  				if (value instanceof String)
  				  props.setProperty(key, (String) value);
  			}
  			//create the user
  			user = wrapper.createUser(name, password, sid, identityClassName, props);
  			// add user to the users Map
  			users.put(pid, user);
  		}

  		String threshold = (String) properties.get(THRESHOLD);
  		String subName = (String) properties.get(SUBNAME);
  		if (isSet(threshold)) {
  			int th = new Integer(threshold).intValue();
  			if (isSet(subName))
  				user.setThreshold(subName, th);
  			else
  				user.setThreshold(th);
  		}

  		String nbMaxMsg = (String) properties.get(NB_MAXMSG);
  		if (isSet(subName) && isSet(nbMaxMsg))
  			user.setNbMaxMsg(subName, new Integer(nbMaxMsg).intValue());

  		// bind the user
  		String jndiName = (String) properties.get(JNDINAME);
  		if (isSet(jndiName)) {
  			jndiHelper.rebind(jndiName, user);
  			jndiNames.put(pid, jndiName);
  		}

  		// set the DMQ
  		String dmq = (String) properties.get(DMQ);
  		if (isSet(dmq)) {
  			String dmqSid = (String) properties.get(DMQ_SID);
  			if (!isSet(dmqSid))
  				dmqSid = ""+wrapper.getLocalServerId();
  			setUserDMQ(wrapper, user, dmq, new Integer(dmqSid).intValue());
  		}

  	} catch (Exception e) {
  		if (logmon.isLoggable(BasicLevel.ERROR))
  			logmon.log(BasicLevel.ERROR, "doUpdated ", e);
  	}
  }
