private AdminItf adminConnect(boolean collocated, String user, String pass, String host, int port) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "JoramAdminBeanDefinitionParser.adminConnect(" + collocated + ", " + user + ", " + pass + ", " + host + ", " + port + ')');
    AdminItf wrapper = JoramAdmin.getWrapper();
    if (wrapper != null) return null;

    try {
      org.objectweb.joram.client.jms.ConnectionFactory cf;

      if (collocated)
        cf = LocalConnectionFactory.create();
      else
        cf = TcpConnectionFactory.create(host, port);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "JoramAdmin.adminConnect: cf = " + cf);

      //      if (connectingTimer == 0)
      //        cf.getParameters().connectingTimer = 60;
      //      else
      //        cf.getParameters().connectingTimer = connectingTimer;
      //      cf.setIdentityClassName(identityClass);
      //      cf.setCnxJMXBeanBaseName(jmxRootName+"#"+getName());
      cnx = cf.createConnection(user, pass);
      cnx.start();
     
      wrapper = new org.objectweb.joram.client.jms.admin.JoramAdmin(cnx);
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "adminConnect: wrapper = " + wrapper);
      
      return wrapper;
      
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "JoramAdmin.adminConnect", e);
      throw e;
    }
  }
