protected void doParse(Element element, BeanDefinitionBuilder bean) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "JoramAdminBeanDefinitionParser.doParse(" + element + ", " + bean + ')');
    
    boolean collocated = true;
    
    // this however is an optional property
    String user = element.getAttribute("user");
    if (!StringUtils.hasText(user)) {
      user = "root";
    }
    
    // this however is an optional property
    String pass = element.getAttribute("pass");
    if (!StringUtils.hasText(pass)) {
      pass = "root";
    }

    // this however is an optional property
    String host = element.getAttribute("host");
    if (StringUtils.hasText(host)) {
      collocated = false;
    }

    // this however is an optional property
    String port = element.getAttribute("port");
    if (StringUtils.hasText(port)) {
      collocated = false;
    }
    
    AdminItf wrapper = null;
    try {
      if (collocated)
        wrapper = adminConnect(collocated, user, pass, null, -1);
      else
        wrapper = adminConnect(collocated, user, pass, host, Integer.parseInt(port));
      
      JoramAdmin.setWrapper(wrapper);
      JoramAdmin.setConnection(cnx);
      bean.addPropertyValue("wrapper", wrapper);
      
    } catch (Exception e) {
      // TODO: handle exception
    }
  }
