protected void doParse(Element element, BeanDefinitionBuilder bean) {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "JoramServerBeanDefinitionParser.doParse(" + element + ", " + bean + ')');
    
    // this however is an optional property
    String sid = element.getAttribute("sid");
    if (!StringUtils.hasText(sid)) {
      sid = "0";
    }

    // this however is an optional property
    String pathToConf = element.getAttribute("pathToConf");
    if (!StringUtils.hasText(pathToConf)) {
      pathToConf = ".";
    }

    // this however is an optional property
    String storage = element.getAttribute("storage");
    if (!StringUtils.hasText(storage)) {
      storage = "s"+sid;
    }

    // this however is an optional property
//    String collocated = element.getAttribute("collocated");
//    if (!StringUtils.hasText(collocated)) {
//      collocated ="true";
//    }

    // this however is an optional property
    String persistent = element.getAttribute("persistent");
    if (!StringUtils.hasText(persistent)) {
      persistent = "false";
    }
    
    // this however is an optional property
    String stopServer = element.getAttribute("stopServer");
    if (!StringUtils.hasText(stopServer)) {
      stopServer = "false";
    }
    
    bean.addPropertyValue("stopServer", Boolean.parseBoolean(stopServer));
    

    createAndStart(Short.parseShort(sid), pathToConf, storage, Boolean.parseBoolean(persistent));
  }
