public void create(short sid, String pathToConf, String storage, boolean collocated, boolean persistent) {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "JoramServer.create(" + sid + ", " + pathToConf + ", " + storage + ", " + collocated + ", " + persistent + ')');
    
    System.setProperty(AgentServer.CFG_DIR_PROPERTY, pathToConf);
    System.setProperty(Debug.DEBUG_DIR_PROPERTY, pathToConf);
    if (!persistent)
      System.setProperty("Transaction", "fr.dyade.aaa.util.NullTransaction");
    //<property name="Transaction" value="fr.dyade.aaa.util.NTransaction" />
    
    if (collocated) {
      if (AgentServer.getStatus() == AgentServer.Status.STARTED ||
          AgentServer.getStatus() == AgentServer.Status.STARTING)
        return;

      try {
        AgentServer.init(sid, storage, null);
      } catch (Exception exc) {
        logmon.log(BasicLevel.ERROR, AgentServer.getName() + " initialization failed", exc);
      }

      try {
        String errStr = AgentServer.start();
        if (errStr == null) {
          if (logmon.isLoggable(BasicLevel.INFO))
            logmon.log(BasicLevel.INFO, AgentServer.getName() + " started: " + AgentServer.OKSTRING);
        } else {
          if (logmon.isLoggable(BasicLevel.INFO)) {
            logmon.log(BasicLevel.INFO, AgentServer.getName() + " started: " + AgentServer.ERRORSTRING +
                "\n" + errStr + "\n" + AgentServer.ENDSTRING);
          }
        }
      } catch (Exception exc) {
        logmon.log(BasicLevel.ERROR, AgentServer.getName() + " failed", exc);
      }

    } else{
      //TODO
    }
  }
