protected void doParse(Element element, BeanDefinitionBuilder bean) {
    if (logmon.isLoggable(BasicLevel.DEBUG))
      logmon.log(BasicLevel.DEBUG, "JoramTcpConnectionFactoryBeanDefinitionParser.doParse(" + element + ", " + bean + ')');

    // this however is an optional property
    String host = element.getAttribute("host");
    if (!StringUtils.hasText(host)) {
      bean.addConstructorArgValue("localhost");
    }

    // this however is an optional property
    String port = element.getAttribute("port");
    if (!StringUtils.hasText(host)) {
      bean.addConstructorArgValue(16010);
    }
    
    ConnectionFactory cf = TcpConnectionFactory.create(host, Integer.parseInt(port));
    bean.addPropertyValue("connectionFactory", cf);
  }
