private void createAdminWrapper() throws Exception {
    AdminItf wrapper = JoramAdmin.getWrapper();
    if (wrapper != null) return;

    try {
      ConnectionFactory cf = LocalConnectionFactory.create();

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "createAdminWrapper: cf = " + cf);
      Connection cnx = cf.createConnection("root", "root");
      cnx.start();
     
      wrapper = new org.objectweb.joram.client.jms.admin.JoramAdmin(cnx);
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "createAdminWrapper: wrapper = " + wrapper);
      
      JoramAdmin.setWrapper(wrapper);
      
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "createAdminWrapper", e);
      throw e;
    }
  }
