protected void doParse(Element element, BeanDefinitionBuilder bean) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "JoramTestServerBeanDefinitionParser.doParse(" + element + ", " + bean + ')');
    
    // this however is an optional property
    String sid = element.getAttribute("sid");
    if (!StringUtils.hasText(sid)) {
      sid = "0";
    }
    
    // this however is an optional property
    String port = element.getAttribute("port");
    if (!StringUtils.hasText(port)) {
      port = "16010";
    }
    
    bean.addPropertyValue("stopServer", "true");

    try {
      createAndStart(Short.parseShort(sid), port);
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "JoramTestServerBeanDefinitionParser.doParse", e);
    }
  }
