protected void doParse(Element element, BeanDefinitionBuilder bean) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "JoramUserBeanDefinitionParser.doParse(" + element + ", " + bean + ')');
    
    // this however is an optional property
    String sid = element.getAttribute("sid");
    if (!StringUtils.hasText(sid)) {
      sid = "0";
    }
    
    // this however is an optional property
    String name = element.getAttribute("name");
    if (!StringUtils.hasText(name)) {
      name = "anonymous";
    }
    // this however is an optional property
    String password = element.getAttribute("password");
    if (!StringUtils.hasText(password)) {
      password = "anonymous";
    }
    
    // this however is an optional property
    String deleteOnStop = element.getAttribute("deleteOnStop");
    if (!StringUtils.hasText(deleteOnStop)) {
      deleteOnStop = "false";
    }

    // joram admin: create the user.
    try {
      AdminItf wrapper = JoramAdmin.getWrapper();
      if (wrapper == null) throw new Exception("JoramUserBeanDefinitionParser:: the admin wrapper is null !");
      
      User user = wrapper.createUser(name, password, Integer.parseInt(sid));
      
      bean.addPropertyValue("user", user);
      bean.addPropertyValue("deleteOnStop", Boolean.parseBoolean(deleteOnStop));
      
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "JoramUserBeanDefinitionParser.doParse", e);
    }
  }
