public static void putResponse(AgentId from, long lock, Object response) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "AMQPAgent.putResponse(" + lock + ',' + response + ')');
    if (lockers.containsKey(Long.valueOf(lock))) {
      responses.put(Long.valueOf(lock), response);
      Long locker = lockers.remove(Long.valueOf(lock));
      synchronized (locker) {
        locker.notify();
      }
    } else {
      if (response instanceof Message) {
        Message msg = (Message) response;
        AMQPRequestNot not = new AMQPRequestNot();
        List<Long> list = new ArrayList<Long>();
        list.add(Long.valueOf(msg.queueMsgId));
        not.obj = new Recover(msg.queueName, list);
        Channel.sendTo(from, not);
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "AMQPAgent.putResponse recover queueMsgId = " + msg.queueMsgId);
      } else {
        logger.log(BasicLevel.ERROR, "!!!!!!! TODO recover? response", new Exception());
      }
    }
  }
