public void react(AgentId from, Notification not) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                 "AMQPAgent.react(" + from + ',' + not + ')');

    // set agent no save (this is the default).
    setNoSave();

    if (not instanceof AMQPRequestNot) {
      // AMQP request
      Object obj = ((AMQPRequestNot) not).obj;
      long keyLock = ((AMQPRequestNot) not).keyLock;
      long proxyId = ((AMQPRequestNot) not).proxyId;
      StubAgentIn.processRequest(from, keyLock, proxyId, obj);
    } else if (not instanceof AMQPResponseNot){
      //AMQP response
      Object obj = ((AMQPResponseNot) not).obj;
      long keyLock = ((AMQPResponseNot) not).keyLock;
      StubAgentIn.processResponse(from, keyLock, obj);
    } else if (not instanceof RestartNot) {
      short sid = from.getFrom();
      // clean proxies
      Iterator<Proxy> proxies = Naming.getProxies().iterator();
      while (proxies.hasNext()) {
        Proxy proxy = proxies.next();
        proxy.cleanConsumers(sid);
      }
      // clean queues
      Iterator<Queue> queues = Naming.getQueues().iterator();
      while (queues.hasNext()) {
        Queue queue = queues.next();
        queue.cleanConsumers(sid);
      }
    } else {
      super.react(from, not);
    }
  }
