public synchronized void unbind(String queueName, String routingKey, Map<String, Object> arguments)
      throws NotFoundException {
    Set<String> boundQueues = bindings.get(routingKey);
    if (boundQueues != null) {
      boolean removed = boundQueues.remove(queueName);
      if (!removed) {
        throw new NotFoundException("Unknown routing key '" + routingKey + "' between direct exchange '"
            + name + "' and queue '" + queueName + "'.");
      }
      if (boundQueues.size() == 0) {
        bindings.remove(routingKey);
      }
      if (durable)
        saveExchange();
    } else {
      throw new NotFoundException("Unknown routing key '" + routingKey + "' between direct exchange '" + name
          + "' and queue '" + queueName + "'.");
    }
  }
