public synchronized void unbind(String queueName, String routingKey, Map<String, Object> arguments)
      throws NotFoundException {
    Set<String> boundQueues = bindings.get(arguments);
    if (boundQueues != null) {
      boolean removed = boundQueues.remove(queueName);
      if (!removed) {
        throw new NotFoundException("Unknown headers '" + arguments + "' between headers exchange '" + name
            + "' and queue '" + queueName + "'.");
      }
      if (boundQueues.size() == 0) {
        bindings.remove(arguments);
      }
      if (durable) {
        saveExchange();
      }
    } else {
      throw new NotFoundException("Unknown headers '" + arguments + "' between headers exchange '" + name
          + "' and queue '" + queueName + "'.");
    }
  }
