public static boolean isLocal(String name) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Naming.isLocal(" + name + ')');

    // is name already bind in queues or exchanges ?
    if (exchanges.containsKey(name) || queues.containsKey(name))
      return true;

    String serverName = getServerName(name);
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "server name: " + serverName);

    try {
      if (AgentServer.getServerId() == AgentServer.getServerIdByName(serverName))
        return true;
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Error getting server Id.", e);
    }
    return false;
  }
