public void basicRecover(boolean requeue, int channelNumber) throws TransactionException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.basicRecover(" + requeue + ", " + channelNumber + ')');

    // Recover non-acked messages on the channel
    ChannelContext channelContext = getContext(channelNumber);
    Map<QueueShell, List<Long>> recoverMap = new HashMap<QueueShell, List<Long>>();

    Iterator<Delivery> iter = channelContext.deliveriesToAck.iterator();
    while (iter.hasNext()) {
      Delivery delivery = iter.next();
      if (delivery.waitingCommit) {
        continue;
      }
      List<Long> ackList = recoverMap.get(delivery.queue);
      if (ackList == null) {
        ackList = new ArrayList<Long>();
        recoverMap.put(delivery.queue, ackList);
      }
      ackList.add(Long.valueOf(delivery.queueMsgId));
      iter.remove();
    }

    if (recoverMap.size() > 0 && channelContext.prefetchCount != 0) {
      queueIn.push(new GetDeliveries(null, channelNumber));
    }

    Iterator<QueueShell> iterQueues = recoverMap.keySet().iterator();
    while (iterQueues.hasNext()) {
      QueueShell queue = iterQueues.next();
      if (queue.islocal()) {
        queue.getReference().recoverMessages(recoverMap.get(queue));
      } else {
        StubAgentOut.asyncSend(new Recover(queue.getName(), recoverMap.get(queue)),
            Naming.resolveServerId(queue.getName()));
      }
    }
  }
