public void basicReject(AMQP.Basic.Reject basicReject) throws TransactionException,
      PreconditionFailedException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.basicReject(" + basicReject + ')');
    ChannelContext channelContext = getContext(basicReject.channelNumber);
    Iterator<Delivery> iter = channelContext.deliveriesToAck.iterator();
    while (iter.hasNext()) {
      Delivery delivery = iter.next();
      QueueShell queue = delivery.queue;
      if (delivery.deliveryTag == basicReject.deliveryTag) {
        List<Long> recoverList = new ArrayList<Long>(1);
        recoverList.add(Long.valueOf(delivery.queueMsgId));
        if (basicReject.requeue) {
          // Recover the message to requeue it.
          if (queue.islocal()) {
            queue.getReference().recoverMessages(recoverList);
          } else {
            StubAgentOut.asyncSend(new Recover(queue.getName(), recoverList), Naming.resolveServerId(queue.getName()));
          }
        } else {
          // Ack the message to discard it from the queue.
          if (queue.islocal()) {
            queue.getReference().ackMessages(recoverList);
          } else {
            StubAgentOut.asyncSend(new Ack(queue.getName(), recoverList), Naming.resolveServerId(queue.getName()));
          }
        }
        iter.remove();
        return;
      } else if (delivery.deliveryTag > basicReject.deliveryTag) {
        break;
      }
    }
    throw new PreconditionFailedException("Reject error: invalid tag '" + basicReject.deliveryTag + "'.");
  }
