public void channelClose(int channelNumber) throws AMQPException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.channelClose(" + channelNumber + ")");

    // Close consumers on the channel
    ChannelContext channelContext = channelContexts.get(Integer.valueOf(channelNumber));
    if (channelContext != null) {
      Set<Map.Entry<String, QueueShell>> entrySet = channelContext.consumerQueues.entrySet();
      for (Iterator<Map.Entry<String, QueueShell>> iterator = entrySet.iterator(); iterator.hasNext();) {
        try {
          Map.Entry<String, QueueShell> entry = iterator.next();
          iterator.remove();
          doCancel(entry.getKey(), channelNumber, entry.getValue());
        } catch (ResourceLockedException exc) {
          // Can't happen.
        }
      }

      if (channelContext.transacted) {
        txRollback(channelNumber);
      }
    }

    // Recover all non-acked messages
    basicRecover(true, channelNumber);

    channelContexts.remove(Integer.valueOf(channelNumber));
  }
