public synchronized void cleanConsumers(short sid) throws AMQPException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.cleanConsumers(" + sid + ')');
    Set<Integer> channelsIds = channelContexts.keySet();
    for (Iterator<Integer> iterator = channelsIds.iterator(); iterator.hasNext();) {
      Integer channel = iterator.next();
      int channelNumber = channel.intValue();
      ChannelContext channelContext = channelContexts.get(channel);
      if (channelContext.consumerQueues != null) {
        Collection<QueueShell> queueShells = channelContext.consumerQueues.values();
        Iterator<QueueShell> it = queueShells.iterator();
        while (it.hasNext()) {
          QueueShell queueShell = it.next();
          if (!queueShell.islocal()) {
            String name = queueShell.getName();
            if (Naming.resolveServerId(name) == sid) {
              //NotFoundException e = new NotFoundException("server " + sid + " restart.");
              InternalErrorException e = new InternalErrorException("server " + sid + " restart.");
              throwException(e, channelNumber, -1, -1);
            }
          }
        }
      }
    }
  }
