private void cleanQueueContext(int channelNumber, QueueShell queueShell) {
    // Clean non-acked deliveries.
    ChannelContext channelContext = getContext(channelNumber);
    Iterator<Delivery> iter = channelContext.deliveriesToAck.iterator();
    while (iter.hasNext()) {
      Delivery delivery = iter.next();
      if (delivery.queue.equals(queueShell)) {
        iter.remove();
      }
    }

    // Remove queue from exclusive list
    exclusiveQueues.remove(queueShell);

    // Remove consumers using this queue
    Iterator<QueueShell> consumerQueueIterator = channelContext.consumerQueues.values().iterator();
    while (consumerQueueIterator.hasNext()) {
      QueueShell consumerQueue = consumerQueueIterator.next();
      if (consumerQueue.equals(queueShell)) {
        consumerQueueIterator.remove();
      }
    }
  }
