public void connectionClose() {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.connectionClose()");

    // Close each remaining channel
    Integer[] channelsIds = channelContexts.keySet().toArray(new Integer[channelContexts.size()]);
    for (int i = 0; i < channelsIds.length; i++) {
      try {
        channelClose(channelsIds[i].intValue());
      } catch (AMQPException exc) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN, "Error while cleaning channel " + channelsIds[i], exc);
      }
    }

    // Delete exclusive queues
    QueueShell[] queueArray = exclusiveQueues.toArray(new QueueShell[exclusiveQueues.size()]);
    for (int i = 0; i < queueArray.length; i++) {
      QueueShell queue = queueArray[i];
      try {
        if (queue.islocal()) {
          queueDelete(new AMQP.Queue.Delete(0, queue.getReference().getName(), false, false, true));
        } else {
          queueDelete(new AMQP.Queue.Delete(0, queue.getName(), false, false, true));
        }
      } catch (AMQPException exc) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN, "Error while cleaning exclusive queue " + queue, exc);
      }
    }
    exclusiveQueues.clear();

    stop();
  }
