private void doCancel(String consumerTag, int channelNumber, QueueShell queueShell)
      throws ResourceLockedException, NotFoundException, PreconditionFailedException, AMQPException {
    if (queueShell.islocal()) {
      Queue queue = queueShell.getReference();
      if (queue != null) {
        queue.cancel(consumerTag, channelNumber, name.serverId, name.proxyId);
        if (queue.getConsumerCount() == 0 && queue.isAutodelete()) {
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "Proxy: no more consumers -> autodelete");
          AMQP.Queue.Delete delete = new AMQP.Queue.Delete(0, queue.getName(), true, false, true);
          delete.channelNumber = channelNumber;
          queueDelete(delete);
        }
      }
    } else {
      Boolean queueAutodeleted = (Boolean) StubAgentOut.syncSend(new Cancel(consumerTag,
          queueShell.getName(), channelNumber), Naming.resolveServerId(queueShell.getName()), name.proxyId);
      if (queueAutodeleted == null || queueAutodeleted.booleanValue()) {
        cleanQueueContext(channelNumber, queueShell);
      }
    }
  }
