private void getDeliveries(GetDeliveries getDeliveries) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.getDeliveries(" + getDeliveries.consumerTag + ')');

    ChannelContext channelContext = channelContexts.get(Integer.valueOf(getDeliveries.channelId));
    if (channelContext == null) {
      // channel has been closed in the meantime
      return;
    }

    int maxMessage = -1;
    if (channelContext.prefetchCount > 0) {
      maxMessage = channelContext.prefetchCount - channelContext.deliveriesToAck.size();
    }
    if (maxMessage == 0) {
      return;
    }
    
    if (getDeliveries.consumerTag != null) {
      QueueShell queueShell = channelContext.consumerQueues.get(getDeliveries.consumerTag);
      if (queueShell != null) {
        Queue queue = queueShell.getReference();
        doGetDeliveries(getDeliveries.consumerTag, getDeliveries.channelId, maxMessage, queue);
      }
    } else {
      String[] tags = channelContext.consumerQueues.keySet().toArray(
          new String[channelContext.consumerQueues.size()]);
      int i = 0;
      while (i < tags.length && maxMessage != 0) {
        String consumerTag = tags[i];
        Queue queue = channelContext.consumerQueues.get(consumerTag).getReference();
        int deliveredCount = doGetDeliveries(consumerTag, getDeliveries.channelId, maxMessage, queue);
        maxMessage -= deliveredCount;
        i++;
      }
    }

  }
