public AMQP.Queue.DeclareOk queueDeclare(AMQP.Queue.Declare queueDeclare) throws NotFoundException,
      ResourceLockedException, AMQPException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.queueDeclare(" + queueDeclare + ')');

    AMQP.Queue.DeclareOk declareOk;
    QueueShell queueShell;

    if (Naming.isLocal(queueDeclare.queue)) {
      declareOk = StubLocal.queueDeclare(queueDeclare.queue, queueDeclare.passive, queueDeclare.durable,
          queueDeclare.autoDelete, queueDeclare.exclusive, name.serverId, name.proxyId);
      queueShell = new QueueShell(Naming.lookupQueue(declareOk.queue));
    } else {
      declareOk = (AMQP.Queue.DeclareOk) StubAgentOut.syncSend(queueDeclare, Naming.resolveServerId(queueDeclare.queue));
      queueShell = new QueueShell(declareOk.queue);
    }
    if (!queueDeclare.passive && queueDeclare.exclusive) {
      exclusiveQueues.add(queueShell);
    }
    ChannelContext context = getContext(queueDeclare.channelNumber);
    context.lastQueueCreated = declareOk.queue;
    return declareOk;
  }
