public AMQP.Queue.DeleteOk queueDelete(AMQP.Queue.Delete queueDelete) throws NotFoundException,
      PreconditionFailedException, ResourceLockedException, AMQPException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.queueDelete(" + queueDelete + ')');
    
    QueueShell queueShell;
    AMQP.Queue.DeleteOk deleteOk;
    if (Naming.isLocal(queueDelete.queue)) {
      queueShell = new QueueShell(Naming.lookupQueue(queueDelete.queue));
      int msgCount = StubLocal.queueDelete(queueDelete.queue, queueDelete.ifUnused, queueDelete.ifEmpty,
          name.serverId, name.proxyId);
      deleteOk = new AMQP.Queue.DeleteOk(msgCount);
    } else {
      queueShell = new QueueShell(queueDelete.queue);
      deleteOk = (AMQP.Queue.DeleteOk) StubAgentOut.syncSend(queueDelete, Naming.resolveServerId(queueDelete.queue));
    }
    cleanQueueContext(queueDelete.channelNumber, queueShell);
    return deleteOk;
  }
