public void send(Deliver deliver, QueueShell queue) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Proxy.send(" + deliver.msgId + ", " + queue + ')');
    // Get the delivery tag.
    ChannelContext channelContext = getContext(deliver.deliver.channelNumber);
    long deliveryTag = channelContext.nextDeliveryTag();
    long queueMsgId = deliver.deliver.deliveryTag;
    deliver.deliver.deliveryTag = deliveryTag;
    if (!deliver.noAck) {
      channelContext.deliveriesToAck.add(new Delivery(deliveryTag, queueMsgId, queue));
    }
    try {
      queueOut.add(deliver);
    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "Proxy.send ERROR", e);
    }
  }
