public void txRollback(int channelNumber) throws PreconditionFailedException {
    ChannelContext channelContext = getContext(channelNumber);
    if (!channelContext.transacted) {
      throw new PreconditionFailedException("Can't rollback a non-transacted channel.");
    }

    channelContext.pubToCommit.clear();
    for (Delivery delivery : channelContext.deliveriesToAck) {
      delivery.waitingCommit = false;
    }
  }
