public synchronized void cancel(String consumerTag, int channelNumber, short serverId, long proxyId)
      throws ResourceLockedException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.cancel()");

    if (exclusive && (this.serverId != serverId || this.proxyId != proxyId)) {
      throw new ResourceLockedException("Can't cancel a consumer on the non-owned exclusive queue '" + name + "'.");
    }
    
    SubscriptionKey subKey = new SubscriptionKey(serverId, proxyId, channelNumber, consumerTag);
    consumers.remove(subKey);
  }
