public synchronized void deleteQueue(String queueName, short serverId, long proxyId)
      throws ResourceLockedException,
      TransactionException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.deleteQueue(" + queueName + ')');

    if (exclusive && (this.serverId != serverId || this.proxyId != proxyId)) {
      throw new ResourceLockedException("Can't delete the non-owned exclusive queue '" + name + "'.");
    }

    if (durable) {
      AgentServer.getTransaction().delete(PREFIX_QUEUE + Naming.getLocalName(queueName));
      deleteAllMessage(toDeliver);
      deleteAllMessage(toAck);
      Iterator<String> iterBoundExchanges = boundExchanges.iterator();
      while (iterBoundExchanges.hasNext()) {
        String exchangeName = iterBoundExchanges.next();
        deleteBoundExchange(exchangeName);
      }
    }
  }
