public synchronized List<Deliver> getDeliveries(String consumerTag, int channelId, int maxMessage,
      short serverId, long proxyId) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.getDeliveries(" + consumerTag + ',' + maxMessage + ')');

    SubscriptionKey subKey = new SubscriptionKey(serverId, proxyId, channelId, consumerTag);
    Subscription sub = consumers.get(subKey);

    if (sub == null || maxMessage == 0) {
      return null;
    }
    List<Deliver> deliveries = new ArrayList<Deliver>();
    if (toDeliver.size() > 0) {
      Iterator<Message> messagesIter = toDeliver.iterator();
      while (messagesIter.hasNext() && (maxMessage < 0 || deliveries.size() < maxMessage)) {
        Message msg = messagesIter.next();
        if (!sub.noAck) {
          toAck.add(msg);
        } else {
          if (durable) {
            deleteMessage(msg.queueMsgId);
          }
        }
        messagesIter.remove();

        AMQP.Basic.Deliver deliver = new AMQP.Basic.Deliver(consumerTag, msg.queueMsgId, msg.redelivered,
            msg.exchange, msg.routingKey);
        deliver.channelNumber = channelId;
        Deliver msgDelivery = new Deliver(deliver, msg.properties, msg.body, msg.queueMsgId, serverId,
            proxyId, name, sub.noAck);

        deliveries.add(msgDelivery);
      }
    }
    return deliveries;
  }
