public static Queue loadQueue(String name) throws IOException, ClassNotFoundException, TransactionException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.loadQueue(" + name + ')');

    Transaction transaction = AgentServer.getTransaction();
    // load Queue
    Queue queue = (Queue) transaction.load(name);
    try {
      Naming.bindQueue(queue.name, queue);
    } catch (AlreadyBoundException exc) {
      // TODO
      exc.printStackTrace();
    }
    
    final String localName = Naming.getLocalName(queue.name);
    // load Messages
    String[] list = transaction.getList(PREFIX_MSG + localName);
    if (list != null) {
      for (int i = 0; i < list.length; i++) {
        Message msg = (Message) transaction.load(list[i]);
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "Queue.loadQueue: msg.queueMsgId = " + msg.queueMsgId + ", name = " + list[i]);
        queue.toDeliver.add(msg);
        queue.msgCounter = msg.queueMsgId + 1;
      }
    }
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.loadQueue: msgCounter = " + queue.msgCounter);

    // load BoundExchanges
    list = transaction.getList(PREFIX_BOUND_EXCHANGE + localName);
    if (list != null) {
      for (int i = 0; i < list.length; i++) {
        String exchangeName = (String) transaction.load(list[i]);
        queue.boundExchanges.add(exchangeName);
      }
    }
    return queue;
  }
