public synchronized Message receive(boolean noAck, short serverId, long proxyId) throws ResourceLockedException, TransactionException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.receive()");

    if (exclusive && (this.serverId != serverId || this.proxyId != proxyId)) {
      throw new ResourceLockedException("Can't get message on the non-owned exclusive queue '" + name + "'.");
    }
    Message msg = null;
    if (toDeliver.size() > 0) {
      msg = toDeliver.first();
      toDeliver.remove(msg);
      if (noAck) {
        if (durable) {
          deleteMessage(msg.queueMsgId);
        }
      } else {
        toAck.add(msg);
      }
      msg.queueSize = toDeliver.size();
    }
    return msg;
  }
