public synchronized void recoverMessages(List<Long> idsToRecover) throws TransactionException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.recoverMessages(" + idsToRecover + ')');

    // Both lists must be sorted
    Iterator<Long> iterIds = idsToRecover.iterator();
    Iterator<Message> iterMsgs = toAck.iterator();
    List<Message> recoveredMsgs = new ArrayList<Message>();
    while (iterIds.hasNext()) {
      long id = iterIds.next().longValue();
      while (iterMsgs.hasNext()) {
        Message msg = iterMsgs.next();
        if (msg.queueMsgId == id) {
          iterMsgs.remove();
          recoveredMsgs.add(msg);
          break;
        }
      }
    }

    iterMsgs = recoveredMsgs.iterator();
    while (iterMsgs.hasNext()) {
      Message msg = iterMsgs.next();
      try {
        msg.redelivered = true;
        publish(msg, false, (short) -1, -1);
      } catch (NoConsumersException exc) {
        // Can't happen with immediate=false
      }
    }
  }
