public static void processResponse(AgentId from, long keyLock, Object response) {   
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "processResponse(" + from + ", " + keyLock + ", " + response + ')');

    if(response instanceof Deliver) {
      ProxyName pxName = new ProxyName(((Deliver) response).serverId, ((Deliver) response).proxyId);
      Proxy proxy = Naming.lookupProxy(pxName);
      if (proxy == null) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "processResponse recover Deliver: queue = " + ((Deliver) response).queueName + ", msgId = " + ((Deliver) response).msgId);
        AMQPRequestNot not = new AMQPRequestNot();
        List<Long> list = new ArrayList<Long>();
        list.add(Long.valueOf(((Deliver) response).msgId));
        not.obj = new Recover(((Deliver) response).queueName, list);
        Channel.sendTo(from, not);
      } else {
        proxy.send((Deliver) response, new QueueShell(((Deliver) response).queueName));
      }
    } else if (response instanceof Returned) {
      ProxyName pxName = new ProxyName(((Returned) response).serverId, ((Returned) response).proxyId);
      Proxy proxy = Naming.lookupProxy(pxName);
      if (proxy == null) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "processResponse nothing to do (Returned).");
      } else {
        proxy.send((Returned) response);
      }
    } else {
      if (keyLock > 0) {
        AMQPAgent.putResponse(from, keyLock, response);
      }
    }
  }
