private static void publishToQueue(PublishToQueue request) throws TransactionException {
    Queue queue = Naming.lookupQueue(request.getQueueName());
    try {
      if (queue != null) {
        queue.publish(request.getMessage(), request.isImmediate(), request.getServerId(), request.getProxyId());
      }
    } catch (NoConsumersException exc) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Immediate Exception: " + exc.getMessage());
      AMQPResponseNot not = new AMQPResponseNot();
      AMQP.Basic.Return returned = new AMQP.Basic.Return(exc.getCode(), exc.getMessage(), request
          .getExchangeName(), request.getRoutingKey());
      returned.channelNumber = request.getChannelNumber();
      not.obj = new Returned(returned, request.getProperties(), request.getBody(), request.getServerId(), request.getProxyId());
      not.keyLock = -1;
      Channel.sendTo(AMQPAgent.getAMQPId(request.getServerId()), not);
    }
  }
