public static Object syncSend(Object request, short serverId, long proxyId) throws AMQPException {
    Long lock = getNextLock();
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "syncSend(" + request + ", " + serverId + ") lock=" + lock);

    synchronized (lock) {
      AMQPAgent.sendRequestTo(request, serverId, proxyId, lock);
      try {
        lock.wait(timeOut);
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "syncSend wakeup lock=" + lock);
      } catch (java.lang.InterruptedException e) {
        // remove the entry.
        AMQPAgent.getResponse(lock);
        throw new InterruptedException(e.getMessage());
      }
    }
    Object response = AMQPAgent.getResponse(lock);
    if (response instanceof AMQPException)
      throw (AMQPException) response;
    return response;
  }
