private static void checkName(String name) throws AccessRefusedException, PreconditionFailedException {
    if (name.startsWith("amq.")) {
      throw new AccessRefusedException(
          "Queue or Exchange names starting with 'amq.' are reserved for pre-declared and standardised queues or exchanges.");
    }
    // The exchange name consists of a non-empty sequence of these characters:
    // letters, digits, hyphen, underscore, period, or colon.
    Matcher m = exchangeNamePattern.matcher(name);
    if (!m.matches()) {
      throw new PreconditionFailedException("Exchange name contains an invalid character: '" + name + "'.");
    }
  }
