public static void queueBind(String queueName, String exchangeName, String routingKey,
      Map<String, Object> arguments, short serverId, long proxyId) throws NotFoundException,
      ResourceLockedException, TransactionException {
    IExchange exchange = Naming.lookupExchange(exchangeName);
    if (exchange == null) {
      throw new NotFoundException("Binding to a non-existent exchange: '" + exchangeName + "'.");
    }
    if (Naming.isLocal(queueName)) {
      Queue queue = Naming.lookupQueue(queueName);
      if (queue == null) {
        throw new NotFoundException("Binding to a non-existent queue: '" + queueName + "'.");
      }
      queue.addBoundExchange(exchangeName, serverId, proxyId);
    } else {
      StubAgentOut.asyncSend(new AddBoundExchange(queueName, exchangeName), Naming.resolveServerId(queueName));
    }
    exchange.bind(queueName, routingKey, arguments);
  }
