public static void queueUnbind(String exchangeName, String queueName, String routingKey,
      Map<String, Object> arguments, short serverId, long proxyId) throws NotFoundException,
      ResourceLockedException {
    IExchange exchange = Naming.lookupExchange(exchangeName);
    if (exchange != null) {
      if (Naming.isLocal(queueName)) {
        Queue queue = Naming.lookupQueue(queueName);
        if (queue != null) {
          queue.removeBoundExchange(exchangeName, serverId, proxyId);
          exchange.unbind(queueName, routingKey, arguments);
        } else {
          throw new NotFoundException("Queue not found for unbinding: '" + queueName + "'.");
        }
      } else {
        StubAgentOut.asyncSend(new RemoveBoundExchange(queueName, exchangeName), Naming.resolveServerId(queueName));
      }
    } else {
      throw new NotFoundException("Exchange not found for unbinding: '" + exchangeName + "'.");
    }
  }
