public synchronized void unbind(String queueName, String routingKey, Map<String, Object> arguments)
      throws NotFoundException {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "TopicExchange.Unbind(" + queueName + "," + routingKey + ")");
    }
    Pattern routingPattern = createPattern(routingKey);
    KeyAndPattern keyAndPattern = new KeyAndPattern(routingKey, routingPattern);
    Set<String> boundQueues = bindings.get(keyAndPattern);
    if (boundQueues != null) {
      boolean removed = boundQueues.remove(queueName);
      if (!removed) {
        throw new NotFoundException("Unknown binding '" + routingKey + "' between topic exchange '" + name
            + "' and queue '" + queueName + "'.");
      }
      if (boundQueues.size() == 0) {
        bindings.remove(keyAndPattern);
      }
      if (durable) {
        saveExchange();
      }
    } else {
      throw new NotFoundException("Unknown binding '" + routingKey + "' between topic exchange '" + name
          + "' and queue '" + queueName + "'.");
    }
  }
