private final Object[] readArray() throws IOException, SyntaxErrorException {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "readArray()");
    }

    long arrayLength = StreamUtil.readIntFrom(in);
    if (arrayLength < 0)
      throw new SyntaxErrorException("Negative array size.");

    InputStream oldIn = in;
    in = new TruncatedInputStream(this.in, arrayLength);

    List<Object> list = new ArrayList<Object>();
    while (in.available() > 0) {
      list.add(readFieldValue());
    }

    in = oldIn;

    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "readArray -> " + list);
    }
    return list.toArray();
  }
