public final Map readTable() throws IOException, SyntaxErrorException {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "readTable()");
    }

    clearBits();
    if (in.available() < 1)
      return null;
    long tableLength = StreamUtil.readUnsignedIntFrom(in);
    if (tableLength < 0)
      throw new SyntaxErrorException("Negative table size.");
    Map table = new HashMap();

    InputStream oldIn = in;
    in = new TruncatedInputStream(this.in, tableLength);
    Object value = null;
    while (in.available() > 0) {
      String name = readShortstr();
      value = readFieldValue();
      if (!table.containsKey(name))
        table.put(name, value);
    }

    in = oldIn;
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "readTable -> " + table);
    }
    return table;
  }
