private long fieldValueSize(Object value) throws UnsupportedEncodingException {
    long size = 1; // field value type
    if (value == null) {
      // 0
    } else if (value instanceof Byte || value instanceof Boolean) {
      size++;
    } else if (value instanceof String) {
      size += shortStrSize((String) value);
    } else if (value instanceof LongString) {
      size += 4;
      size += ((LongString) value).length();
    } else if (value instanceof Integer || value instanceof Float) {
      size += 4;
    } else if (value instanceof Short) {
      size += 2;
    } else if (value instanceof BigDecimal) {
      size += 5;
    } else if (value instanceof Long || value instanceof Date || value instanceof Timestamp
        || value instanceof Double) {
      size += 8;
    } else if (value instanceof Map) {
      size += 4;
      size += tableSize((Map) value);
    } else if (value instanceof Object[]) {
      size += 4;
      size += arraySize((Object[]) value);
    } else {
      throw new IllegalArgumentException("Invalid value in table: " + value.getClass().getName());
    }
    return size;
  }
