public static AbstractMarshallingClass read(AMQPInputStream is) throws IOException, FrameErrorException {
    int classid = is.readShort();
    AbstractMarshallingClass marshallingClass = AMQP.getAmqpClass(classid);

    if (marshallingClass == null) {
      if (logger.isLoggable(BasicLevel.WARN)) {
        logger.log(BasicLevel.WARN, "Unknown class id: " + classid);
      }
      throw new FrameErrorException("Unknown class id: " + classid);
    }

    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "AbstractMarshallingClass.read: " + marshallingClass);
    }

    return marshallingClass;
  }
