public static Frame readFrom(InputStream in) throws IOException, FrameErrorException {
    int type = StreamUtil.readUnsignedByteFrom(in);
    int channel = StreamUtil.readShortFrom(in);
    byte[] payload = StreamUtil.readByteArrayFrom(in);
    int frameEndMarker = StreamUtil.readUnsignedByteFrom(in);

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "type = " + type + ", channel = " + channel + ", payload = " + payload
          + ", frameEndMarker = " + frameEndMarker);
    if (frameEndMarker != AMQP.FRAME_END) {
      throw new FrameErrorException("Bad frame end marker: " + frameEndMarker);
    }
    return new Frame(type, channel, payload);
  }
