public static void writeTo(Frame frame, OutputStream out, int maxBodySize) throws IOException {
    if (maxBodySize == 0 || frame.getPayload() == null) {
      StreamUtil.writeTo((byte) frame.getType(), out);
      StreamUtil.writeTo((short) frame.getChannel(), out);
      if (frame.getPayload() == null) {
        StreamUtil.writeTo(0, out);
      } else {
        StreamUtil.writeTo(frame.getPayload(), out);
      }
      StreamUtil.writeTo((byte) AMQP.FRAME_END, out);
    } else {
      int copied = 0;
      while (copied < frame.getPayload().length) {
        int length = Math.min(frame.getPayload().length - copied, maxBodySize);
        byte[] array = new byte[length];
        System.arraycopy(frame.getPayload(), copied, array, 0, length);
        StreamUtil.writeTo((byte) frame.getType(), out);
        StreamUtil.writeTo((short) frame.getChannel(), out);
        StreamUtil.writeTo(array, out);
        StreamUtil.writeTo((byte) AMQP.FRAME_END, out);
        copied += length;
        out.flush();
      }
    }
  }
