private void insertItem(ScheduleEvent event, ScheduleTask task) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Scheduler.insertItem(" + event + ", " + task + ')');
    
    Date now = new Date();
    ScheduleItem newItem = new ScheduleItem(event, task);

    // finds next scheduling date of event
    newItem.date = event.nextDate(now);

    // checks for an outdated scheduling
    if (newItem.date == null) {
      if (! event.outdatedRestart) return;
      newItem.date = now;
    }

    insertItem(newItem);
  }
