private void insertItem(ScheduleItem newItem) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Scheduler.insertItem(" + newItem + ')');
    
    if (newItem.date == null) return;

    if (items == null) {
      items = newItem;
    } else {
      ScheduleItem prev = null;

      for (ScheduleItem item = items; item != null; item = item.next) {
        if (!newItem.date.after(item.date))
          break;
        prev = item;
      }
      if (prev == null) {
        if (items != null) {
          // cancel Wakeup Timer.
          cancel();
          
          newItem.next = items;
          items.prev = newItem;
        }
        items = newItem;
      } else {
        newItem.next = prev.next;
        newItem.prev = prev;
        prev.next = newItem;
        if (newItem.next != null)
          newItem.next.prev = newItem;
      }
    }
  }
