public void processMessages(ClientMessages cm) {
  	if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "AcquisitionModule.processMessages(" + cm + ')');
  	}
    if (isDaemon || period > 0) {
      // Go to DMQ
      DMQManager dmqManager = new DMQManager(destination.getDMQAgentId(), destination.getId());
      Iterator msgs = cm.getMessages().iterator();
      while (msgs.hasNext()) {
        dmqManager.addDeadMessage((Message) msgs.next(), MessageErrorConstants.NOT_ALLOWED);
      }
      dmqManager.sendToDMQ();
      return;
    }
    Iterator msgs = cm.getMessages().iterator();
    while (msgs.hasNext()) {
      Message msg = (Message) msgs.next();
      // If non-empty, sets the new properties on the handler
      // AcquisitionModule properties are left unchanged, unless we use setProperties admin command.
      if (msg.properties != null) {
        Properties msgProperties = AcquisitionModule.transform(msg.properties);
        ((AcquisitionHandler) acquisitionHandler).setProperties(msgProperties);
      }
      AgentServer.getTimer().schedule(new AcquisitionTask(), 0);
    }
  }
