private void acquisitionNot(AcquisitionNot not) {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "acquisitionNot(" + not + ")");
    }
    // Test if the message has already been received to avoid duplicates
    if (lastMessageId != null && lastMessageId.equals(not.getId())) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Message already received, drop the message " + not);
      if (logmsg.isLoggable(BasicLevel.WARN))
        logmsg.log(BasicLevel.WARN, getName() + ": drops already received message " + not.getId());
      return;
    }
    lastMessageId = not.getId();
    ClientMessages clientMessages = acquisitionModule.acquisitionNot(not, msgCount);
    if (clientMessages != null) {
      msgCount += clientMessages.getMessageCount();
      try {
        addClientMessages(clientMessages, false);
      } catch (AccessException e) {/* never happens */}
    }
  }
