public void react(AgentId from, Notification not) throws Exception {
    try {
      long diff = getAcquiredMsgCount() - acquisitionNotNb;
      if (not instanceof AcquisitionNot) diff -= 1;
      int pending = getPendingMessageCount();

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                   "AcquisitionQueue.react: " + pause + ", " + diff + ", " + pending);

      if (!pause && 
          (((diff_max > 0) && (diff >= diff_max)) || 
           ((pending_max > 0) && (pending >= pending_max)))) {
        if (logger.isLoggable(BasicLevel.INFO))
          logger.log(BasicLevel.INFO, "AcquisitionQueue.react: stopHandler " + diff + '/' + pending);

        stopHandler(properties);
        pause = true;
      } else if (pause && (diff <= diff_min) && (pending <= pending_min)){
        if (logger.isLoggable(BasicLevel.INFO))
          logger.log(BasicLevel.INFO, "AcquisitionQueue.react: startHandler " + diff + '/' + pending);

        startHandler(properties);
        pause = false;
      }
    } catch (Throwable t) {
      logger.log(BasicLevel.ERROR, "AcquisitionQueue: error in react.", t);
    }
    if (not instanceof AcquisitionNot) {
      acquisitionNotNb += 1;
      acquisitionNot((AcquisitionNot) not);
    } else {
      super.react(from, not);
    }
  }
