public void react(AgentId from, Notification not) throws Exception {
    try {
      long diff = getAcquiredMsgCount() - acquisitionNotNb;
      if (not instanceof AcquisitionNot) diff -= 1;
      
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                   getId() + " - AcquisitionTopic.react(" + not + ") -> " + pause + ", " + diff);

      if (!pause && ((diff_max > 0) && (diff >= diff_max))) {
        if (logger.isLoggable(BasicLevel.INFO))
          logger.log(BasicLevel.INFO, "AcquisitionTopic.react: stopHandler " + diff);

        stopHandler(properties);
        pause = true;
      } else if (pause && (diff <= diff_min)) {
        if (logger.isLoggable(BasicLevel.INFO))
          logger.log(BasicLevel.INFO, "AcquisitionTopic.react: startHandler " + diff);

        startHandler(properties);
        pause = false;
      }
    } catch (Throwable t) {
      logger.log(BasicLevel.ERROR, "AcquisitionTopic: error in react.", t);
    }

    if (not instanceof AcquisitionNot) {
      acquisitionNotNb += 1;
      acquisitionNot(from, (AcquisitionNot) not);
    } else {
      super.react(from, not);
    }
  }
