private void doProcess(CreateDestinationRequest request,
                         AgentId replyTo,
                         String msgId) throws UnknownServerException, RequestException {
    if (checkServerId(request.getServerId())) {
      // The destination is local, process the request.

      DestinationDesc destDesc = createDestination(request.getDestinationName(),
                                                   // Not really needed, the administration topic already has administration rights.
                                                   getId(),
                                                   request.getProperties(),
                                                   request.getExpectedType(),
                                                   request.getClassName(),
                                                   request.getClass().getName(),
                                                   strbuf);

      distributeReply(replyTo,
                      msgId,
                      new CreateDestinationReply(destDesc.getId().toString(), 
                                                 destDesc.getName(),
                                                 strbuf.toString()));
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, strbuf.toString());
      strbuf.setLength(0);
    } else {
      // Forward the request to the right AdminTopic agent.
      forward(getDefault((short) request.getServerId()),
              new FwdAdminRequestNot(request, replyTo, msgId));
    }
  }
