private void doProcess(DeleteUser request, AgentId replyTo, String msgId) throws UnknownServerException {
    String name = request.getUserName();
    AgentId proxId = AgentId.fromString(request.getProxId());

    if (checkServerId(proxId.getTo())) {
      // If the user belong to this server, process the request.
      if (usersTable.containsKey(name)) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "Forward delete request to proxy " + proxId);
        forward(proxId, new FwdAdminRequestNot(request, replyTo, msgId, createMessageId()));
      } else {
        String info = strbuf.append("Request [").append(request.getClass().getName())
            .append("], sent to AdminTopic on server [").append(serverId)
            .append("], successful [false]: user [").append(name).append("] does not exist").toString();
        strbuf.setLength(0);
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, info);
        distributeReply(replyTo, msgId, new AdminReply(AdminReply.NAME_UNKNOWN, info));
      }

    } else {
      // Forward the request to the right AdminTopic agent.
      forward(getDefault(proxId.getTo()), new FwdAdminRequestNot(request, replyTo, msgId));
    }
  }
