private void doProcess(GetDMQSettingsRequest request,
                         AgentId replyTo,
                         String msgId) throws UnknownServerException {
    AgentId targetId = AgentId.fromString(request.getDestId());
    
    if (targetId.isNullId()) {
      // Get the default DMQ setting
      if (checkServerId(targetId.getTo())) {
        // Get the default DMQ setting for local server
        String dmqId = null;
        if (Queue.defaultDMQId != null)
          dmqId = Queue.defaultDMQId.toString();
        GetDMQSettingsReply reply = new GetDMQSettingsReply(dmqId, Queue.defaultThreshold);
        distributeReply(replyTo, msgId, reply);
      } else {
        // Forward the request to the right AdminTopic agent.
        forward(getDefault(targetId.getTo()),
                new FwdAdminRequestNot(request, replyTo, msgId));
      }
    } else {
      // Forward the request to the target
      forward(targetId, new FwdAdminRequestNot(request, replyTo, msgId, createMessageId()));
    }
  }
