private void doProcess(GetDestinationsRequest request,
                         AgentId replyTo,
                         String msgId) throws UnknownServerException {
    if (checkServerId(request.getServerId())) {
      Iterator destinations = destinationsTable.values().iterator();
      String[] ids = new String[destinationsTable.size()];
      String[] names = new String[destinationsTable.size()];
      byte[] types = new byte[destinationsTable.size()];
      int i = 0;
      while (destinations.hasNext()) {
        DestinationDesc destDesc = (DestinationDesc) destinations.next();
        ids[i] = destDesc.getId().toString();
        names[i] = destDesc.getName();
        types[i] = destDesc.getType();
        i++;
      }
      GetDestinationsReply reply = new GetDestinationsReply(ids, names, types);
      distributeReply(replyTo, msgId, reply);
    } else {
      // Forward the request to the right AdminTopic agent.
      forward(getDefault((short) request.getServerId()),
              new FwdAdminRequestNot(request, replyTo, msgId));
    }
  }
