private void doProcess(GetRightsRequest request,
                         AgentId replyTo,
                         String msgId) throws UnknownServerException {
    AgentId destId = AgentId.fromString(request.getDest());

    // Be careful, this request must be sent to the AdminTopic of the server where
    // the destination is, because the information about users is handled locally.
    // It the reply is handled by this AdminTopic it is bad !!
    // This issue should disappear with roles based security.
   if (checkServerId(destId.getTo())) {
      // The destination is local, process the request.
      forward(destId, new GetRightsRequestNot(msgId));
      if (replyTo != null) requestsTable.put(msgId, replyTo);
    } else {
      // Forward the request to the right AdminTopic agent.
      forward(getDefault(destId.getTo()),
              new FwdAdminRequestNot(request, replyTo, msgId));
    }
  }
