private void doProcess(SetDMQRequest request, AgentId replyTo, String msgId) throws UnknownServerException {
    AgentId destId = AgentId.fromString(request.getDestId());

    if (destId.isNullId()) {
      // This request ask to set the default DMQ
      if (checkServerId(destId.getTo())) {
        // Set the default DMQ for local server
        Queue.defaultDMQId = null;
        if (request.getDmqId() != null)
          Queue.defaultDMQId = AgentId.fromString(request.getDmqId());

        distributeReply(replyTo, msgId, new AdminReply(true, null));
      } else {
        // Forward the request to the right AdminTopic agent.
        forward(getDefault(destId.getTo()),
                new FwdAdminRequestNot(request, replyTo, msgId));
      }
    } else {
      // Send the request to the destination or User.
      forward(destId, new FwdAdminRequestNot(request, replyTo, msgId, createMessageId()));
    }

  }
