private void doProcess(SetThresholdRequest request,
                         AgentId replyTo,
                         String msgId) throws UnknownServerException {
    AgentId destId = AgentId.fromString(request.getDestId());

    if (destId.isNullId()) {
      // Set the default Threshold
      if (checkServerId(destId.getTo())) {
        // Set the default Threshold for local server
        Queue.defaultThreshold = 0;
        if (request.getThreshold() > 0)
          Queue.defaultThreshold = request.getThreshold();

        distributeReply(replyTo, msgId, new AdminReply(true, null));
      } else {
        // Forward the request to the right AdminTopic agent.
        forward(getDefault(destId.getTo()),
                new FwdAdminRequestNot(request, replyTo, msgId));
      }
    } else {
      // Forward the request to the target.
      forward(destId, new FwdAdminRequestNot(request, replyTo, msgId, createMessageId()));
    }
  }
