private void doProcess(UserAdminRequest request,
                         AgentId replyTo,
                         String requestMsgId) throws UnknownServerException {
    AgentId userId = AgentId.fromString(request.getUserId());
    if (checkServerId(userId.getTo())) {
      // Delegate to the proxy
      forward(userId, new FwdAdminRequestNot(request, replyTo, requestMsgId, createMessageId()));
    } else {
      // Forward the request to the right AdminTopic agent.
      forward(getDefault(userId.getTo()),
              new FwdAdminRequestNot(request, replyTo, requestMsgId, null));
    }
  }
