public void handleAdminRequestNot(AgentId from, FwdAdminRequestNot not) {
		AdminRequest adminRequest = not.getRequest();
		AgentId dest;
		int index;

		//		if (adminRequest instanceof SetRemoteDestination) {
		//			setSave(); // state change, so save.
		//
		//			dest = AgentId.fromString(((SetRemoteDestination) adminRequest).getNewId());
		//			index = destinations.indexOf(dest);
		//			if (index == -1) {
		//				destinations.add(dest);
		//				metrics.add(new Long(0l));
		//				weights.add(new Long(1l));
		//
		//				currentDestination = destinations.size() - 1;
		//				//loadBalancing = false;
		//			} else {
		//				currentDestination = index;
		//			}
		//
		//			replyToTopic(new AdminReply(true, null),
		//			             not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
		//		} else 
		if (adminRequest instanceof AddRemoteDestination) {
			setSave(); // state change, so save.

			dest = AgentId.fromString(((AddRemoteDestination) adminRequest).getNewId());
			if (!destinations.contains(dest)) {
				destinations.add(dest);
				metrics.add(new Long(0l));
				weights.add(5l); // the max weight being 10l
			}
			replyToTopic(new AdminReply(true, null),
					not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
		} else if (adminRequest instanceof DelRemoteDestination) {
			// The AQ should have at least one remote destination
			if (destinations.size() > 1) {
				setSave(); // state change, so save.

				dest = AgentId.fromString(((DelRemoteDestination) adminRequest).getNewId());
				index = destinations.indexOf(dest);

				if (index != -1) {
					destinations.remove(index);
					metrics.remove(index);
					weights.remove(index);

					if (currentDestination > index) {
						currentDestination--;
					} else if (currentDestination == destinations.size()) {
						currentDestination = 0;
					}
				}
				replyToTopic(new AdminReply(true, null),
						not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
			} else {
				replyToTopic(new AdminReply(AdminReply.ILLEGAL_STATE, "Can't remove last destination"),
						not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
			}
		} else if (adminRequest instanceof SendDestinationsWeights) {
			setSave(); // state change, so save.
			
			int[] newWeights = ((SendDestinationsWeights) adminRequest).getWeights();
			String weightStr = "";
			for (int i = 0; i < newWeights.length; i++) {
				weightStr = weightStr + " " + newWeights[i];
				weights.set(i,(long)newWeights[i]);
			}
			
			logger.log(BasicLevel.ERROR,"Received weights:" + weightStr);
			
			replyToTopic(new AdminReply(true, null),
					not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
		} else {
			super.handleAdminRequestNot(from, not);
		}
	}
