public void setProperties(Properties properties, boolean firstTime) throws Exception {
		super.setProperties(properties, firstTime);

		if (logger.isLoggable(BasicLevel.DEBUG)) {
			logger.log(BasicLevel.DEBUG, "AliasInQueue.<init> prop = " + properties);
		}

		if (properties != null && properties.containsKey(REMOTE_AGENT_OPTION)) {
			try {
				String[] agents = properties.getProperty(REMOTE_AGENT_OPTION).split(";");
				
				destinations = new ArrayList<AgentId>();
				oldmetrics = new ArrayList<Long>();
				newmetrics = new ArrayList<Long>();
				metrics = new ArrayList<Long>();
				weights = new ArrayList<Long>();

				for (String str : agents) {
					destinations.add(AgentId.fromString(str));
					oldmetrics.add(new Long(0l));
					newmetrics.add(new Long(0l));
					metrics.add(new Long(0l));
					weights.add(new Long(1l));
				}

			} catch (IllegalArgumentException exc) {
				logger.log(BasicLevel.ERROR,
				           "AliasInQueue: can't parse '" + REMOTE_AGENT_OPTION + " property -> " +
				               properties.getProperty(REMOTE_AGENT_OPTION), exc);
			}
		}

		if (destinations == null) {
			throw new Exception("Remote agent identifier is null or invalid." + " The property '"
					+ REMOTE_AGENT_OPTION + "' of the Alias queue has not been set properly.");
		}
	}
