protected void handleExpiredNot(AgentId from, ExpiredNot not) {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "ExpiredNot received, messages will be queued.");
    }
    Notification expiredNot = not.getExpiredNot();
    if (expiredNot instanceof ClientMessages) {
      nbMsgsDeliverSinceCreation -= ((ClientMessages) expiredNot).getMessageCount();
      // If this is the first expired notification, send a PingNot
      if (messages.size() == 0) {
        if (logger.isLoggable(BasicLevel.DEBUG)) {
          logger.log(BasicLevel.DEBUG, "Send a Ping to know when the foreign destination will be reachable.");
        }
        Channel.sendTo(remoteDestinationID, new PingNot());
      }
      try {
        addClientMessages(((ClientMessages) expiredNot), false);
      } catch (AccessException e) {/* never happens*/}
    } else {
      super.handleExpiredNot(from, not);
    }
  }
