public void setProperties(Properties properties, boolean firstTime) throws Exception {
    super.setProperties(properties, firstTime);

    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "AliasQueue.<init> prop = " + properties);
    }

    remoteDestinationID = null;

    if (properties != null && properties.containsKey(REMOTE_AGENT_OPTION)) {
      try {
        remoteDestinationID = AgentId.fromString(properties.getProperty(REMOTE_AGENT_OPTION));
      } catch (IllegalArgumentException exc) {
        logger.log(BasicLevel.ERROR, "AliasQueue: can't parse '" + REMOTE_AGENT_OPTION + " option.", exc);
      }
    }

    if (remoteDestinationID == null) {
      throw new Exception("Remote agent identifier is null or invalid." + " The property '"
          + REMOTE_AGENT_OPTION + "' of the Alias queue has not been set properly.");
    }
  }
