private void lBMessageHope(AgentId from, LBMessageHope not) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "--- " + this + " ClusterQueue.lBMessageHope(" + from + "," + not + ")");

    clusters.put(from,new Float(not.getRateOfFlow()));

    int hope = not.getNbMsg();

    long current = System.currentTimeMillis();
    // Cleaning the possible expired messages.
    DMQManager dmqManager = cleanPendingMessage(current);
    // If needed, sending the dead messages to the DMQ:
    if (dmqManager != null)
      dmqManager.sendToDMQ();
    
    if ((loadingFactor.getRateOfFlow() < 1) && (getPendingMessageCount() > 0)) {
      int possibleGive = getPendingMessageCount();
      
      // get client messages, hope or possible give.
      ClientMessages cm = null;
      if (possibleGive > hope) {
        cm = getClientMessages(hope, null, true);
      } else {
        cm = getClientMessages(possibleGive, null, true);
      }
      if (cm != null) {
        LBMessageGive msgGive = 
            new LBMessageGive(loadingFactor.validityPeriod, loadingFactor.getRateOfFlow());
        msgGive.setClientMessages(cm);

        // send notification contains ClientMessages.
        forward(from, msgGive);
        sentToCluster += msgGive.getClientMessages().getMessageCount();

        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "--- " + this
                     + " ClusterQueue.lBMessageHope LBMessageHope : nbMsgSend = " + cm.getMessages().size());
      }
    }
  }
