private void addInterceptor(String agentId, String agentName, final Properties prop) throws Exception {
    String error = null;
    String interceptorsClassName = prop.getProperty(AdminCommandConstant.INTERCEPTORS);
    if (interceptorsClassName == null) return;
    
    if (interceptorsProp == null)
      interceptorsProp = new ArrayList<Properties>();
    if (interceptors == null)
      interceptors = new ArrayList<MessageInterceptor>();
    
    if (interceptorsClassName.contains(InterceptorsHelper.INTERCEPTOR_CLASS_NAME_SEPARATOR)) {
      StringTokenizer token = new StringTokenizer(interceptorsClassName, InterceptorsHelper.INTERCEPTOR_CLASS_NAME_SEPARATOR);
      while (token.hasMoreTokens()) {
        String interceptorClassName = token.nextToken();
        Properties iProp = new Properties();
        iProp.setProperty(AdminCommandConstant.INTERCEPTORS, interceptorClassName);
        interceptorsProp.add(iProp);
        try {
          InterceptorsHelper.addInterceptors(agentId, agentName, AdminCommandConstant.INTERCEPTORS, iProp, interceptors);
        } catch(Exception exc) {
          if (logger.isLoggable(BasicLevel.WARN))
            logger.log(BasicLevel.WARN, "addInterceptors", exc);
          StringWriter sw = new StringWriter();
          exc.printStackTrace(new PrintWriter(sw));
          if (error == null)
          error = "(" + interceptorClassName + " exc=" + sw.toString() + ')';
          else 
            error += "(" + interceptorClassName + " exc=" + sw.toString() + ')';
        }
      }
    } else {
      interceptorsProp.add(prop);
      InterceptorsHelper.addInterceptors(agentId, agentName, AdminCommandConstant.INTERCEPTORS, prop, interceptors);
    }
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "addInterceptor interceptors = " + interceptors + ", interceptorsProp = " + interceptorsProp);

    // state change
    setSave();
    
    if (error != null) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, "addInterceptor error = " + error);
      throw new Exception(error);
    }
  }
