protected void clientMessages(AgentId from, ClientMessages not) throws AccessException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Destination.clientMessages(" + from + ',' + not + ')');
    
    if (AgentId.nullId.equals(from)) {
      from = not.getProxyId();
    }
    
    // If sender is not a writer, sending the messages to the DMQ, and
    // throwing an exception:
    if (!isWriter(from)) {
      DMQManager dmqManager = new DMQManager(not.getDMQId(), dmqId, getId());
      Message msg;
      for (Iterator msgs = not.getMessages().iterator(); msgs.hasNext();) {
        msg = (Message) msgs.next();
        nbMsgsSentToDMQSinceCreation++;
        // JORAM-326: Saves the queue to avoid bad counter value at restart.
        if (strictCounters) {
          setSave();
        }
        
        dmqManager.addDeadMessage(msg, MessageErrorConstants.NOT_WRITEABLE);
        handleDeniedMessage(msg.id, AgentId.fromString(msg.replyToId));
      }
      dmqManager.sendToDMQ();
      throw new AccessException("WRITE right not granted");
    }

    doClientMessages(from, not, true);

    // For topic performance we must send reply after process ClientMessage. It results
    // in a best flow-control of sender allowing the handling of forwarded messages before
    // sender freeing.
    
    if (!not.isPersistent() && !not.getAsyncSend() && !not.hasCallback()) {
      forward(from, new SendReplyNot(not.getClientContext(), not.getRequestId()));
    }
  }
