public void decode(Decoder decoder) throws Exception {
    super.decode(decoder);
    deletable = decoder.decodeBoolean();
    adminId = new AgentId((short) 0, (short) 0, 0);
    adminId.decode(decoder);
    freeReading = decoder.decodeBoolean();
    freeWriting = decoder.decodeBoolean();
    int clientsSize = decoder.decodeUnsignedInt();
    clients = new Hashtable<AgentId, Integer>(clientsSize);
    for (int i = 0; i < clientsSize; i++) {
      AgentId key = new AgentId((short) 0, (short) 0, 0);
      key.decode(decoder);
      int value = decoder.decodeUnsignedInt();
      clients.put(key, value);
    }
    boolean isNull = decoder.decodeBoolean();
    if (isNull) {
      dmqId = null;
    } else {
      dmqId = new AgentId((short) 0, (short) 0, 0);
      dmqId.decode(decoder);
    }
    creationDate = decoder.decodeUnsignedLong();
    nbMsgsDeliverSinceCreation = decoder.decodeUnsignedLong();
    nbMsgsSentToDMQSinceCreation = decoder.decodeUnsignedLong();
    period = decoder.decodeUnsignedLong();
    
    isNull = decoder.decodeBoolean();
    if (isNull) {
      interceptorsProp = null;
    } else {
      int size = decoder.decodeUnsignedInt();
      interceptorsProp = new ArrayList<Properties>();
      for (int i = 0; i < size; i++) {
        Properties properties = EncodableHelper.decodeProperties(decoder);
        interceptorsProp.add(properties);
      }
    }
  }
