public void encode(Encoder encoder) throws Exception {
    super.encode(encoder);
    encoder.encodeBoolean(deletable);
    adminId.encode(encoder);
    encoder.encodeBoolean(freeReading);
    encoder.encodeBoolean(freeWriting);
    encoder.encodeUnsignedInt(clients.size());
    Iterator<Entry<AgentId, Integer>> clientIterator = clients.entrySet().iterator();
    while (clientIterator.hasNext()) {
      Entry<AgentId, Integer> client = clientIterator.next();
      client.getKey().encode(encoder);
      encoder.encodeUnsignedInt(client.getValue());
    }
    if (dmqId == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      dmqId.encode(encoder);
    }
    encoder.encodeUnsignedLong(creationDate);
    encoder.encodeUnsignedLong(nbMsgsDeliverSinceCreation);
    encoder.encodeUnsignedLong(nbMsgsSentToDMQSinceCreation);
    encoder.encodeUnsignedLong(period);

    if (interceptorsProp == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      encoder.encodeUnsignedInt(interceptorsProp.size());
      for (Properties properties : interceptorsProp) {
        EncodableHelper.encodeProperties(properties, encoder);
      }
    }
  }
