public int getEncodedSize() throws Exception {
    int encodedSize = super.getEncodedSize();
    encodedSize += BOOLEAN_ENCODED_SIZE;
    encodedSize += adminId.getEncodedSize();
    encodedSize += BOOLEAN_ENCODED_SIZE + BOOLEAN_ENCODED_SIZE + INT_ENCODED_SIZE;
    Iterator<Entry<AgentId, Integer>> clientIterator = clients.entrySet().iterator();
    while (clientIterator.hasNext()) {
      Entry<AgentId, Integer> client = clientIterator.next();
      encodedSize += client.getKey().getEncodedSize();
      encodedSize += INT_ENCODED_SIZE;
    }
    encodedSize += BOOLEAN_ENCODED_SIZE;
    if (dmqId != null) {
      encodedSize += dmqId.getEncodedSize();
    }
    encodedSize += LONG_ENCODED_SIZE * 4;
    
    encodedSize += BOOLEAN_ENCODED_SIZE;
    if (interceptorsProp != null) {
      encodedSize += INT_ENCODED_SIZE;
      for (Properties properties : interceptorsProp) {
        encodedSize += EncodableHelper.getEncodedSize(properties);
      }
    }

    return encodedSize;
  }
