protected final Hashtable getJMXStatistics(String names) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Destination.getJMXStatistics()");

    Hashtable stats = null;

    try {
      if (names != null) {
        StringTokenizer st = new StringTokenizer(names, ",");
        stats = new Hashtable(st.countTokens());
        while (st.hasMoreTokens()) {
          String name = st.nextToken();
          if (isValidJMXAttribute(name)) {
            Object value = MXWrapper.getAttribute(getMBeanName(), name);
            if ((value != null) && StreamUtil.isStreamable(value))
              stats.put(name, value);
          }

        }
      } else {
        List attributes = MXWrapper.getAttributeNames(getMBeanName());
        if (attributes != null) {
          stats = new Hashtable(attributes.size());
          for (int k = 0; k < attributes.size(); k++) {
            String name = (String) attributes.get(k);
            if (isValidJMXAttribute(name)) {
              Object value = MXWrapper.getAttribute(getMBeanName(), name);
              if ((value != null) && StreamUtil.isStreamable(value))
                stats.put(name, value);
            }
          }
        }
      }
    } catch (Exception exc) {
      logger.log(BasicLevel.ERROR, " getAttributes  on " + getMBeanName() + " error.", exc);
    }

    return stats;
  }
