protected void processAdminCommand(AdminCommandRequest request, AgentId replyTo, String requestMsgId) {
  	if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "processAdminCommand(" + request + ", " + replyTo + ", " + requestMsgId + ')');
  	Properties prop = null;
  	Properties replyProp = null;
  	try {
			switch (request.getCommand()) {
			case AdminCommandConstant.CMD_ADD_INTERCEPTORS:
				prop = request.getProp();
				addInterceptor(getDestinationId(), getName(), prop);
				break;
				
			case AdminCommandConstant.CMD_REMOVE_INTERCEPTORS:
				prop = request.getProp();
				String classNames = (String) prop.get(AdminCommandConstant.INTERCEPTORS);
				removeInterceptor(classNames);
				break;
				
			case AdminCommandConstant.CMD_GET_INTERCEPTORS:
			  replyProp = new Properties();
			  if (interceptors == null) {
			    replyProp.put(AdminCommandConstant.INTERCEPTORS, "");
			  } else {
			    replyProp.put(AdminCommandConstant.INTERCEPTORS, InterceptorsHelper.getListInterceptors(interceptors));
			  }
			  break;
			  
			case AdminCommandConstant.CMD_REPLACE_INTERCEPTORS:
				prop = request.getProp();
				if (interceptors == null)
					throw new Exception("interceptors == null.");
				replaceInterceptor(getDestinationId(), getName(), prop);
				break;
				
			case AdminCommandConstant.CMD_SET_PROPERTIES:
				setProperties(request.getProp(), false);
				setSave();
				break;
			case AdminCommandConstant.CMD_START_HANDLER:
				replyProp = processStartHandler(request.getProp());
				break;
			case AdminCommandConstant.CMD_STOP_HANDLER:
				replyProp = processStopHandler(request.getProp());
				break;
			case AdminCommandConstant.CMD_PAUSE:
			  replyProp = processPause(request.getProp());
			  break;
			default:
				throw new Exception("Bad command : \"" + request.getCommand() + "\"");
			}
			// reply
			replyToTopic(new AdminCommandReply(true, AdminCommandConstant.commandNames[request.getCommand()] + " done.", replyProp), replyTo, requestMsgId, requestMsgId);
		} catch (Exception exc) {
			if (logger.isLoggable(BasicLevel.WARN))
				logger.log(BasicLevel.WARN, "", exc);
			replyToTopic(new AdminReply(-1, exc.getMessage()), replyTo, requestMsgId, requestMsgId);
		}
  }
