protected Message processInterceptors(Message msg) {
  	if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "processInterceptors(" + msg + ')');
  	
  	if (interceptors != null && !interceptors.isEmpty()) {
  		Iterator<MessageInterceptor> it = interceptors.iterator();
  		while (it.hasNext()) {
  			MessageInterceptor interceptor = (MessageInterceptor) it.next();
  			if (!interceptor.handle(msg, -1))
  				return null;
  		}
  	}
  	return msg;
  }
