public void react(AgentId from, Notification not) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Destination.react(" + from + ',' + not + ')');

    // set agent no save (this is the default).
    setNoSave();
    
    CallbackNotification callbackNotification = null;

    try {
      if (not instanceof GetRightsRequestNot)
        getRights(from, (GetRightsRequestNot) not);
      else if (not instanceof ClientMessages) {
        ClientMessages clientMessages = (ClientMessages) not;
        callbackNotification = clientMessages;
        clientMessages(from, clientMessages);
      } else if (not instanceof UnknownAgent)
        unknownAgent(from, (UnknownAgent) not);
      else if (not instanceof RequestGroupNot)
        requestGroupNot(from, (RequestGroupNot) not);
      else if (not instanceof DeleteNot) {
        deleteNot(from, (DeleteNot) not);
        if (canBeDeleted()) {
          // A DeleteNot notification is finally processed at the
          // Agent level when its processing went successful in
          // the DestinationItf instance.
          super.react(from, not);
        }
      } else if (not instanceof WakeUpNot) {
        if (logger.isLoggable(BasicLevel.DEBUG)) {
          logger.log(BasicLevel.DEBUG,
                     "wakeupnot received: current task=" + task + " update=" + ((WakeUpNot) not).update);
        }
        setNoSave();
        if (task == null || ((WakeUpNot) not).update) {
          doSetPeriod(getPeriod());
        }
        if (getPeriod() > 0) {
          wakeUpNot((WakeUpNot) not);
        }
      } else if (not instanceof FwdAdminRequestNot) {
        handleAdminRequestNot(from, (FwdAdminRequestNot) not);
      } else if (not instanceof PingNot) {
        Channel.sendTo(from, new PongNot(getStats()));
      } else {
        throw new UnknownNotificationException(not.getClass().getName());
      }
    } catch (MomException exc) {
      // MOM Exceptions are sent to the requester.
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, this + ".react()", exc);
      if (callbackNotification != null) {
        callbackNotification.failed(exc); 
      } 
      AbstractRequestNot req = (AbstractRequestNot) not;
      Channel.sendTo(from, new ExceptionReply(req, exc));
    } catch (UnknownNotificationException exc) {
      super.react(from, not);
    }
  }
