private void replaceInterceptor(String agentId, String agentName, final Properties prop) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "replaceInterceptor(" + agentId + ", " + agentName + ", " + prop + ')');
    
    Boolean ret = InterceptorsHelper.replaceInterceptor(
        agentId, 
        agentName, 
        AdminCommandConstant.INTERCEPTORS_NEW, 
        AdminCommandConstant.INTERCEPTORS_OLD, 
        interceptors, 
        prop);
    
    if (ret) {
      // update the interceptorsProp list
      Iterator<Properties> it = interceptorsProp.iterator();
      while (it.hasNext()) {
        Properties properties = (Properties) it.next();
        if (properties.getProperty(AdminCommandConstant.INTERCEPTORS).equals(prop.getProperty(AdminCommandConstant.INTERCEPTORS_OLD))) {
          int index = interceptorsProp.indexOf(properties);
          Properties newProp = new Properties();
          Set<Entry<Object, Object>> entrys = prop.entrySet();
          Iterator<Entry<Object, Object>> iterator = entrys.iterator();
          while (iterator.hasNext()) {
            Entry<Object, Object> entry = (Entry<Object, Object>) iterator.next();
            if (entry.getKey().equals(AdminCommandConstant.INTERCEPTORS_NEW))
              newProp.put(AdminCommandConstant.INTERCEPTORS, entry.getValue());
            else
              newProp.put(entry.getKey(), entry.getValue());
          }
          interceptorsProp.remove(index);
          interceptorsProp.add(index, newProp);
          // state change
          setSave();
          break;
        }
      }
    }
  }
