public void run() {
		if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "DistributionDaemon run()");
		
		while (running) {
      canStop = true;
      Message msg = null;
      try {
      	if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "DistributionDaemon run: distributeQueue.size() = " + distributeQueue.size());
      	// get the first message
      	msg = (Message) distributeQueue.get(5000L);
      	if (msg == null) continue;
      	
      	if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "DistributionDaemon run: distributeQueue.get() = " + msg.id);
      	
      	// test if this message is deliverable
      	if (isUndeliverable(msg)) {
      		if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "DistributionDaemon run: the message " +  msg.id + " is undeliverable.");
      		// delete the message from the distributeQueue
      		distributeQueue.pop();
      		continue;
      	}
      } catch (InterruptedException exc) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "DistributionDaemon run()", exc);
        return;
      }

      canStop = false;
      // process
      try {
      	// distribute the message
      	distributionHandler.distribute(msg);
      	ackMessage(msg.id);

        // transaction save the ack list
        AgentServer.getTransaction().save(ackQueue.list(), acklistTxName);
        AgentServer.getTransaction().begin();
        AgentServer.getTransaction().commit(true);
      } catch (Exception e) {
      	if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN, "DistributionDaemon run()", e);
      	
      	if (e instanceof EmptyQueueException) {
      		continue;
      	}
      	
      	// Increment the delivery count of failed message
      	incDeliveryCount(msg);
      	
        if (!running) return;

      	canStop = true;
      	// the connection is down, wait a wakeup from DistributionQueue or DistributionTopic.
      	synchronized (this) {
      	  try {
      	    if (logger.isLoggable(BasicLevel.DEBUG))
      	      logger.log(BasicLevel.DEBUG, "DistributionDaemon run: wait.");
      	    wait();
      	    if (logger.isLoggable(BasicLevel.DEBUG))
      	      logger.log(BasicLevel.DEBUG, "DistributionDaemon run: wakeup.");
      	  } catch (InterruptedException e1) {
      	    if (logger.isLoggable(BasicLevel.WARN))
      	      logger.log(BasicLevel.WARN, "DistributionDaemon run wait InterruptedException.");
      	  }
      	}
      }
    }
  }
