public void initialize(boolean firstTime) throws Exception {
    super.initialize(firstTime);

    try {
      String list = (String) AgentServer.getTransaction().load(getAgentId() + "AL");
      
      if (logmsg.isLoggable(BasicLevel.DEBUG))
        logmsg.log(BasicLevel.DEBUG, getName() + ": removes " + list);
      
      if ((list != null) && (list.length() > 0)) {
        String[] ids = list.split(",");
        for (int i=0; i<ids.length; i++) {
          removeAndDeleteMessage(ids[i]);
        }
      }
    } catch (Exception exc) {
      logger.log(BasicLevel.ERROR, "DistributionQueue: error during initialisation.", exc);
    }

    if (distributionModule == null) {
      distributionModule = new DistributionModule(distributionClassName, properties, firstTime);
    }
    if (properties != null)
    	isAsyncDistribution = isAsyncDistribution(properties);
    if (distributionDaemon == null && isAsyncDistribution) {
    	distributionDaemon = new DistributionDaemon(distributionModule.getDistributionHandler(), getAgentId(), getName(), this);
    	distributionDaemon.start();
    }
  }
