@Override
  protected void postProcess(ClientMessages cm) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "DistributionQueue.postProcess(...)");
    super.postProcess(cm);
    
    // Bug fix (JORAM-198): Avoid parallelism access during message serialization (save method).
    // The handling of messages is no longer in pre-process.
    if (isAsyncDistribution) {
      List msgs = cm.getMessages();

      for (Iterator ite = msgs.iterator(); ite.hasNext();) {
        // Bug fix JORAM-232: now counts received messages.
        nbMsgsReceiveSinceCreation++;

        Message msg = (Message) ite.next();

        // a processMessage exception is normal with async mode.
        if (distributionDaemon != null) {
          // use msg.id ?
          distributionDaemon.push(msg);
        } else {
          if (logger.isLoggable(BasicLevel.WARN)) {
            logger.log(BasicLevel.WARN,
                       "DistributionQueue.postProcess: distribution distributionDaemon = null in async mode.");
          }
        }
      }
    }
    
    if (distributionDaemon != null) {
      // Cleans message list using ackList from daemon.
      removeAndDeleteMessages();
    }
  }
