public ClientMessages preProcess(AgentId from, ClientMessages cm) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "DistributionQueue.preProcess(" + from + ", " + cm + ')');

    // This method modifies the counters (Bug fix JORAM-232).
    setSave();

    if (!batchDistribution && messages.size() > 0) {
      // we already have an Exception because messages.size>0
      // so return immediately the new client messages
      return cm;
    }

    if (! isAsyncDistribution) {
      List msgs = cm.getMessages();
      for (Iterator ite = msgs.iterator(); ite.hasNext();) {
        // Bug fix JORAM-232: now counts received messages.
        nbMsgsReceiveSinceCreation++;
        
        Message msg = (Message) ite.next();
        try {
          distributionModule.processMessage(msg);
          nbMsgsDeliverSinceCreation++;
          ite.remove();
        } catch (Exception exc) {
          if (logger.isLoggable(BasicLevel.WARN))
            logger.log(BasicLevel.WARN, "DistributionQueue.preProcess: distribution error.", exc);

          // if we don't do batch distribution, stop on first error
          if (!batchDistribution)
            break;
        }
      }

      if (msgs.size() > 0) {
        return cm;
      }
      return null;
    } else {
      return cm;
    }

  }
