public ClientMessages preProcess(AgentId from, ClientMessages cm) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "DistributionTopic. preProcess(" + from + ", " + cm + ')');

    List msgs = cm.getMessages();
    // This method return null so the counter will not be updated in processMessage method
    nbMsgsReceiveSinceCreation = nbMsgsReceiveSinceCreation + msgs.size();

    DMQManager dmqManager = null;
    for (int i = 0; i < msgs.size(); i++) {
      Message msg = (Message) msgs.get(i);
      try {
        if (isAsyncDistribution) {
          if (distributionDaemon != null) {
            distributionDaemon.push(msg);
          } else {
            throw new Exception("distribution distributionDaemon is null");
          }
        } else {
          distributionModule.processMessage(msg);
          nbMsgsDeliverSinceCreation++;
        }
      } catch (Exception exc) {
        if (logger.isLoggable(BasicLevel.ERROR))
          logger.log(BasicLevel.ERROR, "DistributionTopic: error during distribution.", exc);

        if (dmqManager == null)
          dmqManager = new DMQManager(cm.getDMQId(), getDMQAgentId(), getId());

        nbMsgsSentToDMQSinceCreation++;
        dmqManager.addDeadMessage(msg, MessageErrorConstants.UNDELIVERABLE);
      }
    }
    if (dmqManager != null) {
      dmqManager.sendToDMQ();
    }
    return null;
  }
