public void wakeUpNot(WakeUpNot not) {
  	if (logger.isLoggable(BasicLevel.DEBUG) && !isAsyncDistribution) {
  		logger.log(BasicLevel.DEBUG, "DistributionTopic.wakeUpNot(" + not + ')');
  	}
  	super.wakeUpNot(not);

  	// delete the ackQueue
  	if (distributionDaemon != null) {
      distributionDaemon.cleanAckList();
  	}

  	if (distributionDaemon != null) {
  		synchronized (distributionDaemon) {
  			// wakeup the daemon, because the distributionDaemon can wait 
    		// after a distribution exception
  			distributionDaemon.notify();
  		}
  	}
  }
