private void handleScaleRequest(FwdAdminRequestNot not) {
		ScaleRequest sr = (ScaleRequest) not.getRequest();

		setSave(); // state change, so save.
		String[] param;
		int op = sr.getOperation();
		switch(op) {
		case ScaleRequest.SCALE_OUT:
			/* Add a new topic to the pool.
			   param should be: "agent_id;server;port" */
			param = sr.getParameter().split(";");
			TopicDesc td = new TopicDesc();
			td.id = AgentId.fromString(param[0]);
			td.server = param[1];
			td.port = Integer.parseInt(param[2]);
			pool.add(td);
			break;
		case ScaleRequest.SCALE_IN:
			/* remove last added topic.
			   param is not used. */
			pool.remove(pool.size() - 1);
			subId = subId % pool.size();
			break;
		case ScaleRequest.BALANCE:
			/* Reconnect a given number of subscribers ON THE SAME TOPIC.
			   param should be: "init_topic:topic_index1;number_of_subscribers1;topic_index2;..." */
			param = sr.getParameter().split(":");
			AgentId topic = pool.get(Integer.parseInt(param[0])).id;
			String[] param1 = param[1].split(";");
			ArrayList<Integer> subs = new ArrayList<Integer>();
			ArrayList<Message> msgs = new ArrayList<Message>();
			for (int i = 0; i < param1.length; i += 2) {
				msgs.add(createReconnectionMessage(Integer.parseInt(param1[i])));
				subs.add(Integer.parseInt(param1[i + 1]));
			}
			ReconnectSubscribersNot rsn =
					new ReconnectSubscribersNot(subs, msgs,not);
			//Destination should do the Admin reply.
			Channel.sendTo(topic,rsn);
			return;
		default:
			// Should never happen.
		}

		replyToTopic(new AdminReply(true, null),
				not.getReplyTo(), not.getRequestMsgId(), not.getReplyMsgId());
	}
