private int processGive(int nbMsgGive, Map clusters) {
    int forwarded = 0;

    // select queue in cluster who have a rateOfFlow > 1
    List selected = new ArrayList();
    for (Iterator e = clusters.keySet().iterator(); e.hasNext();) {
      AgentId id = (AgentId) e.next();
      if (((Float) clusters.get(id)).floatValue() >= 1 && !id.equals(clusterQueue.getId()))
        selected.add(id);
    }

    if (selected.size() == 0) return 0;

    int nbGivePerQueue = nbMsgGive / selected.size();
    if (nbGivePerQueue > maxFwdPerQueue) 
      nbGivePerQueue = maxFwdPerQueue;
    LBMessageGive msgGive = new LBMessageGive(validityPeriod, rateOfFlow);

    if (nbGivePerQueue == 0 && nbMsgGive > 0) {
      // send all to the first element of clusterQueue.
      AgentId id = (AgentId) selected.get(0);
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, 
                   "LoadingFactor.processGive nbMsgGive = " + nbMsgGive + ", id = " + id);
      msgGive.setClientMessages(clusterQueue.getClientMessages(nbMsgGive, null, true));
      clusterQueue.forward(id, msgGive);
      forwarded += msgGive.getClientMessages().getMessageCount();
    } else {
      // dispatch to cluster.
      
      // TODO (AF): May be we have to take in account the load of each queue.
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, 
                   "LoadingFactor.processGive givePerQueue = " + nbGivePerQueue + ", selected = " + selected);
      for (Iterator e = selected.iterator(); e.hasNext();) {
        AgentId id = (AgentId) e.next();
        msgGive.setClientMessages(clusterQueue.getClientMessages(nbGivePerQueue, null, true));
        clusterQueue.forward(id, msgGive);
        forwarded += msgGive.getClientMessages().getMessageCount();
      }
    }
    return forwarded;
  }
