public static void getJMXValues(Message message, Vector elements) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "MonitoringHelper.getJMXValues() -> " + elements.size());
    
    for (int i=0; i<elements.size(); i++) {
      MonitoringElement element = (MonitoringElement) elements.elementAt(i);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "MonitoringHelper.getJMXValues() -> " + element.mbean);
      
      try {
        Set mBeans = MXWrapper.queryNames(element.mbean);
        if (mBeans != null) {
          for (Iterator iterator = mBeans.iterator(); iterator.hasNext();) {
            String mBean = (String) iterator.next();
            
            for (int j=0; j<element.attributes.length; j++) {
              try {
                if (element.attributes[j].equals("*")) {
                  List attributes = MXWrapper.getAttributeNames(mBean);
                  if (attributes != null) {
                    for (int k = 0; k < attributes.size(); k++) {
                      setMessageProperty(message, mBean, (String) attributes.get(k));
                    }
                  }
                } else {
                  setMessageProperty(message, mBean, element.attributes[j]);
                }
              } catch (Exception exc) {
                logger.log(BasicLevel.ERROR, " getAttributes  on " + mBean + " error.", exc);
              }
            }
          }
        }
      } catch (Exception exc) {
        logger.log(BasicLevel.ERROR, "Invalid MBean name : " + element.mbean, exc);
      }
    }
  }
