public void encode(Encoder encoder) throws Exception {
    int persistentMessageCount = 0;
    Iterator<Entry<String, QueueDelivery>> iterator = deliveries.entrySet().iterator();
    while (iterator.hasNext()) {
      Entry<String, QueueDelivery> delivery = iterator.next();
      if (delivery.getValue().getMessage() == null) throw new RuntimeException("Null message: " + delivery.getKey());
      if (delivery.getValue().getMessage().isPersistent()) {
        persistentMessageCount++;
      }
    }
    
    encoder.encodeUnsignedInt(persistentMessageCount);
    iterator = deliveries.entrySet().iterator();
    while (iterator.hasNext()) {
      Entry<String, QueueDelivery> delivery = iterator.next();
      if (delivery.getValue().getMessage().isPersistent()) {
        encoder.encodeString(delivery.getKey());
        delivery.getValue().encode(encoder);
      }
    }
  }
