private void acknowledge(String msgId) {
    if (logmsg.isLoggable(BasicLevel.INFO))
      logmsg.log(BasicLevel.INFO, getName() + ": acknowledges message " + msgId);

    QueueDelivery queueDelivery = deliveryTable.remove(msgId);
    if (queueDelivery != null) {
      // The DeliveryTable is saved outside the Queue agent
      /*
      if (queueDelivery.getMessage().isPersistent()) {
        // state change, so save.
        setSave();
      }*/

      queueDelivery.getMessage().delete();

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "Message " + msgId + " acknowledged.");
    } else if ((logger.isLoggable(BasicLevel.WARN) || logmsg.isLoggable(BasicLevel.WARN))) {
      logger.log(BasicLevel.WARN, "Message " + msgId + " not found for acknowledgement.");
      logmsg.log(BasicLevel.WARN, getName() + ": message " + msgId + " not found for acknowledgement.");
    }
  }
