public void addClientMessages(ClientMessages clientMsgs, boolean throwsExceptionOnFullDest) throws AccessException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Queue.addClientMessage(" + clientMsgs + ')');
    
    long currentTime = System.currentTimeMillis();
    long deliveryTime = currentTime;
    if (deliveryDelay > 0)
      deliveryTime += deliveryDelay;

    if (clientMsgs != null) {
      Message msg;
      // Storing each received message:
      for (Iterator msgs = clientMsgs.getMessages().iterator(); msgs.hasNext();) {
        msg = new Message((org.objectweb.joram.shared.messages.Message) msgs.next());
        msg.order = arrivalState.getAndIncrementArrivalCount(msg.isPersistent());
        
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "Queue.addClientMessage() -> " + msg.getId() + ',' + msg.order);

        if ((deliveryTime > currentTime) && (deliveryTime > msg.getDeliveryTime()))
          msg.setDeliveryTime(deliveryTime);;

        if (interceptorsAvailable()) {
        	// get the shared message
        	org.objectweb.joram.shared.messages.Message message = msg.getFullMessage();
        	// set the destination name
        	message.setProperty("JoramDestinationName", getName());
        	// interceptors process
      		org.objectweb.joram.shared.messages.Message m = processInterceptors(message);
      		if (m == null) {
      			// send message to the DMQ
      			DMQManager dmqManager = new DMQManager(dmqId, getId());
            nbMsgsSentToDMQSinceCreation++;
            // JORAM-326: Saves the queue to avoid bad counter value at restart.
            if (strictCounters) setSave();
            dmqManager.addDeadMessage(msg.getFullMessage(), MessageErrorConstants.INTERCEPTORS);
            dmqManager.sendToDMQ();
            // TODO (AF): Is it useful? The message will never be queued.
      			msg.releaseFullMessage();
      			continue;
      		} else {
      			msg = new org.objectweb.joram.mom.messages.Message(m);
      		}
      	}
        
        if (msg.getDeliveryTime() > currentTime) {
          // TODO: We can not set the client context id, fix to -1. Is it a problem?
          addDeliveryTimeMessage(msg, -1, throwsExceptionOnFullDest, false);
        } else {
          // store message
          storeMessage(msg, throwsExceptionOnFullDest);
        }
      }
    }
    // Launching a delivery sequence:
    deliverMessages(0);
  }
