protected DMQManager cleanPendingMessage(long currentTime) {
    DMQManager dmqManager = null;
    
    if (nbExpirations == 0)
      return dmqManager;
    
    // Be careful, browsing the message list is expensive when there are many messages waiting.
    
    int index = 0;
    Message message = null;
    while (index < messages.size()) {
      message = (Message) messages.get(index);
      if (! message.isValid(currentTime)) {
        messages.remove(index);
        nbExpirations -= 1;

        if (dmqManager == null)
          dmqManager = new DMQManager(dmqId, getId());
        nbMsgsSentToDMQSinceCreation++;
        // JORAM-326: Saves the queue to avoid bad counter value at restart.
        if (strictCounters) setSave();
        message.delete();
        dmqManager.addDeadMessage(message.getFullMessage(), MessageErrorConstants.EXPIRED);

        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG,
                     "Removes expired message " + message.getId(), new Exception());
      } else {
        index++;
      }
    }
    return dmqManager;
  }
