protected void doDeleteNot(DeleteNot not) {
    // Building the exception to send to the pending receivers:
    DestinationException exc = new DestinationException("Queue " + getId() + " is deleted.");
    ReceiveRequest rec;
    ExceptionReply excRep;
    // Sending it to the pending receivers:
    cleanWaitingRequest(System.currentTimeMillis());
    for (int i = 0; i < requests.size(); i++) {
      rec = (ReceiveRequest) requests.get(i);

      excRep = new ExceptionReply(rec, exc);
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                   "Requester " + rec.requester + " notified of the queue deletion.");
      forward(rec.requester, excRep);
    }

    if (temporary && (! AgentServer.getBoolean(DestinationConstants.TMPQUEUE_DMQ_ON_DELETE))) {
      logger.log(BasicLevel.INFO, 
                 "Removes temporary queue (" + getName() + ") and deletes " + messages.size() + " remaining messages.");
    } else {
      // Sending the remaining messages to the DMQ, if needed:
      if (! messages.isEmpty()) {
        Message message;
        DMQManager dmqManager = new DMQManager(dmqId, getId());
        while (! messages.isEmpty()) {
          message = (Message) messages.remove(0);
          message.delete();
          nbMsgsSentToDMQSinceCreation++;
          dmqManager.addDeadMessage(message.getFullMessage(), MessageErrorConstants.DELETED_DEST);
        }
        dmqManager.sendToDMQ();
      }
    }

    Message.deleteAll(getMsgTxPrefix().toString());
  }
