protected void doUnknownAgent(UnknownAgent uA) {
    AgentId client = uA.agent;
    Notification not = uA.not;

    // If the notification is not a delivery, doing nothing. 
    if (! (not instanceof QueueMsgReply))
      return;

    String msgId;
    QueueDelivery queueDelivery;
    Message message;
    AgentId consId;
    DMQManager dmqManager = null;
    
    Iterator<Entry<String, QueueDelivery>> iterator = deliveryTable.iterator();
    while (iterator.hasNext()) {
      // Browsing the delivered messages:
      Entry<String, QueueDelivery> entry = iterator.next();

      msgId = entry.getKey();
      queueDelivery = entry.getValue();
      message = queueDelivery.getMessage();

      // Delivered message has been delivered to the deleted client:
      // denying it.
      if (queueDelivery.getConsumerId().equals(client)) {
        iterator.remove();
        message.setRedelivered();

        // The deliveryTable is saved outside the Queue agent
        /*
        // state change, so save.
        setSave();*/
        deliveryTable.remove(msgId);

        // If message considered as undeliverable, adding it to the
        // list of dead messages:
        if (isUndeliverable(message)) {
          message.delete();
          if (dmqManager == null)
            dmqManager = new DMQManager(dmqId, getId());
          nbMsgsSentToDMQSinceCreation++;
          // JORAM-326: Saves the queue to avoid bad counter value at restart.
          if (strictCounters) setSave();
          dmqManager.addDeadMessage(message.getFullMessage(), MessageErrorConstants.UNDELIVERABLE);
        } else {
          try {
            // Else, putting it back into the deliverables list:
            storeMessageHeader(message, false);
          } catch (AccessException e) {/* never happens */  }
        }

        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN,
                     "Message " + message.getId() + " denied.");
      }
    }
    // Sending dead messages to the DMQ, if needed:
    if (dmqManager != null)
      dmqManager.sendToDMQ();

    // Launching a delivery sequence:
    deliverMessages(0);
  }
