protected TopicForwardNot createTopicForward(AgentId destId, ClientMessages messages, boolean fromCluster) {
    TopicForwardNot topicForwardNot = new TopicForwardNot(messages, fromCluster);
    if (destId.getTo() == AgentServer.getServerId()) {
      // Local destination
      // The initial notification may be persistent (e.g. if remote).
      // In that case the forward needs to be persistent too.
      topicForwardNot.setPersistent(messages.isPersistent());
      
      // Pass the callback in any cases (transient or persistent)
      // in order to provide flow control.
      messages.passCallback(topicForwardNot);
    } else {
      // Remote destination
      // The initial notification may be persistent.
      // In that case the forward needs to be persistent too.
      boolean persistent = messages.isPersistent();
      
      if (!persistent) {
        // Check if there is a persistent message to transmit.
        // In that case, the forward needs to be persistent.
        List<Message> msgList = messages.getMessages();
        for (Message msg : msgList) {
          if (msg.persistent) {
            persistent = true;
            break;
          }
        }
      }
      topicForwardNot.setPersistent(persistent);
      
      // Pass the callback in any cases (transient or persistent)
      // in order to provide flow control with the network.
      messages.passCallback(topicForwardNot);
    }
    return topicForwardNot;
  }
