public static CompositeData createCompositeDataSupport(Message msg) throws Exception {
    String[] props = null;

    Properties properties = msg.getHeaderMessage().properties;
    if (properties != null) {
      props = new String[properties.size()];
      int i = 0;
      StringBuffer strbuf = new StringBuffer();
      for (Enumeration e = properties.keys(); e.hasMoreElements();) {
        String key = (String) e.nextElement();
        strbuf.append(key).append('=').append(properties.get(key));
        props[i++] = strbuf.toString();
        strbuf.setLength(0);
      }
    }
    
    String type = "UNKNOWN";
    switch (msg.getType()) {
      case org.objectweb.joram.shared.messages.Message.SIMPLE:
        type="SIMPLE";
        break;
      case org.objectweb.joram.shared.messages.Message.TEXT:
        type="TEXT";
        break;
      case org.objectweb.joram.shared.messages.Message.OBJECT:
        type="OBJECT";
        break;
      case org.objectweb.joram.shared.messages.Message.MAP:
        type="MAP";
        break;
      case org.objectweb.joram.shared.messages.Message.STREAM:
        type="STREAM";
        break;
      case org.objectweb.joram.shared.messages.Message.BYTES:
        type="BYTES";
        break;
      case org.objectweb.joram.shared.messages.Message.ADMIN:
        type="ADMIN";
        break;
      default:
        break;
    }

    CompositeDataSupport cds = new CompositeDataSupport(rowType, itemNames,
                                                        new Object[] {
                                                                      new Long(msg.order),
                                                                      msg.getId(),
                                                                      new Integer(msg.getPriority()),
                                                                      new Long(msg.getTimestamp()),
                                                                      new Long(msg.getExpiration()),
                                                                      props,
                                                                      type
                                                                      });
    return cds;
  }
