public void encode(Encoder encoder) throws Exception {
    super.encode(encoder);
    encoder.encodeBoolean(autoAck);
    encoder.encodeUnsignedLong(expirationTime);
    encoder.encodeUnsignedInt(msgCount);
    if (msgIds == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      encoder.encodeUnsignedInt(msgIds.length);
      for (String msgId : msgIds) {
        encoder.encodeString(msgId);
      }
    }
    if (requester == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      requester.encode(encoder);
    }
    if (selector == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      encoder.encodeString(selector);
    }
    encoder.encodeUnsignedLong(timeOut);
  }
