public void decode(Decoder decoder) throws Exception {
    int activeSubsSize = decoder.decodeUnsignedInt();
    activeSubs = new Vector<String>(activeSubsSize);
    for (int i = 0; i < activeSubsSize; i++) {
      String activeSub = decoder.decodeString();
      activeSubs.add(activeSub);
    }
    int deliveringQueuesSize = decoder.decodeUnsignedInt();
    deliveringQueues = new Hashtable<AgentId, AgentId>(deliveringQueuesSize);
    for (int i = 0; i < deliveringQueuesSize; i++) {
      AgentId key = new AgentId((short) 0, (short) 0, 0);
      key.decode(decoder);
      deliveringQueues.put(key, key);
    }
    id = decoder.decodeUnsignedInt();
    
    int tempDestinationsSize = decoder.decodeUnsignedInt();
    tempDestinations = new Vector<AgentId>(tempDestinationsSize);
    for (int i = 0; i < tempDestinationsSize; i++) {
      AgentId tempDestination = new AgentId((short) 0, (short) 0, 0);
      tempDestination.decode(decoder);
      tempDestinations.add(tempDestination);
    }
    
    boolean isNull = decoder.decodeBoolean();
    if (isNull) {
      transactionsTable = null;
    } else {
      int size = decoder.decodeUnsignedInt();
      transactionsTable = new Hashtable<Xid, XACnxPrepare>(size);
      for (int i = 0; i < size; i++) {
        XACnxPrepare ctx = new XACnxPrepare();
        ctx.decode(decoder);
        Xid xid = new Xid(ctx.getBQ(), ctx.getFI(), ctx.getGTI());
        transactionsTable.put(xid, ctx);
      }
    }
  }
