public void encode(Encoder encoder) throws Exception {
    encoder.encodeUnsignedInt(activeSubs.size());
    for (String activeSub : activeSubs) {
      encoder.encodeString(activeSub);
    }
    encoder.encodeUnsignedInt(deliveringQueues.size());
    Iterator<Entry<AgentId, AgentId>> deliveringQueueIterator = deliveringQueues.entrySet().iterator();
    while (deliveringQueueIterator.hasNext()) {
      Entry<AgentId, AgentId> deliveringQueue = deliveringQueueIterator.next();
      deliveringQueue.getKey().encode(encoder);
      // not useful to encode the value
    }
    encoder.encodeUnsignedInt(id);
    
    encoder.encodeUnsignedInt(tempDestinations.size());
    for (AgentId tempDestination : tempDestinations) {
      tempDestination.encode(encoder);
    }
    
    if (transactionsTable == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      encoder.encodeUnsignedInt(transactionsTable.size());
      Iterator<Entry<Xid, XACnxPrepare>> transactionsIterator = transactionsTable
          .entrySet().iterator();
      while (transactionsIterator.hasNext()) {
        Entry<Xid, XACnxPrepare> context = transactionsIterator.next();
        // Not useful to encode the key as it is in the value
        // context.getKey().encode(encoder);
        context.getValue().encode(encoder);
      }
    }

  }
