public int getEncodedSize() throws Exception {
    int encodedSize = INT_ENCODED_SIZE;
    for (String activeSub : activeSubs) {
      encodedSize += EncodableHelper.getStringEncodedSize(activeSub);
    }
    encodedSize += INT_ENCODED_SIZE;
    Iterator<Entry<AgentId, AgentId>> deliveringQueueIterator = deliveringQueues.entrySet().iterator();
    while (deliveringQueueIterator.hasNext()) {
      Entry<AgentId, AgentId> deliveringQueue = deliveringQueueIterator.next();
      encodedSize += deliveringQueue.getKey().getEncodedSize();
    }
    encodedSize += INT_ENCODED_SIZE;
    encodedSize += INT_ENCODED_SIZE;
    
    for (AgentId tempDestination : tempDestinations) {
      encodedSize += tempDestination.getEncodedSize();
    }
    
    encodedSize += BOOLEAN_ENCODED_SIZE;
    if (transactionsTable != null) {
      encodedSize += INT_ENCODED_SIZE;
      Iterator<Entry<Xid, XACnxPrepare>> transactionsIterator = transactionsTable
          .entrySet().iterator();
      while (transactionsIterator.hasNext()) {
        Entry<Xid, XACnxPrepare> context = transactionsIterator.next();
        // Not useful to encode the key as it is in the value
        // context.getKey().encode(encoder);
        encodedSize += context.getValue().getEncodedSize();
      }
    }
    
    return encodedSize;
  }
