public void decode(Decoder decoder) throws Exception {
    int deliveredIdsSize = decoder.decodeUnsignedInt();
    deliveredIds = new Hashtable<String, String>(deliveredIdsSize);
    for (int i = 0; i < deliveredIdsSize; i++) {
      String key = decoder.decodeString();
      deliveredIds.put(key, key);
    }
    int deniedMsgSize = decoder.decodeUnsignedInt();
    deniedMsgs = new Hashtable<String, Integer>(deniedMsgSize);
    for (int i = 0; i < deniedMsgSize; i++) {
      String key = decoder.decodeString();
      Integer value = decoder.decodeUnsignedInt();
      deniedMsgs.put(key, value);
    }
    boolean isNull = decoder.decodeBoolean();
    if (isNull) {
      dmqId = null;
    } else {
      dmqId = new AgentId((short) 0, (short) 0, 0);
      dmqId.decode(decoder);
    }
    durable = decoder.decodeBoolean();
    
    name = decoder.decodeString();
    
    nbMaxMsg = decoder.decodeUnsignedInt();
    nbMsgsDeliveredSinceCreation = decoder.decodeUnsignedLong();
    nbMsgsSentToDMQSinceCreation = decoder.decodeUnsignedLong();
    
    isNull = decoder.decodeBoolean();
    if (isNull) {
      selector = null;
    } else {
      selector = decoder.decodeString();
    }
    threshold = decoder.decodeUnsignedInt();
    topicId = new AgentId((short) 0, (short) 0, 0);
    topicId.decode(decoder);
    clientID = decoder.decodeNullableString();
  }
