public void encode(Encoder encoder) throws Exception {
    encoder.encodeUnsignedInt(deliveredIds.size());
    Iterator<Entry<String, String>> deliveredIdIterator = deliveredIds.entrySet().iterator();
    while (deliveredIdIterator.hasNext()) {
      Entry<String, String> deliveredId = deliveredIdIterator.next();
      encoder.encodeString(deliveredId.getKey());
      // no need to encode the value
    }
    encoder.encodeUnsignedInt(deniedMsgs.size());
    Iterator<Entry<String, Integer>> deniedMsgIterator = deniedMsgs.entrySet().iterator();
    while (deniedMsgIterator.hasNext()) {
      Entry<String, Integer> deniedMsg = deniedMsgIterator.next();
      encoder.encodeString(deniedMsg.getKey());
      encoder.encodeUnsignedInt(deniedMsg.getValue());
    }
    if (dmqId == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      dmqId.encode(encoder);
    }
    encoder.encodeBoolean(durable);
    
    encoder.encodeString(name);

    encoder.encodeUnsignedInt(nbMaxMsg);
    encoder.encodeUnsignedLong(nbMsgsDeliveredSinceCreation);
    encoder.encodeUnsignedLong(nbMsgsSentToDMQSinceCreation);
    
    if (selector == null) {
      encoder.encodeBoolean(true);
    } else {
      encoder.encodeBoolean(false);
      encoder.encodeString(selector);
    }
    encoder.encodeUnsignedInt(threshold);
    topicId.encode(encoder);
    encoder.encodeNullableString(clientID);
  }
