public int getEncodedSize() throws Exception {
    int encodedSize = INT_ENCODED_SIZE;
    Iterator<Entry<String, String>> deliveredIdIterator = deliveredIds.entrySet().iterator();
    while (deliveredIdIterator.hasNext()) {
      Entry<String, String> deliveredId = deliveredIdIterator.next();
      encodedSize += EncodableHelper.getStringEncodedSize(deliveredId.getKey());
    }
    encodedSize += INT_ENCODED_SIZE;
    Iterator<Entry<String, Integer>> deniedMsgIterator = deniedMsgs.entrySet().iterator();
    while (deniedMsgIterator.hasNext()) {
      Entry<String, Integer> deniedMsg = deniedMsgIterator.next();
      encodedSize += EncodableHelper.getStringEncodedSize(deniedMsg.getKey());
      encodedSize += INT_ENCODED_SIZE;
    }
    encodedSize += BOOLEAN_ENCODED_SIZE;
    if (dmqId != null) {
      encodedSize += dmqId.getEncodedSize();
    }
    encodedSize += BOOLEAN_ENCODED_SIZE;
    
    encodedSize += EncodableHelper.getStringEncodedSize(name);
    encodedSize += INT_ENCODED_SIZE + LONG_ENCODED_SIZE * 2;
    
    encodedSize += BOOLEAN_ENCODED_SIZE;
    if (selector != null) {
      encodedSize += EncodableHelper.getStringEncodedSize(selector);
    }
    encodedSize += INT_ENCODED_SIZE;
    encodedSize += topicId.getEncodedSize();
    encodedSize += EncodableHelper.getNullableStringEncodedSize(clientID);
    return encodedSize;
  }
