void reinitialize(MessageTable messagesTable, List persistedMessages, boolean denyDeliveredMessages) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "ClientSubscription[" + this + "].reinitialize()");
    
    this.messagesTable = messagesTable;
    
    // Browsing the persisted messages.
    Message message;
    String msgId;
    for (Iterator e = persistedMessages.iterator(); e.hasNext();) {
      message = (Message) e.next();
      msgId = message.getId();

      // delivery time message
      if (messageTimeIds.contains(msgId)) {
        if (message.getDeliveryTime() < System.currentTimeMillis()) {
          // delivery time expire
          messageIds.add(msgId, message.isPersistent());
          messageTimeIds.remove(msgId);
        } else {
          // schedule a task
          AgentServer.getTimer().schedule(new TopicDeliveryTimeTask(proxyId, topicId, name, message), new Date(message.getDeliveryTime()));
        }
      }
      
      if (messageIds.contains(msgId) || deliveredIds.containsKey(msgId)) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, " -> contains message " + msgId);
        message.acksCounter++;
        message.durableAcksCounter++;
        
        if (message.acksCounter == 1) {
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, " -> messagesTable.put(" + msgId + ')');
          messagesTable.put(message);
        }
//          if (message.durableAcksCounter == 1) {
        // if (logger.isLoggable(BasicLevel.DEBUG))
        // logger.log(
        //                BasicLevel.DEBUG,
//                " -> save message " + message);
// it's alredy save.
//          message.save(proxyStringId);          
//        }
      }
    }

    if (denyDeliveredMessages) {
      // Denying all previously delivered messages:
      HashSet h = new HashSet(deliveredIds.keySet());
      deny(h.iterator(), false);
      deliveredIds.clear();
    }
  }
