public static final void sendToProxy(AgentId proxyId, int cnxKey,
      AbstractJmsRequest req, Object msg, ConnectionContext ctx) {
    RequestNot rn = new RequestNot(cnxKey, msg);
    if (multiCnxSync
        && (req instanceof ProducerMessages || 
            req instanceof JmsRequestGroup)) {
      MultiCnxSync mcs = ConnectionManager.getMultiCnxSync(proxyId);
      mcs.send(rn);
    } else {
      if (req instanceof ProducerMessages) {
        if (! ((ProducerMessages) req).getAsyncSend()) {
          rn.setCountDownCallback(createCallback(req, ctx));
        }
        flowControl();
      } else if (req instanceof CommitRequest) {
        if (! ((CommitRequest) req).getAsyncSend()) {
          rn.setCountDownCallback(createCallback(req, ctx));
        }
        flowControl();
      }
      
      if (directNotification) {
        if (req instanceof ProducerMessages) {
          ProducerMessages pm = (ProducerMessages) req;
          AgentId destId = AgentId.fromString(req.getTarget());

          if (pm.getAsyncSend()) {
            ClientMessages not = new ClientMessages(cnxKey, pm.getRequestId(),
                pm.getMessages());
            not.setPersistent(false);
            not.setExpiration(0L);
            not.setProxyId(proxyId);
            not.setAsyncSend(true);
            Channel.sendTo(destId, not);
          } else {
            if (destId.getTo() == proxyId.getTo()) {
              ClientMessages not = new ClientMessages(cnxKey,
                  pm.getRequestId(), pm.getMessages());
              not.setPersistent(false);
              not.setExpiration(0L);
              not.setProxyId(proxyId);
              not.setAsyncSend(false);    
              not.setCountDownCallback(createCallback(req, ctx));
              Channel.sendTo(destId, not);
            } else {
              // Remote destination
              // Set a callback too in order to provide flow control
              // with the network.
              rn.setCountDownCallback(createCallback(req, ctx));
              Channel.sendTo(proxyId, rn);
            }
          }
        } else {
          Channel.sendTo(proxyId, rn);
        }
      } else {
        Channel.sendTo(proxyId, rn);
      }
    }
    if ((inFlow != -1) && (req instanceof ProducerMessages)) {
      FlowControl.flowControl();
    }
  }
