protected void cleanPendingMessages(long currentTime) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "UserAgent.cleanPendingMessages(" + messagesTable.size() + ')');

    Message message = null;
    DMQManager dmqManager = null;

    if (dmqManager == null)
      dmqManager = new DMQManager(dmqId, null);
    
    // The table cleaning is delegated to the table itself
    messagesTable.clean(currentTime, dmqManager);

    // If needed, sending the dead messages to the DMQ:
    if (dmqManager != null)
      dmqManager.sendToDMQ();

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "UserAgent.cleanPendingMessages -> " + messagesTable.size());
  }
