private void doReact(AgentId from, ReconnectSubscribersNot not) {
    ClientSubscription sub;
    ConsumerMessages consM;

    String subName = not.getSubName();
    ArrayList<org.objectweb.joram.shared.messages.Message> msgs = not.getMsgs();

    List<Message> messages = new ArrayList<Message>();
    messages.add(new Message(msgs.get(0)));

    if (subName != null) {
      sub = subsTable.get(subName);
      sub.browseNewMessages(messages);
      consM = sub.deliver();
      try {
        setCtx(sub.getContextId());
        if (activeCtx.getActivated()) {
          doReply(consM);
        }
      } catch (StateException e) {
        logger.log(BasicLevel.ERROR, "Error while sending reconnection message..");
      }
    } else {
      // Redirect many subscribers..
      ArrayList<Integer> subs = not.getSubs();
      TopicSubscription tSub = (TopicSubscription) topicsTable.get(from);
      int i = 0;
      int s = subs.get(i);
      // message has already been initialized
      for (Iterator names = tSub.getNames(); names.hasNext();) {
        subName = (String) names.next();
        sub = (ClientSubscription) subsTable.get(subName);
        if (sub != null && sub.getActive() > 0) {
          sub.browseNewMessages(messages);
          consM = sub.deliver();
          try {
            setCtx(sub.getContextId());
            if (activeCtx.getActivated()) {
              doReply(consM);
            }
          } catch (StateException e) {
            logger.log(BasicLevel.ERROR, "Error while sending reconnection message..\n");
          }
        }

        if (--s == 0) {
          if (++i < subs.size()) {
            s = subs.get(i);
            messages.set(0, new Message(msgs.get(i)));
          } else {
            break;
          }
        }
      }
    }

    FwdAdminRequestNot adr = not.getNot();
    if (adr != null) {
      replyToTopic(new AdminReply(true, null),
                   adr.getReplyTo(), adr.getRequestMsgId(), adr.getReplyMsgId());
    }
  }
