private void doReact(CloseConnectionNot not) {
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "CloseConnectionNot: key=" + not.getKey());

    if (connections != null) {
      Integer key = new Integer(not.getKey());
      // The connection may have already been explicitly closed by a CnxCloseRequest.
      if (connections.containsKey(key)) {
        
        try {
          setCtx(not.getKey());
          doReact(not.getKey(), new CnxCloseRequest());
        } catch (StateException exc) {
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "CloseConnectionNot: " + exc.getMessage());
        }

        connections.remove(key);
        
        HeartBeatTask hbt = (HeartBeatTask) heartBeatTasks.remove(key);
        if (hbt != null) hbt.cancel();
      }
      clientIDs.remove(key);
    }
  }
