private void doReact(ConsumerCloseSubRequest req) throws DestinationException {
    // Getting the subscription:
    String subName = req.getTarget();
    ClientSubscription sub = null;
    if (subName != null)
      sub = (ClientSubscription) subsTable.get(subName);

    if (sub == null)
      throw new DestinationException("Can't desactivate non existing subscription: " + subName);

    if (!sharedSubs.containsKey(subName)) {
      // De-activating the subscription:
      activeCtx.removeSubName(subName);
      sub.deactivate(false);
    } else {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "ConsumerCloseSubRequest: SharedCtx remove ctxId = " + activeCtx.getId());
      SharedCtx sharedCtx = sharedSubs.get(subName);
      sharedCtx.remove(activeCtx.getId());
      activeCtx.removeSubName(subName);
      if (sharedCtx.isEmpty()) {
        sub.deactivate(false);
        sharedSubs.remove(subName);
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "ConsumerCloseSubRequest: activCtx remove " + subName);
      }
    }

    // Acknowledging the request:
    doReply(new ServerReply(req));
  }
