private void doReact(ConsumerDenyRequest req) {
    if (req.getQueueMode()) {
      AgentId qId = AgentId.fromString(req.getTarget());
      String id = req.getId();
      DenyRequest denyRequest = new DenyRequest(activeCtxId, req.getRequestId(), id);
      denyRequest.setRedelivered(req.isRedelivered());
      sendNot(qId, denyRequest);

      // Acknowledging the request, unless forbidden:
      if (!req.getDoNotAck())
        sendNot(getId(), new SyncReply(activeCtxId, new ServerReply(req)));
    } else {
      String subName = req.getTarget();
      ClientSubscription sub = (ClientSubscription) subsTable.get(subName);

      if (sub == null)
        return;

      String msgId = req.getId();
      Vector<String> ids = new Vector<String>();
      ids.add(msgId);

      if (getRedeliveryDelay() > 0 && req.isRedelivered()) {
        Message msg = sub.getSubMessage(msgId);
        if (msg != null) {
          msg.setDeliveryTime(System.currentTimeMillis() + (getRedeliveryDelay() *1000L));
          msg.setRedelivered();
          //TODO: msg.setDeliveryCount(deliveryCount);
          sub.scheduleDeliveryTimeMessage(msg);
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "UserAgent.doReact ConsumerDenyRequest: scheduleDeliveryTimeMessage " + msg.getId() + ", reDeliveryDelay = " + getRedeliveryDelay());
        } else {
          sub.deny(ids.iterator(), req.isRedelivered());
        }
      } else {
        sub.deny(ids.iterator(), req.isRedelivered());
      }

      // Launching a delivery sequence:
      ConsumerMessages consM = sub.deliver();
      // Delivering.
      if (consM != null && activeCtx.getActivated())
        doReply(consM);
      else if (consM != null)
        activeCtx.addPendingDelivery(consM);
    }
  }
