private void doReact(RequestNot not) {
    Integer key = new Integer(not.getConnectionKey());
    if (connections != null) {
      ConnectionContext ctx = (ConnectionContext) connections.get(key);
      if (ctx != null) {
        HeartBeatTask heartBeatTask = (HeartBeatTask) heartBeatTasks.get(key);
        if (heartBeatTask != null) {
          heartBeatTask.touch();
        }

        AbstractJmsRequest request = ctx.getRequest(not.getMessage());
        reactToClientRequest(key.intValue(), request, not);

        if (ctx.isClosed()) {
          if (!(request instanceof CnxCloseRequest))
            logger.log(BasicLevel.WARN, "RequestNot on closed context: " + key);

          connections.remove(key);
          HeartBeatTask hbt = (HeartBeatTask) heartBeatTasks.remove(key);
          if (hbt != null) hbt.cancel();
        }
      } else if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, "ConnectionContext not found");
    } else if (logger.isLoggable(BasicLevel.WARN))
      logger.log(BasicLevel.WARN, "No connections");
  }
