private void doReact(SessDenyRequest req) {
    if (req.getQueueMode()) {
      AgentId qId = AgentId.fromString(req.getTarget());
      Vector ids = req.getIds();
      DenyRequest dr = new DenyRequest(activeCtxId, req.getRequestId(), ids);
      if (req.isRedelivered())
        dr.setRedelivered(true);
      sendNot(qId, dr);

      // Acknowledging the request unless forbidden:
      if (!req.getDoNotAck())
        sendNot(getId(), new SyncReply(activeCtxId, new ServerReply(req)));
    } else {
      String subName = req.getTarget();
      ClientSubscription sub = (ClientSubscription) subsTable.get(subName);

      if (sub == null)
        return;

      Iterator<String> denies = new Vector<String>(req.getIds()).iterator();
      while (denies.hasNext()) {
        String msgId = (String) denies.next();
        Message msg = sub.getSubMessage(msgId);

        if (msg != null && getRedeliveryDelay() > 0 && req.isRedelivered()) {
          msg.setDeliveryTime(System.currentTimeMillis() + (getRedeliveryDelay() *1000L));
          msg.setRedelivered();
          //TODO: msg.setDeliveryCount(deliveryCount);
          sub.scheduleDeliveryTimeMessage(msg);
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "UserAgent.doReact SessDenyRequest: scheduleDeliveryTimeMessage " + msg.getId() + ", reDeliveryDelay = " + getRedeliveryDelay());
          req.getIds().remove(msgId);
        }
      }
      
      sub.deny(req.getIds().iterator(), req.isRedelivered());

      // Launching a delivery sequence:
      ConsumerMessages consM = sub.deliver();
      // Delivering.
      if (consM != null && activeCtx.getActivated())
        doReply(consM);
      else if (consM != null)
        activeCtx.addPendingDelivery(consM);
    }
  }
