private void doReact(TopicDeliveryTimeNot not) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "UserAgent.doReact(" + not + ')');

    String subName = not.subName;
    ClientSubscription sub = (ClientSubscription) subsTable.get(subName);
    
    if (sub == null) return;

    Message momMsg = not.msg;
    List<Message> messages = new ArrayList<Message>();
    messages.add(momMsg);
    
    // remove sub.messagesTimeIds.remove()
    sub.removeMessagesTimeIds(momMsg.getId());

    // Browsing the delivered messages.
    sub.browseNewMessages(messages);

    // If the subscription is active, launching a delivery sequence.
    if (sub.getActive() > 0) {
      ConsumerMessages consM = sub.deliver();

      if (consM != null) {
        try {
          int ctxId = sub.getContextId();
          SharedCtx sharedCtx = sharedSubs.get(subName);
          if (sharedCtx != null) {
            if(logger.isLoggable(BasicLevel.DEBUG))
              logger.log(BasicLevel.DEBUG, "Subscription "+ subName + ", sharedCtx = " + sharedCtx);
            int i = 0;
            do {
              // if shared, used the next contextId 
              Iterator<Entry<Integer, Integer>> it = sharedCtx.entrySet().iterator();
              Entry<Integer, Integer> entry = it.next();
              ClientContext ctx = (ClientContext) contexts.get(new Integer(entry.getKey()));
              if (ctx.getActivated()) {
                ctxId = ctx.getId();
                if(logger.isLoggable(BasicLevel.DEBUG))
                  logger.log(BasicLevel.DEBUG, "Subscription "+ subName + ", ctxId = " + ctxId);
                sharedCtx.get(ctxId);//update LRU
                break;
              }
              i++;
            } while (sharedCtx.size() < i);
          }
          setCtx(ctxId);
          if (activeCtx.getActivated())
            doReply(consM);
          else
            activeCtx.addPendingDelivery(consM);
        } catch (StateException pE) {
          // The context is lost: nothing to do.
        }
      }
    } else if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Subscription " + sub + " is not active");

    messagesTable.checkConsumedMemory();
  }
