private void doReact(int key, AddClientIDRequest req) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "AddClientIDRequest  key = " + key + ", clientID = " + req.clientID);

    if (clientIDs.containsValue(req.clientID)) {
      int oldKey = getKeyByValue(clientIDs, req.clientID);
      ConnectionContext oldCtx = (ConnectionContext) connections.get(oldKey);
      HeartBeatTask hbt = (HeartBeatTask) heartBeatTasks.get(oldKey);
      
      if (oldCtx instanceof ReliableConnectionContext && !((ReliableConnectionContext) oldCtx).isActive()) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "doReact AddClientIDRequest: try to connect with the same clientID \"" + req.clientID +
              "\" on inactive context, so close the old context - oldKey=" + oldKey);
        Channel.sendTo(getId(), (Notification) new CloseConnectionNot2(oldKey));
        hbt.cancel();
        clientIDs.remove(oldKey);
        heartBeatTasks.remove(oldKey);
        connections.remove(oldKey);
      } else {
        throw new Exception("clientID \""+ req.clientID + "\" already active.");
      }
    }
    clientIDs.put(new Integer(key), req.clientID);
    
    AddClientIDReply reply = new AddClientIDReply();
    reply.setCorrelationId(req.getRequestId());
    sendToClient(key, reply);
  }
