public void sendToClient(int key, AbstractJmsReply reply) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "UserAgent.sendToClient(" + key + ',' + reply + ')');
    Integer objKey = new Integer(key);
    if (connections != null) {
      ConnectionContext ctx = (ConnectionContext) connections.get(objKey);
      if (ctx != null) {
        // interceptors process...
        if (interceptorsOUT != null && !interceptorsOUT.isEmpty()) {
          if (reply instanceof ConsumerMessages) {
            org.objectweb.joram.shared.messages.Message m = null;
            Vector msgs = ((ConsumerMessages) reply).getMessages();
            Vector newMsgs = new Vector();
            Vector acks = new Vector();
            for (int i = 0; i < msgs.size(); i++) {
      				m = (org.objectweb.joram.shared.messages.Message) msgs.elementAt(i);
              // interceptors iterator
              Iterator<MessageInterceptor> it = interceptorsOUT.iterator();
              while (it.hasNext()) {
                MessageInterceptor interceptor = (MessageInterceptor) it.next();
                // interceptor handle
                if (!interceptor.handle(m, key)) {
                  m = null;
                  break;
                }
              }
              if (m != null) {
                newMsgs.add(m);
              } else {
      					acks.add(((org.objectweb.joram.shared.messages.Message) msgs.elementAt(i)).id);
                // Send the original messages to the user DMQ.
        				sendToDMQ((org.objectweb.joram.shared.messages.Message) msgs.elementAt(i), MessageErrorConstants.INTERCEPTORS);
              }
            }
            if (newMsgs.size() == 0 && !msgs.isEmpty()) {
              // ack messages
      				org.objectweb.joram.shared.messages.Message msg = (org.objectweb.joram.shared.messages.Message) msgs.firstElement(); 
      				sendNot(AgentId.fromString(msg.toId), new AcknowledgeRequest(activeCtxId, reply.getCorrelationId(), acks));
            }
            // update consumer message.
            ((ConsumerMessages) reply).setMessages(newMsgs);
          }
        }
        // push the reply
        ctx.pushReply(reply);
      }
    }
    // else may happen. Drop the reply.
  }
