protected ServerSocket createServerSocket(int port, int backlog, String address) throws Exception {
    ServerSocketFactory serverSocketFactory = createServerSocketFactory();

    SSLServerSocket serverSocket = null;
    try {
      if (address.equals("0.0.0.0")) {
        serverSocket = (SSLServerSocket) serverSocketFactory.createServerSocket(port, backlog);
      } else {
        serverSocket = (SSLServerSocket) serverSocketFactory.createServerSocket(port, backlog, InetAddress.getByName(address));
      }

      // require mutual authentication
      serverSocket.setNeedClientAuth(true);
      // request mutual authentication
      //serverSocket.setWantClientAuth(true);
      String[] cipherTable = getCipherList();
      if (cipherTable != null && cipherTable.length > 0)
        serverSocket.setEnabledCipherSuites(cipherTable);
    } catch (Exception exc) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.ERROR,
                   "TcpProxyService.createServerSocket(" + port + ',' + backlog + ',' + address + ')', exc);
      else
        logger.log(BasicLevel.ERROR,
                   "TcpProxyService.createServerSocket(" + port + ',' + backlog + ',' + address + "): " + exc.getMessage());
      throw exc;
    }

    return serverSocket;
  }
