@Override
  public void activate() {
  	if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "TcpProxyService.activate()");
  	
  	if (activated) {
  	  logger.log(BasicLevel.WARN, "TcpProxyService.activate(): Already active, do nothing.");
  	  return;
  	}
  	
    try {
      if (cnxWithNoAckedQueue && executorService == null) {
        createExecutors();
      }
      
      if (serverSocket == null)
        serverSocket = createServerSocket(port, backlog, address);

      // Note: If there is a failure during socket initialization, an exception is thrown, serverSocket is
      // null and activated is false.
      
      for (int i = 0; i < connectionListeners.length; i++) {
        if (!connectionListeners[i].isRunning())
          connectionListeners[i].start();
      }
      activated = true;
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "TcpProxyService.activated.");
    } catch (Exception exc) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "TcpProxyService.activate()", exc);
    }
  }
