protected ServerSocket createServerSocket(int port, int backlog, String address) throws Exception {
  	if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "TcpProxyService.createServerSocket(" + port + ',' + backlog + ',' + address + ')');
  	
  	ServerSocket serverSocket;
  	try {
  	  // TODO (AF): Use the ServerSocketFactory
  	  if (address.equals("0.0.0.0")) {
  	    serverSocket = new ServerSocket(port, backlog);
  	  } else {
  	    serverSocket = new ServerSocket(port, backlog, InetAddress.getByName(address));
  	  }
  	} catch (Exception exc) {
  	  if (logger.isLoggable(BasicLevel.DEBUG))
  	    logger.log(BasicLevel.ERROR,
  	               "TcpProxyService.createServerSocket(" + port + ',' + backlog + ',' + address + ')', exc);
  	  else
  	    logger.log(BasicLevel.ERROR,
  	               "TcpProxyService.createServerSocket(" + port + ',' + backlog + ',' + address + "): " + exc.getMessage());
  	  throw exc;
  	}
  	
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "TcpProxyService.createServerSocket serverSocket = " + serverSocket);
    
    return serverSocket;
  }
