public void addDeadMessage(Message mess, short reason) {

    if (destDmqId != null) {
      String ERROR_COUNT = "JMS_JORAM_ERRORCOUNT";
      Integer errorCount = (Integer) mess.getProperty(ERROR_COUNT);
      if (errorCount == null) {
        errorCount = new Integer(1);
      } else {
        errorCount = new Integer(errorCount.intValue() + 1);
      }
      String causePropertyName = "JMS_JORAM_ERRORCAUSE_" + errorCount;
      String codePropertyName = "JMS_JORAM_ERRORCODE_" + errorCount;
      mess.setProperty(ERROR_COUNT, errorCount);

      switch (reason) {
      case MessageErrorConstants.EXPIRED:
        mess.setProperty(causePropertyName, "Expired at " + new Date(mess.expiration));
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.EXPIRED));
        break;
      case MessageErrorConstants.NOT_WRITEABLE:
        mess.setProperty(causePropertyName, "Destination is not writable");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.NOT_WRITEABLE));
        break;
      case MessageErrorConstants.UNDELIVERABLE:
        mess.setProperty(causePropertyName, "Undeliverable after " + mess.deliveryCount + " tries");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.UNDELIVERABLE));
        break;
      case MessageErrorConstants.ADMIN_DELETED:
        mess.setProperty(causePropertyName, "Message deleted by an admin");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.ADMIN_DELETED));
        break;
      case MessageErrorConstants.DELETED_DEST:
        mess.setProperty(causePropertyName, "Deleted destination");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.DELETED_DEST));
        break;
      case MessageErrorConstants.QUEUE_FULL:
        mess.setProperty(causePropertyName, "Queue full");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.QUEUE_FULL));
        break;
      case MessageErrorConstants.UNEXPECTED_ERROR:
        mess.setProperty(causePropertyName, "Unexpected error");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.UNEXPECTED_ERROR));
        break;
      case MessageErrorConstants.INTERCEPTORS:
        mess.setProperty(causePropertyName, "Interceptors");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.INTERCEPTORS));
        break;
      case MessageErrorConstants.NOT_ALLOWED:
        mess.setProperty(causePropertyName, "Operation is not allowed");
        mess.setProperty(codePropertyName, new Short(MessageErrorConstants.NOT_ALLOWED));
        break;
      default:
        break;
      }

      if (deadMessages == null) {
        deadMessages = new ClientMessages();
      }
      mess.expiration = 0;
      deadMessages.addMessage(mess);
    }
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, this.getClass().getName() + ", addDeadMessage for dmq: " + destDmqId + ". Msg: " + mess);
  }
