public int clean(long currentTime, DMQManager dmqManager) {
    int res = 0;
    for (Iterator<Message> values = map.values().iterator(); values.hasNext();) {
      Message message = values.next();
      if ((message == null) || message.isValid(currentTime))
        continue;

      values.remove();
      if (message.durableAcksCounter > 0)
        message.delete();

      res++;
      dmqManager.addDeadMessage(message.getFullMessage(), MessageErrorConstants.EXPIRED);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "UserAgent expired message " + message.getId());
    }
    return res;
  }
