public static synchronized void addInterceptors(
	    String agentId, 
	    String agentName, 
	    String interceptorsKey, 
	    Properties prop, 
	    List<MessageInterceptor> interceptors) throws Exception {
	  if (prop != null && interceptors != null) {
	    if (logger.isLoggable(BasicLevel.DEBUG))
	      logger.log(BasicLevel.DEBUG, "addInterceptors(" + prop + ", " + interceptors + ')');
	    String error = null;
	    String interceptorClassName = prop.getProperty(interceptorsKey);
	    try {
	      MessageInterceptor interceptor = (MessageInterceptor)Class.forName(interceptorClassName).newInstance();
	      interceptor.init(agentId, agentName, prop);
	      interceptors.add(interceptor);
	    } catch(Throwable t) {
	      if (logger.isLoggable(BasicLevel.WARN))
	        logger.log(BasicLevel.WARN, "addInterceptors", t);
	      StringWriter sw = new StringWriter();
	      t.printStackTrace(new PrintWriter(sw));
	      error = "(" + interceptorClassName + " exc=" + sw.toString() + ')';
	      throw new Exception(error);
	    }
	  }
	}
