public static synchronized boolean replaceInterceptor(
      String agentId, 
      String agentName, 
      String interceptorKeyNew, 
      String interceptorKeyOld, 
      List<MessageInterceptor> interceptors, 
      Properties prop) throws Exception {
    String newInterceptorClassName = prop.getProperty(interceptorKeyNew);
    String oldInterceptorClassName = prop.getProperty(interceptorKeyOld);
  	if (newInterceptorClassName != null && oldInterceptorClassName != null && interceptors != null) {
  		if (logger.isLoggable(BasicLevel.DEBUG))
  			logger.log(BasicLevel.DEBUG, "replaceInterceptor(" + newInterceptorClassName + ", " + oldInterceptorClassName + ", " + interceptors + ')');
  		try {
  			boolean replaced = false;
  			Iterator<MessageInterceptor> it = interceptors.iterator();
  			while (it.hasNext()) {
  				MessageInterceptor oldMI = (MessageInterceptor) it.next();
  				if (oldInterceptorClassName.equals(oldMI.getClass().getName())) {
  					int index = interceptors.indexOf(oldMI);
  					interceptors.remove(index);
  					MessageInterceptor interceptor = (MessageInterceptor)Class.forName(newInterceptorClassName).newInstance();
  					interceptor.init(agentId, agentName, prop);
  					interceptors.add(index, interceptor);
  					if (logger.isLoggable(BasicLevel.DEBUG))
  						logger.log(BasicLevel.DEBUG, "replaceInterceptor index = " + index);
  					replaced=true;
  					break;
  				}
  			}
  			return replaced;
  		} catch(Throwable t) {
  			if (logger.isLoggable(BasicLevel.WARN))
  				logger.log(BasicLevel.WARN, "replaceInterceptor", t);
  			StringWriter sw = new StringWriter();
  			t.printStackTrace(new PrintWriter(sw));
  			throw new Exception("(" + newInterceptorClassName + " exc=" + sw.toString() + ')');
  		}
  	}
  	return false;
  }
