public static MessageTableFactory newFactory() {
    String factoryClassName = AgentServer
        .getProperty(MESSAGE_TABLE_FACTORY_CLASS);
    if (factoryClassName == null) {
      return new InMemoryMessageTableFactory();
    } else {
      try {
        Class factoryClass = null;
        if (factoryClass == null) {
          factoryClass = (Class) Class.forName(factoryClassName);
        }
        return (MessageTableFactory) factoryClass.newInstance();
      } catch (Exception exc) {
        throw new RuntimeException(exc);
      }
    }
  }
