public synchronized boolean clearQueue(String queueName) throws InterruptedException {
    DestinationDesc queueDesc;
    try {
      queueDesc = AdminTopic.lookupDest(queueName, DestinationConstants.QUEUE_TYPE);
      if(queueDesc==null) return false;
    } catch (RequestException e) {
      return false;
    }
    String reqId = nextReqMsgId();
    ClearQueue req = new ClearQueue(queueDesc.getId().toString());
    FwdAdminRequestNot not =
        new FwdAdminRequestNot(req, getId(), reqId, null);
    sendTo(queueDesc.getId(), not);
    while(!requests.containsKey(reqId))
      wait();
    Message msg = requests.remove(reqId);
    AdminReply reply = (AdminReply) msg.getAdminMessage();
    return reply.succeeded();
  }
