public synchronized boolean createUser(short serverId, String userName, 
      String password, String identityClass, Properties props)
      throws Exception {
    if ((userName == null) || userName.equals(""))
      throw new Exception("User name can not be null or empty");

    //Set identity
    Identity identity = (Identity) (identityClass==null?
        SimpleIdentity.class.newInstance():
        Class.forName(identityClass).newInstance());
    if(password==null)
      identity.setUserName(userName);
    else
      identity.setIdentity(userName, password);
    
    CreateUserRequest req = new CreateUserRequest(identity,serverId,props);
    String reqId = nextReqMsgId();
    FwdAdminRequestNot not = new FwdAdminRequestNot(req,
        getId(),
        reqId,
        null);
    sendTo(AdminTopic.getDefault(), not);
    while(!requests.containsKey(reqId))
      wait();
    Message msg = requests.remove(reqId);
    AdminReply reply = (AdminReply) msg.getAdminMessage();
    return reply.succeeded();        
  }
