public synchronized boolean deleteQueueMessage(String queueName, String msgId) throws InterruptedException {
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteQueueMessage(" + queueName + ", " + msgId + ")" +
          		": Method called");
    
    DestinationDesc queueDesc;
    try {
      queueDesc = AdminTopic.lookupDest(queueName, DestinationConstants.QUEUE_TYPE);
    } catch (RequestException e) {
      return false;
    }
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteQueueMessage(" + queueName + ", " + msgId + ")" +
              ": Queue found="+queueDesc!=null);
    if(queueDesc==null) return false;
    
    String reqId = nextReqMsgId();
    DeleteQueueMessage req =
        new DeleteQueueMessage(queueDesc.getId().toString(), msgId);
    FwdAdminRequestNot not =
        new FwdAdminRequestNot(req, getId(), reqId, null);
    sendTo(queueDesc.getId(), not);
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteQueueMessage(" + queueName + ", " + msgId + ")" +
              ": Request sent to "+queueDesc.getId());
    while(!requests.containsKey(reqId))
      wait();
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteQueueMessage(" + queueName + ", " + msgId + ")" +
              ": Reply received");
    Message msg = requests.remove(reqId);
    AdminReply reply = (AdminReply) msg.getAdminMessage();
    return reply.succeeded();
  }
