public synchronized boolean deleteSubMessage(String userName, String subName, String msgId) throws InterruptedException {
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteSubMessage("+ userName + ", " + subName + ", " + msgId + ")" +
              ": Method called.");
    AgentId userId = AdminTopic.lookupUser(userName);
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteSubMessage("+ userName + ", " + subName + ", " + msgId + ")" +
              ": User found="+userId!=null);
    if(userId==null)
      return false;
    String reqId = nextReqMsgId();
    DeleteSubscriptionMessage req =
        new DeleteSubscriptionMessage(userId.toString(), subName, msgId);
    FwdAdminRequestNot not =
        new FwdAdminRequestNot(req, getId(), reqId, null);
    sendTo(userId, not);
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteSubMessage("+ userName + ", " + subName + ", " + msgId + ")" +
              ": Request sent to "+userId);
    while(!requests.containsKey(reqId))
      wait();
    if(logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,this.toString() 
          + ".deleteSubMessage("+ userName + ", " + subName + ", " + msgId + ")" +
            ": Reply received");
    Message msg = requests.remove(reqId);
    AdminReply reply = (AdminReply) msg.getAdminMessage();
    return reply.succeeded();
  }
