private void checkEncoding(Message msg) throws Exception {
    byte[] bytes = EncodingHelper.encode(msg);

    Message msgDec = (Message) EncodingHelper.decode(
        msg.getEncodableClassId(), bytes);

    Assert.assertEquals(msg.order, msgDec.order);
    Assert.assertEquals(msg.getFullMessage().id, msgDec.getFullMessage().id);
    Assert.assertEquals(msg.getFullMessage().toId, msgDec.getFullMessage().toId);
    Assert.assertEquals(msg.getFullMessage().toName, msgDec.getFullMessage().toName);
    Assert.assertEquals(msg.getFullMessage().toType, msgDec.getFullMessage().toType);
    Assert.assertEquals(msg.getFullMessage().timestamp, msgDec.getFullMessage().timestamp);
    Assert.assertEquals(msg.getFullMessage().compressed, msgDec.getFullMessage().compressed);
    Assert.assertEquals(msg.getFullMessage().deliveryTime, msgDec.getFullMessage().deliveryTime);
    
    Assert.assertEquals(msg.getFullMessage().type, msgDec.getFullMessage().type);
    Assert.assertEquals(msg.getFullMessage().replyToId, msgDec.getFullMessage().replyToId);
    Assert.assertEquals(msg.getFullMessage().replyToName, msgDec.getFullMessage().replyToName);
    Assert.assertEquals(msg.getFullMessage().replyToId, msgDec.getFullMessage().replyToId);
    Assert.assertEquals(msg.getFullMessage().priority, msgDec.getFullMessage().priority);
    Assert.assertEquals(msg.getFullMessage().expiration, msgDec.getFullMessage().expiration);
    Assert.assertEquals(msg.getFullMessage().correlationId, msgDec.getFullMessage().correlationId);
    Assert.assertEquals(msg.getFullMessage().deliveryCount, msgDec.getFullMessage().deliveryCount);
    Assert.assertEquals(msg.getFullMessage().jmsType, msgDec.getFullMessage().jmsType);
    Assert.assertEquals(msg.getFullMessage().redelivered, msgDec.getFullMessage().redelivered);
    Assert.assertEquals(msg.getFullMessage().persistent, msgDec.getFullMessage().persistent);
    
    if (msg.getFullMessage().properties != null) {
      Assert.assertEquals(msg.getFullMessage().properties.size(), msgDec.getFullMessage().properties.size());
      Assert.assertEquals(msg.getFullMessage().properties.get(PROPERTY1), msgDec.getFullMessage().properties.get(PROPERTY1));
      Assert.assertEquals(msg.getFullMessage().properties.get(PROPERTY2), msgDec.getFullMessage().properties.get(PROPERTY2));
      Assert.assertEquals(msg.getFullMessage().properties.get(PROPERTY3), msgDec.getFullMessage().properties.get(PROPERTY3));
      Assert.assertEquals(msg.getFullMessage().properties.get(PROPERTY4), msgDec.getFullMessage().properties.get(PROPERTY4));
    }
    
    if (msg.getFullMessage().body != null) {
      Assert.assertEquals(msg.getFullMessage().body.length, msgDec.getFullMessage().body.length);
    } else {
      Assert.assertEquals(null, msgDec.getFullMessage().body);
    }
    Assert.assertEquals(msg.getFullMessage().clientID, msgDec.getFullMessage().clientID);

  }
