@Test
  public void run() throws Exception {
    EncodingHelper.init();
    
    org.objectweb.joram.shared.messages.Message sharedMsg = new org.objectweb.joram.shared.messages.Message();
    sharedMsg.id = "msgId";
    sharedMsg.toId = "toId";
    sharedMsg.toName = null;
    sharedMsg.toType = 1;
    sharedMsg.timestamp = 17899823;
    sharedMsg.compressed = true;
    sharedMsg.deliveryTime = 100;
    sharedMsg.body = null;
    sharedMsg.clientID = null;
    
    
    Message momMsg = new Message(sharedMsg);
    sharedMsg.toName = "toName"; // null
    sharedMsg.body = new byte[1000];  // null
    sharedMsg.clientID = "clientId"; // null
    momMsg.order = 999;

    checkEncoding(momMsg);
    
    sharedMsg.toName = null;
    sharedMsg.body = null;
    sharedMsg.clientID = null;
    checkEncoding(momMsg);
    
    sharedMsg.type = org.objectweb.joram.shared.messages.Message.TEXT;
    sharedMsg.replyToId = "replyToId";
    sharedMsg.replyToName = "replyToName";
    sharedMsg.replyToType = 1;
    sharedMsg.priority = 10;
    sharedMsg.expiration = 150;
    sharedMsg.correlationId = "correlationId";
    sharedMsg.deliveryCount = 4;
    sharedMsg.jmsType = "jmsType";
    sharedMsg.redelivered = true;
    sharedMsg.persistent = true;
    checkEncoding(momMsg);
    
    Properties properties = new Properties();
    properties.put(PROPERTY1, "propValue1");
    properties.put(PROPERTY2, new Integer(1));
    properties.put(PROPERTY3, new Long(1));
    properties.put(PROPERTY4, Boolean.TRUE);
    sharedMsg.properties = properties;
    checkEncoding(momMsg);
  }
