@Test
  public void run() throws Exception {
    EncodingHelper.init();

    AgentId proxyId = new AgentId((short) 10, (short) 20, 30);
    int contextId = 40; // Not encoded by ClientSubscription
    int reqId = 50; // Not encoded by ClientSubscription
    boolean durable = true;
    AgentId topicId = new AgentId((short) 60, (short) 70, 80);
    String name = "test-subscription";
    String selector = "test-selector";
    boolean noLocal = true;
    AgentId dmqId = new AgentId((short) 90, (short) 100, 110);
    int threshold = 120;
    int nbMaxMsg = 130;
    MessageTable messagesTable = null; // Not encoded by ClientSubscription
    String clientID = null;

    ClientSubscription cs1 = new ClientSubscription(proxyId, contextId, reqId,
        durable, topicId, name, selector, noLocal, dmqId, threshold, nbMaxMsg,
        messagesTable, clientID);

    cs1.getDeliveredIds().put("msg1", "msg1");
    cs1.getDeliveredIds().put("msg2", "msg2");

    cs1.getDeniedMsgs().put("msg3", 1);
    cs1.getDeniedMsgs().put("msg4", 2);

    checkEncoding(cs1);

    clientID = "clientId";
    ClientSubscription cs2 = new ClientSubscription(proxyId, contextId, reqId,
        durable, topicId, name, selector, noLocal, dmqId, threshold, nbMaxMsg,
        messagesTable, clientID);

    checkEncoding(cs2);
  }
