public void updateConnections(List<LiveServerConnection> connections) {
    for (LiveServerConnection connection : connections) {
      if (!channels.containsKey(connection.getName())) {
        if (connectionNames == null || connectionNames.contains(connection.getName())) {
          if (logger.isLoggable(BasicLevel.DEBUG)) {
            logger.log(BasicLevel.DEBUG, "Creating a new consumer on queue " + amqpQueue + " for connection "
                + connection.getName());
          }
          try {
            Channel channel = connection.getConnection().createChannel();
            if (amqpQueuePassive) {
              channel.queueDeclarePassive(amqpQueue);
            } else {
              channel.queueDeclare(amqpQueue, amqpQueueDurable, amqpQueueExclusive, amqpQueueAutoDelete, null);
            }
            AmqpConsumer consumer = new AmqpConsumer(channel, connection.getName());
            channel.basicConsume(amqpQueue, false, consumer);
            channels.put(connection.getName(), channel);
          } catch (Exception e) {
            logger.log(BasicLevel.ERROR,
                "Error while starting consumer on connection: " + connection.getName(), e);
          }
        }
      }
    }
  }
