public static void addServer(String urls) {
  	if (logger.isLoggable(BasicLevel.DEBUG)) {
			logger.log(BasicLevel.DEBUG, "AmqpConnectionService.addServer(" + urls + ')');
		}
  	
  	StringTokenizer tk = new StringTokenizer(urls);
  	while (tk.hasMoreTokens()) {
  		URL url = null;
  		try {
  			url = new URL(null, tk.nextToken(), new MyURLStreamHandler());
  		} catch (Exception e) {
  			if (logger.isLoggable(BasicLevel.ERROR)) {
    			logger.log(BasicLevel.ERROR, "AmqpConnectionService.addServer : Exception ", e);
    		}
				continue;
			}
  		String host = null;
      int port = -1;
      String name = "default";
      String userName = null;
    	String userPass = null;
    	
  		String userInfo = url.getUserInfo();
  		if (userInfo != null) {
  			StringTokenizer token = new StringTokenizer(userInfo, ":");
  			if (token.hasMoreTokens())
  				userName = token.nextToken();
  			if (token.hasMoreTokens())
  				userPass = token.nextToken();
  		}
  		
  		host = url.getHost();
  		if (host == null)
  			host = ConnectionFactory.DEFAULT_HOST;
  		
  		port = url.getPort();
  		if (port < 0)
  			port = ConnectionFactory.DEFAULT_AMQP_PORT;

  		String query = url.getQuery();
  		if (query != null) {
  			int index = query.indexOf('=');
  			if (index > 0)
  				name = query.substring(index+1, query.length());
  		}

  		if (logger.isLoggable(BasicLevel.DEBUG)) {
  			logger.log(BasicLevel.DEBUG, "AmqpConnectionService.addServer(" + name + ", " + host + ", " + port + ", " + userName + ')');
  		}
  		getInstance().addServer(name, host, port, userName, userPass);
  	}
  }
