public void addServer(String name, String host, int port, String user, String pass) {
    synchronized (servers) {
      if (!servers.containsKey(name)) {
        LiveServerConnection cnx = new LiveServerConnection(name, host, port, user, pass);
        cnx.startLiveConnection();
        servers.put(name, cnx);
      }
    }
    try {
      if (! AgentServer.isEngineThread()) {
        AgentServer.getTransaction().begin();
      }
      AgentServer.getTransaction().save((HashMap) servers, SAVE_FILE_NAME);
      if (! AgentServer.isEngineThread()) {
        AgentServer.getTransaction().commit(true);
      }
    } catch (IOException exc) {
      logger.log(BasicLevel.ERROR, "Error while persisting new server " + name + ": " + host + ':' + port, exc);
    }
  }
