public void initialize(boolean firstTime) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "initialize(" + firstTime + ')');
    
    super.initialize(firstTime);

    try {
      if ((ftpImplName != null) && (ftpImplName.length() > 0))
        transfer = (TransferItf) Class.forName(ftpImplName).newInstance();
    } catch (Exception exc) {
      transfer = null;
      logger.log(BasicLevel.ERROR, 
                  "--- " + this + " initialize : transfer = null" ,exc);
    }

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG,
                  "--- " + this + " initialize transfer = "+ transfer);

    if (transfer != null) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
                   "--- " + this + " initialize : transferTable = " + transferTable);

      if (transferTable != null) {
        for (Enumeration e = transferTable.elements(); e.hasMoreElements(); ) {
          Message msg = (Message) e.nextElement();
          FtpMessage ftpMsg = new FtpMessage(msg);
          FtpThread t = new FtpThread(transfer,
              (FtpMessage) ftpMsg.clone(),
              getId(),
              dmq,
              clientContext,
              requestId,
              user,
              pass,
              path);
          t.start();
        }
      }
    }
  }
