public String getFile(String protocol,
                        String host, int port,
                        String user, String pass,
                        String remotePath, 
                        String localPath, 
                        String remoteFileName,
                        String localFileName,
                        String type,
                        long crc) throws Exception {
    
    Settings.setProperty("jftp.disableLog","true");
    Settings.setProperty("jftp.enableMultiThreading","true");
    Settings.maxConnections = 5;
    Settings.enableResuming = true;
    
    // create a FtpConnection
    FtpConnection con = null;
    if (port > -1) 
      con = new FtpConnection(host,port,remotePath);
    else
      con = new FtpConnection(host);

    // set updatelistener, interface methods are below
    con.addConnectionListener(this);

    // set handler
    con.setConnectionHandler(handler);

    // connect and login. 
    con.login(user,pass);

    // login calls connectionInitialized() below which sets established to true
    while(!established) {
      try { 
        Thread.sleep(10); 
      } catch(Exception exc) { 
        throw exc; 
      }
    }

    if (remotePath != null)
      con.chdirRaw(remotePath);

    if (localPath != null)
      con.setLocalPath(localPath);

    //System.out.println("LocalPath = " + con.getLocalPath());

    // which spawns a new thread for the download
    con.download(remoteFileName);
    
    File file = new File(con.getLocalPath(),localFileName);
    
    if (crc > 0 && crc != file.length())
      throw new Exception("CRC ERROR.");
    
    return file.getAbsolutePath();
  }
