public String getFile(String protocol,
                        String host, int port,
                        String user, String pass,
                        String remotePath, 
                        String localPath, 
                        String remoteFileName,
                        String localFileName,
                        String type,
                        long crc) throws Exception {
    
    StringBuffer sb = new StringBuffer();
    
    sb.append("ftp://").append(user).append(':').append(pass).append('@').append(host);
    if (port > -1) {
      sb.append(":").append(port);
    }
    sb.append('/');
    if (remotePath != null) {
      sb.append(remotePath).append('/');
    }
    sb.append(remoteFileName);
    sb.append(";type=").append(type);

    URL url = new URL(sb.toString());

    URLConnection urlc = url.openConnection();
    InputStream is = urlc.getInputStream();
    
    File file = new File(localPath, localFileName);
    
    BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(file));
    
    int c = is.read();
    while (c != -1) {
      bos.write(c);
      c = is.read();
    }
    bos.flush();
    bos.close();
    is.close();

    if (crc > 0 && crc != file.length())
      throw new Exception("CRC ERROR.");

    return file.getAbsolutePath();
  }
