public void stop() {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "Stop JMSAcquisition.");

    connectionUpdater.removeUpdateListener(this);
    
    closing = true;
    synchronized (listeners) {
      for (JmsListener listener : listeners.values()) {
        try {
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "Close JMS session: " + listener.session);

          listener.session.close();
          
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "JMS session closed: " + listener.session);
        } catch (JMSException exc) {
          if (logger.isLoggable(BasicLevel.INFO)) {
            logger.log(BasicLevel.INFO, "Error while stopping JmsAcquisition.", exc);
          }
        }
        // Remove ExceptionListener from JMSModule
        listener.connection.removeExceptionListener(listener);
      }
      
      listeners.clear();
      closing = false;
    }
  }
