protected Context getInitialContext() throws IOException, NamingException {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "getInitialContext() - Load jndi.properties file");
    }
    Context jndiCtx;
    Properties props = new Properties();
    InputStream in = Class.class.getResourceAsStream("/jndi.properties");
    
    if (in == null) {
      if (logger.isLoggable(BasicLevel.DEBUG)) {
        logger.log(BasicLevel.DEBUG, "jndi.properties not found.");
      }
    } else {
      props.load(in);
    }

    // Override jndi.properties with properties given at initialization if present
    if (jndiFactory != null) {
      props.setProperty(Context.INITIAL_CONTEXT_FACTORY, jndiFactory);
    }
    if (jndiUrl != null) {
      props.setProperty(Context.PROVIDER_URL, jndiUrl);
    }

    Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
    jndiCtx = new InitialContext(props);
    return jndiCtx;
  }
