public void onException(JMSException exc) {
  	if (logger.isLoggable(BasicLevel.WARN)) {
  		logger.log(BasicLevel.WARN, "JMSModule.onException()", exc);
  	}

  	if (listeners != null) {
  		for (Iterator<JmsListener> listener = listeners.iterator(); listener.hasNext();) {
  			JmsListener type = listener.next();
  			type.onException(exc);
  		}
  		listeners.clear();
  	}
  	
  	// JORAM-306: Close the connection
    if (cnx != null) {
      try {
        cnx.close();
      } catch (JMSException exc2) {
        logger.log(BasicLevel.INFO, "JMSModule.onException(), error closing the connection", exc2);
      }
    }

  	reconnectionDaemon.start();
  }
