protected Object retrieveJndiObject(String jndiName) throws Exception {

    Context jndiCtx = null;
    ClassLoader oldClassLoader = Thread.currentThread().getContextClassLoader();

    try {
      jndiCtx = getInitialContext();
      return jndiCtx.lookup(jndiName);
    } catch (Exception exc) {
      throw exc;
    } finally {
      // Closing the JNDI context.
      if (jndiCtx != null) {
        jndiCtx.close();
      }
      Thread.currentThread().setContextClassLoader(oldClassLoader);
    }
  }
