public void stopLiveConnection() {
    if (logger.isLoggable(BasicLevel.DEBUG)) {
      logger.log(BasicLevel.DEBUG, "JMSModule.stopLiveConnection()");
    }

    // Waits for end of initialization if needed (JORAM-290)
    while (getStatus() <= STARTING) {
      logger.log(BasicLevel.WARN, "JMSModule.stopLiveConnection: Wait for StartupDaemon");
      try {
        Thread.sleep(1000L);
      } catch (InterruptedException exc) {}
    }
    
    if (cnx != null) {
      try {
        cnx.setExceptionListener(null);
      } catch (JMSException exc) {
        logger.log(BasicLevel.WARN, "JMSModule.stopLiveConnection", exc);
      }
    }

    if (cnx != null) {
      try {
        cnx.stop();
      } catch (JMSException exc) {
        logger.log(BasicLevel.WARN, "JMSModule.stopLiveConnection", exc);
      }
    }

    if (reconnectionDaemon != null) {
      try {
        reconnectionDaemon.stop();
      } catch (Exception exc) {
        logger.log(BasicLevel.WARN, "JMSModule.stopLiveConnection", exc);
      }
    }

    if (cnx != null) {
      try {
        cnx.close();
      } catch (JMSException exc) {
        logger.log(BasicLevel.WARN, "JMSModule.stopLiveConnection", exc);
      }
    }

    try {
      MXWrapper.unregisterMBean(getMBeanName());
    } catch (Exception exc) {
      if (logger.isLoggable(BasicLevel.DEBUG)) {
        logger.log(BasicLevel.DEBUG, "unregisterMBean", exc);
      }
    }
  }
