public void close() {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "JMSBridgeModule.close()");

    try {
      if (consumerCnx != null)
        consumerCnx.setExceptionListener(null);
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }
    try {
      if (producerCnx != null)
        producerCnx.setExceptionListener(null);
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }

    try {
      if (producerCnx != null)
        producerCnx.stop();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }
    try {
      if (consumerCnx != null)
        consumerCnx.stop();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }

    unsetMessageListener();

    try {
      consumerDaemon.stop();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }
    try {
      reconnectionDaemon.stop();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }

    try {
      if (producerCnx != null)
        producerCnx.close();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }
    try {
      if (consumerCnx != null)
        consumerCnx.close();
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "JMSBridgeModule.close", exc);
    }
  }
