public void connect() throws JMSException {
    if (! usable)
      throw new IllegalStateException(notUsableMessage);
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "connect()");

    listener = false;
    // Creating the module's daemons.
    consumerDaemon = new ConsumerDaemon();
    reconnectionDaemon = new ReconnectionDaemon();
    
    // Administered objects have not been retrieved: launching the startup
    // daemon.
    if (cnxFact == null || dest == null) {
      StartupDaemon startup = new StartupDaemon();
      startup.start();
    } else {
      // Administered objects have been retrieved: connecting.
      try {
        if (isXA) {
          doXAConnect();
        } else {
          doConnect();
        }
        // start daemon.
        consumerDaemon.start();
      } catch (JMSException exc) {
        reconnectionDaemon.reconnect();
      }
    }
  }
