protected void doConnect() throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "doConnect()");
    
    if (userName != null && password != null) {
      producerCnx = cnxFact.createConnection(userName, password);
      consumerCnx = cnxFact.createConnection(userName, password);
    } else {
      producerCnx = cnxFact.createConnection();
      consumerCnx = cnxFact.createConnection();
    }

    if (clientID == null) {
      consumerCnx.setClientID("joramBridgeCons_" + agentId);
    } else {
      producerCnx.setClientID(clientID);
      consumerCnx.setClientID(clientID);
    }
    
    producerCnx.setExceptionListener(this);
    consumerCnx.setExceptionListener(this);
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "doConnect: producerCnx=" + producerCnx + ", consumerCnx=" + consumerCnx);
    
    producerSession = producerCnx.createSession(false, Session.AUTO_ACKNOWLEDGE);
    producer = producerSession.createProducer(dest);

    consumerSession = consumerCnx.createSession(true, 0);
  }
