protected void doXAConnect() throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "doXAConnect()");
    
    if (userName != null && password != null) {
      producerCnx = ((XAConnectionFactory) cnxFact).createXAConnection(userName, password);
      consumerCnx = ((XAConnectionFactory) cnxFact).createXAConnection(userName, password);
    } else {
      producerCnx = ((XAConnectionFactory) cnxFact).createXAConnection();
      consumerCnx = ((XAConnectionFactory) cnxFact).createXAConnection();
    }

    if (clientID == null) {
      consumerCnx.setClientID("joramBridgeCons_" + agentId);
    } else {
      producerCnx.setClientID(clientID);
      consumerCnx.setClientID(clientID);
    }
    
    producerCnx.setExceptionListener(this);
    consumerCnx.setExceptionListener(this);

    producerCnx.start();
    consumerCnx.start();
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "doXAConnect: cnx=" + producerCnx + ", consumerCnx=" + consumerCnx);

    producerSession = ((XAConnection) producerCnx).createXASession();
    producer = producerSession.createProducer(dest);
    consumerSession = ((XAConnection) consumerCnx).createXASession();
    
    producerRes = ((XASession) producerSession).getXAResource();
    consumerRes = ((XASession) consumerSession).getXAResource();
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "doXAConnect: producerRes=" + producerRes + ", consumerRes=" + consumerRes);
    
    // Recover if needed.
    new XARecoverDaemon(producerRes).start();
    new XARecoverDaemon(consumerRes).start();
  }
