protected void setConsumer() throws JMSException {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "setConsumer()");
    
    if (consumer != null)
      return;

    try {
      if (dest instanceof Queue)
        consumer = consumerSession.createConsumer(dest, selector);
      else
        consumer = consumerSession.createDurableSubscriber((Topic) dest,
                                                           agentId.toString(),
                                                           selector,
                                                           false);
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "setConsumer: consumer=" + consumer);
      
    } catch (JMSException exc) {
      throw exc;
    } catch (Exception exc) {
      throw new JMSException("JMS resources do not allow to create consumer: " + exc);
    }
  }
