private MimeBodyPart getMultipartProp(Message msg) throws Exception {
    MimeBodyPart mbp = new MimeBodyPart();

    StringBuffer buf = new StringBuffer();
    buf.append("type=" + msg.type + "\n");
    buf.append("id=" + msg.id + "\n");
    buf.append("persistent=" + msg.persistent + "\n");
    buf.append("priority=" + msg.priority + "\n");
    buf.append("expiration=" + msg.expiration + "\n");
    buf.append("timestamp=" + msg.timestamp + "\n");
    buf.append("toId=" + msg.toId + "\n");
    if (msg.toName != null)
      buf.append('(').append(msg.toName).append(')');
    buf.append("destType=" + msg.toType + "\n");
    buf.append("correlationId=" + msg.correlationId + "\n");
    buf.append("replyToId=" + msg.replyToId + "\n");
    if (msg.replyToName != null)
      buf.append('(').append(msg.replyToName).append(')');
    buf.append("replyDestType=" + msg.replyToType + "\n");
    buf.append("deliveryCount=" + msg.deliveryCount + "\n");
    buf.append("denied=" + msg.redelivered + "\n");

    if (msg.getProperty("JMS_JORAM_ERRORCOUNT") != null) {
      int errorCount = ((Integer) msg.getProperty("JMS_JORAM_ERRORCOUNT")).intValue();
      buf.append("errorCount=" + errorCount + "\n");
      for (int i = 1; i <= errorCount; i++) {
        buf.append("errorCode" + i + "=" + msg.getProperty("JMS_JORAM_ERRORCODE_" + i) + "\n");
        buf.append("errorCause" + i + "=" + msg.getProperty("JMS_JORAM_ERRORCAUSE_" + i) + "\n");
      }
    }

    mbp.setText(buf.toString());
    return mbp;
  }
