public void sendJavaMail(Message message) throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "--- " + this + " sendJavaMail(" + message + ")");

    if (smtpServer == null || smtpServer.length() <= 0) {
      logger.log(BasicLevel.ERROR, "--- " + this + " sendJavaMail : smtpServer is empty.");
      throw new Exception("sendJavaMail : smtpServer is empty.");
    }

    Properties props = System.getProperties();
    props.put("mail.smtp.host", smtpServer);
    Session session = Session.getDefaultInstance(props);
    MimeMessage msg = new MimeMessage(session);
    MimeMultipart mimeMultiPart = new MimeMultipart();
    MimeBodyPart mimeBodyPart = new MimeBodyPart();

    msg.setFrom(new InternetAddress(from));

    if (to != null && to != "") {
      StringTokenizer st = new StringTokenizer(to, ",");
      while (st.hasMoreTokens()) {
        msg.setRecipients(javax.mail.Message.RecipientType.TO, InternetAddress.parse(st.nextToken(), false));
      }
    }

    if (cc != null && cc != "") {
      StringTokenizer st = new StringTokenizer(cc, ",");
      while (st.hasMoreTokens()) {
        msg.setRecipients(javax.mail.Message.RecipientType.CC, InternetAddress.parse(st.nextToken(), false));
      }
    }

    if (bcc != null && bcc != "") {
      StringTokenizer st = new StringTokenizer(bcc, ",");
      while (st.hasMoreTokens()) {
        msg.setRecipients(javax.mail.Message.RecipientType.BCC, InternetAddress.parse(st.nextToken(), false));
      }
    }

    msg.setSubject(subject);

    if (ConversionHelper.toBoolean(message.getProperty("showProperties"))) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "--- " + this + " showProperties option enabled.");
      try {
        mimeMultiPart.addBodyPart(getMultipartProp(message));
      } catch (Exception exc) {
        logger.log(BasicLevel.WARN, "--- " + this + " sendJavaMail: setMultipartProp", exc);
      }
    }

    if (message.type == Message.TEXT) {
      mimeBodyPart.setText(message.getText());
      mimeMultiPart.addBodyPart(mimeBodyPart);
    } else {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "not yet implemented");
      //message.getBytes()
    }

    msg.setHeader("X-Mailer", "JORAM:JavaMailUtil");
    msg.setSentDate(new Date());

    msg.setContent(mimeMultiPart);
    Transport.send(msg);
  }
