public void createConsumer() {
    Builder builder = target.path("jndi").path(destName).request();
    Response response = builder.accept(MediaType.TEXT_PLAIN).head();
//    if (logger.isLoggable(BasicLevel.DEBUG))
//      logger.log(BasicLevel.DEBUG, "RESTAcquisition.createConsumer: response = " + response);
    if (201 != response.getStatus()) {
      return;
    }
    
    uriCreateConsumer = response.getLink("create-consumer").getUri();
    try {
      // TODO (AF): to remove (use FormParam alternate URI)
      uriCreateConsumer = new URI(uriCreateConsumer.toString() + "-fp");
    } catch (URISyntaxException exc) {
      logger.log(BasicLevel.ERROR, "RESTAcquisition.createConsumer: use FormParam alternate URI", exc);
      uriCreateConsumer = null;
    }
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "RESTAcquisition.createConsumer: uriCreateConsumer = " + uriCreateConsumer);

    WebTarget wTarget = client.target(uriCreateConsumer)
        .queryParam("name", "cons-" + destName)
        .queryParam("client-id", "id-" + destName);
    if (userName != null)
      wTarget = wTarget.queryParam("user", userName);
    if (password != null)
      wTarget = wTarget.queryParam("password", password);
    
    response = wTarget.request().accept(MediaType.TEXT_PLAIN).post(Entity.entity(null, MediaType.APPLICATION_FORM_URLENCODED));
//    if (logger.isLoggable(BasicLevel.DEBUG))
//      logger.log(BasicLevel.DEBUG, "RESTAcquisition.createConsumer: response = " + response);
    if (201 == response.getStatus()) {
      uriCloseConsumer = response.getLink("close-context").getUri();
      uriConsume = response.getLink("receive-message").getUri();
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "RESTAcquisition.createConsumer: uriCloseConsumer = " + uriCloseConsumer + ", uriConsume = " + uriConsume);
    }
  }
