void acknowledgeMessage() throws Exception {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, 
          "RestAcquisitionAsync.acknowledgeMessage: " + uriAcknowledgeMsg);
    
    if (uriAcknowledgeMsg != null) {
      Response response = client.target(uriAcknowledgeMsg)
          .request()
          .accept(MediaType.TEXT_PLAIN)
          .delete();

      if (response.getStatus() != 200) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN, 
              "RestAcquisitionAsync.acknowledgeMessage: error during acknowledge ->" + response.getStatusInfo());
        
        throw new Exception("Error during acknowledge: "+ response.getStatusInfo());
      }
    } else {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, 
            "RestAcquisitionAsync.acknowledgeMessage: Cannot acknowledge message, empty URI.");
      
      throw new Exception("Error during acknowledge: empty URI");
    }
    uriAcknowledgeMsg = null;
  }
