private void closeConsumer() {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "RestAcquisitionAsync.closeConsumer():");
    
    if (uriCloseConsumer != null) {
      try {
        Response response = client.target(uriCloseConsumer).request().accept(MediaType.TEXT_PLAIN).delete();
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "RestAcquisitionAsync.closeConsumer(): -> " + response.getStatus());
      } catch (Exception exc) {
        logger.log(BasicLevel.WARN, "RestAcquisitionAsync.closeConsumer()", exc);
        return;
      } finally {
        uriCloseConsumer = null;
      }
    }    
  }
