private Map<String, Object> getMapMessage(Map<String, Object> jsonMap) {
    Map<String, Object> map = new HashMap<String, Object>();

    // parse the json map
    for (String key : jsonMap.keySet()) {
      ArrayList<String> array = null;
      try {
        array = (ArrayList<String>) jsonMap.get(key);
      } catch (Exception exc) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN,
              "RESTAcquisitionAsync.getMapMessage: bad element, ignore map entry " + key, exc);
        continue;
      }

      if (array.size() != 2) {
        if (logger.isLoggable(BasicLevel.WARN))
          logger.log(BasicLevel.WARN,
              "RESTAcquisitionAsync.getMapMessage: bad element, ignore map entry " + key);
        continue;
      }
      
      String classname = array.get(1);
      try {
        Object value = null;
        if (Character.class.getName().equals(classname)) {
          value =  array.get(0).charAt(0);
        } else if (byte[].class.getName().equals(classname)) {
          value = array.get(0).getBytes("UTF-8");
        } else {
          Constructor<?> constructor = Class.forName(classname).getConstructor(String.class);
          value = constructor.newInstance(array.get(0));
        }
        map.put(key, value);
      } catch (Exception exc) {
        if (logger.isLoggable(BasicLevel.ERROR))
          logger.log(BasicLevel.ERROR,
              "RESTAcquisitionAsync.getMapMessage: ignore map entry " + key + ", " + array.get(0) + " / " + classname, exc);
        continue;
      }


      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG,
            "RESTAcquisitionAsync.getMapMessage: get key=" + key + ", value = " + array.get(0) + " / " + classname);
    }
    
    return map;
  }
