public void postProcess(ClientMessages not) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "SchedulerQueue.postProcess(" + not + ')');

    org.objectweb.joram.shared.messages.Message msg;
    long currentTimeMillis = System.currentTimeMillis();
    for (Iterator msgs = not.getMessages().iterator(); msgs.hasNext();) {
      msg = (org.objectweb.joram.shared.messages.Message) msgs.next();
      long scheduleDate = getScheduleDate(msg);
      // If there is no schedule date or if it is outdated  do nothing.
      if (scheduleDate < currentTimeMillis) return;
      
      // schedule a task
      try {
        scheduler.scheduleEvent(new ScheduleEvent(msg.id, new Date(scheduleDate)), 
                                new SchedulerQueueTask(getId()));
        
        // Needs to save the SchedulerQueue.
        // Queue may not be modified so a 'setSave' is required.
        setSave();
      } catch (Exception e) {
        if (logger.isLoggable(BasicLevel.ERROR))
          logger.log(BasicLevel.ERROR, "SchedulerQueue.postProcess(" + not + ')', e);
      }
    }
  }
