static public AbstractJmsMessage read(InputStream is) throws IOException, ClassNotFoundException, InstantiationException, IllegalAccessException {
    int classid = -1;
    AbstractJmsMessage msg = null;

    classid = StreamUtil.readIntFrom(is);
    if (classid != NULL_CLASS_ID) {
      switch (classid) {
      // NOTE: Avoid to use Class.forName for frequent messages.
      case PRODUCER_MESSAGES:
        msg = new ProducerMessages();
        break;
      case CONSUMER_MESSAGES:
        msg = new ConsumerMessages();
        break;
      case CONSUMER_ACK_REQUEST:
        msg = new ConsumerAckRequest();
        break;
      case CONSUMER_RECEIVE_REQUEST:
        msg = new ConsumerReceiveRequest();
        break;
      case SERVER_REPLY:
        msg = new ServerReply();
        break;
      case CONSUMER_SET_LIST_REQUEST:
        msg = new ConsumerSetListRequest();
        break;
      default:
        msg = (AbstractJmsMessage) Class.forName(classnames[classid]).newInstance();
      }
      
      msg.readFrom(is);
    }

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "AbstractJmsMessage.read: " + msg);

    return msg;
  }
