public void readFrom(InputStream is) throws IOException {
    super.readFrom(is);
    int size = StreamUtil.readIntFrom(is);
    if (size == -1) {
      requests = null;
    } else {
      requests = new AbstractJmsRequest[size];
      for (int i=0; i<size; i++) {
        String cn = StreamUtil.readStringFrom(is);
        try {
          requests[i] = (AbstractJmsRequest) Class.forName(cn).newInstance();
        } catch (ClassNotFoundException exc) {
          throw new IOException("AbstractJmsRequest.readFrom(), Unknown class " + cn);
        } catch (InstantiationException exc) {
          throw new IOException("AbstractJmsRequest.readFrom(), Cannot Instantiate " + cn);
        } catch (IllegalAccessException exc) {
          throw new IOException("AbstractJmsRequest.readFrom(), Cannot IllegalAccessException " + cn);
        }
        requests[i].readFrom(is);
      }
    }
  }
