public static long toLong(Object value) throws MessageValueException {
    if (value == null)
      return Long.valueOf(null).longValue();

    if (value instanceof Byte || value instanceof Short 
        || value instanceof Integer || value instanceof Long)
      return ((Number) value).longValue();
    else if (value instanceof String)
      return Long.valueOf((String) value).longValue();
    else
      throw new MessageValueException("Type " + value.getClass().getName() + " can't be converted to Long.");
  }
