public boolean check(Identity identity) throws Exception  {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "SimpleIdentity.check(" + identity + ')');

    if (! (identity instanceof SimpleIdentity)) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "check : SimpleIdentity is expected for " + identity);
      throw new Exception("check : SimpleIdentity is expected for " + identity);
    }

    if (! getUserName().equals(identity.getUserName())) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, 
                   "Invalid user [" + getUserName() + "] wait [" + identity.getUserName() + "]");
      throw new Exception("Invalid user [" + getUserName() + "] wait [" + identity.getUserName() + "]");
    }
    if (! passwd.equals(((SimpleIdentity)identity).passwd)) {
      if (logger.isLoggable(BasicLevel.ERROR))
        logger.log(BasicLevel.ERROR, "Invalid credential for user [" + identity.getUserName() + "]");
      throw new Exception("Invalid credential for user [" + identity.getUserName() + "]");
    }
    return true;
  }
