private static void getVersionInResource() {
  	String implVersion = null;
  	// Read version from joram.version file in bundle. 
  	try {
  		InputStream in = MetaData.class.getResourceAsStream("/joram.version");
  		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
  		String v = reader.readLine();
  		while (v != null) {
  			if (v.contains("version"))
  				implVersion = (v.substring(v.indexOf('=')+1, v.length())).trim();
  			else if (v.contains("protocol"))
  				protocol = Integer.parseInt(v.substring(v.indexOf('=')+1, v.length()).trim());
  			v = reader.readLine();
  		}

  	} catch (Exception e) {
  		if (logger.isLoggable(BasicLevel.DEBUG))
	      logger.log(BasicLevel.DEBUG, "MetaData.getVersionInResource:: EXCEPTION", e);
  	}
  	if (implVersion != null) {
  		try {
  			version = implVersion.trim();
  			StringTokenizer st = new StringTokenizer(implVersion, ".");
  			major = Integer.parseInt(st.nextToken());
  			minor = Integer.parseInt(st.nextToken());
  			String b = st.nextToken();
  			//remove -SNAPSHOT
  			int i = b.indexOf("-");
  			if (i > 0)
  				b = b.substring(0, i);
  			build = Integer.parseInt(b);
  		} catch (Exception e) {
  			if (logger.isLoggable(BasicLevel.DEBUG))
  	      logger.log(BasicLevel.DEBUG, "MetaData.getVersionInResource:: EXCEPTION", e);
  		}
  	}
  }
