public void init(BundleContext bundleContext) throws Exception {
    this.bundleContext = bundleContext;
    
    restAdminRoot = bundleContext.getProperty(BUNDLE_REST_ADMIN_ROOT);
    restAdminPass = bundleContext.getProperty(BUNDLE_REST_ADMIN_PASS);
    
    restAdminIPAllowed = bundleContext.getProperty(BUNDLE_REST_ADMIN_IP_ALLOWED);
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "IPFilter allowedList = " + restAdminIPAllowed);
    ipfilter = new IPFilter(restAdminIPAllowed);
    
    String name = "dlft-admin";

    jmsRootUser = bundleContext.getProperty(BUNDLE_JMS_USER);
    jmsRootPassword = bundleContext.getProperty(BUNDLE_JMS_USER);

    startJoramAdmin(name);
    
    // set the jndi properties
    if (bundleContext.getProperty(BUNDLE_JNDI_FACTORY_INITIAL_PROP) != null && 
        bundleContext.getProperty(BUNDLE_JNDI_FACTORY_HOST_PROP) != null &&
        bundleContext.getProperty(BUNDLE_JNDI_FACTORY_PORT_PROP) != null) {
      jndiProps = new Properties();
      jndiProps.setProperty("java.naming.factory.initial", bundleContext.getProperty(BUNDLE_JNDI_FACTORY_INITIAL_PROP));
      jndiProps.setProperty("java.naming.factory.host", bundleContext.getProperty(BUNDLE_JNDI_FACTORY_HOST_PROP));
      jndiProps.setProperty("java.naming.factory.port", bundleContext.getProperty(BUNDLE_JNDI_FACTORY_PORT_PROP));
    } else {
      jndiProps = new Properties();
      jndiProps.setProperty("java.naming.factory.initial", "fr.dyade.aaa.jndi2.client.NamingContextFactory");
      jndiProps.setProperty("java.naming.factory.host", "localhost");
      jndiProps.setProperty("java.naming.factory.port", "16400");
    }
    
    ictx = new InitialContext(jndiProps);
    
    // TODO: use the osgi service jndi ?
//    ServiceReference<ObjectFactory> ref = bundleContext.getServiceReference(javax.naming.spi.ObjectFactory.class);
//    ObjectFactory jndiFactory = bundleContext.getService(ref);
//    context = (scnURLContext) jndiFactory.getObjectInstance(null, null, null, jndiProps);
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "jndiProperties = " + jndiProps);
   }
