@GET
  @Path("/local/create")
  @Produces({MediaType.TEXT_PLAIN})
  public synchronized Response createLocalConnectionFactory(
      @Context HttpHeaders headers,
      @QueryParam("jndi-name") String jndiName,
      @Context UriInfo uriInfo) {
 
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "createLocalConnectionFactory(" + headers + ", " + jndiName + ", " + uriInfo + ")");

    Response.ResponseBuilder builder = null;
    try {
      //Create local connection factory
      ConnectionFactory cf = helper.createlocalConnectionFactory();

      // bind the local connection factory
      if (jndiName != null)
        helper.rebind(jndiName, cf);

      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "createLocalConnectionFactory cf = " + cf);

    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, e);
      if (e instanceof JMSSecurityRuntimeException)
        builder = Response.status(Response.Status.UNAUTHORIZED).entity(e.toString());
      else
        builder = Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity(e.toString());
      return builder.build();
    }

    builder = Response.status(Response.Status.CREATED);
    // TODO: Adds links?
    return builder.build();
  }
