@DELETE
  @Path("/user/{userName}")
  @Produces({MediaType.TEXT_PLAIN})
  public synchronized Response deleteUser(
      @Context HttpHeaders headers,
      @PathParam("userName") String userName,
      @NotNull @QueryParam("password") String password,
      @DefaultValue("-1") @QueryParam("server-id") int serverId,
      @Context UriInfo uriInfo) {
 
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "DELETE: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "deleteUser(" + headers + ", " + userName + ", " + uriInfo + ")");

    Response.ResponseBuilder builder = null;
    
    if (password == null) {
      builder = Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity("The password is null.");
      return builder.build();
    }
    
    try {
      // delete the user
      if (serverId < 0)
        serverId = helper.getLocalServerId();
      helper.deleteUser(userName, password, serverId);

    } catch (Exception e) {
      if (logger.isLoggable(BasicLevel.WARN))
        logger.log(BasicLevel.WARN, e);
      if (e instanceof JMSSecurityRuntimeException)
        builder = Response.status(Response.Status.UNAUTHORIZED).entity(e.toString());
      else
        builder = Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity(e.toString());
      return builder.build();
    }

    builder = Response.status(Response.Status.OK);
    return builder.build();
  }
