@GET
  @Produces(MediaType.TEXT_HTML)
  public String info(@Context UriInfo uriInfo) {
    StringBuilder buff = new StringBuilder();
    buff.append("<html>");
    buff.append("<body>");
    
    buff.append("<h3>create a default destination (GET)</h3>");
    buff.append("<pre>");
    buff.append("create a queue or topic: " + uriInfo.getAbsolutePathBuilder() + "/[queue|topic]/{<b>name</b>}");
    buff.append("</pre>");
    
    buff.append("<h3>create a destination (POST)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/[queue|topic]/{<b>name</b>}");
    buff.append("\n<b>path:</b>");
    buff.append("\n  <b>name:</b> The queue or topic name");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>class-name:</b> The className (default = org.objectweb.joram.mom.dest.[Queue|Topic])");
    buff.append("\n  <b>server-id:</b> The serverId (default the local server Id");
    buff.append("\n  <b>free-reading:</b> boolean for free reading (default = false)");
    buff.append("\n  <b>free-writing:</b> boolean for free writing (default = false)");
    buff.append("\n  <b>jndi-bind:</b> boolean for jndi re-binding the destination (default = true)");
    buff.append("\n  <b>jndi-name:</b> Jndi name for this destination (default = the destination name)");
    buff.append("\n<b>post:</b>");
    buff.append("\n  <b>json:</b> The destination properties (in Json)");
    buff.append("</pre>");
    
    buff.append("<h3>delete a destination (DELETE)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/[queue|topic]/{<b>name</b>}");
    buff.append("\n<b>path:</b>");
    buff.append("\n  <b>name:</b> The queue or topic name");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>server-id:</b> The serverId (default the local server Id");
    buff.append("\n  <b>jndi-unbind:</b> boolean for jndi un-binding the destination (default = true)");
    buff.append("\n  <b>jndi-name:</b> Jndi name for this destination (default = the destination name)");
    buff.append("</pre>");
    
    buff.append("<h3>list destinations (queue|topic) (GET)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/[queue|topic]");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>server-id:</b> The serverId (default the local server Id");
    buff.append("</pre>");
    
    buff.append("<h3>create a user (GET)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/user/{<b>name</b>}");
    buff.append("\n<b>path:</b>");
    buff.append("\n  <b>name:</b> The user name");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>password:</b> The user password");
    buff.append("</pre>");
    
    buff.append("<h3>create a user (POST)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/user/{<b>name</b>}");
    buff.append("\n<b>path:</b>");
    buff.append("\n  <b>name:</b> The user name");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>password:</b> The user password");
    buff.append("\n  <b>identity-class-name:</b> the identity className (default = org.objectweb.joram.shared.security.SimpleIdentity)");
    buff.append("\n  <b>server-id:</b> The serverId (default the local server Id)");
    buff.append("\n<b>post:</b>");
    buff.append("\n  <b>json:</b> The user properties (in Json)");
    buff.append("</pre>");
    
    buff.append("<h3>delete a user (DELETE)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/user/{<b>name</b>}");
    buff.append("\n<b>path:</b>");
    buff.append("\n  <b>name:</b> The user name");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>password:</b> The user password");
    buff.append("\n  <b>server-id:</b> The serverId (default the local server Id)");
    buff.append("</pre>");
      
    buff.append("<h3>create a TCP connection factory (GET)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/tcp/create");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>host:</b> The host name (default = localhost)");
    buff.append("\n  <b>port:</b> the port value (default = 16010)");
    buff.append("\n  <b>reliable-class:</b> the reliable class (default = org.objectweb.joram.client.jms.tcp.ReliableTcpClient)");
    buff.append("\n  <b>jndi-name:</b> registered name of the ConnectionFactory in JNDI");
    buff.append("</pre>");
    
    buff.append("<h3>create a Local connection factory (GET)</h3>");
    buff.append("<pre>");
    buff.append(uriInfo.getAbsolutePathBuilder() + "/local/create");
    buff.append("\n<b>options:</b>");
    buff.append("\n  <b>jndi-name:</b> registered name of the ConnectionFactory in JNDI");
    buff.append("</pre>");
    
    buff.append("</body>");
    buff.append("</html>");
    return buff.toString();
  }
