@GET
  @Path("/queue")
  @Produces({MediaType.TEXT_PLAIN})
  public synchronized String listQueue(
      @Context HttpHeaders headers,
      @QueryParam("server-id") int serverId,
      @Context UriInfo uriInfo) throws ConnectException, AdminException {
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "listQueue(" + headers + ", " + serverId + ", " + uriInfo + ")");

    if (serverId == -1)
      serverId = helper.getLocalServerId();
    ArrayList<Destination> queues = helper.getQueueNames(serverId);
    StringBuilder buff = new StringBuilder();
    for (Destination queue : queues) {
      buff.append(queue.getAdminName()).append("\n");
    }
    return buff.toString();
  }
