@GET
  @Path("/topic")
  @Produces({MediaType.TEXT_PLAIN})
  public synchronized String listTopic(
      @Context HttpHeaders headers,
      @QueryParam("server-id") int serverId,
      @Context UriInfo uriInfo) throws ConnectException, AdminException {
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());

    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "listTopic(" + headers + ", " + serverId + ", " + uriInfo + ")");

    if (serverId == -1)
      serverId = helper.getLocalServerId();
    ArrayList<Destination> topics = helper.getTopicNames(serverId);
    StringBuilder buff = new StringBuilder();
    for (Destination topic : topics) {
      buff.append(topic.getAdminName()).append("\n");
    }
    return buff.toString();
  }
