synchronized Message receive(long timeout, long msgId) throws JMSException {
    Message message = null;
    if (timeout > 0)
      message = getConsumer().receive(timeout);
     else if (timeout == 0)
       message = getConsumer().receiveNoWait();
     else {
       message = getConsumer().receive();
       if (message == null)
         throw new JMSException("The consumer expire (timeout)");
     }
     
     //update activity
     getClientCtx().setLastActivity(System.currentTimeMillis());
     
     if (message != null) {
       if (getJmsContext().getSessionMode() == JMSContext.CLIENT_ACKNOWLEDGE) {
         long id = msgId;
         if (id == -1)
           id = incLastId();
         put(id, message);
       } else {
         incLastId();
       }
     }
     
     return message;
  }
