private Map getHeaderToJsonMap(Message message) {
    HashMap<String, Object> header = new HashMap<>();
    try {
      if (message.getJMSDeliveryMode() == DeliveryMode.NON_PERSISTENT)
        header.put("DeliveryMode", "NON_PERSISTENT");
      else if (message.getJMSDeliveryMode() == DeliveryMode.PERSISTENT)
        header.put("DeliveryMode", "PERSISTENT");
    } catch (JMSException e) { }
    try {
      header.put("Priority", message.getJMSPriority());
    } catch (JMSException e) { }
    try {
      header.put("Redelivered", message.getJMSRedelivered());
    } catch (JMSException e) { }
    try {
      header.put("Timestamp", message.getJMSTimestamp());
    } catch (JMSException e) { }
    try {
      if (message.getJMSExpiration() > 0)
        header.put("Expiration", message.getJMSExpiration());
    } catch (JMSException e) { }
    try {
      if (message.getJMSCorrelationID() != null)
        header.put("CorrelationID", message.getJMSCorrelationID());
    } catch (JMSException e) { }
    try {
      if (message.getJMSCorrelationIDAsBytes() != null)
        header.put("CorrelationIDAsBytes", message.getJMSCorrelationIDAsBytes());
    } catch (JMSException e) { }
    try {
      if (message.getJMSDestination() != null)
        header.put("Destination", message.getJMSDestination());
    } catch (JMSException e) { }
    try {
      if (message.getJMSMessageID() != null)
        header.put("MessageID", message.getJMSMessageID());
    } catch (JMSException e) { }
    try {
      if (message.getJMSReplyTo() != null)
        header.put("ReplyTo", message.getJMSReplyTo());
    } catch (JMSException e) { }
    try {
      if ( message.getJMSType() != null)
        header.put("Type", message.getJMSType());
    } catch (JMSException e) { }
    return header;
  }
