private Map getMapMessageToJsonBodyMap(Message message) throws JMSException {
    Map msgMap = message.getBody(Map.class);
    if (msgMap == null)
      return null;
    HashMap<String, Object> jsonBodyMap = new HashMap<>();
    Iterator<Map.Entry> entries = msgMap.entrySet().iterator();
    while (entries.hasNext()) {
      Entry entry = entries.next();
      String name = (String) entry.getKey();
      Object v = entry.getValue();
      if (v != null) {
        String[] value = {""+v, v.getClass().getName()};
        if (v instanceof byte[]) {
          value[0] = new String((byte[])v);
        }
        jsonBodyMap.put(name, value);
      }
    }
    return jsonBodyMap;
  }
