final Message createMessage(String type, Object jmsBody) throws Exception {
    Message msg = null;
    
    // Build the JMS Message
    if (type.equals(TextMessage.class.getSimpleName())) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "send text message = " + jmsBody);
      
      // create the text message
      msg = getJmsContext().createTextMessage((String) jmsBody);
    } else if(type.equals(BytesMessage.class.getSimpleName())) {
      // create the byte message
      if (jmsBody instanceof ArrayList) {
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "send bytes message");
        
        msg = getJmsContext().createBytesMessage();
        byte[] bytes = new byte[((ArrayList) jmsBody).size()];
        for (int i = 0; i < ((ArrayList) jmsBody).size(); i++) {
          Object value = ((ArrayList) jmsBody).get(i);
          bytes[i] = ((Number) value).byteValue();
        }
        ((BytesMessage) msg).writeBytes(bytes);
        ((BytesMessage) msg).reset();
      } else {
        throw new Exception("BytesMessage: invalid jmsBody = " + jmsBody.getClass().getName());
      }
    } else if(type.equals(MapMessage.class.getSimpleName())) {
      if (logger.isLoggable(BasicLevel.DEBUG))
        logger.log(BasicLevel.DEBUG, "send map message");

      // create the map message
      if (jmsBody instanceof Map) {
        msg = getJmsContext().createMapMessage();
        Helper.setMapMessage((Map) jmsBody, (MapMessage) msg);
      } else {
        throw new Exception("MapMessage: invalid jmsBody = " + jmsBody.getClass().getName());
      }
    } else if(type.equals(ObjectMessage.class.getSimpleName())) {
      throw new Exception("type: " + type + ", not yet implemented");
    } else if(type.equals(StreamMessage.class.getSimpleName())) {
      throw new Exception("type: " + type + ", not yet implemented");
    } else {
      throw new Exception("Unknown message type: " + type); 
    }

    return msg;
  }
