final void setJMSProperties(Message msg, Map<String, Object> jmsProps) throws JMSException {
    if (jmsProps != null) {
      // Properties
      for (String key : jmsProps.keySet()) {
        Object value = null; 
        try {
          value = Helper.getValue(jmsProps, key);
        } catch (Exception e) {
          if (logger.isLoggable(BasicLevel.ERROR))
            logger.log(BasicLevel.ERROR, "ignore set jms properties(" + key + ", " + value + ") : " + e.getMessage());
          continue;
        }
        if (value == null)
          continue;
        if (logger.isLoggable(BasicLevel.DEBUG))
          logger.log(BasicLevel.DEBUG, "set jms properties: " + key + ", value = " + value + ", " + value.getClass().getSimpleName());
        
        switch (value.getClass().getSimpleName()) {
        case "String":
          msg.setStringProperty(key, (String) value);
          break;
        case "Boolean":
          msg.setBooleanProperty(key, (Boolean)value);
          break;
        case "Integer":
          msg.setIntProperty(key, (Integer)value);
          break;
        case "Long":
          msg.setLongProperty(key, (Long)value);
          break;
        case "Double":
          msg.setDoubleProperty(key, (Double)value);
          break;
        case "Float":
          msg.setFloatProperty(key, (Float)value);
          break;
        case "Short":
          msg.setShortProperty(key, (Short)value);
          break;
        case "Byte":
          msg.setByteProperty(key, (Byte)value);
          break;

        default:
          try {
          msg.setObjectProperty(key, value);
          } catch (Exception e) {
            if (logger.isLoggable(BasicLevel.ERROR))
              logger.log(BasicLevel.ERROR, "ignore jms setObjectProperties(" + key + ", " + value + ") : " + e.getMessage());
          }
          break;
        }
      }
    }
  }
