public void start(BundleContext bundleContext) throws Exception {
    this.context = bundleContext;
    ServiceReference<HttpService> reference = bundleContext.getServiceReference(HttpService.class);
    if (reference == null) {
      logger.log(BasicLevel.ERROR, "rest.jmx.Activator ServiceReference<HttpService> = null");
      throw new Exception("rest.jmx.Activator ServiceReference<HttpService> = null");
    }
    httpService = bundleContext.getService(reference);
    
    ClassLoader myClassLoader = getClass().getClassLoader();
    ClassLoader originalContextClassLoader = Thread.currentThread().getContextClassLoader();
    try {
      Thread.currentThread().setContextClassLoader(myClassLoader);
      
      // initialize the jmx helper
      JmxHelper.getInstance().init(bundleContext);
      
      Dictionary<String, String> jerseyServletParams = new Hashtable<>();
      jerseyServletParams.put("javax.ws.rs.Application", JmxJerseyApplication.class.getName());
      if (logger.isLoggable(BasicLevel.INFO))
        logger.log(BasicLevel.INFO, "start: REGISTERING SERVLETS " + servletAlias);
      // register the servlet
      httpService.registerServlet(servletAlias, new ServletContainer(), jerseyServletParams, null);
      
    } finally {
      Thread.currentThread().setContextClassLoader(originalContextClassLoader);
    }
  }
