public boolean checkIpAllowed(String addr) {
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "IPFilter.checkIpAllowed address=" + addr + ", ipAlloweds=" + ipAlloweds);

    if (ipAlloweds == null)
      return true;
    
    try {
      Inet4Address a = (Inet4Address) InetAddress.getByName(addr);

      if (a.isAnyLocalAddress() || a.isLoopbackAddress())
        return true;
      // Check if the address is defined on any interface
      if(NetworkInterface.getByInetAddress(a) != null)
        return true;

      byte[] b = a.getAddress();
      int ipInt = ((b[0] & 0xFF) << 24) | ((b[1] & 0xFF) << 16) | ((b[2] & 0xFF) << 8) | ((b[3] & 0xFF) << 0);

      for (Authorized authorized : ipAlloweds) {
        if ((authorized.ip & authorized.mask) == (ipInt & authorized.mask)) {
          if (logger.isLoggable(BasicLevel.DEBUG))
            logger.log(BasicLevel.DEBUG, "IPFilter.checkIpAllowed address " + addr + " authorized.");
          return true;
        }
      }
    } catch (Exception exc) {
      logger.log(BasicLevel.WARN, "IPFilter.checkIpAllowed " + addr, exc);
    }
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "IPFilter.checkIpAllowed " + addr + " failed.");
    return false;
  }
