private HashMap<String, HashMap<String, ArrayList<ObjectName>>> beanToTree() {
    HashMap<String, HashMap<String, ArrayList<ObjectName>>> domains = 
        new HashMap<String, HashMap<String, ArrayList<ObjectName>>>();
    Set<ObjectName> objectNames = new TreeSet<ObjectName>(mbs.queryNames(null, null));
    for (ObjectName objectName: objectNames) {
      // get the current domain
      String domain = objectName.getDomain();
      // get type map for this domain
      HashMap<String, ArrayList<ObjectName>> types = domains.get(domain);
      if (types == null) {
        types = new HashMap<String, ArrayList<ObjectName>>();
        domains.put(domain, types);
      }
      String type = objectName.getKeyProperty("type");
      if (type == null) {
        type = objectName.getKeyProperty("server");
        if (type == null)
          type = objectName.getKeyProperty("host");
      }
      // get attribute list for this type
      ArrayList<ObjectName> attributtes = types.get(type);
      if (attributtes == null) {
        attributtes = new ArrayList<ObjectName>();
        types.put(type, attributtes);
      }
      attributtes.add(objectName);
    }
    return domains;
  }
