@GET
  @Produces(MediaType.APPLICATION_JSON)
  public String getAllMBeanInfoJson(
      @Context UriInfo uriInfo) throws Exception {
    
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "getAllMBeanInfoJson(" + uriInfo + ")");

    ByteArrayOutputStream out = new ByteArrayOutputStream();
    JsonWriter writer = new JsonWriter(new OutputStreamWriter(out, "UTF-8"));
    writer.setIndent("  ");

    Set<ObjectName> objectNames = new TreeSet<ObjectName>(mbs.queryNames(null, null));
    writer.beginObject();
    for (ObjectName objectName: objectNames) {
      MBeanInfo mbeanInfo = mbs.getMBeanInfo(objectName);
      MBeanAttributeInfo[] attributes = mbeanInfo.getAttributes();
      writer.name(objectName.toString());
      //writer.setIndent("    ");
      writer.beginArray();
      for (MBeanAttributeInfo attribute : attributes) {
        writer.value(attribute.getName());
      }
      writer.endArray();
    }
    writer.endObject();
    writer.flush();
    writer.close();
    return out.toString();
  }
