@GET
  @Path("/" + DOMAINS + "/{domain}")
  @Produces(MediaType.APPLICATION_JSON)
  public Response getDomainJson(
      @PathParam("domain") String domain,
      @Context UriInfo uriInfo) throws Exception {
    
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "getDomainJson(" + domain + ", " + uriInfo + ")");
    
    ResponseBuilder builder = Response.status(Response.Status.OK);
    
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    JsonWriter writer = new JsonWriter(new OutputStreamWriter(out, "UTF-8"));
    writer.setIndent("  ");
    
    Set<ObjectName> ObjectNames = mbs.queryNames(ObjectName.getInstance(domain + ":*"), null);
    writer.beginObject();
    int i = 0;
    for (ObjectName objectName : ObjectNames) {
      URI uri = uriInfo.getAbsolutePathBuilder()
          .path(objectName.getCanonicalName()).build();
      //link to this objectName
      String name = "objectName" + (i++);
      builder.link(uri, name);
      writer.name(objectName.getCanonicalName());
      writer.value(name);
    }
    writer.flush();
    writer.endObject();
    writer.close();
    String json = out.toString();
    // add Json to the response
    builder.entity(json);

    return builder.build();
  }
