@GET
  @Path("/" + DOMAINS)
  @Produces(MediaType.APPLICATION_JSON)
  public Response getDomainsJson(@Context UriInfo uriInfo) throws Exception {
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "getDomainsJson(" + uriInfo + ")");
    
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    
    ResponseBuilder builder = Response.status(Response.Status.OK);
    JsonWriter writer = new JsonWriter(new OutputStreamWriter(out, "UTF-8"));
    writer.setIndent("  ");
    String[] domains = mbs.getDomains();
    writer.beginArray();
    for (String domain : domains) {
      writer.value(domain);
      //link to this domain
      builder.link(uriInfo.getAbsolutePathBuilder().path(domain).build(), domain);
    }
    writer.flush();
    writer.endArray();
    writer.close();
    String json =  out.toString();
    // add Json to the response
    builder.entity(json);
    
    return builder.build();
  }
