@GET
  @Produces(MediaType.TEXT_HTML)
  public String getMBeanInfo(@Context UriInfo uriInfo) {
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "getMBeanInfo(" + uriInfo + ")");
    
    StringBuilder buff = new StringBuilder();
    buff.append("<html><body>\n");
    
    buff.append("<head>\n");
    buff.append("<style media=\"screen\" type=\"text/css\">\n");
    
    /* CSS */
    buff.append("input {\n");
    buff.append("  display: none;\n");
    buff.append("}\n");
    
    buff.append("input ~ ul {\n");
    buff.append("  display: none;\n");
    buff.append("  }\n");
    buff.append(" input:checked ~ ul {\n");
    buff.append("  display: block;\n");
    buff.append(" }\n");
    
    buff.append("input ~ .fa-angle-double-down {\n");
    buff.append("  display: none;\n");
    buff.append(" }\n");
    buff.append(" input:checked ~ .fa-angle-double-right {\n");
    buff.append("  display: none;\n");
    buff.append(" }\n");
    buff.append(" input:checked ~ .fa-angle-double-down {\n");
    buff.append("  display: inline;\n");
    buff.append(" }\n");
    
    buff.append("li {\n");
    buff.append("  display: block;\n");
    buff.append("  font-family: 'Arial';\n");
    buff.append("  font-size: 15px;\n");
    buff.append("  padding: 0.2em;\n");
    buff.append("  border: 1px solid transparent;\n");
    buff.append("}\n");
    
    buff.append("li:hover {\n");
    buff.append("  border: 1px solid grey;\n");
    buff.append("  border-radius: 3px;\n");
    buff.append("  background-color: lightgrey;\n");
    buff.append("}\n");
    
    buff.append(" </style>\n");
    buff.append("</head>\n");
    
    // help
    buff.append("<a href=\"");
    buff.append(uriInfo.getBaseUri());
    buff.append("help\">");
    buff.append("help</a>");
    buff.append("<br>");
    buff.append("<br>");
    //buff.append("<h3>MBeans browser</h3>");
    buff.append("<h3 style=\"background-color:#dcdcdc; padding:10px;\">MBeans browser</h3>");
    buff.append("<br>");
    try {
      buff.append("<div id=\"tree\">\n");
      HashMap<String, HashMap<String, ArrayList<ObjectName>>> domains = beanToTree();
      int i = 0;
      for (Entry<String, HashMap<String, ArrayList<ObjectName>>> entry : domains.entrySet()) {
        String domain = entry.getKey();
        openDomain(buff, domain, ++i);
        for (Entry<String, ArrayList<ObjectName>> typeEntry : entry.getValue().entrySet()) {
          String type = typeEntry.getKey();
          openType(buff, type, ++i);
          for (ObjectName objectName : typeEntry.getValue()) {
            openAttribute(buff, uriInfo, objectName, ++i);
            closeAttribute(buff);
          }
          closeType(buff);
        }
        closeDomain(buff);
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    buff.append("</body></html>");

    return buff.toString();
  }
