@GET
  @Path("/domains/{domain}/{objectName}")
  @Produces(MediaType.TEXT_HTML)
  public String getObjectName(
      @PathParam("domain") String domain,
      @PathParam("objectName") String objName,
      @Context UriInfo uriInfo) 
          throws IntrospectionException, InstanceNotFoundException, MalformedObjectNameException, 
          ReflectionException, NullPointerException {
    
    if (logger.isLoggable(BasicLevel.INFO))
      logger.log(BasicLevel.INFO, "GET: " + uriInfo.getAbsolutePathBuilder());
    
    if (logger.isLoggable(BasicLevel.DEBUG))
      logger.log(BasicLevel.DEBUG, "getObjectName(" + domain + ", " + objName + ", " + uriInfo + ")");
    
    StringBuilder buff = new StringBuilder();
    buff.append("<html><body>\n");
    ObjectName objectName = ObjectName.getInstance(objName);
    MBeanInfo mbeanInfo = mbs.getMBeanInfo(objectName);
    MBeanAttributeInfo[] attributes = mbeanInfo.getAttributes();
    for (MBeanAttributeInfo attribute : attributes) {
      buff.append("<br>  <a href=\"");
      buff.append(uriInfo.getAbsolutePathBuilder()
          .path(attribute.getName()));
      buff.append("\">");
      buff.append(attribute.getName());
      buff.append("</a>\t=\t");
      try {
        buff.append(getAttribute(objectName, attribute.getName()));
      } catch (Exception e) {
        buff.append(e.getClass().getName() + ": " + e.getMessage());
      }
      buff.append("\n");
    }
    buff.append("</body></html>");
    return buff.toString();
  }
