@Override
  public void onMessage(Message msg) {
    try {
    Trace.debug("ActionListener: get " + msg);
    Destination replyTo = null;
    String correlationId = null;
    ActionReturn reply = null;
    try {
      replyTo = msg.getJMSReplyTo();
      correlationId = msg.getJMSMessageID();
    } catch (JMSException exc) {
      Trace.error("ActionListener: Cannot get replyTo.");
    }
    
    try {
      int type = msg.getIntProperty("type");
      Action action = (Action) ((ObjectMessage) msg).getObject();
      Trace.debug("ActionListener: call handler");
      reply = handler.onAction(action);
    } catch (Exception exc) {
      Trace.error("ActionListener: Bad action.", exc);
      reply = new ActionReturn(ActionReturn.ERROR, "Bad action definition");
    }

    Trace.debug("ActionListener: reply to " + replyTo);
    if (replyTo != null) {
      Message replyMsg;
      if (reply == null)
        reply = new ActionReturn(ActionReturn.NOP);
      try {
        replyMsg = session.createMessage();
        replyMsg.setJMSCorrelationID(correlationId);
        replyMsg.setIntProperty("replyCode", reply.error);
        if (reply.msg != null)
          replyMsg.setStringProperty("replyMsg", reply.msg);
        producer.send(replyTo, replyMsg);
      } catch (JMSException exc) {
        Trace.error("ActionListener: Cannot send reply.", exc);
      }
    }
    try {
      session.commit();
    } catch (JMSException exc) {
      Trace.error("ActionListener: Cannot commit.", exc);
    }
    } catch (Throwable t) {
      Trace.fatal("ActionListener.onMessage", t);
    } finally {
      Trace.debug("ActionListener: end ");
    }
  }
