synchronized ActionReturn request(Destination dest, String callee, Action action) throws JMSException {
    if (dest == null)
      throw new IllegalStateException("Cannot request \"null\" destination");

    ObjectMessage request = session.createObjectMessage();
    request.setJMSReplyTo(queue);
    request.setStringProperty("callee", callee);
    request.setIntProperty("type", action.getType());
    request.setObject(action);
    prod.send(dest, request);
    String msgid = request.getJMSMessageID();
    
    Message reply = null;
    do {
      reply = cons.receive();
    } while ((reply != null) && !msgid.equals(reply.getJMSCorrelationID()));
    
    return new ActionReturn(reply.getIntProperty("replyCode"),
                            reply.getStringProperty("replyMsg"));
  }
