public static ClientFramework createFramework(String name, String host, int port) throws Exception {
    Trace.debug("ClientFramework.createFramework()");

    if (framework != null)
      throw new IllegalStateException("Framework is already initialized");

    // Initializes the ConnectionFactory.
    ConnectionFactory cf = TcpConnectionFactory.create(host, port);
    FactoryParameters parameters = cf.getParameters();
    parameters.connectingTimer = 5;
    parameters.cnxPendingTimer = 5000;

    framework = new ClientFramework(name, cf);
    return framework;
  }
