@Override
  public synchronized void setInventoryCMDBHandler(InventoryHandler handler) throws Exception {
    if (cmdbListener != null) {
      Trace.error("CMDB inventory handler is already set.");
      throw new Exception("CMDB inventory handler is already set.");
    }
    try {
      cmdbListener = new InventoryListener(handler, cnx, CMDBTopic);
    } catch (JMSException exc) {
      Trace.error("Cannot initialize CMDB inventory framework.");
      throw exc;
    }
  }
