public void run() {
    try {
      // getting initial context
      ictx = new InitialContext();
      // connecting to agent agBillingConnQ
      QueueConnectionFactory qcf ;
      qcf = (QueueConnectionFactory) ictx.lookup("qcf");
      // connecting to queueCheck, queueChecked and queueBills 
      Queue queueCheck ;
      queueCheck = (Queue) ictx.lookup("qCheck");
      Queue queueChecked ;
      queueChecked = (Queue) ictx.lookup("qChecked");
      Queue queueBills ;
      queueBills = (Queue) ictx.lookup("qBills");
      ictx.close();

      // creating a QueueConnection 
      QueueConnection qc = qcf.createQueueConnection("billing", "billing");
      // creating a QueueSession         
      QueueSession qsession = qc.createQueueSession(true, Session.AUTO_ACKNOWLEDGE);
      // creating a QueueSender (sending to queueCheck)
      QueueSender qsCheck = qsession.createSender(queueCheck);
      // creating a QueueReceiver (receiving from queueChecked) 
      QueueReceiver qr = qsession.createReceiver(queueChecked);
      // creating a QueueSender (sending to queueBills)     
      QueueSender qsBills = qsession.createSender(queueBills);
      // starting the QueueConnection 
      qc.start() ;	 
      
      System.out.println("BillingServer is ready.");
      
      while (true) {
      	// ObjectMessage got from the FifoQueue
        ObjectMessage msg ;
        
      	// waiting for the FifoQueue to be filled 
        msg = (ObjectMessage) queue.get() ;
      
        // poping out FifoQueue's first ObjectMessage 
        msg = (ObjectMessage) queue.pop();
        
        // if msg encapsulates a QuitMessage, close sessions and connections
        if (msg.getObject() instanceof QuitMessage) {
          // getting the QuitMessage
          QuitMessage quitMsg = (QuitMessage) msg.getObject() ;
          // creating an ObjectMessage and encapsulating the QuitMessage 
          ObjectMessage msgSent = qsession.createObjectMessage();
          msgSent.setObject(quitMsg) ;
          // forwarding the QuitMessage to ControlServer 
          qsCheck.send(msgSent) ;
          qsession.commit() ;
          
          // closing sessions and connections
          tsession.close() ;
          tc.close() ;
          qsession.close() ;
          qc.close() ;
          
          System.out.println("Sessions and connections closed by BillingServer.");
          System.exit(0) ;
        }
        
        // if msg encapsulates an OrderMessage, treat it
        else if (msg.getObject() instanceof OrderMessage) {
          // get OrderMessage 
          OrderMessage orderMsg = (OrderMessage) msg.getObject() ;
        
          System.out.println("Message received by BillingServer from WebServer: " + orderMsg.id) ;
         
	      // creating an ObjectMessage and encapsulating the OrderMessage 
	      ObjectMessage msgSent = qsession.createObjectMessage();
	      msgSent.setObject(orderMsg) ;
	      // sending the ObjectMessage to topicCheck 
	      qsCheck.send(msgSent) ; 
	      // commiting the sending
	      qsession.commit() ;
	
	      // receiving an ObjectMessage from queueChecked 
	      ObjectMessage msgRec = (ObjectMessage) qr.receive() ;
	      // getting encapsulated OkMessage 
	      OkMessage okMsg = (OkMessage)(msgRec.getObject()) ;
	
	      System.out.println("Message received by BillingServer from ControlServer: " + okMsg.id) ;
	 
	      // creating an ObjectMessage and encapsulating the OkMessage 
	      msgSent = qsession.createObjectMessage() ;
	      msgSent.setObject(okMsg) ;
	      // sending the ObjectMessage to queueBills 
	      qsBills.send(msgSent);
	
	      // commiting reception from queueChecked and sending to queueBills
	      qsession.commit() ;
        }
      }
    } catch (Exception exc) {
      System.out.println("Exception caught in BillingServer thread: " + exc) ;
      exc.printStackTrace() ;
    } 
  }
