public void run() {  	
    // creating the GUI representing the ControlServer 
    controlGUI = new GUI("Control Server", "Validate", "Don't validate", this, 700, 300) ;
    
    try {
      // getting initial context
      ictx = new InitialContext();
      // connecting to agent agControlConnQ 
      QueueConnectionFactory qcf;
      qcf = (QueueConnectionFactory) ictx.lookup("qcf");
      // connecting to queueCheck and queueChecked 
      Queue queueCheck ;
      queueCheck = (Queue) ictx.lookup("qCheck");
      Queue queueChecked;
      queueChecked = (Queue) ictx.lookup("qChecked");
      ictx.close();

      // creating a QueueConnection 
      QueueConnection qc = qcf.createQueueConnection("control", "control");
      // creating a QueueSession         
      qsession = qc.createQueueSession(true, Session.AUTO_ACKNOWLEDGE);
      // creating a QueueReceiver (receiving from queueCheck) and a QueueSender (sending to queueChecked) 
      QueueReceiver qr = qsession.createReceiver(queueCheck);
      qs = qsession.createSender(queueChecked);
      // starting the connection
      qc.start() ;
      
      // creating the lock object
      lock = new Object() ;
      
      System.out.println("ControlServer is ready.") ;
         
      while (true) {
        // receiving an ObjectMessage from queueCheck
	    ObjectMessage msg = (ObjectMessage) qr.receive() ;
	
        // if msg encapsulates a QuitMessage
        if (msg.getObject() instanceof QuitMessage) {
          // commiting the reception
          qsession.commit() ;
        
          // closing session and connection
          qsession.close() ;
          qc.close() ;
          
          System.out.println("Session and connection closed by ControlServer.");
          System.exit(0) ;
        }
        
        // if msg encapsulates an OrderMessage, treat it
        else if (msg.getObject() instanceof OrderMessage) {
          // get OrderMessage 
          orderMsg = (OrderMessage) msg.getObject() ;
        
          System.out.println("Message received by ControlServer from BillingServer: " + orderMsg.id);
        
          // updating and activating GUI 
          controlGUI.updateId(orderMsg.id) ;
          controlGUI.updateItem(orderMsg.item) ;
          controlGUI.setVisible(true) ;
        
          // waiting for GUI interaction 
          synchronized(lock) {
            lock.wait() ;
          }
        }
      }
    } catch (Exception exc) {
      System.out.println("Exception caught in ControlServer thread: " + exc) ;
      exc.printStackTrace() ;
    }	  
  }
