public void run() {
    // creating the GUI representing the InventoryServer 
    stockGUI = new GUI("Inventory Server", "Validate", "Don't validate", this, 700, 600) ;
        
    try {
      // getting initial context
      ictx = new InitialContext();
      
      // connecting to agent agInventConnQ
      QueueConnectionFactory qcf;
      qcf = (QueueConnectionFactory) ictx.lookup("qcf");
      // connecting to queueItems 
      Queue queueItems;
      queueItems = (Queue) ictx.lookup("qItems");
      ictx.close();

      // creating a QueueConnection  
      QueueConnection qc = qcf.createQueueConnection("inventory", "inventory");
      // creating a QueueSession 
      qsession = qc.createQueueSession(true, Session.AUTO_ACKNOWLEDGE);
      // creating a QueueSender (sending to queueItems) 
      qs = qsession.createSender(queueItems);
      
      System.out.println("InventoryServer is ready.") ;
      
      // creating the lock object
      lock = new Object() ;
      
      while (true) {
        // ObjectMessage got from the FifoQueue
        ObjectMessage msg ;
        
      	// waiting for the FifoQueue to be filled 
        msg = (ObjectMessage) queue.get() ;
      
        // poping out FifoQueue's first OrderMessage 
        msg = (ObjectMessage) queue.pop();
        
        // if msg encapsulates a QuitMessage, close sessions and connections
        if (msg.getObject() instanceof QuitMessage) {
          tsession.close() ;
          tc.close() ;
          qsession.close() ;
          qc.close() ;
          
          System.out.println("Sessions and connections closed by InventoryServer.");
          System.exit(0) ;
        }
        
        // if msg encapsulates an OrderMessage, treate it
        else if (msg.getObject() instanceof OrderMessage) {
          // get OrderMessage 
          orderMsg = (OrderMessage) msg.getObject() ;
        
          System.out.println("Message received by InventoryServer from WebServer: " + orderMsg.id) ;

          // updating and activating GUI 
          stockGUI.updateId(orderMsg.id) ;
          stockGUI.updateItem(orderMsg.item) ;
          stockGUI.setVisible(true) ;

          // waiting for GUI interaction 
          synchronized(lock) {
            lock.wait() ;
          }
        }
      } 
    } catch (Exception exc) {
      System.out.println("Exception caught in InventoryServer thread: " + exc);
      exc.printStackTrace() ;  
    }	  
  }
