public void run()
  {
    try {
      //Getting initial context
      ictx = new InitialContext();
      // connecting to agent agWebConnT
      TopicConnectionFactory tcf = (TopicConnectionFactory) ictx.lookup("tcf");
      // connecting to topicOrders 	    
      Topic topicOrders = (Topic) ictx.lookup("tOrders");
      ictx.close();

      // creating a TopicConnection 
      tc = tcf.createTopicConnection("web", "web");
      // creating a TopicSession 
      tsession = tc.createTopicSession(true, Session.AUTO_ACKNOWLEDGE);  
      // creating a TopicPublisher (publishing in topicOrders) 
      tp = tsession.createPublisher(topicOrders);
      
      // initializing orderId and choice
      orderId = 1 ;
      choice = "Shoes" ;
      
      // creating and activating the GUI representing the WebServer 
      webGUI = new GUI("WebServer" , this, 50, 300) ;
      webGUI.setVisible(true) ;
      
      System.out.println("WebServer is ready.") ;
      
    } catch (Exception exc) {
      System.out.println("Exception caught in WebServer thread: " + exc);
      exc.printStackTrace();
    }
  }
