HashMap<String, Object> receiveJSonMsg() {
    if (debug) System.out.println("== receive-next-message -> " + uriReceiveNextMsg);
    Response response = client.target(uriReceiveNextMsg)
        .queryParam("timeout", "30000")
        .request()
        .accept(MediaType.APPLICATION_JSON)
        .get();
    
    String json = response.readEntity(String.class);
    if (debug) System.out.println("Receive json = " + json);
    
    HashMap<String, Object> msg = null;
    if (response.getStatus() == Response.Status.OK.getStatusCode() && json != null) {
      Gson gson = new GsonBuilder().create();
      msg = gson.fromJson(json, HashMap.class);

      if (debug) {
        Map header = (Map) msg.get("header");
        Map props = (Map) msg.get("properties");

        System.out.println("*** header " + header);
        System.out.println("*** properties " + props);
        System.out.println("== receive-next-message = " + response.getStatus() + ", msg = " + msg);

        print(response.getLinks());
      }
      uriReceiveNextMsg = response.getLink("receive-next-message").getUri();
      uriAcknowledgeMsg = response.getLink("acknowledge-message").getUri();
    } else {
      System.out.println("ERROR receive-next-message = " + response.getStatus() + ", msg = " + json);
    }
    
    acknowledgeMessage();
    
    return msg;
  }
