void sendTextMessage(String content, HashMap<String, Object> header, HashMap<String, Object> props) {
    HashMap<String, Object> msg = new HashMap<String, Object>();

    msg.put("type", TextMessage);
    if ((header != null) && (header.size() > 0)) msg.put("header", header);
    if ((props != null) && (props.size() > 0)) msg.put("properties", props);
    msg.put("body", content);
    
    Gson gson = new GsonBuilder().create();
    String json = gson.toJson(msg);

    if (debug) System.out.println("send json = " + json);

    // Send next message
    Response response = client.target(uriSendNextMsg).request()
        .accept(MediaType.TEXT_PLAIN)
        .post(Entity.entity(json, MediaType.APPLICATION_JSON));

    if (debug) {
      System.out.println("== send-next-message = " + response.getStatus());
      print(response.getLinks());
    }
    
    uriSendNextMsg = response.getLink("send-next-message").getUri();
  }
