public void run() {
    try {
      Connection cnx = cf.createConnection();
      Session session = cnx.createSession(transacted, Session.AUTO_ACKNOWLEDGE);
      MessageProducer producer = session.createProducer(dest);
      if (MsgTransient) {
        producer.setDeliveryMode(javax.jms.DeliveryMode.NON_PERSISTENT);
      }
      
      StringBuffer strbuf = new StringBuffer();
      for (int i = 0; i< MsgSize; i++)
        strbuf.append('0');
      String content = strbuf.toString();

      long dtx = 0;
      long start = System.currentTimeMillis();
      for (int i=0; i<(Round*NbMsgPerRound); i++) {
        TextMessage msg = session.createTextMessage();
        //BytesMessage msg = session.createBytesMessage();
        if (SwapAllowed) {
          msg.setBooleanProperty("JMS_JORAM_SWAPALLOWED", true);
        }
        msg.setText(content);
        //msg.writeBytes(content);
        msg.setLongProperty("time", System.currentTimeMillis());
        msg.setIntProperty("index", i);
        
        producer.send(msg);

        if (transacted && ((i%10) == 9)) session.commit();

        if ((i%NbMsgPerRound) == (NbMsgPerRound-1)) {
          long dtx1 = (i * 1000L) / mps;
          long dtx2 = System.currentTimeMillis() - start;
          if (dtx1 > (dtx2 + 20)) {
            dtx += (dtx1 - dtx2);
            try {
              Thread.sleep(dtx1 - dtx2);
            } catch (InterruptedException exc) { }
          }
          if (dtx2 > 0)
            System.out.println("sent=" + i + ", mps=" + ((((long) i) * 1000L)/dtx2));
          else
            System.out.println("sent=" + i);
        }
      }
      long end = System.currentTimeMillis();
      long dt = end - start;

      System.out.println("----------------------------------------------------");
      System.out.println("| sender dt=" +  ((dt *1000L)/(Round*NbMsgPerRound)) + "us -> " +
          ((1000L * (Round*NbMsgPerRound)) / (dt)) + "msg/s");
      System.out.println("| sender wait=" + dtx + "ms");

      cnx.close();
    } catch (Exception exc) {
      exc.printStackTrace();
    }
  }
