static void centralAdmin() throws Exception {
    System.out.println();
    System.out.println("Central administration...");

    ConnectionFactory cf = TcpConnectionFactory.create("localhost", 16010);
    AdminModule.connect(cf, "root", "root");
    
    User.create("anonymous", "anonymous");

    Queue queue = Queue.create("mqs_dest");
    queue.setFreeReading();
    queue.setFreeWriting();

    Properties jndiProps = new Properties();
    jndiProps.setProperty("java.naming.factory.initial", "fr.dyade.aaa.jndi2.client.NamingContextFactory");
    jndiProps.setProperty("java.naming.factory.host", "localhost");
    jndiProps.setProperty("java.naming.factory.port", "16401");
    
    javax.naming.Context jndiCtx = new javax.naming.InitialContext(jndiProps);
    jndiCtx.bind("mqs_cf", cf);
    jndiCtx.bind("mqs_dest", queue);
    jndiCtx.close();

    AdminModule.disconnect();
    System.out.println("Admin closed.");
  }
