public void testConnect() throws Exception {
    inputBuffer = new ByteArrayOutputStream();

    socket = new Socket(host, port);
    System.out.println("Open connection to localhost:" + port);

    String connect = "CONNECT\n" +
      "login: " + login + "\n" + "passcode: " + passcode + "\n" +
      "request-id: 1\n" + "\n" + STOMP_NULL;
    sendFrame(connect);
    System.out.println("Send frame:" + connect + "\n------------------------------");
    
    String result = receiveFrame(10000);
    System.out.println("Receive frame:" + result + "\n------------------------------");

    String send = "SEND\n" +
      "destination:/queue/" + "#0.0.1026" + "\n\n" +
      "Hello World from STOMP client" + STOMP_NULL;
    sendFrame(send);
    System.out.println("Send frame:" + send + "\n------------------------------");

    String subscribe = "SUBSCRIBE\n" +
      "destination:/queue/" + "#0.0.1026" + "\n" + "ack:auto\n\n" + STOMP_NULL;
    sendFrame(subscribe);
    System.out.println("Send frame:" + subscribe + "\n------------------------------");

    try {
      while (true) {
        String msg1 = receiveFrame(10000);
        System.out.println("Receive frame:\n" + msg1 + "\n------------------------------");
      }
    } catch (SocketTimeoutException exc) {
    }

    String disconnect = "DISCONNECT\n" + "\n\n" + STOMP_NULL;
    sendFrame(disconnect);
    System.out.println("Send frame:" + disconnect);
  }
