private void deleteMsgSub(String userName, String subName, String msgId) {
    //Check user & subscription
    try {
      findClientSubscription(userName, subName);
    } catch(UserNotFoundException e) {
      System.err.println("Error: The user \""+userName+"\" does not exist.");          
      return;        
    } catch (SubscriptionNotFoundException e) {
      System.err.println("Error: The user \""+userName
          +"\" has no subscription of the name \""+subName+"\"");          
      return;
    }
    try {
      if(!SynchronousAgent.getSynchronousAgent().deleteSubMessage(userName, subName, msgId))
        System.err.println("Error: Couldn't delete message from "+userName
            +"'s subscription "+subName);
    } catch (InterruptedException e) {
      System.err.println("Error: Interrupted.");
      return;
    } catch (Exception e) {
      System.err.println("Error: Exception raised");
      e.printStackTrace();
      return;
    }
  }
