public static void help(String command) {
    //Checks whether the command name contains the namespace
    if(command.length()>NAMESPACE.length()
        && command.substring(0, NAMESPACE.length()).equalsIgnoreCase(NAMESPACE)) {
      //If so, remove the namespace part
      command = command.substring(NAMESPACE.length()+1, command.length());
    }
    String fullCommand = "["+NAMESPACE+":]"+command;
    StringBuffer buf = new StringBuffer();
    buf.append("Usage: ").append(fullCommand).append(" ");
    if(command.equalsIgnoreCase("list")) {
      buf.append("<category> [username]");
      buf.append("\n\tPossible categories: destination, topic, queue, user, subscription");
      buf.append("\n\tNB: For the subscription category, you must provide the user name.");     
    } else if(command.equalsIgnoreCase("help")) {
      buf.append("<command>");     
      buf.append("\nShows this help.");
    } else if(command.equalsIgnoreCase("create")) {
      buf.append("<topic|queue> <name> [option...]");
      buf.append("\n       ").append(fullCommand).append(" ");
      buf.append("user [<name>]\n");
      buf.append("Options: -sid <server id>\tSpecifies on which server the destination is to be created\n");
      buf.append("                         \tDefault: This server\n");
      buf.append("         -ext <extension>\tSpecifies which extension class to instanciate\n");
      buf.append("                         \tDefault: None");
    } else if(command.equalsIgnoreCase("queueLoad")) {
      buf.append("<queueName>");
    } else if(command.equalsIgnoreCase("subscriptionLoad")) {
      buf.append("<userName> <subscriptionName>");
    } else if(command.equalsIgnoreCase("delete")) {
      buf.append("(topic|queue|dest[ination]|user) <name>");
    } else if(command.equalsIgnoreCase("info")) {
      buf.append("(queue|topic) <name>");
      buf.append("\n       ").append(fullCommand).append(" ");
      buf.append("subscription <user name> <subscription name>");
    } else if(command.equalsIgnoreCase("lsMsg")) {
      buf.append("queue <queue name> [[first msg idx]:[last msg idx]]");
      buf.append("\n       ").append(fullCommand).append(" ");
      buf.append("subscription <username> <subscription name> [[first msg idx]:[last msg idx]]");
    } else if(command.equalsIgnoreCase("deleteMsg")) {
      buf.append("queue <queue name> <msg id>");
      buf.append("\n       ").append(fullCommand).append(" ");
      buf.append("subscription <username> <subscription name> <msg id>");
    } else if(command.equalsIgnoreCase("receiveMsg")) {
      buf.append("<queue name> [options]");
      buf.append("Options: -n <x>\tReceive only <x> messages");
      buf.append("         -t <x>\tTimes out after <x> seconds");
    } else if(command.equalsIgnoreCase("sendMsg")) {
      buf.append("(queue|topic) <destination name> <text>");
    } else if(command.equalsIgnoreCase("ping")) {
      buf.append("\nChecks whether a JoramAdminTopic exists.");
    } else if(command.equalsIgnoreCase("clear")) {
      buf.append("queue <name>");
      buf.append("\n       ").append(fullCommand).append(" ");
      buf.append("subscription <username> <subscription name>");
      buf.append("\nDeletes all pending messages.");
    } else if(command.equalsIgnoreCase("setFreeRead")) {
      buf.append("(topic|queue) <destination name> <value>");
      buf.append("\nChange destination's reading permission.");
    } else if(command.equalsIgnoreCase("setFreeWrite")) {
      buf.append("(topic|queue) <destination name> <value>");
      buf.append("\nChange destination's writing permission.");
    } else {
      System.err.println("Unknown command: "+command);
      return;
    }
    System.out.println(buf.toString());
  }
