private void listDestination() {
    Object[] obj = destinationTracker.getServices();
    
    if(obj == null || obj.length ==0) {
      System.out.println("There is no destination.");
      return;
    }
    
    HashMap<String, DestinationMBean> dests = new HashMap<String, DestinationMBean>();
    for(Object o : obj) {
      DestinationMBean d = (DestinationMBean) o;
      dests.put(d.getDestinationId(), d);
    }

    String[][] table = new String[dests.size()+1][];
    table[0] = new String[] { "Id",
                              "Name",
                              "Type",
                              "Creation Date",
                              "Perm."};
    int i = 1;
    for(DestinationMBean d : dests.values()) {
      String type = "NA";
      if(d instanceof TopicMBean)         type="Topic";
        else if(d instanceof QueueMBean)  type="Queue";
        else                              type="(Unknown)";
      table[i++] = new String[] { d.getDestinationId(),
                                d.getName(),
                                type,
                                d.getCreationDate(),
                                (d.isFreeReading()?"r":"-")+'/'
                                +(d.isFreeWriting()?"w":"-")};
    }
    int n = dests.size();
    if(n < 2)
      System.out.println("There is " + dests.size() + " destination.");
    else
      System.out.println("There are " + dests.size() + " destinations.");
    ShellDisplay.displayTable(table, true);
  }
