private void listQueue() {
    Object[] obj = queueTracker.getServices();
    
    if(obj == null || obj.length ==0) {
      System.out.println("There is no queue.");
      return;
    }
    
    HashMap<String, QueueMBean> dests = new HashMap<String, QueueMBean>();
    for(Object o : obj) {
      QueueMBean d = (QueueMBean) o;
      dests.put(d.getDestinationId(), d);
    }

    String[][] table = new String[dests.size()+1][];
    table[0] = new String[] { "Id",
                              "Name",
                              "Pending msg",
                              "Rcvd Msg",
                              "Dlvd Msg",
                              "Perm."};
    int i = 1;
    for(QueueMBean d : dests.values()) {
      table[i++] = new String[] { d.getDestinationId(),
                                d.getName(),
                                Integer.toString(d.getPendingMessageCount()),
                                Long.toString(d.getNbMsgsReceiveSinceCreation()),
                                Long.toString(d.getNbMsgsDeliverSinceCreation()),
                                (d.isFreeReading()?"r":"-")+'/'
                                +(d.isFreeWriting()?"w":"-")};
    }
    int n = dests.size();
    if(n < 2)
      System.out.println("There is " + dests.size() + " queue.");
    else
      System.out.println("There are " + dests.size() + " queues.");
    ShellDisplay.displayTable(table, true);    
  }
