private void listSubscription(String userName) {
    try {
    //Step 1: retrieve the user
    UserAgentMBean user = null;
    Object[] objs = userTracker.getServices();
    if(objs==null) {
      System.err.println("Error: No user found.");
      return;
    }
    for(Object o : objs) {
      UserAgentMBean u = (UserAgentMBean) o;
      if(u.getName().equals(userName)) {
        user = u;
        break;
      }
    }
    if(user == null) {
      System.err.println("Error: The user "+userName+" does not exist.");
      return;
    }
    //Step 2: retrieve the user's subscriptions
    String[] names = user.getSubscriptionNames();
    HashSet<ClientSubscriptionMBean> subs =
        new HashSet<ClientSubscriptionMBean>();
    Object[] clients = clientSubTracker.getServices();
    if(clients==null) {
      System.err.println("Error: No subscription found.");
      return;
    }
    for(Object o : clients) {
      ClientSubscriptionMBean s = (ClientSubscriptionMBean) o;
      for(String n : names)
        if(n.equals(s.getName())) {
          subs.add(s);
          break;
        }
    }
    if(subs.size()==0) {
      System.err.println("Error: The user "+userName+" has no subscription.");
      return;
    }
    
    //Step 3: Display
    String[][] table = new String[subs.size()+1][8];
    table[0] = new String[]{"Name",
                            "Topic Id",
                            "Pndng msgs",
                            "Wtng for ack.",
                            "Dlvd msg",
                            "Nb msg max",
                            "Sent to DMQ"};
    int i=1;
    for(ClientSubscriptionMBean sub : subs) {
      table[i] = new String[] {
        (sub.getName().length()>9
          ? sub.getName().subSequence(0, 9).toString()
          : sub.getName()), //Name
        sub.getTopicIdAsString(), //Topic Id
        String.valueOf(sub.getPendingMessageCount()), //Pending messages
        String.valueOf(sub.getDeliveredMessageCount()), //Waiting for ack.
        String.valueOf(sub.getNbMsgsDeliveredSinceCreation()), //Nb msg delivered
        String.valueOf(sub.getNbMaxMsg()), //Nb msg max
        String.valueOf(sub.getNbMsgsSentToDMQSinceCreation()) //Nb msg send to DMQ
      };
    }
    ShellDisplay.displayTable(table, true);
    }catch(StringIndexOutOfBoundsException e) {
      e.printStackTrace();
    }
  }
