private void listTopic() {
    Object[] obj = topicTracker.getServices();
    
    if(obj == null || obj.length ==0) {
      System.out.println("There is no topic.");
      return;
    }
    
    HashMap<String, TopicMBean> dests = new HashMap<String, TopicMBean>();
    for(Object o : obj) {
      TopicMBean d = (TopicMBean) o;
      dests.put(d.getDestinationId(), d);
    }

    String[][] table = new String[dests.size()+1][];
    table[0] = new String[] { "Id",
                              "Name",
                              "Subscriber",
                              "Rcvd Msg",
                              "Dlvd Msg",
                              "Perm."};
    int i = 1;
    for(TopicMBean d : dests.values()) {
      table[i++] = new String[] { d.getDestinationId(),
                                d.getName(),
                                Integer.toString(d.getNumberOfSubscribers()),
                                Long.toString(d.getNbMsgsReceiveSinceCreation()),
                                Long.toString(d.getNbMsgsDeliverSinceCreation()),
                                (d.isFreeReading()?"r":"-")+'/'
                                +(d.isFreeWriting()?"w":"-")};
    }
    int n = dests.size();
    if(n < 2)
      System.out.println("There is " + dests.size() + " topic.");
    else
      System.out.println("There are " + dests.size() + " topics.");
    ShellDisplay.displayTable(table, true);    
  }
