@Override
    public List<IAdminDashboardComponent> selectDashboardComponents( AdminDashboardFilter filter )
    {
        StringBuilder sbSQL = new StringBuilder( SQL_QUERY_SELECT );
        buildSQLFilter( sbSQL, filter );
        sbSQL.append( SQL_QUERY_ORDER_BY_COLUMN_AND_ORDER );

        DAOUtil daoUtil = new DAOUtil( sbSQL.toString( ) );

        applySQLFilter( daoUtil, 1, filter );

        daoUtil.executeQuery( );

        List<IAdminDashboardComponent> listDashboards = new ArrayList<IAdminDashboardComponent>( );

        while ( daoUtil.next( ) )
        {
            IAdminDashboardComponent dashboardComponent = null;

            String strBeanName = daoUtil.getString( 1 );

            dashboardComponent = findDashboardFromFactory( strBeanName );

            if ( dashboardComponent != null )
            {
                load( dashboardComponent, daoUtil );
                listDashboards.add( dashboardComponent );
            }
            else
            {
                AppLogService.error( "Admindashboard named " + strBeanName + " not found" );
            }
        }

        daoUtil.free( );

        return listDashboards;
    }
