public synchronized void insert( Page page )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_INSERT );

        int nNewPrimaryKey = newPrimaryKey( );
        page.setId( nNewPrimaryKey );
        page.setOrigParentPageId( page.getParentPageId( ) );

        daoUtil.setInt( 1, page.getId( ) );
        daoUtil.setInt( 2, page.getParentPageId( ) );
        daoUtil.setString( 3, page.getName( ) );
        daoUtil.setString( 4, page.getDescription( ) );
        daoUtil.setTimestamp( 5, new Timestamp( new java.util.Date( ).getTime( ) ) );
        daoUtil.setInt( 6, page.getPageTemplateId( ) );
        daoUtil.setInt( 7, page.getOrder( ) );
        daoUtil.setInt( 8, page.getStatus( ) );
        daoUtil.setString( 9, page.getRole( ) );

        daoUtil.setTimestamp( 10, page.getDateUpdate( ) == null ? new Timestamp( new java.util.Date( ).getTime( ) ) : page.getDateUpdate( ) );
        daoUtil.setString( 11, page.getCodeTheme( ) );
        daoUtil.setInt( 12, page.getNodeStatus( ) );
        daoUtil.setBytes( 13, page.getImageContent( ) );
        daoUtil.setString( 14, page.getMimeType( ) );

        if ( ( page.getMetaKeywords( ) != null ) && ( page.getMetaKeywords( ).length( ) > 0 ) )
        {
            daoUtil.setString( 15, page.getMetaKeywords( ) );
        }
        else
        {
            daoUtil.setString( 15, null );
        }

        if ( ( page.getMetaDescription( ) != null ) && ( page.getMetaDescription( ).length( ) > 0 ) )
        {
            daoUtil.setString( 16, page.getMetaDescription( ) );
        }
        else
        {
            daoUtil.setString( 16, null );
        }

        if ( page.getIdAuthorizationNode( ) != null )
        {
            daoUtil.setInt( 17, page.getIdAuthorizationNode( ) );
        }
        else
        {
            daoUtil.setIntNull( 17 );
        }
        daoUtil.setBoolean( 18, page.getDisplayDateUpdate( ) );
        daoUtil.setBoolean( 19, page.getIsManualDateUpdate( ) );

        daoUtil.executeUpdate( );
        daoUtil.free( );
    }
