public Page loadWithoutImageContent( int nPageId, boolean bPortlets )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT_WITHOUT_IMAGE_CONTENT );
        daoUtil.setInt( 1, nPageId );

        daoUtil.executeQuery( );

        Page page = new Page( );

        if ( daoUtil.next( ) )
        {
            page.setId( nPageId );
            page.setParentPageId( daoUtil.getInt( 1 ) );
            page.setOrigParentPageId( daoUtil.getInt( 1 ) );
            page.setName( daoUtil.getString( 2 ) );
            page.setDescription( daoUtil.getString( 3 ) );
            page.setPageTemplateId( daoUtil.getInt( 4 ) );
            page.setTemplate( daoUtil.getString( 5 ) );
            page.setOrder( daoUtil.getInt( 6 ) );
            page.setStatus( daoUtil.getInt( 7 ) );
            page.setRole( daoUtil.getString( 8 ) );
            page.setCodeTheme( daoUtil.getString( 9 ) );
            page.setNodeStatus( daoUtil.getInt( 10 ) );
            page.setMimeType( daoUtil.getString( 11 ) );
            page.setDateUpdate( daoUtil.getTimestamp( 12 ) );
            page.setMetaKeywords( daoUtil.getString( 13 ) );
            page.setMetaDescription( daoUtil.getString( 14 ) );

            if ( daoUtil.getObject( 15 ) != null )
            {
                page.setIdAuthorizationNode( daoUtil.getInt( 15 ) );
            }

            // Patch perfs : close connection before loadPortlets
            daoUtil.free( );

            // Loads the portlets contained into the page
            if ( bPortlets )
            {
                loadPortlets( page );
            }
        }

        daoUtil.free( );

        return page;
    }
