public Collection<StyleSheet> selectStyleSheetList( int nModeId )
    {
        Collection<StyleSheet> stylesheetList = new ArrayList<StyleSheet>( );

        String strSelect = " SELECT a.id_stylesheet , a.description , a.file_name ";
        String strFrom = " FROM core_stylesheet a ";

        if ( nModeId != -1 )
        {
            strFrom = " FROM  core_stylesheet a , core_style_mode_stylesheet b " + " WHERE a.id_stylesheet = b.id_stylesheet " + " AND b.id_mode = ? ";
        }

        strFrom += " ORDER BY a.description ";

        String strSQL = strSelect + strFrom;

        DAOUtil daoUtil = new DAOUtil( strSQL );

        if ( nModeId != -1 )
        {
            daoUtil.setInt( 1, nModeId );
        }

        daoUtil.executeQuery( );

        while ( daoUtil.next( ) )
        {
            StyleSheet stylesheet = new StyleSheet( );

            stylesheet.setId( daoUtil.getInt( 1 ) );
            stylesheet.setDescription( daoUtil.getString( 2 ) );
            stylesheet.setFile( daoUtil.getString( 3 ) );
            stylesheetList.add( stylesheet );
        }

        daoUtil.free( );

        return stylesheetList;
    }
