@Override
    public AdminUser load( int nUserId )
    {
        AdminUser user = null;
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT_USER_FROM_USER_ID );
        daoUtil.setInt( 1, nUserId );
        daoUtil.executeQuery( );

        if ( daoUtil.next( ) )
        {
            user = new AdminUser( );
            user.setUserId( daoUtil.getInt( 1 ) );
            user.setAccessCode( daoUtil.getString( 2 ) );
            user.setLastName( daoUtil.getString( 3 ) );
            user.setFirstName( daoUtil.getString( 4 ) );
            user.setEmail( daoUtil.getString( 5 ) );
            user.setStatus( daoUtil.getInt( 6 ) );
            user.setLocale( new Locale( daoUtil.getString( 8 ) ) );
            user.setUserLevel( daoUtil.getInt( 9 ) );
            user.setPasswordReset( daoUtil.getBoolean( 10 ) );
            user.setAccessibilityMode( daoUtil.getBoolean( 11 ) );
            user.setPasswordMaxValidDate( daoUtil.getTimestamp( 12 ) );

            long accountTime = daoUtil.getLong( 13 );

            if ( accountTime > 0 )
            {
                user.setAccountMaxValidDate( new Timestamp( accountTime ) );
            }
        }

        daoUtil.free( );

        return user;
    }
