@Override
    public AdminUser selectUserByAccessCode( String strUserAccessCode )
    {
        AdminUser user = null;
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT_USER_FROM_ACCESS_CODE );
        daoUtil.setString( 1, strUserAccessCode );
        daoUtil.executeQuery( );

        if ( daoUtil.next( ) )
        {
            user = new AdminUser( );
            user.setUserId( daoUtil.getInt( 1 ) );
            user.setAccessCode( daoUtil.getString( 2 ) );
            user.setLastName( daoUtil.getString( 3 ) );
            user.setFirstName( daoUtil.getString( 4 ) );
            user.setEmail( daoUtil.getString( 5 ) );
            user.setStatus( daoUtil.getInt( 6 ) );
            user.setLocale( new Locale( daoUtil.getString( 7 ) ) );
            user.setUserLevel( daoUtil.getInt( 8 ) );
            user.setPasswordReset( daoUtil.getBoolean( 9 ) );
            user.setAccessibilityMode( daoUtil.getBoolean( 10 ) );
            user.setPasswordMaxValidDate( daoUtil.getTimestamp( 11 ) );

            Timestamp dateLastLogin = daoUtil.getTimestamp( 12 );

            if ( ( dateLastLogin != null ) && !dateLastLogin.equals( AdminUser.DEFAULT_DATE_LAST_LOGIN ) )
            {
                user.setDateLastLogin( dateLastLogin );
            }
        }

        daoUtil.free( );

        return user;
    }
