@Override
    public Collection<AdminUser> selectUserList( )
    {
        Collection<AdminUser> userList = new ArrayList<AdminUser>( );
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECTALL );
        daoUtil.executeQuery( );

        while ( daoUtil.next( ) )
        {
            AdminUser user = new AdminUser( );
            user.setUserId( daoUtil.getInt( 1 ) );
            user.setAccessCode( daoUtil.getString( 2 ) );
            user.setLastName( daoUtil.getString( 3 ) );
            user.setFirstName( daoUtil.getString( 4 ) );
            user.setEmail( daoUtil.getString( 5 ) );
            user.setStatus( daoUtil.getInt( 6 ) );
            user.setLocale( new Locale( daoUtil.getString( 7 ) ) );
            user.setUserLevel( daoUtil.getInt( 8 ) );
            user.setAccessibilityMode( daoUtil.getBoolean( 9 ) );
            user.setPasswordReset( daoUtil.getBoolean( 10 ) );
            user.setPasswordMaxValidDate( daoUtil.getTimestamp( 11 ) );

            long accountTime = daoUtil.getLong( 12 );

            if ( accountTime > 0 )
            {
                user.setAccountMaxValidDate( new Timestamp( accountTime ) );
            }

            Timestamp dateLastLogin = daoUtil.getTimestamp( 13 );

            if ( ( dateLastLogin != null ) && !dateLastLogin.equals( AdminUser.DEFAULT_DATE_LAST_LOGIN ) )
            {
                user.setDateLastLogin( dateLastLogin );
            }

            user.setWorkgroupKey( daoUtil.getString( 14 ) );
            userList.add( user );
        }

        daoUtil.free( );

        return userList;
    }
