@Override
    public Collection<AdminUser> selectUsersByFilter( AdminUserFilter auFilter )
    {
        Collection<AdminUser> userList = new ArrayList<AdminUser>( );
        DAOUtil daoUtil;

        String query = SQL_QUERY_SELECT_USER_FROM_SEARCH;

        if ( auFilter.getStatus( ) != -1 )
        {
            query += CONSTANT_AND_STATUS;
        }

        if ( auFilter.getUserLevel( ) != -1 )
        {
            query += CONSTANT_AND_USER_LEVEL;
        }

        query += CONSTANT_ORDER_BY_LAST_NAME;

        daoUtil = new DAOUtil( query );
        daoUtil.setString( 1, CONSTANT_PERCENT + auFilter.getAccessCode( ) + CONSTANT_PERCENT );
        daoUtil.setString( 2, CONSTANT_PERCENT + auFilter.getLastName( ) + CONSTANT_PERCENT );
        daoUtil.setString( 3, CONSTANT_PERCENT + auFilter.getEmail( ) + CONSTANT_PERCENT );

        if ( auFilter.getStatus( ) != -1 )
        {
            daoUtil.setInt( 4, auFilter.getStatus( ) );

            if ( auFilter.getUserLevel( ) != -1 )
            {
                daoUtil.setInt( 5, auFilter.getUserLevel( ) );
            }
        }
        else
        {
            if ( auFilter.getUserLevel( ) != -1 )
            {
                daoUtil.setInt( 4, auFilter.getUserLevel( ) );
            }
        }

        daoUtil.executeQuery( );

        while ( daoUtil.next( ) )
        {
            AdminUser user = new AdminUser( );
            user.setUserId( daoUtil.getInt( 1 ) );
            user.setAccessCode( daoUtil.getString( 2 ) );
            user.setLastName( daoUtil.getString( 3 ) );
            user.setFirstName( daoUtil.getString( 4 ) );
            user.setEmail( daoUtil.getString( 5 ) );
            user.setStatus( daoUtil.getInt( 6 ) );
            user.setLocale( new Locale( daoUtil.getString( 7 ) ) );
            user.setUserLevel( daoUtil.getInt( 8 ) );
            user.setAccessibilityMode( daoUtil.getBoolean( 9 ) );
            userList.add( user );
        }

        daoUtil.free( );

        return userList;
    }
