@Override
    public List<AdminUserField> selectUserFieldsByIdUserIdAttribute( int nIdUser, int nIdAttribute )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT_USER_FIELDS_BY_ID_USER_ID_ATTRIBUTE );
        daoUtil.setInt( 1, nIdUser );
        daoUtil.setInt( 2, nIdAttribute );
        daoUtil.executeQuery( );

        List<AdminUserField> listUserFields = new ArrayList<AdminUserField>( );

        while ( daoUtil.next( ) )
        {
            AdminUserField userField = new AdminUserField( );
            userField.setIdUserField( daoUtil.getInt( 1 ) );
            userField.setValue( daoUtil.getString( 6 ) );

            // FILE
            if ( daoUtil.getObject( 5 ) != null ) // f.id_file
            {
                File file = new File( );
                file.setIdFile( daoUtil.getInt( 5 ) ); // f.id_file
                userField.setFile( file );
            }

            // USER
            AdminUser user = new AdminUser( );
            user.setUserId( nIdUser );
            userField.setUser( user );

            // ATTRIBUTE
            IAttribute attribute = null;

            try
            {
                attribute = (IAttribute) Class.forName( daoUtil.getString( 7 ) ).newInstance( );
            }
            catch( ClassNotFoundException e )
            {
                // class doesn't exist
                AppLogService.error( e );
            }
            catch( InstantiationException e )
            {
                // Class is abstract or is an interface or haven't accessible
                // builder
                AppLogService.error( e );
            }
            catch( IllegalAccessException e )
            {
                // can't access to the class
                AppLogService.error( e );
            }

            attribute.setIdAttribute( nIdAttribute );
            attribute.setTitle( daoUtil.getString( 8 ) );
            attribute.setHelpMessage( daoUtil.getString( 9 ) );
            attribute.setMandatory( daoUtil.getBoolean( 10 ) );
            attribute.setPosition( daoUtil.getInt( 11 ) );
            userField.setAttribute( attribute );

            // ATTRIBUTEFIELD
            AttributeField attributeField = new AttributeField( );
            attributeField.setIdField( daoUtil.getInt( 4 ) );
            userField.setAttributeField( attributeField );

            listUserFields.add( userField );
        }

        daoUtil.free( );

        return listUserFields;
    }
