@Override
    public List<AdminUser> selectUsersByFilter( AdminUserFieldFilter auFieldFilter )
    {
        List<AdminUserField> listUserFields = auFieldFilter.getListUserFields( );

        if ( ( listUserFields == null ) || ( listUserFields.size( ) == 0 ) )
        {
            return null;
        }

        List<AdminUser> listUsers = new ArrayList<AdminUser>( );
        StringBuilder sbSQL = new StringBuilder( SQL_QUERY_SELECT_USERS_BY_FILTER );

        for ( int i = 1; i <= listUserFields.size( ); i++ )
        {
            if ( i == 1 )
            {
                sbSQL.append( SQL_ID_ATTRIBUTE_AND_USER_FIELD_VALUE );
            }
            else
            {
                sbSQL.append( CONSTANT_OPEN_BRACKET + SQL_QUERY_SELECT_ID_USER );
            }

            if ( ( i != listUserFields.size( ) ) && ( i != 1 ) )
            {
                sbSQL.append( SQL_AND_ID_USER_IN );
            }
            else
                if ( ( i != listUserFields.size( ) ) && ( i == 1 ) )
                {
                    sbSQL.append( SQL_AND_ID_USER_IN_FIRST );
                }
        }

        for ( int i = 2; i <= listUserFields.size( ); i++ )
        {
            sbSQL.append( CONSTANT_CLOSED_BRACKET );
        }

        DAOUtil daoUtil = new DAOUtil( sbSQL.toString( ) );

        int nbCount = 1;

        for ( AdminUserField userField : listUserFields )
        {
            daoUtil.setInt( nbCount++, userField.getAttribute( ).getIdAttribute( ) );
            daoUtil.setInt( nbCount++, userField.getAttributeField( ).getIdField( ) );
            daoUtil.setString( nbCount++, CONSTANT_PERCENT + userField.getValue( ) + CONSTANT_PERCENT );
        }

        daoUtil.executeQuery( );

        while ( daoUtil.next( ) )
        {
            AdminUser user = new AdminUser( );
            user.setUserId( daoUtil.getInt( 1 ) );
            user.setAccessCode( daoUtil.getString( 2 ) );
            user.setLastName( daoUtil.getString( 3 ) );
            user.setFirstName( daoUtil.getString( 4 ) );
            user.setEmail( daoUtil.getString( 5 ) );
            user.setStatus( daoUtil.getInt( 6 ) );

            Locale locale = new Locale( daoUtil.getString( 7 ) );
            user.setLocale( locale );
            listUsers.add( user );
        }

        daoUtil.free( );

        return listUsers;
    }
