public IAttribute load( int nIdAttribute, Locale locale )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT );
        daoUtil.setInt( 1, nIdAttribute );
        daoUtil.executeQuery( );

        IAttribute attribute = null;

        if ( daoUtil.next( ) )
        {
            int nIndex = 1;

            try
            {
                attribute = (IAttribute) Class.forName( daoUtil.getString( nIndex++ ) ).newInstance( );
            }
            catch( ClassNotFoundException e )
            {
                // class doesn't exist
                AppLogService.error( e );
            }
            catch( InstantiationException e )
            {
                // Class is abstract or is an interface or haven't accessible
                // builder
                AppLogService.error( e );
            }
            catch( IllegalAccessException e )
            {
                // can't access to rhe class
                AppLogService.error( e );
            }

            attribute.setIdAttribute( daoUtil.getInt( nIndex++ ) );
            attribute.setTitle( daoUtil.getString( nIndex++ ) );
            attribute.setHelpMessage( daoUtil.getString( nIndex++ ) );
            attribute.setMandatory( daoUtil.getBoolean( nIndex++ ) );
            attribute.setShownInSearch( daoUtil.getBoolean( nIndex++ ) );
            attribute.setShownInResultList( daoUtil.getBoolean( nIndex++ ) );
            attribute.setFieldInLine( daoUtil.getBoolean( nIndex++ ) );
            attribute.setPosition( daoUtil.getInt( nIndex++ ) );
            attribute.setAttributeType( locale );

            Plugin plugin = PluginService.getPlugin( daoUtil.getString( nIndex++ ) );
            attribute.setPlugin( plugin );
        }

        daoUtil.free( );

        return attribute;
    }
