@Override
    public IAttribute selectAttributeByIdField( int nIdField )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_SELECT_ATTRIBUTE_BY_ID_FIELD );
        daoUtil.setInt( 1, nIdField );
        daoUtil.executeQuery( );

        IAttribute attribute = null;

        if ( daoUtil.next( ) )
        {
            try
            {
                attribute = (IAttribute) Class.forName( daoUtil.getString( 1 ) ).newInstance( );
            }
            catch( ClassNotFoundException e )
            {
                // class doesn't exist
                AppLogService.error( e );
            }
            catch( InstantiationException e )
            {
                // Class is abstract or is an interface or haven't accessible
                // builder
                AppLogService.error( e );
            }
            catch( IllegalAccessException e )
            {
                // can't access to rhe class
                AppLogService.error( e );
            }

            attribute.setIdAttribute( daoUtil.getInt( 2 ) );
            attribute.setTitle( daoUtil.getString( 3 ) );
            attribute.setHelpMessage( daoUtil.getString( 4 ) );
            attribute.setMandatory( daoUtil.getBoolean( 5 ) );
            attribute.setPosition( daoUtil.getInt( 6 ) );
        }

        daoUtil.free( );

        return attribute;
    }
