@Override
    public List<AdminUserField> getUserFieldsData( HttpServletRequest request, AdminUser user )
    {
        String strUpdateAttribute = request.getParameter( PARAMETER_UPDATE_ATTRIBUTE + CONSTANT_UNDERSCORE + getIdAttribute( ) );
        List<AdminUserField> listUserFields = new ArrayList<AdminUserField>( );

        try
        {
            if ( StringUtils.isNotBlank( strUpdateAttribute ) )
            {
                MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
                FileItem fileItem = multipartRequest.getFile( PARAMETER_ATTRIBUTE + CONSTANT_UNDERSCORE + getIdAttribute( ) );

                if ( ( fileItem != null ) && ( fileItem.getName( ) != null ) && !EMPTY_STRING.equals( fileItem.getName( ) ) )
                {
                    File file = new File( );
                    PhysicalFile physicalFile = new PhysicalFile( );
                    physicalFile.setValue( fileItem.get( ) );
                    file.setTitle( FileUploadService.getFileNameOnly( fileItem ) );
                    file.setSize( (int) fileItem.getSize( ) );
                    file.setPhysicalFile( physicalFile );
                    file.setMimeType( FileSystemUtil.getMIMEType( FileUploadService.getFileNameOnly( fileItem ) ) );

                    // verify that the file is an image
                    ImageIO.read( new ByteArrayInputStream( file.getPhysicalFile( ).getValue( ) ) );

                    AdminUserField userField = new AdminUserField( );
                    userField.setUser( user );
                    userField.setAttribute( this );

                    AttributeService.getInstance( ).setAttributeField( this );

                    if ( ( getListAttributeFields( ) != null ) && ( getListAttributeFields( ).size( ) > 0 ) )
                    {
                        userField.setAttributeField( getListAttributeFields( ).get( 0 ) );
                        userField.setFile( file );
                    }

                    listUserFields.add( userField );
                }
            }
            else
            {
                AdminUserFieldFilter auFieldFilter = new AdminUserFieldFilter( );
                auFieldFilter.setIdAttribute( getIdAttribute( ) );

                String strIdUser = request.getParameter( PARAMETER_ID_USER );

                if ( StringUtils.isNotBlank( strIdUser ) )
                {
                    auFieldFilter.setIdUser( StringUtil.getIntValue( strIdUser, 0 ) );
                }

                listUserFields = AdminUserFieldHome.findByFilter( auFieldFilter );

                for ( AdminUserField userField : listUserFields )
                {
                    if ( userField.getFile( ) != null )
                    {
                        File file = FileHome.findByPrimaryKey( userField.getFile( ).getIdFile( ) );
                        userField.setFile( file );

                        int nIdPhysicalFile = file.getPhysicalFile( ).getIdPhysicalFile( );
                        PhysicalFile physicalFile = PhysicalFileHome.findByPrimaryKey( nIdPhysicalFile );
                        userField.getFile( ).setPhysicalFile( physicalFile );
                    }
                }
            }
        }
        catch( IOException e )
        {
            AppLogService.error( e );
        }

        return listUserFields;
    }
