@Override
    public String setAttributeData( HttpServletRequest request )
    {
        String strTitle = request.getParameter( PARAMETER_TITLE );
        String strHelpMessage = ( request.getParameter( PARAMETER_HELP_MESSAGE ) != null ) ? request.getParameter( PARAMETER_HELP_MESSAGE ).trim( ) : null;
        String strMandatory = request.getParameter( PARAMETER_MANDATORY );
        String strWidth = request.getParameter( PARAMETER_WIDTH );
        String strHeight = request.getParameter( PARAMETER_HEIGHT );
        String strShownInResultList = request.getParameter( PARAMETER_IS_SHOWN_IN_RESULT_LIST );

        String strError = EMPTY_STRING;

        if ( StringUtils.isNotBlank( strTitle ) )
        {
            setTitle( strTitle );
            setHelpMessage( strHelpMessage );
            setMandatory( strMandatory != null );
            setShownInResultList( strShownInResultList != null );
            // Never show an image in the search box
            setShownInSearch( false );

            if ( getListAttributeFields( ) == null )
            {
                List<AttributeField> listAttributeFields = new ArrayList<AttributeField>( );
                AttributeField attributeField = new AttributeField( );
                listAttributeFields.add( attributeField );
                setListAttributeFields( listAttributeFields );
            }

            if ( ( StringUtils.isNotBlank( strWidth ) && !strWidth.matches( REGEX_ID ) )
                    || ( StringUtils.isNotBlank( strHeight ) && !strHeight.matches( REGEX_ID ) ) )
            {
                strError = PROPERTY_MESSAGE_NO_ARITHMETICAL_CHARACTERS;
            }

            if ( EMPTY_STRING.equals( strError ) )
            {
                if ( StringUtils.isNotBlank( strWidth ) && strWidth.matches( REGEX_ID ) )
                {
                    int nWidth = Integer.parseInt( strWidth );
                    getListAttributeFields( ).get( 0 ).setWidth( nWidth );
                }
                else
                {
                    getListAttributeFields( ).get( 0 ).setWidth( -1 );
                }

                if ( StringUtils.isNotBlank( strHeight ) && strHeight.matches( REGEX_ID ) )
                {
                    int nHeight = Integer.parseInt( strHeight );
                    getListAttributeFields( ).get( 0 ).setHeight( nHeight );
                }
                else
                {
                    getListAttributeFields( ).get( 0 ).setHeight( -1 );
                }

                return null;
            }
        }
        else
        {
            strError = Messages.MANDATORY_FIELDS;
        }

        return AdminMessageService.getMessageUrl( request, strError, AdminMessage.TYPE_STOP );
    }
