public LuteceDefaultAdminUser load( String strAccessCode, AdminAuthentication authenticationService )
    {
        DAOUtil daoUtil = new DAOUtil( SQL_QUERY_LOAD_USER );
        daoUtil.setString( 1, strAccessCode );
        daoUtil.executeQuery( );

        if ( !daoUtil.next( ) )
        {
            daoUtil.free( );
            throw new AppException( "The line doesn't exist " );
        }

        String strUserName = daoUtil.getString( 1 );
        LuteceDefaultAdminUser user = new LuteceDefaultAdminUser( strUserName, authenticationService );
        user.setUserId( daoUtil.getInt( 2 ) );
        user.setPasswordMaxValidDate( daoUtil.getTimestamp( 3 ) );

        long accountMaxValidDate = daoUtil.getLong( 4 );

        if ( accountMaxValidDate > 0 )
        {
            user.setAccountMaxValidDate( new Timestamp( accountMaxValidDate ) );
        }

        user.setEmail( daoUtil.getString( 5 ) );
        daoUtil.free( );

        return user;
    }
