@Override
    public IPassword getPassword( String strStoredPassword )
    {
        int storageTypeSeparatorIndex = strStoredPassword.indexOf( ':' );
        if ( storageTypeSeparatorIndex == -1 )
        {
            throw new IllegalArgumentException( strStoredPassword );
        }
        String storageType = strStoredPassword.substring( 0, storageTypeSeparatorIndex );
        String password = strStoredPassword.substring( storageTypeSeparatorIndex + 1 );
        switch( storageType )
        {
            case PLAINTEXT_STORAGE_TYPE:
                return new PlaintextPassword( password );
            case PBKDF2WITHHMACSHA1_STORAGE_TYPE:
                return new PBKDF2WithHmacSHA1Password( password );
            case PBKDF2WITHHMACSHA512_STORAGE_TYPE:
                return new PBKDF2WithHmacSHA512Password( password );
            case DUMMY_STORAGE_TYPE:
                return new DummyPassword( );
            default:
                return new DigestPassword( storageType, password );
        }
    }
