public AdminUser getRemoteUser( HttpServletRequest request ) throws UserNotSignedException, AccessDeniedException
    {
        AdminUser user = getRegisteredUser( request );

        if ( _authentication.isExternalAuthentication( ) )
        {
            if ( user == null )
            {
                // User is not registered by Lutece, but it may be authenticated by another system
                user = _authentication.getHttpAuthenticatedUser( request );
                registerUser( request, user );
                AdminUserService.updateDateLastLogin( user.getUserId( ) );

                // Start a new session
                throw new UserNotSignedException( );
            }
            else
            {
                // user is already in session. for external auth, we check that the user hasn't changed in the external module .
                AdminUser newUser = _authentication.getHttpAuthenticatedUser( request );

                if ( newUser == null )
                {
                    throw new AccessDeniedException( "User not found while retrieving from external authentication" );
                }
                else
                    if ( !newUser.getAccessCode( ).equals( user.getAccessCode( ) ) )
                    {
                        unregisterUser( request );
                        registerUser( request, newUser );
                        AdminUserService.updateDateLastLogin( user.getUserId( ) );

                        // Start a new session
                        throw new UserNotSignedException( );
                    }
            }
        }
        else
        // if not external authentication, just check if user is null or not
        {
            if ( user == null )
            {
                // user is not signed
                throw new UserNotSignedException( );
            }
        }

        return user;
    }
