public static String getEmailErrorMessageUrl( HttpServletRequest request )
    {
        String strMessage;

        if ( isEmailPatternSetManually( ) )
        {
            strMessage = getEmailPattern( );
        }
        else
        {
            StringBuilder sbMessage = new StringBuilder( );
            String emailPatternVerifyBy = DefaultUserParameterHome.findByKey( DSKEY_EMAIL_PATTERN_VERIFY_BY );
            String [ ] regularExpressionIds = emailPatternVerifyBy.split( COMMA );

            for ( String strRegularExpressionId : regularExpressionIds )
            {
                strRegularExpressionId.trim( );

                if ( StringUtils.isNotBlank( strRegularExpressionId ) && StringUtils.isNumeric( strRegularExpressionId ) )
                {
                    int nRegularExpressionId = Integer.parseInt( strRegularExpressionId );
                    RegularExpression regularExpression = RegularExpressionService.getInstance( ).getRegularExpressionByKey( nRegularExpressionId );

                    if ( regularExpression != null )
                    {
                        sbMessage.append( regularExpression.getValidExemple( ) );
                        sbMessage.append( COMMA );
                    }
                }
            }

            // Get all message except the last character which is a comma
            strMessage = sbMessage.toString( ).substring( 0, sbMessage.length( ) - 1 );
        }

        String strBannedDomainNames = getSecurityParameter( DSKEY_BANNED_DOMAIN_NAMES );
        String strMessageProperty;

        if ( !StringUtils.isEmpty( strBannedDomainNames ) )
        {
            strMessageProperty = PROPERTY_MESSAGE_EMAIL_FORMAT_BANNED_DOMAIN_NAME;
        }
        else
        {
            strMessageProperty = PROPERTY_MESSAGE_EMAIL_FORMAT;
        }

        Object [ ] param = {
                strMessage, strBannedDomainNames
        };

        return AdminMessageService.getMessageUrl( request, strMessageProperty, param, AdminMessage.TYPE_STOP );
    }
