private long getLongProperty( String strCacheName, String strProperty, long lDefault )
    {
        String strKey = getDSKey( strCacheName, strProperty );

        if ( DatastoreService.existsInstanceKey( strKey ) )
        {
            String strValue = NOT_FOUND;

            try
            {
                strValue = DatastoreService.getInstanceDataValue( strKey, strValue );

                long lValue = Integer.parseInt( strValue );

                return lValue;
            }
            catch( NumberFormatException e )
            {
                AppLogService.error( "Invalid numeric property : " + strCacheName + strProperty + "=" + strValue, e );
            }
        }

        return lDefault;
    }
