private void loadCachesConfig( )
    {
        String strCachesStatusFile = AppPathService.getPath( PROPERTY_PATH_CONF, FILE_CACHES_STATUS );
        File file = new File( strCachesStatusFile );

        FileInputStream fis = null;

        try
        {
            Properties properties = new Properties( );
            fis = new FileInputStream( file );
            properties.load( fis );

            // If the keys aren't found in the datastore then create a key in it
            for ( String strKey : properties.stringPropertyNames( ) )
            {
                String strDSKey = KEY_PREFIX + strKey;

                if ( !DatastoreService.existsInstanceKey( strDSKey ) )
                {
                    String strValue = properties.getProperty( strKey );
                    DatastoreService.setInstanceDataValue( strDSKey, strValue );
                }
            }
        }
        catch( FileNotFoundException e )
        {
            AppLogService.error( "No cache.dat file. Should be created at shutdown." );
        }
        catch( Exception e )
        {
            AppLogService.error( "Error loading caches status defined in file : " + file.getAbsolutePath( ), e );
        }
        finally
        {
            StreamUtil.safeClose( fis );
        }
    }
