@Override
    protected void doFilter( HttpServletRequest request, HttpServletResponse response, FilterChain chain ) throws AlreadyGzippedException, AlreadyCommittedException, FilterNonReentrantException, LockTimeoutException, Exception
    {
        if ( !getInit( ) )
        {
            init( );
        }

        if( SecurityService.isAuthenticationEnable() )
        {
            if( isCacheEnable() )
            {
                AppLogService.info( "The PageCachingService has been inhibited because MyLutece authentication is enabled. Please disable this service in the Lutece Administration.");
            }
            chain.doFilter( request, response );
        }
        else
        {    
            super.doFilter( request, response, chain ); 
        }
    }
