protected void init( )
    {
        // Execute the doInit
        synchronized( HeadersPageCachingFilter.class )
        {
            if ( blockingCache == null )
            {
                _strCacheName = filterConfig.getInitParameter( INIT_PARAM_CACHE_NAME );
                CacheService.getInstance( ).createCache( _strCacheName );
                _cache = CacheManager.getInstance( ).getCache( _strCacheName );
                CacheService.registerCacheableService( this );
                _logger.debug( "Initializing cache : " + _strCacheName );

                setCacheNameIfAnyConfigured( filterConfig );

                final String localCacheName = getCacheName( );
                Ehcache cache = getCacheManager( ).getEhcache( localCacheName );

                if ( cache == null )
                {
                    throw new CacheException( "cache '" + localCacheName + "' not found in configuration" );
                }

                if ( !( cache instanceof BlockingCache ) )
                {
                    // decorate and substitute
                    BlockingCache newBlockingCache = new BlockingCache( cache );
                    getCacheManager( ).replaceCacheWithDecoratedCache( cache, newBlockingCache );
                }

                blockingCache = (BlockingCache) getCacheManager( ).getEhcache( localCacheName );

                Integer blockingTimeoutMillis = parseBlockingCacheTimeoutMillis( filterConfig );

                if ( ( blockingTimeoutMillis != null ) && ( blockingTimeoutMillis > 0 ) )
                {
                    blockingCache.setTimeoutMillis( blockingTimeoutMillis );
                }
            }

            PageService.addPageEventListener( this );
        }

        _bInit = true;
    }
