public List<CSVMessageDescriptor> readCSVFile( String strPath, int nColumnNumber, boolean bCheckFileBeforeProcessing, boolean bExitOnError,
            boolean bSkipFirstLine, Locale locale, String strBaseUrl )
    {
        java.io.File file = new java.io.File( strPath );

        try
        {
            FileReader fileReader = new FileReader( file );
            CSVReader csvReader = new CSVReader( fileReader, getCSVSeparator( ), getCSVEscapeCharacter( ) );

            return readCSVFile( fileReader, csvReader, nColumnNumber, bCheckFileBeforeProcessing, bExitOnError, bSkipFirstLine, locale, strBaseUrl );
        }
        catch( FileNotFoundException e )
        {
            AppLogService.error( e.getMessage( ), e );
        }

        List<CSVMessageDescriptor> listErrors = new ArrayList<CSVMessageDescriptor>( );
        CSVMessageDescriptor errorDescription = new CSVMessageDescriptor( CSVMessageLevel.ERROR, 0, I18nService.getLocalizedString( MESSAGE_NO_FILE_FOUND,
                locale ) );
        listErrors.add( errorDescription );

        return listErrors;
    }
