public static synchronized void init( ) throws LuteceInitException
    {
        // already initialized
        if ( _bInit )
        {
            return;
        }

        _executor = SpringContextService.getBean( IDaemonScheduler.BEAN_NAME );

        if ( _mapDaemonEntries.size( ) > 0 )
        {
            // Unsynchronized daemon start
            int nInitialDaemon = 0;

            for ( DaemonEntry entry : _mapDaemonEntries.values( ) )
            {
                if ( entry.onStartup( ) )
                {
                    nInitialDaemon++;
                }
            }

            int nDelay = AppPropertiesService.getPropertyInt( PROPERTY_MAX_INITIAL_START_DELAY, 30 );

            if ( nInitialDaemon > 0 )
            {
                nDelay = nDelay / nInitialDaemon;
            }

            int nInitialDelay = 0;

            // Register daemons
            for ( DaemonEntry entry : _mapDaemonEntries.values( ) )
            {
                // starts any daemon declared as startup daemons
                if ( entry.onStartup( ) )
                {
                    nInitialDelay += nDelay;

                    scheduleThread( entry, nInitialDelay );
                }
            }
        }

        _bInit = true;
    }
