@Override
    public void schedule( DaemonEntry entry, long nInitialDelay, TimeUnit unit )
    {
        synchronized( _scheduledDaemons )
        {
            if ( _scheduledDaemons.containsKey( entry.getId( ) ) )
            {
                AppLogService.error( "Daemon " + entry.getId( ) + " already scheduled, not scheduling again" );
            }
            else
            {

                DaemonTimerTask daemonTimerTask = new DaemonTimerTask( entry );
                _scheduledDaemonsTimer.scheduleAtFixedRate( daemonTimerTask, unit.toMillis( nInitialDelay ), entry.getInterval( ) * 1000 );
                _scheduledDaemons.put( entry.getId( ), daemonTimerTask );
            }
        }

    }
