@Override
    public void run( )
    {
        if ( _entry.isRunning( ) )
        {
            if ( _strDaemonName == null )
            {
                _strDaemonName = "Daemon " + _entry.getId( );
            }

            Thread currentThread = Thread.currentThread( );
            String strPooledThreadName = currentThread.getName( );
            currentThread.setName( "Lutece-Daemon-" + _entry.getId( ) );

            Daemon daemon = _entry.getDaemon( );
            AppLogService.info( _strDaemonName + " - starts processing." );

            try
            {
                _entry.setLastRunDate( new Date( ) );

                if ( PluginService.isPluginEnable( daemon.getPluginName( ) ) )
                {
                    daemon.run( );
                    _entry.setLastRunLogs( daemon.getLastRunLogs( ) );
                }
                else
                {
                    _entry.setLastRunLogs( "Plugin not enabled" );
                }
            }
            catch( Throwable t )
            {
                AppLogService.error( "Could not process Daemon: " + _entry.getId( ), t );
            }

            AppLogService.info( _strDaemonName + " - end of process." );
            currentThread.setName( strPooledThreadName );
        }
        else
        {
            AppLogService.error( "Daemon's " + _entry.getId( ) + " run not processed because it has been stopped. Will unschedule." );
            AppDaemonService.cancelScheduledThread( _entry.getId( ) );
        }
    }
