public String getDashboardData( List<IDashboardComponent> listDashboards, AdminUser user, int nZone, HttpServletRequest request )
    {
        List<IDashboardComponent> listDashboardComponents = new ArrayList<IDashboardComponent>( );

        for ( IDashboardComponent dc : listDashboards )
        {
            if ( dc.getZone( ) == nZone )
            {
                listDashboardComponents.add( dc );
            }
        }

        Collections.sort( listDashboardComponents, new AttributeComparator( ORDER, true ) );

        StringBuffer sbDashboardData = new StringBuffer( );

        for ( IDashboardComponent dc : listDashboardComponents )
        {
            boolean bRight = user.checkRight( dc.getRight( ) ) || dc.getRight( ).equalsIgnoreCase( ALL );

            if ( ( dc.getZone( ) == nZone ) && dc.isEnabled( ) && bRight )
            {
                sbDashboardData.append( dc.getDashboardData( user, request ) );
            }
        }

        return sbDashboardData.toString( );
    }
