public void registerDashboardComponent( DashboardComponentEntry entry, Plugin plugin )
    {
        try
        {
            DashboardComponent dc = (DashboardComponent) Class.forName( entry.getComponentClass( ) ).newInstance( );

            dc.setName( entry.getName( ) );
            dc.setRight( entry.getRight( ) );
            dc.setPlugin( plugin );

            boolean bRegistered = DashboardFactory.registerDashboardComponent( dc );

            if ( bRegistered )
            {
                AppLogService.info( "New Dashboard Component registered : " + entry.getName( ) );
            }
            else
            {
                AppLogService.error( " Dashboard Component not registered : " + entry.getName( ) + " : " + entry.getComponentClass( ) );
            }
        }
        catch( InstantiationException e )
        {
            AppLogService.error( "Error registering a DashboardComponent : " + e.getMessage( ), e );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( "Error registering a DashboardComponent : " + e.getMessage( ), e );
        }
        catch( ClassNotFoundException e )
        {
            AppLogService.error( "Error registering a DashboardComponent : " + e.getMessage( ), e );
        }
    }
