public void doMoveDashboard( IAdminDashboardComponent dashboard, int nOldColumn, int nOldOrder, boolean bCreate )
    {
        int nColumn = dashboard.getZone( );
        int nOrder = dashboard.getOrder( );

        // find the dashboard already with this order and column
        AdminDashboardFilter filter = new AdminDashboardFilter( );
        filter.setFilterColumn( nColumn );

        List<IAdminDashboardComponent> listColumnDashboards = AdminDashboardHome.findByFilter( filter );

        if ( ( listColumnDashboards != null ) && !listColumnDashboards.isEmpty( ) )
        {
            if ( AppLogService.isDebugEnabled( ) )
            {
                AppLogService.debug( "Reordering admin dashboard column " + dashboard.getZone( ) );
            }

            // sort by order
            Collections.sort( listColumnDashboards );

            int nMaxOrder = listColumnDashboards.get( listColumnDashboards.size( ) - 1 ).getOrder( );

            if ( ( nOldColumn == 0 ) || ( nOldColumn != nColumn ) )
            {
                // was not in this column before, put to the end
                dashboard.setOrder( nMaxOrder + 1 );
            }
            else
            {
                if ( nOrder < nOldOrder )
                {
                    for ( IAdminDashboardComponent dc : listColumnDashboards )
                    {
                        int nCurrentOrder = dc.getOrder( );

                        if ( !dc.equals( dashboard ) && ( nCurrentOrder >= nOrder ) && ( nCurrentOrder < nOldOrder ) )
                        {
                            dc.setOrder( nCurrentOrder + 1 );
                            AdminDashboardHome.update( dc );
                        }
                    }
                }
                else
                    if ( nOrder > nOldOrder )
                    {
                        for ( IAdminDashboardComponent dc : listColumnDashboards )
                        {
                            int nCurrentOrder = dc.getOrder( );

                            if ( !dc.equals( dashboard ) && ( nCurrentOrder <= nOrder ) && ( nCurrentOrder > nOldOrder ) )
                            {
                                dc.setOrder( nCurrentOrder - 1 );
                                AdminDashboardHome.update( dc );
                            }
                        }
                    }

                // dashboard are singletons, values are modified by getting it from database
                dashboard.setOrder( nOrder );
                dashboard.setZone( nColumn );
            }
        }
        else
        {
            dashboard.setOrder( 1 );
        }

        if ( bCreate )
        {
            // create dashboard
            AdminDashboardHome.create( dashboard );
        }
        else
        {
            // update dashboard
            AdminDashboardHome.update( dashboard );
        }
    }
