public void registerDashboardComponent( DashboardComponentEntry entry, Plugin plugin )
    {
        try
        {
            IAdminDashboardComponent dc = (IAdminDashboardComponent) Class.forName( entry.getComponentClass( ) ).newInstance( );

            dc.setName( entry.getName( ) );
            dc.setPlugin( plugin );

            boolean bRegistered = AdminDashboardFactory.registerDashboardComponent( dc );

            if ( bRegistered )
            {
                AppLogService.info( "New Admin Dashboard Component registered : " + entry.getName( ) );
            }
            else
            {
                AppLogService.error( " Admin Dashboard Component not registered : " + entry.getName( ) + " : " + entry.getComponentClass( ) );
            }
        }
        catch( InstantiationException e )
        {
            AppLogService.error( "Error registering an Admin DashboardComponent : " + e.getMessage( ), e );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( "Error registering an Admin DashboardComponent : " + e.getMessage( ), e );
        }
        catch( ClassNotFoundException e )
        {
            AppLogService.error( "Error registering an Admin DashboardComponent : " + e.getMessage( ), e );
        }
    }
