@Override
    public void processPluginEvent( PluginEvent event )
    {
        if ( getPluginName( ).equals( event.getPlugin( ).getName( ) ) )
        {
            if ( ( event.getEventType( ) == PluginEvent.PLUGIN_INSTALLED ) || ( event.getEventType( ) == PluginEvent.PLUGIN_POOL_CHANGED ) )
            {
                if ( StringUtils.isNotBlank( event.getPlugin( ).getDbPoolName( ) )
                        && !AppConnectionService.NO_POOL_DEFINED.equals( event.getPlugin( ).getDbPoolName( ) ) )
                {
                    try
                    {
                        _logger.debug( "DAOUtilTransactionManager changed datasource status..." );
                        setDataSource( AppConnectionService.getPoolManager( ).getDataSource( event.getPlugin( ).getDbPoolName( ) ) );
                        _bInit = true;
                    }
                    catch( Exception ex )
                    {
                        _bInit = false;
                        _logger.error( "An error occured getting pool for DAOUtilTransactionManager for plugin " + event.getPlugin( ).getName( )
                                + ", please check plugin is activated and pool is correctly set : " + ex.getMessage( ), ex );
                    }
                }
                else
                {
                    _logger.debug( "Pool for plugin " + event.getPlugin( ).getName( ) + " is set to null, clearing transaction manager" );
                    setDataSource( null );
                    _bInit = false;
                }
            }
            else
                if ( event.getEventType( ) == PluginEvent.PLUGIN_UNINSTALLED )
                {
                    setDataSource( null );
                    _bInit = false;
                }
        }
    }
