public static String getDataValue( String strKey, String strDefault )
    {
        try
        {
            if ( _bDatabase )
            {
                DataEntity entity = null;

                if ( _cache != null )
                {
                    entity = (DataEntity) _cache.getFromCache( strKey );
                }

                if ( entity == null )
                {
                    entity = DataEntityHome.findByPrimaryKey( strKey );

                    if ( entity == null )
                    {
                        return strDefault;
                    }

                    if ( _cache != null )
                    {
                        _cache.putInCache( strKey, entity );
                    }
                }

                return entity.getValue( );
            }
        }
        catch( NoDatabaseException e )
        {
            disableDatastore( e );
        }

        return strDefault;
    }
