public void init( )
    {
        _listParserElement = new ArrayList<ParserElement>( );
        _listParserComplexElement = new ArrayList<ParserComplexElement>( );

        // init simple elements
        String strParserElements = AppPropertiesService.getProperty( PROPERTY_PARSER_ELEMENTS );

        if ( StringUtils.isNotBlank( strParserElements ) )
        {
            String [ ] tabParserElements = strParserElements.split( SEPARATOR );
            String strCodeElement;
            String strValueElement;

            for ( int i = 0; i < tabParserElements.length; i++ )
            {
                strCodeElement = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_ELEMENT_PATH + "." + tabParserElements [i] + "."
                        + CONSTANT_EDITOR_BBCODE_ELEMENT_CODE );
                strValueElement = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_ELEMENT_PATH + "." + tabParserElements [i] + "."
                        + CONSTANT_EDITOR_BBCODE_ELEMENT_VALUE );
                _listParserElement.add( new ParserElement( strCodeElement, strValueElement ) );
            }
        }

        // init complex elements
        String strParserComplexElements = AppPropertiesService.getProperty( PROPERTY_PARSER_COMPLEX_ELEMENTS );

        if ( StringUtils.isNotBlank( strParserComplexElements ) )
        {
            String [ ] tabParserComplexElements = strParserComplexElements.split( SEPARATOR );
            String strTagName;
            String strOpenSubstWithParam;
            String strCloseSubstWithParam;
            String strOpenSubstWithoutParam;
            String strCloseSubstWithoutParam;
            String strInternalSubst;
            boolean bProcessInternalTags;
            boolean bAcceptParam;
            boolean bRequiresQuotedParam;

            for ( int i = 0; i < tabParserComplexElements.length; i++ )
            {
                strTagName = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i] + "."
                        + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_TAG_NAME );
                strOpenSubstWithParam = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i]
                        + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_OPEN_SUBST_WITH_PARAM );
                strCloseSubstWithParam = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i]
                        + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_CLOSE_SUBST_WITH_PARAM );
                strOpenSubstWithoutParam = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i]
                        + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_OPEN_SUBST_WITHOUT_PARAM );
                strCloseSubstWithoutParam = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i]
                        + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_CLOSE_SUBST_WITHOUT_PARAM );
                strInternalSubst = AppPropertiesService.getProperty( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i] + "."
                        + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_INTERNAL_SUBST );
                bProcessInternalTags = AppPropertiesService.getPropertyBoolean( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "."
                        + tabParserComplexElements [i] + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_PROCESS_INTERNAL_TAGS, false );
                bAcceptParam = AppPropertiesService.getPropertyBoolean( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "." + tabParserComplexElements [i] + "."
                        + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_ACCEPT_PARAM, false );
                bRequiresQuotedParam = AppPropertiesService.getPropertyBoolean( PROPERTY_EDITOR_BBCODE_COMPLEX_ELEMENT_PATH + "."
                        + tabParserComplexElements [i] + "." + CONSTANT_EDITOR_BBCODE_COMPLEX_ELEMENT_REQUIRES_QUOTED_PARAM, false );

                _listParserComplexElement.add( new ParserComplexElement( strTagName, strOpenSubstWithParam, strCloseSubstWithParam, strOpenSubstWithoutParam,
                        strCloseSubstWithoutParam, strInternalSubst, bProcessInternalTags, bAcceptParam, bRequiresQuotedParam ) );
            }
        }
    }
