public void registerFilter( FilterEntry entry, Plugin plugin )
    {
        try
        {
            Filter filter = (Filter) Class.forName( entry.getFilterClass( ) ).newInstance( );
            LuteceFilter f = new LuteceFilter( entry.getName( ), filter, entry.getMappingUrlPattern( ), plugin, entry.getInitParameters( ) );
            f.setOrder( entry.getOrder( ) );
            _listFilters.add( f );
            AppLogService.info( "New Filter registered : " + entry.getName( ) );

            for ( String strKey : entry.getInitParameters( ).keySet( ) )
            {
                AppLogService.info( " * init parameter - name : '" + strKey + "' - value : '" + entry.getInitParameters( ).get( strKey ) + "'" );
            }
        }
        catch( InstantiationException e )
        {
            AppLogService.error( "Error registering a filter : " + e.getMessage( ), e );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( "Error registering a filter : " + e.getMessage( ), e );
        }
        catch( ClassNotFoundException e )
        {
            AppLogService.error( "Error registering a filter : " + e.getMessage( ), e );
        }
    }
