boolean matchFilterUrl( String strUrlPattern, String strRequestUrl )
    {
        if ( strUrlPattern == null )
        {
            return ( false ); // Case 1 - Exact Match
        }

        if ( strUrlPattern.equals( strRequestUrl ) )
        {
            return ( true ); // Case 2 - Path Match ("/.../*")
        }

        if ( strUrlPattern.equals( "/*" ) )
        {
            return ( true );
        }

        if ( strUrlPattern.endsWith( "/*" ) )
        {
            if ( strUrlPattern.regionMatches( 0, strRequestUrl, 0, strUrlPattern.length( ) - 2 ) )
            {
                if ( strRequestUrl.length( ) == ( strUrlPattern.length( ) - 2 ) )
                {
                    return ( true );
                }
                else
                    if ( '/' == strRequestUrl.charAt( strUrlPattern.length( ) - 2 ) )
                    {
                        return ( true );
                    }
            }

            return ( false );
        }

        // Case 3 - Extension Match
        if ( strUrlPattern.startsWith( "*." ) )
        {
            int slash = strRequestUrl.lastIndexOf( '/' );
            int period = strRequestUrl.lastIndexOf( '.' );

            if ( ( slash >= 0 ) && ( period > slash ) && ( period != ( strRequestUrl.length( ) - 1 ) )
                    && ( ( strRequestUrl.length( ) - period ) == ( strUrlPattern.length( ) - 1 ) ) )
            {
                return ( strUrlPattern.regionMatches( 2, strRequestUrl, period + 1, strUrlPattern.length( ) - 2 ) );
            }
        }

        // Case 4 - "Default" Match
        return ( false ); // NOTE - Not relevant for selecting filters
    }
