public static String getLocalizedString( String strKey, Locale theLocale )
    {
        Locale locale = theLocale;
        String strReturn = "";

        try
        {
            int nPos = strKey.indexOf( '.' );

            if ( nPos != -1 )
            {
                String strBundleKey = strKey.substring( 0, nPos );
                String strStringKey = strKey.substring( nPos + 1 );

                String strBundle = FORMAT_PACKAGE_PORTAL_RESOURCES_LOCATION;

                if ( !strBundleKey.equals( "portal" ) )
                {
                    if ( strBundleKey.equals( "module" ) )
                    {
                        // module resource
                        nPos = strStringKey.indexOf( '.' );

                        String strPlugin = strStringKey.substring( 0, nPos );
                        strStringKey = strStringKey.substring( nPos + 1 );
                        nPos = strStringKey.indexOf( '.' );

                        String strModule = strStringKey.substring( 0, nPos );
                        strStringKey = strStringKey.substring( nPos + 1 );

                        strBundle = getModuleBundleName( strPlugin, strModule );
                    }
                    else
                    {
                        // plugin resource
                        strBundle = getPluginBundleName( strBundleKey );
                    }
                }
                else
                {
                    nPos = strStringKey.indexOf( '.' );

                    String strElement = strStringKey.substring( 0, nPos );
                    strStringKey = strStringKey.substring( nPos + 1 );

                    strBundle = getPortalBundleName( strElement );
                }

                // if language is english use a special locale to force using default
                // bundle instead of the bundle of default locale.
                if ( locale.getLanguage( ).equals( Locale.ENGLISH.getLanguage( ) ) )
                {
                    locale = LOCALE_DEFAULT;
                }

                ResourceBundle rbLabels = getResourceBundle( locale, strBundle );
                strReturn = rbLabels.getString( strStringKey );
            }
        }
        catch( Exception e )
        {
            String strErrorMessage = "Error localizing key : '" + strKey + "' - " + e.getMessage( );

            if ( e.getCause( ) != null )
            {
                strErrorMessage += ( " - cause : " + e.getCause( ).getMessage( ) );
            }

            AppLogService.error( strErrorMessage );
        }

        return strReturn;
    }
