private static ResourceBundle getResourceBundle( Locale locale, String strBundle )
    {
        String key = strBundle + locale.toString( );
        ResourceBundle rbLabels = _resourceBundleCache.get( key );

        if ( rbLabels == null )
        {
            rbLabels = ResourceBundle.getBundle( strBundle, locale );

            if ( _overrideLoader != null )
            {
                ResourceBundle overrideBundle = null;

                try
                {
                    overrideBundle = ResourceBundle.getBundle( strBundle, locale, _overrideLoader );
                }
                catch( MissingResourceException e )
                {
                    // no override for this resource
                    _resourceBundleCache.put( key, rbLabels );

                    return rbLabels;
                }

                ResourceBundle res = new CombinedResourceBundle( overrideBundle, rbLabels );
                _resourceBundleCache.put( key, res );

                return res;
            }

            _resourceBundleCache.put( key, rbLabels );
        }

        return rbLabels;
    }
