private static void initProperties( String strRealPath )
    {
        Map<String, Object> model = new HashMap<String, Object>( );
        Properties p = new Properties( );

        FileInputStream fis = null;

        try
        {
            fis = new FileInputStream( strRealPath + PATH_CONFIG + FILE_PROPERTIES_CONFIG );
            p.load( fis );
        }
        catch( Exception e )
        {
            AppLogService.error( e.getMessage( ), e );
        }
        finally
        {
            StreamUtil.safeClose( fis );
        }

        if ( Boolean.parseBoolean( p.getProperty( PROPERTY_AUTOINIT ) ) )
        {
            Object [ ] params = {
                AppPropertiesService.getProperty( PROPERTY_SITE_NAME )
            };
            String strSendMailSubject = I18nService.getLocalizedString( PROPERTY_SENDMAIL_SUBJECT, params, I18nService.getDefaultLocale( ) );
            model.put( MARK_SENDMAIL_SUBJECT, strSendMailSubject );
            model.put( MARK_WEBAPP_HOME, AppPathService.getWebAppPath( ) );
            model.put( MARK_PROD_URL, p.getProperty( PROPERTY_INIT_WEBAPP_PROD_URL ) );
            model.put( MARK_AUTOINIT, Boolean.FALSE.toString( ) );

            HtmlTemplate configTemplate = AppTemplateService.getTemplate( CONFIG_PROPERTIES_TEMPLATE, Locale.getDefault( ), model );
            // reset configuration cache to avoid configuration caching before macros are set. See LUTECE-1460
            AppTemplateService.resetConfiguration( );

            FileWriter fw = null;

            try
            {
                fw = new FileWriter( strRealPath + PATH_CONFIG + FILE_PROPERTIES_CONFIG );
                fw.write( configTemplate.getHtml( ) );
            }
            catch( Exception io )
            {
                io.printStackTrace( );
            }
            finally
            {
                StreamUtil.safeClose( fw );
            }
        }
    }
