private void sendMail( MailItem mail, String strHost, Transport transportSmtp, Session session, StringBuilder sbLogsLine ) throws MessagingException
    {
        try
        {
            sbLogsLine.append( " - To " );
            sbLogsLine.append( ( ( mail.getRecipientsTo( ) != null ) ? mail.getRecipientsTo( ) : "" ) );
            sbLogsLine.append( " - Cc " );
            sbLogsLine.append( ( mail.getRecipientsCc( ) != null ) ? mail.getRecipientsCc( ) : "" );
            sbLogsLine.append( " - Bcc " );
            sbLogsLine.append( ( mail.getRecipientsBcc( ) != null ) ? mail.getRecipientsBcc( ) : "" );
            sbLogsLine.append( " - Subject : " );
            sbLogsLine.append( mail.getSubject( ) );

            switch( mail.getFormat( ) )
            {
                case MailItem.FORMAT_HTML:
                    MailUtil.sendMessageHtml( mail.getRecipientsTo( ), mail.getRecipientsCc( ), mail.getRecipientsBcc( ), mail.getSenderName( ),
                            mail.getSenderEmail( ), mail.getSubject( ), mail.getMessage( ), transportSmtp, session );

                    break;

                case MailItem.FORMAT_TEXT:
                    MailUtil.sendMessageText( mail.getRecipientsTo( ), mail.getRecipientsCc( ), mail.getRecipientsBcc( ), mail.getSenderName( ),
                            mail.getSenderEmail( ), mail.getSubject( ), mail.getMessage( ), transportSmtp, session );

                    break;

                case MailItem.FORMAT_MULTIPART_HTML:
                    MailUtil.sendMultipartMessageHtml( mail.getRecipientsTo( ), mail.getRecipientsCc( ), mail.getRecipientsBcc( ), mail.getSenderName( ),
                            mail.getSenderEmail( ), mail.getSubject( ), mail.getMessage( ), mail.getUrlsAttachement( ), mail.getFilesAttachement( ),
                            transportSmtp, session );

                    break;

                case MailItem.FORMAT_MULTIPART_TEXT:
                    MailUtil.sendMultipartMessageText( mail.getRecipientsTo( ), mail.getRecipientsCc( ), mail.getRecipientsBcc( ), mail.getSenderName( ),
                            mail.getSenderEmail( ), mail.getSubject( ), mail.getMessage( ), mail.getFilesAttachement( ), transportSmtp, session );

                    break;

                case MailItem.FORMAT_CALENDAR:
                    MailUtil.sendMessageCalendar( mail.getRecipientsTo( ), mail.getRecipientsCc( ), mail.getRecipientsBcc( ), mail.getSenderName( ),
                            mail.getSenderEmail( ), mail.getSubject( ), mail.getMessage( ), mail.getCalendarMessage( ), mail.getCreateEvent( ), transportSmtp,
                            session );

                    break;

                default:
                    break;
            }

            sbLogsLine.append( " - Status [ OK ]" );
        }
        catch( AddressException e )
        {
            // a wrongly formatted address is encountered in the list of recipients
            sbLogsLine.append( " - Status [ Failed ] : " );
            sbLogsLine.append( e.getMessage( ) );
            AppLogService.error( "MailService - Error sending mail : " + e.getMessage( ), e );
        }
        catch( SendFailedException e )
        {
            // the send failed because of invalid addresses.
            sbLogsLine.append( " - Status [ Failed ] : " );
            sbLogsLine.append( e.getMessage( ) );
            AppLogService.error( "MailService - Error sending mail : " + e.getMessage( ), e );
        }
        catch( MessagingException e )
        {
            // if the connection is dead or not in the connected state
            // we put the mail in the queue before end process
            sbLogsLine.append( " - Status [ Failed ] : " );
            sbLogsLine.append( e.getMessage( ) );
            AppLogService.error( "MailService - Error sending mail : " + e.getMessage( ), e );
            throw e;
        }
    }
