private static ByteArrayDataSource convertUrlAttachmentDataSourceToByteArrayDataSource( UrlAttachment urlAttachement )
    {
        String strKey = MailAttachmentCacheService.getInstance( ).getKey( urlAttachement.getUrlData( ).toString( ) );
        ByteArrayDataSource urlAttachmentDataSource = null;

        if ( !MailAttachmentCacheService.getInstance( ).isCacheEnable( ) || ( MailAttachmentCacheService.getInstance( ).getFromCache( strKey ) == null ) )
        {
            DataHandler handler = new DataHandler( urlAttachement.getUrlData( ) );
            ByteArrayOutputStream bo = null;
            InputStream input = null;
            String strType = null;

            try
            {
                Object o = handler.getContent( );
                strType = handler.getContentType( );

                if ( o != null )
                {
                    if ( o instanceof InputStream )
                    {
                        input = (InputStream) o;
                        bo = new ByteArrayOutputStream( );

                        int read;
                        byte [ ] tab = new byte [ CONSTANTE_FILE_ATTACHMET_BUFFER];

                        do
                        {
                            read = input.read( tab );

                            if ( read > 0 )
                            {
                                bo.write( tab, 0, read );
                            }
                        }
                        while ( read > 0 );
                    }
                }
            }
            catch( IOException e )
            {
                // Document is ignored
                AppLogService.info( urlAttachement.getContentLocation( ) + MSG_ATTACHMENT_NOT_FOUND );
            }
            finally
            {
                // closed inputstream and outputstream
                try
                {
                    if ( input != null )
                    {
                        input.close( );
                    }

                    if ( bo != null )
                    {
                        bo.close( );
                        urlAttachmentDataSource = new ByteArrayDataSource( bo.toByteArray( ), strType );
                    }
                }
                catch( IOException e )
                {
                    AppLogService.error( e );
                }
            }

            if ( MailAttachmentCacheService.getInstance( ).isCacheEnable( ) )
            {
                // add resource in cache
                MailAttachmentCacheService.getInstance( ).putInCache( strKey, urlAttachmentDataSource );
            }
        }
        else
        {
            // used the resource store in cache
            urlAttachmentDataSource = (ByteArrayDataSource) MailAttachmentCacheService.getInstance( ).getFromCache( strKey );
        }

        return urlAttachmentDataSource;
    }
