protected static Session getMailSession( String strHost, int nPort, final String strUsername, final String strPassword )
    {
        String strDebug = AppPropertiesService.getProperty( PROPERTY_MAIL_SESSION_DEBUG, Boolean.FALSE.toString( ) );
        boolean bSessionDebug = Boolean.parseBoolean( strDebug );

        // Initializes a mail session with the SMTP server
        Properties props = System.getProperties( );
        props.put( MAIL_HOST, strHost );
        props.put( MAIL_TRANSPORT_PROTOCOL, SMTP );
        props.put( MAIL_PROPTOCOL_HOST, strHost );
        props.put( MAIL_PROPTOCOL_PORT, nPort );

        Authenticator auth;

        if ( StringUtils.isNotBlank( strUsername ) )
        {
            props.put( MAIL_SMTP_AUTH, TRUE );
            // using authenticator class that return a PasswordAuthentication
            auth = new Authenticator( )
            {
                @Override
                protected PasswordAuthentication getPasswordAuthentication( )
                {
                    return new PasswordAuthentication( strUsername, strPassword );
                }
            };
        }
        else
        {
            // no authentication data provided, no authenticator
            auth = null;
        }

        Session mailSession = Session.getDefaultInstance( props, auth );
        // Activate debugging
        mailSession.setDebug( bSessionDebug );

        return mailSession;
    }
