protected static void sendMultipartMessageHtml( String strRecipientsTo, String strRecipientsCc, String strRecipientsBcc, String strSenderName,
            String strSenderEmail, String strSubject, String strMessage, List<UrlAttachment> urlAttachements, List<FileAttachment> fileAttachements,
            Transport transport, Session session ) throws MessagingException, AddressException, SendFailedException
    {
        Message msg = prepareMessage( strRecipientsTo, strRecipientsCc, strRecipientsBcc, strSenderName, strSenderEmail, strSubject, session );
        msg.setHeader( HEADER_NAME, HEADER_VALUE );

        // Creation of the root part containing all the elements of the message
        MimeMultipart multipart = ( ( fileAttachements == null ) || ( fileAttachements.isEmpty( ) ) ) ? new MimeMultipart( MULTIPART_RELATED )
                : new MimeMultipart( );

        // Creation of the html part, the "core" of the message
        BodyPart msgBodyPart = new MimeBodyPart( );
        // msgBodyPart.setContent( strMessage, BODY_PART_MIME_TYPE );
        msgBodyPart.setDataHandler( new DataHandler( new ByteArrayDataSource( strMessage, AppPropertiesService.getProperty( PROPERTY_MAIL_TYPE_HTML )
                + AppPropertiesService.getProperty( PROPERTY_CHARSET ) ) ) );
        multipart.addBodyPart( msgBodyPart );

        if ( urlAttachements != null )
        {
            ByteArrayDataSource urlByteArrayDataSource;

            for ( UrlAttachment urlAttachement : urlAttachements )
            {
                urlByteArrayDataSource = convertUrlAttachmentDataSourceToByteArrayDataSource( urlAttachement );

                if ( urlByteArrayDataSource != null )
                {
                    msgBodyPart = new MimeBodyPart( );
                    // Fill this part, then add it to the root part with the
                    // good headers
                    msgBodyPart.setDataHandler( new DataHandler( urlByteArrayDataSource ) );
                    msgBodyPart.setHeader( HEADER_CONTENT_LOCATION, urlAttachement.getContentLocation( ) );
                    multipart.addBodyPart( msgBodyPart );
                }
            }
        }

        // add File Attachement
        if ( fileAttachements != null )
        {
            for ( FileAttachment fileAttachement : fileAttachements )
            {
                String strFileName = fileAttachement.getFileName( );
                byte [ ] bContentFile = fileAttachement.getData( );
                String strContentType = fileAttachement.getType( );
                ByteArrayDataSource dataSource = new ByteArrayDataSource( bContentFile, strContentType );
                msgBodyPart = new MimeBodyPart( );
                msgBodyPart.setDataHandler( new DataHandler( dataSource ) );
                msgBodyPart.setFileName( strFileName );
                msgBodyPart.setDisposition( CONSTANT_DISPOSITION_ATTACHMENT );
                multipart.addBodyPart( msgBodyPart );
            }
        }

        msg.setContent( multipart );

        sendMessage( msg, transport );
    }
