public static Collection<Recipient> getRecipients( String strWorkgroup, String strRole )
    {
        Collection<Recipient> listRecipients = new ArrayList<Recipient>( );
        Collection<AdminUser> listUsers;

        if ( ( strWorkgroup != null ) && ( !strWorkgroup.equals( AdminWorkgroupService.ALL_GROUPS ) ) )
        {
            listUsers = AdminWorkgroupHome.getUserListForWorkgroup( strWorkgroup );
        }
        else
        {
            listUsers = AdminUserHome.findUserList( );
        }

        for ( AdminUser user : listUsers )
        {
            if ( ( strRole != null ) && ( !strRole.equals( ALL_ROLES ) ) )
            {
                if ( !user.isInRole( strRole ) )
                {
                    // skip this user if it isn't in the role
                    continue;
                }
            }

            Recipient recipient = new Recipient( );
            recipient.setName( user.getFirstName( ) + " " + user.getLastName( ) );
            recipient.setEmail( user.getEmail( ) );
            listRecipients.add( recipient );
        }

        return listRecipients;
    }
