@Override
    public String getPage( HttpServletRequest request, int nMode )
    {
        Locale locale = request.getLocale( );
        Map<String, Object> model = new HashMap<String, Object>( );

        SiteMessage message = SiteMessageService.getMessage( request );

        UrlItem url = new UrlItem( AppPathService.getBaseUrl( request ) );

        if ( message == null )
        {
            message = new SiteMessage( Messages.MESSAGE_ERROR_SESSION, null, PROPERTY_TITLE_ERROR, url.getUrl( ), "", SiteMessage.TYPE_ERROR,
                    SiteMessage.TYPE_BUTTON_HIDDEN, null, null );
        }

        model.put( MARK_MESSAGE, message );
        model.put( MARK_TEXT, message.getText( locale ) );
        model.put( MARK_TITLE, message.getTitle( locale ) );
        model.put( MARK_URL, message.getUrl( ) );
        model.put( MARK_TARGET, message.getTarget( ) );
        model.put( MARK_CANCEL_BUTTON, message.getTypeButton( ) );
        model.put( MARK_REQUEST_PARAMETERS, message.getRequestParameters( ) );
        model.put( MARK_BACK_URL, message.getBackUrl( ) );

        // Delete message in session
        SiteMessageService.cleanMessageSession( request );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_MESSAGE, locale, model );

        // Fill a PageData structure for those elements
        PageData data = new PageData( );
        data.setName( message.getTitle( locale ) );
        // FIXME Cannot set the page path when app run in standalone mode (cannot connect to database). The page path is now not set.
        // data.setPagePath( PortalService.getXPagePathContent( message.getTitle( locale ), nMode, request ) );
        data.setContent( template.getHtml( ) );

        return buildPageContent( data, nMode, request );
    }
