@Override
    public String getPageContent( int nIdPage, int nMode, HttpServletRequest request ) throws SiteMessageException
    {
        Locale locale = ( request == null ) ? LocaleService.getDefault( ) : request.getLocale( );

        String [ ] arrayContent = new String [ MAX_COLUMNS];

        for ( int i = 0; i < MAX_COLUMNS; i++ )
        {
            arrayContent [i] = "";
        }

        Page page = PageHome.findByPrimaryKey( nIdPage );
        Map<String, String> mapParams = getParams( request, nMode, nIdPage );
        boolean bCanPageBeCached = Boolean.TRUE;
        LuteceUser user = SecurityService.getInstance( ).getRegisteredUser( request );

        for ( Portlet portlet : page.getPortlets( ) )
        {
            int nCol = portlet.getColumn( ) - 1;

            if ( nCol < MAX_COLUMNS )
            {
                arrayContent [nCol] += getPortletContent( request, portlet, mapParams, nMode );
            }

            // We check if the portlet can be cached
            if ( ( user != null ) ? ( !portlet.canBeCachedForConnectedUsers( ) ) : ( !portlet.canBeCachedForAnonymousUsers( ) ) )
            {
                bCanPageBeCached = false;
            }
        }

        // Add columns outline in admin mode
        if ( nMode == MODE_ADMIN )
        {
            for ( int i = 0; i < MAX_COLUMNS; i++ )
            {
                arrayContent [i] = addColumnOutline( i + 1, arrayContent [i], locale );
            }
        }

        // We save that the page that is generating can not be cached
        if ( !bCanPageBeCached )
        {
            request.setAttribute( ATTRIBUTE_CORE_CAN_PAGE_BE_CACHED, false );
        }

        Map<String, Object> rootModel = new HashMap<String, Object>( );

        for ( int j = 0; j < MAX_COLUMNS; j++ )
        {
            rootModel.put( "page_content_col" + ( j + 1 ), arrayContent [j] );
        }

        List<PageInclude> listIncludes = PageIncludeService.getIncludes( );
        PageData data = new PageData( );

        for ( PageInclude pic : listIncludes )
        {
            pic.fillTemplate( rootModel, data, nMode, request );
        }

        HtmlTemplate t = AppTemplateService.getTemplate( page.getTemplate( ), locale, rootModel );

        return t.getHtml( );
    }
