private Map<String, String> getParams( HttpServletRequest request, int nMode, int nIdPage )
    {
        Map<String, String> mapModifyParam = new HashMap<String, String>( );
        String paramName = "";

        // Get request paramaters and store them in a HashMap
        if ( request != null )
        {
            Enumeration<?> enumParam = request.getParameterNames( );

            while ( enumParam.hasMoreElements( ) )
            {
                paramName = (String) enumParam.nextElement( );
                mapModifyParam.put( paramName, request.getParameter( paramName ) );
            }

            // Add selected locale
            mapModifyParam.put( PARAMETER_USER_SELECTED_LOCALE, LocaleService.getUserSelectedLocale( request ).getLanguage( ) );
        }

        // Added in v1.3
        // Add a path param for choose url to use in admin or normal mode
        if ( nMode != MODE_ADMIN )
        {
            mapModifyParam.put( PARAMETER_SITE_PATH, AppPathService.getPortalUrl( ) );

            if ( SecurityService.isAuthenticationEnable( ) )
            {
                mapModifyParam.put( MARKER_IS_USER_AUTHENTICATED, ( SecurityService.getInstance( ).getRegisteredUser( request ) != null ) ? VALUE_TRUE
                        : VALUE_FALSE );
            }
        }
        else
        {
            mapModifyParam.put( PARAMETER_SITE_PATH, AppPathService.getAdminPortalUrl( ) );
            mapModifyParam.put( MARKER_TARGET, TARGET_TOP );
        }

        if ( !mapModifyParam.containsKey( Parameters.PAGE_ID ) )
        {
            mapModifyParam.put( Parameters.PAGE_ID, Integer.toString( PortalService.getRootPageId( ) ) );
        }

        return mapModifyParam;
    }
