public void load( String strFilename ) throws LuteceInitException
    {
        // Configure Digester from XML ruleset
        DigesterLoader digesterLoader = DigesterLoader.newLoader( new FromXmlRulesModule( )
        {
            @Override
            protected void loadRules( )
            {
                loadXMLRules( getClass( ).getResource( FILE_RULES ) );
            }
        } );

        Digester digester = digesterLoader.newDigester( );

        // Allow variables in plugin files
        MultiVariableExpander expander = new MultiVariableExpander( );
        expander.addSource( "$", ( (Map) AppPropertiesService.getPropertiesAsMap( ) ) );

        Substitutor substitutor = new VariableSubstitutor( expander );
        digester.setSubstitutor( substitutor );

        // Push empty List onto Digester's Stack
        digester.push( this );
        digester.setValidating( false );

        try
        {
            InputStream input = new FileInputStream( strFilename );
            digester.parse( input );
        }
        catch( FileNotFoundException e )
        {
            throw new LuteceInitException( "Error loading plugin file : " + strFilename, e );
        }
        catch( SAXException e )
        {
            throw new LuteceInitException( "Error loading plugin file : " + strFilename, e );
        }
        catch( IllegalArgumentException e )
        {
            throw new LuteceInitException( "Error loading plugin file : " + strFilename, e );
        }
        catch( IOException e )
        {
            throw new LuteceInitException( "Error loading plugin file : " + strFilename, e );
        }
    }
