void load( PluginFile pluginFile ) throws LuteceInitException
    {
        try
        {
            _strName = pluginFile.getName( );
            _strVersion = pluginFile.getVersion( );
            _strDescription = pluginFile.getDescription( );
            _strProvider = pluginFile.getProvider( );
            _strProviderUrl = pluginFile.getProviderUrl( );

            String strDefaultIconUrl = AppPropertiesService.getProperty( PROPERTY_DEFAULT_ICON_URL );
            _strIconUrl = pluginFile.getIconUrl( ).equals( "" ) ? strDefaultIconUrl : pluginFile.getIconUrl( );
            _strDocumentationUrl = pluginFile.getDocumentationUrl( );
            _strCopyright = pluginFile.getCopyright( );
            _strPluginClass = pluginFile.getPluginClass( );
            _strMinCoreVersion = pluginFile.getMinCoreVersion( );
            _strMaxCoreVersion = pluginFile.getMaxCoreVersion( );
            _listXPageApplications = pluginFile.getXPageApplications( );
            _listFilters = pluginFile.getFilters( );
            _listServlets = pluginFile.getServlets( );
            _listListeners = pluginFile.getListeners( );
            _listRights = pluginFile.getRights( );
            _listPortletTypes = pluginFile.getPortletTypes( );
            _listContentServices = pluginFile.getContentServices( );
            _listInsertServices = pluginFile.getInsertServices( );
            _listSearchIndexers = pluginFile.getSearchIndexers( );
            _listPageIncludes = pluginFile.getPageIncludes( );
            _listDashboardComponents = pluginFile.getDashboardComponents( );
            _listAdminDashboardComponents = pluginFile.getAdminDashboardComponents( );
            _listRBACResourceTypes = pluginFile.getRBACResourceTypes( );
            _listDaemons = pluginFile.getDaemons( );
            _mapParams = pluginFile.getParams( );
            _bDbPoolRequired = pluginFile.isDbPoolRequired( );

            _listCssStyleSheets = pluginFile.getCssStyleSheetsForAllModes( );
            _strCssStylesheetsScope = ( pluginFile.getCssStylesheetsScope( ) != null ) ? pluginFile.getCssStylesheetsScope( ) : SCOPE_XPAGE;
            _listJavascriptFiles = pluginFile.getJavascriptFilesForAllModes( );
            _strJavascriptFilesScope = ( pluginFile.getJavascriptFilesScope( ) != null ) ? pluginFile.getJavascriptFilesScope( ) : SCOPE_XPAGE;
            _listFreemarkerMacrosFiles = pluginFile.getFreemarkerMacrosFiles( );
            _listAdminCssStyleSheets = pluginFile.getAdminCssStyleSheets( );
            _listAdminJavascriptFiles = pluginFile.getAdminJavascriptFiles( );
            // Register plugin components
            registerXPageApplications( );
            registerFilters( );
            registerServlets( );
            registerListeners( );
            registerContentServices( );
            registerInsertServices( );
            registerSearchIndexers( );
            registerPageIncludes( );
            registerDashboardComponents( );
            registerAdminDashboardComponents( );
            registerRBACResourceTypes( );
            registerDaemons( );
        }
        catch( Exception e )
        {
            throw new LuteceInitException( "Error loading plugin : " + e.getMessage( ), e );
        }
    }
