protected void registerRBACResourceTypes( ) throws LuteceInitException
    {
        for ( RBACResourceTypeEntry entry : _listRBACResourceTypes )
        {
            ResourceIdService ris;

            try
            {
                ris = (ResourceIdService) Class.forName( entry.getClassName( ) ).newInstance( );
                // Each resource id service should register itself and its permissions
                ris.register( );
            }
            catch( IllegalAccessException e )
            {
                throw new LuteceInitException( e.getMessage( ), e );
            }
            catch( ClassNotFoundException e )
            {
                throw new LuteceInitException( e.getMessage( ), e );
            }
            catch( InstantiationException e )
            {
                throw new LuteceInitException( e.getMessage( ), e );
            }
        }
    }
