public static String buildPageContent( int nCurrentPageId, PageData data, int nMode, HttpServletRequest request )
    {
        Locale locale = null;
        HashMap<String, Object> model = new HashMap<String, Object>( );
        LuteceUser user = null;
        String strWebmasterEmail = DatastoreService.getDataValue( KEY_WEBMASTER_EMAIL, "" );
        model.put( Markers.WEBMASTER_EMAIL, strWebmasterEmail );

        if ( request != null )
        {
            locale = LocaleService.getUserSelectedLocale( request );
            user = SecurityService.getInstance( ).getRegisteredUser( request );
            if ( nMode != MODE_ADMIN )
            {
                model.put( MARK_LUTECE_USER, user );
            }
        }

        List<PageInclude> listIncludes = PageIncludeService.getIncludes( );

        for ( PageInclude pic : listIncludes )
        {
            pic.fillTemplate( model, data, nMode, request );
        }

        String strHeader = ( data.isHomePage( ) ) ? AppPropertiesService.getProperty( PROPERTY_HOME_PAGE_HEADER + nMode, TEMPLATE_HOME_PAGE_HEADER )
                : AppPropertiesService.getProperty( PROPERTY_INTERNAL_PAGE_HEADER + nMode, TEMPLATE_INTERNAL_PAGE_HEADER );
        HtmlTemplate tHeader = AppTemplateService.getTemplate( strHeader, locale, model );

        String strFooter = AppPropertiesService.getProperty( PROPERTY_PORTAL_FOOTER + nMode, TEMPLATE_PORTAL_FOOTER );
        String strToolsMenu = AppPropertiesService.getProperty( PROPERTY_PAGE_TOOLS_MENU + nMode, TEMPLATE_PAGE_TOOLS_MENU );
        model.put( MARK_IS_CONTACT_INSTALLED, isContactActivated( ) );

        boolean bDisplayLastModified = data.getDisplayDateUpdate( );
        model.put( MARK_DISPLAY_LAST_MODIFIED, bDisplayLastModified );

        String strLastModified = DateUtil.getDateString( data.getDateUpdate( ), request.getLocale( ) );
        model.put( MARK_LAST_MODIFIED, strLastModified );

        HtmlTemplate tFooter = AppTemplateService.getTemplate( strFooter, locale, model );

        HtmlTemplate tToolsMenu = AppTemplateService.getTemplate( strToolsMenu, locale, model );
        model.put( Markers.PAGE_HEADER, tHeader.getHtml( ) );
        model.put( MARKER_PAGE_DATA, data );
        model.put( Markers.PAGE_NAME, ( data.getName( ) == null ) ? "" : data.getName( ) );
        model.put( Markers.PAGE_CONTENT, ( data.getContent( ) == null ) ? "" : data.getContent( ) );
        model.put( Markers.PAGE_PATH, ( data.getPagePath( ) == null ) ? "" : data.getPagePath( ) );
        model.put( Markers.PAGE_TOOLS_MENU, tToolsMenu.getHtml( ) );
        model.put( Markers.PAGE_ID, nCurrentPageId );

        model.put( Markers.PAGE_FOOTER, tFooter.getHtml( ) );

        String strBaseUrl = ( request != null ) ? AppPathService.getBaseUrl( request ) : ""; // request could be null (method called by daemons or batch)

        // for link service
        model.put( Markers.WEBAPP_PATH_FOR_LINKSERVICE, strBaseUrl );
        model.put( Markers.BASE_URL, strBaseUrl );

        String strEncoding = AppPropertiesService.getProperty( PROPERTY_ENCODING, PROPERTY_ENCODING_DEFAULT );

        if ( ( strEncoding == null ) || strEncoding.equals( "" ) )
        {
            strEncoding = PROPERTY_ENCODING_DEFAULT;
        }

        model.put( Markers.ENCODING, strEncoding );

        model.put( MARK_IS_EXTEND_INSTALLED, isExtendActivated( ) );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_PAGE_FRAMESET, locale, model );

        template.substitute( BOOKMARK_BASE_URL, ( request != null ) ? AppPathService.getBaseUrl( request ) : "" ); // request could be null (method called by
                                                                                                                   // daemons or batch)

        return template.getHtml( );
    }
