public static String getXPagePathContent( String strXPageName, int nMode, HttpServletRequest request )
    {
        final IPathCacheService pathCacheService = SpringContextService.getBean( IPathCacheService.BEAN_NAME );

        final String strKey = pathCacheService.getKey( strXPageName, nMode, request );

        String strRes = pathCacheService.getFromCache( strKey );

        if ( strRes != null )
        {
            return strRes;
        }

        // Added in v1.3
        StyleSheet xslSource;

        // Selection of the XSL stylesheet
        switch( nMode )
        {
            case MODE_NORMAL:
            case MODE_ADMIN:
                xslSource = PortalComponentHome.getXsl( PORTAL_COMPONENT_PAGE_PATH_ID, MODE_NORMAL );

                break;

            default:
                xslSource = PortalComponentHome.getXsl( PORTAL_COMPONENT_PAGE_PATH_ID, nMode );

                break;
        }

        String strXml = StringUtils.EMPTY;
        String strPageId = request.getParameter( Parameters.PAGE_ID );

        if ( StringUtils.isNotBlank( strPageId ) && StringUtils.isNumeric( strPageId ) )
        {
            int nPageId = Integer.parseInt( strPageId );
            strXml = getXmlPagesList( getXPagePath( strXPageName, nPageId ) );
        }
        else
        {
            String strPortletId = request.getParameter( Parameters.PORTLET_ID );

            if ( StringUtils.isNotBlank( strPortletId ) && StringUtils.isNumeric( strPortletId ) )
            {
                int nPortletId = Integer.parseInt( strPortletId );
                Portlet portlet = PortletHome.findByPrimaryKey( nPortletId );

                if ( portlet != null )
                {
                    int nPageId = portlet.getPageId( );
                    strXml = getXmlPagesList( getXPagePath( strXPageName, nPageId ) );
                }
            }
        }

        if ( StringUtils.isBlank( strXml ) )
        {
            strXml = getXmlPagesList( getXPagePath( strXPageName ) );
        }

        Properties outputProperties = ModeHome.getOuputXslProperties( nMode );

        // Added in v1.3
        // Add a path param for choose url to use in admin or normal mode
        Map<String, String> mapXslParams = new HashMap<String, String>( );
        setXslPortalPath( mapXslParams, nMode );

        XmlTransformerService xmlTransformerService = new XmlTransformerService( );
        String strPath = xmlTransformerService.transformBySourceWithXslCache( strXml, xslSource, mapXslParams, outputProperties );

        strRes = formatPath( strPath, nMode, request );

        pathCacheService.putInCache( strKey, strRes );

        return strRes;
    }
