public static String getXPagePathContent( String strXPageName, int nMode, String strTitlesUrls, HttpServletRequest request )
    {
        final IPathCacheService pathCacheService = SpringContextService.getBean( IPathCacheService.BEAN_NAME );

        final String strKey = pathCacheService.getKey( strXPageName, nMode, strTitlesUrls, request );

        String strRes = pathCacheService.getFromCache( strKey );

        if ( strRes != null )
        {
            return strRes;
        }

        // Selection of the XSL stylesheet
        StyleSheet xslSource;

        // Selection of the XSL stylesheet
        switch( nMode )
        {
            case MODE_NORMAL:
            case MODE_ADMIN:
                xslSource = PortalComponentHome.getXsl( PORTAL_COMPONENT_PAGE_PATH_ID, MODE_NORMAL );

                break;

            default:
                xslSource = PortalComponentHome.getXsl( PORTAL_COMPONENT_PAGE_PATH_ID, nMode );

                break;
        }

        String strXml = getXmlPagesListExtended( strTitlesUrls );

        Properties outputProperties = ModeHome.getOuputXslProperties( nMode );

        // Added in v1.3
        // Add a path param for choose url to use in admin or normal mode
        Map<String, String> mapXslParams = new HashMap<String, String>( );
        setXslPortalPath( mapXslParams, nMode );

        XmlTransformerService xmlTransformerService = new XmlTransformerService( );
        String strPath = xmlTransformerService.transformBySourceWithXslCache( strXml, xslSource, mapXslParams, outputProperties );

        strRes = formatPath( strPath, nMode, request );

        pathCacheService.putInCache( strKey, strRes );

        return strRes;
    }
