private static Collection<Page> getXPagePath( String strXPageName, int nPageId )
    {
        List<Page> list = new ArrayList<Page>( );
        Page page = PageHome.getPage( nPageId );

        if ( page != null )
        {
            int nParentPageId = page.getParentPageId( );

            while ( ( nParentPageId > 0 ) && ( nParentPageId != getRootPageId( ) ) )
            {
                Page parentPage = PageHome.getPage( nParentPageId );

                if ( parentPage != null )
                {
                    // Insert the page at the beginning of the list
                    list.add( 0, parentPage );
                    nParentPageId = parentPage.getParentPageId( );
                }
            }

            if ( nPageId != getRootPageId( ) )
            {
                list.add( page );
            }
        }

        // Insert the home page at the beginning of the list
        Page homePage = PageHome.getPage( getRootPageId( ) );
        list.add( 0, homePage );

        // Insert the XPage at the end of the list
        Page xPage = new Page( );
        xPage.setName( strXPageName );
        xPage.setId( nPageId );
        list.add( xPage );

        return list;
    }
