private static String buildPageContent( PageData data, int nMode, String strPluginName, HttpServletRequest request )
    {
        HtmlTemplate template;
        String strFileName = strPluginName + "/" + TEMPLATE_PAGE_FRAMESET;
        String strFilePath = AppPathService.getPath( PROPERTY_PATH_LUTECE_PLUGINS, strFileName );
        File file = new File( strFilePath );
        String strPluginPath = "skin/plugins/";

        // Load of the templates
        HashMap<String, Object> model = new HashMap<String, Object>( );
        model.put( Markers.BASE_URL, AppPathService.getBaseUrl( request ) );
        model.put( Markers.PAGE_NAME, data.getName( ) );
        model.put( Markers.PAGE_CONTENT, data.getContent( ) );

        Collection<PageInclude> colIncludes = PageIncludeService.getIncludes( );

        for ( PageInclude pic : colIncludes )
        {
            pic.fillTemplate( model, data, nMode, request );
        }

        if ( file.exists( ) )
        {
            template = AppTemplateService.getTemplate( strPluginPath + strFileName, request.getLocale( ), model );
        }
        else
        {
            template = AppTemplateService.getTemplate( TEMPLATE_STANDALONE_PAGE_FRAMESET, request.getLocale( ), model );
        }

        return template.getHtml( );
    }
