@Override
    public String getPage( HttpServletRequest request, int nMode ) throws UserNotSignedException, SiteMessageException
    {
        // Gets XPage info from the lutece.properties
        String strName = request.getParameter( PARAM_STANDALONE_APP );

        if ( ( strName == null ) || ( strName.length( ) <= 0 ) )
        {
            // Return the welcome page
            return null;
        }

        PageData data = new PageData( );
        XPageApplicationEntry entry = XPageAppService.getApplicationEntry( strName );

        if ( ( entry != null ) && ( entry.isEnable( ) ) )
        {
            XPageApplication app = XPageAppService.getApplicationInstance( entry );
            XPage page = app.getPage( request, nMode, entry.getPlugin( ) );
            data.setContent( page.getContent( ) );
            data.setName( page.getTitle( ) );
        }
        else
        {
            AppLogService.error( "The specified Xpage '" + SecurityUtil.logForgingProtect( strName )
                    + "' cannot be retrieved. Check installation of your Xpage application." );
            SiteMessageService.setMessage( request, MESSAGE_ERROR_APP_BODY, SiteMessage.TYPE_ERROR );
        }

        return buildPageContent( data, nMode, strName, request );
    }
