private static IThemeService getThemeService( ) throws ThemeNotAvailableException
    {
        IThemeService themeService = null;

        if ( !isAvailable( ) )
        {
            throw new ThemeNotAvailableException( );
        }

        try
        {
            themeService = SpringContextService.getBean( BEAN_THEME_SERVICE );
        }
        catch( BeanDefinitionStoreException e )
        {
            throw new ThemeNotAvailableException( );
        }
        catch( NoSuchBeanDefinitionException e )
        {
            throw new ThemeNotAvailableException( );
        }
        catch( CannotLoadBeanClassException e )
        {
            throw new ThemeNotAvailableException( );
        }

        return themeService;
    }
