private static void processDocument( IndexerAction action, Document doc ) throws CorruptIndexException, IOException
    {
        if ( action.getIdTask( ) == IndexerAction.TASK_CREATE )
        {
            _writer.addDocument( doc );
            logDoc( "Adding ", doc );
        }
        else
            if ( action.getIdTask( ) == IndexerAction.TASK_MODIFY )
            {
                if ( action.getIdPortlet( ) != ALL_DOCUMENT )
                {
                    // delete only the index linked to this portlet
                    _writer.updateDocument( new Term( SearchItem.FIELD_DOCUMENT_PORTLET_ID, doc.get( SearchItem.FIELD_DOCUMENT_PORTLET_ID ) ), doc );
                }
                else
                {
                    _writer.updateDocument( new Term( SearchItem.FIELD_UID, doc.getField( SearchItem.FIELD_UID ).stringValue( ) ), doc );
                }

                logDoc( "Updating ", doc );
            }
    }
