public static synchronized String processIndexing( boolean bCreate )
    {
        // String buffer for building the response page;
        _sbLogs = new StringBuffer( );

        _writer = null;

        boolean bCreateIndex = bCreate;
        Directory dir = null;

        try
        {
            dir = IndexationService.getDirectoryIndex( );

            if ( !DirectoryReader.indexExists( dir ) )
            { // init index
                bCreateIndex = true;
            }

            Date start = new Date( );
            IndexWriterConfig conf = new IndexWriterConfig( _analyzer );

            if ( bCreateIndex )
            {
                conf.setOpenMode( OpenMode.CREATE );
            }
            else
            {
                conf.setOpenMode( OpenMode.APPEND );
            }

            _writer = new IndexWriter( dir, conf );

            if ( bCreateIndex )
            {
                processFullIndexing( );
            }
            else
            {
                processIncrementalIndexing( );
            }

            Date end = new Date( );
            _sbLogs.append( "Duration of the treatment : " );
            _sbLogs.append( end.getTime( ) - start.getTime( ) );
            _sbLogs.append( " milliseconds\r\n" );
        }
        catch( Exception e )
        {
            error( "Indexing error ", e, "" );
        }
        finally
        {
            try
            {
                if ( _writer != null )
                {
                    _writer.close( );
                }
            }
            catch( IOException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }

            try
            {
                if ( dir != null )
                {
                    dir.close( );
                }
            }
            catch( IOException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
        }

        return _sbLogs.toString( );
    }
