public static LuteceUser getLuteceUserFromName( String strName )
    {
        // TODO : add separation between user management implementations
        LuteceUser user = (LuteceUser) LuteceUserCacheService.getInstance( ).getFromCache( strName );

        if ( user != null )
        {
            try
            {
                return (LuteceUser) user.clone( );
            }
            catch( CloneNotSupportedException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
        }

        for ( ILuteceUserProviderService luteceUserProviderService : SpringContextService.getBeansOfType( ILuteceUserProviderService.class ) )
        {
            user = luteceUserProviderService.getLuteceUserFromName( strName );

            if ( user != null )
            {
                if ( luteceUserProviderService.canUsersBeCached( ) )
                {
                    try
                    {
                        LuteceUserCacheService.getInstance( ).putInCache( strName, user.clone( ) );
                    }
                    catch( CloneNotSupportedException e )
                    {
                        AppLogService.error( e.getMessage( ), e );
                    }
                }

                return user;
            }
        }

        return null;
    }
