private static LuteceAuthentication getPortalAuthentication( ) throws LuteceInitException
    {
        String strAuthenticationClass = AppPropertiesService.getProperty( PROPERTY_AUTHENTICATION_CLASS );
        LuteceAuthentication authentication = null;

        if ( ( strAuthenticationClass != null ) && !strAuthenticationClass.equals( "" ) )
        {
            try
            {
                authentication = (LuteceAuthentication) Class.forName( strAuthenticationClass ).newInstance( );
                AppLogService.info( "Authentication service loaded : " + authentication.getAuthServiceName( ) );
            }
            catch( InstantiationException e )
            {
                throw new LuteceInitException( "Error instantiating Authentication Class", e );
            }
            catch( IllegalAccessException e )
            {
                throw new LuteceInitException( "Error instantiating Authentication Class", e );
            }
            catch( ClassNotFoundException e )
            {
                throw new LuteceInitException( "Error instantiating Authentication Class", e );
            }
        }

        return authentication;
    }
