public LuteceUser getRemoteUser( HttpServletRequest request ) throws UserNotSignedException
    {
        LuteceUser user = getRegisteredUser( request );

        if ( user == null )
        {
            // User is not registered by Lutece, but it may be authenticated by another system
            if ( _authenticationService.isExternalAuthentication( ) || _authenticationService.isMultiAuthenticationSupported( ) )
            {
                user = _authenticationService.getHttpAuthenticatedUser( request );

                if ( ( user == null ) && isPortalAuthenticationRequired( ) )
                {
                    throw new UserNotSignedException( );
                }

                registerUser( request, user );
            }
            else
            {
                throw new UserNotSignedException( );
            }
        }

        return user;
    }
