@Override
    public void service( ServletRequest requestServlet, ServletResponse responseServlet ) throws ServletException, IOException
    {
        AppLogService.debug( "MainServlet : service()" );

        HttpServletRequest request = (HttpServletRequest) requestServlet;
        HttpServletResponse response = (HttpServletResponse) responseServlet;

        for ( LuteceServlet servlet : ServletService.getInstance( ).getServlets( ) )
        {
            AppLogService.debug( "PluginServlet : " + servlet.getName( ) + " - url pattern : " + servlet.getMappingUrlPattern( ) );

            try
            {
                // Checks mapping and plugin status
                if ( matchMapping( servlet, request ) && servlet.getPlugin( ).isInstalled( ) )
                {
                    servlet.getServlet( ).service( request, response );
                }
            }
            catch( Exception e )
            {
                AppLogService.error( "Error execution 'service' method - Servlet " + servlet.getName( ), e );
            }
        }
    }
