public static void init( ServletContext context ) throws LuteceInitException
    {
        AppLogService.info( "Initialize plugins servlets" );
        _context = context;

        for ( LuteceServlet servlet : ServletService.getInstance( ).getServlets( ) )
        {
            // Catch exception for each servlet to execute all chain
            try
            {
                if ( servlet.getPlugin( ).isInstalled( ) )
                {
                    // Create a ServletConfig wrapper to provide init parameters to the servlet
                    LuteceServletConfig servletConfig = new LuteceServletConfig( servlet.getName( ), _context, servlet.getInitParameters( ) );
                    servlet.getServlet( ).init( servletConfig );
                    AppLogService.info( " * servlet '" + servlet.getName( ) + "' from plugin " + servlet.getPlugin( ).getName( ) + " initialized." );
                }
            }
            catch( Exception e )
            {
                AppLogService.error( "Error execution init() method - Servlet " + servlet.getName( ), e );
                throw new LuteceInitException( "Error execution init() method - Servlet " + servlet.getName( ), e );
            }
        }
    }
