public void registerServlet( ServletEntry entry, Plugin plugin )
    {
        try
        {
            HttpServlet servlet = (HttpServlet) Class.forName( entry.getServletClass( ) ).newInstance( );
            LuteceServlet s = new LuteceServlet( entry.getName( ), servlet, entry.getMappingUrlPattern( ), plugin, entry.getInitParameters( ) );
            _listServlets.add( s );
            AppLogService.info( "New Servlet registered : " + entry.getName( ) );

            for ( String strKey : entry.getInitParameters( ).keySet( ) )
            {
                AppLogService.info( " * init parameter - name : '" + strKey + "' - value : '" + entry.getInitParameters( ).get( strKey ) + "'" );
            }
        }
        catch( InstantiationException e )
        {
            AppLogService.error( "Error registering a servlet : " + e.getMessage( ), e );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( "Error registering a servlet : " + e.getMessage( ), e );
        }
        catch( ClassNotFoundException e )
        {
            AppLogService.error( "Error registering a servlet : " + e.getMessage( ), e );
        }
    }
