public static <T> List<T> getBeansOfType( Class<T> classDef )
    {
        // Search the list in the cache
        List<T> list = _mapBeansOfType.get( classDef );

        if ( list != null )
        {
            return new ArrayList<T>( list );
        }

        // The list is not in the cache, so we have to build it
        list = new ArrayList<T>( );

        Map<String, T> map = _context.getBeansOfType( classDef );
        String [ ] sBeanNames = map.keySet( ).toArray( new String [ map.size( )] );

        for ( String strBeanName : sBeanNames )
        {
            String strPluginPrefix = getPrefix( strBeanName );

            if ( ( strPluginPrefix == null ) || ( isEnabled( strPluginPrefix ) ) )
            {
                list.add( map.get( strBeanName ) );
            }
        }

        _mapBeansOfType.put( classDef, new ArrayList<T>( list ) );

        return list;
    }
