public static void doModifyUserFields( AdminUser user, HttpServletRequest request, Locale locale, AdminUser currentUser )
    {
        // Attributes created in the Back-Office
        List<IAttribute> listAttributes = _attributeService.getCoreAttributesWithoutFields( locale );
        Map<Integer, List<AdminUserField>> map = new HashMap<Integer, List<AdminUserField>>( );

        for ( IAttribute attribute : listAttributes )
        {
            List<AdminUserField> listUserFields = attribute.getUserFieldsData( request, user );

            map.put( attribute.getIdAttribute( ), listUserFields );
        }

        // Remove all user fields
        AdminUserFieldFilter auFieldFilter = new AdminUserFieldFilter( );
        auFieldFilter.setIdUser( user.getUserId( ) );
        AdminUserFieldHome.removeByFilter( auFieldFilter );

        for ( int nIdAttribute : map.keySet( ) )
        {
            for ( AdminUserField userField : map.get( nIdAttribute ) )
            {
                if ( userField != null )
                {
                    AdminUserFieldHome.create( userField );
                }
            }
        }

        // Attributes associated to the plugins
        for ( AdminUserFieldListenerService adminUserFieldListenerService : SpringContextService.getBeansOfType( AdminUserFieldListenerService.class ) )
        {
            adminUserFieldListenerService.doModifyUserFields( user, request, locale, currentUser );
        }
    }
