public List<AttributeType> getAttributeTypes( Locale locale )
    {
        if ( _listAttributeTypes == null )
        {
            synchronized( this )
            {
                if ( _listAttributeTypes == null )
                {
                    List<AttributeType> listAttributTypes = new ArrayList<AttributeType>( );

                    for ( IAttribute attribute : SpringContextService.getBeansOfType( IAttribute.class ) )
                    {
                        attribute.setAttributeType( locale );
                        listAttributTypes.add( attribute.getAttributeType( ) );
                    }

                    _listAttributeTypes = listAttributTypes;
                }
            }
        }

        return _listAttributeTypes;
    }
