public static void init( String strConfigPath, String strConfigFile )
    {
        BasicConfigurator.resetConfiguration( );
        // Initialize the logger and configures it with the values of the properties file : config.properties
        InputStream is = null;
        try
        {
            String strAbsoluteConfigDirectoryPath = AppPathService.getAbsolutePathFromRelativePath( strConfigPath );
            String strAlternateFilePath = strAbsoluteConfigDirectoryPath + ( strAbsoluteConfigDirectoryPath.endsWith( "/" ) ? "" : "/" )
                    + ALTERNATE_LOG_OVERRIDE_PATH;

            File alternateLogFile = new File( strAlternateFilePath + File.separator + ALTERNATE_LOG_FILE );
            boolean bAlternateConfigFile = alternateLogFile.exists( );
            String strLog4jConfigFile;

            if ( bAlternateConfigFile )
            {
                // Load loggers configuration from the log.properties
                is = AppPathService.getResourceAsStream( strConfigPath + ( strConfigPath.endsWith( "/" ) ? "" : "/" ) + ALTERNATE_LOG_OVERRIDE_PATH + "/",
                        ALTERNATE_LOG_FILE );
                strLog4jConfigFile = alternateLogFile.getAbsolutePath( );
            }
            else
            {
                // Load loggers configuration from the config.properties
                is = AppPathService.getResourceAsStream( strConfigPath, strConfigFile );
                strLog4jConfigFile = strAbsoluteConfigDirectoryPath + ( ( strAbsoluteConfigDirectoryPath.endsWith( "/" ) ) ? "" : "/" ) + strConfigFile;
            }

            Properties props = new Properties( );
            props.load( is );
            PropertyConfigurator.configure( props );
            is.close( );

            // Define the config.properties as log4j configuration file for other libraries using
            // the System property "log4j.configuration"
            System.setProperty( SYSTEM_PROPERTY_LOG4J_CONFIGURATION, strLog4jConfigFile );

            if ( bAlternateConfigFile )
            {
                debug( "Loaded log properties from alternate log.properties file " );
            }
        }
        catch( Exception e )
        {
            System.err.println( "Bad Configuration of Log4j : " + e );
        }
        finally
        {
            StreamUtil.safeClose( is );
        }
        info( "Lutece logs initialized, using configured property files to define levels and appenders." );
    }
