public static String digest( InputStream stream, String strAlgorithm )
    {
        MessageDigest digest;
        try
        {
            digest = MessageDigest.getInstance( strAlgorithm );
        }
        catch( NoSuchAlgorithmException e )
        {
            AppLogService.error( strAlgorithm + " not found", e );
            return null;
        }
        byte [ ] buffer = new byte [ 1024];
        try
        {
            int nNumBytesRead = stream.read( buffer );
            while ( nNumBytesRead != -1 )
            {
                digest.update( buffer, 0, nNumBytesRead );
                nNumBytesRead = stream.read( buffer );
            }
        }
        catch( IOException e )
        {
            AppLogService.error( "Error reading stream", e );
            return null;
        }
        return byteToHex( digest.digest( ) );
    }
