public static String hmacSHA256( String message )
    {
        byte [ ] keyBytes;
        try
        {
            keyBytes = getCryptoKey( ).getBytes( "UTF-8" );
        }
        catch( UnsupportedEncodingException e )
        {
            throw new AppException( "UTF-8 should be supported", e );
        }
        final String strAlg = "HmacSHA256";
        SecretKeySpec key = new SecretKeySpec( keyBytes, strAlg );

        try
        {
            Mac mac = Mac.getInstance( strAlg );
            mac.init( key );

            return byteToHex( mac.doFinal( message.getBytes( "UTF-8" ) ) );
        }
        catch( NoSuchAlgorithmException e )
        {
            throw new AppException( "Could not find " + strAlg + " algorithm which is supposed to be supported by Java", e );
        }
        catch( InvalidKeyException e )
        {
            throw new AppException( "The key should be valid", e );
        }
        catch( IllegalStateException e )
        {
            throw new AppException( e.getMessage( ), e );
        }
        catch( UnsupportedEncodingException e )
        {
            throw new AppException( "UTF-8 should be supported", e );
        }
    }
