protected <T> boolean validateBean( T bean, Locale locale )
    {
        Set<ConstraintViolation<T>> errors = BeanValidationUtil.validate( bean );

        if ( errors.isEmpty( ) )
        {
            return true;
        }

        for ( ConstraintViolation<T> constraint : errors )
        {
            MVCMessage error = new MVCMessage( );
            error.setMessage( I18nService.getLocalizedString( constraint.getMessage( ), locale ) );
            _listErrors.add( error );
        }

        return false;
    }
