public String getContent( HttpServletRequest request, int nMode ) throws UserNotSignedException, SiteMessageException
    {
        if ( !AppInit.isWebappSuccessfullyLoaded( ) )
        {
            return getStartUpFailurePage( request );
        }

        // Try to register the user in case of external authentication
        if ( SecurityService.isAuthenticationEnable( ) )
        {
            try
            {
                if ( SecurityService.getInstance( ).isExternalAuthentication( ) && !SecurityService.getInstance( ).isMultiAuthenticationSupported( ) )
                {
                    SecurityService.getInstance( ).getRemoteUser( request );
                }
                else
                {
                    LuteceUser user = SecurityService.getInstance( ).getRegisteredUser( request );

                    // no checks are needed if the user is already registered
                    if ( user == null )
                    {
                        // if multiauthentication is supported, then when have to check remote user before other check
                        if ( SecurityService.getInstance( ).isMultiAuthenticationSupported( ) )
                        {
                            // getRemoteUser needs to be checked before any check so the user is registered
                            // getRemoteUser throws an exception if no user found, but here we have to bypass this exception to display login page.
                            SecurityService.getInstance( ).getRemoteUser( request );
                        }
                    }
                }
            }
            catch( UserNotSignedException unse )
            {
                // nothing to do,Leave LuteceAuthenticationFilter testing if the access to the content requires authentication
            }
        }

        // Search the content service invoked and call its getPage method
        ContentService cs = PortalService.getInvokedContentService( request );

        String strContent = ( cs != null ) ? cs.getPage( request, nMode ) : PortalService.getDefaultPage( request, nMode );

        if ( ContentPostProcessorService.hasProcessor( ) )
        {
            strContent = ContentPostProcessorService.process( request, strContent );
        }

        return strContent;
    }
