public String getError500Page( HttpServletRequest request, Throwable exception )
    {
        if ( exception instanceof AppException )
        {
            //AppException calls AppLogService.error( message, this ) in the
            //constructor, so don't call it here again Call toString to have
            //the Class and the message to be able to indentify the correct
            //stacktrace in the preceding logs.
            AppLogService.error( "Error 500 : Caused by previous Critical AppException" );
        }
        else
        {
            AppLogService.error( "Error 500 : " + exception.getMessage( ), exception );
        }

        String strCause = null;

        if ( AppPropertiesService.getProperty( PROPERTY_DEBUG, PROPERTY_DEBUG_DEFAULT ).equalsIgnoreCase( "true" ) )
        {
            strCause = exception.getMessage( );

            if ( exception.getCause( ) != null )
            {
                strCause += exception.getCause( ).getMessage( );
            }
        }

        return getError500Page( request, strCause );
    }
