@Override
    public String getDashboardData( AdminUser user, HttpServletRequest request )
    {
        Right right = RightHome.findByPrimaryKey( getRight( ) );
        Map<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_URL, right.getUrl( ) );
        model.put( MARK_ICON, right.getIconUrl( ) );

        PageService pageService = (PageService) SpringContextService.getBean( BEAN_PAGE_SERVICE );
        Page page = PageHome.getLastModifiedPage( );
        model.put( MARK_LAST_MODIFIED_PAGE, page );
        model.put( MARK_LAST_MODIFIED_PORTLET, PortletHome.getLastModifiedPortlet( ) );
        model.put( MARK_PAGES_COUNT, PageHome.getAllPages( ).size( ) );

        if ( page != null )
        {
            model.put( MARK_IMAGE_THUMBNAIL_PAGE_URL, pageService.getResourceImagePage( String.valueOf( page.getId( ) ) ) );
        }

        HtmlTemplate t = AppTemplateService.getTemplate( TEMPLATE_DASHBOARD, user.getLocale( ), model );

        return t.getHtml( );
    }
