public String getPluginList( HttpServletRequest request )
    {
        HashMap<String, Object> modelList = new HashMap<String, Object>( );
        Collection<XPageApplicationEntry> entryList = new ArrayList<XPageApplicationEntry>( );
        Locale locale = ( request == null ) ? null : request.getLocale( );

        Collection<XPageApplicationEntry> applications = XPageAppService.getXPageApplicationsList( );
        Comparator<XPageApplicationEntry> comparator = new Comparator<XPageApplicationEntry>( )
        {
            public int compare( XPageApplicationEntry c1, XPageApplicationEntry c2 )
            {
                Plugin p1 = ( c1.getPlugin( ) == null ) ? PluginService.getCore( ) : c1.getPlugin( );
                Plugin p2 = ( c2.getPlugin( ) == null ) ? PluginService.getCore( ) : c2.getPlugin( );

                return p1.getName( ).compareTo( p2.getName( ) );
            }
        };

        List<XPageApplicationEntry> applicationsSorted = new ArrayList<XPageApplicationEntry>( applications );
        Collections.sort( applicationsSorted, comparator );

        // Scan of the list
        for ( XPageApplicationEntry entry : applicationsSorted )
        {
            if ( entry.isEnable( ) )
            {
                entryList.add( entry );
            }
        }

        // Insert the rows in the list
        modelList.put( MARK_ENTRY_LIST, entryList );
        modelList.put( MARK_BASE_URL, AppPathService.getBaseUrl( request ) );
        modelList.put( MARK_CORE_PLUGIN, PluginService.getCore( ) );

        HtmlTemplate templateList = AppTemplateService.getTemplate( TEMPLATE_STANDALONE, locale, modelList );

        return templateList.getHtml( );
    }
