public void init( HttpServletRequest request, String strRight ) throws AccessDeniedException, PasswordResetException
    {
        _user = AdminUserService.getAdminUser( request );

        if ( !_user.checkRight( strRight ) )
        {
            throw new AccessDeniedException( "User " + _user.getAccessCode( ) + " does not have " + strRight + " right." );
        }

        if ( _user.isPasswordReset( ) )
        {
            throw new PasswordResetException( PROPERTY_RESET_EXCEPTION_MESSAGE );
        }

        // get the locale
        _locale = _user.getLocale( );

        Right right = RightHome.findByPrimaryKey( strRight );
        right.setLocale( _locale );
        _strFeatureLabel = right.getName( );
        _strFeatureUrl = right.getUrl( );
        _strFeatureIcon = right.getIconUrl( );
        _strFeatureDocumentation = right.getDocumentationUrl( );
        _strFeatureGroup = right.getFeatureGroup( );
    }
