private void findPages( HttpServletRequest request, StringBuffer strXmlArborescence, int nPageId, int nLevel, String strCurrentPageId, StringBuffer strCssId )
    {
        Page page = PageHome.getPage( nPageId );

        AdminUser user = AdminUserService.getAdminUser( request );
        String strPageId = Integer.toString( nPageId );

        boolean bAuthorizationPage;

        if ( nPageId == PortalService.getRootPageId( ) )
        {
            bAuthorizationPage = true;
        }
        else
        {
            // Control the node_status
            if ( page.getNodeStatus( ) != 0 )
            {
                Page parentPage = PageHome.getPage( page.getParentPageId( ) );
                int nParentPageNodeStatus = parentPage.getNodeStatus( );
                int nParentPageId = parentPage.getId( );

                // If 0 the page have a node authorization, else
                // the parent page node_status must be controlled
                // until it is equal to 0
                while ( nParentPageNodeStatus != 0 )
                {
                    parentPage = PageHome.getPage( nParentPageId );
                    nParentPageNodeStatus = parentPage.getNodeStatus( );
                    nParentPageId = parentPage.getParentPageId( );
                }

                strPageId = Integer.toString( parentPage.getId( ) );
            }

            bAuthorizationPage = RBACService.isAuthorized( Page.RESOURCE_TYPE, strPageId, PageResourceIdService.PERMISSION_VIEW, user );
        }

        XmlUtil.beginElement( strXmlArborescence, XmlContent.TAG_PAGE );

        if ( bAuthorizationPage )
        {
            XmlUtil.addElementHtml( strXmlArborescence, XmlContent.TAG_CURRENT_PAGE_ID, strCurrentPageId );
            XmlUtil.addElement( strXmlArborescence, XmlContent.TAG_PAGE_ID, page.getId( ) );
            XmlUtil.addElementHtml( strXmlArborescence, XmlContent.TAG_PAGE_NAME, page.getName( ) );
            XmlUtil.addElement( strXmlArborescence, XmlContent.TAG_PAGE_DESCRIPTION, page.getDescription( ) );
            XmlUtil.addElement( strXmlArborescence, XmlContent.TAG_PAGE_LEVEL, nLevel );
            XmlUtil.addElement( strXmlArborescence, XmlContent.TAG_PARENT_PAGE_ID, page.getParentPageId( ) );
            XmlUtil.addElement( strXmlArborescence, TAG_PAGE_ROLE, page.getRole( ) );

            AdminPageJspBean adminPage = new AdminPageJspBean( );

            if ( page.getImageContent( ) != null )
            {
                int nImageLength = page.getImageContent( ).length;

                if ( nImageLength >= 1 )
                {
                    XmlUtil.addElement( strXmlArborescence, XmlContent.TAG_PAGE_IMAGE, adminPage.getResourceImagePage( page, strPageId ) );
                }
            }
        }

        XmlUtil.beginElement( strXmlArborescence, XmlContent.TAG_CHILD_PAGES_LIST );

        for ( Page pageChild : PageHome.getChildPagesMinimalData( nPageId ) )
        {
            findPages( request, strXmlArborescence, pageChild.getId( ), nLevel + 1, strCurrentPageId, strCssId );
            strCssId.append( "initializeMenu('menu" + pageChild.getId( ) + "' , 'actuator" + pageChild.getId( ) + "');\n" );
        }

        XmlUtil.endElement( strXmlArborescence, XmlContent.TAG_CHILD_PAGES_LIST );

        if ( bAuthorizationPage )
        {
            XmlUtil.addElementHtml( strXmlArborescence, TAG_CSS_ID, strCssId.toString( ) );
        }

        XmlUtil.endElement( strXmlArborescence, XmlContent.TAG_PAGE );
    }
