public String doCreateChildPage( HttpServletRequest request ) throws AccessDeniedException
    {
        MultipartHttpServletRequest mRequest = (MultipartHttpServletRequest) request;

        String strParentPageId = mRequest.getParameter( Parameters.PAGE_ID );
        int nParentPageId = Integer.parseInt( strParentPageId );

        Page page = new Page( );
        page.setParentPageId( nParentPageId );

        String strErrorUrl = getPageData( mRequest, page );

        if ( strErrorUrl != null )
        {
            return strErrorUrl;
        }
        if ( !SecurityTokenService.getInstance( ).validate( mRequest, TEMPLATE_ADMIN_PAGE_BLOCK_CHILDPAGE ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }

        // Create the page
        _pageService.createPage( page );

        // set the authorization node
        if ( page.getNodeStatus( ) != 0 )
        {
            Page parentPage = PageHome.getPage( page.getParentPageId( ) );
            page.setIdAuthorizationNode( parentPage.getIdAuthorizationNode( ) );
        }
        else
        {
            page.setIdAuthorizationNode( page.getId( ) );
        }

        FileItem item = mRequest.getFile( PARAMETER_IMAGE_CONTENT );

        byte [ ] bytes = item.get( );
        String strMimeType = item.getContentType( );

        page.setImageContent( bytes );
        page.setMimeType( strMimeType );

        _pageService.updatePage( page );

        // Displays again the current page with the modifications
        return getUrlPage( page.getId( ) );
    }
