public String getDocumentation( HttpServletRequest request ) throws AccessDeniedException
    {
        String strFeature = request.getParameter( PARAMETER_FEATURE_DOC );

        if ( SecurityUtil.containsPathManipulationChars( request, strFeature ) )
        {
            return null;
        }

        AdminUser user = AdminUserService.getAdminUser( request );
        Locale locale = user.getLocale( );

        // get the xsl file
        String strXslPath = AppPathService.getPath( PROPERTY_XSL_BASE_PATH, XSL_PATH );
        File fileXsl = new File( strXslPath );
        StreamSource sourceStyleSheet = new StreamSource( fileXsl );

        // get the xml documentation file
        String strXmlPath;
        StreamSource sourceXml;
        String strLocal = locale.toString( );

        if ( ( locale == null ) || strLocal.equals( LOCAL_DEFAULT ) )
        {
            strXmlPath = AppPathService.getWebAppPath( ) + XML_BASE_PATH + XML_USER_PATH + strFeature + ".xml";
        }
        else
        {
            strXmlPath = AppPathService.getWebAppPath( ) + XML_BASE_PATH + locale.toString( ) + XML_USER_PATH + strFeature + ".xml";
        }

        sourceXml = new StreamSource( new File( strXmlPath ) );

        String strHtmlDoc = null;

        Map<String, String> params = new HashMap<String, String>( );
        params.put( PARAMS_LOCAL, locale.toString( ) );
        params.put( PARAMS_DEFAULT_LOCAL, LOCAL_DEFAULT );

        XmlTransformerService xmlTransformerService = new XmlTransformerService( );
        String strUniqueId = ADMIN_DOCUMENTATION_XSL_UNIQUE_PREFIX + strXmlPath;

        try
        {
            strHtmlDoc = xmlTransformerService.transformBySourceWithXslCache( sourceXml, sourceStyleSheet, strUniqueId, params, null );
        }
        catch( Exception e )
        {
            AppLogService.error( "Can't parse XML: " + e.getMessage( ), e );

            return null;
        }

        return strHtmlDoc;
    }
