private List<FeatureGroup> getFeatureGroupsList( AdminUser user )
    {
        // structure that will be returned
        ArrayList<FeatureGroup> aOutFeatureGroupList = new ArrayList<FeatureGroup>( );

        // get the list of user's features
        Map<String, Right> featuresMap = user.getRights( );
        Collection<Right> features = featuresMap.values( );

        // for each group, load the features
        for ( FeatureGroup featureGroup : FeatureGroupHome.getFeatureGroupsList( ) )
        {
            ArrayList<Right> aLeftFeatures = new ArrayList<Right>( );

            for ( Right right : features )
            {
                right.setLocale( user.getLocale( ) );

                String strFeatureGroup = right.getFeatureGroup( );
                String strUrlDocumentation = right.getDocumentationUrl( );

                if ( featureGroup.getId( ).equalsIgnoreCase( strFeatureGroup ) && ( strUrlDocumentation != null ) && !( strUrlDocumentation.equals( "" ) ) )
                {
                    featureGroup.addFeature( right );
                }
                else
                    if ( ( strUrlDocumentation != null ) && !( strUrlDocumentation.equals( "" ) ) )
                    {
                        aLeftFeatures.add( right );
                    }
            }

            if ( !featureGroup.isEmpty( ) )
            {
                featureGroup.setLocale( user.getLocale( ) );
                aOutFeatureGroupList.add( featureGroup );
            }

            features = aLeftFeatures;
        }

        FeatureGroup featureGroupSystem = FeatureGroupHome.findByPrimaryKey( FEATURES_GROUP_SYSTEM );

        if ( ( featureGroupSystem != null ) && !features.isEmpty( ) )
        {
            boolean bSystemFeaturesGroupExist = false;

            // Check if the features group system exist in list features group
            for ( FeatureGroup featureGroup : aOutFeatureGroupList )
            {
                // if exist
                if ( featureGroup.getId( ).equalsIgnoreCase( featureGroupSystem.getId( ) ) )
                {
                    // add the features with no group to the list in features group SYSTEM
                    for ( Right right : features )
                    {
                        featureGroup.addFeature( right );
                    }

                    bSystemFeaturesGroupExist = true;

                    break;
                }
            }

            // if not, add features group SYSTEM to the list with the feautres no group
            if ( !bSystemFeaturesGroupExist )
            {
                for ( Right right : features )
                {
                    featureGroupSystem.addFeature( right );
                }

                featureGroupSystem.setLocale( user.getLocale( ) );
                aOutFeatureGroupList.add( featureGroupSystem );
            }
        }
        else
            if ( ( aOutFeatureGroupList.size( ) > 0 ) && !features.isEmpty( ) )
            {
                FeatureGroup lastFeatureGroup = aOutFeatureGroupList.get( aOutFeatureGroupList.size( ) - 1 );

                for ( Right right : features )
                {
                    lastFeatureGroup.addFeature( right );
                }
            }

        return aOutFeatureGroupList;
    }
