public void fillTemplate( Map<String, Object> rootModel, PageData data, int nMode, HttpServletRequest request )
    {
        if ( request == null )
        {
            return;
        }
        // Add links coming from the data object
        String strFavourite = ( data.getFavourite( ) != null ) ? data.getFavourite( ) : PortalService.getSiteName( );
        String strPortalName = PortalService.getSiteName( );
        rootModel.put( MARK_FAVOURITE, strFavourite );
        rootModel.put( MARK_PORTAL_NAME, strPortalName );

        Locale locale = request.getLocale( );

        // Add CSS links coming from plugins
        Collection<Plugin> listPlugins = PluginService.getPluginList( );
        listPlugins.add( PluginService.getCore( ) );

        String strPage = request.getParameter( PARAMETER_PAGE );

        for ( Plugin plugin : listPlugins )
        {
            if ( plugin.isInstalled( ) )
            {
                Theme xpageTheme = plugin.getXPageTheme( request );

                if ( ( strPage != null ) && ( xpageTheme != null ) )
                {
                    for ( XPageApplicationEntry entry : plugin.getApplications( ) )
                    {
                        if ( strPage.equals( entry.getId( ) ) )
                        {
                            rootModel.put( MARK_PLUGIN_THEME_CSS, xpageTheme );
                        }
                    }
                }
            }
        }

        LinksIncludeCacheService cacheService = SpringContextService.getBean( LinksIncludeCacheService.SERVICE_NAME );
        String strKey = cacheService.getCacheKey( nMode, strPage, locale );
        @SuppressWarnings( "unchecked" )
        Map<String, Object> links = (Map<String, Object>) cacheService.getFromCache( strKey );
        if ( links == null )
        {
            StringBuilder sbCssLinks = new StringBuilder( );
            StringBuilder sbJsLinks = new StringBuilder( );

            for ( Plugin plugin : listPlugins )
            {
                if ( plugin.isInstalled( ) )
                {
                    boolean bXPage = isPluginXPage( strPage, plugin );

                    if ( plugin.isCssStylesheetsScopePortal( ) || ( bXPage && plugin.isCssStylesheetsScopeXPage( ) ) )
                    {
                        for ( String strCssStyleSheet : plugin.getCssStyleSheets( ) )
                        {
                            appendStyleSheet( request.getServletContext( ), sbCssLinks, strCssStyleSheet, locale );
                        }

                        for ( String strCssStyleSheet : plugin.getCssStyleSheets( nMode ) )
                        {
                            appendStyleSheet( request.getServletContext( ), sbCssLinks, strCssStyleSheet, locale );
                        }
                    }

                    if ( plugin.isJavascriptFilesScopePortal( ) || ( bXPage && plugin.isJavascriptFilesScopeXPage( ) ) )
                    {
                        for ( String strJavascriptFile : plugin.getJavascriptFiles( ) )
                        {
                            appendJavascriptFile( request.getServletContext( ), sbJsLinks, strJavascriptFile, locale );
                        }

                        for ( String strJavascriptFile : plugin.getJavascriptFiles( nMode ) )
                        {
                            appendJavascriptFile( request.getServletContext( ), sbJsLinks, strJavascriptFile, locale );
                        }
                    }
                }
            }

            links = new HashMap<>( 2 );
            links.put( MARK_PLUGINS_CSS_LINKS, sbCssLinks.toString( ) );
            links.put( MARK_PLUGINS_JAVASCRIPT_LINKS, sbJsLinks.toString( ) );
            cacheService.putInCache( strKey, links );
        }
        rootModel.putAll( links );
    }
