private URI getURI( ServletContext servletContext, String strResourceURI, String strURIPrefix )
    {
        try
        {
            URI resourceURI = new URI( strResourceURI );
            if ( !resourceURI.isAbsolute( ) && resourceURI.getHost( ) == null )
            {
                if ( strURIPrefix != null )
                {
                    resourceURI = new URI( strURIPrefix + strResourceURI );
                }
                try( InputStream inputStream = servletContext.getResourceAsStream( resourceURI.getPath( ) ) )
                {
                    if ( inputStream != null )
                    {
                        String hash = CryptoService.digest( inputStream, ALGORITHM );
                        if ( hash != null )
                        {
                            char separator = '?';
                            if ( resourceURI.getQuery( ) != null )
                            {
                                separator = '&';
                            }
                            resourceURI = new URI( resourceURI.toString( ) + separator + "lutece_h=" + hash );
                        }
                    }
                }
                catch( IOException e )
                {
                    AppLogService.error( "Error while closing stream for " + strResourceURI, e );
                }
            }
            return resourceURI;
        }
        catch( URISyntaxException e )
        {
            AppLogService.error( "Invalid cssStyleSheetURI : " + strResourceURI, e );
            return null;
        }
    }
