public static Locale getDefault( )
    {
        if ( _locale != null )
        {
            return _locale ;
        }
        else
        {
            String dsLang = DatastoreService.getInstanceDataValue( DSKEY_LANGUAGE_DEFAULT, null );
            
            if ( dsLang != null )
            {
                for ( String strISOLang : Locale.getISOLanguages( ) )
                {
                    if ( strISOLang.equals( dsLang ) )
                    {
                        _locale = new Locale( dsLang );
                        AppLogService.info( "LocaleService : default locale set to : " + dsLang );

                        return _locale;
                    }
                }
            }

            // otherwise, get the default locale from properties
            _locale = new Locale( AppPropertiesService.getProperty( PROPERTY_LANG_DEFAULT ) );
            AppLogService.error( "LocaleService : invalid defined locale " + dsLang + " - default set to " + _locale.getLanguage( ) );
                        
            return _locale;
        }
    }
