public String doModifyRole( HttpServletRequest request ) throws AccessDeniedException
    {
        String strOldRoleKey = request.getParameter( PARAMETER_ROLE_KEY_PREVIOUS );
        String strNewRoleKey = request.getParameter( PARAMETER_ROLE_KEY );
        String strRoleDescription = request.getParameter( PARAMETER_ROLE_DESCRIPTION );

        // check that new role key is valid
        if ( StringUtils.isBlank( strNewRoleKey ) || StringUtils.isBlank( strRoleDescription ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        if ( strOldRoleKey.equals( strNewRoleKey ) ) // if the key doesn't change, update the description
        {
            if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_VIEW_ROLE_DESCRIPTION ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }
            // update the role
            AdminRole role = AdminRoleHome.findByPrimaryKey( strOldRoleKey );
            role.setKey( strNewRoleKey );
            role.setDescription( strRoleDescription );
            AdminRoleHome.update( strOldRoleKey, role );
        }
        else
        // if the key changes, first check that the new key doesn't exist
        {
            if ( AdminRoleHome.checkExistRole( strNewRoleKey ) )
            {
                return AdminMessageService.getMessageUrl( request, PROPERTY_ROLE_ALREADY_EXISTS, AdminMessage.TYPE_STOP );
            }
            if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_VIEW_ROLE_DESCRIPTION ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }

            // update the role
            AdminRole role = AdminRoleHome.findByPrimaryKey( strOldRoleKey );
            role.setKey( strNewRoleKey );
            role.setDescription( strRoleDescription );
            AdminRoleHome.update( strOldRoleKey, role );
            AdminUserHome.updateUsersRole( strOldRoleKey, role );

            // update the role key in the role-resource associations
            RBACHome.updateRoleKey( strOldRoleKey, strNewRoleKey );
        }

        return JSP_URL_ROLE_DESCRIPTION + "?" + PARAMETER_ROLE_KEY + "=" + strNewRoleKey;
    }
