public String getViewRoleDescription( HttpServletRequest request )
    {
        setPageTitleProperty( PROPERTY_ROLE_DESCRIPTION_PAGETITLE );

        String strRoleKey = request.getParameter( PARAMETER_ROLE_KEY );

        Collection<RBAC> listResources = RBACHome.findResourcesByCode( strRoleKey );
        I18nService.localizeCollection( listResources, getLocale( ) );

        Collection<ResourceType> listResourceTypes = ResourceTypeManager.getResourceTypeList( );
        I18nService.localizeCollection( listResourceTypes, getLocale( ) );

        AdminRole adminRole = AdminRoleHome.findByPrimaryKey( strRoleKey );

        if ( adminRole == null )
        {
            return getManageRoles( request );
        }

        Map<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_ROLE, adminRole );
        model.put( MARK_CONTROLED_RESOURCE_LIST, listResources );
        model.put( MARK_RESOURCE_TYPE_LIST, listResourceTypes );
        model.put( SecurityTokenService.MARK_TOKEN, SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_VIEW_ROLE_DESCRIPTION ) );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_VIEW_ROLE_DESCRIPTION, getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
