public IPluginActionResult doProcessExtendableResourceAction( HttpServletRequest request, HttpServletResponse response ) throws AccessDeniedException
    {
        IExtendableResourcePluginAction action = PluginActionManager.getPluginAction( request, IExtendableResourcePluginAction.class );

        if ( action != null )
        {
            AppLogService.debug( "Processing resource action " + action.getName( ) );

            return action.process( request, response, getUser( ), null );
        }

        // If no action, then redirect the user to the home page
        UrlItem url = new UrlItem( AppPathService.getBaseUrl( request ) + AppPathService.getAdminMenuUrl( ) );
        DefaultPluginActionResult result = new DefaultPluginActionResult( );
        result.setRedirect( url.getUrl( ) );

        return result;
    }
