public String doModifyMode( HttpServletRequest request ) throws AccessDeniedException
    {
        String strId = request.getParameter( Parameters.MODE_ID );
        String strDescription = request.getParameter( Parameters.MODE_DESCRIPTION );

        if ( strDescription.equals( "" ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_MODIFY_MODE ) )
        {
            throw new AccessDeniedException( "Invalid securioty token" );
        }
        Mode mode = ModeHome.findByPrimaryKey( Integer.parseInt( strId ) );
        mode.setDescription( strDescription );

        /* Since v1.2 */
        mode.setOutputXslPropertyMethod( request.getParameter( Parameters.MODE_OUTPUT_XSL_METHOD ) );
        mode.setOutputXslPropertyVersion( request.getParameter( Parameters.MODE_OUTPUT_XSL_VERSION ) );
        mode.setOutputXslPropertyMediaType( request.getParameter( Parameters.MODE_OUTPUT_XSL_MEDIA_TYPE ) );
        mode.setOutputXslPropertyEncoding( request.getParameter( Parameters.MODE_OUTPUT_XSL_ENCODING ) );
        mode.setOutputXslPropertyIndent( request.getParameter( Parameters.MODE_OUTPUT_XSL_INDENT ) );
        mode.setOutputXslPropertyOmitXmlDeclaration( request.getParameter( Parameters.MODE_OUTPUT_XSL_OMIT_XML_DECLARATION ) );
        mode.setOutputXslPropertyStandalone( request.getParameter( Parameters.MODE_OUTPUT_XSL_STANDALONE ) );

        ModeHome.update( mode );

        // If the process is successfull, redirects towards the mode management page
        return JSP_MANAGE_MODES;
    }
