public String doCreateStyle( HttpServletRequest request ) throws AccessDeniedException
    {
        String strId = request.getParameter( Parameters.STYLE_ID );

        // Mandatory fields
        if ( request.getParameter( Parameters.STYLE_ID ).equals( "" ) || request.getParameter( Parameters.STYLE_NAME ).equals( "" ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        int nId;

        try
        {
            nId = Integer.parseInt( strId );
        }
        catch( NumberFormatException nb )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CREATE_STYLE_INVALID_FORMAT_ID, AdminMessage.TYPE_STOP );
        }

        Style styleExisting = StyleHome.findByPrimaryKey( nId );

        if ( styleExisting != null )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CREATE_STYLE_ID_ALREADY_EXISTS, AdminMessage.TYPE_STOP );
        }

        int nPortalComponentId = Integer.parseInt( request.getParameter( Parameters.PORTAL_COMPONENT ) );

        if ( StyleHome.checkStylePortalComponent( nPortalComponentId ) && ( nPortalComponentId != PORTAL_COMPONENT_ID_PORTLET ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CREATE_STYLE_COMPONENT_EXISTS, AdminMessage.TYPE_STOP );
        }

        if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_CREATE_STYLE ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }

        // The style doesn't exist in the database, we can create it
        Style style = new Style( );
        style.setId( nId );
        style.setDescription( request.getParameter( Parameters.STYLE_NAME ) );
        style.setPortalComponentId( nPortalComponentId );

        String strPortletTypeId = request.getParameter( Parameters.PORTLET_TYPE );
        strPortletTypeId = ( strPortletTypeId != null ) ? strPortletTypeId : "";
        style.setPortletTypeId( strPortletTypeId );
        StyleHome.create( style );

        return getHomeUrl( request );
    }
