public String doModifyStyle( HttpServletRequest request ) throws AccessDeniedException
    {
        int nStyleId = Integer.parseInt( request.getParameter( Parameters.STYLE_ID ) );

        // the portlet type can be not present the request if the portal component is not a portlet
        String strPortletTypeId = request.getParameter( Parameters.PORTLET_TYPE );
        strPortletTypeId = ( strPortletTypeId != null ) ? strPortletTypeId : "";

        int nPortalComponentId = Integer.parseInt( request.getParameter( Parameters.PORTAL_COMPONENT ) );
        String strStyleDescription = request.getParameter( Parameters.STYLE_NAME );

        if ( strStyleDescription.trim( ).equals( "" ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        Style style = StyleHome.findByPrimaryKey( nStyleId );
        int nPortalComponentOld = style.getPortalComponentId( );

        if ( StyleHome.checkStylePortalComponent( nPortalComponentId ) && ( nPortalComponentId != PORTAL_COMPONENT_ID_PORTLET )
                && ( nPortalComponentId != nPortalComponentOld ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CREATE_STYLE_COMPONENT_EXISTS, AdminMessage.TYPE_STOP );
        }
        if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_MODIFY_STYLE ) )
        {
            throw new AccessDeniedException( "Invalid Security token" );
        }

        style.setPortletTypeId( strPortletTypeId );
        style.setPortalComponentId( nPortalComponentId );
        style.setDescription( strStyleDescription );
        StyleHome.update( style );

        return getHomeUrl( request );
    }
