public String getConfirmRemoveStyle( HttpServletRequest request )
    {
        String strId = request.getParameter( Parameters.STYLE_ID );
        int nId = Integer.parseInt( strId );
        Collection<PortletImpl> listPortlets = PortletHome.getPortletListByStyle( nId );
        Collection<StyleSheet> listStyleSheets = StyleHome.getStyleSheetList( nId );

        if ( listPortlets.size( ) > 0 )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CANT_DELETE_STYLE_PORTLETS, AdminMessage.TYPE_STOP );
        }

        if ( listStyleSheets.size( ) > 0 )
        {
            for ( StyleSheet styleSheet : listStyleSheets )
            {
                Object [ ] args = {
                    styleSheet.getDescription( )
                };

                Map<String, Object> parameters = new HashMap<>( );
                parameters.put( Parameters.STYLESHEET_ID, Integer.toString( styleSheet.getId( ) ) );
                parameters.put( Parameters.STYLE_ID, Integer.toString( styleSheet.getStyleId( ) ) );
                parameters.put( SecurityTokenService.PARAMETER_TOKEN,
                        SecurityTokenService.getInstance( ).getToken( request, JSP_DO_REMOVE_STYLESHEET ) );
                return AdminMessageService.getMessageUrl( request, MESSAGE_CONFIRM_DELETE_STYLESHEET, args, null,
                        JSP_DO_REMOVE_STYLESHEET, null, AdminMessage.TYPE_CONFIRMATION, parameters );
            }
        }

        Map<String, String> parameters = new HashMap<>( );
        parameters.put( Parameters.STYLE_ID, Integer.toString( nId ) );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, JSP_DO_REMOVE_STYLE ) );

        return AdminMessageService.getMessageUrl( request, MESSAGE_CONFIRM_DELETE_STYLE, JSP_DO_REMOVE_STYLE, AdminMessage.TYPE_CONFIRMATION, parameters );
    }
