public String doModifyStyleSheet( HttpServletRequest request ) throws AccessDeniedException
    {
        MultipartHttpServletRequest multipartRequest = ( MultipartHttpServletRequest ) request;
        int nId = Integer.parseInt( multipartRequest.getParameter( Parameters.STYLESHEET_ID ) );
        StyleSheet stylesheet = StyleSheetHome.findByPrimaryKey( nId );
        String strErrorUrl = getData( multipartRequest, stylesheet );

        if ( strErrorUrl != null )
        {
            return strErrorUrl;
        }
        if ( !SecurityTokenService.getInstance( ).validate( multipartRequest, TEMPLATE_MODIFY_STYLESHEET ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }

        // Remove the old local file
        removeOldLocalStyleSheet( nId );

        // Update the stylesheet in database
        StyleSheetHome.update( stylesheet );

        // Recreate the local file
        localStyleSheetFile( stylesheet );

        // Displays the management stylesheet page
        return getHomeUrl( request );
    }
