public String doDaemonAction( HttpServletRequest request ) throws AccessDeniedException
    {
        String strAction = request.getParameter( PARAMETER_ACTION );
        String strDaemonKey = request.getParameter( PARAMETER_DAEMON );

        switch( strAction )
        {
            case ACTION_START:
                assertSecurityToken( request );
                AppDaemonService.startDaemon( strDaemonKey );
                break;
            case ACTION_STOP:
                assertSecurityToken( request );
                AppDaemonService.stopDaemon( strDaemonKey );
                break;
            case ACTION_RUN:
                assertSecurityToken( request );
                AppDaemonService.signalDaemon( strDaemonKey );
                break;
            case ACTION_UPDATE_INTERVAL:
                String strErrorMessage = null;
                String strDaemonInterval = request.getParameter( PARAMETER_INTERVAL );

                Object [ ] tabFieldInterval = {
                    I18nService.getLocalizedString( PROPERTY_FIELD_INTERVAL, getLocale( ) )
                };

                if ( StringUtils.isEmpty( strDaemonInterval ) )
                {
                    strErrorMessage = MESSAGE_MANDATORY_FIELD;
                }
                else
                    if ( !StringUtils.isNumeric( strDaemonInterval ) )
                    {
                        strErrorMessage = MESSAGE_NUMERIC_FIELD;
                    }

                if ( strErrorMessage != null )
                {
                    return AdminMessageService.getMessageUrl( request, strErrorMessage, tabFieldInterval, AdminMessage.TYPE_STOP );
                }

                assertSecurityToken( request );
                AppDaemonService.modifyDaemonInterval( strDaemonKey, strDaemonInterval );
                break;
            default:
                AppLogService.error( "Unknown daemon action : " + strAction );
        }

        return getHomeUrl( request );
    }
