public String doInstallPlugin( HttpServletRequest request, ServletContext context ) throws AccessDeniedException
    {
        String strPluginName = request.getParameter( PARAM_PLUGIN_NAME );
        Plugin plugin = PluginService.getPlugin( strPluginName );

        if ( !verifyCoreCompatibility( plugin ) )
        {
            Object[ ] args = { plugin.getMinCoreVersion( ), plugin.getMaxCoreVersion( ) };

            return AdminMessageService.getMessageUrl( request, PROPERTY_PLUGIN_NO_CORE_COMPATIBILITY_MESSAGE, args,
                    AdminMessage.TYPE_STOP );

        }
        if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_MANAGE_PLUGINS ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }
        try
        {
            plugin.install( );
        }
        catch ( Exception e )
        {
            AppLogService.error( e.getMessage( ), e );

            return AdminMessageService.getMessageUrl( request, PROPERTY_PLUGIN_INSTALL_ERROR, AdminMessage.TYPE_STOP );
        }

        return getHomeUrl( request );
    }
