private boolean verifyCoreCompatibility( Plugin plugin )
    {
        String strCoreVersion = AppInfo.getVersion( );

        // Remove version qualifier (-SNAPSHOT, -RC-XX, ...)
        int nPos = strCoreVersion.indexOf( "-" );

        if ( nPos > 0 )
        {
            strCoreVersion = strCoreVersion.substring( 0, nPos );
        }

        String [ ] coreVersion = strCoreVersion.split( "\\." );

        String strMinCoreVersion = ( plugin.getMinCoreVersion( ) == null ) ? "" : plugin.getMinCoreVersion( );
        String strMaxCoreVersion = ( plugin.getMaxCoreVersion( ) == null ) ? "" : plugin.getMaxCoreVersion( );

        // test the min core version
        boolean bMin = ( strMinCoreVersion == null ) || strMinCoreVersion.trim( ).equals( "" );

        if ( ( strMinCoreVersion != null ) && !strMinCoreVersion.trim( ).equals( "" ) )
        {
            String [ ] minCoreVersion = strMinCoreVersion.split( "\\." );

            if ( checkCoreMinCompatibility( minCoreVersion, coreVersion ) )
            {
                AppLogService.debug( "Min core version ok : " + plugin.getMinCoreVersion( ) );
                bMin = true;
            }
        }

        // test the max core version
        boolean bMax = ( strMaxCoreVersion == null ) || strMaxCoreVersion.trim( ).equals( "" );

        if ( ( strMaxCoreVersion != null ) && !strMaxCoreVersion.trim( ).equals( "" ) )
        {
            String [ ] maxCoreVersion = strMaxCoreVersion.split( "\\." );

            if ( checkCoreMaxCompatibility( maxCoreVersion, coreVersion ) )
            {
                AppLogService.debug( "Max core version ok : " + plugin.getMaxCoreVersion( ) );
                bMax = true;
            }
        }

        return bMin && bMax;
    }
