public String getManageFilesSystemDir( HttpServletRequest request )
    {
        setPageTitleProperty( PROPERTY_TITLE_VIEW_FILES_SYSTEM );
        String strDir = request.getParameter( PARAMETER_DIR );

        if ( !isValidDirectoryPath( strDir ) )
        {
            return getManageFilesSystem( request );
        }

        String strDirectory = AppPathService.getWebAppPath( ) + strDir;
        File directory = new File( strDirectory );
        ArrayList<SystemFile> listFiles = new ArrayList<SystemFile>( );
        for ( File file : directory.listFiles( ) )
        {
            SystemFile sFile = new SystemFile( );
            sFile.setName( file.getName( ) );
            sFile.setDirectory( strDir );
            sFile.setSize( (int) ( file.length( ) / 1000 ) + 1 );
            sFile.setDate( new Date( file.lastModified( ) ) );
            listFiles.add( sFile );
        }
        Collections.sort( listFiles );

        Map<String, Serializable> model = new HashMap<String, Serializable>( );
        model.put( MARK_FILES_LIST, listFiles );
        model.put( MARK_FILES_SYSTEM_DIRECTORY, strDir );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_VIEW_FILES_SYSTEM, getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
