private void cleanExpiredEntries( )
    {
        AppLogService.debug( "DosGuard.class : cleanExpiredEntries()" );

        if ( _listOrderedRequests.size( ) != 0 )
        {
            // Expired entries are those where the IP can't be blocked anymore
            long lMinTime = System.currentTimeMillis( ) - _nMinInterval;

            AppLogService.debug( "Min time : " + lMinTime );

            // Read entries from the list, remove them as long as they are expired
            boolean bDone = false;

            while ( !bDone && ( _listOrderedRequests.size( ) > 0 ) )
            {
                // The list is ordered by arrival time, so the last one is the
                // oldest
                Entry lastEntry = _listOrderedRequests.getLast( );

                if ( lastEntry.getRequestTime( ) < lMinTime )
                {
                    // The entry is expired, remove it from the map and the list
                    _mapLastRequestTimes.remove( lastEntry.getRemoteAddr( ) );
                    _listOrderedRequests.removeLast( );

                    AppLogService.debug( "Removing [" + lastEntry.getRemoteAddr( ) + ", " + lastEntry.getRequestTime( ) + "]" );
                }
                else
                {
                    bDone = true;
                }
            }
        }
    }
