@Override
    public void init( FilterConfig config ) throws ServletException
    {
        _filterConfig = config;
        _mapLastRequestTimes = new HashMap<String, Long>( INITIAL_CAPACITY );
        _listOrderedRequests = new LinkedList<Entry>( );

        try
        {
            String paramValue = _filterConfig.getInitParameter( "minContentLength" );

            if ( paramValue != null )
            {
                _nMinContentLength = Integer.parseInt( paramValue );
            }

            paramValue = _filterConfig.getInitParameter( "minInterval" );

            if ( paramValue != null )
            {
                _nMinInterval = Integer.parseInt( paramValue );
            }
        }
        catch( NumberFormatException ex )
        {
            ServletException servletEx = new ServletException( ex.getMessage( ) );
            servletEx.initCause( ex );
            throw servletEx;
        }
    }
