@Override
    public void doFilter( ServletRequest request, ServletResponse response, FilterChain chain ) throws IOException, ServletException
    {
        HttpServletRequest httpRequest = (HttpServletRequest) request;

        if ( !MultipartUtil.isMultipart( httpRequest ) )
        {
            chain.doFilter( request, response );
        }
        else
        {
            try
            {
                MultipartHttpServletRequest multiHtppRequest = MultipartUtil.convert( _nSizeThreshold, _nRequestSizeMax, _bActivateNormalizeFileName,
                        httpRequest );
                chain.doFilter( multiHtppRequest, response );
            }
            catch( SizeLimitExceededException e )
            {
                AppLogService.error( e.getMessage( ), e );

                Object [ ] args = {
                    getDisplaySize( )
                };
                ( (HttpServletResponse) response ).sendRedirect( getMessageRelativeUrl( httpRequest, PROPERTY_MESSAGE_FILE_SIZE_LIMIT_EXCEEDED, args,
                        PROPERTY_TITLE_FILE_SIZE_LIMIT_EXCEEDED ) );
            }
            catch( FileUploadException e )
            {
                AppLogService.error( e.getMessage( ), e );
                throw new ServletException( "Unkown error occured during the upload", e );
            }
        }
    }
