@Override
    public void init( FilterConfig config ) throws ServletException
    {
        _filterConfig = config;

        try
        {
            String paramValue = _filterConfig.getInitParameter( SIZE_THRESHOLD );

            if ( paramValue != null )
            {
                _nSizeThreshold = Integer.parseInt( paramValue );
            }

            paramValue = _filterConfig.getInitParameter( REQUEST_SIZE_MAX );

            if ( paramValue != null )
            {
                _nRequestSizeMax = Long.parseLong( paramValue );
            }

            paramValue = _filterConfig.getInitParameter( ACTIVATE_NORMALIZE_FILE_NAME );

            if ( paramValue != null )
            {
                _bActivateNormalizeFileName = Boolean.valueOf( paramValue );
            }
        }
        catch( NumberFormatException ex )
        {
            AppLogService.error( ex.getMessage( ), ex );
            throw new ServletException( ex.getMessage( ), ex );
        }
    }
