@Override
    protected void doPost( HttpServletRequest req, HttpServletResponse response ) throws ServletException, IOException
    {
        MultipartHttpServletRequest request = (MultipartHttpServletRequest) req;

        List<FileItem> listFileItems = new ArrayList<FileItem>( );
        // When removing IAsynchronousUploadHandler, remove all the populating of the JSONObject
        JSONObject json = new JSONObject( );
        Map<String, Object> mapJson = new HashMap<>( );
        json.element( JSON_FILES, new JSONArray( ) );
        List<Map<String, Object>> listJsonFileMap = new ArrayList<>( );
        mapJson.put( JSON_FILES, listJsonFileMap );

        for ( Entry<String, List<FileItem>> entry : ( request.getFileListMap( ) ).entrySet( ) )
        {
            for ( FileItem fileItem : entry.getValue( ) )
            {
                JSONObject jsonFile = new JSONObject( );
                jsonFile.element( JSON_FILE_NAME, fileItem.getName( ) );
                jsonFile.element( JSON_FILE_SIZE, fileItem.getSize( ) );
                Map<String, Object> jsonFileMap = new HashMap<>( );
                jsonFileMap.put( JSON_FILE_NAME, fileItem.getName( ) );
                jsonFileMap.put( JSON_FILE_SIZE, fileItem.getSize( ) );

                // add to existing array
                json.accumulate( JSON_FILES, jsonFile );
                listJsonFileMap.add( jsonFileMap );

                listFileItems.add( fileItem );
            }
        }

        IAsynchronousUploadHandler2 handler2 = getHandler2( request );
        // IAsynchronousUploadHandler to be removed in the future
        IAsynchronousUploadHandler handler = null;
        if ( handler2 != null )
        {
            handler2.process( request, response, mapJson, listFileItems );
        }
        else
        {
            // The new interface IAsynchronousUploadHandler2 is not implemented yet,
            // try with the deprecated interface.
            handler = getHandler( request );

            // When removing IAsynchronousUploadHandler in the future, delete this if,
            // keep only the 'true' block.
            if ( handler == null )
            {
                AppLogService.error( "No handler found, removing temporary files" );

                for ( FileItem fileItem : listFileItems )
                {
                    fileItem.delete( );
                }
            }
            else
            {
                AppLogService.info( "Using deprecated IAsynchronousUploadHandler; Use IAsynchronousUploadHandler2 instead. handler = " + handler );
                handler.process( request, response, json, listFileItems );
            }
        }

        // When removing IAsynchronousUploadHandler in the future, delete this if,
        // keep only the 'false' block.
        String strResultJson;
        if ( handler != null )
        {
            strResultJson = json.toString( );
        }
        else
        {
            strResultJson = objectMapper.writeValueAsString( mapJson );
        }

        if ( AppLogService.isDebugEnabled( ) )
        {
            AppLogService.debug( "Aysnchronous upload : " + strResultJson );
        }

        response.setContentType( JSON_UTF8_CONTENT_TYPE );
        response.getWriter( ).print( strResultJson );
    }
