public String doForgotLogin( HttpServletRequest request ) throws Exception
    {
        String strEmail = request.getParameter( Parameters.EMAIL );
        Locale locale = AdminUserService.getLocale( request );

        if ( ( strEmail == null ) || strEmail.equals( CONSTANT_EMPTY_STRING ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        if ( !AdminUserService.checkEmail( strEmail ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_WRONG_EMAIL_FORMAT, AdminMessage.TYPE_STOP );
        }

        if ( locale == null )
        {
            locale = LocaleService.getDefault( );
        }

        // if access code not found, send admin message
        String strAccessCode = AdminUserHome.findUserByEmail( strEmail );

        if ( StringUtils.isEmpty( strAccessCode ) )
        {
            return JSP_URL_FORM_CONTACT;
        }

        // send access code by e-mail
        String strSenderEmail = MailService.getNoReplyEmail( );
        String strEmailSubject = I18nService.getLocalizedString( MESSAGE_FORGOT_LOGIN_EMAIL_SUBJECT, locale );
        HashMap<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_LOGIN, strAccessCode );
        model.put( MARK_LOGIN_URL, AppPathService.getBaseUrl( request ) + AdminAuthenticationService.getInstance( ).getLoginPageUrl( ) );
        model.put( MARK_SITE_LINK, MailService.getSiteLink( AppPathService.getBaseUrl( request ), false ) );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_ADMIN_EMAIL_FORGOT_LOGIN, locale, model );

        MailService.sendMailHtml( strEmail, strSenderEmail, strSenderEmail, strEmailSubject, template.getHtml( ) );

        return AdminMessageService.getMessageUrl( request, MESSAGE_FORGOT_LOGIN_SENDING_SUCCESS, AdminMessage.TYPE_INFO );
    }
