public String doResetPassword( HttpServletRequest request )
    {
        if ( !"POST".equals( request.getMethod( ) ) )
        {
            throw new AppException( "This method should requested via POST" );
        }

        String strUserId = request.getParameter( Parameters.USER_ID );

        if ( !StringUtils.isNumeric( strUserId ) || StringUtils.isBlank( strUserId ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        String strTimestamp = request.getParameter( PARAMETER_TIMESTAMP );

        if ( !StringUtils.isNumeric( strTimestamp ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        String strToken = request.getParameter( PARAMETER_TOKEN );

        if ( StringUtils.isEmpty( strToken ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        String strNewPassword = request.getParameter( Parameters.NEW_PASSWORD );
        String strConfirmNewPassword = request.getParameter( Parameters.CONFIRM_NEW_PASSWORD );

        if ( StringUtils.isEmpty( strNewPassword ) || StringUtils.isEmpty( strConfirmNewPassword ) )
        {
            return AdminMessageService.getMessageUrl( request, Messages.MANDATORY_FIELDS, AdminMessage.TYPE_STOP );
        }

        if ( !strNewPassword.equals( strConfirmNewPassword ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_CONTROL_PASSWORD_NO_CORRESPONDING, AdminMessage.TYPE_STOP );
        }

        LuteceDefaultAdminUser user = AdminUserHome.findLuteceDefaultAdminUserByPrimaryKey( Integer.parseInt( strUserId ) );

        if ( user == null )
        {
            user = new LuteceDefaultAdminUser( );
        }

        Date timestamp = new Date( Long.valueOf( strTimestamp ) );

        String strSystemToken = AdminUserService.getUserPasswordResetToken( user, timestamp, request );

        if ( !strSystemToken.equals( strToken ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_INVALID_RESET_TOKEN, AdminMessage.TYPE_STOP );
        }

        long lTokenAge = new Date( ).getTime( ) - timestamp.getTime( );

        if ( lTokenAge < 0 || lTokenAge > ( 1000L * 60 * AdminUserService.getIntegerSecurityParameter( AdminUserService.DSKEY_RESET_TOKEN_VALIDITY ) ) )
        {
            return AdminMessageService.getMessageUrl( request, MESSAGE_EXPIRED_RESET_TOKEN, AdminMessage.TYPE_STOP );
        }

        String strUrl = AdminUserService.checkPassword( request, strNewPassword, user.getUserId( ) );
        if ( StringUtils.isNotEmpty( strUrl ) )
        {
            return strUrl;
        }

        // all checks are OK. Proceed to password change
        user.setPasswordMaxValidDate( AdminUserService.getPasswordMaxValidDate( ) );
        IPasswordFactory passwordFactory = SpringContextService.getBean( IPasswordFactory.BEAN_NAME );
        user.setPassword( passwordFactory.getPasswordFromCleartext( strNewPassword ) );
        AdminUserHome.update( user );
        AdminUserHome.insertNewPasswordInHistory( user.getPassword( ), user.getUserId( ) );

        return AdminMessageService.getMessageUrl( request, MESSAGE_RESET_PASSORWD_SUCCESS, JSP_URL_ADMIN_LOGIN, AdminMessage.TYPE_INFO );
    }
