public String getLogin( HttpServletRequest request, HttpServletResponse response ) throws IOException
    {
        HashMap<String, Object> model = new HashMap<String, Object>( );

        HttpSession session = request.getSession( );

        if ( session != null )
        {
            // Invalidate a previous session
            session.removeAttribute( SESSION_ATTRIBUTE_USER );

            // Put real base url in session
            request.getSession( ).setAttribute( AppPathService.SESSION_BASE_URL, AppPathService.getBaseUrl( request ) );

            if ( !JSP_URL_ADMIN_LOGIN.equals( AdminAuthenticationService.getInstance( ).getLoginPageUrl( ) ) )
            {
                String strRedirectUrl = AdminAuthenticationService.getInstance( ).getLoginPageUrl( );
                if ( strRedirectUrl == null )
                {
                    strRedirectUrl = AppPathService.getAdminMenuUrl( );
                }
                response.sendRedirect( AppPathService.resolveRedirectUrl( request, strRedirectUrl ).getUrl( ) );
                return null;
            }

        }

        Locale locale = AdminUserService.getLocale( request );

        Enumeration<String> enumParams = request.getParameterNames( );
        ReferenceList listParams = new ReferenceList( );
        String strParamName;

        while ( enumParams.hasMoreElements( ) )
        {
            strParamName = enumParams.nextElement( );

            String strParamValue = request.getParameter( strParamName );
            listParams.addItem( strParamName, strParamValue );
        }

        StringBuilder sbUrl = new StringBuilder( );

        if ( AppHTTPSService.isHTTPSSupportEnabled( ) )
        {
            sbUrl.append( AppHTTPSService.getHTTPSUrl( request ) );
        }
        else
        {
            sbUrl.append( AppPathService.getBaseUrl( request ) );
        }

        if ( !sbUrl.toString( ).endsWith( CONSTANT_SLASH ) )
        {
            sbUrl.append( CONSTANT_SLASH );
        }

        sbUrl.append( JSP_URL_DO_ADMIN_LOGIN );

        model.put( MARK_PARAM_VERSION, AppInfo.getVersion( ) );
        model.put( MARK_SITE_NAME, PortalService.getSiteName( ) );
        model.put( MARK_PARAMS_LIST, listParams );
        model.put( MARK_FORGOT_PASSWORD_URL, AdminAuthenticationService.getInstance( ).getLostPasswordPageUrl( ) );
        model.put( MARK_FORGOT_LOGIN_URL, AdminAuthenticationService.getInstance( ).getLostLoginPageUrl( ) );
        model.put( MARK_DO_ADMIN_LOGIN_URL, sbUrl.toString( ) );
        model.put( MARK_TOKEN, SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_ADMIN_LOGIN ) );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_ADMIN_LOGIN, locale, model );

        return template.getHtml( );
    }
