public String doAnonymizeAdminUser( HttpServletRequest request ) throws AccessDeniedException
    {
        String strAdminUserId = request.getParameter( PARAMETER_USER_ID );

        if ( !StringUtils.isNumeric( strAdminUserId ) || strAdminUserId.isEmpty( ) )
        {
            return AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_NO_ADMIN_USER_SELECTED, AdminMessage.TYPE_STOP );
        }

        int nUserId = Integer.parseInt( strAdminUserId );
        AdminUser user = AdminUserHome.findByPrimaryKey( nUserId );

        if ( user == null )
        {
            return AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_USER_ERROR_SESSION, AdminMessage.TYPE_ERROR );
        }
        if ( !SecurityTokenService.getInstance( ).validate( request, JSP_URL_ANONYMIZE_ADMIN_USER ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }

        AdminUserService.anonymizeUser( nUserId, getLocale( ) );

        return JSP_MANAGE_USER;
    }
