public String doConfirmRemoveAdminUser( HttpServletRequest request ) throws AccessDeniedException
    {
        String strUserId = request.getParameter( PARAMETER_USER_ID );
        int nUserId = Integer.parseInt( strUserId );
        AdminUser user = AdminUserHome.findByPrimaryKey( nUserId );

        if ( user == null )
        {
            return AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_USER_ERROR_SESSION, AdminMessage.TYPE_ERROR );
        }

        AdminUser currentUser = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( currentUser, user ) )
        {
            throw new fr.paris.lutece.portal.service.admin.AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        String strUrlRemove = JSP_URL_REMOVE_USER;
        Map<String, Object> parameters = new HashMap<>( );
        parameters.put( PARAMETER_USER_ID, strUserId );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, JSP_URL_REMOVE_USER ) );

        String strUrl = AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_CONFIRM_REMOVE, new Object [ ] {
                user.getFirstName( ), user.getLastName( ), user.getAccessCode( )
        }, null, strUrlRemove, null, AdminMessage.TYPE_CONFIRMATION, parameters );

        return strUrl;
    }
