public String doInsertRegularExpression( HttpServletRequest request ) throws AccessDeniedException
    {
        if ( !SecurityTokenService.getInstance( ).validate( request, JSP_MANAGE_ADVANCED_PARAMETERS ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }
        if ( !RBACService.isAuthorized( AdminUser.RESOURCE_TYPE, RBAC.WILDCARD_RESOURCES_ID, AdminUserResourceIdService.PERMISSION_MANAGE_ADVANCED_PARAMETERS,
                getUser( ) ) )
        {
            throw new AccessDeniedException( "User " + getUser( ) + " is not authorized to permission "
                    + AdminUserResourceIdService.PERMISSION_MANAGE_ADVANCED_PARAMETERS );
        }

        String strRegularExpressionId = request.getParameter( PARAMETER_ID_EXPRESSION );

        if ( StringUtils.isNotBlank( strRegularExpressionId ) && StringUtils.isNumeric( strRegularExpressionId ) )
        {
            int nRegularExpressionId = Integer.parseInt( strRegularExpressionId );
            AdminUserService.doInsertRegularExpression( nRegularExpressionId );
        }

        return JSP_MANAGE_ADVANCED_PARAMETERS;
    }
