public String doModifyAdminUserPassword( HttpServletRequest request ) throws AccessDeniedException
    {
        if ( !SecurityTokenService.getInstance( ).validate( request, PROPERTY_MODIFY_USER_PASSWORD_PAGETITLE ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }
        String strUserId = request.getParameter( PARAMETER_USER_ID );

        int nUserId = Integer.parseInt( strUserId );

        AdminUser userToModify = AdminUserHome.findByPrimaryKey( nUserId );

        if ( userToModify == null )
        {
            throw new AppException( "User " + strUserId + " not found" );
        }

        AdminUser currentUser = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( currentUser, userToModify ) )
        {
            throw new AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        // modification in no-module mode : we manage the password
        if ( AdminAuthenticationService.getInstance( ).isDefaultModuleUsed( ) )
        {
            LuteceDefaultAdminUser user = AdminUserHome.findLuteceDefaultAdminUserByPrimaryKey( nUserId );

            String strFirstPassword = request.getParameter( PARAMETER_FIRST_PASSWORD );
            String strSecondPassword = request.getParameter( PARAMETER_SECOND_PASSWORD );

            if ( StringUtils.isEmpty( strFirstPassword ) )
            {
                return AdminMessageService.getMessageUrl( request, MESSAGE_MANDATORY_FIELD, new String [ ] {
                    I18nService.getLocalizedString( PROPERTY_LABEL_FIRST_PASSWORD, getLocale( ) )
                }, AdminMessage.TYPE_STOP );
            }

            if ( !StringUtils.equals( strFirstPassword, strSecondPassword ) )
            {
                // First and second password are filled but there are different
                return AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_DIFFERENTS_PASSWORD, AdminMessage.TYPE_STOP );
            }

            String strUrl = AdminUserService.checkPassword( request, strFirstPassword, nUserId, Boolean.TRUE );

            if ( StringUtils.isNotEmpty( strUrl ) )
            {
                return strUrl;
            }

            user.setPassword( AdminUserService.encryptPassword( strFirstPassword ) );
            user.setPasswordReset( Boolean.FALSE );
            user.setPasswordMaxValidDate( AdminUserService.getPasswordMaxValidDate( ) );

            AdminUserHome.update( user, PasswordUpdateMode.UPDATE );

        }

        return JSP_MANAGE_USER;
    }
