public String doModifyAdminUserRights( HttpServletRequest request ) throws AccessDeniedException
    {
        if ( !SecurityTokenService.getInstance( ).validate( request, JSP_URL_MANAGE_USER_RIGHTS ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }
        String strUserId = request.getParameter( PARAMETER_USER_ID );
        int nUserId = Integer.parseInt( strUserId );

        String [ ] arrayRights = request.getParameterValues( PARAMETER_RIGHT );

        AdminUser user = AdminUserHome.findByPrimaryKey( nUserId );
        AdminUser userCurrent = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( userCurrent, user ) )
        {
            throw new fr.paris.lutece.portal.service.admin.AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        AdminUserHome.removeAllOwnRightsForUser( user );

        if ( arrayRights != null )
        {
            for ( int i = 0; i < arrayRights.length; i++ )
            {
                AdminUserHome.createRightForUser( nUserId, arrayRights [i] );
            }
        }

        if ( ( user != null ) && ( userCurrent != null ) && ( user.getUserId( ) == userCurrent.getUserId( ) ) )
        {
            try
            {
                AdminAuthenticationService.getInstance( ).registerUser( request, user );
            }
            catch( AccessDeniedException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
            catch( UserNotSignedException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
        }

        return JSP_MANAGE_USER_RIGHTS + "?" + PARAMETER_USER_ID + "=" + nUserId;
    }
