public String doModifyEmailPattern( HttpServletRequest request ) throws AccessDeniedException
    {
        if ( !RBACService.isAuthorized( AdminUser.RESOURCE_TYPE, RBAC.WILDCARD_RESOURCES_ID, AdminUserResourceIdService.PERMISSION_MANAGE_ADVANCED_PARAMETERS,
                getUser( ) ) )
        {
            throw new AccessDeniedException( "User " + getUser( ) + " is not authorized to permission "
                    + AdminUserResourceIdService.PERMISSION_MANAGE_ADVANCED_PARAMETERS );
        }
        if ( PARAMETER_RESET.equals( request.getParameter( PARAMETER_RESET ) ) )
        {
            if ( !SecurityTokenService.getInstance( ).validate( request, JSP_MANAGE_ADVANCED_PARAMETERS ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }
            return doResetEmailPattern( request );
        }
        String strJsp = StringUtils.EMPTY;
        String strSetManually = request.getParameter( PARAMETER_IS_EMAIL_PATTERN_SET_MANUALLY );
        String strEmailPattern = request.getParameter( PARAMETER_EMAIL_PATTERN );

        if ( StringUtils.isNotBlank( strEmailPattern ) )
        {
            if ( !SecurityTokenService.getInstance( ).validate( request, JSP_MANAGE_ADVANCED_PARAMETERS ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }
            AdminUserService.doModifyEmailPattern( strEmailPattern, strSetManually != null );
            strJsp = JSP_MANAGE_ADVANCED_PARAMETERS;
        }
        else
        {
            strJsp = AdminMessageService.getMessageUrl( request, PROPERTY_MESSAGE_ERROR_EMAIL_PATTERN, AdminMessage.TYPE_STOP );
        }

        return strJsp;
    }
