public String getManageAdminUserRoles( HttpServletRequest request ) throws AccessDeniedException
    {
        setPageTitleProperty( PROPERTY_MANAGE_USER_ROLES_PAGETITLE );

        String strUserId = request.getParameter( PARAMETER_USER_ID );
        int nUserId = Integer.parseInt( strUserId );
        AdminUser selectedUser = AdminUserHome.findByPrimaryKey( nUserId );
        AdminUser userCurrent = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( userCurrent, selectedUser ) )
        {
            throw new fr.paris.lutece.portal.service.admin.AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        Collection<AdminRole> roleList = AdminUserHome.getRolesListForUser( nUserId ).values( );

        // ITEM NAVIGATION
        setItemNavigator( nUserId, AppPathService.getBaseUrl( request ) + JSP_URL_MANAGE_USER_ROLES );

        Map<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_CAN_MODIFY, getUser( ).isParent( selectedUser ) || getUser( ).isAdmin( ) );
        model.put( MARK_CAN_DELEGATE, getUser( ).getUserId( ) != nUserId );
        model.put( MARK_USER, AdminUserHome.findByPrimaryKey( nUserId ) );
        model.put( MARK_USER_ROLE_LIST, roleList );
        model.put( MARK_ITEM_NAVIGATOR, _itemNavigator );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_MANAGE_USER_ROLES, getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
