public String getManageAdminUserWorkgroups( HttpServletRequest request ) throws AccessDeniedException
    {
        setPageTitleProperty( PROPERTY_MANAGE_USER_WORKGROUPS_PAGETITLE );

        String strUserId = request.getParameter( PARAMETER_USER_ID );
        int nUserId = Integer.parseInt( strUserId );

        AdminUser selectedUser = AdminUserHome.findByPrimaryKey( nUserId );
        AdminUser currentUser = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( currentUser, selectedUser ) )
        {
            throw new fr.paris.lutece.portal.service.admin.AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        ReferenceList workgroupsList = AdminWorkgroupHome.getUserWorkgroups( selectedUser );

        // ITEM NAVIGATION
        setItemNavigator( nUserId, AppPathService.getBaseUrl( request ) + JSP_URL_MANAGE_USER_WORKGROUPS );

        // ReferenceList assignableWorkgroupsList = AdminWorkgroupHome.getUserWorkgroups( selectedUser );
        Map<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_CAN_MODIFY, getUser( ).isParent( selectedUser ) || getUser( ).isAdmin( ) );
        model.put( MARK_CAN_DELEGATE, getUser( ).getUserId( ) != nUserId );
        model.put( MARK_USER, AdminUserHome.findByPrimaryKey( nUserId ) );
        model.put( MARK_USER_WORKGROUP_LIST, workgroupsList );
        model.put( MARK_ITEM_NAVIGATOR, _itemNavigator );

        HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_MANAGE_USER_WORKGROUPS, getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
