public String getModifyUserPassword( HttpServletRequest request ) throws AccessDeniedException
    {
        setPageTitleProperty( PROPERTY_MODIFY_USER_PASSWORD_PAGETITLE );

        String strUserId = request.getParameter( PARAMETER_USER_ID );

        int nUserId = Integer.parseInt( strUserId );

        Map<String, Object> model = new HashMap<String, Object>( );
        HtmlTemplate template;

        AdminUser user = null;
        String strTemplateUrl = "";

        // creation in no-module mode : load form with password modification field and login modification field
        if ( AdminAuthenticationService.getInstance( ).isDefaultModuleUsed( ) )
        {
            user = AdminUserHome.findLuteceDefaultAdminUserByPrimaryKey( nUserId );
            strTemplateUrl = TEMPLATE_DEFAULT_MODIFY_USER_PASSWORD;
        }
        else
        {
            throw new AppException( "Cannot modify password when not in DeafultModuleUsed mode" );
        }

        if ( ( user == null ) || ( user.getUserId( ) == 0 ) )
        {
            throw new AppException( "User to modify password for not found" );
        }

        AdminUser currentUser = AdminUserService.getAdminUser( request );

        if ( !isUserAuthorizedToModifyUser( currentUser, user ) )
        {
            throw new AccessDeniedException( MESSAGE_NOT_AUTHORIZED );
        }

        // ITEM NAVIGATION
        setItemNavigator( user.getUserId( ), AppPathService.getBaseUrl( request ) + JSP_URL_MODIFY_USER );

        model.put( MARK_USER, user );
        model.put( MARK_ITEM_NAVIGATOR, _itemNavigator );
        model.put( MARK_MINIMUM_PASSWORD_SIZE, AdminUserService.getIntegerSecurityParameter( AdminUserService.DSKEY_PASSWORD_MINIMUM_LENGTH ) );
        model.put( SecurityTokenService.MARK_TOKEN, SecurityTokenService.getInstance( ).getToken( request, PROPERTY_MODIFY_USER_PASSWORD_PAGETITLE ) );

        template = AppTemplateService.getTemplate( strTemplateUrl, getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
