private void reinitUserPasswordsAndNotify( HttpServletRequest request )
    {
        // Alert all users their password have been reinitialized.
        Collection<AdminUser> listUser = AdminUserHome.findUserList( );

        for ( AdminUser user : listUser )
        {
            Locale locale = getLocale( );

            // make password
            String strPassword = AdminUserService.makePassword( );

            // update password
            if ( StringUtils.isNotEmpty( strPassword ) )
            {
                LuteceDefaultAdminUser userStored = AdminUserHome.findLuteceDefaultAdminUserByPrimaryKey( user.getUserId( ) );
                userStored.setPassword( AdminUserService.encryptPassword( strPassword ) );
                userStored.setPasswordMaxValidDate( AdminUserService.getPasswordMaxValidDate( ) );
                userStored.setPasswordReset( Boolean.TRUE );
                AdminUserHome.update( userStored );
            }

            if ( !( ( user.getEmail( ) == null ) || user.getEmail( ).equals( CONSTANT_EMPTY_STRING ) ) )
            {
                // send password by e-mail
                String strSenderEmail = MailService.getNoReplyEmail( );
                String strEmailSubject = I18nService.getLocalizedString( MESSAGE_EMAIL_SUBJECT, locale );
                HashMap<String, Object> model = new HashMap<String, Object>( );
                model.put( MARK_NEW_PASSWORD, strPassword );
                model.put( MARK_LOGIN_URL, AppPathService.getBaseUrl( request ) + AdminAuthenticationService.getInstance( ).getLoginPageUrl( ) );
                model.put( MARK_SITE_LINK, MailService.getSiteLink( AppPathService.getBaseUrl( request ), false ) );

                HtmlTemplate template = AppTemplateService.getTemplate( TEMPLATE_ADMIN_EMAIL_FORGOT_PASSWORD, locale, model );

                MailService.sendMailHtml( user.getEmail( ), strSenderEmail, strSenderEmail, strEmailSubject, template.getHtml( ) );
            }
        }
    }
