private static void filterAccess( HttpServletRequest request ) throws UserNotSignedException, AccessDeniedException
    {
        if ( AdminAuthenticationService.getInstance( ).isExternalAuthentication( ) )
        {
            // The authentication is external
            // Should register the user if it's not already done
            AdminAuthenticationService.getInstance( ).getRemoteUser( request );
        }
        else
        {
            if ( AdminAuthenticationService.getInstance( ).getRegisteredUser( request ) == null )
            {
                // Authentication is required to access to the admin
                throw new UserNotSignedException( );
            }

            if ( AdminUserService.getAdminUser( request ).isPasswordReset( ) )
            {
                throw new PasswordResetException( PROPERTY_RESET_EXCEPTION_MESSAGE );
            }
        }
    }
