public String doMoveDownAttributeField( HttpServletRequest request ) throws AccessDeniedException
    {
        String strIdAttribute = request.getParameter( PARAMETER_ID_ATTRIBUTE );
        String strIdField = request.getParameter( PARAMETER_ID_FIELD );

        if ( StringUtils.isNotBlank( strIdField ) && StringUtils.isNumeric( strIdField ) && StringUtils.isNotBlank( strIdAttribute )
                && StringUtils.isNumeric( strIdAttribute ) )
        {
            int nIdAttribute = Integer.parseInt( strIdAttribute );
            int nIdField = Integer.parseInt( strIdField );

            IAttribute attribute = _attributeService.getAttributeWithFields( nIdAttribute, getLocale( ) );
            List<AttributeField> listAttributeFields = attribute.getListAttributeFields( );
            if ( !SecurityTokenService.getInstance( ).validate( request, attribute.getTemplateModifyAttribute( ) ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }
            if ( listAttributeFields.size( ) > 0 )
            {
                AttributeField currentField = null;
                AttributeField nextField = null;

                Iterator<AttributeField> it = listAttributeFields.iterator( );
                currentField = it.next( );
                nextField = it.next( );

                while ( it.hasNext( ) && ( currentField.getIdField( ) != nIdField ) )
                {
                    currentField = nextField;
                    nextField = it.next( );
                }

                int nextFieldPosition = nextField.getPosition( );
                int currentFieldPosition = currentField.getPosition( );
                nextField.setPosition( currentFieldPosition );
                currentField.setPosition( nextFieldPosition );

                _attributeFieldService.updateAttributeField( nextField );
                _attributeFieldService.updateAttributeField( currentField );
            }
        }

        return JSP_MODIFY_ATTRIBUTE + "?" + PARAMETER_ID_ATTRIBUTE + "=" + strIdAttribute;
    }
