public String doCreateAttribute( HttpServletRequest request ) throws AccessDeniedException
    {
        String strAttributeTypeClassName = request.getParameter( PARAMETER_ATTRIBUTE_TYPE_CLASS_NAME );
        String strActionCancel = request.getParameter( PARAMETER_CANCEL );
        String strActionApply = request.getParameter( PARAMETER_APPLY );

        if ( StringUtils.isEmpty( strActionCancel ) )
        {
            IAttribute attribute = null;

            try
            {
                attribute = (IAttribute) Class.forName( strAttributeTypeClassName ).newInstance( );
            }
            catch( ClassNotFoundException e )
            {
                // class doesn't exist
                AppLogService.error( e );
            }
            catch( InstantiationException e )
            {
                // Class is abstract or is an interface or haven't accessible
                // builder
                AppLogService.error( e );
            }
            catch( IllegalAccessException e )
            {
                // can't access to the class
                AppLogService.error( e );
            }

            if ( attribute == null )
            {
                return getManageAttributes( request );
            }

            String strError = attribute.setAttributeData( request );

            if ( StringUtils.isNotBlank( strError ) )
            {
                return strError;
            }
            if ( !SecurityTokenService.getInstance( ).validate( request, attribute.getTemplateCreateAttribute( ) ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }

            _attributeService.createAttribute( attribute );

            if ( strActionApply != null )
            {
                return JSP_MODIFY_ATTRIBUTE + QUESTION_MARK + PARAMETER_ID_ATTRIBUTE + EQUAL + attribute.getIdAttribute( );
            }
        }

        return JSP_MANAGE_ATTRIBUTES;
    }
