public String doMoveUpAttribute( HttpServletRequest request ) throws AccessDeniedException
    {
        String strIdAttribute = request.getParameter( PARAMETER_ID_ATTRIBUTE );

        if ( StringUtils.isNotBlank( strIdAttribute ) && StringUtils.isNumeric( strIdAttribute ) )
        {
            if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_MANAGE_ATTRIBUTES ) )
            {
                throw new AccessDeniedException( "Invalid security token" );
            }
            int nIdAttribute = Integer.parseInt( strIdAttribute );

            List<IAttribute> listAttributes = _attributeService.getAllAttributesWithoutFields( getLocale( ) );
            IAttribute previousAttribute = null;
            IAttribute currentAttribute = null;

            Iterator<IAttribute> it = listAttributes.iterator( );
            previousAttribute = it.next( );
            currentAttribute = it.next( );

            while ( it.hasNext( ) && ( currentAttribute.getIdAttribute( ) != nIdAttribute ) )
            {
                previousAttribute = currentAttribute;
                currentAttribute = it.next( );
            }

            int previousAttributePosition = previousAttribute.getPosition( );
            int currentAttributePosition = currentAttribute.getPosition( );
            previousAttribute.setPosition( currentAttributePosition );
            currentAttribute.setPosition( previousAttributePosition );

            _attributeService.updateAttribute( previousAttribute );
            _attributeService.updateAttribute( currentAttribute );
        }

        return JSP_MANAGE_ATTRIBUTES;
    }
