public String getCreateAttribute( HttpServletRequest request )
    {
        String strAttributeTypeClassName = request.getParameter( PARAMETER_ATTRIBUTE_TYPE_CLASS_NAME );

        IAttribute attribute = null;

        try
        {
            attribute = (IAttribute) Class.forName( strAttributeTypeClassName ).newInstance( );
        }
        catch( ClassNotFoundException e )
        {
            // class doesn't exist
            AppLogService.error( e );
        }
        catch( InstantiationException e )
        {
            // Class is abstract or is an interface or haven't accessible
            // builder
            AppLogService.error( e );
        }
        catch( IllegalAccessException e )
        {
            // can't access to the class
            AppLogService.error( e );
        }

        if ( attribute == null )
        {
            return getManageAttributes( request );
        }

        setPageTitleProperty( attribute.getPropertyCreatePageTitle( ) );

        attribute.setAttributeType( getLocale( ) );

        HtmlTemplate template;
        Map<String, Object> model = new HashMap<String, Object>( );
        model.put( MARK_ATTRIBUTE_TYPE, attribute.getAttributeType( ) );
        model.put( SecurityTokenService.MARK_TOKEN, SecurityTokenService.getInstance( ).getToken( request, attribute.getTemplateCreateAttribute( ) ) );

        template = AppTemplateService.getTemplate( attribute.getTemplateCreateAttribute( ), getLocale( ), model );

        return getAdminPage( template.getHtml( ) );
    }
