public String doCreateXslExport( HttpServletRequest request ) throws AccessDeniedException
    {
        XslExport xslExport = new XslExport( );
        String strError = getXslExportData( request, xslExport );

        if ( !RBACService.isAuthorized( XslExport.RESOURCE_TYPE, RBAC.WILDCARD_RESOURCES_ID, XslExportResourceIdService.PERMISSION_CREATE, getUser( ) ) )
        {
            throw new AccessDeniedException( MESSAGE_PERMISSION_DENIED );
        }

        if ( strError != null )
        {
            return strError;
        }

        if ( !SecurityTokenService.getInstance( ).validate( request, TEMPLATE_CREATE_XSL_EXPORT ) )
        {
            throw new AccessDeniedException( "Invalid security token" );
        }

        if ( xslExport.getFile( ) != null )
        {
            xslExport.getFile( ).setIdFile( FileHome.create( xslExport.getFile( ) ) );
        }

        XslExportHome.create( xslExport );

        return getJspManageXslExport( request );
    }
