@Override
    public void init( )
    {
        AppLogService.info( "ScannotationDB Scanning classpath..." );

        if ( getFileFilter( ) == null )
        {
            setFileFilter( CONSTANT_DEFAULT_FILENAME_FILTER );
            AppLogService.info( "Using default filename filter" );
        }
        else
        {
            AppLogService.info( "Using " + getFileFilter( ) + " as filename filter" );
        }

        Date start = new Date( );
        File libDirectory = new File( AppPathService.getWebAppPath( ) + CONSTANT_WEB_INF_LIB );

        String [ ] allJars = libDirectory.list( new FilenameFilter( )
        {
            /**
             * {@inheritDoc}
             */
            @Override
            public boolean accept( File dir, String name )
            {
                return name.matches( _strFileFilter );
            }
        } );

        for ( String strJar : allJars )
        {
            try
            {
                if ( AppLogService.isDebugEnabled( ) )
                {
                    AppLogService.debug( "Scanning " + strJar );
                }

                _db.scanArchives( new URL( "file:///" + AppPathService.getWebAppPath( ) + CONSTANT_WEB_INF_LIB + strJar ) );
            }
            catch( MalformedURLException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
            catch( IOException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }
        }

        AppLogService.info( "ScannotationDB WEB-INF/lib scanned" );

        try
        {
            _db.scanArchives( new URL( "file:///" + AppPathService.getWebAppPath( ) + CONSTANT_WEB_INF_CLASS ) );
        }
        catch( MalformedURLException e )
        {
            AppLogService.error( e.getMessage( ), e );
        }
        catch( IOException e )
        {
            AppLogService.error( e.getMessage( ), e );
        }

        AppLogService.info( "ScannotationDB Classpath scanned in " + ( new Date( ).getTime( ) - start.getTime( ) ) + "ms" );
    }
