public static void populate( Object bean, HttpServletRequest request, Locale locale )
    {
        for ( Field field : bean.getClass( ).getDeclaredFields( ) )
        {
            try
            {
                // for all boolean field, init to false
                if ( field.getType( ).getName( ).equals( Boolean.class.getName( ) ) || field.getType( ).getName( ).equals( boolean.class.getName( ) ) )
                {
                    field.setAccessible( true );
                    field.set( bean, false );
                }
            }
            catch( Exception e )
            {
                String error = "La valeur du champ " + field.getName( ) + " de la classe " + bean.getClass( ).getName( ) + " n'a pas pu être récupéré ";
                AppLogService.error( error );
                throw new RuntimeException( error, e );
            }
        }

        try
        {
            BeanUtilsBean beanUtilsBean;
            if ( locale != null && mapBeanUtilsBeans != null )
            {
                beanUtilsBean = mapBeanUtilsBeans.get( locale.getLanguage( ) );
            }
            else
            {
                beanUtilsBean = BeanUtilsBean.getInstance( );
            }

            beanUtilsBean.populate( bean, convertMap( request.getParameterMap( ) ) );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( "Unable to fetch data from request", e );
        }
        catch( InvocationTargetException e )
        {
            AppLogService.error( "Unable to fetch data from request", e );
        }
    }
