public <K> K getAndUpdateFilter( HttpServletRequest request, K filterObject )
    {
        List<DataTableFilter> listFilters = _filterPanel.getListFilter( );

        boolean bSubmitedDataTable = hasDataTableFormBeenSubmited( request );

        boolean bResetFilter = false;
        boolean bUpdateFilter = false;

        Map<String, Object> mapFilter = new HashMap<String, Object>( );

        if ( bSubmitedDataTable )
        {
            bUpdateFilter = true;
            StringUtils.equals( request.getParameter( FilterPanel.PARAM_FILTER_PANEL_PREFIX + FilterPanel.PARAM_RESET_FILTERS ), Boolean.TRUE.toString( ) );

            if ( !bResetFilter )
            {
                bUpdateFilter = StringUtils.equals( request.getParameter( FilterPanel.PARAM_FILTER_PANEL_PREFIX + FilterPanel.PARAM_UPDATE_FILTERS ),
                        Boolean.TRUE.toString( ) );
            }
        }

        for ( DataTableFilter filter : listFilters )
        {
            if ( bSubmitedDataTable )
            {
                String strFilterValue = request.getParameter( FilterPanel.PARAM_FILTER_PANEL_PREFIX + filter.getParameterName( ) );

                if ( bUpdateFilter )
                {
                    filter.setValue( strFilterValue );
                }
            }

            if ( StringUtils.isNotBlank( filter.getValue( ) ) )
            {
                mapFilter.put( filter.getParameterName( ), filter.getValue( ) );
            }
        }

        try
        {
            BeanUtilsBean.getInstance( ).populate( filterObject, mapFilter );
        }
        catch( IllegalAccessException e )
        {
            AppLogService.error( e.getMessage( ), e );

            return null;
        }
        catch( InvocationTargetException e )
        {
            AppLogService.error( e.getMessage( ), e );

            return null;
        }

        return filterObject;
    }
