public static List<File> getFiles( String strRoot, String strDirectoryRelativePath ) throws DirectoryNotFoundException
    {
        // Use a treeset to order files with a comparator
        TreeSet<File> set = new TreeSet<File>( new FileNameComparator( ) );

        // Directory path
        String strDirectory = strRoot + strDirectoryRelativePath;

        // Directory
        File fDirectory = new File( strDirectory );

        if ( !fDirectory.exists( ) )
        {
            throw new DirectoryNotFoundException( );
        }

        File [ ] files = fDirectory.listFiles( );

        for ( int i = 0; i < files.length; i++ )
        {
            File file = files [i];

            if ( file.isFile( ) )
            {
                set.add( file );
            }
        }

        // Convert into a list to preserve the order
        return new ArrayList<File>( set );
    }
