private static String cleanString( String strValue, boolean bKeepSlashes )
    {
        // First, replace the accents :
        String strNoAccents = StringUtil.replaceAccent( strValue );

        // Convert to an array of characters
        char [ ] characters = new char [ strNoAccents.length( )];
        strNoAccents.getChars( 0, strNoAccents.length( ), characters, 0 );

        // Iterate to process one character at a time
        for ( int i = 0; i < strNoAccents.length( ); i++ )
        {
            char current = characters [i];

            // Valid characters are : '.', alphanumeric (a-zA-Z0-9),
            // and '/' if bKeepSlashes is true.
            boolean bValid = ( ( current == '.' ) || ( ( current >= '0' ) && ( current <= '9' ) ) || ( ( current >= 'a' ) && ( current <= 'z' ) )
                    || ( ( current >= 'A' ) && ( current <= 'Z' ) ) || ( bKeepSlashes && ( current == '/' ) ) );

            // Other characters are replaced by underscore.
            if ( !bValid )
            {
                characters [i] = '_';
            }
        }

        // Return result as a string
        return String.valueOf( characters );
    }
