public static boolean isInternalRedirectUrlSafe( String strUrl, HttpServletRequest request, String strAntPathMatcherPatterns )
    {

        if ( StringUtils.isBlank( strUrl ) ) return true ; // this is not a valid redirect Url, but it is not unsafe

        // filter schemes
        if ( !strUrl.startsWith( "//" )
                && !strUrl.startsWith("http:" )
                && !strUrl.startsWith("https:" )
                && !strUrl.contains( "://" )
                && !strUrl.startsWith("javascript:" ) )
            return true ; // should be a relative path

        // compare with current baseUrl
        if ( strUrl.startsWith( AppPathService.getBaseUrl( request ) ) )
                return true ;

        // compare with allowed url patterns
        if ( !StringUtils.isBlank( strAntPathMatcherPatterns ) )
        {
            AntPathMatcher pathMatcher = new AntPathMatcher();

            String[] strAntPathMatcherPatternsTab =  strAntPathMatcherPatterns.split( CONSTANT_COMMA ) ;
            for ( String pattern : strAntPathMatcherPatternsTab )
            {
                if ( pattern != null && pathMatcher.match( pattern , strUrl ) )
                    return true ;
            }
        }


        // the Url does not match the allowed patterns
        Logger logger = Logger.getLogger( LOGGER_NAME );
        logger.warn( "SECURITY WARNING : OPEN_REDIRECT DETECTED : " + dumpRequest( request ) );

        return false;

    }
