public EntityManager getEM( )
    {
        EntityManagerFactory emf = getEntityManagerFactory( );

        if ( TransactionSynchronizationManager.isSynchronizationActive( ) )
        {
            // first, get Spring entitymanager (if available)
            try
            {
                EntityManager em = EntityManagerFactoryUtils.getTransactionalEntityManager( emf );

                if ( em == null )
                {
                    LOG.error( "getEM(  ) : no EntityManager found. Will use native entity manager factory [Transaction will not be supported]" );
                }
                else
                {
                    LOG.debug( "EntityManager found for the current transaction : " + em.toString( ) + " - using Factory : " + emf.toString( ) );

                    return em;
                }
            }
            catch( DataAccessResourceFailureException ex )
            {
                LOG.error( ex );
            }
        }

        LOG.error( "getEM(  ) : no EntityManager found. Will use native entity manager factory [Transaction will not be supported]" );

        if ( _defaultEM == null )
        {
            _defaultEM = emf.createEntityManager( );
        }
        return _defaultEM;
    }
