public void commit( TransactionStatus status ) throws TransactionException
    {
        for ( PlatformTransactionManager transactionManager : _transactionManagers )
        {
            TransactionStatus transactionStatus = null;

            try
            {
                transactionStatus = ( (MultiTransactionStatus) status ).getTransactionStatus( transactionManager );
                transactionManager.commit( transactionStatus );
            }
            catch( Exception e )
            {
                _log.error( e.getMessage( ), e );

                // transactionManager.rollback( transactionStatus );
            }
        }

        if ( _log.isDebugEnabled( ) )
        {
            _log.debug( "Ending transaction : " + status.toString( ) );
        }

        if ( ( (MultiTransactionStatus) status ).isNewSynchonization( ) )
        {
            TransactionSynchronizationManager.clear( );
        }
    }
