public TransactionStatus getTransaction( TransactionDefinition definition ) throws TransactionException
    {
        if ( _transactionManagers.isEmpty( ) )
        {
            return null;
        }

        MultiTransactionStatus mts = new MultiTransactionStatus( _transactionManagers.get( 0 ) );

        if ( !TransactionSynchronizationManager.isSynchronizationActive( ) )
        {
            TransactionSynchronizationManager.initSynchronization( );
            mts.setNewSynchonization( );

            if ( _log.isDebugEnabled( ) )
            {
                _log.debug( "Begin transaction : " + mts.toString( ) );
            }
        }

        for ( PlatformTransactionManager transactionManager : _transactionManagers )
        {
            mts.getTransactionStatuses( ).put( transactionManager, transactionManager.getTransaction( definition ) );
        }

        return mts;
    }
