public List<UrlAttachment> getAllUrlsAttachement( ElementUrl elementType )
    {
        List<UrlAttachment> listUrlAttachement = new ArrayList<UrlAttachment>( );
        UrlAttachment urlAttachement;
        NodeList nodes = _content.getElementsByTagName( elementType.getTagName( ) );

        for ( int i = 0; i < nodes.getLength( ); i++ )
        {
            Node node = nodes.item( i );
            NamedNodeMap attributes = node.getAttributes( );

            // Test if the element matches the required attribute
            if ( elementType.getTestedAttributeName( ) != null )
            {
                String strRel = attributes.getNamedItem( elementType.getTestedAttributeName( ) ).getNodeValue( );

                if ( !elementType.getTestedAttributeValue( ).equals( strRel ) )
                {
                    continue;
                }
            }

            // Retrieve the url, then test if it matches the base url
            String strAttributeName = elementType.getAttributeName( );

            if ( ( strAttributeName != null ) && ( attributes != null ) )
            {
                Node attributeNode = attributes.getNamedItem( strAttributeName );

                if ( attributeNode != null )
                {
                    String strSrc = attributeNode.getNodeValue( );

                    if ( ( strSrc != null ) && strSrc.startsWith( _strBaseUrl ) )
                    {
                        try
                        {
                            URL url = new URL( strSrc );
                            urlAttachement = new UrlAttachment( getUrlName( url ), url );
                            listUrlAttachement.add( urlAttachement );
                        }
                        catch( MalformedURLException e )
                        {
                            // ignored document
                            AppLogService.info( strSrc + " not found, location ignored." );
                        }
                    }
                }
            }
        }

        return listUrlAttachement;
    }
