public Map<String, URL> getAllUrls( ElementUrl elementType )
    {
        Map<String, URL> mapUrl = new HashMap<String, URL>( );

        NodeList nodes = _content.getElementsByTagName( elementType.getTagName( ) );

        for ( int i = 0; i < nodes.getLength( ); i++ )
        {
            Node node = nodes.item( i );
            NamedNodeMap attributes = node.getAttributes( );

            // Test if the element matches the required attribute
            if ( elementType.getTestedAttributeName( ) != null )
            {
                String strRel = attributes.getNamedItem( elementType.getTestedAttributeName( ) ).getNodeValue( );

                if ( !elementType.getTestedAttributeValue( ).equals( strRel ) )
                {
                    continue;
                }
            }

            // Retrieve the url, then test if it matches the base url
            String strSrc = attributes.getNamedItem( elementType.getAttributeName( ) ).getNodeValue( );

            if ( strSrc.startsWith( _strBaseUrl ) )
            {
                try
                {
                    URL url = new URL( strSrc );
                    mapUrl.put( getUrlName( url ), url );
                }
                catch( MalformedURLException e )
                {
                    // ignored document
                    AppLogService.info( strSrc + " not found, location ignored." );
                }
            }
        }

        return mapUrl;
    }
