private void createPools( Properties props ) throws LuteceInitException
    {
        Enumeration propNames = props.propertyNames( );
        String strPoolName = "";

        Hashtable<String, Hashtable<String, String>> htPools = new Hashtable<String, Hashtable<String, String>>( );

        while ( propNames.hasMoreElements( ) )
        {
            String name = (String) propNames.nextElement( );

            try
            {
                strPoolName = name.substring( 0, name.lastIndexOf( '.' ) );

                // tests if the pool has yet somme of its porperties stored in the hatsable
                Hashtable<String, String> htParamsPool;

                // if the pool has not yet property
                if ( htPools.get( strPoolName ) == null )
                {
                    htParamsPool = new Hashtable<String, String>( );
                }
                else
                {
                    htParamsPool = htPools.get( strPoolName );
                }

                htParamsPool.put( name, props.getProperty( name ) );
                htPools.put( strPoolName, htParamsPool );

                _logger.debug( "property " + name );
                _logger.debug( "pool name " + strPoolName );
            }
            catch( Exception e )
            {
                throw new LuteceInitException( "Invalid initialization of the pools. Problem encoutered with the property :  " + name, e );
            }
        }

        Enumeration enumKeys = htPools.keys( );

        while ( enumKeys.hasMoreElements( ) )
        {
            String key = "";

            try
            {
                key = (String) enumKeys.nextElement( );

                Hashtable<String, String> htParamsPool = htPools.get( key );
                ConnectionService cs = null;

                try
                {
                    String strConnectionService = htParamsPool.get( key + ".poolservice" );

                    cs = (ConnectionService) Class.forName( strConnectionService ).newInstance( );
                }
                catch( NullPointerException nullEx )
                {
                    cs = new LuteceConnectionService( );
                }
                catch( Exception e )
                {
                    throw new LuteceInitException( "Exception when getting the property poolservice", e );
                }

                if ( cs != null )
                {
                    cs.setPoolName( key );
                    cs.setLogger( _logger );
                    cs.init( htParamsPool );
                    _pools.put( key, cs );
                }
            }
            catch( Exception e )
            {
                throw new LuteceInitException( "Exception when getting the pool '" + key + "'. Please check your '/WEB-INF/conf/db.properties' file.", e );
            }
        }
    }
