public void init( Hashtable<String, String> htParamsConnectionPool )
    {
        try
        {
            _dataSource = new ComboPooledDataSource( _strPoolName );

            String strDriver = htParamsConnectionPool.get( getPoolName( ) + ".driver" );
            _dataSource.setDriverClass( strDriver );

            String strUrl = htParamsConnectionPool.get( getPoolName( ) + ".url" );
            _dataSource.setJdbcUrl( strUrl );

            String strUser = htParamsConnectionPool.get( getPoolName( ) + ".user" );
            _dataSource.setUser( strUser );

            String strPassword = htParamsConnectionPool.get( getPoolName( ) + ".password" );
            _dataSource.setPassword( strPassword );

            String strMaxConns = htParamsConnectionPool.get( getPoolName( ) + ".maxconns" );
            int nMaxConns = ( strMaxConns == null ) ? 0 : Integer.parseInt( strMaxConns );
            _dataSource.setMaxPoolSize( nMaxConns );

            String strMinConns = htParamsConnectionPool.get( getPoolName( ) + ".initconns" );
            int nInitConns = ( strMinConns == null ) ? 0 : Integer.parseInt( strMinConns );
            _dataSource.setInitialPoolSize( nInitConns );
            _dataSource.setMinPoolSize( nInitConns );
        }
        catch( Exception e )
        {
            _logger.error( "Error while initializing the pool " + getPoolName( ), e );
        }

        _logger.info( "Initialization of the C3P0 pool named '" + getPoolName( ) + "', Min/Max pool size : " + _dataSource.getMinPoolSize( ) + "/"
                + _dataSource.getMaxPoolSize( ) );
    }
