private boolean isConnectionOK( Connection conn )
    {
        Statement testStmt = null;

        try
        {
            if ( !conn.isClosed( ) )
            {
                // Try to createStatement to see if it's really alive
                testStmt = conn.createStatement( );
                testStmt.executeQuery( _strCheckValidConnectionSql );
                testStmt.close( );
            }
            else
            {
                return false;
            }
        }
        catch( SQLException e )
        {
            if ( testStmt != null )
            {
                try
                {
                    testStmt.close( );
                }
                catch( SQLException se )
                {
                    throw new AppException( "ConnectionService : SQL Error executing command : " + se.toString( ) );
                }
            }

            _logger.error( "Pooled Connection was not okay", e );

            return false;
        }

        return true;
    }
