public void init( Hashtable<String, String> htParamsConnectionPool )
    {
        String url = htParamsConnectionPool.get( getPoolName( ) + ".url" );

        if ( url == null )
        {
            _logger.error( "No URL specified for the pool " + getPoolName( ) );
        }

        String user = htParamsConnectionPool.get( getPoolName( ) + ".user" );

        if ( user == null )
        {
            _logger.error( "No user specified for the pool " + getPoolName( ) );
        }

        String password = htParamsConnectionPool.get( getPoolName( ) + ".password" );

        if ( password == null )
        {
            _logger.error( "No password specified for the pool " + getPoolName( ) );
        }

        // load of the driver
        String strDiverClassName = htParamsConnectionPool.get( getPoolName( ) + ".driver" );

        try
        {
            Driver driver = (Driver) Class.forName( strDiverClassName ).newInstance( );
            DriverManager.registerDriver( driver );
            _logger.info( "Registered JDBC driver " + strDiverClassName );
        }
        catch( NullPointerException e )
        {
            _logger.error( "Can't register JDBC driver: " + strDiverClassName + " because the property driver is not defined", e );
        }
        catch( Exception e )
        {
            _logger.error( "Can't register JDBC driver: " + strDiverClassName, e );
        }

        int maxConns = ( htParamsConnectionPool.get( getPoolName( ) + ".maxconns" ) == null ) ? 0 : Integer.parseInt( htParamsConnectionPool.get( getPoolName( )
                + ".maxconns" ) );

        int initConns = ( htParamsConnectionPool.get( getPoolName( ) + ".initconns" ) == null ) ? 0 : Integer.parseInt( htParamsConnectionPool
                .get( getPoolName( ) + ".initconns" ) );

        int timeOut = ( htParamsConnectionPool.get( getPoolName( ) + ".logintimeout" ) == null ) ? 5 : Integer.parseInt( htParamsConnectionPool
                .get( getPoolName( ) + ".logintimeout" ) );

        String checkValidConnectionSql = ( htParamsConnectionPool.get( getPoolName( ) + ".checkvalidconnectionsql" ) == null ) ? "" : htParamsConnectionPool
                .get( getPoolName( ) + ".checkvalidconnectionsql" );

        _connPool = new ConnectionPool( getPoolName( ), url, user, password, maxConns, initConns, timeOut, _logger, checkValidConnectionSql );
    }
