private boolean isComparable( Class<?> clazz )
    {
        for ( Class<?> interfac : clazz.getInterfaces( ) )
        {
            if ( interfac.equals( Comparable.class ) )
            {
                return true;
            }
        }

        // The class might be extending a super class that implements {@link Comparable}
        Class<?> superClass = clazz.getSuperclass( );

        if ( superClass != null )
        {
            return isComparable( superClass );
        }

        return false;
    }
