public static void beginTransaction( Plugin plugin, int nTransactionIsolation )
    {
        Map<String, MultiPluginTransaction> mapTransactions = _tlTransactions.get( );
        MultiPluginTransaction transaction = null;

        if ( mapTransactions == null )
        {
            mapTransactions = new HashMap<String, MultiPluginTransaction>( );
            _tlTransactions.set( mapTransactions );
        }
        else
        {
            transaction = mapTransactions.get( getPluginPool( plugin ) );
        }

        if ( ( transaction == null ) || ( transaction.getNbTransactionsOpened( ) <= 0 ) )
        {
            transaction = new MultiPluginTransaction( plugin );

            try
            {
                transaction.getConnection( ).setTransactionIsolation( nTransactionIsolation );
            }
            catch( SQLException e )
            {
                AppLogService.error( e.getMessage( ), e );
            }

            mapTransactions.put( getPluginPool( plugin ), transaction );
        }
        else
        {
            // A transaction has already been opened for this pool,
            // so we save that information to prevent the next call to the commit method to close the transaction.
            transaction.incrementNbTransactionsOpened( );
        }
    }
