public PreparedStatement prepareStatement( String strSQL, Integer autoGeneratedKeys, boolean bLogQueries  ) throws SQLException
    {
        // Close the previous statement if exists
        if ( _statement != null )
        {
            _statement.close( );
        }

        // Get a new statement
        _strSQL = strSQL;

        if ( _connection == null )
        {
            throw new SQLException( "Plugin : '" + _strPluginName + "' - Connection has been closed. The new prepared statement can not be created : " + ( bLogQueries?_strSQL:"(query log disabled)")  );
        }

        if ( autoGeneratedKeys != null )
        {
            _statement = _connection.prepareStatement( _strSQL, autoGeneratedKeys );
        }
        else
        {
            _statement = _connection.prepareStatement( _strSQL );
        }

        return _statement;
    }
