public void testGetPagesByRoleKey( )
    {
        SecureRandom rnd = new SecureRandom( );
        Role role = null;
        Page page = null;
        try
        {
            // create a role
            String randomRoleName = "role" + rnd.nextLong( );
            role = new Role( );
            role.setRole( randomRoleName );
            role.setRoleDescription( randomRoleName );
            role.setWorkgroup( AdminWorkgroupService.ALL_GROUPS );
            RoleHome.create( role );
            // create a page
            String randomPageName = "page" + rnd.nextLong( );
            page = new Page( );
            page.setParentPageId( PortalService.getRootPageId( ) );
            page.setPageTemplateId( PageTemplateHome.getPageTemplatesList( ).get( 0 ).getId( ) );
            page.setName( randomPageName );
            page.setRole( randomRoleName );
            page.setDateUpdate( new Timestamp( new java.util.Date( ).getTime( ) ) );
            page.setDisplayDateUpdate( false );
            page.setIsManualDateUpdate( false );
            IPageService pageService = (IPageService) SpringContextService.getBean( "pageService" );
            pageService.createPage( page );
            // get page by role
            PageDAO dao = new PageDAO( );
            Collection<Page> pages = dao.getPagesByRoleKey( randomRoleName );
            assertNotNull( pages );
            for ( Page p : pages )
            {
                if ( p.getName( ).equals( randomPageName ) )
                {
                    return;
                }
            }
            Assert.fail( "could not find the page " + randomPageName );
        }
        finally
        {
            // cleanup
            if ( role != null )
            {
                try
                {
                    RoleHome.remove( role.getRole( ) );
                }
                finally
                {
                }
            }
            if ( page != null )
            {
                try
                {
                    PageHome.remove( page.getId( ) );
                }
                finally
                {
                }
            }
        }

    }
