public void testBusiness( )
    {
        // Initialize an object 1
        RBAC rbac1 = new RBAC( );
        rbac1.setRoleKey( ROLEKEY1 );
        rbac1.setResourceTypeKey( RESOURCETYPE1 );
        rbac1.setResourceId( RESOURCEID1 );
        rbac1.setPermissionKey( PERMISSION1 );

        // Initialize an object 2
        RBAC rbac2 = new RBAC( );
        rbac2.setRoleKey( ROLEKEY2 );
        rbac2.setResourceTypeKey( RESOURCETYPE2 );
        rbac2.setResourceId( RESOURCEID2 );
        rbac2.setPermissionKey( PERMISSION2 );

        // Create test
        RBACHome.create( rbac1 );

        RBAC rbacStored = RBACHome.findByPrimaryKey( rbac1.getRBACId( ) );
        assertEquals( rbacStored.getRoleKey( ), rbac1.getRoleKey( ) );
        assertEquals( rbacStored.getResourceTypeKey( ), rbac1.getResourceTypeKey( ) );
        assertEquals( rbacStored.getResourceId( ), rbac1.getResourceId( ) );
        assertEquals( rbacStored.getPermissionKey( ), rbac1.getPermissionKey( ) );

        // Update test
        rbac1.setRoleKey( ROLEKEY2 );
        rbac1.setResourceTypeKey( RESOURCETYPE2 );
        rbac1.setResourceId( RESOURCEID2 );
        rbac1.setPermissionKey( PERMISSION2 );

        RBACHome.update( rbac1 );
        rbacStored = RBACHome.findByPrimaryKey( rbac1.getRBACId( ) );
        assertEquals( rbacStored.getRoleKey( ), rbac1.getRoleKey( ) );
        assertEquals( rbacStored.getResourceTypeKey( ), rbac1.getResourceTypeKey( ) );
        assertEquals( rbacStored.getResourceId( ), rbac1.getResourceId( ) );
        assertEquals( rbacStored.getPermissionKey( ), rbac1.getPermissionKey( ) );

        // Delete test
        RBACHome.remove( rbac1.getRBACId( ) );
        rbacStored = RBACHome.findByPrimaryKey( rbac1.getRBACId( ) );
        assertNull( rbacStored );

        // add elements element for the lists (both rbac1 and rbac2 values are ...2 values at this point)
        RBACHome.create( rbac1 );
        RBACHome.create( rbac2 );

        // List Test
        Collection list = RBACHome.findAll( );
        assertTrue( list.size( ) > 0 );

        // list by role Test
        Collection<RBAC> listByRole = RBACHome.findResourcesByCode( ROLEKEY2 );
        assertTrue( listByRole.size( ) > 0 );

        for ( RBAC rbacListItem : listByRole )
        {
            assertEquals( ROLEKEY2, rbacListItem.getRoleKey( ) );
        }

        // find roles from resource and permission Test
        Collection<String> listOfRoles = RBACHome.findRoleKeys( RESOURCETYPE2, RESOURCEID2, PERMISSION2 );
        assertTrue( list.size( ) > 0 );

        boolean bRoleFound = false;

        for ( String strRoleKey : listOfRoles )
        {
            if ( strRoleKey.equals( ROLEKEY2 ) )
            {
                bRoleFound = true;
            }
        }

        assertTrue( bRoleFound );

        // update role keys for all Test
        RBACHome.updateRoleKey( ROLEKEY2, ROLEKEY1 );

        Collection listByRoleUpdated = RBACHome.findResourcesByCode( ROLEKEY1 );
        assertTrue( listByRoleUpdated.size( ) > 0 );

        // both rbac1 and rbac2 have ROLEKEY1 values at this point
        RBACHome.removeForRoleKey( ROLEKEY1 );
        rbacStored = RBACHome.findByPrimaryKey( rbac1.getRBACId( ) );
        assertNull( rbacStored );
        rbacStored = RBACHome.findByPrimaryKey( rbac2.getRBACId( ) );
        assertNull( rbacStored );
    }
