public void testBusinessFeatureGroup( )
    {
        // Initialize an object
        FeatureGroup featureGroup = new FeatureGroup( );
        featureGroup.setId( ID );
        featureGroup.setLabelKey( LABELKEY1 );
        featureGroup.setDescriptionKey( DESCRIPTIONKEY1 );
        featureGroup.setOrder( ORDER1 );

        // Create test
        FeatureGroupHome.create( featureGroup );

        FeatureGroup featureGroupStored = FeatureGroupHome.findByPrimaryKey( featureGroup.getId( ) );
        assertEquals( featureGroupStored.getLabelKey( ), featureGroup.getLabelKey( ) );
        assertEquals( featureGroupStored.getDescriptionKey( ), featureGroup.getDescriptionKey( ) );
        assertEquals( featureGroupStored.getOrder( ), featureGroup.getOrder( ) );

        // Update test
        featureGroup.setLabelKey( LABELKEY2 );
        featureGroup.setDescriptionKey( DESCRIPTIONKEY2 );
        featureGroup.setOrder( ORDER2 );
        FeatureGroupHome.update( featureGroup );
        featureGroupStored = FeatureGroupHome.findByPrimaryKey( featureGroup.getId( ) );
        assertEquals( featureGroupStored.getLabelKey( ), featureGroup.getLabelKey( ) );
        assertEquals( featureGroupStored.getDescriptionKey( ), featureGroup.getDescriptionKey( ) );
        assertEquals( featureGroupStored.getOrder( ), featureGroup.getOrder( ) );

        // List test
        List listGroups = FeatureGroupHome.getFeatureGroupsList( );
        assertTrue( listGroups.size( ) > 0 );

        assertTrue( FeatureGroupHome.getFeatureGroupsCount( ) > 0 );

        // Delete test
        FeatureGroupHome.remove( featureGroup.getId( ) );
        featureGroupStored = FeatureGroupHome.findByPrimaryKey( featureGroup.getId( ) );
        assertNull( featureGroupStored );
    }
