public void testBusinessRight( )
    {
        // Initialize an object
        Right right = new Right( );
        right.setId( RIGHT_ID );
        right.setNameKey( NAMEKEY1 );
        right.setDescriptionKey( DESCRIPTIONKEY1 );
        right.setLevel( LEVEL1 );
        right.setUrl( URL1 );
        right.setPluginName( PLUGINNAME1 );
        right.setFeatureGroup( FEATUREGROUP1 );
        right.setIconUrl( ICONURL1 );
        right.setExternalFeature( IS_EXTERNAL_FEATURE1 );

        // Create test
        RightHome.create( right );

        Right rightStored = RightHome.findByPrimaryKey( right.getId( ) );
        assertEquals( rightStored.getNameKey( ), right.getNameKey( ) );
        assertEquals( rightStored.getDescriptionKey( ), right.getDescriptionKey( ) );
        assertEquals( rightStored.getLevel( ), right.getLevel( ) );
        assertEquals( rightStored.getUrl( ), right.getUrl( ) );
        assertEquals( rightStored.getPluginName( ), right.getPluginName( ) );
        assertEquals( rightStored.getFeatureGroup( ), right.getFeatureGroup( ) );
        assertEquals( rightStored.getIconUrl( ), right.getIconUrl( ) );
        assertEquals( rightStored.isExternalFeature( ), right.isExternalFeature( ) );

        // Update test
        right.setNameKey( NAMEKEY2 );
        right.setDescriptionKey( DESCRIPTIONKEY2 );
        right.setLevel( LEVEL2 );
        right.setUrl( URL2 );
        right.setPluginName( PLUGINNAME2 );
        right.setFeatureGroup( FEATUREGROUP2 );
        right.setIconUrl( ICONURL2 );
        right.setExternalFeature( IS_EXTERNAL_FEATURE2 );
        RightHome.update( right );
        rightStored = RightHome.findByPrimaryKey( right.getId( ) );
        assertEquals( rightStored.getNameKey( ), right.getNameKey( ) );
        assertEquals( rightStored.getDescriptionKey( ), right.getDescriptionKey( ) );
        assertEquals( rightStored.getLevel( ), right.getLevel( ) );
        assertEquals( rightStored.getUrl( ), right.getUrl( ) );
        assertEquals( rightStored.getPluginName( ), right.getPluginName( ) );
        assertEquals( rightStored.getFeatureGroup( ), right.getFeatureGroup( ) );
        assertEquals( rightStored.getIconUrl( ), right.getIconUrl( ) );
        assertEquals( rightStored.isExternalFeature( ), right.isExternalFeature( ) );

        // List Test
        Collection listRights = RightHome.getRightsList( );
        assertTrue( listRights.size( ) > 0 );

        // List external features tests
        listRights = RightHome.getExternalRightList( );
        assertTrue( listRights.size( ) > 0 );

        // Delete test
        RightHome.remove( right.getId( ) );
        rightStored = RightHome.findByPrimaryKey( right.getId( ) );
        assertNull( rightStored );
    }
