public void testInsertLuteceDefaultAdminUser( )
    {
        AdminUserDAO adminUserDAO = getAdminUserDAO( );
        String randomUsername = "user" + new SecureRandom( ).nextLong( );
        IPasswordFactory passwordFactory = SpringContextService.getBean( IPasswordFactory.BEAN_NAME );

        LuteceDefaultAdminUser user = new LuteceDefaultAdminUser( randomUsername, new LuteceDefaultAdminAuthentication( ) );
        user.setPassword( passwordFactory.getPasswordFromCleartext( randomUsername ) );
        user.setFirstName( randomUsername );
        user.setLastName( randomUsername );
        user.setEmail( randomUsername + "@lutece.fr" );
        adminUserDAO.insert( user );

        try
        {
            LuteceDefaultAdminUser storedUser = adminUserDAO.loadDefaultAdminUser( user.getUserId( ) );
            assertEquals( randomUsername, storedUser.getAccessCode( ) );
            assertEquals( randomUsername, storedUser.getFirstName( ) );
            assertEquals( randomUsername, storedUser.getLastName( ) );
            assertEquals( randomUsername + "@lutece.fr", storedUser.getEmail( ) );
            assertTrue( storedUser.getPassword( ).check( randomUsername ) );
        }
        finally
        {
            adminUserDAO.delete( user.getUserId( ) );
        }
    }
