public void testPasswordHistory( )
    {
        AdminUserDAO adminUserDAO = getAdminUserDAO( );
        String randomUsername = "user" + new SecureRandom( ).nextLong( );
        IPasswordFactory passwordFactory = SpringContextService.getBean( IPasswordFactory.BEAN_NAME );

        LuteceDefaultAdminUser user = new LuteceDefaultAdminUser( randomUsername, new LuteceDefaultAdminAuthentication( ) );
        user.setPassword( passwordFactory.getPasswordFromCleartext( randomUsername ) );
        user.setFirstName( randomUsername );
        user.setLastName( randomUsername );
        user.setEmail( randomUsername + "@lutece.fr" );
        adminUserDAO.insert( user );

        try
        {
            adminUserDAO.insertNewPasswordInHistory( passwordFactory.getPasswordFromCleartext( "1" ), user.getUserId( ) );
            Thread.sleep( 1000 ); // Need this because the PRIMARY KEY uses the timestamp
            adminUserDAO.insertNewPasswordInHistory( passwordFactory.getPasswordFromCleartext( "2" ), user.getUserId( ) );
            Thread.sleep( 1000 ); // Need this because the PRIMARY KEY uses the timestamp
            adminUserDAO.insertNewPasswordInHistory( passwordFactory.getPasswordFromCleartext( "3" ), user.getUserId( ) );

            List<IPassword> passwords = adminUserDAO.selectUserPasswordHistory( user.getUserId( ) );
            assertNotNull( passwords );
            assertEquals( 3, passwords.size( ) );
            assertTrue( passwords.get( 0 ).check( "3" ) );
            assertTrue( passwords.get( 1 ).check( "2" ) );
            assertTrue( passwords.get( 2 ).check( "1" ) );
        }
        catch( InterruptedException e )
        {
            throw new RuntimeException( e ); // Should not happen
        }
        finally
        {
            try
            {
                adminUserDAO.removeAllPasswordHistoryForUser( user.getUserId( ) );
            }
            finally
            {
            }
            adminUserDAO.delete( user.getUserId( ) );
        }
    }
