@Override
    public void setUp( ) throws Exception
    {
        super.setUp( );

        AdminUserDAO adminUserDAO = getAdminUserDAO( );
        String randomUsername = "user" + new SecureRandom( ).nextLong( );

        user = new LuteceDefaultAdminUser( randomUsername, new LuteceDefaultAdminAuthentication( ) );
        user.setPassword( new IPassword( )
        {

            @Override
            public boolean isLegacy( )
            {
                return false;
            }

            @Override
            public String getStorableRepresentation( )
            {
                return "PLAINTEXT:" + LEGACY_PASSWORD;
            }

            @Override
            public boolean check( String strCleartextPassword )
            {
                return LEGACY_PASSWORD.equals( strCleartextPassword );
            }
        } );
        user.setFirstName( randomUsername );
        user.setLastName( randomUsername );
        user.setEmail( randomUsername + "@lutece.fr" );
        adminUserDAO.insert( user );
    }
