public void testRegisterDaemonTwiceIgnored( ) throws LuteceInitException
    {
        assertTrue( AppDaemonService.getDaemonEntries( ).contains( _entry ) );
        DaemonEntry duplicate = new DaemonEntry( );
        duplicate.setId( JUNIT_DAEMON );
        duplicate.setNameKey( JUNIT_DAEMON );
        duplicate.setDescriptionKey( JUNIT_DAEMON + "duplicate" );
        duplicate.setClassName( TestDaemon.class.getName( ) );
        duplicate.setPluginName( "core" );

        AppDaemonService.registerDaemon( duplicate );

        assertFalse( AppDaemonService.getDaemonEntries( ).contains( duplicate ) );
        assertTrue( AppDaemonService.getDaemonEntries( ).contains( _entry ) );
        DaemonEntry registeredEntry = AppDaemonService.getDaemonEntries( ).stream( )
                .filter( entry -> JUNIT_DAEMON.equals( entry.getId( ) ) ).findFirst( )
                .orElseThrow( AssertionError::new );
        assertEquals( JUNIT_DAEMON, registeredEntry.getDescriptionKey( ) );
    }
