private void testEnqueueWhileRunning( boolean shouldThrow ) throws ClassNotFoundException, InstantiationException, IllegalAccessException,
            InterruptedException, BrokenBarrierException, TimeoutException
    {
        BlockingQueue<DaemonEntry> queue = new LinkedBlockingQueue<>( );
        ExecutorService executor = Executors.newCachedThreadPool( );
        DaemonScheduler scheduler = new DaemonScheduler( queue, executor );
        try
        {
            DaemonEntry executing = getDaemonEntry( "JUNIT-executing" );
            TestDaemon executingDaemon = (TestDaemon) executing.getDaemon( );
            executingDaemon.setRunThrows( shouldThrow );
            assertTrue( scheduler.enqueue( executing, 0L, TimeUnit.MILLISECONDS ) );
            executingDaemon.go( );
            assertTrue( scheduler.enqueue( executing, 0L, TimeUnit.MILLISECONDS ) );
            try
            {
                executingDaemon.go( 200, TimeUnit.MILLISECONDS );
                fail( "Daemon started execution while already running" );
            }
            catch( TimeoutException e )
            {
                executingDaemon.resetGo( );
            }
            executingDaemon.waitForCompletion( );
            executingDaemon.go( );
            executingDaemon.waitForCompletion( );
        }
        finally
        {
            scheduler.shutdown( );
        }
    }
