public void testAddItemToQueue( ) throws InterruptedException, BrokenBarrierException, TimeoutException
    {
        CyclicBarrier barrier = new CyclicBarrier( 2 );
        _runnableTimedOut = false;
        ThreadLauncherDaemon.addItemToQueue( ( ) -> {
            try
            {
                barrier.await( 10L, TimeUnit.SECONDS );
            }
            catch( InterruptedException | BrokenBarrierException | TimeoutException e )
            {
                _runnableTimedOut = true;
            }
        }, "key", PluginService.getCore( ) );
        barrier.await( 250L, TimeUnit.MILLISECONDS );
        assertFalse( _runnableTimedOut );
    }
