public void testResetCache( ) throws IOException
    {
        // get a message
        String message = I18nService.getLocalizedString( "portal.admin.admin_home.password", Locale.FRENCH );

        // change the message
        File propertiesFile = new ClassPathResource( "fr/paris/lutece/portal/resources/admin_messages_fr.properties" ).getFile( );
        Properties resources = new Properties( );
        InputStream is = new FileInputStream( propertiesFile );
        resources.load( is );
        is.close( );

        String newValue = "junit" + new SecureRandom( ).nextLong( );
        resources.setProperty( "admin_home.password", newValue );

        OutputStream os = new FileOutputStream( propertiesFile );
        resources.store( os, null );
        os.close( );
        // read the value again
        assertEquals( message, I18nService.getLocalizedString( "portal.admin.admin_home.password", Locale.FRENCH ) );
        // clear the cache and read again
        I18nService.resetCache( );
        assertEquals( newValue, I18nService.getLocalizedString( "portal.admin.admin_home.password", Locale.FRENCH ) );
    }
