public void testEnabledState( ) throws LuteceInitException
    {
        PageIncludeEntry entry = new PageIncludeEntry( );
        entry.setClassName( TestPageInclude.class.getName( ) );
        entry.setId( "testEnablePageInclude" );
        entry.setPluginName( "core" ); // core is an always enabled plugin

        PageIncludeService.registerPageInclude( entry );

        List<PageInclude> includes = PageIncludeService.getIncludes( );
        assertTrue( isTestPageIncludeActive( includes ) );

        entry.setEnabled( false );
        PageIncludeService.registerPageInclude( entry );
        includes = PageIncludeService.getIncludes( );
        assertFalse( isTestPageIncludeActive( includes ) );

        entry.setPluginName( "bogus_inexistant_plugin" );
        PageIncludeService.registerPageInclude( entry );
        includes = PageIncludeService.getIncludes( );
        assertFalse( isTestPageIncludeActive( includes ) );

        entry.setEnabled( true );
        PageIncludeService.registerPageInclude( entry );
        includes = PageIncludeService.getIncludes( );
        assertFalse( isTestPageIncludeActive( includes ) );
    }
