@Test
    public void testBaseUrl( ) throws SiteMessageException
    {
        IPageService pageService = (IPageService) SpringContextService.getBean( "pageService" );
        HttpServletResponse response = new MockHttpServletResponse( );

        MockHttpServletRequest request = new MockHttpServletRequest( );

        LocalVariables.setLocal( null, request, response );
        request.addParameter( Parameters.PAGE_ID, "1" );

        String pageContent = pageService.getPage( request, 0 );
        assertTrue( pageContent.contains( "<base href=\"http://localhost/\">" ) );

        // change server name and thus base_url
        request = new MockHttpServletRequest( );
        request.setServerName( "junit" );

        LocalVariables.setLocal( null, request, response );
        request.addParameter( Parameters.PAGE_ID, "1" );
        pageContent = pageService.getPage( request, 0 );
        assertTrue( pageContent.contains( "<base href=\"http://junit/\">" ) );
    }
