public void testGetMenuContent( )
    {
        HttpServletRequest request = new MockHttpServletRequest( );

        // determine a random page name
        String randomPageName = "page" + new SecureRandom( ).nextLong( );

        // get the menu
        String menu = PortalMenuService.getInstance( ).getMenuContent( 0, PortalMenuService.MODE_NORMAL, PortalMenuService.MENU_MAIN, request );
        assertFalse( "Portal menu should not contain not yet created page with name " + randomPageName, menu.contains( randomPageName ) );

        // create the page
        Page page = new Page( );
        page.setParentPageId( PortalService.getRootPageId( ) );
        page.setName( randomPageName );

        IPageService pageService = (IPageService) SpringContextService.getBean( "pageService" );
        pageService.createPage( page );
        // get the menu
        menu = PortalMenuService.getInstance( ).getMenuContent( 0, PortalMenuService.MODE_NORMAL, PortalMenuService.MENU_MAIN, request );
        assertTrue( "Portal menu should contain page with name " + randomPageName, menu.contains( randomPageName ) );
        // change the page name
        randomPageName = randomPageName + "_mod";
        page.setName( randomPageName );
        pageService.updatePage( page );
        // get the menu
        menu = PortalMenuService.getInstance( ).getMenuContent( 0, PortalMenuService.MODE_NORMAL, PortalMenuService.MENU_MAIN, request );
        assertTrue( "Portal menu should contain page with the modified name " + randomPageName, menu.contains( randomPageName ) );
        // remove the page
        pageService.removePage( page.getId( ) );
        // get the menu
        menu = PortalMenuService.getInstance( ).getMenuContent( 0, PortalMenuService.MODE_NORMAL, PortalMenuService.MENU_MAIN, request );
        assertFalse( "Portal menu should not contain page with name " + randomPageName + " anymore", menu.contains( randomPageName ) );
    }
