public void testBusinessLevel( )
    {
        IPortalUserPreferencesService service = UserPreferencesService.instance( );

        service.clear( USER_ID_1 );

        String strValue = service.get( USER_ID_1, KEY1, DEFAULT );
        assertEquals( strValue, DEFAULT );
        service.put( USER_ID_1, KEY1, VALUE1 );
        strValue = service.get( USER_ID_1, KEY1, DEFAULT );
        assertEquals( strValue, VALUE1 );

        int nValue = service.getInt( USER_ID_1, KEY2, INT_DEFAULT );
        assertEquals( nValue, INT_DEFAULT );
        service.putInt( USER_ID_1, KEY2, INT_VALUE );
        nValue = service.getInt( USER_ID_1, KEY2, INT_DEFAULT );
        assertEquals( nValue, INT_VALUE );

        boolean bValue = service.getBoolean( USER_ID_1, KEY3, BOOL_DEFAULT );
        assertEquals( bValue, BOOL_DEFAULT );
        service.putBoolean( USER_ID_1, KEY3, BOOL_VALUE );
        bValue = service.getBoolean( USER_ID_1, KEY3, BOOL_DEFAULT );
        assertEquals( bValue, BOOL_VALUE );

        service.setNickname( USER_ID_1, NICKNAME );
        assertTrue( NICKNAME.equals( service.getNickname( USER_ID_1 ) ) );

        // List Test
        List list = service.keys( USER_ID_1 );
        assertTrue( list.size( ) == 4 );

        assertTrue( service.existsKey( USER_ID_1, KEY1 ) );
        service.clearKey( USER_ID_1, KEY1 );
        assertTrue( !service.existsKey( USER_ID_1, KEY1 ) );
        service.clearKeyPrefix( USER_ID_1, KEY2 );
        list = service.keys( USER_ID_1 );
        assertTrue( list.size( ) == 2 );
    }
