private boolean enableAuthentication( ) throws IOException, LuteceInitException
    {
        boolean status = SecurityService.isAuthenticationEnable( );

        if ( !status )
        {
            File luteceProperties = new File( getResourcesDir( ), "WEB-INF/conf/lutece.properties" );
            Properties props = new Properties( );
            InputStream is = new FileInputStream( luteceProperties );
            props.load( is );
            is.close( );
            props.setProperty( "mylutece.authentication.enable", "true" );
            props.setProperty( "mylutece.authentication.class", MokeLuteceAuthentication.class.getName( ) );

            OutputStream os = new FileOutputStream( luteceProperties );
            props.store( os, "saved for junit " + this.getClass( ).getCanonicalName( ) );
            os.close( );
            AppPropertiesService.reloadAll( );
            SecurityService.init( );
        }

        return status;
    }
