@Override
    protected void setUp( ) throws Exception
    {
        super.setUp( );
        if ( firstRun )
        {
            firstRun = false;

            _engine = SpringContextService.getBean( BEAN_SEARCH_ENGINE );

            FieldType ft = new FieldType( StringField.TYPE_STORED );
            ft.setOmitNorms( false );
            Document doc = new Document( );
            doc.add( new Field( SearchItem.FIELD_DATE, "2014-06-06", ft ) );
            doc.add( new Field( SearchItem.FIELD_CONTENTS, "lutecefoo lutecebar", TextField.TYPE_NOT_STORED ) );
            doc.add( new StringField( SearchItem.FIELD_METADATA, "lutecetag", Field.Store.NO ) );

            doc.add( new Field( SearchItem.FIELD_TYPE, "lutecetype", ft ) );
            doc.add( new Field( SearchItem.FIELD_ROLE, "role1", ft ) );

            // Not using IndexationService.write(doc) because it needs to be
            // called by IndexationService.processIndexing() (or else it throws null pointer exception)
            IndexWriter indexWriter = getIndexWriter( );
            indexWriter.addDocument( doc );

            doc = new Document( );
            doc.add( new Field( SearchItem.FIELD_CONTENTS, "lutecebaz", TextField.TYPE_NOT_STORED ) );
            doc.add( new Field( SearchItem.FIELD_ROLE, Page.ROLE_NONE, ft ) );
            indexWriter.addDocument( doc );

            indexWriter.close( );
        }
    }
