public void testExec( )
    {
        AbstractMessageFormatTemplateMethod method = new TestAbstractMessageFormatTemplateMethod( "test with 'quote'" );
        Map<Object, Object> model = new HashMap<Object, Object>( );
        model.put( "method", method );
        String template = "${method(\"key\")}";
        HtmlTemplate res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with 'quote'", res.getHtml( ) );

        template = "${method(\"key\",\"arg\")}";
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with quote", res.getHtml( ) );

        method = new TestAbstractMessageFormatTemplateMethod( "test with 'quote' and arg {0}" );
        model.put( "method", method );
        template = "${method(\"key\",\"arg\")}";
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with quote and arg arg", res.getHtml( ) );

        template = "${method(\"key\",arg)}";
        model.put( "arg", "arg" );
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with quote and arg arg", res.getHtml( ) );

        model.put( "arg", 10 );
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with quote and arg 10", res.getHtml( ) );

        model.put( "arg", new Date( 123456789 ) );
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.FRANCE, model );
        assertNotNull( res );
        assertEquals( "test with quote and arg 02/01/70 11:17", res.getHtml( ) );

        model.put( "arg", new Date( 123456789 ) );
        res = FreeMarkerTemplateService.getInstance( ).loadTemplate( template, Locale.US, model );
        assertNotNull( res );
        assertEquals( "test with quote and arg 1/2/70 11:17 AM", res.getHtml( ) );
    }
