public void testDoModifyDefaultAdminUserPasswordInvalidToken( ) throws AccessDeniedException
    {
        AdminUserDAO adminUserDAO = getAdminUserDAO( );
        String randomUsername = "user" + new SecureRandom( ).nextLong( );
        String password = "Pa55word!";
        IPasswordFactory passwordFactory = SpringContextService.getBean( IPasswordFactory.BEAN_NAME );

        LuteceDefaultAdminUser user = new LuteceDefaultAdminUser( randomUsername,
                new LuteceDefaultAdminAuthentication( ) );
        user.setPassword( passwordFactory.getPasswordFromCleartext( password ) );
        user.setFirstName( randomUsername );
        user.setLastName( randomUsername );
        user.setEmail( randomUsername + "@lutece.fr" );
        adminUserDAO.insert( user );
        AdminMenuJspBean instance = new AdminMenuJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.getSession( true ).setAttribute( "lutece_admin_user", user );
        request = new MockHttpServletRequest( );
        request.getSession( true ).setAttribute( "lutece_admin_user", user );
        request.addParameter( Parameters.PASSWORD_CURRENT, password );
        request.addParameter( Parameters.NEW_PASSWORD, password + "_mod" );
        request.addParameter( Parameters.CONFIRM_NEW_PASSWORD, password + "_mod" );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( )
                .getToken( request, "admin/user/modify_password_default_module.html" ) + "b" );
        try
        {
            instance.doModifyDefaultAdminUserPassword( request );
            fail( "Shoulf have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            List<IPassword> history = AdminUserHome.selectUserPasswordHistory( user.getUserId( ) );
            assertEquals( 0, history.size( ) );
            LuteceDefaultAdminUser stored = adminUserDAO.loadDefaultAdminUser( user.getUserId( ) );
            assertTrue( stored.getPassword( ).check( password ) );
        }
    }
