public void testDoCreateChildPage( ) throws AccessDeniedException, SizeLimitExceededException, FileUploadException, IOException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Map<String, String [ ]> parameters = new HashMap<>( );
        parameters.put( Parameters.PAGE_ID, new String [ ] {
            Integer.toString( _page.getId( ) )
        } );
        parameters.put( Parameters.PAGE_DESCRIPTION, new String [ ] {
            _page.getDescription( )
        } );
        parameters.put( Parameters.PAGE_TEMPLATE_ID, new String [ ] {
            Integer.toString( _page.getPageTemplateId( ) )
        } );
        parameters.put( Parameters.META_KEYWORDS, new String [ ] {
            _page.getMetaKeywords( )
        } );
        parameters.put( Parameters.META_DESCRIPTION, new String [ ] {
            _page.getMetaDescription( )
        } );
        parameters.put( "node_status", new String [ ] {
            Integer.toString( _page.getNodeStatus( ) )
        } );
        parameters.put( Parameters.PAGE_NAME, new String [ ] {
            _page.getName( ) + "_child"
        } );
        parameters.put( Parameters.PARENT_ID, new String [ ] {
            Integer.toString( _page.getParentPageId( ) )
        } );
        parameters.put( Parameters.PARAMETER_DISPLAY_UPDATE_DATE, new String [ ] {
            Boolean.toString( _page.getDisplayDateUpdate( ) )
        } );
        parameters.put( Parameters.PARAMETER_ENABLE_MANUAL_UPDATE_DATE, new String [ ] {
            Boolean.toString( _page.getIsManualDateUpdate( ) )
        } );
        parameters.put( Parameters.PARAMETER_MANUAL_UPDATE_DATE, new String [ ] {
            "01/01/2017"
        } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String [ ] {
            SecurityTokenService.getInstance( ).getToken( request, "admin/site/admin_page_block_childpage.html" )
        } );

        Collection<Page> children = PageHome.getChildPages( _page.getId( ) );
        assertNotNull( children );
        assertTrue( children.isEmpty( ) );

        Map<String, List<FileItem>> fileItems = new HashMap<>( );
        List<FileItem> listItems = new ArrayList<>( );
        FileItem pageImageFile = new DiskFileItemFactory( ).createItem( "image_content", "", false, "" );
        pageImageFile.getOutputStream( ).write( new byte [ 1] );
        listItems.add( pageImageFile );
        fileItems.put( "image_content", listItems );
        _bean.doCreateChildPage( new MultipartHttpServletRequest( request, fileItems, parameters ) );
        AdminMessage message = AdminMessageService.getMessage( request );
        assertNull( message );
        children = PageHome.getChildPages( _page.getId( ) );
        assertNotNull( children );
        assertFalse( children.isEmpty( ) );
        assertTrue( children.stream( ).allMatch( page -> page.getParentPageId( ) == _page.getId( ) && page.getName( ).equals( _page.getName( ) + "_child" ) ) );
    }
