public void testDoCreateChildPageInvalidToken( ) throws AccessDeniedException, SizeLimitExceededException, FileUploadException, IOException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Map<String, String [ ]> parameters = new HashMap<>( );
        parameters.put( Parameters.PAGE_ID, new String [ ] {
            Integer.toString( _page.getId( ) )
        } );
        parameters.put( Parameters.PAGE_DESCRIPTION, new String [ ] {
            _page.getDescription( )
        } );
        parameters.put( Parameters.PAGE_TEMPLATE_ID, new String [ ] {
            Integer.toString( _page.getPageTemplateId( ) )
        } );
        parameters.put( Parameters.META_KEYWORDS, new String [ ] {
            _page.getMetaKeywords( )
        } );
        parameters.put( Parameters.META_DESCRIPTION, new String [ ] {
            _page.getMetaDescription( )
        } );
        parameters.put( "node_status", new String [ ] {
            Integer.toString( _page.getNodeStatus( ) )
        } );
        parameters.put( Parameters.PAGE_NAME, new String [ ] {
            _page.getName( ) + "_child"
        } );
        parameters.put( Parameters.PARENT_ID, new String [ ] {
            Integer.toString( _page.getParentPageId( ) )
        } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String [ ] {
            SecurityTokenService.getInstance( ).getToken( request, "admin/site/admin_page_block_childpage.html" ) + "b"
        } );
        Collection<Page> children = PageHome.getChildPages( _page.getId( ) );
        assertNotNull( children );
        assertTrue( children.isEmpty( ) );

        Map<String, List<FileItem>> fileItems = new HashMap<>( );
        List<FileItem> listItems = new ArrayList<>( );
        FileItem pageImageFile = new DiskFileItemFactory( ).createItem( "image_content", "", false, "" );
        pageImageFile.getOutputStream( ).write( new byte [ 1] );
        listItems.add( pageImageFile );
        fileItems.put( "image_content", listItems );
        try
        {
            _bean.doCreateChildPage( new MultipartHttpServletRequest( request, fileItems, parameters ) );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            children = PageHome.getChildPages( _page.getId( ) );
            assertNotNull( children );
            assertTrue( children.isEmpty( ) );
        }
    }
