public void testDoRemovePageWithChild( ) throws AccessDeniedException
    {
        String childPageName = _randomPageName + "-child";
        Page childPage = null;
        IPageService pageService = (IPageService) SpringContextService.getBean( "pageService" );
        try
        {
            childPage = new Page( );
            childPage.setParentPageId( _page.getId( ) );
            childPage.setPageTemplateId( PageTemplateHome.getPageTemplatesList( ).get( 0 ).getId( ) );
            childPage.setName( childPageName );
            pageService.createPage( childPage );
            MockHttpServletRequest request = new MockHttpServletRequest( );
            request.addParameter( Parameters.PAGE_ID, Integer.toString( _page.getId( ) ) );
            _bean.doRemovePage( request );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( AdminMessage.TYPE_STOP, message.getType( ) );
            ReferenceList listLanguages = I18nService.getAdminLocales( Locale.FRANCE );
            for ( ReferenceItem lang : listLanguages )
            {
                assertTrue( message.getText( new Locale( lang.getCode( ) ) ).contains( _randomPageName ) );
            }
        }
        finally
        {
            if ( childPage != null )
            {
                try
                {
                    pageService.removePage( childPage.getId( ) );
                }
                finally
                {
                }
            }
        }
    }
