public void testDoModifyPortletStatus( ) throws AccessDeniedException
    {
        AdminPagePortletJspBean bean = new AdminPagePortletJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Portlet portlet = null;
        AdminUser user = null;
        try
        {
            portlet = getPortlet( );
            int nStatus = portlet.getStatus( );
            int nNewStatus = nStatus == Portlet.STATUS_PUBLISHED ? Portlet.STATUS_UNPUBLISHED : Portlet.STATUS_PUBLISHED;
            user = getAdminUser( );
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/site/DoModifyPortletStatus.jsp" ) );
            request.addParameter( Parameters.PORTLET_ID, Integer.toString( portlet.getId( ) ) );
            request.addParameter( PORTLET_STATUS, Integer.toString( nNewStatus ) );
            Utils.registerAdminUser( request, user );
            String url = bean.doModifyPortletStatus( request );
            assertNotNull( url );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNull( message );
            Portlet storedPortlet = PortletHome.findByPrimaryKey( portlet.getId( ) );
            assertNotNull( storedPortlet );
            assertEquals( nNewStatus, storedPortlet.getStatus( ) );
        }
        finally
        {
            if ( portlet != null )
            {
                removePortlet( portlet );
            }
            if ( user != null )
            {
                removeUser( user );
            }
        }
    }
