public void testDoModifyPortletStatusNoCSRFToken( ) throws AccessDeniedException
    {
        AdminPagePortletJspBean bean = new AdminPagePortletJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Portlet portlet = null;
        AdminUser user = null;
        int nStatus = 0;
        try
        {
            portlet = getPortlet( );
            nStatus = portlet.getStatus( );
            int nNewStatus = nStatus == Portlet.STATUS_PUBLISHED ? Portlet.STATUS_UNPUBLISHED : Portlet.STATUS_PUBLISHED;
            user = getAdminUser( );
            request.addParameter( Parameters.PORTLET_ID, Integer.toString( portlet.getId( ) ) );
            request.addParameter( PORTLET_STATUS, Integer.toString( nNewStatus ) );
            Utils.registerAdminUser( request, user );
            bean.doModifyPortletStatus( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            Portlet storedPortlet = PortletHome.findByPrimaryKey( portlet.getId( ) );
            assertNotNull( storedPortlet );
            assertEquals( nStatus, storedPortlet.getStatus( ) );
        }
        finally
        {
            if ( portlet != null )
            {
                removePortlet( portlet );
            }
            if ( user != null )
            {
                removeUser( user );
            }
        }
    }
