public void testDoRemovePortlet( ) throws AccessDeniedException
    {
        AdminPagePortletJspBean bean = new AdminPagePortletJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Portlet portlet = null;
        AdminUser user = null;
        try
        {
            portlet = getPortlet( );
            user = getAdminUser( );
            request.addParameter( Parameters.PORTLET_ID, Integer.toString( portlet.getId( ) ) );
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/site/DoRemovePortlet.jsp" ) );
            Utils.registerAdminUser( request, user );
            String url = bean.doRemovePortlet( request );
            assertNotNull( url );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNull( message );
            try
            {
                portlet = PortletHome.findByPrimaryKey( portlet.getId( ) );
                fail( "Portlet was not removed" );
            }
            catch( NullPointerException e )
            {
                portlet = null;
            }
        }
        finally
        {
            if ( portlet != null )
            {
                removePortlet( portlet );
            }
            if ( user != null )
            {
                removeUser( user );
            }
        }
    }
