public void testGetModifyPortletStatus( ) throws AccessDeniedException
    {
        AdminPagePortletJspBean bean = new AdminPagePortletJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Portlet portlet = null;
        AdminUser user = null;
        try
        {
            portlet = getPortlet( );
            user = getAdminUser( );
            request.addParameter( Parameters.PORTLET_ID, Integer.toString( portlet.getId( ) ) );
            request.addParameter( PORTLET_STATUS, Integer.toString( Portlet.STATUS_PUBLISHED ) );
            Utils.registerAdminUser( request, user );
            String url = bean.getModifyPortletStatus( request );
            assertNotNull( url );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertNotNull( message.getRequestParameters( ).get( SecurityTokenService.PARAMETER_TOKEN ) );
            assertEquals( message.getType( ), AdminMessage.TYPE_CONFIRMATION );
        }
        finally
        {
            if ( portlet != null )
            {
                removePortlet( portlet );
            }
            if ( user != null )
            {
                removeUser( user );
            }
        }
    }
