public void testDoMoveAdminDashboardInvalidToken( ) throws AccessDeniedException
    {
        IAdminDashboardComponent stored = AdminDashboardHome.findByPrimaryKey( _dashboard.getName( ) );
        assertNotNull( stored );
        assertEquals( 0, stored.getOrder( ) );
        assertEquals( 0, stored.getZone( ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "dashboard_name", _dashboard.getName( ) );
        request.setParameter( "dashboard_order", "-1" );
        request.setParameter( "dashboard_column", "-1" );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "/admin/dashboard/admin/manage_dashboards.html" )
                        + "b" );

        try
        {
            instance.doMoveAdminDashboard( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            stored = AdminDashboardHome.findByPrimaryKey( _dashboard.getName( ) );
            assertNotNull( stored );
            assertEquals( 0, stored.getOrder( ) );
            assertEquals( 0, stored.getZone( ) );
        }
    }
