public void testDoReorderColumn( ) throws AccessDeniedException
    {
        IDashboardComponent stored = DashboardHome.findByPrimaryKey( _dashboard.getName( ) );
        assertNotNull( stored );
        assertEquals( 0, stored.getOrder( ) );
        assertEquals( _nZone, stored.getZone( ) );
        int nZone = DashboardHome.findColumns( ).stream( ).max( Integer::compare ).orElse( 1 ) + 1;
        stored.setZone( nZone );
        stored.setOrder( -1 );
        DashboardHome.update( stored );
        stored = DashboardHome.findByPrimaryKey( _dashboard.getName( ) );
        assertEquals( -1, stored.getOrder( ) );
        assertEquals( nZone, stored.getZone( ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "column", Integer.toString( nZone ) );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( )
                .getToken( request, "/admin/dashboard/manage_dashboards.html" ) );

        _instance.doReorderColumn( request );

        stored = DashboardHome.findByPrimaryKey( _dashboard.getName( ) );
        assertEquals( 1, stored.getOrder( ) );
        assertEquals( nZone, stored.getZone( ) );
    }
