public void testDoCreateExternalFeatureInvalidToken( ) throws PasswordResetException, AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_ID_EXTERNAL_FEAUTRE, TEST_EXTERNAL_FEATURE_ID );
        Utils.registerAdminUserWithRigth( request, new AdminUser( ),
                ExternalFeaturesJspBean.RIGHT_EXTERNAL_FEATURES_MANAGEMENT );

        ExternalFeaturesJspBean instance = new ExternalFeaturesJspBean( );
        instance.init( request, ExternalFeaturesJspBean.RIGHT_EXTERNAL_FEATURES_MANAGEMENT );
        String strRandom = getRandomName( );
        request.setParameter( "id", strRandom );
        request.setParameter( "nameKey", strRandom );
        request.setParameter( "descriptionKey", strRandom );
        request.setParameter( "level_id", "0" );
        request.setParameter( "url", strRandom );
        request.setParameter( "pluginName", strRandom );
        request.setParameter( "feature_group_id", FeatureGroupHome.getFeatureGroupsList( ).get( 0 ).getId( ) );
        request.setParameter( "iconUrl", strRandom );
        request.setParameter( "externalFeature", "false" );
        request.setParameter( "documentationUrl", strRandom );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/features/create_external_feature.html" )
                        + "b" );

        try
        {
            instance.doCreateExternalFeature( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            Right right = RightHome.findByPrimaryKey( strRandom );
            assertNull( right );
        }
        finally
        {
            RightHome.remove( strRandom );
        }
    }
