public void testDoModifyExternalFeatureNoToken( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_ID_EXTERNAL_FEAUTRE, TEST_EXTERNAL_FEATURE_ID );
        Utils.registerAdminUserWithRigth( request, new AdminUser( ),
                ExternalFeaturesJspBean.RIGHT_EXTERNAL_FEATURES_MANAGEMENT );

        ExternalFeaturesJspBean instance = new ExternalFeaturesJspBean( );
        instance.init( request, ExternalFeaturesJspBean.RIGHT_EXTERNAL_FEATURES_MANAGEMENT );
        String strRandom = getRandomName( );
        request.setParameter( "id", _right.getId( ) );
        request.setParameter( "nameKey", strRandom );
        request.setParameter( "descriptionKey", strRandom );
        request.setParameter( "level_id", "0" );
        request.setParameter( "url", strRandom );
        request.setParameter( "pluginName", strRandom );
        request.setParameter( "feature_group_id", FeatureGroupHome.getFeatureGroupsList( ).get( 0 ).getId( ) );
        request.setParameter( "iconUrl", strRandom );
        request.setParameter( "externalFeature", "false" );
        request.setParameter( "documentationUrl", strRandom );

        instance.getModifyExternalFeature( request );

        try
        {
            instance.doModifyExternalFeature( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            Right right = RightHome.findByPrimaryKey( _right.getId( ) );
            assertNotNull( right );
            assertEquals( _right.getNameKey( ), right.getNameKey( ) );
            assertEquals( _right.getDescriptionKey( ), right.getDescriptionKey( ) );
            assertEquals( _right.getLevel( ), right.getLevel( ) );
            assertEquals( _right.getUrl( ), right.getUrl( ) );
            assertEquals( _right.getPluginName( ), right.getPluginName( ) );
            assertEquals( _right.getFeatureGroup( ), right.getFeatureGroup( ) );
            assertEquals( _right.getIconUrl( ), right.getIconUrl( ) );
            assertTrue( right.isExternalFeature( ) );
            assertEquals( _right.getDocumentationUrl( ), right.getDocumentationUrl( ) );
        }
    }
