public void testDoCreateGroup( ) throws AccessDeniedException
    {
        String strGroupName = getRandomName( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( "group_id", strGroupName );
        request.addParameter( "group_name", strGroupName );
        request.addParameter( "group_description", strGroupName );
        request.addParameter( "group_order", "1" );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/features/create_group.html" ) );

        try
        {
            instance.doCreateGroup( request );
            FeatureGroup group = FeatureGroupHome.findByPrimaryKey( strGroupName );
            assertNotNull( group );
            assertEquals( strGroupName, group.getId( ) );
            assertEquals( strGroupName, group.getLabelKey( ) );
            assertEquals( strGroupName, group.getDescriptionKey( ) );
            assertEquals( 1, group.getOrder( ) );
        }
        finally
        {
            FeatureGroupHome.remove( strGroupName );
        }
    }
