public void testDoReinitFeaturesInvalidToken( ) throws AccessDeniedException
    {
        right.setFeatureGroup( featureGroup.getId( ) );
        RightHome.update( right );
        right.setOrder( 100 );
        ( ( IRightDAO ) SpringContextService.getBean( "rightDAO" ) ).store( right );

        Right stored = RightHome.findByPrimaryKey( right.getId( ) );
        assertNotNull( stored );
        assertEquals( 100, stored.getOrder( ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( "group_id", featureGroup.getId( ) );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/features/dispatch_features.html" )
                        + "b" );

        try
        {
            instance.doReinitFeatures( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            stored = RightHome.findByPrimaryKey( right.getId( ) );
            assertNotNull( stored );
            assertEquals( 100, stored.getOrder( ) );
        }
    }
