public void testDoUpdateBackOfficeEditor( ) throws AccessDeniedException
    {
        String strBOEditor = RichTextEditorService.getListEditorsForBackOffice( Locale.FRANCE ).stream( )
                .filter( ref -> !ref.getCode( ).equals( _boDefaultEditor ) ).findFirst( )
                .orElseThrow( IllegalStateException::new ).getCode( );
        assertFalse( strBOEditor.equals( RichTextEditorService.getBackOfficeDefaultEditor( ) ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "editor_back_office", strBOEditor );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( )
                .getToken( request, "admin/globalmanagement/panel/editor_choice_panel.html" ) );
        _instance.doUpdateBackOfficeEditor( request );

        assertEquals( strBOEditor, RichTextEditorService.getBackOfficeDefaultEditor( ) );
    }
