public void testDoUpdateBackOfficeEditorInvalidToken( ) throws AccessDeniedException
    {
        String strBOEditor = RichTextEditorService.getListEditorsForBackOffice( Locale.FRANCE ).stream( )
                .filter( ref -> !ref.getCode( ).equals( _boDefaultEditor ) ).findFirst( )
                .orElseThrow( IllegalStateException::new ).getCode( );
        assertFalse( strBOEditor.equals( RichTextEditorService.getBackOfficeDefaultEditor( ) ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "editor_back_office", strBOEditor );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( )
                .getToken( request, "admin/globalmanagement/panel/editor_choice_panel.html" ) + "b" );
        try
        {
            _instance.doUpdateBackOfficeEditor( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            assertEquals( _boDefaultEditor, RichTextEditorService.getBackOfficeDefaultEditor( ) );
        }
    }
