@Override
    protected void setUp( ) throws Exception
    {
        super.setUp( );
        File dirPlugin = new File( AppPathService.getPath( "path.plugins" ) );
        File testPluginFile = new File( dirPlugin, PLUGIN_NAME + ".xml" );
        try( BufferedWriter writer = new BufferedWriter( new FileWriter( testPluginFile ) ) )
        {
            writer.write( "<plug-in><name>" + PLUGIN_NAME + "</name><class>" + LinksIncludeTestPlugin.class.getName( ) + "</class>"
                    + "<icon-url>../../images/admin/skin/plugins/myplugin/myplugin.gif</icon-url></plug-in>" );
        }
        PluginService.init( );
        PluginService.getPlugin( PLUGIN_NAME ).install( );
        List<CacheableService> caches = CacheService.getCacheableServicesList( );
        for ( CacheableService cacheService : caches )
        {
            if ( LinksIncludeCacheService.SERVICE_NAME.equals( cacheService.getName( ) ) )
            {
                bOrigCacheEnabled = cacheService.isCacheEnable( );
                cacheService.enableCache( enableCache( ) );
                break;
            }
        }
    }
