public void testGetURICssHashDigestError( ) throws IOException
    {
        LinksIncludeTestPlugin plugin = (LinksIncludeTestPlugin) PluginService.getPlugin( PLUGIN_NAME );
        List<String> styleSheets = new ArrayList<>( );
        styleSheets.add( "linksIncludeTestPlugin/junithashed.css" );
        File hashedFile = new File( getResourcesDir( ), "css/plugins/linksIncludeTestPlugin/junithashed.css" );
        System.out.println( hashedFile.toString( ) );
        hashedFile.getParentFile( ).mkdirs( );
        try( FileWriter writer = new FileWriter( hashedFile ) )
        {
            writer.write( "abcd" );
        }
        try
        {
            plugin.setCssStyleSheets( styleSheets );
            plugin.setCssStyleSheetsScopePortal( true );
            LinksInclude include = new LinksInclude( );
            Map<String, Object> rootModel = new HashMap<>( );
            PageData data = new PageData( );
            int nMode = 0;
            ServletContext servletContext = new MockServletContext( )
            {

                @Override
                public InputStream getResourceAsStream( String path )
                {
                    File file = new File( getResourcesDir( ), path );
                    if ( file.exists( ) )
                    {
                        return new InputStream( )
                        {

                            @Override
                            public int read( ) throws IOException
                            {
                                throw new IOException( "Mocking IO error" );
                            }
                        };
                    }
                    return null;
                }

            };
            MockHttpServletRequest request = new MockHttpServletRequest( servletContext );
            include.fillTemplate( rootModel, data, nMode, request );
            String cssLinks = (String) rootModel.get( "plugins_css_links" );
            assertEquals( "<link rel=\"stylesheet\"  href=\"css/plugins/linksIncludeTestPlugin/junithashed.css\" type=\"text/css\"  media=\"screen\" />\n",
                    cssLinks );
        }
        finally
        {
            hashedFile.delete( );
        }
    }
