public void testGetURIJavascriptHash( ) throws IOException
    {
        LinksIncludeTestPlugin plugin = (LinksIncludeTestPlugin) PluginService.getPlugin( PLUGIN_NAME );
        List<String> javascripts = new ArrayList<>( );
        javascripts.add( "linksIncludeTestPlugin/scripthashed.js" );
        File hashedFile = new File( getResourcesDir( ), "js/plugins/linksIncludeTestPlugin/scripthashed.js" );
        hashedFile.getParentFile( ).mkdirs( );
        try( FileWriter writer = new FileWriter( hashedFile ) )
        {
            writer.write( "abcd" );
        }
        try
        {
            plugin.setJavascriptFiles( javascripts );
            plugin.setJavascriptFilesScopePortal( true );
            LinksInclude include = new LinksInclude( );
            Map<String, Object> rootModel = new HashMap<>( );
            PageData data = new PageData( );
            int nMode = 0;
            ServletContext servletContext = new MockServletContext( )
            {

                @Override
                public InputStream getResourceAsStream( String path )
                {
                    File file = new File( getResourcesDir( ), path );
                    if ( file.exists( ) )
                    {
                        try
                        {
                            return new FileInputStream( file );
                        }
                        catch( FileNotFoundException e )
                        {
                            return null;
                        }
                    }
                    return null;
                }

            };
            MockHttpServletRequest request = new MockHttpServletRequest( servletContext );
            include.fillTemplate( rootModel, data, nMode, request );
            String cssLinks = (String) rootModel.get( "plugins_javascript_links" );
            assertEquals(
                    "<script src=\"js/plugins/linksIncludeTestPlugin/scripthashed.js?lutece_h=88d4266fd4e6338d13b845fcf289579d209c897823b9217da3e161936f031589\" type=\"text/javascript\" ></script>",
                    cssLinks );
            try( FileWriter writer = new FileWriter( hashedFile ) )
            {
                writer.write( "bbcd" );
            }
            include.fillTemplate( rootModel, data, nMode, request );
            String cssLinks2 = (String) rootModel.get( "plugins_javascript_links" );
            assertNotNull( cssLinks2 );
            if ( enableCache( ) )
            {
                assertSame( cssLinks, cssLinks2 );
            }
            else
            {
                assertFalse( cssLinks.equals( cssLinks2 ) );
                assertEquals(
                        "<script src=\"js/plugins/linksIncludeTestPlugin/scripthashed.js?lutece_h=531ba794ef006cd3d69cf1acb33ddeccf8d6c655fb08f469335f8c2c32e2ab68\" type=\"text/javascript\" ></script>",
                        cssLinks2 );
            }
        }
        finally
        {
            hashedFile.delete( );
        }
    }
