public void testGetURIJavascriptHashDigestError( ) throws IOException
    {
        LinksIncludeTestPlugin plugin = (LinksIncludeTestPlugin) PluginService.getPlugin( PLUGIN_NAME );
        List<String> javascripts = new ArrayList<>( );
        javascripts.add( "linksIncludeTestPlugin/scripthashed.js" );
        File hashedFile = new File( getResourcesDir( ), "js/plugins/linksIncludeTestPlugin/scripthashed.js" );
        hashedFile.getParentFile( ).mkdirs( );
        try( FileWriter writer = new FileWriter( hashedFile ) )
        {
            writer.write( "abcd" );
        }
        try
        {
            plugin.setJavascriptFiles( javascripts );
            plugin.setJavascriptFilesScopePortal( true );
            LinksInclude include = new LinksInclude( );
            Map<String, Object> rootModel = new HashMap<>( );
            PageData data = new PageData( );
            int nMode = 0;
            ServletContext servletContext = new MockServletContext( )
            {

                @Override
                public InputStream getResourceAsStream( String path )
                {
                    File file = new File( getResourcesDir( ), path );
                    if ( file.exists( ) )
                    {
                        return new InputStream( )
                        {

                            @Override
                            public int read( ) throws IOException
                            {
                                throw new IOException( "Mocking IO error" );
                            }
                        };
                    }
                    return null;
                }

            };
            MockHttpServletRequest request = new MockHttpServletRequest( servletContext );
            include.fillTemplate( rootModel, data, nMode, request );
            String cssLinks = (String) rootModel.get( "plugins_javascript_links" );
            assertEquals( "<script src=\"js/plugins/linksIncludeTestPlugin/scripthashed.js\" type=\"text/javascript\" ></script>", cssLinks );
        }
        finally
        {
            hashedFile.delete( );
        }
    }
