public void testDoAddUsersInvalidToken( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "id_mailinglist", Integer.toString( mailingList.getId( ) ) );
        request.setParameter( "workgroup", AdminWorkgroupService.ALL_GROUPS );
        request.setParameter( "role", AdminMailingListService.ALL_ROLES );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "admin/mailinglist/add_users.html" )
                + "b" );

        MailingListUsersFilter filter = new MailingListUsersFilter( );
        filter.setRole( AdminMailingListService.ALL_ROLES );
        filter.setWorkgroup( AdminWorkgroupService.ALL_GROUPS );
        assertFalse( MailingListHome.checkFilter( filter, mailingList.getId( ) ) );
        try
        {
            bean.doAddUsers( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            assertFalse( MailingListHome.checkFilter( filter, mailingList.getId( ) ) );
        }
    }
