public void testDoCreateMailingListNoToken( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        final String name = getRandomName( );
        request.setParameter( "name", name );
        request.setParameter( "workgroup", AdminWorkgroupService.ALL_GROUPS );
        request.setParameter( "description", name );

        MailingListHome.findAll( ).forEach( mailingList -> {
            assertFalse( name.equals( mailingList.getName( ) ) );
        } );
        try
        {
            bean.doCreateMailingList( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            MailingListHome.findAll( ).forEach( mailingList -> {
                assertFalse( name.equals( mailingList.getName( ) ) );
            } );
        }
        finally
        {
            MailingListHome.findAll( ).stream( ).filter( mailingList -> {
                return name.equals( mailingList.getName( ) );
            } ).forEach( mailingList -> {
                MailingListHome.remove( mailingList.getId( ) );
            } );
        }
    }
