public void testDoAssignUsersInvalidToken( ) throws AccessDeniedException
    {
        RoleManagementJspBean bean = new RoleManagementJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "AssignUsersRole.jsp" ) + "b" );
        Collection<AdminUser> users = AdminUserHome.findUserList( );
        for ( AdminUser user : users )
        {
            request.addParameter( "available_users_list", Integer.toString( user.getUserId( ) ) );
        }
        AdminRole role = new AdminRole( );
        role.setKey( getRandomName( ) );
        role.setDescription( role.getKey( ) );
        AdminRoleHome.create( role );
        request.setParameter( "role_key", role.getKey( ) );
        try
        {
            bean.doAssignUsers( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            users = AdminUserHome.findUserList( );
            for ( AdminUser user : users )
            {
                assertFalse( AdminUserHome.hasRole( user, role.getKey( ) ) );
            }
        }
        finally
        {
            users = AdminUserHome.findUserList( );
            for ( AdminUser user : users )
            {
                AdminUserHome.removeRoleForUser( user.getUserId( ), role.getKey( ) );
            }
            AdminRoleHome.remove( role.getKey( ) );
        }
    }
