public void testDoRemoveControlFromRoleNoToken( ) throws AccessDeniedException
    {
        AdminRole role = new AdminRole( );
        role.setKey( getRandomName( ) );
        role.setDescription( role.getKey( ) );
        AdminRoleHome.create( role );
        RBAC rBAC = new RBAC( );
        rBAC.setRoleKey( role.getKey( ) );
        rBAC.setResourceId( "*" );
        rBAC.setPermissionKey( "*" );
        rBAC.setResourceTypeKey( "*" );
        RBACHome.create( rBAC );
        RoleManagementJspBean bean = new RoleManagementJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "rbac_id", Integer.toString( rBAC.getRBACId( ) ) );
        try
        {
            Collection<RBAC> rbacs = RBACHome.findResourcesByCode( role.getKey( ) );
            boolean found = false;
            for ( RBAC aRBAC : rbacs )
            {
                if ( aRBAC.getRBACId( ) == rBAC.getRBACId( ) )
                {
                    found = true;
                    break;
                }
            }
            assertTrue( found );
            bean.doRemoveControlFromRole( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            Collection<RBAC> rbacs = RBACHome.findResourcesByCode( role.getKey( ) );
            boolean found = false;
            for ( RBAC aRBAC : rbacs )
            {
                if ( aRBAC.getRBACId( ) == rBAC.getRBACId( ) )
                {
                    found = true;
                    break;
                }
            }
            assertTrue( found );
        }
        finally
        {
            RBACHome.remove( rBAC.getRBACId( ) );
            AdminRoleHome.remove( role.getKey( ) );
        }
    }
