public void testDoCreatePageRole( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        final String name = getRandomName( );
        request.setParameter( "role", name );
        request.setParameter( "role_description", name );
        request.setParameter( "workgroup_key", AdminWorkgroupService.ALL_GROUPS );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "admin/role/create_page_role.html" ) );

        assertNull( RoleHome.findByPrimaryKey( name ) );
        try
        {
            bean.doCreatePageRole( request );
            Role stored = RoleHome.findByPrimaryKey( name );
            assertNotNull( stored );
            assertEquals( name, stored.getRole( ) );
            assertEquals( name, stored.getRoleDescription( ) );
            assertEquals( AdminWorkgroupService.ALL_GROUPS, stored.getWorkgroup( ) );
        }
        finally
        {
            RoleHome.remove( name );
        }
    }
