public void testGetRemovePageRole( )
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        // no args
        bean.getRemovePageRole( request );
        AdminMessage message = AdminMessageService.getMessage( request );
        assertNotNull( message );
        ReferenceList listLanguages = I18nService.getAdminLocales( Locale.FRANCE );
        for ( ReferenceItem lang : listLanguages )
        {
            assertTrue( message.getText( new Locale( lang.getCode( ) ) ).contains( PARAMETER_PAGE_ROLE ) );
        }
        // invalid arg
        request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_PAGE_ROLE, role.getRole( ) );
        bean.getRemovePageRole( request );
        message = AdminMessageService.getMessage( request );
        assertNotNull( message );
        for ( ReferenceItem lang : listLanguages )
        {
            assertTrue( message.getText( new Locale( lang.getCode( ) ) ).contains( role.getRole( ) ) );
        }
        // valid arg
        request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_PAGE_ROLE, role.getRole( ) );
        bean.getRemovePageRole( request );
        message = AdminMessageService.getMessage( request );
        assertNotNull( message );
        for ( ReferenceItem lang : listLanguages )
        {
            assertTrue( message.getText( new Locale( lang.getCode( ) ) ).contains( role.getRole( ) ) );
        }
        assertTrue( message.getRequestParameters( ).containsKey( SecurityTokenService.PARAMETER_TOKEN ) );
    }
