public void testDoModifyAdvancedParameters( ) throws AccessDeniedException
    {
        String strTypeFilter;
        if ( "none".equals( SearchParameterHome.findByKey( PARAMETER_TYPE_FILTER ).getName( ) ) )
        {
            strTypeFilter = "option";
        }
        else
        {
            strTypeFilter = "none";
        }

        String strDefaultOperator;
        if ( "OR".equals( SearchParameterHome.findByKey( PARAMETER_DEFAULT_OPERATOR ).getName( ) ) )
        {
            strDefaultOperator = "AND";
        }
        else
        {
            strDefaultOperator = "OR";
        }

        String strHelpMessage = getRandomName( );

        String strDateFilter;
        if ( "0".equals( SearchParameterHome.findByKey( PARAMETER_DATE_FILTER ).getName( ) ) )
        {
            strDateFilter = "1";
        }
        else
        {
            strDateFilter = "0";
        }

        String strTagFilter;
        if ( "0".equals( SearchParameterHome.findByKey( PARAMETER_TAG_FILTER ).getName( ) ) )
        {
            strTagFilter = "1";
        }
        else
        {
            strTagFilter = "0";
        }

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_TYPE_FILTER, strTypeFilter );
        request.addParameter( PARAMETER_DEFAULT_OPERATOR, strDefaultOperator );
        request.addParameter( PARAMETER_HELP_MESSAGE, strHelpMessage );
        request.addParameter( PARAMETER_DATE_FILTER, strDateFilter );
        request.addParameter( PARAMETER_TAG_FILTER, strTagFilter );
        AdminUser user = new AdminUser( );
        Map<String, AdminRole> roles = new HashMap<String, AdminRole>( );
        for ( AdminRole role : AdminRoleHome.findAll( ) )
        {
            roles.put( role.getKey( ), role );
        }
        user.addRoles( roles );
        Utils.registerAdminUserWithRigth( request, user, "CORE_SEARCH_MANAGEMENT" );
        _bean.init( request, "CORE_SEARCH_MANAGEMENT" );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( )
                .getToken( request, "admin/search/manage_advanced_parameters.html" ) );

        _bean.doModifyAdvancedParameters( request );
        AdminMessage message = AdminMessageService.getMessage( request );
        assertNull( message );
        for ( ReferenceItem param : _origSearchParameters )
        {
            if ( PARAMETER_TAGLIST.equals( param.getCode( ) ) )
            {
                continue;
            }
            assertFalse( "SearchParameter " + param.getCode( ) + " stayed equal to " + param.getName( ),
                    param.getName( ).equals( SearchParameterHome.findByKey( param.getCode( ) ).getName( ) ) );
        }
        assertEquals( strTypeFilter, SearchParameterHome.findByKey( PARAMETER_TYPE_FILTER ).getName( ) );
        assertEquals( strDefaultOperator, SearchParameterHome.findByKey( PARAMETER_DEFAULT_OPERATOR ).getName( ) );
        assertEquals( strHelpMessage, SearchParameterHome.findByKey( PARAMETER_HELP_MESSAGE ).getName( ) );
        assertEquals( strDateFilter, SearchParameterHome.findByKey( PARAMETER_DATE_FILTER ).getName( ) );
        assertEquals( strTagFilter, SearchParameterHome.findByKey( PARAMETER_TAG_FILTER ).getName( ) );
    }
