public void testDoModifyAdvancedParametersInvalidToken( ) throws AccessDeniedException
    {
        String strTypeFilter;
        if ( "none".equals( SearchParameterHome.findByKey( PARAMETER_TYPE_FILTER ).getName( ) ) )
        {
            strTypeFilter = "option";
        }
        else
        {
            strTypeFilter = "none";
        }

        String strDefaultOperator;
        if ( "OR".equals( SearchParameterHome.findByKey( PARAMETER_DEFAULT_OPERATOR ).getName( ) ) )
        {
            strDefaultOperator = "AND";
        }
        else
        {
            strDefaultOperator = "OR";
        }

        String strHelpMessage = getRandomName( );

        String strDateFilter;
        if ( "0".equals( SearchParameterHome.findByKey( PARAMETER_DATE_FILTER ).getName( ) ) )
        {
            strDateFilter = "1";
        }
        else
        {
            strDateFilter = "0";
        }

        String strTagFilter;
        if ( "0".equals( SearchParameterHome.findByKey( PARAMETER_TAG_FILTER ).getName( ) ) )
        {
            strTagFilter = "1";
        }
        else
        {
            strTagFilter = "0";
        }

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( PARAMETER_TYPE_FILTER, strTypeFilter );
        request.addParameter( PARAMETER_DEFAULT_OPERATOR, strDefaultOperator );
        request.addParameter( PARAMETER_HELP_MESSAGE, strHelpMessage );
        request.addParameter( PARAMETER_DATE_FILTER, strDateFilter );
        request.addParameter( PARAMETER_TAG_FILTER, strTagFilter );
        AdminUser user = new AdminUser( );
        Map<String, AdminRole> roles = new HashMap<String, AdminRole>( );
        for ( AdminRole role : AdminRoleHome.findAll( ) )
        {
            roles.put( role.getKey( ), role );
        }
        user.addRoles( roles );
        Utils.registerAdminUserWithRigth( request, user, "CORE_SEARCH_MANAGEMENT" );
        _bean.init( request, "CORE_SEARCH_MANAGEMENT" );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/search/manage_advanced_parameters.html" )
                        + "b" );

        try
        {
            _bean.doModifyAdvancedParameters( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            for ( ReferenceItem param : _origSearchParameters )
            {
                assertEquals( param.getName( ), SearchParameterHome.findByKey( param.getCode( ) ).getName( ) );
            }
        }
    }
