public void testDoCreatePageTemplate( ) throws AccessDeniedException, IOException
    {
        final String desc = getRandomName( );
        Map<String, String [ ]> parameters = new HashMap<String, String [ ]>( );
        parameters.put( Parameters.PAGE_TEMPLATE_DESCRIPTION, new String [ ] {
            desc
        } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String [ ] {
            SecurityTokenService.getInstance( ).getToken( request, "admin/style/create_page_template.html" )
        } );
        DiskFileItemFactory fileItemFactory = new DiskFileItemFactory( );
        Map<String, List<FileItem>> files = new HashMap<>( );
        List<FileItem> pageTemplateFiles = new ArrayList<>( );
        FileItem pageTemplateFile = fileItemFactory.createItem( "page_template_file", "text/html", false, "junit.html" );
        pageTemplateFile.getOutputStream( ).write( new byte [ 1] );
        pageTemplateFiles.add( pageTemplateFile );
        files.put( "page_template_file", pageTemplateFiles );
        List<FileItem> pageTemplatePictures = new ArrayList<>( );
        FileItem pageTemplatePicture = fileItemFactory.createItem( "page_template_picture", "image/jpg", false, "junit.jpg" );
        pageTemplatePicture.getOutputStream( ).write( new byte [ 1] );
        pageTemplatePictures.add( pageTemplatePicture );
        files.put( "page_template_picture", pageTemplatePictures );
        MultipartHttpServletRequest multipartRequest = new MultipartHttpServletRequest( request, files, parameters );
        try
        {
            instance.doCreatePageTemplate( multipartRequest );
            assertTrue( PageTemplateHome.getPageTemplatesList( ).stream( ).anyMatch( t -> t.getDescription( ).equals( desc ) ) );
        }
        finally
        {
            PageTemplateHome.getPageTemplatesList( ).stream( ).filter( t -> t.getDescription( ).equals( desc ) )
                    .forEach( t -> PageTemplateHome.remove( t.getId( ) ) );
        }
    }
