public void testDoModifyPageTemplate( ) throws AccessDeniedException
    {
        final String desc = getRandomName( );
        PageTemplate pageTemplate = new PageTemplate( );
        pageTemplate.setDescription( desc );
        PageTemplateHome.create( pageTemplate );

        Map<String, String [ ]> parameters = new HashMap<>( );
        parameters.put( Parameters.PAGE_TEMPLATE_ID, new String [ ] {
            Integer.toString( pageTemplate.getId( ) )
        } );
        parameters.put( Parameters.PAGE_TEMPLATE_DESCRIPTION, new String [ ] {
            desc + "mod"
        } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String [ ] {
            SecurityTokenService.getInstance( ).getToken( request, "admin/style/modify_page_template.html" )
        } );
        MultipartHttpServletRequest multipartRequest = new MultipartHttpServletRequest( request, Collections.emptyMap( ), parameters );
        try
        {
            assertEquals( desc, PageTemplateHome.findByPrimaryKey( pageTemplate.getId( ) ).getDescription( ) );
            instance.doModifyPageTemplate( multipartRequest );
            assertEquals( desc + "mod", PageTemplateHome.findByPrimaryKey( pageTemplate.getId( ) ).getDescription( ) );
        }
        finally
        {
            PageTemplateHome.remove( pageTemplate.getId( ) );
        }
    }
