public void testDoRemovePageTemplateInvalidToken( ) throws AccessDeniedException
    {
        final String desc = getRandomName( );
        PageTemplate pageTemplate = new PageTemplate( );
        pageTemplate.setDescription( desc );
        pageTemplate.setFile( "junit" );
        pageTemplate.setPicture( "junit" );
        PageTemplateHome.create( pageTemplate );

        request.addParameter( Parameters.PAGE_TEMPLATE_ID, Integer.toString( pageTemplate.getId( ) ) );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/style/DoRemovePageTemplate.jsp" ) + "b" );
        try
        {
            instance.doRemovePageTemplate( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            assertNotNull( PageTemplateHome.findByPrimaryKey( pageTemplate.getId( ) ) );
        }
        finally
        {
            PageTemplateHome.remove( pageTemplate.getId( ) );
        }
    }
