public void testDoCreateStyle( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        int nId = StyleHome.getStylesList( ).stream( ).map( Style::getId ).max( Integer::compare ).get( ) + 1;
        request.addParameter( Parameters.STYLE_ID, Integer.toString( nId ) );
        String name = getRandomName( );
        request.addParameter( Parameters.STYLE_NAME, name );
        String portalComponantId = "1";
        request.addParameter( Parameters.PORTAL_COMPONENT, portalComponantId );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/style/create_style.html" ) );
        try
        {
            instance.doCreateStyle( request );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNull( message );
            Style stored = StyleHome.findByPrimaryKey( nId );
            assertNotNull( stored );
            assertEquals( nId, stored.getId( ) );
        }
        finally
        {
            StyleHome.remove( nId );
        }
    }
