public void testDoCreateStyleInvalidToken( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        int nId = StyleHome.getStylesList( ).stream( ).map( Style::getId ).max( Integer::compare ).get( ) + 1;
        request.addParameter( Parameters.STYLE_ID, Integer.toString( nId ) );
        String name = getRandomName( );
        request.addParameter( Parameters.STYLE_NAME, name );
        String portalComponantId = "1";
        request.addParameter( Parameters.PORTAL_COMPONENT, portalComponantId );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/style/create_style.html" ) + "b" );
        try
        {
            instance.doCreateStyle( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            Style stored = StyleHome.findByPrimaryKey( nId );
            assertNull( stored );
        }
        finally
        {
            StyleHome.remove( nId );
        }
    }
