public void testGetConfirmRemoveStyleWithStyleSheet( ) throws AccessDeniedException
    {
        StyleSheet stylesheet = new StyleSheet( );
        String randomName = getRandomName();
        stylesheet.setDescription( randomName );
        stylesheet.setModeId( 1 );
        stylesheet.setStyleId( style.getId( ) );
        stylesheet.setFile( "file" );
        stylesheet.setSource( "<a/>".getBytes( ) );
        StyleSheetHome.create( stylesheet );
        try
        {
            MockHttpServletRequest request = new MockHttpServletRequest( );
            request.addParameter( Parameters.STYLE_ID, Integer.toString( style.getId( ) ) );
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/style/DoRemoveStyle.jsp" ) );
            instance.getConfirmRemoveStyle( request );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertTrue( message.getRequestParameters( ).containsKey( SecurityTokenService.PARAMETER_TOKEN ) );
            assertTrue( message.getRequestParameters( ).containsKey( Parameters.STYLESHEET_ID ) );
            assertEquals( Integer.toString( stylesheet.getId( ) ), message.getRequestParameters( ).get( Parameters.STYLESHEET_ID ) );
        }
        finally
        {
            StyleSheetHome.remove( stylesheet.getId( ) );
        }
    }
