public void testDoCreateStyleSheetNoToken( ) throws IOException, AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Map<String, String[ ]> parameters = new HashMap<>( );
        final String randomName = getRandomName( );
        parameters.put( Parameters.STYLESHEET_NAME, new String[ ] { randomName } );
        parameters.put( Parameters.STYLES, new String[ ] { Integer.toString( style.getId( ) ) } );
        parameters.put( Parameters.MODE_STYLESHEET, new String[ ] { "0" } );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );
        List<FileItem> items = new ArrayList<>( );
        FileItem source = new DiskFileItemFactory( ).createItem( Parameters.STYLESHEET_SOURCE, "application/xml", true,
                randomName );
        source.getOutputStream( ).write( "<a/>".getBytes( ) );
        items.add( source );
        multipartFiles.put( Parameters.STYLESHEET_SOURCE, items );
        MultipartHttpServletRequest multipart = new MultipartHttpServletRequest( request, multipartFiles, parameters );
        try
        {
            instance.doCreateStyleSheet( multipart );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            assertTrue( StyleSheetHome.getStyleSheetList( 0 ).stream( )
                    .noneMatch( stylesheet -> stylesheet.getDescription( ).equals( randomName ) ) );
        }
        finally
        {
            StyleSheetHome.getStyleSheetList( 0 ).stream( )
                    .filter( stylesheet -> stylesheet.getDescription( ).equals( randomName ) )
                    .forEach( stylesheet -> StyleSheetHome.remove( stylesheet.getId( ) ) );
        }
    }
