public void testDoModifyStyleSheetNoToken( ) throws AccessDeniedException, IOException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Map<String, String[ ]> parameters = new HashMap<>( );
        parameters.put( Parameters.STYLESHEET_ID, new String[ ] { Integer.toString( stylesheet.getId( ) ) } );
        parameters.put( Parameters.STYLESHEET_NAME, new String[ ] { stylesheet.getDescription( ) + "_mod" } );
        parameters.put( Parameters.STYLES, new String[ ] { Integer.toString( stylesheet.getStyleId( ) ) } );
        parameters.put( Parameters.MODE_STYLESHEET, new String[ ] { Integer.toString( stylesheet.getModeId( ) ) } );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );
        List<FileItem> items = new ArrayList<>( );
        FileItem source = new DiskFileItemFactory( ).createItem( Parameters.STYLESHEET_SOURCE, "application/xml", true,
                stylesheet.getDescription( ) );
        source.getOutputStream( ).write( "<a/>".getBytes( ) );
        items.add( source );
        multipartFiles.put( Parameters.STYLESHEET_SOURCE, items );
        MultipartHttpServletRequest multipart = new MultipartHttpServletRequest( request, multipartFiles, parameters );
        try
        {
            instance.doModifyStyleSheet( multipart );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            StyleSheet stored = StyleSheetHome.findByPrimaryKey( stylesheet.getId( ) );
            assertNotNull( stored );
            assertEquals( stylesheet.getDescription( ), stored.getDescription( ) );
        }
    }
