public void testDoReloadProperties( ) throws AccessDeniedException, IOException
    {
        String property = "junit_testDoReloadProperties";
        String propertyValue = getRandomName( );

        File luteceProperties = new File( getResourcesDir( ), "WEB-INF/conf/lutece.properties" );
        Properties props = new Properties( );
        InputStream is = new FileInputStream( luteceProperties );
        props.load( is );
        is.close( );
        props.setProperty( property, propertyValue );

        OutputStream os = new FileOutputStream( luteceProperties );
        props.store( os, "saved for junit " + this.getClass( ).getCanonicalName( ) );
        os.close( );

        assertFalse( propertyValue.equals( AppPropertiesService.getProperty( property ) ) );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        Utils.registerAdminUserWithRigth( request, new AdminUser( ), CacheJspBean.RIGHT_CACHE_MANAGEMENT );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/system/manage_caches.html" ) );

        CacheJspBean instance = new CacheJspBean( );
        instance.doReloadProperties( request );

        assertEquals( propertyValue, AppPropertiesService.getProperty( property ) );
    }
