public void testDoResetCaches( ) throws AccessDeniedException
    {
        CacheListener cacheEventListener = new CacheListener( );
        long registeredListener = CacheService.getCacheableServicesList( ).stream( )
                .filter( service -> service instanceof AbstractCacheableService && service.isCacheEnable( ) )
                .map( service -> ( ( AbstractCacheableService ) service ).getCache( )
                        .getCacheEventNotificationService( ) )
                .peek( rel -> rel.registerListener( cacheEventListener ) ).count( );
        assertFalse( "There should be at least one active AbstractCacheableService", 0 == registeredListener );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Utils.registerAdminUserWithRigth( request, new AdminUser( ), CacheJspBean.RIGHT_CACHE_MANAGEMENT );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, "admin/system/manage_caches.html" ) );
        CacheJspBean.doResetCaches( request );
        assertEquals( "Not all AbstractCacheableService were reset", registeredListener,
                cacheEventListener.getCallCount( ) );
    }
