public void testDoToggleCacheNoToken( ) throws AccessDeniedException
    {
        int cacheIndex = -1;
        for ( CacheableService service : CacheService.getCacheableServicesList( ) )
        {
            cacheIndex++;
            if ( service instanceof AbstractCacheableService )
            {
                break;
            }
        }
        assertFalse( "There should be at least one active AbstractCacheableService", cacheIndex == -1 );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.addParameter( "id_cache", Integer.toString( cacheIndex ) );
        try
        {
            assertTrue( CacheService.getCacheableServicesList( ).get( cacheIndex ).isCacheEnable( ) );
            CacheJspBean.doToggleCache( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            assertTrue( CacheService.getCacheableServicesList( ).get( cacheIndex ).isCacheEnable( ) );
        }
        finally
        {
            CacheService.getCacheableServicesList( ).get( cacheIndex ).enableCache( true );
        }
    }
