public void testDoDaemonActionRunInvalidToken( )
            throws InterruptedException, BrokenBarrierException, TimeoutException, AccessDeniedException
    {
        long lReadyTime;
        long lScheduledTime;
        assertFalse( _entry.isRunning( ) );
        _entry.setInterval( 1000 );

        lReadyTime = System.nanoTime( );
        AppDaemonService.startDaemon( JUNIT_DAEMON ); // Daemon should run
                                                      // periodically with
                                                      // interval of 1000s
        _testDaemon.go( );
        lScheduledTime = System.nanoTime( );
        AppLogService.info( "Daemon scheduled after " + ( ( lScheduledTime - lReadyTime ) / 1000000 ) + " ms" );

        _testDaemon.waitForCompletion( );

        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "action", "RUN" ); // Manually do 1 run of the
                                                 // daemon now
        request.setParameter( "daemon", JUNIT_DAEMON );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_MANAGE_DAEMONS ) + "b" );

        try
        {
            bean.doDaemonAction( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            try
            {
                // Here the daemon should not be run
                _testDaemon.go( 1, TimeUnit.SECONDS );
                fail( "Daemon should not have run" );
            }
            catch ( TimeoutException te )
            {
                // ok
            }
        }
    }
