public void testDoDaemonActionStart( ) throws InterruptedException, BrokenBarrierException, TimeoutException, AccessDeniedException
    {
        long lReadyTime;
        long lScheduledTime;
        assertFalse( _entry.isRunning( ) );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "action", "START" );
        request.setParameter( "daemon", JUNIT_DAEMON );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_MANAGE_DAEMONS ) );
        lReadyTime = System.nanoTime( );
        bean.doDaemonAction( request ); // Daemon should run periodically with interval of 1s

        assertTrue( _entry.isRunning( ) );
        _testDaemon.go( );
        lScheduledTime = System.nanoTime( );
        AppLogService.info( "Daemon scheduled after " + ( ( lScheduledTime - lReadyTime ) / 1000000 ) + " ms" );

        _testDaemon.waitForCompletion( ); // Complete first run without a timeout

        lReadyTime = System.nanoTime( );
        _testDaemon.go( );
        lScheduledTime = System.nanoTime( );
        long lRescheduleDurationMilliseconds = ( ( lScheduledTime - lReadyTime ) / 1000000 );
        long lMarginMilliseconds = 250;
        AppLogService.info( "Daemon scheduled after " + lRescheduleDurationMilliseconds + " ms" );

        _testDaemon.waitForCompletion( ); // Complete second run without a timeout. More runs would follow if we continued

        assertTrue(
                "Daemon should be re-scheduled approximately 1 second after the end of the previous run, but got " + lRescheduleDurationMilliseconds + "ms",
                1000 - lMarginMilliseconds <= lRescheduleDurationMilliseconds && lRescheduleDurationMilliseconds <= 1000 + lMarginMilliseconds );
    }
