public void testDoDaemonActionStartInvalidToken( ) throws InterruptedException, BrokenBarrierException, TimeoutException, AccessDeniedException
    {
        assertFalse( _entry.isRunning( ) );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "action", "START" );
        request.setParameter( "daemon", JUNIT_DAEMON );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_MANAGE_DAEMONS ) + "b" );
        try
        {
            bean.doDaemonAction( request ); // Daemon should run periodically with interval of 1s
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            assertFalse( _entry.isRunning( ) );
            try
            {
                // Here the daemon should not be launched 
                _testDaemon.go( 2500, TimeUnit.MILLISECONDS );
                fail( "Daemon running be should not" );
            }
            catch( TimeoutException te )
            {
                // ok
            }
        }
    }
