public void testDoDaemonActionStop( )
            throws InterruptedException, BrokenBarrierException, TimeoutException, AccessDeniedException
    {
        assertFalse( _entry.isRunning( ) );
        AppDaemonService.startDaemon( JUNIT_DAEMON ); // Daemon should run
                                                      // periodically with
                                                      // interval of 1s
        _testDaemon.go( );
        _testDaemon.waitForCompletion( );
        // We have about 1 second to stop the daemon
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "action", "STOP" );
        request.setParameter( "daemon", JUNIT_DAEMON );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, TEMPLATE_MANAGE_DAEMONS ) );
        bean.doDaemonAction( request );
        assertFalse( _entry.isRunning( ) );
        try
        {
            // Here the daemon should not be relaunched after a 1s interval. So
            // wait 2.5 seconds until a timeout.
            _testDaemon.go( 2500, TimeUnit.MILLISECONDS );
            fail( "Daemon still running after stop" );
        }
        catch ( TimeoutException e )
        {
            // ok
        }
    }
