private MockHttpServletRequest getMultipartRequest( ) throws Exception
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        byte [ ] fileContent = new byte [ ] {
                1, 2, 3
        };
        Part [ ] parts = new Part [ ] {
            new FilePart( "file1", new ByteArrayPartSource( "file1", fileContent ) )
        };
        MultipartRequestEntity multipartRequestEntity = new MultipartRequestEntity( parts, new PostMethod( ).getParams( ) );
        // Serialize request body
        ByteArrayOutputStream requestContent = new ByteArrayOutputStream( );
        multipartRequestEntity.writeRequest( requestContent );
        // Set request body to HTTP servlet request
        request.setContent( requestContent.toByteArray( ) );
        // Set content type to HTTP servlet request (important, includes Mime boundary string)
        request.setContentType( multipartRequestEntity.getContentType( ) );
        request.setMethod( "POST" );
        return request;
    }
