private void doResetPasswordTest( )
    {
        AdminLoginJspBean bean = new AdminLoginJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setMethod( "POST" );
        request.setParameter( Parameters.USER_ID, Integer.toString( user.getUserId( ) ) );
        Date timestamp = new Date( );
        String token = AdminUserService.getUserPasswordResetToken( user, timestamp, request );
        request.setParameter( "ts", Long.toString( timestamp.getTime( ) ) );
        request.setParameter( "token", token );
        request.setParameter( Parameters.NEW_PASSWORD, NEW_PASSWORD );
        request.setParameter( Parameters.CONFIRM_NEW_PASSWORD, NEW_PASSWORD );

        String res = bean.doResetPassword( request );
        assertNotNull( res );
        AdminMessage message = AdminMessageService.getMessage( request );
        assertNotNull( message );
        assertEquals( AdminMessage.TYPE_INFO, message.getType( ) );
        LuteceDefaultAdminUser storedUser = getAdminUserDAO( ).loadDefaultAdminUser( user.getUserId( ) );
        assertNotNull( storedUser );
        assertFalse( storedUser.getPassword( ).check( PASSWORD ) );
        assertTrue( storedUser.getPassword( ).check( NEW_PASSWORD ) );
        List<IPassword> passwordHistory = AdminUserHome.selectUserPasswordHistory( user.getUserId( ) );
        boolean found = false;
        for ( IPassword password : passwordHistory )
        {
            if ( password.check( NEW_PASSWORD ) )
            {
                found = true;
                break;
            }
        }
        assertTrue( found );
    }
