public void testDoChangeFieldAnonymizeAdminUsers( ) throws AccessDeniedException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        Map<String, Boolean> origStatusMap = AdminUserHome.getAnonymizationStatusUserStaticField( );
        try
        {
            for ( Entry<String, Boolean> entry : origStatusMap.entrySet( ) )
            {
                assertTrue( entry.getValue( ) );
            }
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "admin/user/field_anonymize_admin_user.html" ) );
            bean.doChangeFieldAnonymizeAdminUsers( request );
            for ( Entry<String, Boolean> entry : AdminUserHome.getAnonymizationStatusUserStaticField( ).entrySet( ) )
            {
                assertFalse( entry.getValue( ) );
            }
        }
        finally
        {
            for ( Entry<String, Boolean> entry : origStatusMap.entrySet( ) )
            {
                AdminUserHome.updateAnonymizationStatusUserStaticField( entry.getKey( ), entry.getValue( ) );
            }
        }
    }
