public void testDoCreateAdminUser( ) throws PasswordResetException, AccessDeniedException, UserNotSignedException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
        bean.doCreateAdminUser( request );
        AdminMessage message = AdminMessageService.getMessage( request );
        assertNotNull( message );
        assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

        String randomUserName = "User_" + new SecureRandom( ).nextLong( );
        try
        {
            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", "   " );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", "admin" );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.user.accessCodeAlreadyUsed", Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", "admin@lutece.fr" );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.user.accessEmailUsed", Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.addParameter( "user_level", "0" );
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel1AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.USER_ACCESS_DENIED, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.addParameter( "user_level", "0" );
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel0AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.addParameter( "user_level", "0" );
            request.addParameter( "first_password", randomUserName );
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel0AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.differentsPassword", Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.addParameter( "user_level", "0" );
            request.addParameter( "first_password", randomUserName );
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel0AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.differentsPassword", Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            request.addParameter( "access_code", randomUserName );
            request.addParameter( "last_name", randomUserName );
            request.addParameter( "first_name", randomUserName );
            request.addParameter( "email", randomUserName + "@lutece.fr" );
            request.addParameter( "user_level", "0" );
            request.addParameter( "first_password", randomUserName );
            request.addParameter( "second_password", randomUserName );
            request.addParameter( "status", Integer.toString( AdminUser.ACTIVE_CODE ) ); // NPE if absent
            request.addParameter( "language", "fr" ); // NPE if absent
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel0AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/CreateUser.jsp" ) );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            bean.doCreateAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNull( message );
            AdminUser createdUser = AdminUserHome.findUserByLogin( randomUserName );
            assertNotNull( createdUser );
            LuteceDefaultAdminUser createdUserWithPassword = AdminUserHome.findLuteceDefaultAdminUserByPrimaryKey( createdUser.getUserId( ) );
            assertNotNull( createdUserWithPassword );
            assertTrue( createdUserWithPassword.getPassword( ).check( randomUserName ) );
        }
        finally
        {
            AdminUser user = AdminUserHome.findUserByLogin( randomUserName );
            if ( user != null )
            {
                AdminUserHome.remove( user.getUserId( ) );
            }
        }
    }
