public void testDoImportUsersFromFileNoToken( ) throws AccessDeniedException, UserNotSignedException, IOException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = getUserToModify( );
        AdminAuthenticationService.getInstance( ).registerUser( request, user );
        bean.init( request, "CORE_USERS_MANAGEMENT" );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );
        List<FileItem> fileItems = new ArrayList<>( );
        FileItem file = new DiskFileItem( "import_file", "application/csv", true, "junit.csv", 1024, new File( System.getProperty( "java.io.tmpdir" ) ) );
        OutputStreamWriter writer = new OutputStreamWriter( file.getOutputStream( ), Charset.forName( "UTF-8" ) );
        writer.write( "test;test;test;test@test.fr;" + AdminUser.ACTIVE_CODE + ";" + Locale.FRANCE + ";0;false;false;;;" );
        writer.close( );
        fileItems.add( file );
        multipartFiles.put( "import_file", fileItems );
        Map<String, String [ ]> parameters = request.getParameterMap( );
        MultipartHttpServletRequest multipartRequest = new MultipartHttpServletRequest( request, multipartFiles, parameters );
        bean.getImportUsersFromFile( request ); // initialize _importAdminUserService
        AdminUser importedUser = null;
        try
        {
            bean.doImportUsersFromFile( multipartRequest );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            importedUser = AdminUserHome.findUserByLogin( "test" );
            assertNull( importedUser );
        }
        finally
        {
            if ( importedUser != null )
            {
                disposeOfUser( importedUser );
            }
            disposeOfUser( user );
        }
    }
