public void testDoModifyAccountLifeTimeEmails( ) throws AccessDeniedException
    {
        String origEmailSender = AdminUserService.getSecurityParameter( "core.advanced_parameters.first_alert_mail_sender" );
        String origEmailSubject = AdminUserService.getSecurityParameter( "core.advanced_parameters.first_alert_mail_subject" );
        String origEmailBody = DatabaseTemplateService.getTemplateFromKey( "core_first_alert_mail" );
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "email_type", "first" );
        request.setParameter( "email_sender", "junit" );
        request.setParameter( "email_subject", "junit" );
        request.setParameter( "email_body", "junit" );
        request.addParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "ManageAdvancedParameters.jsp" ) );
        try
        {
            bean.doModifyAccountLifeTimeEmails( request );
            assertEquals( "junit", AdminUserService.getSecurityParameter( "core.advanced_parameters.first_alert_mail_sender" ) );
            assertEquals( "junit", AdminUserService.getSecurityParameter( "core.advanced_parameters.first_alert_mail_subject" ) );
            assertEquals( "junit", DatabaseTemplateService.getTemplateFromKey( "core_first_alert_mail" ) );
        }
        finally
        {
            AdminUserService.updateSecurityParameter( "core.advanced_parameters.first_alert_mail_sender", origEmailSender );
            AdminUserService.updateSecurityParameter( "core.advanced_parameters.first_alert_mail_subject", origEmailSubject );
            DatabaseTemplateService.updateTemplate( "core_first_alert_mail", origEmailBody );
        }
    }
