public void testDoModifyAdminUser( ) throws AccessDeniedException, UserNotSignedException
    {
        AdminUser userToModify = getUserToModify( );
        try
        {
            AdminUserJspBean bean = new AdminUserJspBean( );
            MockHttpServletRequest request = new MockHttpServletRequest( );
            request.getSession( true ).setAttribute( "lutece_admin_user", getLevel1AdminUserWithCORE_USERS_MANAGEMENTRight( ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            try
            {
                bean.doModifyAdminUser( request );
                fail( "Should not be able to modify a user with a lower level" );
            }
            catch( AccessDeniedException e )
            {
            }

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            AdminMessage message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            final String modifiedName = userToModify.getAccessCode( ) + "_mod";

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", modifiedName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", modifiedName );
            request.addParameter( "last_name", modifiedName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", modifiedName );
            request.addParameter( "last_name", modifiedName );
            request.addParameter( "first_name", modifiedName );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", modifiedName );
            request.addParameter( "last_name", modifiedName );
            request.addParameter( "first_name", modifiedName );
            request.addParameter( "email", "  " );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( Messages.MANDATORY_FIELDS, Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", "admin" );
            request.addParameter( "last_name", modifiedName );
            request.addParameter( "first_name", modifiedName );
            request.addParameter( "email", modifiedName + "@lutece.fr" );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.user.accessCodeAlreadyUsed", Locale.FRENCH ), message.getText( Locale.FRENCH ) );

            request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, AdminUserHome.findUserByLogin( "admin" ) );
            request.addParameter( "id_user", Integer.toString( userToModify.getUserId( ) ) );
            request.addParameter( "access_code", modifiedName );
            request.addParameter( "last_name", modifiedName );
            request.addParameter( "first_name", modifiedName );
            request.addParameter( "email", "admin@lutece.fr" );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ModifyUser.jsp" ) );
            bean.doModifyAdminUser( request );
            message = AdminMessageService.getMessage( request );
            assertNotNull( message );
            assertEquals( I18nService.getLocalizedString( "portal.users.message.user.accessEmailUsed", Locale.FRENCH ), message.getText( Locale.FRENCH ) );
        }
        finally
        {
            disposeOfUser( userToModify );
        }
    }
