public void testDoModifyAdminUserRights( ) throws AccessDeniedException, UserNotSignedException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = getUserToModify( );
        try
        {
            for ( Right right : RightHome.getRightsList( ) )
            {
                if ( "CORE_USERS_MANAGEMENT".equals( right.getId( ) ) )
                {
                    assertTrue( AdminUserHome.hasRight( user, right.getId( ) ) );
                }
                else
                {
                    assertFalse( AdminUserHome.hasRight( user, right.getId( ) ) );
                }
            }
            AdminAuthenticationService.getInstance( ).registerUser( request, user );
            request.setParameter( "id_user", Integer.toString( user.getUserId( ) ) );
            for ( Right right : RightHome.getRightsList( ) )
            {
                request.addParameter( "right", right.getId( ) );
            }
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ManageUserRights.jsp" ) );
            bean.doModifyAdminUserRights( request );
            assertNull( AdminMessageService.getMessage( request ) );
            AdminUser stored = AdminUserHome.findByPrimaryKey( user.getUserId( ) );
            for ( Right right : RightHome.getRightsList( ) )
            {
                assertTrue( AdminUserHome.hasRight( stored, right.getId( ) ) );
            }
        }
        finally
        {
            disposeOfUser( user );
        }
    }
