public void testDoModifyAdminUserRolesNoToken( ) throws AccessDeniedException, UserNotSignedException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = getUserToModify( );
        try
        {
            for ( Role role : RoleHome.findAll( ) )
            {
                assertFalse( AdminUserHome.hasRole( user, role.getRole( ) ) );
            }
            AdminAuthenticationService.getInstance( ).registerUser( request, user );
            request.setParameter( "id_user", Integer.toString( user.getUserId( ) ) );
            assertFalse( RoleHome.findAll( ).isEmpty( ) );
            for ( Role role : RoleHome.findAll( ) )
            {
                request.addParameter( "roles", role.getRole( ) );
            }
            bean.doModifyAdminUserRoles( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            assertNull( AdminMessageService.getMessage( request ) );
            AdminUser stored = AdminUserHome.findByPrimaryKey( user.getUserId( ) );
            for ( Role role : RoleHome.findAll( ) )
            {
                assertFalse( AdminUserHome.hasRole( stored, role.getRole( ) ) );
            }
        }
        finally
        {
            disposeOfUser( user );
        }
    }
