public void testDoModifyAdminUserWorkgroups( ) throws AccessDeniedException, UserNotSignedException
    {
        AdminUserJspBean bean = new AdminUserJspBean( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = getUserToModify( );
        AdminWorkgroup workgroup = null;
        try
        {
            workgroup = new AdminWorkgroup( );
            workgroup.setKey( user.getAccessCode( ) );
            workgroup.setDescription( user.getAccessCode( ) );
            AdminWorkgroupHome.create( workgroup );
            assertFalse( AdminWorkgroupHome.isUserInWorkgroup( user, workgroup.getKey( ) ) );
            AdminAuthenticationService.getInstance( ).registerUser( request, user );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            request.setParameter( "id_user", Integer.toString( user.getUserId( ) ) );
            request.setParameter( "workgroup", workgroup.getKey( ) );
            request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "jsp/admin/user/ManageUserWorkgroups.jsp" ) );
            bean.doModifyAdminUserWorkgroups( request );
            assertNull( AdminMessageService.getMessage( request ) );
            assertTrue( AdminWorkgroupHome.isUserInWorkgroup( user, workgroup.getKey( ) ) );
        }
        finally
        {
            if ( workgroup != null )
            {
                AdminWorkgroupHome.removeAllUsersForWorkgroup( workgroup.getKey( ) );
                AdminWorkgroupHome.remove( workgroup.getKey( ) );
            }
            disposeOfUser( user );
        }

    }
