public void testDoModifyEmailPatternResetInvalidToken( ) throws PasswordResetException, AccessDeniedException, UserNotSignedException
    {
        String origEmailPattern = getEmailPattern( );
        assertTrue( "plugin-regularexpression is not there", isEmailPatternSetManually( ) );
        AdminUserService.doModifyEmailPattern( origEmailPattern + "b", isEmailPatternSetManually( ) );
        AdminUser user = getUserToModify( );
        try
        {
            assertEquals( origEmailPattern + "b", getEmailPattern( ) );
            AdminUserJspBean bean = new AdminUserJspBean( );
            MockHttpServletRequest request = new MockHttpServletRequest( );
            AdminAuthenticationService.getInstance( ).registerUser( request, user );
            bean.init( request, "CORE_USERS_MANAGEMENT" );
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN,
                    SecurityTokenService.getInstance( ).getToken( request, "ManageAdvancedParameters.jsp" ) + "b" );
            request.setParameter( "reset", "reset" );
            bean.doModifyEmailPattern( request );
            fail( "Should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            assertEquals( origEmailPattern + "b", getEmailPattern( ) );
        }
        finally
        {
            AdminUserService.doModifyEmailPattern( origEmailPattern, isEmailPatternSetManually( ) );
            disposeOfUser( user );
        }
    }
