public void testDoRemoveAdvancedSecurityParametersInvalidToken( ) throws AccessDeniedException
    {
        boolean origUseAdvancedSecurityParameters = AdminUserService.getBooleanSecurityParameter( AdminUserService.DSKEY_USE_ADVANCED_SECURITY_PARAMETERS );
        AdminUserService.updateSecurityParameter( AdminUserService.DSKEY_USE_ADVANCED_SECURITY_PARAMETERS, Boolean.TRUE.toString( ) );
        try
        {
            AdminUserJspBean bean = new AdminUserJspBean( );
            MockHttpServletRequest request = new MockHttpServletRequest( );
            request.addParameter( SecurityTokenService.PARAMETER_TOKEN, SecurityTokenService.getInstance( ).getToken( request, "ManageAdvancedParameters.jsp" )
                    + "b" );
            bean.doRemoveAdvancedSecurityParameters( request );
            fail( "should have thrown" );
        }
        catch( AccessDeniedException e )
        {
            assertTrue( AdminUserService.getBooleanSecurityParameter( AdminUserService.DSKEY_USE_ADVANCED_SECURITY_PARAMETERS ) );
        }
        finally
        {
            if ( origUseAdvancedSecurityParameters )
            {
                AdminUserService.useAdvancedSecurityParameters( );
            }
            else
            {
                AdminUserService.removeAdvancedSecurityParameters( );
            }
        }
    }
