private void testDoModifyAttributeFieldNoToken( IAttribute attribute ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "id_attribute", Integer.toString( attribute.getIdAttribute( ) ) );
        request.setParameter( "id_field",
                Integer.toString( attribute.getListAttributeFields( ).get( 0 ).getIdField( ) ) );
        String strName = getRandomName( );
        request.setParameter( "title", strName );
        request.setParameter( "value", strName );

        try
        {
            instance.doModifyAttributeField( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            IAttribute stored = AttributeService.getInstance( ).getAttributeWithFields( attribute.getIdAttribute( ),
                    Locale.FRANCE );
            assertNotNull( stored );
            assertEquals( 3, stored.getListAttributeFields( ).size( ) );
            assertEquals( 0, stored.getListAttributeFields( ).stream( )
                    .filter( f -> strName.equals( f.getTitle( ) ) && strName.equals( f.getValue( ) ) ).count( ) );
        }
    }
