private void testdoMoveUpAttributeFieldNoToken( IAttribute attribute ) throws AccessDeniedException
    {
        assertTrue( attribute.getListAttributeFields( ).size( ) > 1 );
        AttributeField attributeField = attribute.getListAttributeFields( ).get( 0 );
        int nOrigPosition = attributeField.getPosition( );
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "id_attribute", Integer.toString( attribute.getIdAttribute( ) ) );
        request.setParameter( "id_field", Integer.toString( attributeField.getIdField( ) ) );

        try
        {
            instance.doMoveUpAttributeField( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            IAttribute stored = AttributeService.getInstance( ).getAttributeWithFields( attribute.getIdAttribute( ),
                    Locale.FRANCE );
            assertNotNull( stored );
            AttributeField field = stored.getListAttributeFields( ).stream( )
                    .filter( f -> f.getIdField( ) == attributeField.getIdField( ) ).findFirst( )
                    .orElseThrow( AssertionError::new );
            assertEquals( nOrigPosition, field.getPosition( ) );
        }
    }
