private void testDoCreateAttribute( AttributeType type ) throws PasswordResetException, AccessDeniedException,
            InstantiationException, IllegalAccessException, ClassNotFoundException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        request.setParameter( "attribute_type_class_name", type.getClassName( ) );
        String strTitle = getRandomName( );
        request.setParameter( "title", strTitle );
        request.setParameter( "width", "5" );
        IAttribute attribute = ( IAttribute ) Class.forName( type.getClassName( ) ).newInstance( );
        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, attribute.getTemplateCreateAttribute( ) ) );

        Utils.registerAdminUserWithRigth( request, new AdminUser( ), "CORE_USERS_MANAGEMENT" );
        AttributeJspBean instance = new AttributeJspBean( );
        instance.init( request, "CORE_USERS_MANAGEMENT" );

        try
        {
            instance.doCreateAttribute( request );
            assertTrue( "Did not find attribute of type " + type.getClassName( ),
                    AttributeService.getInstance( ).getAllAttributesWithoutFields( Locale.FRANCE ).stream( )
                            .anyMatch( a -> a.getTitle( ).equals( strTitle ) ) );
        }
        finally
        {
            AttributeService.getInstance( ).getAllAttributesWithoutFields( Locale.FRANCE ).stream( )
                    .filter( a -> a.getTitle( ).equals( strTitle ) )
                    .forEach( a -> AttributeService.getInstance( ).removeAttribute( a.getIdAttribute( ) ) );
        }
    }
