private void testDoModifyAttributeNoToken( AttributeType type ) throws PasswordResetException,
            AccessDeniedException, InstantiationException, IllegalAccessException, ClassNotFoundException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        IAttribute attribute = _attributes.get( type );
        assertNotNull( attribute );
        request.setParameter( "id_attribute", Integer.toString( attribute.getIdAttribute( ) ) );
        String strTitle = getRandomName( );
        request.setParameter( "title", strTitle );
        request.setParameter( "width", "5" );

        Utils.registerAdminUserWithRigth( request, new AdminUser( ), "CORE_USERS_MANAGEMENT" );
        AttributeJspBean instance = new AttributeJspBean( );
        instance.init( request, "CORE_USERS_MANAGEMENT" );

        try
        {
            instance.doModifyAttribute( request );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            IAttribute stored = AttributeService.getInstance( ).getAttributeWithoutFields( attribute.getIdAttribute( ),
                    Locale.FRANCE );
            assertNotNull( stored );
            assertEquals( attribute.getTitle( ), stored.getTitle( ) );
        }
    }
