private void testDoModifyAttribute( AttributeType type ) throws PasswordResetException, AccessDeniedException,
            InstantiationException, IllegalAccessException, ClassNotFoundException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        IAttribute attribute = _attributes.get( type );
        assertNotNull( attribute );
        request.setParameter( "id_attribute", Integer.toString( attribute.getIdAttribute( ) ) );
        String strTitle = getRandomName( );
        request.setParameter( "title", strTitle );
        request.setParameter( "width", "5" );

        request.setParameter( SecurityTokenService.PARAMETER_TOKEN,
                SecurityTokenService.getInstance( ).getToken( request, attribute.getTemplateModifyAttribute( ) ) );

        Utils.registerAdminUserWithRigth( request, new AdminUser( ), "CORE_USERS_MANAGEMENT" );
        AttributeJspBean instance = new AttributeJspBean( );
        instance.init( request, "CORE_USERS_MANAGEMENT" );

        instance.doModifyAttribute( request );
        IAttribute stored = AttributeService.getInstance( ).getAttributeWithoutFields( attribute.getIdAttribute( ),
                Locale.FRANCE );
        assertNotNull( stored );
        assertEquals( strTitle, stored.getTitle( ) );
    }
