public void testGetPageMod( )
    {
        HttpServletRequest request = new MockHttpServletRequest( );

        // determine a random page name
        String randomPageName = "page" + new SecureRandom( ).nextLong( );

        // get the site map
        SiteMapApp instance = new SiteMapApp( );
        XPage sitemap = instance.getPage( request, 0, null );
        assertFalse( "Site map should not contain not yet created page with name " + randomPageName, sitemap.getContent( ).contains( randomPageName ) );

        // create the page
        Page page = new Page( );
        page.setParentPageId( PortalService.getRootPageId( ) );
        page.setPageTemplateId( PageTemplateHome.getPageTemplatesList( ).get( 0 ).getId( ) );
        page.setName( randomPageName );

        IPageService pageService = (IPageService) SpringContextService.getBean( "pageService" );
        pageService.createPage( page );
        // get the site map
        sitemap = instance.getPage( request, 0, null );
        assertTrue( "Site map should contain page with name " + randomPageName, sitemap.getContent( ).contains( randomPageName ) );
        // change the page name
        randomPageName = randomPageName + "_mod";
        page.setName( randomPageName );
        pageService.updatePage( page );
        // get the site map
        sitemap = instance.getPage( request, 0, null );
        assertTrue( "Site map should contain page with the modified name " + randomPageName, sitemap.getContent( ).contains( randomPageName ) );
        // remove the page
        pageService.removePage( page.getId( ) );
        // get the site map
        sitemap = instance.getPage( request, 0, null );
        assertFalse( "Site map should not contain page with name " + randomPageName + " anymore", sitemap.getContent( ).contains( randomPageName ) );
    }
