public void testDoCreateXslExport( ) throws AccessDeniedException, IOException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = new AdminUser( );
        user.setRoles( AdminRoleHome.findAll( ).stream( )
                .collect( Collectors.toMap( AdminRole::getKey, Function.identity( ) ) ) );
        Utils.registerAdminUserWithRigth( request, user, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );
        String randomName = getRandomName( );
        Map<String, String[ ]> parameters = new HashMap<>( );
        parameters.put( "title", new String[ ] { randomName } );
        parameters.put( "description", new String[ ] { randomName } );
        parameters.put( "extension", new String[ ] { randomName } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String[ ] {
                SecurityTokenService.getInstance( ).getToken( request, "admin/xsl/create_xsl_export.html" ) } );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );
        List<FileItem> fileItems = new ArrayList<>( );
        FileItem item = new DiskFileItemFactory( ).createItem( "id_file", "", false, "xsl" );
        item.getOutputStream( ).write( "<?xml version='1.0'?><a/>".getBytes( ) );
        fileItems.add( item );
        multipartFiles.put( "id_file", fileItems );

        _instance.init( request, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );
        try
        {
            _instance.doCreateXslExport( new MultipartHttpServletRequest( request, multipartFiles, parameters ) );
            assertTrue( XslExportHome.getList( ).stream( ).anyMatch( e -> randomName.equals( e.getTitle( ) )
                    && randomName.equals( e.getDescription( ) ) && randomName.equals( e.getExtension( ) ) ) );
        }
        finally
        {
            XslExportHome.getList( ).stream( ).filter( e -> randomName.equals( e.getTitle( ) ) )
                    .forEach( e -> XslExportHome.remove( e.getIdXslExport( ) ) );
        }
    }
