public void testDoModifyXslExport( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = new AdminUser( );
        user.setRoles( AdminRoleHome.findAll( ).stream( )
                .collect( Collectors.toMap( AdminRole::getKey, Function.identity( ) ) ) );
        Utils.registerAdminUserWithRigth( request, user, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );
        String randomName = getRandomName( );
        Map<String, String[ ]> parameters = new HashMap<>( );
        parameters.put( "title", new String[ ] { randomName } );
        parameters.put( "description", new String[ ] { randomName } );
        parameters.put( "extension", new String[ ] { randomName } );
        parameters.put( "id_xsl_export", new String[ ] { Integer.toString( _xslExport.getIdXslExport( ) ) } );
        parameters.put( SecurityTokenService.PARAMETER_TOKEN, new String[ ] {
                SecurityTokenService.getInstance( ).getToken( request, "admin/xsl/modify_xsl_export.html" ) } );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );

        _instance.init( request, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );

        _instance.doModifyXslExport( new MultipartHttpServletRequest( request, multipartFiles, parameters ) );

        XslExport stored = XslExportHome.findByPrimaryKey( _xslExport.getIdXslExport( ) );
        assertNotNull( stored );
        assertEquals( randomName, stored.getTitle( ) );
        assertEquals( randomName, stored.getDescription( ) );
        assertEquals( randomName, stored.getExtension( ) );
    }
