public void testDoModifyXslExportNoToken( ) throws AccessDeniedException
    {
        MockHttpServletRequest request = new MockHttpServletRequest( );
        AdminUser user = new AdminUser( );
        user.setRoles( AdminRoleHome.findAll( ).stream( )
                .collect( Collectors.toMap( AdminRole::getKey, Function.identity( ) ) ) );
        Utils.registerAdminUserWithRigth( request, user, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );
        String randomName = getRandomName( );
        Map<String, String[ ]> parameters = new HashMap<>( );
        parameters.put( "title", new String[ ] { randomName } );
        parameters.put( "description", new String[ ] { randomName } );
        parameters.put( "extension", new String[ ] { randomName } );
        parameters.put( "id_xsl_export", new String[ ] { Integer.toString( _xslExport.getIdXslExport( ) ) } );
        Map<String, List<FileItem>> multipartFiles = new HashMap<>( );

        _instance.init( request, XslExportJspBean.RIGHT_MANAGE_XSL_EXPORT );

        try
        {
            _instance.doModifyXslExport( new MultipartHttpServletRequest( request, multipartFiles, parameters ) );
            fail( "Should have thrown" );
        }
        catch ( AccessDeniedException e )
        {
            XslExport stored = XslExportHome.findByPrimaryKey( _xslExport.getIdXslExport( ) );
            assertNotNull( stored );
            assertEquals( _xslExport.getTitle( ), stored.getTitle( ) );
            assertEquals( _xslExport.getDescription( ), stored.getDescription( ) );
            assertEquals( _xslExport.getExtension( ), stored.getExtension( ) );
        }
    }
