public void testReloadAll( ) throws FileNotFoundException, IOException
    {
        File propsFile = File.createTempFile( "junit", ".properties" );
        propsFile.deleteOnExit( );

        Properties props = new Properties( );
        props.put( "test1", "test1" );
        props.put( "test2", "test2" );

        OutputStream os = new FileOutputStream( propsFile );
        props.store( os, this.getClass( ).getName( ) );
        os.close( );

        PropertiesService instance = new PropertiesService( propsFile.getParent( ) );
        instance.addPropertiesFile( "", propsFile.getName( ) );

        for ( String key : props.stringPropertyNames( ) )
        {
            assertNotNull( instance.getProperty( key ) );
            assertEquals( props.getProperty( key ), instance.getProperty( key ) );
        }

        props.setProperty( "test1", "test1_mod" );
        props.remove( "test2" );
        os = new FileOutputStream( propsFile );
        props.store( os, this.getClass( ).getName( ) );
        os.close( );

        instance.reloadAll( );
        assertEquals( props.getProperty( "test1" ), instance.getProperty( "test1" ) );
        assertNull( instance.getProperty( "test2" ) );
    }
