private void doTest( DAOUtil daoUtil, boolean hasGeneratedKey )
    {
        String key = TESTKEY + new SecureRandom( ).nextLong( );
        try
        {
            daoUtil.setString( 1, key );
            daoUtil.setString( 2, TESTVALUE );
            daoUtil.executeUpdate( );
            if ( hasGeneratedKey )
            {
                // For now let's just test that there is no generated key
                // we don't have a table in the core that is created
                // with a generated key correctly in the different databases
                // With mysql and hsql, the result set is empty.
                // With postgresql, the result set has all the inserted values.
                assertNotNull( "There should be a generatedkey resultset", daoUtil.getGeneratedKeysResultSet( ) );
            }
        }
        finally
        {
            daoUtil.free( );
        }

        DAOUtil daoUtildelete = new DAOUtil( SQL_DELETE );
        try
        {
            daoUtildelete.setString( 1, key );
            daoUtildelete.executeUpdate( );
        }
        finally
        {
            daoUtildelete.free( );
        }
    }
