private LogicFormulaNode negate(LogicFormulaNode n) {
		LogicFormulaNode res;
		switch (n.nodeType) {
		case FALSE:
			return new LogicFormulaNode(LogicFormulaNodeType.TRUE);
		case CONJ:
			res = new LogicFormulaNode(LogicFormulaNodeType.DISJ);
			for (LogicFormulaNode son : n.getSons())
				res.addSon(negate(son));
			return res;
		case DISJ:
			res = new LogicFormulaNode(LogicFormulaNodeType.CONJ);
			for (LogicFormulaNode son : n.getSons())
				res.addSon(negate(son));
			return res;
		case NEG:
			return n.getSons().iterator().next();
		case TERM:
			res = new LogicFormulaNode(LogicFormulaNodeType.NEG);
			res.addSon(n);
			return res;
		case TRUE:
			return new LogicFormulaNode(LogicFormulaNodeType.FALSE);
		}
		throw new IllegalArgumentException();
	}
