private LogicFormulaNode readDisjunction(String s) {
		List<String> items = splitSons(s, '|');
		LogicFormulaNode res = new LogicFormulaNode(LogicFormulaNodeType.DISJ);
		boolean containsFalseNode = false;
		for (String item : items) {
			LogicFormulaNode son = readExpression(item);
			if (son.nodeType == LogicFormulaNodeType.DISJ) {
				res.addAllSons(son.getSons());
				son.removeAllSons();
			} else if (son.nodeType == LogicFormulaNodeType.TRUE) {
				return new LogicFormulaNode(LogicFormulaNodeType.TRUE);
			} else if (son.nodeType == LogicFormulaNodeType.FALSE) {
				containsFalseNode = true;
			} else {
				boolean toAdd = true;
				for (LogicFormulaNode bro : res.getSons()) {
					if (bro.equals(son)) {
						toAdd = false;
						break;
					}
					if ((bro.nodeType == LogicFormulaNodeType.NEG)
							&& (son.nodeType == LogicFormulaNodeType.TERM)
							&& (bro.getSons().iterator().next().equals(son))) {
						return new LogicFormulaNode(LogicFormulaNodeType.TRUE);
					}
					if ((bro.nodeType == LogicFormulaNodeType.TERM)
							&& (son.nodeType == LogicFormulaNodeType.NEG)
							&& (son.getSons().iterator().next().equals(bro))) {
						return new LogicFormulaNode(LogicFormulaNodeType.TRUE);
					}
				}
				if (toAdd)
					res.addSon(son);
			}
		}
		if ((res.getSons().size() == 0) && containsFalseNode) {
			return new LogicFormulaNode(LogicFormulaNodeType.FALSE);
		}
		lookForSubsumedSons(res);
		if (res.getSons().size() == 1) {
			return res.getSons().iterator().next();
		}
		return res;
	}
