public void parsePrices(String file) throws IOException {
		BufferedReader priceReader = new BufferedReader(new FileReader(file));
		String line;
		String[] data;
		int objectivevars = this.constrGroup;
		IVecInt lits = new VecInt();
		IVec<BigInteger> coeffs = new Vec<BigInteger>();
		while ((line = priceReader.readLine()) != null) {
			line = removeComments(line);
			if (line.trim().isEmpty())
				continue;
			data = line.split(";");
			data[0] = normalizeLine(data[0]);
			data[1] = data[1].replace(",", "");
			int newVar = newClausalConstraint(data[0], objectivevars, false);
			lits.push(newVar);
			coeffs.push(new BigInteger(data[1].trim()));
			objectivevars++;
		}
		pbSolver.setObjectiveFunction(new ObjectiveFunction(lits, coeffs));
		priceReader.close();
	}
