private void processWord(IBr4cpBackboneComputer backboneComputer,
			String word) throws TimeoutException {
		this.outStream.println(this.solver.getLogPrefix() + "selected : "
				+ word);
		String assump = word.replaceAll("=", "_");
		Set<String> propagated = backboneComputer.propagatedConfigVars();
		if (propagated.contains(assump)) {
			this.outStream.println("Skipping " + assump);
			return;
		}
		try {
			if (this.varMap.isAdditionalVar(assump)) {
				backboneComputer.addAdditionalVarAssumption(assump);
			} else if (this.varMap.isJokerValuedConfigVar(assump)) {
				backboneComputer.setOptionalConfigVarAsNotInstalled(assump);
			} else if (this.varMap.isConfigVar(assump)) {
				try {
					backboneComputer.addAssumption(assump);
				} catch (ContradictionException e) {
					throw new IllegalArgumentException(e.getMessage());
				}
			} else {
				this.outStream.println(assump + " is not defined");
				return;
			}

			printNewlyAsserted(backboneComputer);
		} catch (IllegalArgumentException e) {
			this.outStream.println("ERROR: " + e.getMessage());
		}
	}
