private void computePropagationsAndReductions(IVecInt backbone) {
		this.propagatedConfigVars = new TreeSet<String>(
				new ConfigVarComparator());
		this.domainReductions = new TreeSet<String>(new ConfigVarComparator());
		this.propagatedAdditionalVars = new TreeSet<String>(
				new ConfigVarComparator());
		this.unavailableAdditionalVars = new TreeSet<String>(
				new ConfigVarComparator());
		for (IteratorInt it = backbone.iterator(); it.hasNext();) {
			int next = it.next();
			if (this.varMap.isAdditionalVar(next)) {
				String name = this.varMap.getConfigVar(Math.abs(next));
				assert name != null;
				if (next < 0) {
					this.unavailableAdditionalVars.add(name);
				} else {
					this.propagatedAdditionalVars.add(name);
				}
			} else if ((next > 0) && this.varMap.isConfigVar(next)) {
				String name = this.varMap.getConfigVar(next);
				int lastDotIndex = name.lastIndexOf('_');
				name = name.substring(0, lastDotIndex) + "="
						+ name.substring(lastDotIndex + 1);
				this.fixedVars.add(name.substring(0, lastDotIndex));
				this.propagatedConfigVars.add(name);
			} else if ((next < 0) && this.varMap.isConfigVar(next)) {
				String name = this.varMap.getConfigVar(-next);
				int lastDotIndex = name.lastIndexOf('_');
				name = name.substring(0, lastDotIndex) + "="
						+ name.substring(lastDotIndex + 1);
				this.domainReductions.add(name);
			}
		}
		for (Iterator<String> it = this.domainReductions.iterator(); it
				.hasNext();) {
			String next = it.next();
			if (this.fixedVars
					.contains(next.substring(0, next.lastIndexOf('=')))) {
				it.remove();
			}
		}
	}
