private Integer processFlatFormula(IGroupSolver solver,
			LogicFormulaNode formula, IVecInt sonsId, int groupId)
			throws ContradictionException {
		if (isTerm(formula)) {
			return getTermId(solver, formula);
		}
		int tseitinVar = solver.nextFreeVarId(true);
		if (formula.getNodeType() == LogicFormulaNodeType.CONJ) {
			IVecInt all = new VecInt();
			all.push(tseitinVar);
			for (IteratorInt it = sonsId.iterator(); it.hasNext();) {
				Integer sonId = it.next();
				all.push(-sonId);
				IVecInt cl = new VecInt(2);
				cl.push(sonId);
				cl.push(-tseitinVar);
				solver.addClause(cl, groupId);
			}
			solver.addClause(all);
			return tseitinVar;
		}
		if (formula.getNodeType() == LogicFormulaNodeType.DISJ) {
			IVecInt all = new VecInt();
			all.push(-tseitinVar);
			for (IteratorInt it = sonsId.iterator(); it.hasNext();) {
				Integer sonId = it.next();
				all.push(sonId);
				IVecInt cl = new VecInt(2);
				cl.push(-sonId);
				cl.push(tseitinVar);
				solver.addClause(cl, groupId);
			}
			solver.addClause(all, groupId);
			return tseitinVar;
		}
		throw new IllegalArgumentException();
	}
