public IBr4cpBackboneComputer getBackboneComputer(ISolver solver,
			ConfigVarMap varMap) {
		try {
			Class<?> backboneComputerClass = Class.forName("org.sat4j.br4cp."
					+ backboneComputer + "Br4cpBackboneComputer");
			Constructor<?> constructor = backboneComputerClass.getConstructor(
					ISolver.class, ConfigVarMap.class);
			return (IBr4cpBackboneComputer) constructor.newInstance(solver,
					varMap);
		} catch (ClassNotFoundException e) {
			throw new IllegalArgumentException(backboneComputer
					+ "Br4cpBackboneComputer is not a valid backbone computer");
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
