protected void displayAnswer() {
        if (this.solver == null) {
            return;
        }
        System.out.flush();
        PrintWriter out = getLogWriter();
        out.flush();
        this.solver.printStat(out, COMMENT_PREFIX);
        this.solver.printInfos(out, COMMENT_PREFIX);
        ExitCode exitCode = getExitCode();
        out.println(ILauncherMode.ANSWER_PREFIX + exitCode);
        if (exitCode == ExitCode.SATISFIABLE
                || exitCode == ExitCode.OPTIMUM_FOUND || this.incomplete
                && exitCode == ExitCode.UPPER_BOUND) {
            if (this.displaySolutionLine) {
                out.print(ILauncherMode.SOLUTION_PREFIX);
                getReader().decode(this.solver.model(), out);
                out.println();
            }
            IOptimizationProblem optproblem = (IOptimizationProblem) this.solver;
            if (!optproblem.hasNoObjectiveFunction()) {
                log("objective function=" + optproblem.getObjectiveValue()); //$NON-NLS-1$
            }
        }
    }
