@Override
    protected void displayResult() {
        if (this.solver != null) {
            double wallclocktime = (System.currentTimeMillis() - this.beginTime)
                    / 1000.0;
            this.solver.printStat(this.out);
            this.solver.printInfos(this.out);
            this.out.println(ILauncherMode.ANSWER_PREFIX + this.getExitCode());
            if (this.getExitCode() == ExitCode.SATISFIABLE) {
                int[] model = this.solver.model();
                this.out.print(ILauncherMode.SOLUTION_PREFIX);
                this.reader.decode(model, this.out);
                this.out.println();
            } else if (this.getExitCode() == ExitCode.UNSATISFIABLE
                    && this.mus != null) {
                this.out.print(ILauncherMode.SOLUTION_PREFIX);
                this.reader.decode(this.mus, this.out);
                this.out.println();
            }
            log("Total wall clock time (in seconds) : " + wallclocktime); //$NON-NLS-1$
        }
    }
