public void displayResult(ISolver solver, IProblem problem, ILogAble logger,
            PrintWriter out, Reader reader, long beginTime,
            boolean displaySolutionLine) {
        if (solver == null) {
            return;
        }
        System.out.flush();
        out.flush();
        solver.printStat(out);
        out.println(ANSWER_PREFIX + exitCode);
        if (exitCode == ExitCode.SATISFIABLE
                || exitCode == ExitCode.OPTIMUM_FOUND
                || isIncomplete && exitCode == ExitCode.UPPER_BOUND) {
            assert this.nbSolutions > 0;
            logger.log("Found " + this.nbSolutions + " solution(s)");

            if (displaySolutionLine) {
                out.print(SOLUTION_PREFIX);
                reader.decode(problem.model(), out);
                out.println();
            }
            IOptimizationProblem optproblem = (IOptimizationProblem) problem;
            if (!optproblem.hasNoObjectiveFunction()) {
                String objvalue;
                if (optproblem instanceof LexicoDecorator<?>) {
                    IVec<Number> values = new Vec<Number>();
                    LexicoDecorator<?> lexico = (LexicoDecorator<?>) optproblem;
                    for (int i = 0; i < lexico.numberOfCriteria(); i++) {
                        values.push(lexico.getObjectiveValue(i));
                    }
                    objvalue = values.toString();

                } else {
                    objvalue = optproblem.getObjectiveValue().toString();
                }
                logger.log("objective function=" + objvalue); //$NON-NLS-1$
            }
        }

        logger.log("Total wall clock time (in seconds): " //$NON-NLS-1$
                + (System.currentTimeMillis() - beginTime) / 1000.0);
        out.flush();
    }
