private static Solver<DataStructureFactory> newBestCurrentSolverConfiguration(
            DataStructureFactory dsf) {
        MiniSATLearning<DataStructureFactory> learning = new MiniSATLearning<DataStructureFactory>();
        Solver<DataStructureFactory> solver = new Solver<DataStructureFactory>(
                learning, dsf,
                new VarOrderHeap(new RSATPhaseSelectionStrategy()),
                new ArminRestarts());
        solver.setSearchParams(new SearchParams(1.1, 100));
        solver.setSimplifier(solver.EXPENSIVE_SIMPLIFICATION);
        return solver;
    }
