public static Constr maxWatchCardNew(UnitPropagationListener s, ILits voc,
            IVecInt ps, boolean moreThan, int degree)
            throws ContradictionException {

        MaxWatchCard outclause = null;

        // La contrainte ne doit pas ?tre vide
        if (ps.size() < degree) {
            throw new ContradictionException(
                    "Creating trivially inconsistent constraint"); //$NON-NLS-1$
        } else if (ps.size() == degree) {
            for (int i = 0; i < ps.size(); i++) {
                if (!s.enqueue(ps.get(i))) {
                    throw new ContradictionException(
                            "Contradiction with implied literal"); //$NON-NLS-1$
                }
            }
            return new UnitClauses(ps);
        }

        // On cree la contrainte
        outclause = new MaxWatchCard(voc, ps, moreThan, degree);

        // Si le degr? est insufisant
        if (outclause.degree <= 0) {
            return null;
        }

        // Si il n'y a aucune chance de satisfaire la contrainte
        if (outclause.watchCumul < outclause.degree) {
            throw new ContradictionException();
        }

        // Si les litt?raux observ?s sont impliqu?s
        if (outclause.watchCumul == outclause.degree) {
            for (int i = 0; i < outclause.lits.length; i++) {
                if (!s.enqueue(outclause.lits[i])) {
                    throw new ContradictionException(
                            "Contradiction with implied literal"); //$NON-NLS-1$
                }
            }
            return null;
        }

        return outclause;
    }
