@Override
    public boolean propagate(UnitPropagationListener s, int p) {
        // we use the same trick as for clauses: we move the variables inside
        // the constraint
        // to keep the two doubly watched literals in front of the constraints
        int tmp, nbSatisfied = 0;
        if (p == lits[0] || LiteralsUtils.neg(p) == lits[0]) {
            tmp = lits[1];
            lits[1] = lits[0];
            lits[0] = tmp;
        }
        if (this.voc.isSatisfied(lits[1])) {
            nbSatisfied = 1;
        }
        // look for new literal to watch and counting satisfied literals
        for (int i = 2; i < lits.length; i++) {
            if (this.voc.isSatisfied(lits[i])) {
                nbSatisfied++;
            } else if (this.voc.isUnassigned(lits[i])) {
                tmp = lits[1];
                lits[1] = lits[i];
                lits[i] = tmp;
                this.voc.watch(lits[1] ^ 1, this);
                this.voc.watch(lits[1], this);
                this.voc.watches(p ^ 1).remove(this);
                return true;
            }
        }
        this.voc.watch(p, this);
        // propagates first watched literal, depending on the number of
        // satisfied literals
        int toPropagate = ((nbSatisfied & 1) == 1) == parity ? lits[0]
                : LiteralsUtils.neg(lits[0]);
        return s.enqueue(toPropagate, this);
    }
