@Override
    public String toString() {
        StringBuilder stb = new StringBuilder();
        for (Field field : SearchParams.class.getDeclaredFields()) {
            if (!field.getName().startsWith("serial")
                    && !field.getName().startsWith("class")) {
                stb.append(field.getName());
                stb.append("="); //$NON-NLS-1$
                try {
                    stb.append(field.get(this));
                } catch (IllegalArgumentException e) {
                    LOGGER.log(Level.INFO,
                            "Issue when reflectively accessing field", e);
                } catch (IllegalAccessException e) {
                    LOGGER.log(Level.INFO,
                            "Access issue when reflectively accessing field",
                            e);
                }
                stb.append(" "); //$NON-NLS-1$
            }
        }
        return stb.toString();
    }
