public final LearnedConstraintsDeletionStrategy fixedSize(
            final int maxsize) {
        return new LearnedConstraintsDeletionStrategy() {

            private static final long serialVersionUID = 1L;
            private final ConflictTimer aTimer = new ConflictTimerAdapter(
                    Solver.this, maxsize) {

                private static final long serialVersionUID = 1L;

                @Override
                public void run() {
                    getSolver().setNeedToReduceDB(true);
                }
            };

            public void reduce(IVec<Constr> learnedConstrs) {
                int i, j, k;
                for (i = j = k = 0; i < Solver.this.learnts.size()
                        && Solver.this.learnts.size() - k > maxsize; i++) {
                    Constr c = Solver.this.learnts.get(i);
                    if (c.locked() || c.size() == 2) {
                        Solver.this.learnts.set(j++,
                                Solver.this.learnts.get(i));
                    } else {
                        c.remove(Solver.this);
                        k++;
                    }
                }
                for (; i < Solver.this.learnts.size(); i++) {
                    Solver.this.learnts.set(j++, Solver.this.learnts.get(i));
                }
                if (Solver.this.verbose) {
                    Solver.this.out.log(getLogPrefix() + "cleaning " //$NON-NLS-1$
                            + (Solver.this.learnts.size() - j)
                            + " clauses out of " + Solver.this.learnts.size()); //$NON-NLS-1$
                    // out.flush();
                }
                Solver.this.learnts.shrinkTo(j);
            }

            public void onConflictAnalysis(Constr reason) {
                // TODO Auto-generated method stub

            }

            public void onClauseLearning(Constr outLearnt) {
                // TODO Auto-generated method stub

            }

            @Override
            public String toString() {
                return "Fixed size (" + maxsize
                        + ") learned constraints deletion strategy";
            }

            public void init() {
            }

            public ConflictTimer getTimer() {
                return this.aTimer;
            }

            public void onPropagation(Constr from) {
                // TODO Auto-generated method stub

            }
        };
    }
