private Lbool search(IVecInt assumps) {
        assert this.rootLevel == decisionLevel();
        this.stats.incStarts();
        int backjumpLevel;

        // varDecay = 1 / params.varDecay;
        this.order.setVarDecay(1 / this.params.getVarDecay());
        this.claDecay = 1 / this.params.getClaDecay();

        do {
            this.slistener.beginLoop();
            // propagate unit clauses and other constraints
            Constr confl = propagate();
            assert this.trail.size() == this.qhead;

            if (confl == null) {
                // No conflict found
                if (decisionLevel() == 0 && this.isDBSimplificationAllowed) {
                    this.stats.incRootSimplifications();
                    boolean ret = simplifyDB();
                    assert ret;
                }
                assert nAssigns() <= this.voc.realnVars();
                if (nAssigns() == this.voc.realnVars()) {
                    modelFound();
                    this.slistener.solutionFound(
                            (this.fullmodel != null) ? this.fullmodel
                                    : this.model,
                            this);
                    if (this.sharedConflict == null) {
                        cancelUntil(this.rootLevel);
                        return Lbool.TRUE;
                    } else {
                        // this.sharedConflict;
                        if (decisionLevel() == rootLevel) {
                            confl = this.sharedConflict;
                            this.sharedConflict = null;
                        } else {
                            int level = this.sharedConflict
                                    .getAssertionLevel(trail, decisionLevel());
                            cancelUntilTrailLevel(level);
                            this.qhead = this.trail.size();
                            this.sharedConflict.assertConstraint(this);
                            this.sharedConflict = null;

                            continue;
                        }
                    }
                } else {
                    if (this.restarter.shouldRestart()) {
                        cancelUntil(this.rootLevel);
                        return Lbool.UNDEFINED;
                    }
                    if (this.needToReduceDB) {
                        reduceDB();
                        this.needToReduceDB = false;
                    }
                    if (this.sharedConflict == null) {
                        // New variable decision
                        this.stats.incDecisions();
                        int p = this.order.select();
                        if (p == ILits.UNDEFINED) {
                            // check (expensive) if all the constraints are not
                            // satisfied
                            boolean allsat = true;
                            for (int i = 0; i < this.constrs.size(); i++) {
                                if (!this.constrs.get(i).isSatisfied()) {
                                    allsat = false;
                                    break;
                                }
                            }
                            if (allsat) {
                                modelFound();
                                this.slistener
                                        .solutionFound((this.fullmodel != null)
                                                ? this.fullmodel
                                                : this.model, this);
                                return Lbool.TRUE;
                            } else {
                                confl = preventTheSameDecisionsToBeMade();
                                this.lastConflictMeansUnsat = false;
                            }
                        } else {
                            assert p > 1;
                            this.slistener.assuming(toDimacs(p));
                            boolean ret = assume(p);
                            assert ret;
                        }
                    } else {
                        confl = this.sharedConflict;
                        this.sharedConflict = null;
                    }
                }
            }
            if (confl != null) {
                // conflict found
                this.stats.incConflicts();
                this.slistener.conflictFound(confl, decisionLevel(),
                        this.trail.size());
                this.conflictCount.newConflict();

                if (decisionLevel() == this.rootLevel) {
                    if (this.lastConflictMeansUnsat) {
                        // conflict at root level, the formula is inconsistent
                        this.unsatExplanationInTermsOfAssumptions = analyzeFinalConflictInTermsOfAssumptions(
                                confl, assumps, ILits.UNDEFINED);
                        return Lbool.FALSE;
                    }
                    return Lbool.UNDEFINED;
                }
                int conflictTrailLevel = this.trail.size();
                // analyze conflict
                try {
                    analyze(confl, this.analysisResult);
                } catch (TimeoutException e) {
                    return Lbool.UNDEFINED;
                }
                assert this.analysisResult
                        .getBacktrackLevel() < decisionLevel();
                backjumpLevel = Math.max(
                        this.analysisResult.getBacktrackLevel(),
                        this.rootLevel);
                this.slistener.backjump(backjumpLevel);
                cancelUntil(backjumpLevel);
                if (backjumpLevel == this.rootLevel) {
                    this.restarter.onBackjumpToRootLevel();
                }
                assert decisionLevel() >= this.rootLevel
                        && decisionLevel() >= this.analysisResult
                                .getBacktrackLevel();
                if (this.analysisResult.getReason() == null) {
                    return Lbool.FALSE;
                }
                record(this.analysisResult.getReason());
                this.restarter.newLearnedClause(this.analysisResult.getReason(),
                        conflictTrailLevel);
                this.analysisResult.setReason(null);
                decayActivities();
            }
        } while (this.undertimeout);
        return Lbool.UNDEFINED; // timeout occured
    }
