@Override
    public void init() {
        int nlength = this.lits.nVars() + 1;
        if (this.activity == null || this.activity.length < nlength) {
            this.activity = new double[nlength];
        }
        this.inSubset = new boolean[nlength];
        this.phaseStrategy.init(nlength);
        this.activity[0] = -1;
        this.heap = new Heap(new ActivityBasedVariableComparator(this.activity));
        this.heap.setBounds(nlength);
        for (int var : this.varsToTest) {
            assert var > 0;
            assert var <= this.lits.nVars() : "" + this.lits.nVars() + "/" + var; //$NON-NLS-1$ //$NON-NLS-2$
            this.inSubset[var] = true;
            this.activity[var] = 0.0;
            if (this.lits.belongsToPool(var)) {
                this.heap.insert(var);
            }
        }
    }
