protected void readConstrs()
            throws IOException, ParseFormatException, ContradictionException {
        int realNbOfConstr = 0;

        this.literals.clear();
        boolean needToContinue = true;

        while (needToContinue) {
            boolean added = false;
            if (this.scanner.eof()) {
                // end of file
                if (this.literals.size() > 0) {
                    // no 0 end the last clause
                    flushConstraint();
                    added = true;
                }
                needToContinue = false;
            } else {
                if (this.scanner.currentChar() == 'c') {
                    // ignore comment line
                    this.scanner.skipRestOfLine();
                    continue;
                }
                if (this.scanner.currentChar() == '%'
                        && this.expectedNbOfConstr == realNbOfConstr) {
                    if (this.solver.isVerbose()) {
                        System.out.println(
                                "Ignoring the rest of the file (SATLIB format");
                    }
                    break;
                }
                added = handleLine();
            }
            if (added) {
                realNbOfConstr++;
            }
        }
        if (this.checkConstrNb && this.expectedNbOfConstr != realNbOfConstr) {
            throw new ParseFormatException(
                    "wrong nbclauses parameter. Found " + realNbOfConstr + ", "
                            + this.expectedNbOfConstr + " expected");
        }
    }
