@Override
    protected boolean handleLine()
            throws ContradictionException, IOException, ParseFormatException {
        int lit;
        boolean added = false;
        String component = this.scanner.next();
        if (!component.startsWith("{") || !component.endsWith("}")) {
            throw new ParseFormatException(
                    "Component index required at the beginning of the clause");
        }
        this.currentComponentIndex = Integer
                .valueOf(component.substring(1, component.length() - 1));
        if (this.currentComponentIndex < 0
                || this.currentComponentIndex > this.numberOfComponents) {
            throw new ParseFormatException(
                    "wrong component index: " + this.currentComponentIndex);
        }
        while (!this.scanner.eof()) {
            lit = this.scanner.nextInt();
            if (lit == 0) {
                if (this.literals.size() > 0) {
                    flushConstraint();
                    this.literals.clear();
                    added = true;
                }
                break;
            }
            this.literals.push(lit);
        }
        return added;
    }
