@Override
    protected void readProblemLine() throws IOException, ParseFormatException {

        String line = this.scanner.nextLine();
        assert line != null;
        line = line.trim();
        String[] tokens = line.split("\\s+");
        if (tokens.length < 5 || !"p".equals(tokens[0])
                || !this.formatString.equals(tokens[1])) {
            throw new ParseFormatException(
                    "problem line expected (p " + this.formatString + " ...)");
        }

        int vars;

        // reads the max var id
        vars = Integer.parseInt(tokens[2]);
        assert vars > 0;
        this.solver.newVar(vars);
        // reads the number of clauses
        this.expectedNbOfConstr = Integer.parseInt(tokens[3]);
        assert this.expectedNbOfConstr > 0;
        this.numberOfComponents = Integer.parseInt(tokens[4]);
        this.solver.setExpectedNumberOfClauses(this.expectedNbOfConstr);
    }
