@Override
    public IProblem parseInstance(String filename)
            throws ParseFormatException, IOException, ContradictionException {
        String fname;
        String prefix = "";

        if (filename.startsWith("http://")) {
            filename = filename.substring(filename.lastIndexOf('/') + 1);
        }
        for (String reservedPrefix : getReservedPrefixes()) {
            if (filename.startsWith(reservedPrefix + ":")) {
                filename = filename.substring(reservedPrefix.length() + 1);
                prefix = reservedPrefix;

            }
        }
        if (filename.endsWith(".gz") || filename.endsWith(".bz2")) {
            fname = filename.substring(0, filename.lastIndexOf('.'));
        } else {
            fname = filename;
        }
        if (this.reader == null) {
            this.reader = handleFileName(fname, prefix);
            this.reader.setUseMapping(this.isUsingMapping());
        }
        return this.reader.parseInstance(filename);
    }
