public static InputStream getInputStreamFromFilename(final String filename)
            throws IOException, MalformedURLException {
        InputStream in;
        if (filename.startsWith("http://")) {
            in = new URL(filename).openStream();
        } else {
            in = new FileInputStream(filename);
        }
        if (filename.endsWith(".gz")) {
            in = new GZIPInputStream(in);
        } else if (filename.endsWith(".bz2")) {
            in.close();
            in = Runtime.getRuntime().exec("bunzip2 -c " + filename)
                    .getInputStream();
        } else if (filename.endsWith(".lzma")) {
            in.close();
            in = Runtime.getRuntime().exec("lzma -d -c " + filename)
                    .getInputStream();
        }
        return in;
    }
