public IProblem parseInstance(final String filename)
            throws ParseFormatException, IOException, ContradictionException {
        InputStream in = null;
        try {
            in = getInputStreamFromFilename(filename);
            IProblem problem;
            problem = parseInstance(in);
            return problem;
        } catch (IllegalStateException e) {
            if (e.getCause() instanceof ContradictionException) {
                throw ((ContradictionException) e.getCause());
            } else {
                throw e;
            }
        } finally {
            if (in != null) {
                in.close();
            }
        }
    }
