public List<IVecInt> computeAllMUSes(IVecInt assumptions,
            SolutionFoundListener listener) {
        if (secondPhaseClauses.isEmpty()) {
            computeAllMSS(assumptions);
        }
        ISolver solver = factory.defaultSolver();
        for (IVecInt v : secondPhaseClauses) {
            try {
                solver.addClause(v);
            } catch (ContradictionException e) {
                return musList;
            }
        }
        AbstractMinimalModel minSolver = new Minimal4InclusionModel(solver,
                Minimal4InclusionModel.positiveLiterals(solver));
        return computeAllMUSes(assumptions, listener, minSolver);
    }
