private List<IVecInt> computeAllMUSes(IVecInt assumptions,
            SolutionFoundListener listener, ISolver minSolver) {
        if (css.isVerbose()) {
            System.out.println(css.getLogPrefix() + "Computing all MUSes ...");
        }
        css.internalState();

        IVecInt mus;

        IVecInt blockingClause;

        try {

            while (minSolver.isSatisfiable(assumptions)) {
                blockingClause = new VecInt();
                mus = new VecInt();

                int[] model = minSolver.model();

                for (int i = 0; i < model.length; i++) {
                    if (model[i] > 0) {
                        blockingClause.push(-model[i]);
                        mus.push(model[i]);
                    }
                }
                musList.add(mus);
                listener.onSolutionFound(mus);
                try {
                    minSolver.addBlockingClause(blockingClause);
                } catch (ContradictionException e) {
                    break;
                }
            }
        } catch (TimeoutException e) {
            Logger.getLogger("org.sat4j.core").log(Level.INFO,
                    "Timeout when computing all muses", e);
        }
        if (css.isVerbose()) {
            System.out.println(css.getLogPrefix() + "... done.");
        }
        css.externalState();
        return musList;
    }
