public boolean checkThatItIsAMUS(IVecInt mus) {
        boolean result = false;

        ISolver solver = factory.defaultSolver();

        try {
            for (int i = 0; i < mus.size(); i++) {
                solver.addClause(clauses.get(mus.get(i) - 1));
            }

            result = !solver.isSatisfiable();

            if (!result) {
                explain = "The set of clauses in the MUS is SAT : "
                        + Arrays.toString(solver.model());
                return result;
            }

        } catch (ContradictionException e) {
            Logger.getLogger("org.sat4j.core").log(Level.INFO,
                    "Trivial inconsistency", e);
            result = true;
        } catch (TimeoutException e) {
            Logger.getLogger("org.sat4j.core").log(Level.INFO,
                    "Timeout when checking unsatisfiability", e);
        }

        try {
            for (int i = 0; i < mus.size(); i++) {
                solver = factory.defaultSolver();
                for (int j = 0; j < mus.size(); j++) {
                    if (j != i) {
                        solver.addClause(clauses.get(mus.get(j) - 1));
                    }
                }
                result = result && solver.isSatisfiable();
                if (!result) {
                    explain = "The subset of clauses in the MUS not containing clause "
                            + (i + 1) + " is SAT : "
                            + Arrays.toString(solver.model());
                    return result;
                }
            }
        } catch (ContradictionException e) {
            Logger.getLogger("org.sat4j.core").log(Level.INFO,
                    "Trivial inconsistency", e);
            result = false;
        } catch (TimeoutException e) {
            Logger.getLogger("org.sat4j.core").log(Level.INFO,
                    "Timeout when checking satisfiability", e);
        }

        return result;

    }
