public IConstr[] ite(int y, int x1, int x2, int x3)
            throws ContradictionException {
        IConstr[] constrs = new IConstr[6];
        IVecInt clause = new VecInt(5);
        // y &lt;=&gt; (x1 -> x2) and (not x1 -> x3)
        // y -> (x1 -> x2) and (not x1 -> x3)
        clause.push(-y).push(-x1).push(x2);
        constrs[0] = processClause(clause);
        clause.clear();
        clause.push(-y).push(x1).push(x3);
        constrs[1] = processClause(clause);
        // y <- (x1 -> x2) and (not x1 -> x3)
        // not(x1 -> x2) or not(not x1 -> x3) or y
        // x1 and not x2 or not x1 and not x3 or y
        // (x1 and not x2) or ((not x1 or y) and (not x3 or y))
        // (x1 or not x1 or y) and (not x2 or not x1 or y) and (x1 or not x3 or
        // y) and (not x2 or not x3 or y)
        // not x1 or not x2 or y and x1 or not x3 or y and not x2 or not x3 or y
        clause.clear();
        clause.push(-x1).push(-x2).push(y);
        constrs[2] = processClause(clause);
        clause.clear();
        clause.push(x1).push(-x3).push(y);
        constrs[3] = processClause(clause);
        clause.clear();
        clause.push(-x2).push(-x3).push(y);
        constrs[4] = processClause(clause);
        // taken from Niklas Een et al SAT 2007 paper
        // Adding the following redundant clause will improve unit propagation
        // y -> x2 or x3
        clause.clear();
        clause.push(-y).push(x2).push(x3);
        constrs[5] = processClause(clause);
        return constrs;
    }
