public void optimisationFunction(IVecInt literals, IVec<BigInteger> coefs,
            IVecInt result) throws ContradictionException {
        IVec<IVecInt> buckets = new Vec<IVecInt>();
        IVecInt bucket;
        // filling the buckets
        for (int i = 0; i < literals.size(); i++) {
            int p = literals.get(i);
            BigInteger a = coefs.get(i);
            for (int j = 0; j < a.bitLength(); j++) {
                bucket = createIfNull(buckets, j);
                if (a.testBit(j)) {
                    bucket.push(p);
                }
            }
        }
        // creating the adder
        int x, y, z;
        int sum, carry;
        for (int i = 0; i < buckets.size(); i++) {
            bucket = buckets.get(i);
            while (bucket.size() >= 3) {
                x = bucket.get(0);
                y = bucket.get(1);
                z = bucket.get(2);
                bucket.remove(x);
                bucket.remove(y);
                bucket.remove(z);
                sum = nextFreeVarId(true);
                carry = nextFreeVarId(true);
                fullAdderSum(sum, x, y, z);
                fullAdderCarry(carry, x, y, z);
                additionalFullAdderConstraints(carry, sum, x, y, z);
                bucket.push(sum);
                createIfNull(buckets, i + 1).push(carry);
            }
            while (bucket.size() == 2) {
                x = bucket.get(0);
                y = bucket.get(1);
                bucket.remove(x);
                bucket.remove(y);
                sum = nextFreeVarId(true);
                carry = nextFreeVarId(true);
                halfAdderSum(sum, x, y);
                halfAdderCarry(carry, x, y);
                bucket.push(sum);
                createIfNull(buckets, i + 1).push(carry);
            }
            assert bucket.size() == 1;
            result.push(bucket.last());
            bucket.pop();
            assert bucket.isEmpty();
        }
    }
