@Override
    public int[] model() {
        int[] prevmodel = null;
        IVecInt vec = new VecInt();
        IVecInt cube = new VecInt();
        IConstr prevConstr = null;
        try {
            do {
                prevfullmodel = super.modelWithInternalVariables();
                prevmodel = super.model();
                modelListener.onSolutionFound(prevmodel);
                vec.clear();
                cube.clear();
                assumps.copyTo(cube);
                for (int q : prevfullmodel) {
                    if (pLiterals.contains(q)) {
                        vec.push(-q);
                    } else if (pLiterals.contains(-q)) {
                        cube.push(q);
                    }
                }
                if (prevConstr != null) {
                    removeSubsumedConstr(prevConstr);
                }
                try {
                    prevConstr = addBlockingClause(vec);
                } catch (ContradictionException e) {
                    // added trivial unsat clauses
                    break;
                }
            } while (isSatisfiable(cube));
        } catch (TimeoutException e) {
            throw new IllegalStateException("Solver timed out");
        }
        return prevmodel;

    }
