@Override
    public final BigInteger countModels() {
        // Trying to compute exactly the number of models.
        int threshold = computeThreshold();
        long initialCount = boundedSAT(threshold);
        if (initialCount < threshold) {
            return BigInteger.valueOf(initialCount);
        }

        // Computing the number of models for t random formulas.
        int iterCount = computeIterCount();
        IVec<BigInteger> counts = new Vec<BigInteger>(iterCount);
        for (int i = 0; i < iterCount; i++) {
            BigInteger count = internalCountModels(threshold);
            if (count != null) {
                counts.push(count);
            }
        }

        // The approximate count is the median of all counts.
        return findMedian(counts);
    }
