@Override
    protected BigInteger internalCountModels(int thresh) {
        // Constraints are generated once and for all for this run.
        generator.generate(samplingSet.nVars());

        // Counting with all parity constraints.
        long count = boundedSAT(thresh);
        generator.deactivate();
        if (count >= thresh) {
            // Reporting a counting error.
            return null;
        }

        // This is equivalent to nConstrPrev = log2(nCells)
        int nConstrPrev = Integer.SIZE - Integer.numberOfLeadingZeros(nCells)
                - 1;

        // Computing the number of models with the optimal set of constraints.
        int nConstr = logSatSearch(thresh, nConstrPrev);
        BigInteger nSols = BigInteger.valueOf(boundedSAT(nConstr, thresh));

        // Forgetting all parity constraints used in this run.
        generator.clear();

        // The number of models needs to be scaled w.r.t. the number of cells.
        return nSols.shiftLeft(nConstr);
    }
