private int logSatSearch(int thresh, int nConstrPrev) {
        int loIndex = 0;
        int hiIndex = samplingSet.nVars() - 1;
        int nConstr = nConstrPrev;
        int[] cells = new int[samplingSet.nVars()];
        Arrays.fill(cells, -1);
        cells[0] = 1;
        cells[samplingSet.nVars() - 1] = 0;

        for (;;) {
            long y = boundedSAT(nConstr, thresh);
            if (y >= thresh) {
                // There are too many constraints.
                if (cells[nConstr + 1] == 0) {
                    return nConstr + 1;
                }
                Arrays.fill(cells, 1, nConstr + 1, 1);
                loIndex = nConstr;
                if (Math.abs(nConstr - nConstrPrev) < 3) {
                    nConstr++;
                } else if ((nConstr << 1) < (samplingSet.nVars() - 1)) {
                    nConstr <<= 1;
                } else {
                    nConstr = (hiIndex + nConstr) >> 1;
                }

            } else {
                // There is enough constraints, but maybe too many.
                if (cells[nConstr - 1] == 1) {
                    return nConstr;
                }
                Arrays.fill(cells, nConstr, samplingSet.nVars(), 0);
                hiIndex = nConstr;
                if (Math.abs(nConstr - nConstrPrev) < 3) {
                    nConstr--;
                } else {
                    nConstr = (nConstr + loIndex) >> 1;
                }
            }
        }
    }
