@Override
    public IConstr addAtMostOne(ISolver solver, IVecInt literals)
            throws ContradictionException {
        ConstrGroup group = new ConstrGroup(false);

        final int n = literals.size();
        final int p = (int) Math.ceil(Math.log(n) / Math.log(2));
        final int k = (int) Math.pow(2, p) - n;

        IVecInt clause = new VecInt();
        String binary = "";

        if (p == 0) {
            return group;
        }

        int y[] = new int[p];
        for (int i = 0; i < p; i++) {
            y[i] = solver.nextFreeVarId(true);
        }

        for (int i = 0; i < k; i++) {
            binary = Integer.toBinaryString(i);
            while (binary.length() != p - 1) {
                binary = "0" + binary;
            }

            for (int j = 0; j < p - 1; j++) {
                clause.push(-literals.get(i));
                if (binary.charAt(j) == '0') {
                    clause.push(-y[j]);
                } else {
                    clause.push(y[j]);
                }
                group.add(solver.addClause(clause));
                clause.clear();

            }
        }

        for (int i = k; i < n; i++) {
            binary = Integer.toBinaryString(2 * k + i - k);
            while (binary.length() != p) {
                binary = "0" + binary;
            }
            for (int j = 0; j < p; j++) {
                clause.push(-literals.get(i));
                if (binary.charAt(j) == '0') {
                    clause.push(-y[j]);
                } else {
                    clause.push(y[j]);
                }
                group.add(solver.addClause(clause));
                clause.clear();
            }

        }

        return group;
    }
