private IConstr addAtMostOne(ISolver solver, IVecInt literals, int groupSize)
            throws ContradictionException {

        ConstrGroup constrGroup = new ConstrGroup(false);

        IVecInt clause = new VecInt();
        IVecInt clause1 = new VecInt();

        final int n = literals.size();

        int nbGroup = (int) Math.ceil((double) literals.size()
                / (double) groupSize);

        if (nbGroup == 1) {
            for (int i = 0; i < literals.size() - 1; i++) {
                for (int j = i + 1; j < literals.size(); j++) {
                    clause.push(-literals.get(i));
                    clause.push(-literals.get(j));
                    constrGroup.add(solver.addClause(clause));
                    clause.clear();
                }
            }
            return constrGroup;
        }

        int[] c = new int[nbGroup];

        for (int i = 0; i < nbGroup; i++) {
            c[i] = solver.nextFreeVarId(true);
        }

        int nbVarLastGroup = n - (nbGroup - 1) * groupSize;

        // Encoding <=1 for each group of groupLitterals
        for (int i = 0; i < nbGroup; i++) {
            int size = 0;
            if (i == nbGroup - 1) {
                size = nbVarLastGroup;
            } else {
                size = groupSize;
            }
            // Encoding <=1 for each group of groupLitterals
            for (int j = 0; j < size - 1; j++) {
                for (int k = j + 1; k < size; k++) {
                    clause.push(-literals.get(i * groupSize + j));
                    clause.push(-literals.get(i * groupSize + k));
                    constrGroup.add(solver.addClause(clause));
                    clause.clear();
                }
            }

            // If a commander variable is true then some variable in its
            // corresponding group must be true (clause1)
            // If a commander variable is false then no variable in its group
            // can be true (clause)
            clause1.push(-c[i]);
            for (int j = 0; j < size; j++) {
                clause1.push(literals.get(i * groupSize + j));
                clause.push(c[i]);
                clause.push(-literals.get(i * groupSize + j));
                constrGroup.add(solver.addClause(clause));
                clause.clear();
            }
            constrGroup.add(solver.addClause(clause1));
            clause1.clear();
        }

        // encode <=1 on commander variables

        constrGroup.add(addAtMostOne(solver, new VecInt(c), groupSize));
        return constrGroup;
    }
