public IConstr addAtMostNonOpt(ISolver solver, IVecInt literals, int k)
            throws ContradictionException {

        ConstrGroup group = new ConstrGroup(false);

        IVecInt clause = new VecInt();

        final int n = literals.size();

        if (k > n) {
            return group;
        }
        if (n == k + 1) {
            for (int i = 0; i < n; i++) {
                clause.push(-literals.get(i));
            }
            group.add(solver.addClause(clause));
            clause.clear();
            return group;
        }
        if (n < 7) {
            Binomial binomial = new Binomial();

            return binomial.addAtMost(solver, literals, k);
        }

        final int p = (int) Math.ceil(Math.pow(n, 1 / (double) (k + 1)));

        int[][] a = new int[n][k + 1];
        int[] result;

        result = decompositionBase10VersBaseP(0, p, k + 1);
        a[0] = result;
        ArrayList<Integer> dejaPris = new ArrayList<Integer>();
        dejaPris.add(0);
        int tmp = 1;
        for (int i = 1; i <= k + 1; i++) {
            a[i] = decompositionBase10VersBaseP(tmp, p, k + 1);
            dejaPris.add(tmp);
            tmp = tmp * p;
        }
        tmp = 2;
        for (int i = k + 2; i < n; i++) {
            while (dejaPris.contains(tmp)) {
                tmp++;
            }
            a[i] = decompositionBase10VersBaseP(tmp, p, k + 1);
            tmp++;
        }

        ArrayList<Integer>[] hashTupleSetTable = new ArrayList[k + 1];

        int[][][] aWithoutD = new int[n][k + 1][k];

        int hash;
        HashMap<Integer, Integer>[] ady = new HashMap[k + 1];
        VecInt[] adxd = new VecInt[k + 1];
        int varId;

        for (int d = 0; d < k + 1; d++) {
            hashTupleSetTable[d] = new ArrayList<Integer>();
            ady[d] = new HashMap<Integer, Integer>();
            adxd[d] = new VecInt();
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < k; j++) {
                    if (j < d) {
                        aWithoutD[i][d][j] = a[i][j];
                    } else {
                        aWithoutD[i][d][j] = a[i][j + 1];
                    }
                }
                hash = recompositionBase10DepuisBaseP(aWithoutD[i][d], p);
                if (!hashTupleSetTable[d].contains(hash)) {
                    hashTupleSetTable[d].add(hash);
                    varId = solver.nextFreeVarId(true);
                    ady[d].put(hash, varId);
                    adxd[d].push(varId);
                }
            }
        }

        for (int d = 0; d < k + 1; d++) {
            for (int i = 0; i < n; i++) {
                clause.push(-literals.get(i));
                clause.push(ady[d].get(recompositionBase10DepuisBaseP(
                        aWithoutD[i][d], p)));
                group.add(solver.addClause(clause));
                clause.clear();
            }
            group.add(addAtMost(solver, adxd[d], k));
        }

        return group;
    }
