@Override
    public IConstr addAtMostOne(ISolver solver, IVecInt literals)
            throws ContradictionException {

        ConstrGroup group = new ConstrGroup(false);

        IVecInt clause = new VecInt();

        final int n = literals.size();

        if (n < 7) {
            Binomial binomial = new Binomial();
            return binomial.addAtMostOne(solver, literals);
        }

        final int p = (int) Math.ceil(Math.sqrt(n));
        final int q = (int) Math.ceil((double) n / (double) p);

        int[] u = new int[p];
        int[] v = new int[q];

        for (int i = 0; i < p; i++) {
            u[i] = solver.nextFreeVarId(true);
        }
        for (int i = 0; i < q; i++) {
            v[i] = solver.nextFreeVarId(true);
        }

        int cpt = 0;
        for (int i = 0; i < p; i++) {
            for (int j = 0; j < q; j++) {
                if (cpt < n) {
                    clause.push(-literals.get(cpt));
                    clause.push(u[i]);
                    group.add(solver.addClause(clause));
                    clause.clear();
                    clause.push(-literals.get(cpt));
                    clause.push(v[j]);
                    group.add(solver.addClause(clause));
                    clause.clear();
                    cpt++;
                }
            }
        }

        group.add(addAtMostOne(solver, new VecInt(u)));
        group.add(addAtMostOne(solver, new VecInt(v)));
        return group;
    }
