private void computeExplanation(ISolver solver, IVecInt encodingAssumptions,
            int start, int end, IVecInt result) throws TimeoutException {
        if (!solver.isSatisfiable(encodingAssumptions)) {
            return;
        }
        int i = start;
        encodingAssumptions.set(i, -encodingAssumptions.get(i));
        assert encodingAssumptions.get(i) < 0;
        while (!this.computationCanceled
                && solver.isSatisfiable(encodingAssumptions)) {
            if (i == end) {
                for (int j = start; j <= end; j++) {
                    encodingAssumptions.set(j, -encodingAssumptions.get(j));
                }
                return;
            }
            i++;
            assert encodingAssumptions.get(i) > 0;
            encodingAssumptions.set(i, -encodingAssumptions.get(i));
        }
        result.push(-encodingAssumptions.get(i));
        if (start == i) {
            return;
        }
        int newend = i - 1;
        int split = (newend + start) / 2;
        if (split < newend) {
            for (int j = split + 1; j < i; j++) {
                encodingAssumptions.set(j, -encodingAssumptions.get(j));
            }
            computeExplanation(solver, encodingAssumptions, split + 1, newend,
                    result);
        }
        if (start <= split) {
            for (int j = start; j <= split; j++) {
                encodingAssumptions.set(j, -encodingAssumptions.get(j));
            }
            computeExplanation(solver, encodingAssumptions, start, split,
                    result);
        }
        if (this.computationCanceled) {
            throw new TimeoutException();
        }
    }
