public IVecInt explain(ISolver solver, Map<Integer, ?> constrs,
            IVecInt assumps) throws TimeoutException {
        this.computationCanceled = false;
        IVecInt encodingAssumptions = new VecInt(
                constrs.size() + assumps.size());
        assumps.copyTo(encodingAssumptions);
        IVecInt firstExplanation = solver.unsatExplanation();
        if (solver.isVerbose()) {
            System.out.print(solver.getLogPrefix() + "initial unsat core ");
            firstExplanation.sort();
            for (IteratorInt it = firstExplanation.iterator(); it.hasNext();) {
                System.out.print(constrs.get(-it.next()));
                System.out.print(" ");
            }
            System.out.println();
        }
        Set<Integer> constraintsVariables = constrs.keySet();
        int p;
        for (int i = 0; i < firstExplanation.size(); i++) {
            if (constraintsVariables.contains(p = -firstExplanation.get(i))) {
                encodingAssumptions.push(p);
            }
        }
        IVecInt results = new VecInt(encodingAssumptions.size());
        computeExplanation(solver, encodingAssumptions, assumps.size(),
                encodingAssumptions.size() - 1, results);
        return results;
    }
