private void computeExplanation(ISolver solver, Map<Integer, ?> constrs,
            IVecInt encodingAssumptions, int start, int end, IVecInt result)
            throws TimeoutException {
        if (solver.isVerbose()) {
            System.out.println(
                    solver.getLogPrefix() + "qxplain " + start + "/" + end);
        }
        if (!solver.isSatisfiable(encodingAssumptions)) {
            return;
        }
        if (start == end) {
            result.push(encodingAssumptions.get(start));
            encodingAssumptions.set(start, -encodingAssumptions.get(start));
            if (solver.isVerbose()) {
                System.out.println(solver.getLogPrefix()
                        + constrs.get(-encodingAssumptions.get(start))
                        + " is mandatory ");
            }
            return;
        }
        int split = (end + start) / 2;
        if (split < end) {
            for (int j = start; j <= split; j++) {
                encodingAssumptions.set(j, -encodingAssumptions.get(j));
            }
            computeExplanation(solver, constrs, encodingAssumptions, split + 1,
                    end, result);
        }
        if (start <= split) {
            for (int j = start; j <= split; j++) {
                encodingAssumptions.set(j, -encodingAssumptions.get(j));
            }
            computeExplanation(solver, constrs, encodingAssumptions, start,
                    split, result);
        }
        if (this.computationCanceled) {
            throw new TimeoutException();
        }
    }
