@Test
    public void testAlmostGlobalInconsistencyII()
            throws ContradictionException, TimeoutException {
        this.solver.newVar(3);
        IVecInt clause = new VecInt();
        clause.push(1).push(2);
        IConstr c1 = this.solver.addClause(clause);
        clause.clear();
        clause.push(1).push(-2);
        IConstr c2 = this.solver.addClause(clause);
        clause.clear();
        clause.push(1).push(3);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(2);
        IConstr c4 = this.solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(-2);
        IConstr c5 = this.solver.addClause(clause);
        clause.clear();
        assertFalse(this.solver.isSatisfiable());
        Collection<IConstr> explanation = this.solver.explain();
        assertEquals(4, explanation.size());
        assertTrue(explanation.contains(c1));
        assertTrue(explanation.contains(c2));
        assertTrue(explanation.contains(c4));
        assertTrue(explanation.contains(c5));
    }
