@Test
    public void testSubModelIterator() throws ContradictionException,
            TimeoutException {
        IVecInt subset = new VecInt(new int[] { 1, 2, 3, 4 });
        ModelIterator iterator = new SubModelIterator(
                SolverFactory.newDefault(), subset);
        iterator.addClause(new VecInt(new int[] { 1, 2 }));
        iterator.addClause(new VecInt(new int[] { -1, -2 }));
        iterator.addClause(new VecInt(new int[] { -3, -4 }));
        iterator.addClause(new VecInt(new int[] { 5, 6 }));
        iterator.addClause(new VecInt(new int[] { -5, -6 }));
        iterator.addClause(new VecInt(new int[] { -1, 3 }));
        int counter = 0;
        int[] sub = new int[0];
        while (iterator.isSatisfiable()) {
            sub = iterator.model();
            counter++;
        }
        assertEquals(4, counter);
        assertEquals(4, sub.length);
    }
