@Test
    public void testNoDeclaredVariables() throws ContradictionException,
            TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        assertEquals(0, solver.nVars());
        assertEquals(0, solver.realNumberOfVariables());
        for (int i = 0; i < 10; i++) {
            solver.nextFreeVarId(true);
        }
        assertEquals(10, solver.nVars());
        assertEquals(10, solver.realNumberOfVariables());
        solver.addClause(new VecInt(new int[] { 1, 2, 3 }));
        int[] model1 = solver.findModel();
        assertEquals(3, model1.length);
        int[] model2 = solver.modelWithInternalVariables();
        assertEquals(3, model2.length);
    }
