@Test
    public void testCardModel() {
        try {
            ISolver solver = new Minimal4CardinalityModel(
                    SolverFactory.newDefault());
            solver.newVar(3);
            IVecInt clause = new VecInt();
            clause.push(1);
            clause.push(-2);
            clause.push(3);
            solver.addClause(clause);
            clause.clear();
            clause.push(-1);
            clause.push(2);
            clause.push(-3);
            solver.addClause(clause);
            int counter = 0;
            int[] model;
            while (solver.isSatisfiable() && counter < 10) {
                model = solver.model();
                assertNotNull(model);
                assertEquals(3, model.length);
                counter++;
            }
            assertEquals(10, counter);
        } catch (ContradictionException e) {
            fail();
        } catch (TimeoutException e) {
            fail();
        }
    }
