@Test
    public void testCleaningBlockingClausesForRomain()
            throws ContradictionException, TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        ModelIterator iterator = new ModelIterator(solver);
        solver.newVar(4);
        solver.addClause(VecInt.of(1, 2, 3, 4));
        while (iterator.isSatisfiable()) {
            iterator.model();
        }
        assertEquals(15, iterator.numberOfModelsFoundSoFar());
        assertFalse(iterator.isSatisfiable());
        iterator.clearBlockingClauses();
        assertEquals(0, iterator.numberOfModelsFoundSoFar());
        while (iterator.isSatisfiable()) {
            iterator.model();
        }
        assertEquals(15, iterator.numberOfModelsFoundSoFar());
    }
