@Test(timeout = 12000)
    public void testGlobalTimeoutIterator() {
        ModelIterator iterator = new ModelIterator(SolverFactory.newDefault());
        IVecInt clause = new VecInt();
        for (int i = 1; i < 100; i++) {
            clause.push(i);
        }
        try {
            iterator.addClause(clause);
            iterator.setTimeout(3);
            int[] model;
            while (iterator.isSatisfiable()) {
                model = iterator.model();
                assertNotNull(model);
                assertEquals(99, model.length);
            }
        } catch (TimeoutException e) {

        } catch (ContradictionException e) {
            fail();
        }
    }
