@Test
    public void testInplicantCoverIterator() {
        try {
            ModelIterator solver = new ModelIterator(
                    SolverFactory.newDefault());
            solver.newVar(3);
            IVecInt clause = new VecInt();
            clause.push(1);
            clause.push(2);
            clause.push(3);
            solver.addClause(clause);
            clause.clear();
            clause.push(-1);
            clause.push(-2);
            clause.push(-3);
            solver.addClause(clause);
            while (solver.isSatisfiable()) {
                int[] prime = solver.primeImplicant();
                System.out.println(Arrays.toString(prime));
            }
            assertEquals(6, solver.numberOfModelsFoundSoFar());
        } catch (ContradictionException e) {
            fail();
        } catch (TimeoutException e) {
            fail();
        }
    }
