@Test
    public void testInternalEnumerationOnExampleFromRomain() {
        try {
            ISolver solver = SolverFactory.newDefault();
            SolutionFoundListener sfl = new SolutionFoundListener() {

                public void onSolutionFound(int[] solution) {
                    // do nothing
                }

                public void onSolutionFound(IVecInt solution) {
                    throw new UnsupportedOperationException(
                            "Not implemented yet!");
                }

                public void onUnsatTermination() {
                    // do nothing
                }

            };
            SearchEnumeratorListener enumerator = new SearchEnumeratorListener(
                    sfl);
            solver.setSearchListener(enumerator);
            solver.newVar(6);
            IVecInt clause = new VecInt();
            clause.push(1).push(3).push(5);
            solver.addClause(clause);
            clause.clear();
            clause.push(1).push(3).push(6);
            solver.addClause(clause);
            clause.clear();
            clause.push(1).push(4).push(5);
            solver.addClause(clause);
            clause.clear();
            clause.push(1).push(4).push(6);
            solver.addClause(clause);
            clause.clear();
            clause.push(2).push(3).push(5);
            solver.addClause(clause);
            clause.clear();
            clause.push(2).push(3).push(6);
            solver.addClause(clause);
            clause.clear();
            clause.push(2).push(4).push(5);
            solver.addClause(clause);
            clause.clear();
            clause.push(2).push(4).push(6);
            solver.addClause(clause);
            clause.clear();
            assertTrue(solver.isSatisfiable());
            assertEquals(37, enumerator.getNumberOfSolutionFound());
        } catch (ContradictionException e) {
            fail();
        } catch (TimeoutException e) {
            fail();
        }
    }
