@Test
    public void checkItWorksAfterRunningTheSolver()
            throws ContradictionException, TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        ConstrGroup g1 = new ConstrGroup();

        IVecInt clause = new VecInt(new int[] { 1 });
        solver.addClause(clause);

        // starting group
        clause.clear();
        clause.push(-1).push(-2).push(-3);
        g1.add(solver.addClause(clause));

        clause.clear();
        clause.push(-1).push(2).push(-3);
        g1.add(solver.addClause(clause));
        assertEquals(3, solver.nConstraints());
        assertTrue(solver.isSatisfiable());
        assertTrue(solver.model(1));
        assertFalse(solver.model(3));
        g1.removeFrom(solver);
        assertEquals(1, solver.nConstraints());
    }
