@Test
    public void checkTheExpectedWayToDealWithUnitClausesToRemove()
            throws ContradictionException, TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        ConstrGroup g1 = new ConstrGroup();

        IVecInt clause = new VecInt(new int[] { 1 });
        solver.addClause(clause);

        // starting group
        clause.clear();
        clause.push(2).push(-3);
        g1.add(solver.addClause(clause));

        clause.clear();
        clause.push(-2).push(4);
        g1.add(solver.addClause(clause));

        IVecInt unitClauses = new VecInt(new int[] { 3, -4 });

        assertFalse(solver.isSatisfiable(unitClauses));

        g1.removeFrom(solver);
        assertTrue(solver.isSatisfiable(unitClauses));
    }
