@Test
    public void testIterativeAssumptionCallsWithSet()
            throws FileNotFoundException, ParseFormatException, IOException,
            ContradictionException, TimeoutException {
        ISolver satSolver = SolverFactory.newDefault();
        Reader reader = new LecteurDimacs(satSolver);
        IProblem p = reader.parseInstance("src/test/testfiles/Eshop-fm.dimacs");

        List<Integer> vars = new ArrayList<Integer>();
        for (int i = 1; i <= p.nVars(); i++) {
            vars.add(-i);
            vars.add(i);
        }

        Set<Integer> sol = new HashSet<Integer>();

        for (int i = 0; i < vars.size(); i++) {
            ISolver satSolverOracle = SolverFactory.newDefault();
            Reader readerOracle = new LecteurDimacs(satSolverOracle);
            readerOracle.parseInstance("src/test/testfiles/Eshop-fm.dimacs");

            int varnr = vars.get(i);

            int assumpsArray[] = new int[sol.size() + 1];
            int c = 0;
            for (int a : sol) {
                assumpsArray[c] = a;
                c++;
            }
            assumpsArray[assumpsArray.length - 1] = varnr;
            IVecInt assumps = new VecInt(assumpsArray);
            // Check
            if (satSolver.isSatisfiable(assumps)) {
                sol.add(varnr);
            }

            assertEquals(satSolverOracle.isSatisfiable(assumps),
                    satSolver.isSatisfiable(assumps));
        }
    }
