@Test
    public void testIterativeCorrectWay() throws FileNotFoundException,
            ParseFormatException, IOException, ContradictionException,
            TimeoutException {
        ISolver satSolver = SolverFactory.newDefault();
        Reader reader = new LecteurDimacs(satSolver);
        IProblem p = reader.parseInstance("src/test/testfiles/Eshop-fm.dimacs");

        Set<Integer> sol = new HashSet<Integer>();

        for (int i = 1; i <= p.nVars(); i++) {
            ISolver satSolverOracle = SolverFactory.newDefault();
            Reader readerOracle = new LecteurDimacs(satSolverOracle);
            readerOracle.parseInstance("src/test/testfiles/Eshop-fm.dimacs");

            int assumpsArray[] = new int[sol.size() + 1];
            int c = 0;
            for (int a : sol) {
                assumpsArray[c] = a;
                c++;
            }
            assumpsArray[assumpsArray.length - 1] = -i;
            IVecInt assumps = new VecInt(assumpsArray);

            // Check
            assertEquals(satSolverOracle.isSatisfiable(assumps),
                    satSolver.isSatisfiable(assumps));
            if (satSolver.isSatisfiable(assumps)) {
                sol.add(-i);
                continue;
            }
            assumpsArray[assumpsArray.length - 1] = i;
            satSolverOracle = SolverFactory.newDefault();
            readerOracle = new LecteurDimacs(satSolverOracle);
            readerOracle.parseInstance("src/test/testfiles/Eshop-fm.dimacs");
            assertEquals(satSolverOracle.isSatisfiable(assumps),
                    satSolver.isSatisfiable(assumps));
            if (satSolver.isSatisfiable(assumps)) {
                sol.add(i);
            }
        }
    }
