public void testRemoveConstraints() throws TimeoutException {
        try {
            this.solver.newVar(3);
            assertEquals(0, this.solver.nConstraints());
            IVecInt vec = new VecInt();
            vec.push(1).push(-2);
            IConstr c = this.solver.addClause(vec);
            assertNotNull(c);
            assertEquals(1, this.solver.nConstraints());
            vec.clear();
            vec.push(-1).push(-2);
            c = this.solver.addClause(vec);
            assertNotNull(c);
            assertEquals(2, this.solver.nConstraints());
            vec.clear();
            vec.push(-1).push(2);
            this.solver.addClause(vec);
            // assertNotNull(c);
            assertEquals(3, this.solver.nConstraints());
            vec.clear();
            vec.push(1).push(2);
            this.solver.addClause(vec);
            assertEquals(4, this.solver.nConstraints());
            // assertNotNull(c);
            assertFalse(this.solver.isSatisfiable());
            this.solver.removeConstr(c);
            assertEquals(3, this.solver.nConstraints());
            assertTrue(this.solver.isSatisfiable());
            assertEquals(1, this.solver.model()[0]);
            assertEquals(2, this.solver.model()[1]);
            vec.clear();
            vec.push(-1).push(-2);
            try {
                c = this.solver.addClause(vec);
                assertNotNull(c);
                assertEquals(4, this.solver.nConstraints());
                assertFalse(this.solver.isSatisfiable());
            } catch (ContradictionException ce) {
                // its fine
            }
        } catch (ContradictionException e) {
            fail();
        }
    }
