@Test
    public void checkNumberOfSolutionWithClauses()
            throws TimeoutException, ContradictionException {
        solver.newVar(3);
        IVecInt lits = new VecInt(new int[] { 1, 2, 3 });
        solver.addParity(lits, true);
        IVecInt clause = new VecInt(new int[] { 1, 2, 3 });
        solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(-3);
        solver.addClause(clause);
        ModelIterator iterator = new ModelIterator(solver);
        while (iterator.isSatisfiable()) {
            iterator.model(); // to go to the next model
        }
        assertEquals(2, iterator.numberOfModelsFoundSoFar());
        System.out.println(new VecInt(solver.model()));
    }
