@Test
    public void testMaxSAtIterator() throws ContradictionException,
            TimeoutException {
        ISolver solver = new ModelIterator(new OptToSatAdapter(
                new MaxSatDecorator(SolverFactory.newDefault())));
        solver.newVar(2);
        IVecInt literals = new VecInt();
        literals.push(-1).push(-2);
        solver.addClause(literals);
        literals.clear();
        literals.push(-1).push(2);
        solver.addClause(literals);
        literals.clear();
        literals.push(1).push(-2);
        solver.addClause(literals);
        literals.clear();
        literals.push(1).push(2);
        solver.addClause(literals);
        assertTrue(solver.isSatisfiable());
        assertEquals(2, solver.model().length);
        System.out.println("" + solver.model(1) + solver.model(2));
        assertTrue(solver.isSatisfiable());
        assertEquals(2, solver.model().length);
        System.out.println("" + solver.model(1) + solver.model(2));
        assertTrue(solver.isSatisfiable());
        assertEquals(2, solver.model().length);
        System.out.println("" + solver.model(1) + solver.model(2));
        assertTrue(solver.isSatisfiable());
        assertEquals(2, solver.model().length);
        System.out.println("" + solver.model(1) + solver.model(2));
        assertFalse(solver.isSatisfiable());
    }
