@Test
    public void testBinaryClauseInFormula() throws ContradictionException,
            TimeoutException {
        final ISolver solver = SolverFactory.newDefault();
        solver.addClause(new VecInt(new int[] { 1, 2 }));
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { -1, -2 })));
        IVecInt explanation = solver.unsatExplanation();
        assertTrue(explanation.contains(-1));
        assertTrue(explanation.contains(-2));
        assertEquals(2, explanation.size());
    }
