@Test
    public void testInconsistencyInAssumption() throws ContradictionException,
            TimeoutException {
        final ISolver solver = SolverFactory.newDefault();
        solver.newVar(3);
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { -1, 2, 3, 1 })));
        IVecInt explanation = solver.unsatExplanation();
        assertTrue(explanation.contains(-1));
        assertTrue(explanation.contains(1));
        assertEquals(2, explanation.size());
    }
