@Test
    public void testFilter() throws ContradictionException, TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3);
        solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(2).push(3);
        solver.addClause(clause);
        clause.clear();
        clause.push(1).push(-2);
        solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(-2);
        solver.addClause(clause);
        clause.clear();
        IVecInt filter = new VecInt(new int[] { 1, 2 });
        IVecInt backbone = Backbone.instance().compute(solver, VecInt.EMPTY,
                filter);
        assertEquals(1, backbone.size());
        assertTrue(backbone.contains(-2));
        assertFalse(backbone.contains(3));
        backbone = Backbone.instance().compute(solver);
        assertEquals(2, backbone.size());
        assertTrue(backbone.contains(-2));
        assertTrue(backbone.contains(3));
    }
