@Test
    public void testStateOfSolverAfterBackboneComputationWithIBB()
            throws ContradictionException, TimeoutException {
        ISolver solver = SolverFactory.newDefault();
        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3).push(4);
        solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(-2);
        solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(2);
        solver.addClause(clause);
        clause.clear();
        clause.push(1).push(2);
        solver.addClause(clause);
        clause.clear();
        IVecInt backbone = Backbone.ibb().compute(solver);
        assertEquals(2, backbone.size());
        assertTrue(backbone.contains(-1));
        assertTrue(backbone.contains(2));
        ModelIterator iterator = new ModelIterator(solver);
        while (iterator.isSatisfiable()) {
            iterator.model();
        }
        assertEquals(4, iterator.realNumberOfVariables());
        assertEquals(4, iterator.numberOfModelsFoundSoFar());
    }
