@Test
    public void testSimpleCase() {
        IVecInt c1 = new VecInt();
        IVecInt c2 = new VecInt();
        IVecInt c3 = new VecInt();
        IVecInt c4 = new VecInt();
        IVecInt c5 = new VecInt();
        IVecInt c6 = new VecInt();
        IVecInt c7 = new VecInt();

        // a=1, b=2, c=3, d=4

        // a & c
        c1.push(1);
        c2.push(3);

        // b & c
        c3.push(2);
        c4.push(3);

        // b & d
        c5.push(2);
        c6.push(4);

        // -a | -b
        c7.push(-1).push(-2);

        this.solver.newVar(4);

        try {
            this.solver.addClause(c1, 1);
            this.solver.addClause(c2, 1);
            this.solver.addClause(c3, 2);
            this.solver.addClause(c4, 2);
            this.solver.addClause(c5, 3);
            this.solver.addClause(c6, 3);
            this.solver.addClause(c7, 0);

            List<IVecInt> muses = allMUSes.computeAllMUSes();

            List<IVecInt> msses = allMUSes.getMssList();

            System.out
                    .println("MSS should be {b & c , b & d} and {a & c} i.e. {2,3} and {1}");
            System.out.println("MSS = " + msses);

            System.out
                    .println("MUS should be {a & c, b & c} and {a & c, b & d} i.e. {1,2} and {1,3}");
            System.out.println("MUS = " + muses);

            assertEquals(msses.size(), 2);

        } catch (ContradictionException e) {
            e.printStackTrace();
        }

    }
