@Test
    public void testAtLeast2() throws ContradictionException, TimeoutException {

        this.solver.newVar(5);

        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3).push(4).push(5);

        IConstr constr = this.solver.addAtLeast(clause, 2);
        assertNotNull(constr);

        if (MODE_DEBUG) {
            System.out.println();
            System.out.println("testCommanderAtLeast2");
            if (constr instanceof ConstrGroup) {
                for (int i = 0; i < constr.size(); i++) {

                    System.out.println(((ConstrGroup) constr).getConstr(i));

                }
            } else {
                System.out.println(constr);
            }
        }

        ModelIterator iterator = new ModelIterator(this.solver);
        int[] model = null;
        int cpt = 0;

        if (MODE_DEBUG)
            System.out.println("testCommanderAtLeast2 models");
        while (iterator.isSatisfiable()) {
            model = iterator.model();
            assertNotNull(model);
            if (MODE_DEBUG)
                System.out.println(new VecInt(model));
            cpt++;
        }
        assertEquals(26, cpt);
    }
