@Test
    public void testAtMostOneWith8Vars() throws ContradictionException,
            TimeoutException {

        this.solver.newVar(8);

        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3).push(4).push(5).push(6).push(7).push(8);

        IConstr constr = this.solver.addAtMost(clause, 1);
        assertNotNull(constr);

        if (MODE_DEBUG) {
            System.out.println();
            System.out.println("testLadderAtMostOneWith8Vars");
            for (int i = 0; i < constr.size(); i++) {
                System.out.println(((ConstrGroup) constr).getConstr(i));
            }
        }

        ModelIterator iterator = new ModelIterator(this.solver);
        int[] model = null;
        int cpt = 0;

        if (MODE_DEBUG)
            System.out.println("testLadderAtMostOneWith8Vars models");
        while (iterator.isSatisfiable()) {
            model = iterator.model();
            assertNotNull(model);
            if (MODE_DEBUG)
                System.out.println(new VecInt(model));
            cpt++;
        }
        assertEquals(9, cpt);
    }
