@Test
    public void testExactly4With11Vars() throws ContradictionException,
            TimeoutException {

        int nVar = 11;
        this.solver.newVar(nVar);

        int degree = 4;

        IVecInt clause = new VecInt();
        for (int i = 1; i <= nVar; i++) {
            clause.push(i);
        }

        IConstr constr = this.solver.addExactly(clause, degree);
        assertNotNull(constr);

        if (MODE_DEBUG) {
            System.out.println();
            System.out.println("testExactly4With11Vars");
            for (int i = 0; i < constr.size(); i++) {
                System.out.println(((ConstrGroup) constr).getConstr(i));
            }
        }

        ModelIterator iterator = new ModelIterator(this.solver);
        int[] model = null;
        int cpt = 0;

        if (MODE_DEBUG)
            System.out.println("testExactly4With11Vars models");
        while (iterator.isSatisfiable()) {
            model = iterator.model();
            assertNotNull(model);
            if (MODE_DEBUG)
                System.out.println(new VecInt(model));
            cpt++;
        }
        assertEquals(330, cpt);
    }
