private int checkModelCount() {
        // The theoretical lower bound for the confidence interval.
        BigDecimal lower = new BigDecimal(realCount)
                .multiply(BigDecimal.valueOf(1 / (1 + EPSILON_TEST)));

        // The theoretical upper bound for the confidence interval.
        BigDecimal upper = new BigDecimal(realCount)
                .multiply(BigDecimal.valueOf(1 + EPSILON_TEST));

        // Counting the models.
        int nbInExpectedBounds = 0;
        AbstractApproxMC counter = createCounter();
        for (int i = 0; i < NUMBER_OF_TRIES; i++) {
            BigDecimal nbSolutions = new BigDecimal(counter.countModels());
            if (lower.compareTo(nbSolutions) <= 0
                    && nbSolutions.compareTo(upper) <= 0) {
                // The estimate count is within the theoretical bounds.
                nbInExpectedBounds++;
            }
        }

        // To be correct, we need to find a count within the bounds matching the
        // expected probability.
        return nbInExpectedBounds;
    }
