private void createStructuralConstraints(int n) throws ContradictionException {
		int nbconstrs = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				helper.clause("Completeness", prefers(i, j), indif(i, j), prefers(j, i));
				helper.clause("Assymetry", neg(prefers(i, j)), neg(prefers(j, i)));
				helper.clause("Exclusivity", neg(prefers(i, j)), neg(indif(i, j)));
				helper.clause("Exclusivity", neg(prefers(j, i)), neg(indif(i, j)));
				nbconstrs += 4;
			}
			helper.setTrue(indif(i, i), "Reflexivity");
			nbconstrs++;
		}
		System.out.printf("Created %d constraints without Ferrer condition\n", nbconstrs);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int k = 0; k < n; k++) {
					for (int l = 0; l < n; l++) {
						if (i != j && k != l && i != l && j != l && i != k) {
							helper.implication(prefers(i, j), indif(j, k), prefers(k, l)).implies(prefers(i, l))
									.named("Ferrers");
							nbconstrs++;
						}

					}
				}
			}
		}
		System.out.printf("Created %d hard constraints\n", nbconstrs);
	}
