@SuppressWarnings("nls")
    private Options createCLIOptions() {
        Options options = new Options();
        options.addOption("s", "solver", true,
                "specifies the name of a PB solver");
        options.addOption("t", "timeout", true,
                "specifies the timeout (in seconds)");
        options.addOption("p", "parallel", false,
                "uses CP and RES pseudo-boolean solvers in parallel");
        options.addOption("T", "timeoutms", true,
                "specifies the timeout (in milliseconds)");
        options.addOption("K", "kind", true,
                "kind of problem: minone, maxsat, etc.");
        options.addOption("i", "incomplete", false,
                "incomplete mode for maxsat");
        options.addOption("I", "inner mode", false,
                "optimize using inner mode");
        options.addOption("c", "clean databases", false,
                "clean up the database at root level");
        options.addOption("k", "keep Hot", false,
                "Keep heuristics accross calls to the SAT solver");
        options.addOption("e", "equivalence", false,
                "Use an equivalence instead of an implication for the selector variables");
        options.addOption("pi", "prime-implicant", false,
                "Use prime implicants instead of models for evaluating the objective function");
        options.addOption("n", "no solution line", false,
                "Do not display a solution line (useful if the solution is large)");
        options.addOption("l", "lower bounding", false,
                "search solution by lower bounding instead of by upper bounding");
        options.addOption("hs", "MaxHS Like", false,
                "search solution using a MaxHS like approach");
        options.addOption("m", "mystery", false, "mystery option");
        options.addOption("B", "External&Internal", false,
                "External&Internal optimization");
        return options;
    }
