public IConstr addSoftAtMost(BigInteger weight, IVecInt literals, int degree)
            throws ContradictionException {
        checkMaxVarId();
        if (weight.compareTo(this.top) < 0) {
            this.coefs.push(weight);
            int newvar = nextFreeVarId(true);
            this.lits.push(newvar);
            IVec<BigInteger> cardcoeffs = new Vec<BigInteger>(
                    literals.size() + 1);
            cardcoeffs.growTo(literals.size(), BigInteger.ONE);
            literals.push(newvar);
            BigInteger bigDegree = BigInteger.valueOf(degree);
            cardcoeffs.push(bigDegree.negate());
            return addPseudoBoolean(literals, cardcoeffs, true, bigDegree);
        } else {
            return addAtMost(literals, degree);
        }
    }
