private void testProblemWithExpectedAnswer(String filename,
             int expectedValue) {
        try {
            IProblem problem = this.reader.parseInstance(System.getProperty("test.prefix")+filename);
            assertNotNull(problem);
            IOptimizationProblem optproblem = new PseudoOptDecorator(
                    this.maxsat);
            IProblem satproblem = new OptToSatAdapter(optproblem);
            assertTrue(satproblem.isSatisfiable());
            int[] model = satproblem.model();
            assertNotNull(model);
            assertEquals(expectedValue, optproblem.getObjectiveValue()
                    .intValue());

        } catch (Exception e) {
            fail(" Problem when reading instance : " + e);
        }
    }
