@Test
    public void testTwoSatisfiedConstraintImplicant() throws TimeoutException, ContradictionException {
        WeightedMaxSatDecorator wms = new WeightedMaxSatDecorator(SolverFactory.newDefault());
        wms.newVar(2);
        wms.setExpectedNumberOfClauses(4);
        IVecInt clause = new VecInt().push(-1).push(1);
        wms.addSoftClause(clause);
        clause.clear();
        clause.push(2).push(-2);
        wms.addSoftClause(clause);
        clause.clear();
        clause.push(2);
        wms.addSoftClause(clause);
        clause.clear();
        clause.push(-2);
        wms.addSoftClause(clause);
        OptToPBSATAdapter problem = new OptToPBSATAdapter(new PseudoOptDecorator(wms,false,true));
        assertTrue(problem.isSatisfiable());
        assertEquals(BigInteger.ONE,problem.getCurrentObjectiveValue());
    }
