@Test
    public void testMichalWithOptAdapter() throws ContradictionException,
            TimeoutException {
        WeightedMaxSatDecorator maxSATSolver = new WeightedMaxSatDecorator(
                SolverFactory.newLight());

        maxSATSolver.newVar(2);
        maxSATSolver.setExpectedNumberOfClauses(4);

        int[] clause_1 = { 1, 2 };
        maxSATSolver.addSoftClause(1,new VecInt(clause_1));

        int[] clause_2 = { -1, -2 };
        maxSATSolver.addSoftClause(100,new VecInt(clause_2));

        int[] clause_3 = { 1, -2 };
        maxSATSolver.addSoftClause(100,new VecInt(clause_3));

        int[] clause_4 = { -1, 2 };
        maxSATSolver.addSoftClause(100000, new VecInt(clause_4));

        IProblem problem = new OptToSatAdapter(new PseudoOptDecorator(
                maxSATSolver));

        boolean isSatisfiable = problem.isSatisfiable();

        assertEquals(true, isSatisfiable);
        int[] model = problem.model();
        assertEquals(2, model.length);
        assertEquals(-1, model[0]);
        assertEquals(-2, model[1]);
    }
