@Test
    public void testExampleDavid() throws ContradictionException,
            TimeoutException {
        WeightedMaxSatDecorator maxsat = new WeightedMaxSatDecorator(
                SolverFactory.newLight());
        maxsat.newVar(3);
        IVecInt literals = new VecInt();
        literals.push(1).push(-2).push(3);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(-1).push(-2);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(1).push(2).push(3);
        maxsat.addLiteralsToMinimize(literals);
        OptToPBSATAdapter opt = new OptToPBSATAdapter(new PseudoOptDecorator(
                maxsat));
        assertTrue(opt.isSatisfiable());
        assertFalse(opt.model(1));
        assertFalse(opt.model(2));
        assertFalse(opt.model(3));
    }
