@Test
    public void testMaxsat() throws ContradictionException, TimeoutException {
        MaxSatDecorator maxsat = new MaxSatDecorator(SolverFactory.newLight());
        maxsat.newVar(3);
        IVecInt literals = new VecInt();
        literals.push(1).push(-2).push(3);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(-1).push(-2);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(2);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(-3);
        maxsat.addClause(literals);
        OptToSatAdapter opt = new OptToSatAdapter(maxsat);
        assertTrue(opt.isSatisfiable());
        assertEquals(1, maxsat.calculateObjective());
    }
