@Test
    public void testMaxsatBis() throws ContradictionException, TimeoutException {
        MaxSatDecorator maxsat = new MaxSatDecorator(SolverFactory.newLight());
        maxsat.newVar(3);
        IVecInt literals = new VecInt();
        literals.push(1).push(-2);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(-1).push(-2);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(2);
        maxsat.addClause(literals);
        literals.clear();
        literals.push(-3);
        maxsat.addClause(literals);
        OptToSatAdapter opt = new OptToSatAdapter(maxsat);
        assertTrue(opt.isSatisfiable());
        assertTrue(maxsat.calculateObjective().equals(1));
        assertFalse(opt.model(3));
    }
