@Test
    public void testPartialWeightedMaxsat() throws ContradictionException,
            TimeoutException {
        WeightedMaxSatDecorator maxsat = new WeightedMaxSatDecorator(
                SolverFactory.newLight());
        maxsat.newVar(3);
        IVecInt literals = new VecInt();
        literals.push(1).push(-2).push(3);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(-1).push(-2);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(2);
        maxsat.addSoftClause(10, literals);
        literals.clear();
        literals.push(-3);
        maxsat.addSoftClause(5, literals);
        OptToPBSATAdapter opt = new OptToPBSATAdapter(new PseudoOptDecorator(
                maxsat));
        assertTrue(opt.isSatisfiable());
        assertTrue(opt.model(2));
        assertTrue(opt.model(3));
    }
