@Test
    public void testWeightedMinimization() throws ContradictionException,
            TimeoutException {
        WeightedMaxSatDecorator maxsat = new WeightedMaxSatDecorator(
                SolverFactory.newLight());
        maxsat.newVar(3);
        IVecInt literals = new VecInt();
        literals.push(1).push(-2).push(3);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(-1).push(-2);
        maxsat.addHardClause(literals);
        literals.clear();
        literals.push(-2).push(3);
        IVecInt coefs = new VecInt().push(10).push(5);
        maxsat.addWeightedLiteralsToMinimize(literals, coefs);
        OptToPBSATAdapter opt = new OptToPBSATAdapter(new PseudoOptDecorator(
                maxsat));
        assertTrue(opt.isSatisfiable());
        assertTrue(opt.model(2));
        assertTrue(opt.model(3));
    }
