public void objectiveFunctionToLP(ObjectiveFunction obj,
            StringBuilder buffer) {
        buffer.append("Minimize \n");
        buffer.append("obj: ");
        IVecInt variables = obj.getVars();
        IVec<BigInteger> coeffs = obj.getCoeffs();
        int n = variables.size();
        if (n > 0) {
            buffer.append(coeffs.get(0));
            buffer.append("x");
            buffer.append(variables.get(0));
            buffer.append(" ");
        }
        BigInteger coeff;
        for (int i = 1; i < n; i++) {
            coeff = coeffs.get(i);
            if (coeff.signum() > 0) {
                buffer.append("+ " + coeff);
            } else {
                buffer.append("- " + coeff.negate());
            }
            buffer.append("x");
            buffer.append(variables.get(i));
            buffer.append(" ");
        }

    }
