@Override
    protected IProblem readProblem(String problemname)
            throws ParseFormatException, IOException, ContradictionException {
        IProblem problem = super.readProblem(problemname);
        ObjectiveFunction obj = null;
        if (super.feedWithDecorated) {
            SolverDecorator<IPBSolver> decorator = (SolverDecorator<IPBSolver>) problem;
            obj = (decorator.decorated()).getObjectiveFunction();
        } else {
            obj = ((IPBSolver) problem).getObjectiveFunction();
        }
        if (obj != null) {
            this.out.println(COMMENT_PREFIX + "objective function length is "
                    + obj.getVars().size() + " literals");
        }
        return problem;
    }
