private int[] modelWithAdaptedNonPrimeLiterals() {
        // do not use model() because it might contain holes.
        int[] completeModel = new int[nVars()];
        int var;
        for (int i = 0; i < nVars(); i++) {
            var = i + 1;
            completeModel[i] = super.model(var) ? var : -var;
        }
        primeImplicant();
        ObjectiveFunction obj = getObjectiveFunction();
        for (int i = 0; i < obj.getVars().size(); i++) {
            int d = obj.getVars().get(i);
            BigInteger coeff = obj.getCoeffs().get(i);
            if (d <= nVars() && !primeImplicant(d) && !primeImplicant(-d)) {
                // the variable does not appear in the model: it can be assigned
                // either way
                assert Math.abs(completeModel[Math.abs(d) - 1]) == d;
                if (coeff.signum() * d < 0) {
                    completeModel[Math.abs(d) - 1] = Math.abs(d);
                } else {
                    completeModel[Math.abs(d) - 1] = -Math.abs(d);
                }
            }
        }
        return completeModel;
    }
