public static IPBSolver newEclipseP2() {
        MiniSATLearning<PBDataStructureFactory> learning = new MiniSATLearning<PBDataStructureFactory>();
        PBSolverResolution solver = new PBSolverResolution(learning,
                new CompetResolutionPBMixedHTClauseCardConstrDataStructure(),
                new VarOrderHeapObjective(new RSATPhaseSelectionStrategy()),
                new ArminRestarts());
        learning.setDataStructureFactory(solver.getDSFactory());
        learning.setVarActivityListener(solver);
        solver.setTimeoutOnConflicts(300);
        solver.setVerbose(false);
        solver.setLearnedConstraintsDeletionStrategy(
                solver.activity_based_low_memory);
        return new OptToPBSATAdapter(new PseudoOptDecorator(solver));
    }
