@Override
    protected Constr learntConstraintFactory(IDataStructurePB dspb) {
        if (dspb.getDegree().equals(BigInteger.ONE)) {
            IVecInt literals = new VecInt();
            IVec<BigInteger> resCoefs = new Vec<BigInteger>();
            dspb.buildConstraintFromConflict(literals, resCoefs);
            // then assertive literal must be placed at the first place
            int indLit = dspb.getAssertiveLiteral();
            if (indLit > -1) {
                int tmp = literals.get(indLit);
                literals.set(indLit, literals.get(0));
                literals.set(0, tmp);
                BigInteger coeftmp = resCoefs.get(indLit);
                resCoefs.set(indLit, resCoefs.get(0));
                resCoefs.set(0, coeftmp);
            }
            return constructLearntClause(literals);
        }
        if (dspb.isCardinality()) {
            return constructLearntCard(dspb);
        }
        return constructLearntPB(dspb);
    }
