private Constr learntConstraintFactory(IVecInt literals,
            IVec<BigInteger> coefs, BigInteger degree, boolean moreThan) {
        int[] lits = new int[literals.size()];
        literals.copyTo(lits);
        BigInteger[] bc = new BigInteger[coefs.size()];
        coefs.copyTo(bc);
        degree = Pseudos.niceCheckedParametersForCompetition(lits, bc, moreThan,
                degree);

        if (degree.equals(BigInteger.ONE)) {
            return constructLearntClause(new VecInt(lits));
        }
        if (coefficientsEqualTo(BigInteger.ONE, bc)) {
            return constructLearntCard(new VecInt(lits),
                    new Vec<BigInteger>(bc), degree);
        }
        if (coefficientsEqualTo(bc[0], bc)) {
            BigInteger[] division = degree.divideAndRemainder(bc[0]);
            if (!division[1].equals(BigInteger.ZERO))
                division[0] = division[0].add(BigInteger.ONE);
            // for (int i = 0; i < bc.length; i++)
            // bc[i] = BigInteger.ONE;
            return constructLearntCard(new VecInt(lits),
                    new Vec<BigInteger>(bc), division[0]);
        }
        return constructLearntPB(new VecInt(lits), new Vec<BigInteger>(bc),
                degree);
    }
