public int getBacktrackLevel(int maxLevel) {
        if (this.backtrackLevel == NOTCOMPUTED) {
            // we are looking for a level higher than maxLevel
            // where the constraint is still assertive
            VecInt lits;
            int level;
            int indStop = levelToIndex(maxLevel) - 1;
            int indStart = levelToIndex(0);
            BigInteger slack = computeSlack(0)
                    .subtract(ConflictMap.this.degree);
            int previous = 0;
            for (int indLevel = indStart; indLevel <= indStop; indLevel++) {
                if (ConflictMap.this.byLevel[indLevel] != null) {
                    level = indexToLevel(indLevel);
                    assert ConflictMap.this.computeSlack(level)
                            .subtract(ConflictMap.this.degree).equals(slack);
                    if (ConflictMap.this.isImplyingLiteralOrdered(level, slack))
                        break;

                    // updating the new slack
                    lits = ConflictMap.this.byLevel[indLevel];
                    int lit;
                    for (IteratorInt iterator = lits.iterator(); iterator
                            .hasNext();) {
                        lit = iterator.next();
                        if (ConflictMap.this.voc.isFalsified(lit)
                                && ConflictMap.this.voc.getLevel(
                                        lit) == indexToLevel(indLevel))
                            slack = slack.subtract(
                                    ConflictMap.this.weightedLits.get(lit));

                    }
                    if (!lits.isEmpty())
                        previous = level;

                }
            }
            assert previous == oldGetBacktrackLevel(maxLevel);
            return previous;
        } else
            return this.backtrackLevel;
    }
