private static PBConstr minWatchCardPBNew(UnitPropagationListener s,
            ILits voc, IVecInt ps, boolean moreThan, int degree,
            boolean normalized) throws ContradictionException {
        int mydegree = degree + linearisation(voc, ps);

        if (ps.size() < mydegree) {
            throw new ContradictionException();
        } else if (ps.size() == 0 && mydegree > 0) {
            throw new ContradictionException();
        } else if (ps.size() == mydegree || ps.size() <= 0) {
            for (int i = 0; i < ps.size(); i++) {
                if (!s.enqueue(ps.get(i))) {
                    throw new ContradictionException();
                }
            }
            return new UnitClausesPB(ps);
        }

        // constraint is now instanciated
        MinWatchCardPB retour = null;
        if (normalized) {
            retour = new MinWatchCardPB(voc, ps, mydegree);
        } else {
            retour = new MinWatchCardPB(voc, ps, moreThan, mydegree);
        }

        if (retour.bigDegree.signum() <= 0) {
            return null;
        }

        retour.computeWatches();

        return (MinWatchCardPB) retour.computePropagation(s);
    }
