protected BigInteger updateWatched(BigInteger mc, int pIndice) {
        BigInteger maxCoef = mc;
        // if not all the literals are watched
        if (this.watchingCount < size()) {
            // the watchCumul sum will have to be updated
            BigInteger upWatchCumul = this.watchCumul
                    .subtract(this.coefs[pIndice]);

            // we must obtain upWatchCumul such that
            // upWatchCumul = degree + maxCoef
            BigInteger degreePlusMaxCoef = this.degree.add(maxCoef);
            for (int ind = 0; ind < this.lits.length; ind++) {
                if (upWatchCumul.compareTo(degreePlusMaxCoef) >= 0) {
                    // nothing more to watch
                    // note: logic negated to old version // dvh
                    break;
                }
                // while upWatchCumul does not contain enough
                if (!this.voc.isFalsified(this.lits[ind]) && !this.watched[ind]) {
                    // watch one more
                    upWatchCumul = upWatchCumul.add(this.coefs[ind]);
                    // update arrays watched and watching
                    this.watched[ind] = true;
                    assert this.watchingCount < size();
                    this.watching[this.watchingCount++] = ind;
                    this.voc.watch(this.lits[ind] ^ 1, this);
                    // this new watched literal could change the maximal
                    // coefficient
                    if (this.coefs[ind].compareTo(maxCoef) > 0) {
                        maxCoef = this.coefs[ind];
                        degreePlusMaxCoef = this.degree.add(maxCoef);
                    }
                }
            }
            // update watchCumul
            this.watchCumul = upWatchCumul.add(this.coefs[pIndice]);
        }
        return maxCoef;
    }
