private int chooseAssertiveLiteral(int maxLevel, ConflictMap conflictMap) {
        // we are looking for a level higher than maxLevel
        // where the constraint is still assertive
        VecInt lits;
        int level;
        int indStop = ConflictMap.levelToIndex(maxLevel); // ou maxLevel - 1 ???
        int indStart = ConflictMap.levelToIndex(0);
        BigInteger slack = conflictMap.computeSlack(0)
                .subtract(conflictMap.degree);
        int previous = 0;
        IVecInt literals = new VecInt();
        for (int indLevel = indStart; indLevel <= indStop; indLevel++) {
            if (conflictMap.byLevel[indLevel] != null) {
                level = ConflictMap.indexToLevel(indLevel);
                assert conflictMap.computeSlack(level)
                        .subtract(conflictMap.degree).equals(slack);
                if (conflictMap.isImplyingLiteralOrdered(level, slack,
                        literals)) {
                    this.assertiveLevel = level;
                    conflictMap.backtrackLevel = previous;
                    break;
                }
                // updating the new slack
                lits = conflictMap.byLevel[indLevel];
                int lit;
                for (IteratorInt iterator = lits.iterator(); iterator
                        .hasNext();) {
                    lit = iterator.next();
                    if (conflictMap.voc.isFalsified(lit)
                            && conflictMap.voc.getLevel(lit) == ConflictMap
                                    .indexToLevel(indLevel)) {
                        slack = slack
                                .subtract(conflictMap.weightedLits.get(lit));
                    }
                }
                if (!lits.isEmpty()) {
                    previous = level;
                }
            }
        }

        assert literals.size() > 0;
        BigInteger coef;
        int maxLit = literals.get(0);
        BigInteger maxCoef = conflictMap.weightedLits.getCoef(maxLit);
        for (int i = 1; i < literals.size(); i++) {
            coef = conflictMap.weightedLits.getCoef(literals.get(i));
            if (coef.compareTo(maxCoef) > 0) {
                maxLit = literals.get(i);
                maxCoef = coef;
            }
        }

        assert conflictMap.backtrackLevel == conflictMap
                .oldGetBacktrackLevel(maxLevel);
        assert literals.size() > 0;
        return maxLit;
    }
