public void postProcess(int dl, ConflictMap conflictMap) {
        // procedure Reduce-to-cardinality 4.3.9 proposed by H. Dixon
        // (Dixon's dissertation, page 67)
        if (conflictMap.isAssertive(dl)
                && (!conflictMap.degree.equals(BigInteger.ONE))) {
            int lit, litLevel, ilit;
            BigInteger coefLit;
            conflictMap.setDecisionLevel(dl);
            if (conflictMap.assertiveLiteral != -1) {
                conflictMap.assertiveLiteral = this.chooseAssertiveLiteral(dl,
                        conflictMap);
                coefLit = conflictMap.weightedLits
                        .getCoef(conflictMap.assertiveLiteral);

                // compute sum of coefficients of confl
                BigInteger sumCoefsTmp = BigInteger.ZERO;
                for (int i = 0; i < conflictMap.size(); i++) {
                    sumCoefsTmp = sumCoefsTmp
                            .add(conflictMap.weightedLits.getCoef(i));
                }

                // if it is already a cardinality constraint, return
                if (sumCoefsTmp.compareTo(
                        BigInteger.valueOf(conflictMap.size())) == 0) {
                    return;
                }
                IVecInt compLSet = new VecInt();
                BigInteger coefMax = coefLit;
                BigInteger coefTmp;

                // construct lSet with all falsified literals s.t. sum of
                // the coefs of compl(lSet) < degree
                // first we add the assertive literal
                sumCoefsTmp = sumCoefsTmp.subtract(coefLit);
                conflictMap.changeCoef(conflictMap.assertiveLiteral,
                        BigInteger.ONE);
                // then the needed falsified literals
                for (int i = 0; i < conflictMap.size(); i++) {
                    ilit = conflictMap.weightedLits.getLit(i);
                    lit = conflictMap.weightedLits
                            .getLit(conflictMap.assertiveLiteral);
                    litLevel = conflictMap.voc.getLevel(ilit);
                    coefTmp = conflictMap.weightedLits.getCoef(i);
                    if (ilit != lit) {
                        if (litLevel < this.assertiveLevel
                                && conflictMap.voc.isFalsified(ilit)) {
                            conflictMap.changeCoef(i, BigInteger.ONE);
                            sumCoefsTmp = sumCoefsTmp.subtract(coefTmp);
                            if (coefMax.compareTo(coefTmp) < 0)
                                coefMax = coefTmp;
                        } else
                            compLSet.push(ilit);
                    }
                }
                assert sumCoefsTmp.compareTo(conflictMap.degree) < 0;

                // add into lSet the sSet literals which are not already in
                // L and with coef > coefMax

                lit = conflictMap.weightedLits
                        .getLit(conflictMap.assertiveLiteral);
                int degreeCard = 1;
                for (int i = 0; i < compLSet.size(); i++) {
                    ilit = conflictMap.weightedLits
                            .getFromAllLits(compLSet.get(i));
                    if (coefMax.compareTo(
                            conflictMap.weightedLits.getCoef(ilit)) <= 0) {
                        conflictMap.changeCoef(ilit, BigInteger.ONE);
                        degreeCard++;
                    } else {
                        conflictMap.removeCoef(compLSet.get(i));
                    }
                }

                conflictMap.degree = BigInteger.valueOf(degreeCard);
                conflictMap.assertiveLiteral = conflictMap.weightedLits
                        .getFromAllLits(lit);

                assert conflictMap.backtrackLevel == conflictMap
                        .oldGetBacktrackLevel(dl);
            }
        }
    }
