public int chooseAssertiveLiteral(int maxLevel, ConflictMap conflictMap) {
        // we are looking for a level higher than maxLevel
        // where the constraint is still assertive
        // update ConflictMap.this.assertiveLiteral
        VecInt lits;
        int level;

        int indStop = ConflictMap.levelToIndex(maxLevel); // ou maxLevel - 1 ???
        int indStart = ConflictMap.levelToIndex(0);
        BigInteger slack = conflictMap.computeSlack(0)
                .subtract(conflictMap.degree);
        int previous = 0;
        for (int indLevel = indStart; indLevel <= indStop; indLevel++) {
            if (conflictMap.byLevel[indLevel] != null) {
                level = ConflictMap.indexToLevel(indLevel);
                assert conflictMap.computeSlack(level)
                        .subtract(conflictMap.degree).equals(slack);
                if (conflictMap.isImplyingLiteralOrdered(level, slack)) {
                    conflictMap.backtrackLevel = previous;
                    assertiveLevel = level;
                    break;
                }
                // updating the new slack
                lits = conflictMap.byLevel[indLevel];
                int lit;
                for (IteratorInt iterator = lits.iterator(); iterator
                        .hasNext();) {
                    lit = iterator.next();
                    if (conflictMap.voc.isFalsified(lit)
                            && conflictMap.voc.getLevel(lit) == ConflictMap
                                    .indexToLevel(indLevel)) {
                        slack = slack
                                .subtract(conflictMap.weightedLits.get(lit));
                    }
                }
                if (!lits.isEmpty()) {
                    previous = level;
                }
            }
        }

        assert conflictMap.backtrackLevel == conflictMap
                .oldGetBacktrackLevel(maxLevel);
        return conflictMap.assertiveLiteral;
    }
