public void postProcess(int dl, ConflictMap conflictMap) {
        if (conflictMap.isAssertive(dl)
                && (!conflictMap.degree.equals(BigInteger.ONE))) {
            int litLevel, ilit;
            conflictMap.setDecisionLevel(dl);
            if (conflictMap.assertiveLiteral != -1) {
                conflictMap.assertiveLiteral = this.chooseAssertiveLiteral(dl,
                        conflictMap);
                int lit = conflictMap.weightedLits
                        .getLit(conflictMap.assertiveLiteral);

                IVecInt toSuppress = new VecInt();

                for (int i = 0; i < conflictMap.size(); i++) {
                    ilit = conflictMap.weightedLits.getLit(i);
                    litLevel = conflictMap.voc.getLevel(ilit);
                    if ((litLevel < this.assertiveLevel)
                            && conflictMap.voc.isFalsified(ilit))
                        conflictMap.weightedLits.changeCoef(i, BigInteger.ONE);
                    else if (ilit != lit) {
                        toSuppress.push(ilit);
                    }
                }

                conflictMap.weightedLits.changeCoef(
                        conflictMap.assertiveLiteral, BigInteger.ONE);

                for (int i = 0; i < toSuppress.size(); i++)
                    conflictMap.removeCoef(toSuppress.get(i));

                conflictMap.degree = BigInteger.ONE;
                conflictMap.assertiveLiteral = conflictMap.weightedLits
                        .getFromAllLits(lit);
                assert conflictMap.backtrackLevel == conflictMap
                        .oldGetBacktrackLevel(dl);
            }
        }
    }
