public static ObjectiveFunction normalizeObjective(
            ObjectiveFunction initial) {
        IVec<BigInteger> initCoeffs = initial.getCoeffs();
        IVecInt initLits = initial.getVars();
        assert initCoeffs.size() == initLits.size();
        Map<Integer, BigInteger> reduced = new HashMap<Integer, BigInteger>();
        int lit;
        for (int i = 0; i < initLits.size(); i++) {
            lit = initLits.get(i);
            BigInteger oldCoef = reduced.get(lit);
            if (oldCoef == null) {
                reduced.put(lit, initCoeffs.get(i));
            } else {
                reduced.put(lit, oldCoef.add(initCoeffs.get(i)));
            }
        }
        assert reduced.size() <= initLits.size();
        if (reduced.size() < initLits.size()) {
            IVecInt newLits = new VecInt(reduced.size());
            IVec<BigInteger> newCoefs = new Vec<BigInteger>(reduced.size());
            for (Map.Entry<Integer, BigInteger> entry : reduced.entrySet()) {
                newLits.push(entry.getKey());
                newCoefs.push(entry.getValue());
            }
            return new ObjectiveFunction(newLits, newCoefs);
        }
        return initial;
    }
