public IntegerVariable newIntegerVar(BigInteger maxValue) {
        if (maxValue.compareTo(BigInteger.ZERO) <= 0) {
            throw new IllegalArgumentException(
                    "the integer variable maximum value must be at least 1");
        }
        int nbVars = maxValue.bitLength();
        IVecInt vars = new VecInt(nbVars);
        for (int i = 0; i < nbVars; ++i) {
            vars.push(decorated.nextFreeVarId(true));
        }
        return new IntegerVariable(vars);
    }
