private void pushIntegerVariables(IVecInt literals, IVecInt coeffs,
            IVec<IntegerVariable> integerVars,
            IVec<BigInteger> integerVarsCoeffs) {
        if (integerVars.size() != integerVarsCoeffs.size()) {
            throw new IllegalArgumentException(
                    "different number of integer variables and integer variables coeffs");
        }
        Iterator<IntegerVariable> intVarsIt = integerVars.iterator();
        Iterator<BigInteger> intVarsCoeffsIt = integerVarsCoeffs.iterator();
        while (intVarsIt.hasNext()) {
            BigInteger factor = intVarsCoeffsIt.next();
            IteratorInt intVarLitsIt = intVarsIt.next().getVars().iterator();
            while (intVarLitsIt.hasNext()) {
                literals.push(intVarLitsIt.next());
                coeffs.push(factor.intValue());
                factor = factor.shiftLeft(1);
            }
        }
    }
