private int processAtMostOneCstrs(ObjectiveFunction obj, IVecInt newVars,
            IVec<BigInteger> newCoeffs, Set<Integer> oldVarsToIgnore) {
        System.out.println("c " + this.atMostOneCstrs.size()
                + " atMostOne constraints found");
        int nbReduc = 0;
        IVecInt oldObjVars = obj.getVars();
        IVec<BigInteger> oldObjCoeffs = obj.getCoeffs();
        for (IVecInt lits : this.atMostOneCstrs) {
            boolean allLitsIn = true;
            for (IteratorInt it = lits.iterator(); it.hasNext();) {
                int next = it.next();
                if (oldVarsToIgnore.contains(next)) {
                    allLitsIn = false;
                    break;
                }
                int indexOf = oldObjVars.indexOf(next);
                if (indexOf == -1
                        || !oldObjCoeffs.get(indexOf).equals(BigInteger.ONE)) {
                    allLitsIn = false;
                    break;
                }
            }
            if (allLitsIn) {
                int newObjVar = nextFreeVarId(true);
                try {
                    for (IteratorInt it = lits.iterator(); it.hasNext();) {
                        int nextInt = it.next();
                        this.decorated.addClause(
                                new VecInt(new int[] { nextInt, newObjVar }));
                        oldVarsToIgnore.add(Integer.valueOf(nextInt));
                        ++nbReduc;
                    }
                } catch (ContradictionException e) {
                    // should not occur
                    Logger.getLogger("org.sat4j.pb").log(Level.SEVERE,
                            "Inconsistency found, should not happen", e);
                }

                newVars.push(newObjVar);
                newCoeffs.push(BigInteger.ONE);
                --nbReduc;
            }
        }
        return nbReduc;
    }
