private void addBoundConstraint(int boundVarIndex,
            IntegerVariable boundVar, int objIndex) {
        IVecInt literals = new VecInt();
        IVec<BigInteger> coeffs = new Vec<BigInteger>();
        this.initObjs.get(objIndex).getVars().copyTo(literals);
        this.initObjs.get(objIndex).getCoeffs().copyTo(coeffs);
        int flagLit = decorated().nextFreeVarId(true);
        this.atLeastFlags.get(boundVarIndex).push(flagLit);
        literals.push(flagLit);
        coeffs.push(minObjValuesBound().negate());
        try {
            this.integerSolver.addAtMost(literals, coeffs,
                    new Vec<IntegerVariable>().push(boundVar),
                    new Vec<BigInteger>().push(BigInteger.ONE.negate()),
                    BigInteger.ZERO);
        } catch (ContradictionException e) {
            throw new RuntimeException(e);
        }
    }
