private void addConstraint(IntegerVariable boundVar,
            List<Integer> permutation) {
        IVecInt vars = new VecInt();
        IVec<BigInteger> weights = new Vec<BigInteger>();
        for (int i = 0; i < super.objs.size(); ++i) {
            ObjectiveFunction currentObj = super.objs.get(permutation.get(i));
            BigInteger curWeight = this.weights[i];
            currentObj.getVars().copyTo(vars);
            for (Iterator<BigInteger> coeffIt = currentObj.getCoeffs()
                    .iterator(); coeffIt.hasNext();) {
                weights.push(coeffIt.next().multiply(curWeight));
            }
        }
        BigInteger fact = BigInteger.ONE;
        for (IteratorInt litsIt = boundVar.getVars().iterator(); litsIt
                .hasNext();) {
            int nextLit = litsIt.next() * -1;
            vars.push(nextLit);
            weights.push(fact);
            fact = fact.shiftLeft(1);
        }
        try {
            decorated().addAtMost(vars, weights, fact.subtract(BigInteger.ONE));
        } catch (ContradictionException e) {
            throw new UnsupportedOperationException(e);
        }
    }
