@Override
    protected void setInitConstraints() {
        String owaWeightsProperty = System.getProperty("_owaWeights");
        if (owaWeightsProperty != null) {
            String[] weights = owaWeightsProperty.split(",");
            for (int i = 0; i < this.weights.length; ++i) {
                this.weights[i] = BigInteger.valueOf(Long.valueOf(weights[i]));
            }
        }
        if (decorated().isVerbose()) {
            System.out.println(getLogPrefix() + "OWA weights : "
                    + Arrays.toString(weights));
        }
        BigInteger minObjValuesBound = minObjValuesBound();
        for (int i = 0; i < super.objs.size(); ++i) {
            IntegerVariable boundVar = this.integerSolver
                    .newIntegerVar(minObjValuesBound);
            this.objBoundVariables.add(boundVar);
            this.atLeastFlags.add(new VecInt());
            for (int j = 0; j < super.objs.size(); ++j) {
                addBoundConstraint(i, boundVar, j);
            }
            addFlagsCardinalityConstraint(i);
        }
        createSumAndLexObjs();
    }
