@Override
    public void init() {
        super.init();
        if (this.obj != null) {
            IVecInt vars = this.obj.getVars();
            IVec<BigInteger> coefs = this.obj.getCoeffs();
            for (int i = 0; i < vars.size(); i++) {
                int dimacsLiteral = vars.get(i);
                if (this.lits.belongsToPool(Math.abs(dimacsLiteral))) {
                    int p = this.lits.getFromPool(dimacsLiteral);
                    BigInteger c = coefs.get(i);
                    if (c.signum() < 0) {
                        p = neg(p);
                    }
                    int var = var(p);
                    this.activity[var] = c.bitLength() < Long.SIZE ? c.abs()
                            .longValue() : Long.MAX_VALUE;
                    if (this.heap.inHeap(var)) {
                        this.heap.increase(var);
                    } else {
                        this.heap.insert(var);
                    }
                    this.phaseStrategy.init(var, neg(p));
                }
            }
        }
    }
