@Override
    protected void readVariablesExplanation() throws IOException,
            ParseFormatException {
        char c;
        StringBuilder var = new StringBuilder();

        // read variables line (if any)
        // if the problem is unsatisfiable, and if these variables are part of
        // the reason of the conflict
        // then an explanation should be produced for these variables

        skipSpaces();
        c = get();
        if (c != 'e') {
            // no variables line
            putback(c);
            return;
        }

        this.hasVariablesExplanation = true;
        if (get() == 'x' && get() == 'p' && get() == 'l' && get() == 'a'
                && get() == 'i' && get() == 'n' && get() == ':') {
            beginListOfVariables(); // callback

            while (!eof()) {
                readIdentifier(var);
                this.varExplain.push(translateVarToId(var.toString()));

                skipSpaces();
                c = get();
                if (c == ';') {
                    break; // end of list of variables
                }
                putback(c);
            }

            endListOfVariables();
        } else {
            throw new ParseFormatException(
                    "input format error: 'explain:' expected");
        }

    }
