protected void readConstraint()
            throws IOException, ParseFormatException, ContradictionException {
        StringBuilder var = new StringBuilder();
        StringBuilder coeff = new StringBuilder();
        char c;

        beginConstraint();

        while (!eof()) {
            readTerm(coeff, var);
            constraintTerm(new BigInteger(coeff.toString()), var.toString());

            skipSpaces();
            c = get();
            if (c == '>' || c == '=' || c == '<') {
                // relational operator found
                putback(c);
                break;
            } else if (c == '-' || c == '+' || Character.isDigit(c)) {
                putback(c);
            } else {
                throw new ParseFormatException(
                        "unexpected character in constraint");
            }
        }

        if (eof()) {
            throw new ParseFormatException(
                    "unexpected EOF before end of constraint");
        }

        String relop;
        if ((relop = readRelOp()) == null) {
            throw new ParseFormatException(
                    "unexpected relational operator in constraint");

        }
        constraintRelOp(relop);
        readInteger(coeff);
        constraintRightTerm(new BigInteger(coeff.toString()));

        skipSpaces();
        c = get();
        if (eof() || c != ';') {
            throw new ParseFormatException(
                    "semicolon expected at end of constraint");
        }

        endConstraint();
    }
