protected void readObjective() throws IOException, ParseFormatException {
        char c;
        StringBuilder var = new StringBuilder();
        StringBuilder coeff = new StringBuilder();

        // read objective line (if any)

        skipSpaces();
        c = get();
        if (c != 'm') {
            // no objective line
            putback(c);
            if (solver.isVerbose()) {
                System.out.println(
                        solver.getLogPrefix() + " no objective function found");
            }
            return;
        }
        if (solver.isVerbose()) {
            System.out.println(
                    solver.getLogPrefix() + " objective function found");
        }
        this.hasObjFunc = true;
        if (get() == 'i' && get() == 'n' && get() == ':') {
            beginObjective(); // callback

            while (!eof()) {
                readTerm(coeff, var);
                constraintTerm(new BigInteger(coeff.toString()),
                        var.toString()); // callback

                skipSpaces();
                c = get();
                if (c == ';') {
                    break; // end of objective
                } else if (c == '-' || c == '+' || Character.isDigit(c)) {
                    putback(c);
                } else {
                    throw new ParseFormatException(
                            "unexpected character in objective function");
                }
            }

            endObjective();
        } else {
            throw new ParseFormatException(
                    "input format error: 'min:' expected");
        }
    }
