private String linearizeProduct(IVec<String> tmpLit)
            throws ContradictionException, ParseFormatException {
        tmpLit.sort(String.CASE_INSENSITIVE_ORDER);
        String newVar = getProductVariable(tmpLit);
        if (newVar == null) {
            // generate a new symbol
            newVar = "X" + this.nbNewSymbols++;
            // linearization proposed by O. Roussel (PB07)
            // generate the clause
            // product => newSymbol (this is a clause)
            // not x1 or not x2 ... or not xn or newSymbol
            if (tmpLit.size() == 2) {
                Map<String, String> map1 = this.binaryProductToVar
                        .get(tmpLit.get(0));
                if (map1 == null) {
                    map1 = new HashMap<String, String>();
                    this.binaryProductToVar.put(tmpLit.get(0), map1);
                }
                map1.put(tmpLit.get(1), newVar);
            }
            this.varToProduct.put(newVar, tmpLit);
            IVecInt newLits = new VecInt();
            for (Iterator<String> iterator = tmpLit.iterator(); iterator
                    .hasNext();) {
                negateLiteralInAProduct(iterator.next(), newLits);
            }
            literalInAProduct(newVar, newLits);
            this.solver.addClause(newLits);
            // generate the PB-constraint
            // newSymbol => product translated as
            // x1+x2+x3...+xn-n*newSymbol>=0
            newLits.clear();
            IVec<BigInteger> newCoefs = new Vec<BigInteger>();
            for (Iterator<String> iterator = tmpLit.iterator(); iterator
                    .hasNext();) {
                literalInAProduct(iterator.next(), newLits);
                newCoefs.push(BigInteger.ONE);
            }
            literalInAProduct(newVar, newLits);
            newCoefs.push(new BigInteger(String.valueOf(-tmpLit.size())));
            this.solver.addPseudoBoolean(newLits, newCoefs, true,
                    BigInteger.ZERO);
            // nbConstraintsRead += 2;
        }
        return newVar;
    }
