@Override
    protected void readTerm(StringBuilder coeff, StringBuilder var)
            throws IOException, ParseFormatException {
        readInteger(coeff);

        skipSpaces();

        var.setLength(0);
        IVec<String> tmpLit = new Vec<String>();
        StringBuilder tmpVar = new StringBuilder();
        while (readIdentifier(tmpVar)) {
            tmpLit = tmpLit.push(tmpVar.toString());
            skipSpaces();
        }
        if (tmpLit.size() == 0) {
            throw new ParseFormatException("identifier expected");
        }
        if (tmpLit.size() == 1) {
            // it is a "normal" term
            var.append(tmpLit.last());
            tmpLit.pop();
        } else {
            // it is a product term
            try {
                var.append(linearizeProduct(tmpLit));
            } catch (ContradictionException e) {
                throw new ParseFormatException(e);
            }
        }
    }
