private boolean cardIsSubsumed(BitSet atLeastLits, int threshold) {
        List<BitSet> storedCards = this.atLeastCardCache
                .get(atLeastLits.nextSetBit(0)
                        - this.coSolver.realNumberOfVariables());
        if (storedCards == null) {
            return false;
        }
        // if clause is subsumed by a card, a card contain all the clause
        // literals
        for (BitSet storedCard : storedCards) {
            BitSet atLeastLitsClone = (BitSet) atLeastLits.clone();
            atLeastLitsClone.andNot(storedCard);
            if (atLeastLitsClone.isEmpty()) {
                // L>=d dominates L'>=d' iff |L\L'| <= d-d'
                BitSet intersection = ((BitSet) storedCard.clone());
                intersection.andNot(atLeastLits);
                if (intersection
                        .cardinality() <= this.atLeastCardDegree.get(storedCard)
                                - threshold) {
                    return true;
                }
            }
        }
        return false;
    }
