private Set<Integer> expendAtMostCard(BitSet atMostLits, int degree) {
        Set<Integer> res = new HashSet<Integer>();
        BitSet candidates = computeInitialCandidates(atMostLits, degree);
        if (candidates == null || candidates.isEmpty())
            return res;
        int from = 0;
        int cur;
        while ((cur = candidates.nextSetBit(from)) != -1) {
            from = cur + 1;
            // if a candidate is the negation of a literal, forget it
            // this literal may not be set by the solver (improvement needed)
            if (atMostLits.get(2 * this.coSolver.realNumberOfVariables() - cur))
                continue;
            res.add(-(cur - this.coSolver.realNumberOfVariables()));
            // after adding the new literal to the card, we need to compute the
            // remaining candidates
            refineCandidates(atMostLits, degree, cur, candidates);
            atMostLits.set(2 * this.coSolver.realNumberOfVariables() - cur);
        }
        return res;
    }
