private void refineCandidates(BitSet atMostLits, int degree,
            int newLitInCard, BitSet candidates) {
        if (degree == 1) {
            BitSet newLit = new BitSet(1);
            newLit.set(
                    2 * this.coSolver.realNumberOfVariables() - newLitInCard);
            BitSet implied = impliedBy(newLit);
            candidates.and(implied);
        } else {
            CombinationIterator combIt = new CombinationIterator(degree - 1,
                    atMostLits);
            while (combIt.hasNext()) {
                BitSet comb = combIt.nextBitSet();
                comb.set(2 * this.coSolver.realNumberOfVariables()
                        - newLitInCard);
                candidates.and(impliedBy(comb));
                if (candidates.isEmpty())
                    break;
            }
        }
    }
