public void rissPreprocessing(String rissLocation, String instance) {
        this.initNumberOfConstraints = this.atLeastCards.size();
        int status = -1;
        if (verbose)
            System.out.println("c executing riss subprocess");
        try {
            Process p = Runtime.getRuntime().exec(rissLocation
                    + " -findCard -card_print -no-card_amt -no-card_amo -no-card_sub -no-card_twoProd -no-card_merge -card_noLim "
                    + instance);
            BufferedReader reader = new BufferedReader(
                    new InputStreamReader(p.getErrorStream()));
            String line;
            while ((line = reader.readLine()) != null) {
                if (line.startsWith("c "))
                    continue;
                IVecInt lits = new VecInt();
                String[] words = line.split(" +");
                try {
                    for (int i = 0; i < words.length - 2; ++i)
                        lits.push(Integer.valueOf(words[i]));
                    int degree = Integer.valueOf(words[words.length - 1]);
                    if (verbose)
                        System.out.println("c riss extracted: "
                                + new AtMostCard(lits, degree));
                    storeAtMostCard(lits, degree);
                } catch (Exception e) {
                    System.err.println("WARNING: read \"" + line
                            + "\" from Riss subprocess");
                }
            }
            reader.close();
            status = p.waitFor();
            if (verbose)
                System.out
                        .println("c riss process exited with status " + status);
        } catch (Exception e) {
            Logger.getLogger("org.sat4j.pb").log(Level.INFO,
                    "Issue when riss subprocess", e);
        }
        for (Iterator<AtLeastCard> cardIt = this.atLeastCards.iterator(); cardIt
                .hasNext();) {
            AtLeastCard card = cardIt.next();
            BitSet atLeastLits = new BitSet(card.getLits().size());
            for (IteratorInt litIt = card.getLits().iterator(); litIt
                    .hasNext();)
                atLeastLits.set(
                        litIt.next() + this.coSolver.realNumberOfVariables());
            if (cardIsSubsumed(atLeastLits, card.getDegree())) {
                cardIt.remove();
            }
        }
        this.cardIt = this.atLeastCardDegree.keySet().iterator();
    }
