public void cardDetectionAnalyzeCP(Constr myconfl, Pair results)
            throws TimeoutException {
        int litImplied = this.trail.last();
        int currentLevel = this.voc.getLevel(litImplied);
        IConflict confl = chooseConflict((PBConstr) myconfl, currentLevel);
        confl.setDecisionLevel(currentLevel);
        assert confl.slackConflict().signum() < 0;
        while (!confl.isAssertive(currentLevel)) {
            if (!this.undertimeout) {
                throw new TimeoutException();
            }
            PBConstr constraint = (PBConstr) this.voc.getReason(litImplied);
            this.extendedConstr = null;
            if (constraintIsAdmissibleForExtension(constraint)) {
                tryToExtendConstraint(constraint);
            }
            if (this.extendedConstr != null) {
                constraint = (PBConstr) extendedConstr;
            }
            // result of the resolution is in the conflict (confl)
            confl.resolve(constraint, litImplied, this);
            updateNumberOfReductions(confl);
            assert confl.slackConflict().signum() < 0;
            // implication trail is reduced
            if (this.trail.size() == 1) {
                break;
            }
            undoOne();
            // assert decisionLevel() >= 0;
            if (decisionLevel() == 0) {
                break;
            }
            litImplied = this.trail.last();
            if (this.voc.getLevel(litImplied) != currentLevel) {
                this.trailLim.pop();
                slistener.backtracking(LiteralsUtils.toDimacs(litImplied));
            }
            assert this.voc.getLevel(litImplied) <= currentLevel;
            currentLevel = this.voc.getLevel(litImplied);
            confl.setDecisionLevel(currentLevel);
            assert confl.slackIsCorrect(currentLevel);
            assert currentLevel == decisionLevel();
            assert litImplied > 1;
        }
        assert confl.isAssertive(currentLevel) || this.trail.size() == 1
                || decisionLevel() == 0;

        assert currentLevel == decisionLevel();
        confl.setDecisionLevel(currentLevel);
        undoOne();
        this.qhead = this.trail.size();
        updateNumberOfReducedLearnedConstraints(confl);
        // necessary informations to build a PB-constraint
        // are kept from the conflict
        if (confl.size() == 0
                || (decisionLevel() == 0 || this.trail.size() == 0)
                        && confl.slackConflict().signum() < 0) {
            results.setReason(null);
            results.setBacktrackLevel(-1);
            return;
        }

        // assertive PB-constraint is build and referenced
        PBConstr resConstr = (PBConstr) this.dsfactory
                .createUnregisteredPseudoBooleanConstraint(confl);
        results.setReason(resConstr);

        // the conflict give the highest decision level for the backtrack
        // (which is less than current level)
        // assert confl.isAssertive(currentLevel);
        if (decisionLevel() == 0 || this.trail.size() == 0) {
            results.setBacktrackLevel(-1);
            results.setReason(null);
        } else {
            results.setBacktrackLevel(confl.getBacktrackLevel(currentLevel));
        }
    }
