public IConstr addAtLeast(IVecInt literals, IVec<BigInteger> coeffs,
            BigInteger degree) throws ContradictionException {
        assertConstraintIsCard(coeffs);
        Set<Integer> negLitsSet = new HashSet<Integer>(literals.size());
        for (IteratorInt it = literals.iterator(); it.hasNext();)
            negLitsSet.add(-it.next());
        int clausesDegree = literals.size() - degree.intValue() + 1;
        ConstrGroup group = new ConstrGroup(false);
        CombinationIterator combIt = new CombinationIterator(literals.size()
                - degree.intValue(), negLitsSet);
        for (Set<Integer> comb : combIt) {
            for (IteratorInt it = literals.iterator(); it.hasNext();) {
                int lit = it.next();
                if (!comb.contains(-lit)) {
                    IVecInt clause = new VecInt(clausesDegree);
                    clause.push(lit);
                    for (Integer negLit : comb) {
                        clause.push(-negLit);
                    }
                    group.add(addClause(clause));
                }
            }
        }
        return group;
    }
