public IConstr addAtMost(IVecInt literals, IVec<BigInteger> coeffs,
            BigInteger degree) throws ContradictionException {
        BigInteger coeffsSum = BigInteger.ZERO;
        IVecInt newLiterals = new VecInt(literals.size());
        for (IteratorInt it = literals.iterator(); it.hasNext();)
            newLiterals.push(-it.next());
        IVec<BigInteger> newCoeffs = new Vec<BigInteger>(coeffs.size());
        for (Iterator<BigInteger> it = coeffs.iterator(); it.hasNext();) {
            BigInteger c = it.next();
            newCoeffs.push(c);
            coeffsSum = coeffsSum.add(c);
        }
        BigInteger newDegree = coeffsSum.subtract(degree);
        return addAtLeast(newLiterals, newCoeffs, newDegree);
    }
