private void printPreprocessingStats(PrintWriter out) {
        if (this.cardFinder == null)
            return;
        out.println("c remaining constraints: "
                + this.cardFinder.remainingAtLeastCards().size() + "/"
                + this.cardFinder.initNumberOfClauses());
        out.println("c cardinality constraints found (preprocessing): "
                + this.preprocessingCardsFound);
        out.println("c cardinality search time (preprocessing): "
                + this.preprocessingTime + "ms");
        Map<Integer, Map<Integer, Integer>> cardsStats = new HashMap<Integer, Map<Integer, Integer>>();
        for (Iterator<AtLeastCard> it = this.cardFinder; it.hasNext();) {
            AtMostCard card = it.next().toAtMost();
            int degree = card.getDegree();
            Map<Integer, Integer> sizeMap = cardsStats.get(degree);
            if (sizeMap == null) {
                sizeMap = new HashMap<Integer, Integer>();
                cardsStats.put(degree, sizeMap);
            }
            Integer size = sizeMap.get(card.getLits().size());
            sizeMap.put(card.getLits().size(), size == null ? 1 : size + 1);
        }
        for (Map.Entry<Integer, Map<Integer, Integer>> cardinality : cardsStats
                .entrySet()) {
            for (Map.Entry<Integer, Integer> size : cardinality.getValue()
                    .entrySet()) {
                out.println("c found " + size.getValue()
                        + " at-most cardinality constraint of degree "
                        + cardinality.getKey() + " and size " + size.getKey());
            }
        }
        System.out.println("c solver contains "
                + this.solvers.get(solverIndex).nConstraints()
                + " constraints");
    }
