private void mergeCurrentandNextCriteria() {
        ObjectiveFunction currentObj = this.objs.get(this.currentCriterion);
        int currentObjSize = currentObj.getVars().size();
        ObjectiveFunction nextObj = this.objs.get(this.currentCriterion + 1);
        int nextObjSize = nextObj.getVars().size();
        IVecInt newLits = new VecInt(currentObjSize + nextObjSize);
        currentObj.getVars().copyTo(newLits);
        nextObj.getVars().copyTo(newLits);
        IVec<BigInteger> newCoeffs = new Vec<BigInteger>(currentObjSize
                + nextObjSize);
        BigInteger coeffFactor = BigInteger.valueOf(nextObjSize).add(
                BigInteger.ONE);
        for (Iterator<BigInteger> it = currentObj.getCoeffs().iterator(); it
                .hasNext();) {
            newCoeffs.push(it.next().multiply(coeffFactor));
        }
        nextObj.getCoeffs().copyTo(newCoeffs);
        this.objs.set(this.currentCriterion + 1, new ObjectiveFunction(newLits,
                newCoeffs));
    }
