private IConstr addPseudoBoolean(IVecInt lits, IVecInt coeffs,
            boolean moreThan, int d) throws ContradictionException {
        int newvar = createNewVar(lits);
        lits.push(newvar);
        if (moreThan && d >= 0) {
            coeffs.push(d);
        } else {
            int sum = 0;
            for (IteratorInt ite = coeffs.iterator(); ite.hasNext();) {
                sum += ite.next();
            }
            sum = sum - d;
            coeffs.push(-sum);
        }
        IConstr constr = moreThan ? decorated().addAtLeast(lits, coeffs, d)
                : decorated().addAtMost(lits, coeffs, d);
        if (constr == null) {
            // constraint trivially satisfied
            discardLastestVar();
            // System.err.println(lits.toString()+"/"+coeffs+"/"+(moreThan?">=":"<=")+d);
        } else {
            getConstrs().put(newvar, constr);
        }
        return constr;
    }
