@Test
    public void testAlmostGlobalInconsistencyIndex()
            throws ContradictionException, TimeoutException {
        this.solver.newVar(3);
        IVecInt clause = new VecInt();
        clause.push(1).push(2);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(1).push(-2);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(2);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-1).push(-2);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(1).push(3);
        this.solver.addClause(clause);
        clause.clear();
        assertFalse(this.solver.isSatisfiable());
        int[] explanation = this.solver.minimalExplanation();
        assertEquals(4, explanation.length);
        assertEquals(1, explanation[0]);
        assertEquals(2, explanation[1]);
        assertEquals(3, explanation[2]);
        assertEquals(4, explanation[3]);
    }
