@Test
    public void testExactlyConstraint()
            throws ContradictionException, TimeoutException {
        this.solver.newVar(4);
        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3).push(4);
        IConstr c1 = this.solver.addExactly(clause, 1);
        clause.clear();
        clause.push(-1).push(2);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-2).push(3);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-3).push(4);
        this.solver.addClause(clause);
        clause.clear();
        clause.push(-4).push(1);
        this.solver.addClause(clause);
        clause.clear();
        assertFalse(this.solver.isSatisfiable());
        Collection<IConstr> explanation = this.solver.explain();
        assertEquals(5, explanation.size());
        assertTrue(explanation.contains(c1));
    }
