@Before
    public void setUp() throws ContradictionException {
        solver = new OptToPBSATAdapter(new PseudoOptDecorator(
                SolverFactory.newDefault()));
        solver.newVar(100);
        IVecInt clause = new VecInt();
        for (int i = 2; i < 100; i += 2) {
            clause.push(-1).push(i);
            solver.addClause(clause);
            clause.clear();
            clause.push(-i).push(i + 1);
            solver.addClause(clause);
            clause.clear();
            clause.push(-i - 1).push(i);
            solver.addClause(clause);
        }
        clause.clear();
        IVec<BigInteger> coefs = new Vec<BigInteger>();
        for (int i = 1; i <= 10; i++) {
            clause.push(i);
        }
        solver.addClause(clause);
        clause.clear();
        for (int i = 20; i <= 40; i++) {
            clause.push(i);
        }
        solver.addClause(clause);
        clause.clear();
        for (int i = 1; i <= 100; i++) {
            clause.push(i);
            coefs.push(BigInteger.ONE);
        }
        solver.setObjectiveFunction(new ObjectiveFunction(clause, coefs));

    }
