@Test
    public void testTimeoutConflictsLoop() throws ContradictionException,
            TimeoutException, NoSuchFieldException, SecurityException,
            IllegalArgumentException, IllegalAccessException {

        for (int i = 0; i < 1000; i++) {
            solver = SolverFactory.newEclipseP2();
            IVecInt clause = new VecInt();
            clause.push(1).push(2).push(3);
            solver.addClause(clause);
            solver.setTimeoutOnConflicts(10);
            assertTrue(solver.isSatisfiable());
            Field field = solver.getSolvingEngine().getClass().getSuperclass()
                    .getSuperclass().getDeclaredField("timer");
            field.setAccessible(true);
            assertNull(field.get(solver.getSolvingEngine()));
        }
    }
