@Test
    public void testWBO2() throws ContradictionException, TimeoutException,
            ParseFormatException, IOException {
        String wbo = "* #variable= 2 #constraint= 3 #soft= 2 mincost= 2 maxcost= 3 sumcost= 5\nsoft: 6 ;\n[2] +1 x1 >= 1 ;\n[3] +1 x2 >= 1 ;\n-1 x1 -1 x2 >= -1 ;\n";
        reader.parseInstance(new StringBufferInputStream(wbo));
        assertTrue(solver.isSatisfiable());
        IVecInt sol = new VecInt(solver.model());
        assertTrue(sol.contains(-1));
        assertTrue(sol.contains(2));
        assertEquals(BigInteger.valueOf(2), solver.getCurrentObjectiveValue());
    }
