@Test
    public void testWithCard() throws ContradictionException, TimeoutException {
        IVecInt lits = new VecInt(new int[] { 1, 2, 3 });
        IVec<BigInteger> coeffs_good = new Vec<BigInteger>(new BigInteger[] {
                BigInteger.ONE, BigInteger.ONE, BigInteger.ONE });
        IPBSolver solver = SolverFactory.newDefault();
        solver.newVar(3);
        IConstr constr = null;
        solver.addAtMost(lits, 2);
        boolean is_sat = solver.isSatisfiable();
        assertTrue(is_sat);
        constr = solver.addPseudoBoolean(lits, coeffs_good, true,
                new BigInteger("3"));
        is_sat = solver.isSatisfiable();
        assertFalse(is_sat);
        solver.removeConstr(constr);
        is_sat = solver.isSatisfiable();
        assertTrue(is_sat);
    }
