@Test
    public void testWithPB() throws ContradictionException, TimeoutException {
        IVecInt lits = new VecInt(new int[] { 1, 2, 3 });
        IVec<BigInteger> coeffs_bug = new Vec<BigInteger>(new BigInteger[] {
                BigInteger.ONE, BigInteger.ONE, new BigInteger("2") });
        IPBSolver solver = SolverFactory.newDefault();
        solver.newVar(3);
        IConstr constr = null;
        solver.addAtMost(lits, 2);
        boolean is_sat = solver.isSatisfiable();
        assertTrue(is_sat);
        constr = solver.addPseudoBoolean(lits, coeffs_bug, true,
                new BigInteger("4"));
        is_sat = solver.isSatisfiable();
        assertFalse(is_sat);
        solver.removeConstr(constr);
        is_sat = solver.isSatisfiable();
        assertTrue(is_sat);
    }
