@Test
    public void testSimpleResolverUnitLast() throws ContradictionException,
            TimeoutException {
        IPBSolver solver = SolverFactory.newEclipseP2();
        DependencyHelper<Named, String> helper = new DependencyHelper<Named, String>(
                solver, false);
        Set<Named> slice = new HashSet<Named>();
        Named A1 = new Named("A1");
        slice.add(A1);
        Named A2 = new Named("A2");
        slice.add(A2);
        Named B = new Named("B");
        slice.add(B);
        Named X = new Named("X");
        // objective function
        helper.addToObjectiveFunction(A2, 1);
        helper.addToObjectiveFunction(A1, 2);
        helper.addToObjectiveFunction(B, 1);
        // depends
        helper.or("a", X, new Named[] { A1, A2 });
        helper.or("b", X, new Named[] { B });
        // base
        helper.setTrue(X, "Build");
        // solve
        assertTrue(helper.hasASolution());
        IVec<Named> solution = helper.getSolution();
        assertEquals(3, solution.size());
        assertTrue(solution.contains(B));
        assertTrue(solution.contains(X));
        assertTrue(solution.contains(A2));
    }
