@Test
    public void testUnitClause() {
        this.system.newVar(3);
        try {
            // x_1 v x_2 <=> x_3
            this.system.addClause(new VecInt(new int[] { 1, 2, -3 }));
            this.system.addClause(new VecInt(new int[] { -1, 3 }));
            this.system.addClause(new VecInt(new int[] { -2, 3 }));
            // not both true
            this.system.addClause(new VecInt(new int[] { -1, -2 }));
            // x2 is true
            IConstr unit = this.system.addClause(new VecInt(new int[] { 2 }));
            assertNotNull(this.solvername + " has unit clause problem", unit);
            // x3 is true
            IConstr cl = this.system.addAtLeast(new VecInt(new int[] { 3 }), 1);
            assertNotNull(this.solvername + " has unit clause problem", cl);
            int[] model = this.system.findModel();
            assertNotNull(this.solvername + " has a model problem", model);
            this.system.removeConstr(cl);
            // x3 is true
            cl = this.system.addAtLeast(new VecInt(new int[] { 3 }), 1);
            assertNotNull(this.solvername + " has unit clause problem", cl);
            // x1 is true
            // so here x1, x2 and x3 is true
            IConstr r = this.system.addClause(new VecInt(new int[] { 1 }));
            assertNotNull(r);
            assertNotNull(this.solvername + " has unit clause problem", r);
            model = this.system.findModel();
            assertNull(this.solvername + " has a model problem", model);
        } catch (ContradictionException e) {
        } catch (TimeoutException e) {
        }
        ;
    }
