@Test
    public void testObjectiveFunctionMax() throws ParseFormatException,
            ContradictionException {
        String json = "[['max',[[1,1],[20,2],[80,3]]],[-1,-2,-3],[[1,-2,3],'>',2],[4,-3,6],[[[1,1],[2,2],[4,3],[8,4]],'<=',6]]";
        reader.parseString(json);
        IVecInt objvars = new VecInt().push(1).push(2).push(3);
        IVec<BigInteger> objcoefs = new Vec<BigInteger>()
                .push(new BigInteger("-1")).push(new BigInteger("-20"))
                .push(new BigInteger("-80"));
        ObjectiveFunction obj = new ObjectiveFunction(objvars, objcoefs);
        IVecInt clause1 = new VecInt().push(-1).push(-2).push(-3);
        IVecInt card = new VecInt().push(1).push(-2).push(3);
        IVecInt clause2 = new VecInt().push(4).push(-3).push(6);
        IVecInt lits = new VecInt().push(1).push(2).push(3).push(4);
        IVecInt coefs = new VecInt().push(1).push(2).push(4).push(8);
        InOrder inOrder = inOrder(solver);
        inOrder.verify(solver).setObjectiveFunction(obj);
        inOrder.verify(solver).addClause(clause1);
        inOrder.verify(solver).addAtLeast(card, 3);
        inOrder.verify(solver).addClause(clause2);
        inOrder.verify(solver).addAtMost(lits, coefs, 6);
    }
