@Test
    public void testSimple() throws ContradictionException, TimeoutException {
        IVecInt clause = new VecInt();
        clause.push(1).push(2).push(3);
        lexico.addClause(clause);
        clause.clear();
        clause.push(2).push(4).push(5);
        lexico.addClause(clause);
        clause.clear();
        clause.push(6).push(7).push(8);
        lexico.addClause(clause);
        clause.clear();
        clause.push(1).push(2).push(3).push(4).push(5).push(6).push(7).push(8);
        lexico.addCriterion(clause);

        IPBSolver solver = new OptToPBSATAdapter(lexico);
        try {
            if (solver.isSatisfiable()) {
                int[] expectedModel = new int[] { -1, 2, -3, -4, -5, 6, -7,
                        -8 };
                int[] actualModel = solver.model();
                for (int i = 0; i < expectedModel.length; ++i) {
                    assertEquals(expectedModel[i], actualModel[i]);
                }
                assertEquals(BigInteger.valueOf(2), lexico.getObjectiveValue());

            }
        } catch (TimeoutException e) {
            fail(e.getMessage());
        }
    }
