@Test
	public void testJunitExample() throws ContradictionException,
			TimeoutException {
		this.helper.implication(profile).implies(junit3)
				.named("profile->junit_3");
		this.helper.implication(profile).implies(junit4)
				.named("profile->junit_4");
		this.helper.setObjectiveFunction(WeightedObject.newWO(junit4, 1),
				WeightedObject.newWO(junit3, 2));
		this.helper.setTrue(profile, "profile must exist");
		assertTrue(this.helper.hasASolution());
		List<String> expected = new ArrayList<String>(Arrays.asList(profile,
				junit3, junit4));
		IVec<String> solution = this.helper.getSolution();
		for (Iterator<String> i = solution.iterator(); i.hasNext();) {
			String variable = i.next();
			assertTrue(variable + " was not part of the solution",
					expected.remove(variable));
		}
		assertTrue("solution contained too many variables: " + expected,
				expected.isEmpty());
	}
