@Test
	public void testPseudoConstraints() throws ContradictionException,
			TimeoutException {
		this.helper.setNegator(StringNegator.INSTANCE);
		// 3A + 2B + C <= 5
		this.helper.atMost("C1", BigInteger.valueOf(5),
				WeightedObject.newWO("A", 3), WeightedObject.newWO("B", 2),
				WeightedObject.newWO("C", 1));
		this.helper.atLeast("C2", BigInteger.valueOf(7),
				WeightedObject.newWO("A", 6), WeightedObject.newWO("B", 4),
				WeightedObject.newWO("C", 2));
		assertTrue(this.helper.hasASolution());
		IVec<String> solution = this.helper.getSolution();
		assertTrue(solution.contains("A"));
		assertFalse(solution.contains("B") && solution.contains("C"));
	}
