@Test
    public void testRemovalOfConstraintsPropagatingLiterals()
            throws ContradictionException, TimeoutException {
        IPBSolver solver = buildSolver1();
        IVecInt literals = new VecInt(new int[] { 4, 5, 6, 7 });
        IVecInt coeffs = new VecInt(new int[] { 12, 10, 8, 6 });
        IConstr c1 = solver.addAtMost(literals, coeffs, 8);
        IConstr c2 = solver.addAtMost(literals, coeffs, 6);
        assertTrue(solver.isSatisfiable());
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { 4 })));
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { 5 })));
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { 6 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 7 })));
        solver.removeConstr(c2);
        assertTrue(solver.isSatisfiable());
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { 4 })));
        assertFalse(solver.isSatisfiable(new VecInt(new int[] { 5 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 6 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 7 })));
        solver.removeConstr(c1);
        assertTrue(solver.isSatisfiable());
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 4 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 5 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 6 })));
        assertTrue(solver.isSatisfiable(new VecInt(new int[] { 7 })));

    }
