@Test
    public void testConflictingRequirements() throws ContradictionException,
            TimeoutException {
        this.helper.setTrue("profile", "profile must exist");
        this.helper.implication("profile").implies("a_1").named("profile->a_1");
        this.helper.implication("profile").implies("b_1").named("profile->b_1");
        addExtraImplications("profile");
        this.helper.implication("a_1").implies("c_1").named("a_1->c_1");
        addExtraImplications("a_1");
        this.helper.implication("b_1").implies("d_1").named("b_1->d_1");
        addExtraImplications("b_1");
        this.helper.implication("c_1").implies("d_2").named("c_1->d_2");
        addExtraImplications("c_1");
        this.helper.setTrue("d_1", "d_1 exists");
        this.helper.setTrue("d_2", "d_2 exists");
        this.helper.atMost(1, "d_1", "d_2").named("singleton on d");

        Explanation<String> explanation = new Explanation<String>();
        Conflict<String> conflict = explanation.newConflict();
        conflict.newRoot("profile must exist").newChild("profile->a_1")
                .newChild("a_1->c_1").newChild("c_1->d_2");
        conflict.newRoot("profile must exist").newChild("profile->b_1")
                .newChild("b_1->d_1");
        checkExplanationForConflict(explanation);
    }
