@Test(timeout = 10000)
    public void testRequiredSoftwareDependsOnOlderVersion()
            throws ContradictionException, TimeoutException {
        this.helper.setTrue("profile", "profile must exist");
        this.helper.implication("profile").implies("a_1").named("profile->a_1");
        addExtraImplications("profile");
        this.helper.implication("a_1").implies("b_1").named("a_1->b_1");
        addExtraImplications("a_1");
        this.helper.implication("b_1").implies("c_[2,3)").named("b_1->c_[2,3)");
        addExtraImplications("b_1");
        this.helper.implication("c_[2,3)").implies("p(c_[2,3))")
                .named("c_[2,3) does not exist");
        this.helper.setFalse("p(c_[2,3))", "placeholder(c_[2,3))");

        Explanation<String> explanation = new Explanation<String>();
        explanation.newFalseRoot("profile must exist").newChild("profile->a_1")
                .newChild("a_1->b_1").newChild("b_1->c_[2,3)")
                .newChild("c_[2,3) does not exist")
                .newChild("placeholder(c_[2,3))");
        checkExplanationForMissingRequirement(explanation);
    }
