@Test(timeout = 10000)
    public void testRequiredSoftwareDependsOnOlderVersionDeepTree()
            throws ContradictionException, TimeoutException {
        this.helper.setTrue("profile", "profile must exist");
        this.helper.implication("profile").implies("a_1").named("profile->a_1");
        addExtraImplications("profile");

        Explanation<String> explanation = new Explanation<String>();
        DepdendenyNode<String> node = explanation.newFalseRoot(
                "profile must exist").newChild("profile->a_1");

        String lastThing = "a_1";
        for (int i = 0; i < 10; i++) {
            String newThing = "newThing" + i;
            String name = lastThing + "->" + newThing;
            this.helper.implication(lastThing).implies(newThing).named(name);
            node = node.newChild(name);
            addExtraImplications(lastThing);
            lastThing = newThing;
        }
        this.helper.implication(lastThing).implies("c_[2,3)")
                .named("b_1->c_[2,3)");
        node = node.newChild("b_1->c_[2,3)");
        addExtraImplications(lastThing);
        this.helper.implication("c_[2,3)").implies("p(c_[2,3))")
                .named("c_[2,3) does not exist");
        node = node.newChild("c_[2,3) does not exist");
        this.helper.setFalse("p(c_[2,3))", "placeholder(c_[2,3))");
        node = node.newChild("placeholder(c_[2,3))");

        checkExplanationForMissingRequirement(explanation);
    }
