@Test(timeout = 10000)
    public void testUseNumberOfMissingVariablesToOrderExplanations()
            throws ContradictionException, TimeoutException {
        this.helper.setTrue("profile", "profile must exist");
        this.helper.implication("profile").implies("a_1").named("profile->a_1");
        this.helper.implication("profile").implies("a_2").named("profile->a_2");
        addExtraImplications("profile");
        this.helper.implication("a_1").implies("b_1").named("a_1->b_1");
        addExtraImplications("a_1");
        this.helper.implication("a_2").implies("b_1").named("a_2->b_1");
        this.helper.implication("a_2").implies("d").named("a_2->d");
        addExtraImplications("a_2");
        this.helper.implication("b_1").implies("c_[2,3)").named("b_1->c_[2,3)");
        addExtraImplications("b_1");

        // Need some way to weight a_2 > a_1 & b_2 > b_1
        this.helper.setObjectiveFunction(newWO("a_1", 2), newWO("a_2", 1),
                newWO("b_1", 8), newWO("b_2", 4));
        this.helper.implication("c_[2,3)").implies("p(c_[2,3))")
                .named("c_[2,3) does not exist");
        this.helper.setFalse("p(c_[2,3))", "placeholder(c_[2,3))");
        this.helper.implication("d").implies("p(d)").named("d does not exist");
        this.helper.setFalse("p(d)", "placeholder(d)");

        Explanation<String> explanation = new Explanation<String>();
        explanation.newFalseRoot("profile must exist").newChild("profile->a_1")
                .newChild("a_1->b_1").newChild("b_1->c_[2,3)")
                .newChild("c_[2,3) does not exist")
                .newChild("placeholder(c_[2,3))");
        checkExplanationForMissingRequirement(explanation);
    }
