@Test
    public void testAlmostGlobalInconsistencyII()
            throws ContradictionException, TimeoutException {
        XplainPB solver = new XplainPB(SolverFactory.newDefault());
        solver.newVar(3);
        IVec<BigInteger> coeffs = new Vec<BigInteger>();
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        IVecInt clause = new VecInt();
        clause.push(1).push(2);
        IConstr c1 = solver.addPseudoBoolean(clause, coeffs, true,
                BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(1).push(-2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        IConstr c2 = solver.addPseudoBoolean(clause, coeffs, true,
                BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(1).push(3);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        solver.addPseudoBoolean(clause, coeffs, true, BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(-1).push(2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        IConstr c4 = solver.addPseudoBoolean(clause, coeffs, true,
                BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(-1).push(-2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        IConstr c5 = solver.addPseudoBoolean(clause, coeffs, true,
                BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        assertFalse(solver.isSatisfiable());
        Collection<IConstr> explanation = solver.explain();
        assertEquals(4, explanation.size());
        assertTrue(explanation.contains(c1));
        assertTrue(explanation.contains(c2));
        assertTrue(explanation.contains(c4));
        assertTrue(explanation.contains(c5));
    }
