@Test
    public void testGlobalInconsistency() throws ContradictionException,
            TimeoutException {
        XplainPB solver = new XplainPB(SolverFactory.newDefault());
        solver.newVar(2);
        IVec<BigInteger> coeffs = new Vec<BigInteger>();
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        IVecInt clause = new VecInt();
        clause.push(1).push(2);
        solver.addPseudoBoolean(clause, coeffs, true, BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(1).push(-2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        solver.addPseudoBoolean(clause, coeffs, true, BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(-1).push(2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        solver.addPseudoBoolean(clause, coeffs, true, BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        clause.push(-1).push(-2);
        coeffs.push(BigInteger.ONE).push(BigInteger.ONE);
        solver.addPseudoBoolean(clause, coeffs, true, BigInteger.ONE);
        clause.clear();
        coeffs.clear();
        assertFalse(solver.isSatisfiable());
        Collection<IConstr> explanation = solver.explain();
        assertEquals(4, explanation.size());
    }
