@Override
    public void createPanel() {

        this.setBorder(new CompoundBorder(new TitledBorder(null,
                this.getName(), TitledBorder.LEFT, TitledBorder.TOP),
                DetailedCommandPanel.BORDER5));

        this.setLayout(new BorderLayout());

        this.cleanSlider = new JSlider(SwingConstants.HORIZONTAL, CLEAN_MIN,
                CLEAN_MAX, CLEAN_INIT);

        this.cleanSlider.setMajorTickSpacing(CLEAN_SPACE);
        this.cleanSlider.setPaintTicks(true);

        // Create the label table
        Dictionary<Integer, JLabel> cleanValuesTable = new Hashtable<Integer, JLabel>();
        cleanValuesTable.put(0, this.clean5000Label);
        cleanValuesTable.put(1, this.clean10000Label);
        cleanValuesTable.put(2, this.clean20000Label);
        cleanValuesTable.put(3, this.clean50000Label);
        cleanValuesTable.put(4, this.clean100000Label);
        cleanValuesTable.put(5, this.clean500000Label);
        this.cleanSlider.setLabelTable(cleanValuesTable);

        this.cleanSlider.setPaintLabels(true);
        this.cleanSlider.setSnapToTicks(true);

        this.cleanSlider.setPreferredSize(new Dimension(400, 50));

        JPanel tmpPanel1 = new JPanel();
        tmpPanel1.add(this.deleteClauseLabel);
        tmpPanel1.add(this.cleanSlider);

        JPanel tmpPanel4 = new JPanel();

        this.evaluationLabel = new JLabel(EVALUATION_TYPE);
        ButtonGroup evaluationGroup = new ButtonGroup();
        this.activityRadio = new JRadioButton(ACTIVITY_BASED);
        this.lbdRadio = new JRadioButton(LBD_BASED);
        this.lbd2Radio = new JRadioButton(LBD2_BASED);

        evaluationGroup.add(this.activityRadio);
        evaluationGroup.add(this.lbdRadio);
        evaluationGroup.add(this.lbd2Radio);

        tmpPanel4.add(this.evaluationLabel);
        tmpPanel4.add(this.activityRadio);
        tmpPanel4.add(this.lbdRadio);
        tmpPanel4.add(this.lbd2Radio);

        this.cleanAndEvaluationApplyButton = new JButton("Apply changes");
        this.cleanAndEvaluationApplyButton
                .addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        hasChangedCleaningValue();
                    }
                });

        JPanel tmpPanel5 = new JPanel();
        tmpPanel5.add(this.cleanAndEvaluationApplyButton);

        JPanel tmpPanel = new JPanel();
        tmpPanel.setBorder(new CompoundBorder(new TitledBorder(null, "",
                TitledBorder.LEFT, TitledBorder.TOP),
                DetailedCommandPanel.BORDER5));

        tmpPanel.setLayout(new BorderLayout());

        tmpPanel.add(tmpPanel1, BorderLayout.NORTH);
        tmpPanel.add(tmpPanel4, BorderLayout.CENTER);
        tmpPanel.add(tmpPanel5, BorderLayout.SOUTH);

        JPanel tmpPanel2 = new JPanel();

        this.manualCleanLabel = new JLabel(MANUAL_CLEAN);

        this.cleanButton = new JButton(CLEAN);

        this.cleanButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                hasClickedOnClean();
            }
        });

        tmpPanel2.add(this.manualCleanLabel);
        tmpPanel2.add(this.cleanButton);

        JPanel tmpPanel3 = new JPanel();
        this.cleanUseOriginalStrategyCB = new JCheckBox(USE_ORIGINAL_STRATEGY);
        this.cleanUseOriginalStrategyCB.setSelected(true);

        this.cleanUseOriginalStrategyCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                hasClickedOnUseOriginalStrategy();
            }
        });

        tmpPanel3.add(this.cleanUseOriginalStrategyCB);

        JPanel tmpPanel6 = new JPanel();
        this.speedLabel = new JLabel("");
        this.speedNameLabel = new JLabel(SPEED);
        this.speedUnitLabel = new JLabel(SPEED_UNIT);

        tmpPanel6.add(this.speedNameLabel);
        tmpPanel6.add(this.speedLabel);
        tmpPanel6.add(this.speedUnitLabel);

        JPanel tmpPanel7 = new JPanel();
        tmpPanel7.setLayout(new BorderLayout());

        tmpPanel7.add(tmpPanel2, BorderLayout.SOUTH);
        tmpPanel7.add(tmpPanel6, BorderLayout.CENTER);

        this.add(tmpPanel3, BorderLayout.NORTH);
        this.add(tmpPanel7, BorderLayout.CENTER);
        this.add(tmpPanel, BorderLayout.SOUTH);

    }
