private void createChoixSolverPanel() {
        this.choixSolverPanel = new JPanel();

        this.choixSolverPanel.setName(CHOIX_SOLVER_PANEL);
        this.choixSolverPanel.setBorder(new CompoundBorder(new TitledBorder(
                null, this.choixSolverPanel.getName(), TitledBorder.LEFT,
                TitledBorder.TOP), BORDER5));

        this.choixSolverPanel.setLayout(new BoxLayout(choixSolverPanel,
                BoxLayout.Y_AXIS));

        this.choixSolver = new JLabel(CHOIX_SOLVER);

        this.listeSolvers = new JComboBox();

        updateListOfSolvers();

        JPanel tmpPanel1 = new JPanel();
        tmpPanel1.add(this.choixSolver);
        tmpPanel1.add(this.listeSolvers);

        this.startStopButton = new JButton(START);

        this.startStopButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                manageStartStopButton();
            }
        });

        this.pauseButton = new JButton(PAUSE);
        this.pauseButton.setEnabled(false);

        this.pauseButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (DetailedCommandPanel.this.pauseButton.getText().equals(
                        PAUSE)) {
                    DetailedCommandPanel.this.pauseButton.setText(RESUME);
                    DetailedCommandPanel.this.telecomStrategy
                            .setInterrupted(true);
                } else {
                    DetailedCommandPanel.this.pauseButton.setText(PAUSE);
                    DetailedCommandPanel.this.telecomStrategy
                            .setInterrupted(false);
                }

            }
        });

        JPanel tmpPanel = new JPanel();
        tmpPanel.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();

        tmpPanel.setName("Cardinality Constraints Encodings");
        tmpPanel.setBorder(new CompoundBorder(new TitledBorder(null, tmpPanel
                .getName(), TitledBorder.LEFT, TitledBorder.TOP), BORDER5));

        JLabel atMostKLabel = new JLabel(AT_MOST_K);
        atMostKCB = new JComboBox(new DefaultComboBoxModel(getListOfEncodings(
                AT_MOST_K).toArray()));

        JLabel atMost1Label = new JLabel(AT_MOST_1);
        atMost1CB = new JComboBox(new DefaultComboBoxModel(getListOfEncodings(
                AT_MOST_1).toArray()));

        JLabel exactlyKLabel = new JLabel(EXACTLY_K);
        exactlyKCB = new JComboBox(new DefaultComboBoxModel(getListOfEncodings(
                EXACTLY_K).toArray()));

        JLabel exactly1Label = new JLabel(EXACTLY_1);
        exactly1CB = new JComboBox(new DefaultComboBoxModel(getListOfEncodings(
                EXACTLY_1).toArray()));

        c.fill = GridBagConstraints.NONE;
        c.weightx = 0.2;
        c.gridx = 0;
        c.gridy = 0;
        c.anchor = GridBagConstraints.LINE_END;

        tmpPanel.add(atMostKLabel, c);

        c.gridx = 0;
        c.gridy = 1;
        tmpPanel.add(atMost1Label, c);

        c.gridx = 2;
        c.gridy = 1;
        tmpPanel.add(exactly1Label, c);

        c.gridx = 2;
        c.gridy = 0;
        tmpPanel.add(exactlyKLabel, c);

        c.fill = GridBagConstraints.HORIZONTAL;
        c.anchor = GridBagConstraints.LINE_START;
        c.weightx = 0.8;
        c.gridx = 1;
        c.gridy = 0;
        tmpPanel.add(atMostKCB, c);

        c.gridx = 3;
        c.gridy = 0;
        tmpPanel.add(exactlyKCB, c);

        c.gridx = 1;
        c.gridy = 1;
        tmpPanel.add(atMost1CB, c);

        c.gridx = 3;
        c.gridy = 1;
        tmpPanel.add(exactly1CB, c);

        JPanel tmpPanel2 = new JPanel();
        tmpPanel2.setLayout(new GridBagLayout());

        GridBagConstraints c2 = new GridBagConstraints();
        c2.anchor = GridBagConstraints.LINE_START;
        c2.fill = GridBagConstraints.NONE;
        c2.weightx = 1;
        c2.gridx = 0;

        tmpPanel2.setName(CHOOSE_START_CONFIG);
        tmpPanel2.setBorder(new CompoundBorder(new TitledBorder(null, tmpPanel2
                .getName(), TitledBorder.LEFT, TitledBorder.TOP), BORDER5));

        this.solverLineParamLineRadio = new JRadioButton(
                SOLVER_LINE_PARAM_LINE_CONFIG);
        this.solverLineParamRemoteRadio = new JRadioButton(
                SOLVER_LINE_PARAM_REMOTE_CONFIG);
        this.solverListParamRemoteRadio = new JRadioButton(
                SOLVER_LIST_PARAM_REMOTE_CONFIG);
        this.solverListParamListRadio = new JRadioButton(
                SOLVER_LIST_PARAM_LIST_CONFIG);

        ButtonGroup solverConfigGroup = new ButtonGroup();
        solverConfigGroup.add(this.solverLineParamLineRadio);
        solverConfigGroup.add(this.solverLineParamRemoteRadio);
        solverConfigGroup.add(this.solverListParamListRadio);
        solverConfigGroup.add(this.solverListParamRemoteRadio);

        this.solverListParamListRadio.setSelected(true);
        this.startConfig = StartSolverEnum.SOLVER_LIST_PARAM_DEFAULT;

        c2.gridy = 0;
        tmpPanel2.add(this.solverLineParamLineRadio, c2);
        c2.gridy = 1;
        tmpPanel2.add(this.solverLineParamRemoteRadio, c2);
        c2.gridy = 2;
        tmpPanel2.add(this.solverListParamListRadio, c2);
        c2.gridy = 3;
        tmpPanel2.add(this.solverListParamRemoteRadio, c2);

        JPanel tmpPanel3 = new JPanel();
        tmpPanel3.setLayout(new FlowLayout());
        tmpPanel3.add(this.startStopButton);
        tmpPanel3.add(this.pauseButton);

        this.choixSolverPanel.add(tmpPanel1);
        this.choixSolverPanel.add(tmpPanel);
        this.choixSolverPanel.add(tmpPanel2);
        this.choixSolverPanel.add(tmpPanel3);

        atMostKCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                encodingPolicy.setAtMostKEncoding((EncodingStrategy) atMostKCB
                        .getSelectedItem());
            }
        });

        atMost1CB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                encodingPolicy
                        .setAtMostOneEncoding((EncodingStrategy) atMost1CB
                                .getSelectedItem());
            }
        });

        exactlyKCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                encodingPolicy
                        .setExactlyKEncoding((EncodingStrategy) exactlyKCB
                                .getSelectedItem());
            }
        });

        exactly1CB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                encodingPolicy
                        .setExactlyOneEncoding((EncodingStrategy) exactly1CB
                                .getSelectedItem());
            }
        });

        this.solverLineParamLineRadio.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (DetailedCommandPanel.this.solverLineParamLineRadio
                        .isSelected()) {
                    DetailedCommandPanel.this.startConfig = StartSolverEnum.SOLVER_LINE_PARAM_LINE;
                }
            }
        });

        this.solverLineParamRemoteRadio.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (DetailedCommandPanel.this.solverLineParamRemoteRadio
                        .isSelected()) {
                    DetailedCommandPanel.this.startConfig = StartSolverEnum.SOLVER_LINE_PARAM_REMOTE;
                }
            }
        });

        this.solverListParamListRadio.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (DetailedCommandPanel.this.solverListParamListRadio
                        .isSelected()) {
                    DetailedCommandPanel.this.startConfig = StartSolverEnum.SOLVER_LIST_PARAM_DEFAULT;
                }
            }
        });

        this.solverListParamRemoteRadio.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (DetailedCommandPanel.this.solverListParamRemoteRadio
                        .isSelected()) {
                    DetailedCommandPanel.this.startConfig = StartSolverEnum.SOLVER_LIST_PARAM_REMOTE;
                }
            }
        });

        setChoixSolverPanelEnabled(true);

        if (this.solver == null) {
            this.solverLineParamLineRadio.setEnabled(false);
            this.solverLineParamRemoteRadio.setEnabled(false);
        }

        if (this.firstStart) {
            this.solverLineParamRemoteRadio.setEnabled(false);
            this.solverListParamRemoteRadio.setEnabled(false);
        }

    }
