private void createInstancePanel() {
        this.instancePanel = new JPanel();

        this.instancePanel.setName(INSTANCE_PANEL);
        this.instancePanel.setBorder(new CompoundBorder(new TitledBorder(null,
                this.instancePanel.getName(), TitledBorder.LEFT,
                TitledBorder.TOP), BORDER5));

        this.instancePanel.setLayout(new BorderLayout(0, 0));

        this.instanceLabel = new JLabel(INSTANCE);
        this.instancePathField = new JTextField(20);
        this.instancePathField.setText(this.instancePath);

        this.instanceLabel.setLabelFor(this.instancePathField);

        this.browseButton = new JButton(BROWSE);

        this.browseButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                openFileChooser();
                updateListOfSolvers();
            }
        });

        this.optimisationModeCB = new JCheckBox(OPTMIZATION_MODE);
        this.optimisationModeCB.setSelected(this.optimizationMode);

        this.equivalenceCB = new JCheckBox(EQUIVALENCE);
        this.equivalenceCB.setSelected(this.equivalenceMode);

        this.lowerCB = new JCheckBox(LOWER);
        this.lowerCB.setSelected(this.lowerMode);

        JPanel tmpPanel11 = new JPanel();
        tmpPanel11.add(this.instanceLabel);
        tmpPanel11.add(this.instancePathField);
        tmpPanel11.add(this.browseButton);

        JPanel tmpPanel12 = new JPanel();
        tmpPanel12.setLayout(new BoxLayout(tmpPanel12, BoxLayout.Y_AXIS));
        tmpPanel12.add(this.optimisationModeCB);
        tmpPanel12.add(this.equivalenceCB);
        tmpPanel12.add(this.lowerCB);

        this.optimisationModeCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setOptimisationMode(optimisationModeCB.isSelected());
                log("use optimization mode: "
                        + DetailedCommandPanel.this.optimizationMode);
                updateListOfSolvers();
            }
        });

        this.equivalenceCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                equivalenceMode = equivalenceCB.isSelected();
            }
        });

        this.lowerCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                lowerMode = lowerCB.isSelected();
            }
        });

        instancePanel.setLayout(new BoxLayout(instancePanel, BoxLayout.Y_AXIS));

        instancePanel.add(tmpPanel11);
        instancePanel.add(tmpPanel12);
    }
