public void updateListOfSolvers() {
        List<String> theList = new ArrayList<String>();
        String defaultSolver = "";

        if (instancePath == null || instancePath.length() == 0) {
            theList = getListOfSolvers();
            defaultSolver = "minisat.Default";
            problemType = ProblemType.CNF_SAT;
            equivalenceCB.setEnabled(false);
            lowerCB.setEnabled(false);
        } else if (instancePath.endsWith(".cnf")) {
            optimisationModeCB.setEnabled(true);
            if (optimizationMode) {
                theList.addAll(getListOfMaxsatSolvers());
                theList.addAll(getListOfPBSolvers());
                defaultSolver = "maxsat.Default";
                equivalenceCB.setEnabled(true);
                lowerCB.setEnabled(true);
                problemType = ProblemType.CNF_MAXSAT;
                log("cnf file + opt => pb/maxsat solvers");
            } else {
                theList.addAll(getListOfSatSolvers());
                theList.addAll(getListOfPBSolvers());
                defaultSolver = "minisat.Default";
                log("cnf file + non opt => sat/pb solvers");
                problemType = ProblemType.CNF_SAT;
                equivalenceCB.setEnabled(false);
                lowerCB.setEnabled(false);
            }
        } else if (instancePath.endsWith(".opb")) {
            optimisationModeCB.setEnabled(true);
            theList.addAll(getListOfPBSolvers());
            defaultSolver = "pb.Default";
            if (optimizationMode) {
                problemType = ProblemType.PB_OPT;
                equivalenceCB.setEnabled(true);
                lowerCB.setEnabled(true);
            } else {
                problemType = ProblemType.PB_SAT;
                equivalenceCB.setEnabled(false);
                lowerCB.setEnabled(false);
            }
            log("opb file => pb solvers");
        } else if (instancePath.endsWith(".wcnf")) {
            equivalenceCB.setEnabled(true);
            lowerCB.setEnabled(true);
            theList.addAll(getListOfMaxsatSolvers());
            theList.addAll(getListOfPBSolvers());
            defaultSolver = "maxsat.Default";
            optimisationModeCB.setSelected(true);
            optimisationModeCB.setEnabled(false);
            problemType = ProblemType.WCNF_MAXSAT;
            log("wcnf file => pb/maxsat solvers");
        }
        this.listeSolvers.setModel(new DefaultComboBoxModel(theList.toArray()));
        this.listeSolvers.setSelectedItem(defaultSolver);
        this.choixSolverPanel.repaint();
    }
