public void hasClickedOnApplyPhase() {
        String phaseName = (String) this.phaseList.getSelectedItem();
        this.currentPhaseSelectionStrategy = phaseName;
        IPhaseSelectionStrategy phase = null;
        try {
            phase = (IPhaseSelectionStrategy) Class.forName(
                    PHASE_PATH_SAT + "." + phaseName).newInstance();
            phase.init(this.solverController.getNVar() + 1);
            this.solverController.setPhaseSelectionStrategy(phase);

        } catch (ClassNotFoundException e) {
            LOGGER.log(Level.INFO, "Invalid Phase Class error", e);
        } catch (IllegalAccessException e) {
            LOGGER.log(Level.INFO, "Invalid Phase Access error", e);
        } catch (InstantiationException e) {
            LOGGER.log(Level.INFO, "Invalid Phase Instanciation error", e);
        }

    }
