public static Set<String> findnames(String pckgname, Class<?> tosubclass,
            boolean fullname) {
        Set<String> v = new HashSet<String>();

        // Code from JWhich
        // ======
        // Translate the package name into an absolute path
        String name = pckgname;
        if (!name.startsWith("/")) {
            name = "/" + name;
        }
        name = name.replace('.', '/');

        // Get a File object for the package
        URL url = RTSI.class.getResource(name);

        if (url == null) {
            return null;
        }

        File directory = new File(url.getFile());

        // New code
        // ======
        if (directory.exists()) {
            // Get the list of the files contained in the package
            String[] files = directory.list();
            for (String file : files) {

                // we are only interested in .class files
                if (file.endsWith(".class")) {

                    String classname = file.substring(0, file.length() - 6);
                    try {
                        // Try to create an instance of the object
                        Class<?> o = Class.forName(pckgname + "." + classname);

                        if (tosubclass.isAssignableFrom(o) && !o.isInterface()
                                && !Modifier.isAbstract(o.getModifiers())) {
                            if (fullname) {
                                v.add(pckgname + "." + classname);
                            } else {
                                v.add(classname);
                            }
                        }
                    } catch (NoClassDefFoundError cnfex) {

                    } catch (ClassNotFoundException cnfex) {
                        System.err.println(cnfex);
                    }

                }
            }
            File[] dirs = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return new File(dir.getAbsolutePath() + "/" + name)
                            .isDirectory();
                }
            });
            Set<String> tmp;
            for (File dir : dirs) {
                String newName = pckgname + "." + dir.getName();
                tmp = find(newName, tosubclass, fullname);
                if (tmp != null) {
                    v.addAll(tmp);
                }

            }

        } else {
            try {
                // It does not work with the filesystem: we must
                // be in the case of a package contained in a jar file.
                JarURLConnection conn = (JarURLConnection) url.openConnection();
                String starts = conn.getEntryName();
                JarFile jfile = conn.getJarFile();
                Enumeration<JarEntry> e = jfile.entries();
                while (e.hasMoreElements()) {
                    ZipEntry entry = e.nextElement();
                    String entryname = entry.getName();
                    if (entryname.startsWith(starts)
                            && entryname.endsWith(".class")) {
                        String classname = entryname.substring(0,
                                entryname.length() - 6);
                        if (classname.startsWith("/")) {
                            classname = classname.substring(1);
                        }
                        classname = classname.replace('/', '.');
                        try {
                            // Try to create an instance of the object
                            Class<?> o = Class.forName(classname);

                            if (tosubclass.isAssignableFrom(o)
                                    && !o.isInterface()
                                    && !Modifier.isAbstract(o.getModifiers())) {
                                if (fullname) {
                                    v.add(classname);
                                } else {
                                    v.add(classname.substring(classname
                                            .lastIndexOf('.') + 1));
                                }
                            }
                        } catch (NoClassDefFoundError cnfex) {
                        } catch (ClassNotFoundException cnfex) {
                            System.err.print(cnfex);
                        }
                    }
                }
            } catch (IOException ioex) {
                System.err.println(ioex);
            }
        }

        return v;
    }
