public void hasClickedOnChange() {
        this.controller.shouldRestartNow();

        String choix = (String) this.listeRestarts.getSelectedItem();

        boolean isNotSameRestart = !choix.equals(this.currentRestart);
        boolean shouldInit = isNotSameRestart;

        RestartStrategy restart = new NoRestarts();
        SearchParams params = this.controller.getSearchParams();
        SolverStats stats = this.controller.getSolverStats();
        if (choix.equals("LubyRestarts")) {
            boolean factorChanged = false;
            int factor = LubyRestarts.DEFAULT_LUBY_FACTOR;
            if (this.factorField.getText() != null) {
                factor = Integer.parseInt(this.factorField.getText());
            }
            // if the current restart is a LubyRestart
            if (isNotSameRestart) {
                restart = new LubyRestarts(factor);
                this.controller.setRestartStrategy(restart);
            } else {
                factorChanged = !(factor == ((LubyRestarts) this.controller
                        .getRestartStrategy()).getFactor());
            }
            // if the factor has changed
            if (factorChanged) {
                restart = this.controller.getRestartStrategy();
                ((LubyRestarts) restart).setFactor(factor);
            }
            shouldInit = isNotSameRestart || factorChanged;

            if (shouldInit) {
                this.controller.init(params, stats);
            }

        } else {
            try {
                restart = (RestartStrategy) Class.forName(
                        RESTART_PATH + "." + choix).newInstance();
                assert restart != null;
                this.controller.setRestartStrategy(restart);
                this.controller.init(params, stats);

            } catch (ClassNotFoundException e) {
                logger.log(e.getMessage());
            } catch (IllegalAccessException e) {
                logger.log(e.getMessage());
            } catch (InstantiationException e) {
                logger.log(e.getMessage());
            }
        }

        this.currentRestart = choix;

    }
