public static void showAvailableLearning(ILogAble logger) {
        List<String> classNames = new ArrayList<String>();
        List<String> resultRTSI = RTSI.find(LEARNING_NAME);
        Set<String> keySet;
        for (String name : resultRTSI) {
            try {
                keySet = BeanUtils.describe(
                        Class.forName(PACKAGE_LEARNING + "." + name)
                                .newInstance()).keySet();
                keySet.remove(CLASS);
                if (keySet.size() > 0) {
                    classNames.add(name + keySet);
                } else {
                    classNames.add(name);
                }
            } catch (IllegalAccessException e) {
                logger.log(e.getMessage());
            } catch (InvocationTargetException e) {
                logger.log(e.getMessage());
            } catch (NoSuchMethodException e) {
                logger.log(e.getMessage());
            } catch (InstantiationException e) {
                classNames.add(name);
            } catch (ClassNotFoundException e) {
                logger.log(e.getMessage());
            } catch (NoClassDefFoundError cnfex) {
                logger.log(cnfex.getMessage());
            }
        }
        logger.log("Available learning (" + Solvers.LEARNING + "): "
                + classNames);
    }
