public static void showAvailableOrders(ILogAble logger) {
        List<String> classNames = new ArrayList<String>();
        List<String> resultRTSI = RTSI.find(ORDER_NAME);
        Set<String> keySet = null;
        for (String name : resultRTSI) {
            if (!name.contains("Remote")) {
                try {
                    if (name.contains("Objective")) {
                        String namePackage = Solvers.PACKAGE_ORDERS
                                .replaceFirst(MINISAT, PB);
                        keySet = BeanUtils.describe(
                                Class.forName(namePackage + "." + name)
                                        .newInstance()).keySet();
                    } else {
                        keySet = BeanUtils.describe(
                                Class.forName(
                                        Solvers.PACKAGE_ORDERS + "." + name)
                                        .newInstance()).keySet();
                    }
                    keySet.remove(CLASS);

                    if (keySet.size() > 0) {
                        classNames.add(name + keySet);
                    } else {
                        classNames.add(name);
                    }

                } catch (IllegalAccessException e) {
                    logger.log(e.getMessage());
                } catch (InvocationTargetException e) {
                    logger.log(e.getMessage());
                } catch (NoSuchMethodException e) {
                    logger.log(e.getMessage());
                } catch (InstantiationException e) {
                    logger.log(e.getMessage());
                } catch (ClassNotFoundException e) {
                    logger.log(e.getMessage());
                }
            }
        }
        logger.log("Available orders (" + Solvers.ORDERS + "): " + classNames);
    }
