public static void showAvailableRestarts(ILogAble logger) {
        List<String> classNames = new ArrayList<String>();
        List<String> resultRTSI = RTSI.find(RESTART_STRATEGY_NAME);
        Set<String> keySet;
        for (String name : resultRTSI) {
            if (!name.contains("Remote")) {
                try {
                    keySet = BeanUtils
                            .describe(
                                    Class.forName(
                                            Solvers.PACKAGE_RESTARTS + "."
                                                    + name).newInstance())
                            .keySet();
                    keySet.remove(CLASS);
                    if (keySet.size() > 0) {
                        classNames.add(name + keySet);
                    } else {
                        classNames.add(name);
                    }
                } catch (IllegalAccessException e) {
                    logger.log(e.getMessage());
                } catch (InvocationTargetException e) {
                    logger.log(e.getMessage());
                } catch (NoSuchMethodException e) {
                    logger.log(e.getMessage());
                } catch (InstantiationException e) {
                    logger.log(e.getMessage());
                } catch (ClassNotFoundException e) {
                    logger.log(e.getMessage());
                }
            }
        }
        logger.log("Available restart strategies (" + Solvers.RESTARTS + "): "
                + classNames);
    }
