public void initTraces() {
        this.positiveDecisionTrace = new Trace2DSimple("Positive decision");
        this.positiveDecisionTrace.setTracePainter(new TracePainterPlus());
        this.positiveDecisionTrace.setColor(new Color(0f, 0.78f, 0.09f));

        this.negativeDecisionTrace = new Trace2DSimple("Negative decision");
        this.negativeDecisionTrace.setTracePainter(new TracePainterPlus());
        this.negativeDecisionTrace.setColor(Color.RED);

        this.restartPosDecisionTrace = new Trace2DSimple(RESTART);
        this.restartPosDecisionTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.positiveDecisionVariableChart));
        this.restartPosDecisionTrace.setColor(Color.LIGHT_GRAY);

        this.restartNegDecisionTrace = new Trace2DSimple(RESTART);
        this.restartNegDecisionTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.negativeDecisionVariableChart));
        this.restartNegDecisionTrace.setColor(Color.LIGHT_GRAY);

        this.cleanPosDecisionTrace = new Trace2DSimple(CLEAN);
        this.cleanPosDecisionTrace.setTracePainter(new TracePainterVerticalBar(
                2, this.positiveDecisionVariableChart));
        this.cleanPosDecisionTrace.setColor(Color.ORANGE);

        this.cleanNegDecisionTrace = new Trace2DSimple(CLEAN);
        this.cleanNegDecisionTrace.setTracePainter(new TracePainterVerticalBar(
                2, this.negativeDecisionVariableChart));
        this.cleanNegDecisionTrace.setColor(Color.ORANGE);

        this.positiveDecisionVariableChart.addTrace(this.positiveDecisionTrace);
        this.positiveDecisionVariableChart
                .addTrace(this.restartPosDecisionTrace);
        this.positiveDecisionVariableChart.addTrace(this.cleanPosDecisionTrace);
        this.positiveDecisionTrace.setZIndex(ITrace2D.ZINDEX_MAX);

        this.positiveDecisionVariableChart.getAxisX().setRangePolicy(
                new RangePolicyHighestValues(8000));

        this.negativeDecisionVariableChart
                .addTrace(this.restartNegDecisionTrace);
        this.negativeDecisionVariableChart.addTrace(this.cleanNegDecisionTrace);
        this.negativeDecisionVariableChart.addTrace(this.negativeDecisionTrace);
        this.negativeDecisionTrace.setZIndex(ITrace2D.ZINDEX_MAX);
        this.negativeDecisionVariableChart.getAxisX().setRangePolicy(
                this.positiveDecisionVariableChart.getAxisX().getRangePolicy());

        this.conflictDepthTrace = new Trace2DLtd(15000, "Trail level");
        this.conflictDepthTrace.setTracePainter(new TracePainterPlus());
        this.conflictDepthTrace.setColor(Color.MAGENTA);
        this.trailLevelWhenConflictChart
                .setName("Trail level when the conflict occurs");
        this.trailLevelWhenConflictChart.addTrace(this.conflictDepthTrace);
        this.conflictDepthTrace.setZIndex(ITrace2D.ZINDEX_MAX);

        this.conflictDepthRestartTrace = new Trace2DSimple(RESTART);
        this.conflictDepthRestartTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.trailLevelWhenConflictChart));
        this.conflictDepthRestartTrace.setColor(Color.LIGHT_GRAY);
        this.trailLevelWhenConflictChart
                .addTrace(this.conflictDepthRestartTrace);

        this.conflictDepthCleanTrace = new Trace2DSimple(CLEAN);
        this.conflictDepthCleanTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.trailLevelWhenConflictChart));
        this.conflictDepthCleanTrace.setColor(Color.ORANGE);
        this.trailLevelWhenConflictChart.addTrace(this.conflictDepthCleanTrace);
        this.trailLevelWhenConflictChart.getAxisX().setRangePolicy(
                new RangePolicyHighestValues(2000));

        this.conflictLevelTrace = new Trace2DSimple("Decision level");
        this.conflictLevelTrace.setTracePainter(new TracePainterPlus());
        this.conflictLevelTrace.setColor(Color.MAGENTA);
        this.decisionLevelWhenConflictChart
                .setName("Decision level chen the conflict occurs");
        this.decisionLevelWhenConflictChart.addTrace(this.conflictLevelTrace);
        this.conflictLevelTrace.setZIndex(ITrace2D.ZINDEX_MAX);

        this.conflictLevelRestartTrace = new Trace2DSimple(RESTART);
        this.conflictLevelRestartTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.decisionLevelWhenConflictChart));
        this.conflictLevelRestartTrace.setColor(Color.LIGHT_GRAY);
        this.decisionLevelWhenConflictChart
                .addTrace(this.conflictLevelRestartTrace);

        this.conflictLevelCleanTrace = new Trace2DSimple(CLEAN);
        this.conflictLevelCleanTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.decisionLevelWhenConflictChart));
        this.conflictLevelCleanTrace.setColor(Color.ORANGE);
        this.decisionLevelWhenConflictChart
                .addTrace(this.conflictLevelCleanTrace);

        this.decisionLevelWhenConflictChart.getAxisX().setRangePolicy(
                new RangePolicyHighestValues(2000));

        this.learnedClausesSizeTrace = new Trace2DSimple("Size");
        this.learnedClausesSizeTrace.setTracePainter(new TracePainterPlus());
        this.learnedClausesSizeTrace.setColor(Color.BLUE);
        this.learnedClausesSizeChart.setName("Learned clauses size");
        this.learnedClausesSizeChart.addTrace(this.learnedClausesSizeTrace);
        this.learnedClausesSizeTrace.setZIndex(ITrace2D.ZINDEX_MAX);
        this.learnedClausesSizeChart.getAxisX().setRangePolicy(
                new RangePolicyHighestValues(2000));

        this.learnedClausesSizeRestartTrace = new Trace2DSimple(RESTART);
        this.learnedClausesSizeRestartTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.learnedClausesSizeChart));
        this.learnedClausesSizeRestartTrace.setColor(Color.LIGHT_GRAY);
        this.learnedClausesSizeChart
                .addTrace(this.learnedClausesSizeRestartTrace);

        this.learnedClausesSizeCleanTrace = new Trace2DSimple(CLEAN);
        this.learnedClausesSizeCleanTrace
                .setTracePainter(new TracePainterVerticalBar(2,
                        this.learnedClausesSizeChart));
        this.learnedClausesSizeCleanTrace.setColor(Color.ORANGE);
        this.learnedClausesSizeChart
                .addTrace(this.learnedClausesSizeCleanTrace);

        this.clausesEvaluationTrace = new Trace2DSimple("Evaluation");
        this.clausesEvaluationTrace.setTracePainter(new TracePainterPlus());
        this.clausesEvaluationTrace.setColor(Color.BLUE);
        this.clausesEvaluationTrace.setName("Clauses evaluation");
        this.clausesEvaluationChart.addTrace(this.clausesEvaluationTrace);

        this.heuristicsTrace = new Trace2DSimple("Evaluation");
        this.heuristicsTrace.setTracePainter(new TracePainterPlus());
        this.heuristicsTrace.setColor(Color.ORANGE);
        this.variablesEvaluationChart.setName("Variables evaluation");
        this.variablesEvaluationChart.addTrace(this.heuristicsTrace);

        this.speedTrace = new Trace2DSimple("Speed");
        this.speedTrace.setColor(new Color(0.02f, .78f, .76f));
        this.speedCleanTrace = new Trace2DSimple(CLEAN);
        this.speedCleanTrace.setColor(Color.ORANGE);
        this.speedCleanTrace.setTracePainter(new TracePainterVerticalBar(2,
                this.propagationPerSecondChart));
        this.speedRestartTrace = new Trace2DSimple(RESTART);
        this.speedRestartTrace.setColor(Color.LIGHT_GRAY);
        this.speedRestartTrace.setTracePainter(new TracePainterVerticalBar(2,
                this.propagationPerSecondChart));

        this.propagationPerSecondChart.addTrace(this.speedCleanTrace);
        this.propagationPerSecondChart.addTrace(this.speedRestartTrace);
        this.propagationPerSecondChart.addTrace(this.speedTrace);
        this.propagationPerSecondChart.getAxisX().setRangePolicy(
                new RangePolicyHighestValues(30));

        this.speedTrace.setZIndex(ITrace2D.ZINDEX_MAX);

    }
