private void createGeneralOptionsPanel() {
        this.generalOptionsPanel = new JPanel();

        this.generalOptionsPanel.setName("General options");
        this.generalOptionsPanel.setBorder(new CompoundBorder(new TitledBorder(
                null, this.generalOptionsPanel.getName(), TitledBorder.LEFT,
                TitledBorder.TOP), BORDER5));

        this.generalOptionsPanel.setLayout(GRIDLAYOUT);

        JLabel backgroundColorLabel;

        backgroundColorLabel = new JLabel(BACKGROUND_COLOR);
        this.bgButton = new JButton("");
        this.bgButton.setOpaque(true);
        this.bgButton.setBorderPainted(false);
        this.bgButton.setBackground(this.preferences.getBackgroundColor());

        this.bgButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Color color = JColorChooser.showDialog(getFrame(),
                        "Background Color",
                        VisuPreferencesFrame.this.bgButton.getBackground());
                VisuPreferencesFrame.this.preferences.setBackgroundColor(color);
                VisuPreferencesFrame.this.bgButton.setBackground(color);
            }
        });

        this.generalOptionsPanel.add(backgroundColorLabel);
        this.generalOptionsPanel.add(this.bgButton);

        JLabel borderColorLabel = new JLabel(BORDER_COLOR);

        this.borderButton = new JButton("");
        this.borderButton.setOpaque(true);
        this.borderButton.setBorderPainted(false);
        this.borderButton.setBackground(this.preferences.getBorderColor());

        this.borderButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Color color = JColorChooser.showDialog(getFrame(),
                        "Border Color",
                        VisuPreferencesFrame.this.borderButton.getBackground());
                VisuPreferencesFrame.this.preferences.setBorderColor(color);
                VisuPreferencesFrame.this.borderButton.setBackground(color);
            }
        });

        this.generalOptionsPanel.add(borderColorLabel);
        this.generalOptionsPanel.add(this.borderButton);

        this.restartColorLabel = new JLabel(RESTART_COLOR);
        this.restartButton = new JButton("");
        this.restartButton.setOpaque(true);
        this.restartButton.setBorderPainted(false);
        this.restartButton.setBackground(this.preferences.getRestartColor());

        this.restartButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Color color = JColorChooser
                        .showDialog(getFrame(), "Restart Color",
                                VisuPreferencesFrame.this.restartButton
                                        .getBackground());
                VisuPreferencesFrame.this.preferences.setRestartColor(color);
                VisuPreferencesFrame.this.restartButton.setBackground(color);
            }
        });

        this.generalOptionsPanel.add(this.restartColorLabel);
        this.generalOptionsPanel.add(this.restartButton);
    }
