private void createGnuplotOptionsPanel() {
        this.gnuplotOptionsPanel = new JPanel();

        this.gnuplotOptionsPanel.setName("Gnuplot options");
        this.gnuplotOptionsPanel.setBorder(new CompoundBorder(new TitledBorder(
                null, this.gnuplotOptionsPanel.getName(), TitledBorder.LEFT,
                TitledBorder.TOP), BORDER5));

        this.gnuplotOptionsPanel.setLayout(GRIDLAYOUT);

        this.slidingWindows = new JCheckBox(SLIDING_WINDOWS);
        this.slidingWindows.setSelected(this.preferences.isSlidingWindows());

        this.slidingWindows.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.nbLinesReadLabel
                        .setEnabled(VisuPreferencesFrame.this.slidingWindows
                                .isSelected());
                VisuPreferencesFrame.this.nbLinesTextField
                        .setEnabled(VisuPreferencesFrame.this.slidingWindows
                                .isSelected());
                VisuPreferencesFrame.this.preferences
                        .setSlidingWindows(VisuPreferencesFrame.this.slidingWindows
                                .isSelected());
            }
        });

        this.gnuplotOptionsPanel.add(this.slidingWindows);
        this.gnuplotOptionsPanel.add(new JLabel());

        this.nbLinesReadLabel = new JLabel(NB_LINE);
        this.nbLinesTextField = new JTextField(
                this.preferences.getNbLinesRead() + "");

        this.nbLinesReadLabel.setEnabled(this.slidingWindows.isSelected());
        this.nbLinesTextField.setEnabled(this.slidingWindows.isSelected());

        this.gnuplotOptionsPanel.add(this.nbLinesReadLabel);
        this.gnuplotOptionsPanel.add(this.nbLinesTextField);

        JLabel refreshTimeLabel = new JLabel(REFRESH_TIME);
        JTextField refreshTimeField = new JTextField(
                this.preferences.getRefreshTime() + "");

        this.gnuplotOptionsPanel.add(refreshTimeLabel);
        this.gnuplotOptionsPanel.add(refreshTimeField);

        JLabel timeBeforeLaunchLabel = new JLabel(TIME_BEFORE_LAUNCHING);
        JTextField timeBeforeLaunchField = new JTextField(
                this.preferences.getTimeBeforeLaunching() + "");

        this.gnuplotOptionsPanel.add(timeBeforeLaunchLabel);
        this.gnuplotOptionsPanel.add(timeBeforeLaunchField);

        this.displayRestartsCheckBox = new JCheckBox(DISPLAY_RESTARTS);
        this.displayRestartsCheckBox.setSelected(this.preferences
                .isDisplayRestarts());

        this.displayRestartsCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.restartColorLabel
                        .setEnabled(VisuPreferencesFrame.this.displayRestartsCheckBox
                                .isSelected());
                VisuPreferencesFrame.this.restartButton
                        .setEnabled(VisuPreferencesFrame.this.displayRestartsCheckBox
                                .isSelected());
                VisuPreferencesFrame.this.preferences
                        .setDisplayRestarts(VisuPreferencesFrame.this.displayRestartsCheckBox
                                .isSelected());
            }
        });

        this.gnuplotOptionsPanel.add(this.displayRestartsCheckBox);
        this.gnuplotOptionsPanel.add(new JLabel());

    }
