public void createMainPanel() {
        this.mainPanel = new JPanel();
        this.mainPanel.setLayout(new BorderLayout());

        JPanel graphPanel;

        createGeneralOptionsPanel();

        createGnuplotOptionsPanel();

        JButton okButton;

        okButton = new JButton(OK);
        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                getFrame().setVisible(false);
            }
        });

        graphPanel = new JPanel();
        graphPanel.setLayout(new BoxLayout(graphPanel, BoxLayout.Y_AXIS));

        graphPanel.setName("Possible Graphs");
        graphPanel.setBorder(new CompoundBorder(new TitledBorder(null,
                graphPanel.getName(), TitledBorder.LEFT, TitledBorder.TOP),
                BORDER5));

        this.displayClausesEvaluationCB = new JCheckBox(CLAUSES_EVALUATION);
        graphPanel.add(this.displayClausesEvaluationCB);
        this.displayClausesEvaluationCB.setSelected(this.preferences
                .isDisplayClausesEvaluation());
        this.displayClausesEvaluationCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplayClausesEvaluation(VisuPreferencesFrame.this.displayClausesEvaluationCB
                                .isSelected());
            }
        });

        this.displayClausesSizeCB = new JCheckBox(CLAUSES_SIZE);
        graphPanel.add(this.displayClausesSizeCB);
        this.displayClausesSizeCB.setSelected(this.preferences
                .isDisplayClausesSize());
        this.displayClausesSizeCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplayClausesSize(VisuPreferencesFrame.this.displayClausesSizeCB
                                .isSelected());
            }
        });

        this.displayConflictsDecisionCB = new JCheckBox(CONFLICTS_DECISION);
        graphPanel.add(this.displayConflictsDecisionCB);
        this.displayConflictsDecisionCB.setSelected(this.preferences
                .isDisplayConflictsDecision());
        this.displayConflictsDecisionCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplayConflictsDecision(VisuPreferencesFrame.this.displayConflictsDecisionCB
                                .isSelected());
            }
        });

        this.displayConflictsTrailCB = new JCheckBox(CONFLICTS_TRAIL);
        graphPanel.add(this.displayConflictsTrailCB);
        this.displayConflictsTrailCB.setSelected(this.preferences
                .isDisplayConflictsTrail());
        this.displayConflictsTrailCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplayConflictsTrail(VisuPreferencesFrame.this.displayConflictsTrailCB
                                .isSelected());
            }
        });

        this.displayDecisionIndexesCB = new JCheckBox(DECISION_INDEX);
        graphPanel.add(this.displayDecisionIndexesCB);
        this.displayDecisionIndexesCB.setSelected(this.preferences
                .isDisplayDecisionIndexes());
        this.displayDecisionIndexesCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplayDecisionIndexes(VisuPreferencesFrame.this.displayDecisionIndexesCB
                                .isSelected());
            }
        });

        this.displaySpeedCB = new JCheckBox(SPEED);
        graphPanel.add(this.displaySpeedCB);
        this.displaySpeedCB.setSelected(this.preferences.isDisplaySpeed());
        this.displaySpeedCB.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                VisuPreferencesFrame.this.preferences
                        .setDisplaySpeed(VisuPreferencesFrame.this.displaySpeedCB
                                .isSelected());
            }
        });

        this.displayVariablesEvaluationCB = new JCheckBox(VARIABLE_EVALUATION);
        graphPanel.add(this.displayVariablesEvaluationCB);
        this.displayVariablesEvaluationCB.setSelected(this.preferences
                .isDisplayVariablesEvaluation());
        this.displayVariablesEvaluationCB
                .addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        VisuPreferencesFrame.this.preferences
                                .setDisplayVariablesEvaluation(VisuPreferencesFrame.this.displayVariablesEvaluationCB
                                        .isSelected());
                    }
                });

        JPanel topPanel = new JPanel();
        topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.Y_AXIS));

        topPanel.add(this.generalOptionsPanel);
        topPanel.add(this.gnuplotOptionsPanel);

        this.mainPanel.add(topPanel, BorderLayout.NORTH);
        this.mainPanel.add(graphPanel, BorderLayout.CENTER);
        this.mainPanel.add(okButton, BorderLayout.SOUTH);
    }
