@Override
    public void execute(Enum<EditCommand> command) {
        switch ((EditCommand) command) {
        case COPY_PUZZLE:
            String toCopy = sudoku.getGui().getCellGrid().exportString();
            if (sudoku.getMainProgramWindow().isApplication()) {
                writeToClipboard(toCopy);
            } else {
                sudoku.getGui().setPuzzlePaste(toCopy);
            }
            break;

        case PASTE_PUZZLE:
            String toPaste;
            if (sudoku.getMainProgramWindow().isApplication()) {
                toPaste = readFromClipboard();
            } else {
                toPaste = sudoku.getGui().getPuzzlePaste();
            }

            CellGrid cellGrid = sudoku.getGui().getCellGrid();
            cellGrid.clearProtection();
            cellGrid.clearAll();
            sudoku.getGui().getCellGrid().importString(toPaste);
            sudoku.getGui().setProtection(true);
            break;
        }
    }
