String checkForEscapes(String s) {
    	StringBuilder result = new StringBuilder();
        int i = 0;
        while (i < s.length()) {
            char ch = s.charAt(i);
            if (ch == '\\') {
                i++;
                if (i < s.length()) {
                    char tag = s.charAt(i);
                    switch (tag) {
                    case 'n':
                        result.append('\n');
                        i++;
                        break;

                    case 't':
                        result.append('\t');
                        i++;
                        break;

                    case 'u':
                        char unicode = 0;
                        boolean stillOK = true;
                        i++;
                        int j;
                        for (j = 0; stillOK && (j < 4); j++) {
                            stillOK = isHex(s.charAt(i + j));
                            if (stillOK) {
                                unicode = (char) (16 * unicode + hexValue(s
                                        .charAt(i + j)));
                            }
                        }
                        result.append(unicode);
                        i += j;
                        break;

                    default:
                        result.append(tag);
                        i++;
                        break;
                    }
                }
            } else {
                result.append(ch);
                i++;
            }
        }

        return result.toString();
    }
