void addOneBlockSolver(int br, int bc, ClauseHandler ch) {
        for (int v = 1; v <= sdSize.getLargeSide(); v++) {
            vi.clear();
            if (gui.getUseExtra()) {
                vi1.clear();
                vi2.clear();
            }
            for (int r = 1; r <= sdSize.getSmallRows(); r++) {
                for (int c = 1; c <= sdSize.getSmallCols(); c++) {
                    vi.push(blockVariable(br, bc, r, c, v));
                    if (gui.getUseExtra()) {
                        vi1.push(blockVariable1(br, bc, r, v, c));
                        vi2.push(blockVariable2(br, bc, v, c, r));
                    }
                }
            }
            ch.addClause(vi);
            if (gui.getUseExtra()) {
                ch.addClause(vi1);
                ch.addClause(vi2);
            }

            if (fullCNF) {
                for (int i1 = 1; i1 <= sdSize.getLargeSide() - 1; i1++) {
                    for (int i2 = i1 + 1; i2 <= sdSize.getLargeSide(); i2++) {
                        int r1 = (i1 - 1) / sdSize.getSmallCols() + 1;
                        int c1 = (i1 - 1) % sdSize.getSmallCols() + 1;
                        int r2 = (i2 - 1) / sdSize.getSmallCols() + 1;
                        int c2 = (i2 - 1) % sdSize.getSmallCols() + 1;

                        vi.clear();
                        vi.push(-blockVariable(br, bc, r1, c1, v));
                        vi.push(-blockVariable(br, bc, r2, c2, v));
                        ch.addClause(vi);

                        if (gui.getUseExtra()) {
                            vi1.clear();
                            vi1.push(-blockVariable1(br, bc, r1, v, c1));
                            vi1.push(-blockVariable1(br, bc, r2, v, c2));
                            ch.addClause(vi1);

                            vi2.clear();
                            vi2.push(-blockVariable2(br, bc, v, c1, r1));
                            vi2.push(-blockVariable2(br, bc, v, c2, r2));
                            ch.addClause(vi2);
                        }
                    }
                }
            }
        }
    }
