/*
 * Copyright (c) 2002-2017, Mairie de Paris
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice
 *     and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright notice
 *     and the following disclaimer in the documentation and/or other materials
 *     provided with the distribution.
 *
 *  3. Neither the name of 'Mairie de Paris' nor 'Lutece' nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * License 1.0
 */
package fr.paris.lutece.portal.web.constants;

/**
 * Shared messages constants
 */
public final class Messages
{
    public static final String MANDATORY_FIELDS = "portal.util.message.mandatoryFields";
    public static final String MANDATORY_FILE = "portal.util.message.mandatoryFileSelection";
    public static final String MESSAGE_ILLEGAL_CHARACTER = "portal.util.message.illegalCharacter";
    public static final String TEXT_SIZE = "portal.util.message.textSize";
    public static final String MESSAGE_INVALID_ENTRY = "portal.util.message.invalidEntry";
    public static final String USER_ACCESS_DENIED = "portal.users.message.user.accessDenied";
    public static final String MESSAGE_LOGOUT = "portal.users.message.user.logout";
    public static final String MESSAGE_USER_DISABLED = "portal.users.message.user.disabled";
    public static final String MESSAGE_AUTH_FAILURE = "portal.users.message.user.authentication.failure";
    public static final String MESSAGE_USER_NOT_AUTHENTICATED = "portal.users.message.user.not.authenticated";
    public static final String MESSAGE_USER_NEW_SESSION = "portal.users.message.user.new.session";
    public static final String MESSAGE_USER_MUST_CHANGE_PASSWORD = "portal.users.message.user.change.password";
    public static final String MESSAGE_ERROR_SESSION = "portal.users.message.user.error.session";
    public static final String PATH_ALREADY_EXISTS = "portal.util.message.errorPathAlreadyExists";
    public static final String PATH_CREATION_ERROR = "portal.util.message.errorCreatingPath";
    public static final String PATH_MODIFICATION_ERROR = "portal.util.message.errorModifyingPath";
    public static final String HTML_CLEANER_ERROR = "portal.util.message.errorHtmlCleaner";
    public static final String MESSAGE_STRING_FORMAT = "portal.util.message.accentuatedCharacter";

    /** Private constructor */
    private Messages( )
    {
    }
}
