package com.devonfw.application.mtsj.bookingmanagement.common.api.to;

import java.time.Instant;

import com.devonfw.application.mtsj.bookingmanagement.common.api.datatype.BookingType;
import com.devonfw.application.mtsj.general.common.api.to.AbstractSearchCriteriaTo;
import com.devonfw.module.basic.common.api.query.StringSearchConfigTo;

/**
 *
 *
 * used to find {@link com.devonfw.application.mtsj.bookingmanagement.common.api.Booking}s.
 */
public class BookingSearchCriteriaTo extends AbstractSearchCriteriaTo {

  private static final long serialVersionUID = 1L;

  private String name;

  private String bookingToken;

  private String comment;

  private Instant bookingDate;

  private Instant expirationDate;

  private Instant creationDate;

  private String email;

  private Boolean canceled;

  private BookingType bookingType;

  private Long tableId;

  private Long orderId;

  private Integer assistants;

  private Long userId;

  private StringSearchConfigTo nameOption;

  private StringSearchConfigTo bookingTokenOption;

  private StringSearchConfigTo commentOption;

  private StringSearchConfigTo emailOption;

  /**
   * The constructor.
   */
  public BookingSearchCriteriaTo() {

    super();
  }

  public /*@ pure @*/ String getName() {

    return this.name;
  }

  public void setName(String name) {

    this.name = name;
  }

  public /*@ pure @*/ String getBookingToken() {

    return this.bookingToken;
  }

  public void setBookingToken(String bookingToken) {

    this.bookingToken = bookingToken;
  }

  public /*@ pure @*/ String getComment() {

    return this.comment;
  }

  public void setComment(String comment) {

    this.comment = comment;
  }

  public /*@ pure @*/ Instant getBookingDate() {

    return this.bookingDate;
  }

  public void setBookingDate(Instant bookingDate) {

    this.bookingDate = bookingDate;
  }

  public /*@ pure @*/ Instant getExpirationDate() {

    return this.expirationDate;
  }

  public void setExpirationDate(Instant expirationDate) {

    this.expirationDate = expirationDate;
  }

  public /*@ pure @*/ Instant getCreationDate() {

    return this.creationDate;
  }

  public void setCreationDate(Instant creationDate) {

    this.creationDate = creationDate;
  }

  public /*@ pure @*/ String getEmail() {

    return this.email;
  }

  public void setEmail(String email) {

    this.email = email;
  }

  public /*@ pure @*/ Boolean getCanceled() {

    return this.canceled;
  }

  public void setCanceled(Boolean canceled) {

    this.canceled = canceled;
  }

  public /*@ pure @*/ BookingType getBookingType() {

    return this.bookingType;
  }

  public void setBookingType(BookingType bookingType) {

    this.bookingType = bookingType;
  }

  public /*@ pure @*/ Long getTableId() {

    return this.tableId;
  }

  public void setTableId(Long tableId) {

    this.tableId = tableId;
  }

  public /*@ pure @*/ Long getOrderId() {

    return this.orderId;
  }

  public void setOrderId(Long orderId) {

    this.orderId = orderId;
  }

  public /*@ pure @*/ Integer getAssistants() {

    return this.assistants;
  }

  public void setAssistants(Integer assistants) {

    this.assistants = assistants;
  }

  public /*@ pure @*/ Long getUserId() {

    return this.userId;
  }

  public void setUserId(Long userId) {

    this.userId = userId;
  }

  /**
   * @return nameOption
   */
  public /*@ pure @*/ StringSearchConfigTo getNameOption() {

    return this.nameOption;
  }

  /**
   * @param nameOption new value of {@link #getnameOption}.
   */
  public void setNameOption(StringSearchConfigTo nameOption) {

    this.nameOption = nameOption;
  }

  /**
   * @return bookingTokenOption
   */
  public /*@ pure @*/ StringSearchConfigTo getBookingTokenOption() {

    return this.bookingTokenOption;
  }

  /**
   * @param bookingTokenOption new value of {@link #getbookingTokenOption}.
   */
  public void setBookingTokenOption(StringSearchConfigTo bookingTokenOption) {

    this.bookingTokenOption = bookingTokenOption;
  }

  /**
   * @return commentOption
   */
  public /*@ pure @*/ StringSearchConfigTo getCommentOption() {

    return this.commentOption;
  }

  /**
   * @param commentOption new value of {@link #getcommentOption}.
   */
  public void setCommentOption(StringSearchConfigTo commentOption) {

    this.commentOption = commentOption;
  }

  /**
   * @return emailOption
   */
  public /*@ pure @*/ StringSearchConfigTo getEmailOption() {

    return this.emailOption;
  }

  /**
   * @param emailOption new value of {@link #getemailOption}.
   */
  public void setEmailOption(StringSearchConfigTo emailOption) {

    this.emailOption = emailOption;
  }

}
