package com.devonfw.application.mtsj.imagemanagement.common.api.to;

import java.sql.Blob;

import com.devonfw.application.mtsj.general.common.api.to.AbstractSearchCriteriaTo;
import com.devonfw.application.mtsj.imagemanagement.common.api.datatype.ContentType;
import com.devonfw.module.basic.common.api.query.StringSearchConfigTo;

/**
 * used to find {@link com.devonfw.application.mtsj.imagemanagement.common.api.Image}s.
 *
 */
public class ImageSearchCriteriaTo extends AbstractSearchCriteriaTo {

  private static final long serialVersionUID = 1L;

  private String name;

  private Blob content;

  private ContentType contentType;

  private String mimeType;

  private StringSearchConfigTo nameOption;

  private StringSearchConfigTo contentOption;

  private StringSearchConfigTo mimeTypeOption;

  /**
   * The constructor.
   */
  public ImageSearchCriteriaTo() {

    super();
  }

  public /*@ pure @*/ String getName() {

    return this.name;
  }

  public void setName(String name) {

    this.name = name;
  }

  public /*@ pure @*/ Blob getContent() {

    return this.content;
  }

  public void setContent(Blob content) {

    this.content = content;
  }

  public /*@ pure @*/ ContentType getContentType() {

    return this.contentType;
  }

  public void setContentType(ContentType contentType) {

    this.contentType = contentType;
  }

  public /*@ pure @*/ String getMimeType() {

    return this.mimeType;
  }

  public void setExtension(String mimeType) {

    this.mimeType = mimeType;
  }

  /**
   * @return nameOption
   */
  public /*@ pure @*/ StringSearchConfigTo getNameOption() {

    return this.nameOption;
  }

  /**
   * @param nameOption new value of {@link #getnameOption}.
   */
  public void setNameOption(StringSearchConfigTo nameOption) {

    this.nameOption = nameOption;
  }

  /**
   * @return contentOption
   */
  public /*@ pure @*/ StringSearchConfigTo getContentOption() {

    return this.contentOption;
  }

  /**
   * @param contentOption new value of {@link #getcontentOption}.
   */
  public void setContentOption(StringSearchConfigTo contentOption) {

    this.contentOption = contentOption;
  }

  /**
   * @return mimeTypeOption
   */
  public /*@ pure @*/ StringSearchConfigTo getMimeTypeOption() {

    return this.mimeTypeOption;
  }

  /**
   * @param mimeTypeOption new value of {@link #getmimeTypeOption}.
   */
  public void setMimeTypeOption(StringSearchConfigTo mimeTypeOption) {

    this.mimeTypeOption = mimeTypeOption;
  }

  /**
   * @param mimeType new value of {@link #getmimeType}.
   */
  public void setMimeType(String mimeType) {

    this.mimeType = mimeType;
  }

}
